#include <bits/stdc++.h>

using namespace std;

vector<int> pref(string &s)
{
    int n = s.size();
    vector<int> pi(n);
    for (int i = 1; i < n; ++i)
    {
        int j = pi[i - 1];
        while (j > 0 && s[i] != s[j])
        {
            j = pi[j - 1];
        }
        if (s[i] == s[j])
        {
            j++;
        }
        pi[i] = j;
    }
    return pi;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    vector<int> result(n);
    for (int i = 1; i <= n; ++i)
    {
        int s = 0;
        unordered_map<int, int> s2;
        for (int j = 0; j < i; ++j)
        {
            if (s2[a[j]] == 0)
            {
                s++;
            }
            s2[a[j]]++;
        }
        result[i - 1] += s;
        for (int j = i; j < n; ++j)
        {
            s2[a[j - i]]--;
            if (s2[a[j - i]] == 0)
            {
                s--;
            }
            if (s2[a[j]] == 0)
            {
                s++;
            }
            s2[a[j]]++;
            result[i - 1] += s;
        }
    }
    for (int i = 0; i < n; ++i)
    {
        cout << result[i] << ' ';
    }
    return 0;
}
