#include <bits/stdc++.h>

using namespace std;

#define ON_START ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

#define endl "\n"
#define double long double
#define int long long

#define EPS 1e-6L

//#define MULTITEST

struct oper {
    int a, b, op;
};

vector<vector<int>> gzi(int n, int m) {
    vector<vector<int>> res;
    if (n == 0) {
        res.emplace_back();
        return res;
    }
    auto av = gzi(n - 1, m);
    for (int i = 0; i <= m; i++) {
        for (const vector<int> &v : av) {
            res.push_back(v);
            res.back().push_back(i);
        }
    }
    return res;
}

inline void solve() {
    int n, m, s;
    cin >> n >> m >> s;
    oper ops[m][n - 1];
    bool alo1 = true;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            cin >> ops[i][j].a >> ops[i][j].b >> ops[i][j].op;
            if (ops[i][j].op != 1) {
                alo1 = false;
            }
        }
    }

    int x[m][n];
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            cin >> x[i][j];
        }
    }

    if (alo1) {
        for (int i = 1; i < n; i++) {
            cout << m << " ";
        }
        cout << s << endl;
        return;
    }

    auto az = gzi(n, m);
    for (const auto &zs : az) {
        int ones = 0;
        for (int i = 0; i < m; i++) {
            bool arr[2 * n];
            memset(arr, false, sizeof(arr));
            for (int j = 0; j < n; j++) {
                arr[j + 1] = x[i][j] < zs[j];
            }
            for (int p = 0; p < n - 1; p++) {
                auto op = ops[i][p];
                if (op.op == 1) {
                    arr[n + p] = arr[op.a] and arr[op.b];
                } else {
                    arr[n + p] = arr[op.a] or arr[op.b];
                }
            }
            ones += arr[2 * n - 2];
//            for (bool sad : arr) {
//                cout << sad;
//            }
//            cout << endl;
        }
//        cout << ones << endl;
        if (ones == s) {
            for (int i = 0; i < (int)zs.size(); i++) {
                cout << zs[i] << (i == (int)zs.size() - 1 ? endl : " ");
            }
            break;
        }
    }
}

int32_t main() {
    ON_START
#ifdef MULTITEST
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
#endif
    solve();
#ifdef MULTITEST
    }
#endif
    return 0;
}