#include <iostream>
#include <vector>
#include <unordered_set>
using namespace std;

int main() {
    long n;
    cin >> n;
    vector<long> a(n);
    vector<long> S(n, 0);
    S[0] = n;
    vector<long> k_types(n, 1);
    vector<unordered_set<long> > types(n);
    long i;
    for (i = 0; i < n; i++) {
        cin >> a[i];
        types[i].insert(a[i]);
    }
    for (long d = 2; d <= n; d++) {
        for (i = n - 1; i >= d - 1; i--) {
            if (types[i - 1].count(a[i])) {
                k_types[i] = k_types[i - 1];
                S[d - 1] += k_types[i - 1];
            }
            else {
                k_types[i] = k_types[i - 1] + 1;
                S[d - 1] += k_types[i - 1] + 1;
            }
            if (i - d + 1 >= 0) {
                types[i].insert(a[i - d + 1]);
            }
        }
    }
    for (i = 0; i < n - 1; i++) {
        cout << S[i] << ' ';
    }
    cout << S[n - 1] << endl;
    return 0;
}
