#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

const int INF = 2 * 1e9;

long double mx(int add, vector<pair<int, int>> &lst){
    long double ans = 0;
    for (auto el : lst)
        ans += (long double)el.sd / (el.ft + add);
    return ans;
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n; cin >> n;
    vector<pair<int, int>> seg(n); // v, length
    for (int i = 0; i < n; i++)
        cin >> seg[i].ft;
    for (int i = 0; i < n; i++)
        cin >> seg[i].sd;
    int m; cin >> m;
    vector<int> lst(m + 1); // null
    for (int i = 0; i < m - 1; i++)
        cin >> lst[i + 1];
    lst[m] = INF;
    vector<int> fee(m + 1);
    for (int i = 0; i < m; i++)
        cin >> fee[i + 1];
    int q; cin >> q;
    int a, b;
    for (int i = 0; i < q; i++){
        cin >> a >> b;
        long double tt = (b - a);
        int left = -1, right = m, mid;
        while (right - left > 1){
            mid = (left + right) / 2;
            //cout << "ab: " << a << " " << b << " mid " << mid <<  ": " << mx(lst[mid], seg) << endl;
            if (mx(lst[mid], seg) <= tt)
                right = mid;
            else left = mid;
        }
        cout << fee[right] << "\n";
    }
    return 0;
}