#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

const ll ROOF = 2 * 1e5;
map<ll, ll> mem;

ll get(ll x, vector<ll> &lst){
    if (mem[x] != 0)
        return mem[x];
    ll ans = 0;
    while (x > 0){
        int pos = upper_bound(lst.begin(), lst.end(), x) - lst.begin();
        pos--;
        ll here = x / lst[pos];
        ans += here;
        x -= here * lst[pos];
    }
    mem[x] = ans;
    return ans;
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n; cin >> n;
    vector<ll> lst(n);
    for (int i = 0; i < n; i++)
        cin >> lst[i];
    int q; cin >> q;
    ll b;
    for (int i = 0; i < q; i++){
        cin >> b;
        if (b <= ROOF){
            pair<ll, ll> ans = {0, 0};
            for (ll curr = b, j = 0; curr > 0 && j < 1000000; curr--, j++){
                ll cnt = get(curr, lst);
                if (cnt > ans.sd)
                    ans = {curr, cnt};
            }
            cout << ans.ft << " " << ans.sd << "\n";
        }
        else{
            int last = -1;
            for (int j = 0; j < 60; j++)
                if (b & (1 << j))
                    last = j;
            if (b == (1 << (last + 1)) - 1)
                cout << b << " " << last + 1 << "\n";
            else
                cout << (1 << last) - 1 << " " << last - 1 << "\n";
        }
    }
    return 0;
}