#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector,inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,sse4a,avx,avx2,bmi,bmi2,abm,mmx,adx,aes,xop")

#include <bits/stdc++.h>

using namespace std;
//#define int long long

struct Instr {
  int a, b, t;
};

struct Line {
  vector<int> arr;
  vector<Instr> instr;

  bool operator<(const Line &oth) const {
    return arr < oth.arr;
  }
};

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int n, m, s;
  cin >> n >> m >> s;
  vector<Line> matr(m);
  for (auto &line : matr) {
    line.arr.resize(n);
    line.instr.resize(n - 1);
    for (auto &el : line.instr) {
      cin >> el.a >> el.b >> el.t;
      el.a--, el.b--, el.t--;
    }
  }
  for (auto &line : matr) {
    for (auto &el : line.arr)
      cin >> el;
  }
  if (n == 1) {
    return cout << s, 0;
  } else if (n == 2) {
    sort(matr.begin(), matr.end());
    vector<int> pref(m);
    pref[0] = matr[0].instr[0].t;
    vector<int> kthor(m, -1);
    for (int i = 1; i < m; ++i) {
      pref[0] = pref[i - 1];
      if (matr[i].instr[0].t) {
        pref[i]++;
        kthor[pref[i] - 1] = i;
      }
    }
    kthor[pref.back()] = -2;
    for (int z0 = 0; z0 <= m; ++z0) {
      int cs = 0;
      if (z0 > 0)
        cs = pref[z0 - 1];
      if (cs > s)
        break;
      if (cs == s) {
        cout << z0 << ' ' << 0;
        return 0;
      }
      int ost = s - cs;
      if (ost - 1 >= n || kthor[ost - 1] == -1)
        continue;
      int ind = kthor[ost - 1];
      int z1 = m;
      if (ind != -2)
        z1 = matr[ind].arr[1] + 1;
      cout << z0 << ' ' << z1;
      return 0;
    }
    assert(false);
  }

  return 0;
}

