#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector,inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,sse4a,avx,avx2,bmi,bmi2,abm,mmx,adx,aes,xop"
#endif

#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 200000;
int arr[MAXN];
int n;

bool checkisin(int x, int i) {
  auto it = lower_bound(arr, arr + n, x);
  if (it == arr + n)
    return false;
  return *it == x && arr + i != it;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  cin >> n;
  for (int i = 0; i < n; ++ i)
    cin >> arr[i];
  int Q;
  cin >> Q;
  int q = Q;
  vector<pair<int, int>> anses(n);
  anses[0] = {0, 0};
  int ccb = 0;
  int ccnt = 0;
  for (int i = 0; i < n - 1; ++i) {
    int mn = ((arr[i + 1] - 1) - ccb) / arr[i];
    if (mn <= 0)
      continue;
    int ncb;
    mn++;
    do {
      mn--;
      ncb = ccb + mn * arr[i];
    } while (checkisin(ncb, i));
    ccb += mn * arr[i];
    ccnt += mn;
    anses[i + 1] = {ccb, ccnt};
  }
  while (q--) {
    int sb;
    cin >> sb;
    int i = lower_bound(anses.begin(), anses.end(), make_pair(sb + 1, -1LL)) - anses.begin();
    i--;
    auto[cb, cnt] = anses[i];
    int mn = (min(arr[i + 1] - 1, sb) - cb) / arr[i];
    if (mn > 0) {
      int ncb;
      mn++;
      do {
        mn--;
        ncb = cb + mn * arr[i];
      } while (checkisin(ncb, i));
      cb += mn * arr[i];
      cnt += mn;
    }
    cout << cb << ' ' << cnt << '\n';
  }
  return 0;
}
