#include <bits/stdc++.h>
// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("fast-math")

using namespace std;

void solve();

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

signed main() {

	// fast();

	#ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif

	solve();
}

const long double eps = 1e-7;
vector <int> speed;
vector <int> len;
vector <int> ans;
int n, m;

bool check(long double mid, long long time) {

	long double sum = 0;

	for (int i = 0; i < n; ++i) 
		sum += (long double)len[i] / (speed[i] + mid);

	return (sum <= time);
}

long double bin_find(long long time) {

	int left = 0;
	int right = m - 1;

	while (right - left > 1) {

		int mid = (left + right) / 2;

		if (check(ans[mid], time))
			right = mid;
		else 
			left = mid;
	}

	if (check(ans[left], time))
		return left;
	
	return right;
}

void solve() {
	
	cin >> n;

	speed.resize(n);
	len.resize(n);

	for (auto &d: speed) 
		cin >> d;

	for (auto &d: len) 
		cin >> d;

	cin >> m;

	ans.resize(m - 1);
	vector <int> cost(m);

	for (auto &d: ans)
		cin >> d;

	for (auto &d: cost) 
		cin >> d;

	int q;
	cin >> q;

	for (int i = 0; i < q; ++i) {
		int s, t;
		cin >> s >> t;

		if (check(0, t - s))
			cout << 0 << endl;
		else {

			cout << cost[bin_find(t - s)] << endl;

			// bool flag = true;

			// for (int j = 0; j + 1 < m; ++j) {
			// 	if (check(ans[j], t - s)) {
			// 		cout << cost[j] << endl;
			// 		flag = false;
			// 		break;
			// 	}
			// }

			// if (flag)
			// 	cout << cost.back() << endl;

			// int j = upper_bound(ans.begin(), ans.end(), e) - ans.begin();
			// cout << cost[j] << endl;
		}
	}

}