#include <bits/stdc++.h>

using namespace std;

void solve();

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}	

int gcd(int a, int b, int &x, int &y) {

	if (a == 0) {
		x = 0, y = 1;
		return b;
	}

	int x1, y1;

	int d = gcd(b % a, b, x1, y1);
	x = y1 - b / a * x1;
	y = x1;

	return d;
}

signed main() {

	// fast();

	#ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif

	solve();
}

void solve() {

	int n;
	cin >> n;

	vector <long double> ans(n);
	for (auto &d: ans) 
		cin >> d;

	long double sum = 0;
	long double summ = 0;

	for (auto &d: ans) 
		sum += d;

	long double mx = 0;
	int pos = 0;

	for (int i = 0; i + 1 < n; ++i) {
		sum -= ans[i];
		summ += ans[i];
		if (sum * summ > mx) {
			mx = sum * summ;
			pos = i;			
		} 
	}

	cout << pos + 1;
}