#include <bits/stdc++.h>

using namespace std;

void solve();

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}	

signed main() {

	// fast();

	#ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif

	solve();
}

const long long INF = 10000000000000;

int gcd(int a, int b, int &x, int &y) {

	if (a == 0) {
		x = 0, y = 1;
		return b;
	}

	int x1, y1;

	int d = gcd(b % a, a, x1, y1);
	x = y1 - b / a * x1;
	y = x1;

	return d;
}

pair <int, int> get_reson(int a, int b, int c) {

	pair <int, int> ans;
	int d = gcd(a, b, ans.first, ans.second);
	ans.first *= c;
	ans.second *= -c;
	return ans;
}

void solve() {

	int n, x;
	cin >> n >> x;

	int cnt = 0;

	for (int a = 2; a <= n; ++a) {
		for (int b = 1; b < a; ++b) {
			int aa = a;
			int bb = b;
			int cc = n;

			int g = __gcd(a, b);

			aa /= g;
			bb /= g;

			if (cc % g) 
				continue;

			cc /= g;

			pair <int, int> kek = get_reson(aa, bb, cc);

			while (kek.first > 0) {
				kek.first -= bb;
				kek.second -= aa;
			}

			while (kek.first <= 0 || kek.second <= 0) {
				kek.first += bb;
				kek.second += aa;
			}

			while (kek.first > kek.second) {
				// cout << a << " " << kek.first << " " << b << " " << kek.second << endl;
				cnt++;
				kek.first += bb;
				kek.second += aa;
			}
		}
	}

	cout << cnt;
}