#include <bits/stdc++.h>

using namespace std;

void solve();

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}	

signed main() {

	// fast();

	#ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif

	solve();
}

vector <long long> ans;

int cnt_way(int b) {

	int cnt = 0;

	while (b) {
		int j = upper_bound(ans.begin(), ans.end(), b) - ans.begin();
		
		j--;

		cnt += b / ans[j];
		b %= ans[j];
	}

	return cnt;
}

void solve() {

	int n;
	cin >> n;

	ans.resize(n);

	for (auto &d: ans) 
		cin >> d;

	bool flag = true;

	for (int i = 1; i < ans.size(); ++i) {
		if (ans[i] != ans[i - 1] * 2) {
			flag = false;
			break;			
		} 
	}

	if (flag) {
		int q;
		cin >> q;

		for (int u = 0; u < q; ++u) {
			long long b;
			cin >> b;

			long long i = 0;

			while ((1 << i) - 1 <= b)
				i++;

			i--;

			cout << (1 << i) - 1 << " " << i << endl; 
		}

		return;
	}


	int q;
	cin >> q;

	vector <pair<long long, int>> kes(q);
	vector <pair<int, int>> for_zap(q);

	for (int i = 0; i < q; ++i) {
		cin >> kes[i].first;
		kes[i].second = i;
	}

	sort(kes.begin(), kes.end());

	int pos = 0;

	int mx_i = 0;
	int mx = 0;

	for (int i = 1; i <= kes.back().first; ++i) {
		int cnt = cnt_way(i);

		if (cnt > mx) {
			mx = cnt;
			mx_i = i;
		}

		while (pos < kes.size() && kes[pos].first == i) {
			for_zap[kes[pos].second] = {mx_i, mx};
			pos++;
		}
	}

	for (auto d: for_zap)
		cout << d.first << " " << d.second << endl;
}