#include <bits/stdc++.h>
// #define int long long

using namespace std;

void solve();

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}	

signed main() {

	// fast();

	#ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif

	solve();
}

bool check(int a, int b) {

	string s;
	for (int i = 2; i >= 0; --i) 
		if (b & (1 << i))
			s += "1";
		else 
			s += "0";

	for (int i = 2; i >= 0; --i) 
		if (a & (1 << i))
			s += "1";
		else 
			s += "0";

	if (s[0] == '1' && s[1] == '1' && s[2] == '1' && s[3] == '1' || s[1] == '1' && s[2] == '1' && s[3] == '1' && s[4] == '1' || s[2] == '1' && s[3] == '1' && s[4] == '1' && s[5] == '1')
		return false;

	return true;
}

void solve() {

	int n;
	cin >> n;

	vector <long long> ans(n);

	for (auto &d: ans) 
		cin >> d;

	if (n <= 10) {

		long long mx = 0;
		for (int mask = 0; mask < (1 << n); ++mask) {
			long long sum = 0;

			string s;

			for (int i = 0; i < n; ++i) {
				if ((1 << i) & mask) {
					s += '1';
					sum += ans[i];
				}
				else 
					s += '0';
			}

			s = s + s;
			bool flag = true;

			for (int i = 0; i + 3 < s.size(); ++i)
				if (s[i] == '1' && s[i + 1] == '1' && s[i + 2] == '1' && s[i + 3] == '1')
					flag = false;

			if (flag)
				mx = max(mx, sum);
		}

		cout << mx << endl;

		return;
	}

	long long dp[n][1 << 3][1 << 3]; // dp[kol - vo][begin][end];

	for (int i = 0; i < n; ++i) 
		for (int j = 0; j < 8; ++j) 
			for (int k = 0; k < 8; ++k)
					dp[i][j][k] = 0;

	dp[3][0][0] = 0;
	dp[3][1][1] = ans[2];
	dp[3][2][2] = ans[1];
	dp[3][3][3] = ans[1] + ans[2];
	dp[3][4][4] = ans[0];
	dp[3][5][5] = ans[0] + ans[2];
	dp[3][6][6] = ans[0] + ans[1];
	dp[3][7][7] = 0;

	for (int i = 4; i < n; ++i) {
		for (int j = 0; j < (1 << 3); ++j) {
			for (int mask = 0; mask + 1 < (1 << 3); ++mask) {
				dp[i][j][(mask & 3) << 1] = max(dp[i][j][(mask & 3) << 1], dp[i - 1][j][mask]);
				dp[i][j][((mask & 3) << 1) + 1] = max(dp[i][j][((mask & 3) << 1) + 1], dp[i - 1][j][mask] + ans[i - 1]);

			}

			int mask = 7;	
			dp[i][j][(mask & 3) << 1] = max(dp[i][j][(mask & 3) << 1], dp[i - 1][j][mask]);
		}
	}

	long long mx = 0;

	for (int i = 0; i < 8; ++i)
		for (int j = 0; j < 8; ++j) 
			mx = max(mx, dp[n - 1][i][j]);

	for (int i = 0; i < 8; ++i) {
		for (int j = 0; j < 8; ++j) {
			if (check(i, j)) {
				cout << dp[n - 1][i][j] + ans.back() << endl;
				cout << i << " " << j << endl << endl;
				mx = max(dp[n - 1][i][j] + ans.back(), mx);
			}
		}		
	} 

	cout << mx << endl;

	int q;
	cin >> q;

}