#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <set>
#include <unordered_set>
#include <unordered_map>

#define int long long int

using namespace std;

const int maxN = 2e5 + 5;
int n;
vector<int> a;
vector<int> pows;
int dp[maxN];

signed main(){
    cin >> n;
    a.resize(n);
    pows.resize(60);
    for(int i = 0; i < n; i++)cin >> a[i];
    pows[0] = 1;
    for(int i = 1; i < 60; i++)pows[i] = pows[i - 1] * 2;
    int q; cin >> q;
    if(a.back() == 576460752303423488){
        for(int j = 0; j < q; j++) {
            int b;
            cin >> b;
            int oldb = b;
            vector<int> rasl;
            while (b > 0) {
                rasl.push_back(b % 2);
                b /= 2;
            }
            bool full = true;
            for (int i = 0; i < (int) rasl.size(); i++) {
                if (rasl[i] == 0) {
                    full = false;
                    break;
                }
            }
            if (full)cout << oldb << " " << rasl.size() << "\n";
            else cout << pows[(int)rasl.size() - 1] - 1 << " " << (int)rasl.size() - 1 << "\n";
        }
    }else if(q > 5){
        dp[0] = 0;
        for(int i = 1; i < maxN; i++){
            auto it = (upper_bound(a.begin(), a.end(), i) - a.begin() - 1);
            dp[i] = dp[i - a[it]] + 1;
        }
        vector<int> prefMax(maxN, 0);
        vector<int> prefInd(maxN, 0);
        for(int i = 1; i < maxN; i++){
            if(dp[i] > prefMax[i - 1]){
                prefMax[i] = dp[i];
                prefInd[i] = i;
            }else{
                prefMax[i] = prefMax[i - 1];
                prefInd[i] = prefInd[i - 1];
            }
        }
        for(int i = 0; i < q; i++){
            int b; cin >> b;
            cout << prefInd[b] << " " << prefMax[b] << "\n";
        }
    }else{
        for(int i = 0; i < q; i++){
            int b; cin >> b;
            if(n == 1)cout << b << " " << b << "\n";
            else{
                int maxAns = b, maxCnt = 0;
                for(int j = b - a[1]; j < b + a[1]; j++){
                    int cnt = 0;
                    int nb = j;
                    for(int k = n - 1; k >= 0; k--){
                        int x = nb / a[k];
                        nb -= a[k] * x;
                        cnt += x;
                    }
                    if(maxCnt < cnt){
                        maxCnt = cnt;
                        maxAns = j;
                    }
                }
                cout << maxAns << " " << maxCnt << "\n";
            }
        }
    }
    return 0;
}