#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

int main()
{
    int n;
    cin >> n;
    vector<int> v(n);
    for(int i = 0; i < n; ++i){
        cin >> v[i];
    }
    vector<int> L(n);
    for(int i = 0; i < n; ++i){
        cin >> L[i];
    }
    int m;
    cin >> m;
    vector<int> a(m);
    a[0] = 0;
    for(int i = 1; i < m; ++i){
        cin >> a[i];
    }
    vector<int> f(m);
    for(int i = 0; i < m; ++i){
        cin >> f[i];
    }
    vector<long double> t(m, 0);
    for(int i = 0; i < n; ++i){
        t[0] += (1.0L*L[i])/v[i];
    }
    for(int i = 1; i < m; ++i){
        for(int j = 0; j < n; ++j){
            t[i] += (1.0L*L[j])/(v[j]+a[i]);
        }
    }
    int q;
    cin >> q;
    for(int w = 0; w < q; ++w){
        int s, ti;
        cin >> s >> ti;
        int delt = ti - s;
        int left = -1;
        int right = m-1;
        while(left + 1 < right){
            int mid = (left + right) / 2;
            if(delt < t[mid]){
                left = mid;
            }
            else{
                right = mid;
            }
        }
        if(right == 0){
            cout << 0 << endl;
        }
        else{
            cout << f[right-1] << endl;
        }
    }
    return 0;
}
