#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

// Не судите строго, у меня лапки.

long long INF = 1e18;

int main() {
    int n;
    cin >> n;
    vector<long long> num(n);
    for(int i = 0; i < n; i ++) {
        cin >> num[i];
    }
    vector<pair<long long, int>> before(n - 1);
    long long ind = 0;
    long long sum = 0;
    long long cnt = 0;
    while(ind < n - 1) {
        cnt += (max(num[ind + 1] - 1 - sum, 0LL) / num[ind]);
        sum += (max(num[ind + 1] - 1 - sum, 0LL) / num[ind]) * num[ind];
        before[ind] = make_pair(sum, cnt);
        ind ++;
    }
    int q;
    cin >> q;
    for(int i = 0; i < q; i ++) {
        long long b;
        cin >> b;
        int l = -1, r = n - 1;
        while(l + 1 < r) {
            int middle = (l + r) / 2;
            if(before[middle].first <= b) {
                l = middle;
            }
            else {
                r = middle;
            }
        }
        if(l == -1) {
            ind = 0;
            cnt = 0;
            sum = 0;
        }
        else {
            ind = l + 1;
            cnt = before[l].second;
            sum = before[l].first;
        }
        cnt += max(b - sum, 0LL) / num[ind];
        sum += (max(b - sum, 0LL) / num[ind]) * num[ind];
        cout << sum << ' ' << cnt << endl;
        cout << endl;
    }
    return 0;
}