#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

// Не судите строго, у меня лапки.

long long INF = 1e18;

bool check(vector<bool> & a) {
    int cnt = 0;
    for(int i = 0; i < a.size(); i ++) {
        if(a[i]) {
            cnt ++;
        }
        else {
            cnt = 0;
        }
        if(cnt >= 4) {
            return false;
        }
    }
    return true;
}

int main() {
    int n;
    cin >> n;
    vector<long long> in(n);
    for(int i = 0; i < n; i ++) {
        cin >> in[i];
    }
    long long max_ans = 0;

    for(int i = 0; i < (1 << n); i ++) {
        vector<bool> is_up(2 * n, false);
        int cur = i;
        int ind = 0;
        while(cur > 0) {
            is_up[ind] = (cur % 2) == 1;
            is_up[n + ind] = (cur % 2) == 1;
            cur /= 2;
            ind ++;
        }
        long long sum = 0;
        if(check(is_up)) {
            for(int j = 0; j < n; j ++) {
                sum += in[j] * is_up[j];
            }
        }
        if(sum > max_ans) {
            max_ans = sum;
        }
    }
    cout << max_ans << endl;
    int q;
    cin >> q;
    for(int l = 0; l < q; l ++) {
        int a, val;
        cin >> a >> val;
        a --;
        in[a] = val;
        max_ans = 0;
        for(int i = 0; i < (1 << n); i ++) {
            vector<bool> is_up(2 * n, false);
            int cur = i;
            int ind = 0;
            while(cur > 0) {
                is_up[ind] = (cur % 2) == 1;
                is_up[n + ind] = (cur % 2) == 1;
                cur /= 2;
                ind ++;
            }
            long long sum = 0;
            if(check(is_up)) {
                for(int j = 0; j < n; j ++) {
                    sum += in[j] * is_up[j];
                }
            }
            if(sum > max_ans) {
                max_ans = sum;
            }
        }
        cout << max_ans << endl;
    }
    return 0;
}