#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

// Не судите строго, у меня лапки.

long long INF = 1e18;

bool check_2(int mask1, int mask2, long long lenght) {
    int sub_mask = (mask2 >> (lenght - 4));
    int cur = mask1;
    for(int i = 0; i < (lenght - 4); i ++) {
        if(sub_mask % 2 != cur % 2) {
            return false;
        }
        sub_mask /= 2;
        cur /= 2;
    }
    int cur_mask = ((mask1 - (mask2 >> (lenght - 4))) << (lenght - 4)) + mask2;
    int sum = 0;
    for(int i = 0; i < lenght; i ++) {
        if(cur_mask % 2) {
            sum ++;
        }
        else {
            sum = 0;
        }
        if(sum >= 4) {
            return false;
        }
        cur_mask /= 2;
    }
    return true;
}

bool check(vector<bool> & a) {
    int cnt = 0;
    for(int i = 0; i < a.size(); i ++) {
        if(a[i]) {
            cnt ++;
        }
        else {
            cnt = 0;
        }
        if(cnt >= 4) {
            return false;
        }
    }
    return true;
}

long long ans(vector<long long>& in) {
    int n = in.size();
    vector<vector<vector<long long>>> dp(n + 1, vector<vector<long long>> ((1 << 4), vector<long long> ((1 << 4), 0)));
    long long ans = 0;
    if(n <= 10) {
        for(int i = 0; i < (1 << n); i ++) {
            vector<bool> is_up(2 * n, false);
            int cur = i;
            int ind = 0;
            while(cur > 0) {
                is_up[ind] = (cur % 2) == 1;
                is_up[n + ind] = (cur % 2) == 1;
                cur /= 2;
                ind ++;
            }
            long long sum = 0;
            if(check(is_up)) {
                for(int j = 0; j < n; j ++) {
                    sum += in[j] * is_up[j];
                }
            }
            if(sum > ans) {
                ans = sum;
            }
        }
    }
    else {
        for (int i = 1; i < min(n + 1, 4); i++) {
            int k = (1 << i) - 1;
            long long sum = 0;
            for (int j = 0; j < i; j++) {
                sum += in[j];
            }
            dp[i][k][k << (4 - i)] = sum;
        }
        for (int i = 4; i < min(n + 1, 9); i++) {
            for (int mask1 = 0; mask1 < (1 << 4); mask1++) {
                for (int mask2 = 0; mask2 < (1 << 4); mask2++) {
                    if (check_2(mask1, mask2, i)) {
                        int sum = 0;
                        int cur_mask = ((mask1 - (mask2 >> (i - 4))) << (i - 4)) + mask2;
                        for (int lenght = 0; lenght < i; lenght++) {
                            sum += (cur_mask % 2) * in[i - lenght - 1];
                            cur_mask /= 2;
                        }
                        dp[i][mask1][mask2] = sum;
                    }
                }
            }
        }
        for (int i = 9; i < n + 1; i++) {
            for (int mask1 = 0; mask1 < (1 << 4); mask1++) {
                for (int mask2 = 0; mask2 < (1 << 4); mask2++) {
                    if (mask1 == 15 || mask2 == 15) {
                        continue;
                    } else {
                        if(8 + (mask2 >> 1) != 16) {
                            dp[i][mask1][mask2] += max(dp[i - 1][mask1][8 + (mask2 >> 1)] + in[i - 1],
                                                       dp[i - 1][mask1][mask2 >> 1]);
                        }
                        else {
                            dp[i][mask1][mask2] = dp[i - 1][mask1][mask2 >> 1];
                        }
                    }
                }
            }
        }
        for (int mask1 = 0; mask1 < (1 << 4); mask1 ++) {
            for(int mask2 = 0; mask2 < (1 << 4); mask2 ++) {
                vector<bool> end(4, false);
                vector<bool> begin(4, false);
                int cur1 = mask1;
                int cur2 = mask2;
                for(int j = 0; j < 4; j ++) {
                    end[3 - j] = (cur1 % 2 == 1);
                    begin[3 - j] = (cur2 % 2 == 1);
                    cur1 /= 2;
                    cur2 /= 2;
                }
                if(!((begin[0] && end[3] && end[2] && end[1]) || (begin[0] && end[3] && end[2] && begin[1]) || (begin[0] && end[3] && begin[2] && begin[1]) || (begin[0] && begin[3] && begin[2] && begin[1]) || (end[0] && end[3] && end[2] && end[1]))) {
                    ans = max(dp[n][mask1][mask2], ans);
                }
            }
        }
    }
    return ans;
}

int32_t main() {
    int n;
    cin >> n;
    vector<long long> in(n);
    for(int i = 0; i < n; i ++) {
        cin >> in[i];
    }
    cout << ans(in) << endl;
    int q;
    cin >> q;
    for(int i = 0; i < q; i ++) {
        int ind;
        long long val;
        cin >> ind >> val;
        ind --;
        in[ind] = val;
        cout << ans(in) << endl;
    }
    return 0;
}