#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        test_cnt = 100;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }

    for (int i = 0; i < test_cnt; ++i) {
        entry(i);

        while (DEV) {
            int ch = fgetc(stdin);
            if (ch == -1) {
                return 0;
            }
            if (!isspace(ch)) {
                ungetc(ch, stdin);
                break;
            }
        }
    }
}

template<typename T>
bool relmax(T &pl, T const val) {
    if (pl < val) {
        pl = val;
        return true;
    }
    return false;
}

template<typename T>
bool relmin(T &pl, T const val) {
    if (pl > val) {
        pl = val;
        return true;
    }
    return false;
}

using ll = long long;

using ld = __float128;

void entry(int test_id) {
    (void) test_id;
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& x : a) {cin >> x;}
    vector<int> ans(n);
    map<int, vector<int>> s;
    for (int i = 0; i < n; ++i) {
        s[a[i]].push_back(i);
    }
    for (auto const& [_,poss] : s) {
        int cur;
        for (int d = 1; d <= n; ++d) {
            cur = 0;
            for (int i : poss) {
                int l = i - d + 1;
                int r = min(i, n-d);
                relmax(l, cur);
                ans[d-1] += r - l + 1;
                cur = r + 1;
            }
        }
    }
    for (int x :ans) {
        cout <<x << " ";
    }cout << "\n";
}