#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        test_cnt = 100;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }

    for (int i = 0; i < test_cnt; ++i) {
        entry(i);

        while (DEV) {
            int ch = fgetc(stdin);
            if (ch == -1) {
                return 0;
            }
            if (!isspace(ch)) {
                ungetc(ch, stdin);
                break;
            }
        }
    }
}

template<typename T>
bool relmax(T &pl, T const val) {
    if (pl < val) {
        pl = val;
        return true;
    }
    return false;
}

template<typename T>
bool relmin(T &pl, T const val) {
    if (pl > val) {
        pl = val;
        return true;
    }
    return false;
}

using ll = long long;

using ld = __float128;

void entry(int test_id) {
    (void) test_id;
    int n;
    cin >> n;
    vector<ll> a(n);
    for (ll & x : a) {cin >> x;}
    ll s = accumulate(a.begin(), a.end(), ll(0));
    ll t = 0;
    int ans_pos;
    ll ans = -1;
    for (int i = 0; i < n; ++i) {
        t += a[i];
        if (relmax(ans, t * (s-t))) {
            ans_pos = i;
        }
    }
    cout << ans_pos + 1 << "\n";
 }