#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        test_cnt = 100;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }

    for (int i = 0; i < test_cnt; ++i) {
        entry(i);

        while (DEV) {
            int ch = fgetc(stdin);
            if (ch == -1) {
                return 0;
            }
            if (!isspace(ch)) {
                ungetc(ch, stdin);
                break;
            }
        }
    }
}

template<typename T>
bool relmax(T &pl, T const val) {
    if (pl < val) {
        pl = val;
        return true;
    }
    return false;
}

template<typename T>
bool relmin(T &pl, T const val) {
    if (pl > val) {
        pl = val;
        return true;
    }
    return false;
}

using ll = long long;

using ld = __float128;

const int ALLOC_MEM_SZ = 160 * 1024 * 1024;
char ALLOC_MEM[ALLOC_MEM_SZ];
int ALLOC_POS = ALLOC_MEM_SZ;

void* operator new(size_t n) {
    //void* ret = ALLOC_MEM + ALLOC_POS;
    ALLOC_POS -= n;
    return ALLOC_MEM + ALLOC_POS;
}

void  operator delete (void* p) {
    (void) p;
}



vector<int> mp_f[10'000'001];
vector<int> mp_s[10'000'001];


void entry(int test_id) {
    (void) test_id;
    int n;
    cin >> n;
    int x;
    cin >> x;
    if (n == 6 && x == 1) {
        n = 3000;
        x = 0;
    }
    ll ans = 0;

    for (int a = n; a > 0; --a) {
        int s = 0;
        for (int b = 1; b <= n; ++b) {
            s += a;
            mp_f[s].emplace_back(a);
            mp_s[s].emplace_back(b);
        }
    }
    for (int s = 1; s + n <= n * n; ++s) {
        size_t k1 = mp_s[s].size();
        size_t k2 = mp_s[s+n].size();
        //auto const &small = mp[s];
        //auto const &large = mp[s + n];
        if (k1 == 0 || k2 == 0) {continue;}
        ll p1 = 0;
        ll p2 = 0;
        for (int i = 0; i < k2; ++i) {
            if (mp_f[s+n][i] == x || mp_s[s+n][i] == x) { continue; }
            while (true) {
                if (__builtin_expect( p1 < k1, 1)) {
                    if (mp_f[s][p1] >=  mp_f[s+n][i]) {
                        ++p1;
                    } else { break; }
                } else {
                    goto t;
                }
            }
            while (p2 <k1 &&  mp_s[s][p2] < mp_s[s+n][i]) {
                ++p2;
            }
            ans += p2 - p1;
            t: (void) 0;
        }
    }
    cout << ans << "\n";
}