#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        test_cnt = 100;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }

    for (int i = 0; i < test_cnt; ++i) {
        entry(i);

        while (DEV) {
            int ch = fgetc(stdin);
            if (ch == -1) {
                return 0;
            }
            if (!isspace(ch)) {
                ungetc(ch, stdin);
                break;
            }
        }
    }
}

template<typename T>
bool relmax(T &pl, T const val) {
    if (pl < val) {
        pl = val;
        return true;
    }
    return false;
}

template<typename T>
bool relmin(T &pl, T const val) {
    if (pl > val) {
        pl = val;
        return true;
    }
    return false;
}

using ll = long long;

using ld = __float128;

const int ALLOC_MEM_SZ = 160 * 1024 * 1024;
char ALLOC_MEM[ALLOC_MEM_SZ];
int ALLOC_POS = ALLOC_MEM_SZ;

void* operator new(size_t n) {
    //void* ret = ALLOC_MEM + ALLOC_POS;
    ALLOC_POS -= n;
    return ALLOC_MEM + ALLOC_POS;
}

void  operator delete (void* p) {
    (void) p;
}



// vector<pair<int, int>> mp[10'000'001];
void entry(int test_id) {
    (void) test_id;
    int n;
    cin >> n;
    vector<ll> a(n);
    for (ll& x : a) {cin >>x;}
    int q;
    cin >> q;
    auto _a = a;
    for (int j = 0; j <= q; ++j) {
        if (j > 0) {
            int p, v;
            cin >> p >> v;
            --p;
            a[p] = v;
        }

        auto t = vector<ll>(n+1, -1e18);
        ll ans = -1e18;
        for (int _i = 0; _i < n; ++_i) {
            {
                a.insert(a.begin(), ll(a.back()));
                a.pop_back();
            }
            vector<ll> dp[4] = {t, t, t, t};
            dp[0][0] = 0;
            for (int i = 0; i < n; ++i) {
                for (int h = 0; h < 4; ++h) {
                    if (h < 3) {
                        relmax(dp[h + 1][i + 1], dp[h][i] + a[i]);
                    }
                    relmax(dp[0][i + 1], dp[h][i]);
                }
            }
            ans = max({ans, dp[0][n]});
            //
            // ans = max({ans, dp[0][n], dp[1][n], dp[2][n], dp[3][n]});
        }
        cout << ans << "\n";
    }

}