#include <bits/stdc++.h>

using namespace std;

#define int long long

int solve(vector<int> a)
{
    vector<int> dp(a.size());
    dp[1] = a[1];
    dp[2] = a[1] + a[2];
    dp[3] = a[1] + a[2] + a[3];
    for (int i = 4; i < a.size(); ++i)
    {
        dp[i] = dp[i - 1];
        dp[i] = max(dp[i], dp[i - 2] + a[i]);
        dp[i] = max(dp[i], dp[i - 3] + a[i] + a[i - 1]);
        dp[i] = max(dp[i], dp[i - 4] + a[i] + a[i - 1] + a[i - 2]);
    }
    return dp.back();
}

int get(vector<int> a)
{
    int n = a.size();
    int res = solve(a);
    int t;
    for (int i = 0; i < 3; ++i)
    {
        reverse(a.begin(), a.end());
        t = a.back();
        a.pop_back();
        reverse(a.begin(), a.end());
        a.push_back(t);
        res = max(res, solve(a));
    }
    return res;

}

signed main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    cout << get(a) << endl;
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i)
    {
        int p, v;
        cin >> p >> v;
        --p;
        a[p] = v;
        cout << get(a) << endl;
    }
}
