#include <bits/stdc++.h>

using namespace std;

#define int long long

int solve(vector<int> a)
{
    if (a.size() < 4)
    {
        int res = 0;
        for (int i = 0; i < a.size(); ++i) res += a[i];
        return res;
    }
    vector<int> dp(a.size());
    dp[0] = a[0];
    dp[1] = a[0] + a[1];
    dp[2] = a[0] + a[1] + a[2];
    dp[3] = dp[2];
    dp[3] = max(dp[3], dp[1] + a[3]);
    dp[3] = max(dp[3], dp[0] + a[3] + a[2]);
    dp[3] = max(dp[3], a[3] + a[2] + a[1]);
    for (int i = 4; i < a.size(); ++i)
    {
        dp[i] = dp[i - 1];
        dp[i] = max(dp[i], dp[i - 2] + a[i]);
        dp[i] = max(dp[i], dp[i - 3] + a[i] + a[i - 1]);
        dp[i] = max(dp[i], dp[i - 4] + a[i] + a[i - 1] + a[i - 2]);
    }
    return dp.back();
}

signed main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<int> a1(n - 1), a2(n - 1), a3(n - 1), a4(n - 1);
    for (int i = 0; i < n - 1; ++i) a1[i] = a[(i + 1) % n];
    for (int i = 0; i < n - 1; ++i) a2[i] = a[(i + 2) % n];
    for (int i = 0; i < n - 1; ++i) a3[i] = a[(i + 3) % n];
    for (int i = 0; i < n - 1; ++i) a4[i] = a[(i + 4) % n];
    cout << max(max(solve(a1), solve(a2)), max(solve(a3), solve(a4))) << endl;
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i)
    {
        int p, v;
        cin >> p >> v;
        --p;
        if (p != 0)
        {
            a1[(p - 1 + n) % (n)] = v;
        }

        if (p != 1)
        {
            a2[(p - 2 + n) % (n)] = v;
        }

        if (p != 2)
        {
            a3[(p - 3 + n) % (n)] = v;
        }

        if (p != 3)
        {
            a4[(p - 4 + n) % (n)] = v;
        }
        cout << max(max(solve(a1), solve(a2)), max(solve(a3), solve(a4))) << endl;
    }
}
