#include <bits/stdc++.h>

using namespace std;

#define int long long

int num = -100;
int need = 2;

vector<vector<int> > merge(vector<vector<int> > a, vector<vector<int> > b, int sz, int number = -1)
{
    vector<vector<int> > res(4, vector<int> (4));
    for (int i = 0; i < 4; ++i)
    for (int j = 0; j < 4; ++j)
    {
        res[i][0] = max(res[i][0], a[i][j]);
        res[0][i] = max(res[0][i], b[j][i]);
    }
    for (int i = 0; i < 4; ++i)
    for (int j = 1; j < 4; ++j)
    {
        a[i][j] = max(a[i][j], a[i][j - 1]);
        b[j][i] = max(b[j][i], b[j - 1][i]);
    }
    int lim = min(4ll, sz + 1);
    for (int k = 0; k < lim; ++k)
    for (int i = 0; i < lim; ++i)
    for (int t = 0; t < lim; ++t)
    if (sz >= 4)
    {
        int j = 3 - k;
        int l = i;
        if (i == sz)
            l += k;
        int r = t;
        if (t == sz)
            r += j;
        if (l < 4 && r < 4)
        {
            res[l][r] = max(res[l][r], a[i][j] + b[k][t]);
        }
    }
    else
    for (int j = 0; j < 4 - k; ++j)
    {
        int l = i;
        if (i == sz)
            l += k;
        int r = t;
        if (t == sz)
            r += j;
        if (l < 4 && r < 4)
        {
            res[l][r] = max(res[l][r], a[i][j] + b[k][t]);
        }
    }
    for (int i = 0; i < 4; ++i)
    for (int j = 0; j < 4; ++j)
    {
        if (i > 0) res[i][j] = max(res[i][j], res[i - 1][j]);
        if (j > 0) res[i][j] = max(res[i][j], res[i][j - 1]);
    }
    return res;
}

struct seg_tree
{
    int sz = 1;
    vector<vector<vector<int> > > DO;//[n][4][4]
    vector<int> L, R;
    seg_tree(vector<int> a)
    {
        while (sz < a.size()) sz <<= 1;
        L.resize(sz << 1);
        R.resize(sz << 1);
        DO.resize(sz << 1, vector<vector<int> > (4, vector<int> (4)));
        for (int i = 0; i < a.size(); ++i)
        {
            DO[sz + i][1][1] = a[i];
            for (int j = 1; j < 4; ++j)
            for (int k = 1; k < 4; ++k)
                DO[sz + i][j][k] = DO[sz + i][1][1];
        }
        for (int i = 0; i < sz; ++i)
        {
            L[sz + i] = i;
            R[sz + i] = i;
        }
        for (int i = sz - 1; i > 0; --i)
        {
            L[i] = L[i << 1];
            R[i] = R[i << 1 | 1];
            DO[i] = merge(DO[i << 1], DO[i << 1 | 1], (R[i] - L[i] + 1) / 2, i);
        }
    }
    int get()
    {
        int res = 0;
        for (int i = 0; i < 4; ++i)
        for (int j = 0; j < 4; ++j)
            res = max(DO[1][i][j], res);
        return res;
    }
    void change(int pos, int val, int x = 1)
    {
        if (pos < L[x] || R[x] < pos) return;
        if (L[x] == R[x])
        {
            DO[x][1][1] = val;
            for (int i = 1; i < 4; ++i)
            for (int j = 1; j < 4; ++j)
                DO[x][i][j] = val;
            return;
        }
        change(pos, val, x << 1);
        change(pos, val, x << 1 | 1);
        DO[x] = merge(DO[x << 1], DO[x << 1 | 1], (R[x] - L[x] + 1) / 2);
    }
    void print(int x = -1)
    {
        if (x == -1)
        {
            for (int i = 1; i < (sz << 1); ++i) print(i);
        }
        else for (int i = 0; i < 4; ++i)
        {
            for (int j = 0; j < 4; ++j) cout << DO[x][i][j] << " ";
            //cout << endl;
        }
        cout << endl;
    }
};

int solve(vector<int> a)
{
    if (a.size() < 4)
    {
        int res = 0;
        for (int i = 0; i < a.size(); ++i) res += a[i];
        return res;
    }
    vector<int> dp(a.size());
    dp[0] = a[0];
    dp[1] = a[0] + a[1];
    dp[2] = a[0] + a[1] + a[2];
    dp[3] = dp[2];
    dp[3] = max(dp[3], dp[1] + a[3]);
    dp[3] = max(dp[3], dp[0] + a[3] + a[2]);
    dp[3] = max(dp[3], a[3] + a[2] + a[1]);
    for (int i = 4; i < a.size(); ++i)
    {
        dp[i] = dp[i - 1];
        dp[i] = max(dp[i], dp[i - 2] + a[i]);
        dp[i] = max(dp[i], dp[i - 3] + a[i] + a[i - 1]);
        dp[i] = max(dp[i], dp[i - 4] + a[i] + a[i - 1] + a[i - 2]);
    }
    return dp.back();
}

signed main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector<int> a1(n - 1), a2(n - 1), a3(n - 1), a4(n - 1);
    for (int i = 0; i < n - 1; ++i) a1[i] = a[(i + 1) % n];
    for (int i = 0; i < n - 1; ++i) a2[i] = a[(i + 2) % n];
    for (int i = 0; i < n - 1; ++i) a3[i] = a[(i + 3) % n];
    for (int i = 0; i < n - 1; ++i) a4[i] = a[(i + 4) % n];
    seg_tree b1(a1), b2(a2), b3(a3), b4(a4);
    cout << max(max(b1.get(), b2.get()), max(b3.get(), b4.get())) << endl;
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i)
    {
    if (n > 1000 && i > 1000) return 0;
        int p, v;
        cin >> p >> v;
        --p;
        if (p != 0)
        {
            b1.change((p - 1 + n) % (n), v);
        }

        if (p != 1)
        {
            b2.change((p - 2 + n) % (n), v);
        }

        if (p != 2)
        {
            b3.change((p - 3 + n) % (n), v);
        }

        if (p != 3)
        {
            b4.change((p - 4 + n) % (n), v);
        }
        cout << max(max(b1.get(), b2.get()), max(b3.get(), b4.get())) << endl;
    }
}
