#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string>

using namespace std;

int main() {
	long long n, m, q, b;
	cin >> n;

	vector<pair<int, int>> road(n);
	
	//speed
	for (int i = 0; i < n; i++) {
		cin >> b;
		road[i].second = b;
	}
	//len
	for (int i = 0; i < n; i++) {
		cin >> b;
		road[i].first = b;
	}

	cin >> m;
	vector<int> a(m);
	vector<int> f(m + 1);
	vector<double> minTime(m, 0);
	//max speed increase
	a[0] = 0;
	for (int i = 1; i < m; i++) {
		cin >> a[i];
	}
	//pay
	f[0] = 0;
	for (int i = 1; i < m + 1; i++) {
		cin >> f[i];
	}

	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++)
			minTime[i] += ((double)road[j].first) / ((double)(road[j].second + a[i]));
	}

	/*for (int i = 0; i < m; i++) {
		cout << a[i] << " ";
	}
	cout << "\n";
	for (int i = 0; i < m; i++) {
		cout << minTime[i] << " ";
	}
	cout << "\n";
	for (int i = 0; i < m + 1; i++) {
		cout << f[i] << " ";
	}
	cout << "\n";*/

	cin >> q;
	int s, t, time;
	for (int i = 0; i < q; i++) {
		cin >> s >> t;
		time = t - s;

		if (time >= minTime[0]) {
			cout << 0;
		}
		else if (time < minTime[m - 1]) {
			cout << f[m];
		}
		else {
			int l = 0;
			int r = m;
			int mid;

			while (true) {
				mid = (l + r) / 2;

				if (time < minTime[mid] && time >= minTime[mid + 1]) {
					cout << f[mid + 1];
					break;
				}
				else if (time >= minTime[mid]) {
					r = mid;
				}
				else if (time < minTime[mid + 1]) {
					l = mid;
				}
			}
		}

		cout << "\n";
		//cout << time << "\n";
	}

	return 0;
}