#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

int main() {
	long long n, m, q, b;
	cin >> n;
	vector<int> task(n);
	
	for (int i = 0; i < n; i++) {
		cin >> task[i];
	}

	vector<int> S(n, 0);
	vector<int> pref(n, 0);
	vector<int> suf(n, 0);

	set<int> unique;
	for (int i = 0; i < n; i++) {
		unique.insert(task[i]);

		pref[i] = unique.size();
	}
	
	unique = set<int>();
	for (int i = n - 1; i > -1; i--) {
		unique.insert(task[i]);

		suf[i] = unique.size();
	}

	/*cout << "\n";
	for (int i = 0; i < n; i++) {
		cout << pref[i] << " ";
	}
	cout << "\n";
	for (int i = 0; i < n; i++) {
		cout << suf[i] << " ";
	}
	cout << "\n";*/

	for (int i = 0; i < n; i++) {
		unique = set<int>();

		for (int j = 0; j < n - i; j++) {
			unique.insert(task[i + j]);

			S[j] += unique.size();
		}
	}

	for (int i = 0; i < n; i++) {
		cout << S[i] << " ";
	}

	return 0;
}