#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

bool comp(pair<int, int> a, pair<int, int> b) {
	return a.second < b.second;
}

int main() {
	long long n, a;
	cin >> n;
	vector<int> S(n, 0);
	set<int> unique;
	vector<int> oldTask(n);
	vector<pair<int, int>> task(n);
	
	for (int i = 0; i < n; i++) {
		cin >> a;
		task[i] = { a, i };
		oldTask[i] = a;
	}

	sort(oldTask.begin(), oldTask.end());
	sort(task.begin(), task.end());

	int difNumb = 0;
	task[0].first = difNumb;
	//cout << task[0].first << " ";
	for (int i = 1; i < n; i++) {
		if (task[i].first != oldTask[i - 1]) {
			difNumb++;
		}
		task[i].first = difNumb;

		//cout << task[i].first << " ";
	}
	//cout << "\n";

	sort(task.begin(), task.end(), comp);
	/*for (int i = 0; i < n; i++) {
		cout << task[i].first << " ";
	}
	cout << "\n";*/

	//to keep array normal size
	difNumb++;
	vector<bool> used(difNumb, false);

	/*vector<int> pref(n, 0);
	vector<int> suf(n, 0);
	for (int i = 0; i < n; i++) {
		unique.insert(task[i]);

		pref[i] = unique.size();
	}
	
	unique = set<int>();
	for (int i = n - 1; i > -1; i--) {
		unique.insert(task[i]);

		suf[i] = unique.size();
	}*/

	/*cout << "\n";
	for (int i = 0; i < n; i++) {
		cout << pref[i] << " ";
	}
	cout << "\n";
	for (int i = 0; i < n; i++) {
		cout << suf[i] << " ";
	}
	cout << "\n";*/

	for (int i = 0; i < n; i++) {
		used = vector<bool>(difNumb, false);
		int counter = 0;

		for (int j = 0; j < n - i; j++) {
			if (!used[task[i + j].first]) {
				used[task[i + j].first] = true;
				counter++;
			}

			S[j] += counter;
		}
	}

	for (int i = 0; i < n; i++) {
		cout << S[i] << " ";
	}

	return 0;
}