#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string>
#include <queue>

using namespace std;

int countGoodDivisers(int numb, int a, int b) {
	int counter = 0;

	for (int i = 1; i <= sqrt(numb); i++) {
		if (numb % i == 0) {
			if (i < a && (numb / i) < b) {
				//cout << "Good four: " << a << " " << b << " " << i << " " << numb / i << "\n";
				counter++;
			}
			if (numb / i != i && i < b && (numb / i) < a) {
				//cout << "Good four: " << a << " " << b << " " << numb / i << " " << i << "\n";
				counter++;
			}
		}
	}

	return counter;
}

int main() {
	int n, x;

	cin >> n >> x;

	long long ans = 0;

	for (int i = 2; i <= n; i++) {
		for (int j = 2; j <= n; j++) {
			if (i != x && j != x) {
				ans += countGoodDivisers((i * j - n), i, j);
			}
		}
	}

	cout << ans;
}