#include <iostream>
#include <vector>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <algorithm>
#include <unordered_map>
using namespace std;
#define int long long


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int amount;
    cin >> amount;
    if (amount <= 100000000) {
        int line[amount];
        for (int i = 0; i < amount; ++i) {
            cin >> line[i];
        }
        unordered_map <int, int> numb;
        int current, ans;
        for (int d = 1; d <= amount; ++d) {
            ans = 0;
            current = 0;
            numb.clear();
            for (int i = 0; i < d; ++i) {
                ++numb[line[i]];
                if (numb[line[i]] == 1) {
                    ++current;
                }
            }
            ans += current;
            for (int i = d; i < amount; ++i) {
                --numb[line[i - d]];
                if (numb[line[i - d]] == 0) {
                    --current;
                }
                ++numb[line[i]];
                if (numb[line[i]] == 1) {
                    ++current;
                }
                ans += current;
            }
            cout << ans << ' ';
        }
    }else{
        vector< int > uniq;
        set< int > un;
        int line[amount];
        for (int i = 0; i < amount; ++i) {
            cin >> line[i];
            un.insert(line[i]);
        }
        for (auto it = un.begin(); it != un.end(); ++it){
            uniq.push_back(*it);
        }
        int numb[uniq.size()];
        int current, ans;
        int new_i, old_i;
        for (int d = 1; d <= amount; ++d) {
            for (int i = 0; i < uniq.size(); ++i) {
                numb[i] = 0;
            }
            ans = 0;
            current = 0;
            for (int i = 0; i < d; ++i) {
                new_i = lower_bound(uniq.begin(), uniq.end(), line[i]) - uniq.begin();
                ++numb[new_i];
                if (numb[new_i] == 1) {
                    ++current;
                }
            }
            ans += current;
            for (int i = d; i < amount; ++i) {
                new_i = lower_bound(uniq.begin(), uniq.end(), line[i]) - uniq.begin();
                old_i = lower_bound(uniq.begin(), uniq.end(), line[i - d]) - uniq.begin();
                --numb[old_i];
                if (numb[old_i] == 0) {
                    --current;
                }
                ++numb[new_i];
                if (numb[new_i] == 1) {
                    ++current;
                }
                ans += current;
            }
            cout << ans << ' ';
        }
    }
    return 0;
}