#include <iostream>
#include <vector>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#define int long long
#define double long double

vector< int > money;


int count(int needed){
    int ans = 0;
    while (needed > 0){
        int i = upper_bound(money.begin(), money.end(), needed) - money.begin();
        --i;
        ans += needed / money[i];
        needed %= money[i];
    }
    return ans;
}


int count_1(int needed){
    while (needed > 0){
        int i = upper_bound(money.begin(), money.end(), needed) - money.begin();
        --i;
        if (money[i] == 1){
            return needed;
        }
        needed %= money[i];
    }
    return 0;
}


signed main() {
    int amount;
    cin >> amount;
    money.resize(amount);
    for (int i = 0; i < amount; ++i){
        cin >> money[i];
    }
    int req;
    cin >> req;
    for (int z = 0; z < req; ++z){
        int needed;
        cin >> needed;
        int a = needed;
        needed -= count_1(needed);
        --needed;
        int b = needed;
        if (b < 0){
            cout << a << ' ' << count(a) << "\n";
        }else if (count(a) > count(b))
        {
            cout << a << ' ' << count(a) << "\n";
        }else {
            cout << b << ' ' << count(b) << "\n";
        }
    }
    return 0;
}