#include <iostream>
#include <vector>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#define int long long
#define double long double

vector< int > money;


int count(int needed){
    int ans = 0;
    while (needed > 0){
        int i = upper_bound(money.begin(), money.end(), needed) - money.begin();
        --i;
        ans += needed / money[i];
        needed %= money[i];
    }
    return ans;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int amount;
    bool ez = true;
    cin >> amount;
    money.resize(amount);
    int current = 1;
    for (int i = 0; i < amount; ++i){
        cin >> money[i];
        if (money[i] != current){
            ez = false;
        }
        current *= 2;
    }
    if (amount == 1){
        ez = false;
    }
    int req;
    cin >> req;
    for (int z = 0; z < req; ++z){
        int needed;
        cin >> needed;
        if (!ez) {
            int i = 0;
            int sum = 0;
            int ans = 0;
            int prev = 0;
            while (true){
                int number = needed / money[i];
                if (i < money.size() - 1){
                    if (money[i + 1] % money[i] == 0){
                        number = min(number, money[i + 1] / money[i] - 1);
                    }else{
                        number = min(number, money[i + 1] / money[i]);
                    }
                }
                ans += number;
                sum += number * money[i];
                needed -= number * money[i];
                if (i < money.size() - 1){
                    ++i;
                }
                if (sum == prev){
                    break;
                }
                prev = sum;
            }
            cout << sum << ' ' << ans << "\n";
        }else{
            int i = upper_bound(money.begin(), money.end(), needed) - money.begin();
            int a = __builtin_popcount(needed);
            int b = i - 1;
            if (a > b){
                cout << needed << ' ' << a << "\n";
            }else{
                cout << money[i - 1] - 1 << ' ' << b << "\n";
            }
        }
    }
    return 0;
}