#include <iostream>
#include <vector>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#define int long long
#define double long double

vector< int > money;


int count(int needed){
    int ans = 0;
    while (needed > 0){
        int i = upper_bound(money.begin(), money.end(), needed) - money.begin();
        --i;
        ans += needed / money[i];
        needed %= money[i];
    }
    return ans;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int amount;
    bool ez = true;
    cin >> amount;
    money.resize(amount);
    int current = 1;
    for (int i = 0; i < amount; ++i){
        cin >> money[i];
        if (money[i] != current){
            ez = false;
        }
        current *= 2;
    }
    int next[amount - 1];
    for (int i = 0; i < amount - 1; ++i){
        next[i] = count(money[i + 1] - 1);
    }
    if (amount == 1){
        int req;
        cin >> req;
        for (int i = 0; i < req; ++i){
            int k;
            cin >> k;
            cout << k << ' ' << k << "\n";
        }
        return 0;
    }
    int req;
    cin >> req;
    for (int z = 0; z < req; ++z){
        int needed;
        cin >> needed;
        if (!ez) {
            int maximum = -1;
            int best = needed;
            int best_ans = count(needed);
            if (best_ans < money[1] - 1 && needed > money[1] - 1){
                best_ans = money[1] - 1;
                best = money[1] - 1;
                maximum = money[1] - 1;
            }
            for (int i = 1; i < amount; ++i){
                if (needed <= money[i]){
                    break;
                }
                current = count(needed - needed % money[i] - 1);
                maximum = max(maximum, needed - needed % money[i] - 1);
                if (current > best_ans){
                    best_ans = current;
                    best = needed - needed % money[i] - 1;
                }
            }
            for (int i = maximum + 2; i <= needed; ++i){
                if (count(i) > best_ans){
                    best_ans = count(i);
                    best = i;
                }
            }
            cout << best << ' ' << best_ans << "\n";
        }else{
            int i = upper_bound(money.begin(), money.end(), needed) - money.begin();
            int a = __builtin_popcount(needed);
            int b = i - 1;
            if (a > b){
                cout << needed << ' ' << a << "\n";
            }else{
                cout << money[i - 1] - 1 << ' ' << b << "\n";
            }
        }
    }
    return 0;
}