#include <iostream>
#include <vector>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#define int long long
#define double long double


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int amount;
    cin >> amount;
    int a[amount];
    for (int i = 0; i < amount; ++i){
        cin >> a[i];
    }
    int dp[amount][4][4];
    for (int i = 0; i < amount; ++i){
        for (int j = 0; j < 4; ++j){
            for (int k = 0; k < 4; ++k){
                dp[i][j][k] = 0;
            }
        }
    }

    for (int i = 1; i < amount; ++i){
        dp[i][0][0] = max(max(dp[i - 1][0][0], dp[i - 1][1][0]), max(dp[i - 1][2][0], dp[i - 1][3][0]));
        for (int j = 1; j < 4; ++j){
            if (dp[i - 1][j - 1][0] > 0 || j == 1) {
                dp[i][j][0] = dp[i - 1][j - 1][0] + a[i];
            }
        }
    }
    dp[0][1][1] = a[0];
    for (int i = 1; i < amount - 1; ++i){
        dp[i][0][1] = max(max(dp[i - 1][0][1], dp[i - 1][1][1]), max(dp[i - 1][2][1], dp[i - 1][3][1]));
        for (int j = 1; j < 4; ++j){
            if (dp[i - 1][j - 1][1] > 0 || j == 1) {
                dp[i][j][1] = dp[i - 1][j - 1][1] + a[i];
            }
        }
    }
    dp[amount - 1][0][1] = max(max(dp[amount - 2][0][1], dp[amount - 2][1][1]),
            max(dp[amount - 2][2][1], dp[amount - 2][3][1]));
    for (int j = 1; j < 3; ++j){
        dp[amount - 1][j][1] = max(dp[amount - 2][j][1], dp[amount - 2][j - 1][1] + a[amount -1]);
    }

    dp[0][1][2] = a[0];
    dp[1][2][2] = a[0] + a[1];
    for (int i = 2; i < amount - 1; ++i){
        dp[i][0][2] = max(max(dp[i - 1][0][2], dp[i - 1][1][2]),
                max(dp[i - 1][2][2], dp[i - 1][3][2]));
        for (int j = 1; j < 4; ++j){
            if (dp[i - 1][j - 1][2] > 0 || j == 1) {
                dp[i][j][2] = dp[i - 1][j - 1][2] + a[i];
            }
        }
    }
    dp[amount - 1][0][2] = max(max(dp[amount - 2][0][2], dp[amount - 2][1][2]),
                               max(dp[amount - 2][2][2], dp[amount - 2][3][2]));
    dp[amount - 1][1][2] = max(dp[amount - 2][1][2], dp[amount - 2][0][2] + a[amount -1]);

    dp[0][1][3] = a[0];
    dp[1][2][3] = a[0] + a[1];
    dp[2][3][3] = a[0] + a[1] + a[2];

    for (int i = 3; i < amount - 1; ++i){
        dp[i][0][3] = max(max(dp[i - 1][0][3], dp[i - 1][1][3]),
                          max(dp[i - 1][2][3], dp[i - 1][3][3]));
        for (int j = 1; j < 4; ++j){
            if (dp[i - 1][j - 1][3] > 0 || j == 1) {
                dp[i][j][3] = dp[i - 1][j - 1][3] + a[i];
            }
        }
    }
    dp[amount - 1][0][3] = max(max(dp[amount - 2][0][3], dp[amount - 2][1][3]),
                               max(dp[amount - 2][2][3], dp[amount - 2][3][3]));

    int best = -1;
    for (int i = 0; i < 4; ++i){
        for (int j = 0; j < 4; ++j){
            best = max(best, dp[amount - 1][i][j]);
        }
    }
    cout << best << "\n";
    int req;
    cin >> req;
    for (int z = 0; z < req; ++z){
        int pos, new_val;
        cin >> pos >> new_val;
        --pos;
        a[pos] = new_val;
        for (int i = 0; i < amount; ++i){
            for (int j = 0; j < 4; ++j){
                for (int k = 0; k < 4; ++k){
                    dp[i][j][k] = 0;
                }
            }
        }

        for (int i = 1; i < amount; ++i){
            dp[i][0][0] = max(max(dp[i - 1][0][0], dp[i - 1][1][0]), max(dp[i - 1][2][0], dp[i - 1][3][0]));
            for (int j = 1; j < 4; ++j){
                if (dp[i - 1][j - 1][0] > 0 || j == 1) {
                    dp[i][j][0] = dp[i - 1][j - 1][0] + a[i];
                }
            }
        }
        dp[0][1][1] = a[0];
        for (int i = 1; i < amount - 1; ++i){
            dp[i][0][1] = max(max(dp[i - 1][0][1], dp[i - 1][1][1]), max(dp[i - 1][2][1], dp[i - 1][3][1]));
            for (int j = 1; j < 4; ++j){
                if (dp[i - 1][j - 1][1] > 0 || j == 1) {
                    dp[i][j][1] = dp[i - 1][j - 1][1] + a[i];
                }
            }
        }
        dp[amount - 1][0][1] = max(max(dp[amount - 2][0][1], dp[amount - 2][1][1]),
                                   max(dp[amount - 2][2][1], dp[amount - 2][3][1]));
        for (int j = 1; j < 3; ++j){
            dp[amount - 1][j][1] = max(dp[amount - 2][j][1], dp[amount - 2][j - 1][1] + a[amount -1]);
        }

        dp[0][1][2] = a[0];
        dp[1][2][2] = a[0] + a[1];
        for (int i = 2; i < amount - 1; ++i){
            dp[i][0][2] = max(max(dp[i - 1][0][2], dp[i - 1][1][2]),
                              max(dp[i - 1][2][2], dp[i - 1][3][2]));
            for (int j = 1; j < 4; ++j){
                if (dp[i - 1][j - 1][2] > 0 || j == 1) {
                    dp[i][j][2] = dp[i - 1][j - 1][2] + a[i];
                }
            }
        }
        dp[amount - 1][0][2] = max(max(dp[amount - 2][0][2], dp[amount - 2][1][2]),
                                   max(dp[amount - 2][2][2], dp[amount - 2][3][2]));
        dp[amount - 1][1][2] = max(dp[amount - 2][1][2], dp[amount - 2][0][2] + a[amount -1]);

        dp[0][1][3] = a[0];
        dp[1][2][3] = a[0] + a[1];
        dp[2][3][3] = a[0] + a[1] + a[2];

        for (int i = 3; i < amount - 1; ++i){
            dp[i][0][3] = max(max(dp[i - 1][0][3], dp[i - 1][1][3]),
                              max(dp[i - 1][2][3], dp[i - 1][3][3]));
            for (int j = 1; j < 4; ++j){
                if (dp[i - 1][j - 1][3] > 0 || j == 1) {
                    dp[i][j][3] = dp[i - 1][j - 1][3] + a[i];
                }
            }
        }
        dp[amount - 1][0][3] = max(max(dp[amount - 2][0][3], dp[amount - 2][1][3]),
                                   max(dp[amount - 2][2][3], dp[amount - 2][3][3]));

        best = -1;
        for (int i = 0; i < 4; ++i){
            for (int j = 0; j < 4; ++j){
                best = max(best, dp[amount - 1][i][j]);
            }
        }
        cout << best << "\n";
    }
    return 0;
}