#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#define int long long
using namespace std;

int n;
vector<int> speed, len;

int check(int e) {
    long double ans = 0;
    for (int i = 0; i < n; ++i) {
        if ((speed[i] + e) > len[i]) {
            continue;
        }
        ans += (long double)len[i] / (long double)(speed[i] + e);
    }
    return ans;
}

signed main() {
    cin >> n;
    speed.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> speed[i];
    }
    len.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> len[i];
    }
    int m;
    cin >> m;
    vector<int> lim(m - 1);
    for (int i = 0; i < m - 1; ++i) {
        cin >> lim[i];
    }
    lim.push_back(1e18);
    vector<int> shtraf(m);
    for (int i = 0; i < m; ++i) {
        cin >> shtraf[i];
    }
    int q;
    cin >> q;
    ++q;
    while (--q) {
        int start, finish;
        cin >> start >> finish;
        int d_time = (finish - start + 1);
        int l = 0, r = 1e9;
        while (r != l) {
            int mid = (l + r) / 2;
            if (check(mid) <= d_time) {
                r = mid;
            } else {
                l = mid + 1;
            }
        }
        if (l == 0) {
            cout << 0 << endl;
            continue;
        }
        int ind = lower_bound(lim.begin(), lim.end(), l) - lim.begin();
        cout << shtraf[ind] << endl;
    }
}
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100


 1
 10
 1000
 1
 1303
 100

 */