#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

bool check(int d, int n, vector<int> &dist, vector<int> &v, int time) {
    ld need = 0;
    for (int i = 0; i < n; ++i) {
        need += dist[i] / (ld)(v[i] + d);
    }
    return need <= time;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> dist(n), v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> dist[i];
    }
    int m;
    cin >> m;
    vector<int> a(m), f(m);
    for (int i = 0; i < m - 1; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> f[i];
    }
    int q;
    cin >> q;
    while (q) {
        q--;
        int start, finish;
        cin >> start >> finish;
        int time = finish - start;
        int l = -1, r = m;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (check((mid > 0 ? a[mid - 1] : 0), n, dist, v, time)) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cout << (r > 0 ? f[r - 1] : 0) << endl;
    }
}
