#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

int fHungryCashpoint(int iCredit, std::vector <long long>& vMoney)
{
    int iAmCoins = 0;
    int iSize = vMoney.size();

    for(int iIterator = 0; iIterator < iSize; iIterator ++)
    {
        iAmCoins += iCredit / vMoney[iSize - 1 - iIterator];

        iCredit %= vMoney[iSize - 1 - iIterator];
    }

    return iAmCoins;
}




int main()
{
    int iAmMoneyTypes;
    std::cin >> iAmMoneyTypes;
    std::vector <long long> vMoneyTypes(iAmMoneyTypes);
    for(int iIterator = 0; iIterator < iAmMoneyTypes; iIterator ++)
        std::cin >> vMoneyTypes[iIterator];

    int iIfTwos = 1;
    for(int iIterator = 1; iIterator < iAmMoneyTypes; iIterator ++)
    {
        if(vMoneyTypes[iIterator] != 2 * vMoneyTypes[iIterator + 1])
        {
            iIfTwos = 0;
            break;
        }
    }







    int iAmQuestions;
    std::cin >> iAmQuestions;


    if(iIfTwos == 1)
    {
        for(int iIterator = 0; iIterator < iAmQuestions; iIterator ++)
        {
            long long iQuestion;
            std::cin >> iQuestion;
            long long iAnswer = 1;


            for(int iIterator1 = 0; iIterator1 > -1; iIterator1 ++)
            {
                if(iAnswer < iQuestion)
                    iAnswer *= 2;
                else
                {
                    std::cout << iAnswer / 2 - 1 << " " << iIterator1 - 1 << std::endl;
                    break;
                }
            }
        }
    }
    else
    {
        std::vector <int> vQuestions(iAmQuestions);
        std::vector <int> vSortedQuestions(iAmQuestions);
        vSortedQuestions[0] = 0;

        for(int iIterator = 0; iIterator < iAmQuestions; iIterator ++)
                std::cin >> vQuestions[iIterator];

        std::copy(&vQuestions[0], &vQuestions[iAmQuestions], &vSortedQuestions[1]);
        std::sort(&vSortedQuestions[1], &vSortedQuestions[iAmQuestions]);


        std::vector <int> vAmsCoins(iAmQuestions);
        std::vector <int> vSumms(iAmQuestions);
        for(int iIterator = 0; iIterator < iAmQuestions; iIterator ++)
            vAmsCoins[iIterator] = 0;


        int iMaxCoinsNow = 0;
        int iMaxIdentity = 0;

        for(int iIterator = 1; iIterator <= iAmQuestions; iIterator ++)
        {

            for(int iIterator1 = vSortedQuestions[iIterator - 1]; iIterator1 < vSortedQuestions[iIterator]; iIterator1 ++)
            {
                if(iMaxCoinsNow < fHungryCashpoint(iIterator1 + 1, vMoneyTypes))
                {
                    iMaxCoinsNow = fHungryCashpoint(iIterator1 + 1, vMoneyTypes);
                    iMaxIdentity = iIterator1;
                }
            }




            for(int iIterator1 = 0; iIterator1 < iAmQuestions; iIterator1 ++)
            {
                if(vSortedQuestions[iIterator] == vQuestions[iIterator1] && vAmsCoins[iIterator1] == 0)
                {
                    vAmsCoins[iIterator1] = iMaxCoinsNow;
                    vSumms[iIterator1] = iMaxIdentity + 1;
                }
            }
        }

        for(int iIterator = 0; iIterator < iAmQuestions; iIterator ++)
            std::cout << vSumms[iIterator] << " " << vAmsCoins[iIterator] << std::endl;








    }





    return 0;
}
