#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

signed main() {
    int n; cin >> n;
    vector<int> a(n);
    for (int i = 1; i < n; i++) cin >> a[i];
    bool ok = true;
    if (n != 60){
        ok = false;
    }
    if (a[0] != 1){
        ok = false;
    }
    if (ok) {
        for (int i = 1; i < 60; i++) {
            if (a[i] != a[i - 1] * 2) {
                ok = false;
                break;
            }
        }
    }
    if (ok){
        vector<int> lst = a;
        for (int i = 0; i < n; i++) lst[i]--;
        lst.push_back(1e18 * 2);
        int q; cin >> q;
        for (int i = 0; i < q; i++){
            int b; cin >> b;
            auto it = lower_bound(lst.begin(), lst.end(), b);
            it--;
            cout << *it << " " << max((long long)(it - lst.begin()), (long long)1) << endl;
        }
        return 0;
    }
    a.push_back(1e10);
    vector<int> dp(200001, 0);
    vector<int> pref(200001, 0);
    for (int i = 1; i <= 200000; i++){
        auto it = upper_bound(a.begin(), a.end(), i);
        --it;
        int v = *it;
        dp[i] = dp[i - v] + 1;
        if (dp[pref[i - 1]] < dp[i]){
            pref[i] = i;
        } else {
            pref[i] = pref[i - 1];
        }
    }
    int q; cin >> q;
    for (int i = 0; i < q; i++){
        int b; cin >> b;
        cout << pref[b] << " " << dp[pref[b]] << endl;
    }
    return 0;
}
