//#pragma GCC optimize("Ofast, no-stack-protector")
//#pragma GCC target("sse, sse2, sse3, ssse3, sse4, popcnt, abm, mmx, avx, tune=native")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize("fast-math")

#include <iostream>

using namespace std;

#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(s) (int)s.size()
#define int long long
typedef long long ll;

const int maxn = 2e5 + 228;

int arr[maxn];

int dp[maxn][4];

int n;

int get() {
    int sum = 0;
    int res = 0;
    for (int step = 0; step < 4; step++) {
        for (int i = 0; i < step; i++)
            dp[step][i] = sum;
        for (int i = step+1; i < n; i++) {
            dp[i][0] = max({dp[i - 1][0], dp[i - 1][1], dp[i - 1][2], dp[i - 1][3]});
            dp[i][1] = dp[i - 1][0] + arr[i];
            dp[i][2] = dp[i - 1][1] + arr[i];
            dp[i][3] = dp[i - 1][2] + arr[i];
        }
        sum += arr[step];
        for (int j = 0; j <= 3 - step; j++)
            res = max(res, dp[n-1][j]);
    }
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> arr[i];
    int q;
    cin >> q;
    int lst = get();
    cout << lst << endl;
    while (q--) {
        int x, y;
        cin >> x >> y;
        x--;
        arr[x] = y;
        lst = get();
        cout << lst << endl;
    }
    return 0;
}