//#pragma GCC optimize("Ofast, no-stack-protector")
//#pragma GCC target("sse, sse2, sse3, ssse3, sse4, popcnt, abm, mmx, avx, tune=native")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize("fast-math")

#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define len(s) (int)s.size()
#define int long long
typedef long long ll;

const int maxn = 2e5 + 228;

int arr[maxn];

int dp[maxn][4];

int n;

int sqrtdp[5000][4][4];

int numsqrt;

void upd(int l, int r, int ind) {
    int sum = 0;
    for (int i = 0; i < 4; i++) {
        for (int j = 0; j < 4; j++) {
            sqrtdp[ind][i][j] = 0;
        }
    }
    for (int step = l; step <= min(r, l + 3); step++) {
        for (int i = 0; i < 4; i++)
            dp[step][i] = -1e18;
        if (step == l) {
            dp[step][0] = 0;
            for (int i = step + 1; i <= r; i++) {
                dp[i][0] = max({dp[i - 1][0], dp[i - 1][1], dp[i - 1][2], dp[i - 1][3]});
                dp[i][1] = dp[i - 1][0] + arr[i];
                dp[i][2] = dp[i - 1][1] + arr[i];
                dp[i][3] = dp[i - 1][2] + arr[i];
            }
            for (int j = 0; j <= 3; j++) {
                sqrtdp[ind][step - l][j] = dp[r][j];
            }
        }
        for (int i = 0; i < 4; i++)
            dp[step][i] = -1e18;

        sum += arr[step];
        dp[step][step - l + 1] = sum;
        for (int i = step + 1; i <= r; i++) {
            dp[i][0] = max({dp[i - 1][0], dp[i - 1][1], dp[i - 1][2], dp[i - 1][3]});
            dp[i][1] = dp[i - 1][0] + arr[i];
            dp[i][2] = dp[i - 1][1] + arr[i];
            dp[i][3] = dp[i - 1][2] + arr[i];
        }
        for (int j = 0; j <= 3; j++) {
            sqrtdp[ind][step - l + 1][j] = dp[r][j];
        }
    }
}



















int dddp[maxn][4];

int get() {
    int res = 0;
    for (int i = 0; i < numsqrt; i++) {
        for (int j = 0; j < 4; j++) {
                dddp[i][j] = 0;
        }
    }
    for (int step = 0; step < 4; step++) {
        for (int j = 0; j < 4; j++) {
            dddp[0][j] = sqrtdp[0][step][j];
        }
        for (int i = 1; i < numsqrt; i++) {
            for (int last = 0; last < 4; last++) {
                for (int nowfirst = 0; nowfirst < 4; nowfirst++) {
                    for (int nnd = 0; nnd < 4; nnd++) {
                        if (last + nowfirst < 4) {
                            dddp[i][nnd] = max(dddp[i-1][last] + sqrtdp[i][nowfirst][nnd], dddp[i][nnd]);
                        }
                    }
                }
            }
        }
        for (int i = 0; i < 4; i++) {
            if (i + step < 4) {
                res = max(res, dddp[numsqrt-1][i]);
            }
        }
    }
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> arr[i];
    vector <pair<int, int> > v;
    int k = n;
    for (int i = 0; i < n; i += k) {
        v.pb({i, min(n - 1, i + k - 1)});
    }
    numsqrt = len(v);
    for (int i = 0; i < numsqrt; i++) {
        upd(v[i].first, v[i].second, i);
    }
    /*cout << sqrtdp[0][0][1] << endl;
    cout << sqrtdp[1][0][1] << endl;
    cout << sqrtdp[2][2][2] << endl;
    cout << "_------------" << endl;*/
    cout << get() << endl;
    int q;
    cin >> q;
    int lst = get();
    while (q--) {
        int x, y;
        cin >> x >> y;
        x--;
        arr[x] = y;
        for (int i = 0; i < numsqrt; i++) {
            if (x >= v[i].first) {
                upd(v[i].first, v[i].second, i);
                break;
            }
        }
        lst = get();
        cout << lst << endl;
    }
    return 0;
}