#include <iostream>
#include <vector>
#include <fstream>
#include <assert.h>
#include <set>
#include <map>
#include <algorithm>
#define int long long
#define ll long long
#define pi pair<int, int>
#define pll pair<ll, ll>
#define F first
#define S second

using namespace std;

const int MAXN = 2007;
int n;
int a[MAXN];

void solvePow2() {
	int q;
	cin >> q;
	for (int j = 0; j < q; ++j) {
		ll b;
		cin >> b;
		int i = 0;
		while ((1ll << i) - 1 <= b) {
			++i;
		}
		--i;
		cout << (1ll << i) - 1 << ' ' << i << '\n';
	}
}

int dp[MAXN];
pi fwq[MAXN];
void add(pi a, int x) {
	for (int i = x; i < MAXN; i |= i + 1ll) {
		fwq[i] = max(fwq[i], a);
	}
}

pi get(int x) {
	pi ans = { 0, 0 };
	for (int i = x; i >= 0; i = (i & (i + 1ll)) - 1ll) {
		ans = max(fwq[i], ans);
	}
	return ans;
}

signed main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n;
	bool is_pow = true;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		if (n == 60) {
			if (a[i] != (1ll << i)) {
				is_pow = false;
			}
		}
		dp[a[i]] = 1;
	}
	if (n == 60 && is_pow) {
		solvePow2();
		return 0;	
	}
	int le = 0;
	for (int i = 1; i < MAXN; ++i) {
		while ((le < n - 1) && (a[le + 1] <= i)) {
			++le;
		}
		dp[i] = dp[i - a[le]] + 1;
	}
	int q;
	cin >> q;
	for (int i = 1; i < MAXN; ++i) {
		add({dp[i], i}, i);
	}
	for (int i = 0; i < q; ++i) {
		int b;
		cin >> b;
		auto a = get(b);
		cout << a.second << ' ' << a.first << '\n';
	}
	return 0;
} 