#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <set>
#include <map>
#include <vector>

using namespace std;

#define int long long

signed main() {
    int n;
    cin >> n;
    double h = 0.0;
    vector<double> len(n), sp(n);
    for(int i = 0;i<n;++i)
    {
        cin >> sp[i];
    }
    for(int i = 0;i<n;++i)
    {
        cin >> len[i];
        h += (len[i] + 0.0) / (sp[i] + 0.0);
    }
    int m;
    cin >> m;
    vector<double> a(m - 1);
    for(int i = 0;i<m - 1;++i)
    {
        cin >> a[i];
    }
    vector<int> sh(m);
    for(int i = 0;i<m;++i)
    {
        cin >> sh[i];
    }
    int q;
    cin >> q;
    for(int i = 0;i<q;++i)
    {
        int l, r;
        cin >> l >> r;
        if(r - l >= h)
        {
            cout << 0 << endl;
            continue;
        }
        double lll = -1.0, rrr = 1000000000.0;
        while(lll + 0.00001 < rrr)
        {
            double mid = (lll + rrr) / 2;
            //cout << mid <<endl;
            double help = 0;
            for(int j = 0;j<n;++j)
            {
                help += len[j] / (sp[j] + mid);
            }
            if(help <= r - l)
            {
                rrr = mid;
            }
            else
            {
                lll = mid;
            }
        }
        int left = -1, rig = m - 1;
        while(left + 1 < rig)
        {
            int midle = (left + rig) / 2;
            if(a[midle] >= rrr)
            {
                rig = midle;
            }
            else
            {
                left = midle;
            }
        }
        cout << sh[rig] << endl;
    }
}