#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <set>
#include <map>
#include <vector>

using namespace std;

#define int long long

signed main() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for(int i = 0;i<n;++i)
    {
        cin >> a[i];
        b[i] = a[i];
    }
    sort(b.begin(), b.end());
    map<int, int> hhelp;
    for(int i =0;i<n;++i)
    {
        hhelp[b[i]] = i;
    }
    for(int i =0;i<n;++i)
    {
        a[i] = hhelp[a[i]];
    }
    vector<int> all(n + 1, 0);
    for(int i = 1;i<=n;++i)
    {
        int ans = 0;
        int cnt = 0;
        for(int j =0;j<i;++j)
        {
            if(all[a[j]] == 0)
            {
                cnt++;
            }
            all[a[j]] += 1;
        }
        ans += cnt;
        for(int j = 1;j < n - i + 1;++j)
        {
            if(all[a[j - 1]] == 1)
            {
                cnt--;
            }
            all[a[j - 1]] -= 1;
            if(all[a[j + i - 1]] == 0)
            {
                cnt++;
            }
            all[a[j + i - 1]]++;
            ans += cnt;
        }
        for(int j = 0;j<n + 1;++j)
        {
            all[j] = 0;
        }
        cout << ans << " ";
    }
}