#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <set>
#include <map>
#include <vector>

using namespace std;

#define int long long

int n;

int find(vector<int> &a) {
    vector<vector<vector<int> > > b(n + 1, vector<vector<int> >(8, vector<int>(8, -1000)));
    for (int mask1 = 0; mask1 < 8; ++mask1) {
        int mask = mask1;
        int y = 0;
        b[3][mask1][mask1] = 0;
        while(mask > 0){
            if (mask % 2 == 1) {
                b[3][mask1][mask1] += a[y];
            }
            y++;
            mask /= 2;
        }
    }
    for (int j = 3; j < n; ++j) {
        for (int maskk = 0; maskk < 8; ++maskk) {
            for (int maskstart = 0; maskstart < 8; ++maskstart) {
                if(b[j][maskk][maskstart] == -1000)
                {
                    continue;
                }
                if ((j == 3 && maskk != maskstart) || (j == 4 && (maskk / 2) != (maskstart % 4)) ||
                    (j == 5 && maskk / 4 != maskstart % 2)) {
                    continue;
                }
                if (maskk != 7) {
                    b[j + 1][(maskk % 4) * 2 + 1][maskstart] = max(b[j + 1][(maskk % 4) * 2 + 1][maskstart],
                                                                   b[j][maskk][maskstart] + a[j]);
                }
                b[j + 1][(maskk % 4) * 2][maskstart] = max(b[j + 1][(maskk % 4) * 2][maskstart],
                                                               b[j][maskk][maskstart]);
            }
        }
    }
    int mx = 0;
    for (int maskk = 0; maskk < 8; ++maskk) {
        for (int maskstart = 0; maskstart < 8; ++maskstart) {
            if ((n == 3 && maskk != maskstart) || (n == 4 && (maskk / 2) != (maskstart % 4)) ||
                (n == 5 && maskk / 4 != maskstart % 2)) {
                continue;
            }
            int help = 0;
            int mas = maskk;
            while (mas > 0) {
                if (mas % 2 == 0) {
                    break;
                }
                mas /= 2;
                help++;
            }
            if(maskstart / 4 == 1)
            {
                help += 1;
                if((maskstart % 4) / 2 == 1)
                {
                    help += 1;
                    if(maskstart % 2 == 1)
                    {
                        help += 1;
                    }
                }
            }
            if (help >= 4) {
                continue;
            } else {
                mx = max(mx, b[n][maskk][maskstart]);
            }
        }
    }
    return mx;
}

signed main() {
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cout << find(a) << endl;
        int x, y;
        cin >> x >> y;
        --x;
        a[x] = y;
    }
    cout << find(a) << endl;
}