#include <bits/stdc++.h>


using namespace std;


#define int long long
const int INF = 1e18;


void warp()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


int max(vector<int> a)
{
    int ans = a[0];
    for (int i = 0; i < a.size(); i++) ans = max(ans, a[i]);
    return ans;
}


int solve(vector<int> a)
{
    int n = a.size();
    if (n < 3)
    {
        int ans = 0;
        for (int i = 0; i < n; i++) ans += a[i];
        return ans;
    }
    for (int i = 0; i < 4; i++) a.push_back(a[i]);
    int ans = 0;
    for (int start = 0; start < 4; start++)
    {
        vector<vector<int> > dp(n + 4, vector<int> (4));
        for (int i = start + 1; i < start + n; i++)
        {
            dp[i][0] = max(dp[i - 1]);
            for (int j = 1; j < 4; j++) dp[i][j] = dp[i - 1][j - 1] + a[i];
        }
        ans = max(ans, max(dp[start + n - 1]));
    }
    return ans;
}


int block = 300;


vector<vector<int> > calc(vector<int> a)
{
    vector<vector<int> > ans(4, vector<int> (4));
    int n = a.size();
    for (int i = 0; i < 4; i++)
    {
        vector<vector<int> > dp(n, vector<int> (4));
        if (i != 3) dp[0][i + 1] = a[0];
        dp[0][0] = 0;
        for (int j = 1; j < n; j++)
        {
            dp[j][0] = max(dp[j - 1]);
            for (int k = 1; k < 4; k++) dp[j][k] = dp[j - 1][k - 1] + a[j];
        }
        ans[i] = dp.back();
    }
    return ans;
}


int findAns(vector<vector<vector<int> > > &val)
{
    int ans = 0;
    int h = val.size();
    for (int start = 0; start < 4; start++)
    {
        /*
        vector<vector<int> > dp(h, vector<int> (4));
        dp[0] = val[0][start];
        for (int i = 1; i < h; i++)
        {
            for (int j = 0; j < 4; j++)
            {
                for (int k = 0; k < 4; k++) dp[i][j] = max(dp[i][j], dp[i - 1][k] + val[i][k][j]);
            }
        }
        ans = max(ans, dp.back()[start]);
        */
        vector<int> dp = val[0][start];
        for (int i = 1; i < h; i++)
        {
            vector<int> next(4);
            for (int j = 0; j < 4; j++)
            {
                for (int k = 0; k < 4; k++)
                {
                    next[j] = max(next[j], dp[k] + val[i][k][j]);
                }
            }
            dp = next;
        }
        ans = max(ans, dp[start]);
    }
    return ans;
}


signed main()
{
    warp();
    int n;
    cin >> n;
    //while (block * block < n) block++;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    /*
    cout << solve(a) << "\n";
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        int p, x;
        cin >> p >> x;
        p--;
        a[p] = x;
        cout << solve(a) << "\n";
    }
    */
    vector<vector<int> > b(1);
    for (int i = 0; i < n; i++)
    {
        if (b.back().size() == block) b.push_back(vector<int> ());
        b.back().push_back(a[i]);
    }
    int h = b.size();
    vector<vector<vector<int> > > dp(h, vector<vector<int> > (4, vector<int> (4)));
    for (int i = 0; i < h; i++) dp[i] = calc(b[i]);
    cout << findAns(dp) << "\n";
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        int p, x;
        cin >> p >> x;
        p--;
        b[p / block][p % block] = x;
        dp[p / block] = calc(b[p / block]);
        cout << findAns(dp) << "\n";
    }
    return 0;
}
