#include <bits/stdc++.h>

using namespace std;
#define int long long
vector <int> tree, p;
void push(int v, int len) {
    tree[2 * v] += p[v] * len;
    tree[2 * v + 1] += p[v] * len;
    p[2 * v] += p[v];
    p[2 * v + 1] += p[v];
    p[v] = 0;
}
void update(int v, int l, int r, int a, int b) {
    if (l > b || a > r) {
        return;
    }
    if (a <= l && r <= b) {
        tree[v] += r - l + 1;
        ++p[v];
        return;
    }
    push(v, (r - l + 1) / 2);
    int m = (l + r) / 2;
    update(2 * v, l, m, a, b);
    update(2 * v + 1, m + 1, r, a, b);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

int get(int v, int l, int r, int i) {
    if (l > i || i > r) {
        return 0;
    }
    if (l == r) {
        return tree[v];
    }
    push(v, (r - l + 1) / 2);
    int m = (l + r) / 2;
    return get(2 * v, l, m, i) + get(2 * v + 1, m + 1, r, i);
}
signed main() {
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector <int> b = a;
    sort(b.begin(), b.end());
    b.resize(unique(b.begin(), b.end()) - b.begin());
    unordered_map <int, int> tmp;
    for (int i = 0; i < b.size(); ++i) {
        tmp[b[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        a[i] = tmp[a[i]];
    }
    int len = 1 << (int)ceil(log2(n + 1));
    tree.resize(2 * len);
    p.resize(2 * len);
    vector <int> now(b.size(), -1);
    for (int i = 0; i < n; ++i) {
        if (now[a[i]] == -1) {
            update(1, 0, len - 1, 1, i + 1);
            now[a[i]] = i;
        }
        else {
            update(1, 0, len - 1, 1, i - now[a[i]]);
            now[a[i]] = i;
        }
    }
    vector <int> pref(n + 1);
    pref[0] = 0;
    vector <int> now1(n + 1);
    for (int i = 1; i <= n; ++i) {
        ++now1[a[n - i]];
        pref[i] = pref[i - 1];
        if (now1[a[n - i]] == 1) {
            ++pref[i];
        }
    }
    vector <pair <int, int>> ans(n + 1);
    ans[1].first = n;
    ans[1].second = 1;
    cout << ans[1].first << " ";
    for (int le = 2; le <= n; ++le) {
        ans[le].first = ans[le - 1].first + get(1, 0, len - 1, le) - pref[le - 1];
        cout << ans[le].first << " ";
    }
    return 0;
}