#include <bits/stdc++.h>

#define int long long
#define endl "\n"
#define pii pair<int, int>
#define F first 
#define S second
#define B begin
#define E end

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int INF = 1e9;
const double EPS = 1e-9;
const ll P = 1e9 + 7;
const ll Q = 47;

void hello()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
}

void show(vector <int>& arr)
{
	for (auto i : arr)
		cout << i << " ";
	cout << endl;
}

void show(vector <vector <int>>& arr)
{
	for (auto i : arr)
		show(i);
	cout << endl;
}

signed main()
{
	hello();

	int n;
	cin >> n;
	vector <int> seq(n);
	for (int i = 0; i < n; ++i)
		cin >> seq[i];
	vector <int> order = seq;
	sort(order.B(), order.E());
	order.resize(unique(order.B(), order.E()) - order.B());
	for (int i = 0; i < n; ++i)
		seq[i] = lower_bound(order.B(), order.E(), seq[i]) - order.B();

	vector <int> res(n);
	for (int i = 0; i < n; ++i)
	{
		vector <int> used(n);
		int cnt = 0;
		for (int j = 0; j <= i; ++j)
		{
			++used[seq[j]];
			if (used[seq[j]] == 1)
				++cnt;
		}
		res[i] += cnt;
		for (int j = i + 1; j < n; ++j)
		{
			--used[seq[j - i - 1]];
			if (!used[seq[j - i - 1]])
				--cnt;
			++used[seq[j]];
			if (used[seq[j]] == 1)
				++cnt;
			res[i] += cnt;
		}
	}

	show(res);
}