#include <bits/stdc++.h>
#ifdef DEBUG
#define __GLIBCXX_DEBUG
#endif // DEBUG

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 4e4 + 5;

int n;
int a[maxn];
ll dp[4][4][maxn];

void source() {
    for (int i = 0; i < 4; i++)
        for (int j = 0; j < 4; j++)
            fill(dp[i][j], dp[i][j] + n, 0);
    dp[0][0][2] = a[1];
    dp[0][1][2]  = a[2];
    dp[0][2][2]  = a[1] + a[2];
    dp[1][0][2]  = a[0];
    dp[1][1][2]  = a[0] + a[2];
    dp[2][0][2]  = a[0] + a[1];
    dp[3][3][2]  = a[0] + a[1] + a[2];
    for (int i = 3; i < n; i++) {
        for (int j = 0; j <= 3; j++) {
            for (int k = 0; k <= 2; k++) {
                dp[j][k + 1][i] = max(dp[j][k + 1][i], dp[j][k][i - 1] + a[i]);
            }
            for (int k = 0; k <= 3; k++) {
                dp[j][0][i] = max(dp[j][0][i], dp[j][k][i - 1]);
            }
        }
    }
    ll res = 0;
    for (int i = 0; i <= 3; i++) {
        for (int j = 0; j <= 3; j++) {
            if (i + j <= 3)
                res = max(res, dp[i][j][n - 1]);
        }
    }
    cout << res << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // DEBUG
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    source();
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int t1, t2;
        cin >> t1 >> t2;
        a[t1 - 1] = t2;
        source();
    }
    return 0;
}
