#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 4e4 + 5;
const int blsz = 100;

ll a[maxn];
ll dp[maxn][4][4];

struct taker {
    int len;
    ll res[4][4];
    taker() {
        for (int i = 0; i <= 3; i++)
            for (int j = 0; j <= 3; j++)
                res[i][j] = 0;
    }
    void dobuild(int l, int r) { /// []
        if (l == r) {
            res[1][1] = a[l];
            return;
        }
        if (r == l + 1) {
            res[1][0] = a[l];
            res[0][1] = a[r];
            res[2][2] = a[l] + a[r];
            return;
        }
        for (int i = l; i <= r; i++)
            for (int j = 0; j < 4; j++)
                for (int k = 0; k < 4; k++)
                    dp[i][j][k] = 0;
        dp[l + 2][0][0] = a[l + 1];
        dp[l + 2][0][1] = a[l + 2];
        dp[l + 2][0][2] = a[l + 1] + a[l + 2];
        dp[l + 2][1][0] = a[l + 0];
        dp[l + 2][1][1] = a[l + 0] + a[l + 2];
        dp[l + 2][2][0] = a[l + 0] + a[l + 1];
        dp[l + 2][3][3] = a[l + 0] + a[l + 1] + a[l + 2];
        for (int i = l + 3; i <= r; i++) {
            for (int j = 0; j <= 3; j++) {
                for (int k = 0; k <= 2; k++) {
                    dp[i][j][k + 1] = max(dp[i][j][k + 1], dp[i - 1][j][k] + a[i]);
                }
                for (int k = 0; k <= 3; k++) {
                    dp[i][j][0] = max(dp[i][j][0], dp[i - 1][j][k]);
                }
            }
        }
        for (int i = 0; i <= 3; i++) {
            for (int j = 0; j <= 3; j++) {
                res[i][j] = dp[r][i][j];
            }
        }
    }
};

pair <int, int> zaps[maxn];
bool isnow[maxn];
vector <taker> cvec;
int cvpos[maxn];
int ctim = 0;

void docvec() {
    for (int t = 0; t < cvec.size(); t++) {
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                dp[t][i][j] = 0;

            }
        }
    }
    for (int i = 0; i < 4; i++) {
        for (int j = 0; j < 4; j++) {
            dp[0][i][j] = cvec[0].res[i][j];
        }
    }
    int slen = cvec[0].len;
    for (int i = 1; i < cvec.size(); i++) {
        for (int st = 0; st < 4; st++) {
            for (int fin = 0; fin < 4; fin++) {
                if (!cvec[i].res[st][fin] && (st || fin))
                    continue;
                if (st < cvec[i].len && fin < cvec[i].len) {
                    for (int fp = 0; st + fp < 4; fp++) {
                        for (int sp = 0; sp < 4; sp++) {
                            if (sp != slen)
                                dp[i][sp][fin] = max(dp[i][sp][fin], dp[i - 1][sp][fp] + cvec[i].res[st][fin]);
                            else if (slen + st <= 3)
                                dp[i][slen + st][fin] = max(dp[i][slen + st][fin], dp[i - 1][sp][fp] + cvec[i].res[st][fin]);
                        }
                    }
                }
                else {
                    for (int fp = 0; fp + st < 4; fp++) {
                        for (int sp = 0; sp < 4; sp++) {
                            if (sp != slen)
                                dp[i][sp][fp + st] = max(dp[i][sp][fp + st], dp[i - 1][sp][fp] + cvec[i].res[st][fin]);
                            else if (slen + st <= 3)
                                dp[i][slen + st][fp + st] = max(dp[i][slen + st][fp + st],
                                                                 dp[i - 1][sp][fp] + cvec[i].res[st][fin]);
                        }
                    }
                }
            }
        }
        slen += cvec[i].len;
    }
    ll cres = 0;
    for (int i = 0; i < 4; i++) {
        for (int j = 0; i + j < 4; j++) {
            cres = max(cres, dp[cvec.size() - 1][i][j]);
        }
    }
    /*ctim++;
    if (ctim % 1000 == 0)
        cerr << ctim << "\n";*/
    cout << cres << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // DEBUG
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        cin >> zaps[i].first >> zaps[i].second;
        zaps[i].first--;
    }
    for (int blnum = 0; blnum < max(1, (q + blsz - 1) / blsz); blnum++) {
        int L = blnum * blsz, R = min(L + blsz, q); /// [)
        fill(isnow, isnow + n, false);
        for (int i = L; i < R; i++) {
            isnow[zaps[i].first] = true;
        }
        cvec.clear();
        cvec.reserve(2 * blsz);
        int st = 0;
        for (int i = 0; i < n; i++) {
            if (isnow[i]) {
                if (st <= i - 1) {
                    cvec.push_back(taker());
                    cvec.back().len = i - st;
                    cvec.back().dobuild(st, i - 1);
                }
                cvpos[i] = cvec.size();
                cvec.push_back(taker());
                cvec.back().len = 1;
                cvec.back().res[1][1] = a[i];
                st = i + 1;
            }
        }
        if (st < n) {
            cvec.push_back(taker());
            cvec.back().len = n - st;
            cvec.back().dobuild(st, n - 1);
        }
        if (blnum == 0) {
            docvec();
        }
        for (int i = L; i < R; i++) {
            a[zaps[i].first] = zaps[i].second;
            cvec[cvpos[zaps[i].first]].res[1][1] = zaps[i].second;
            docvec();
        }
    }
    return 0;
}
