#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
struct et {
	int sum = 0;;
	int cur = 0;
	char tp;
	int woq = 0;

	et(int sum, int cur, char tp,int woq) {
		this->sum = sum;
		this->cur = cur;
		this->tp = tp;
		this->woq = woq;
	}
	et() {}
};
bool operator<(et& a, et& b) {
	if (a.sum == b.sum) {
		if (a.tp == 'm' && b.tp == 'a') {
			return true;
		}
		else if (a.tp == 'a' && b.tp == 'm') {
			return false;
		}
		else {
			return a.cur < b.cur;
		}
	}
	else {
		return a.sum < b.sum;
	}
}
int main() {
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];

	}
	int q;
	cin >> q;
	vector<int> req(q);
	for (int i = 0; i < q; i++) {
		cin >> req[i];
	}

	vector<int> maxtak(n - 1);
	vector <et> forsort;
	for (int i = 0; i < n - 1; i++) {
		maxtak[i] = (a[i + 1] - 1) / a[i];
	}
	vector<int> stepsum(n - 1);
	for (int i = 0; i < n - 1; i++) {
		stepsum[i] = a[i] * maxtak[i];
	}
	for (int i = 1; i < n - 1; i++) {
		stepsum[i] += stepsum[i - 1];
		maxtak[i] += maxtak[i - 1];
		forsort.push_back(et(stepsum[i], i + 1, 'm',maxtak[i]));
	}
	forsort.push_back(et(stepsum[0], 1, 'm',maxtak[0]));
	vector<pair<int,int> > ans(q);
	for (int i = 0; i < q; i++) {
		forsort.push_back(et(req[i], i, 'a',0));
	}
	sort(forsort.begin(), forsort.end());
	int cur = 0;
	int woq = 0;
	int woqnum = 0;
	for (auto h : forsort) {
		if (h.tp == 'm') {
			woq = h.sum;
			cur = h.cur;
			woqnum = h.woq;
		}
		if (h.tp == 'a') {
			//int basenum = cur;
			int diff = h.sum - woq;
			int diffnum = (diff / a[cur]);
			ans[h.cur]=(make_pair(woqnum + diffnum, woq + diffnum * a[cur]));
		}
	}
	for (auto h : ans) {
		cout << h.second << ' ' << h.first << endl;
	}
}