#include <bits/stdc++.h>

using namespace std;

struct segment {
    int l, r;
};

struct query {
    int id1, id2, type;
};

inline bool good(const vector<segment> &s) {
    for (int i = 0; i < s.size(); i++) {
        if (s[i].r - s[i].l > 1) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, s;
    cin >> n >> m >> s;
    vector<vector<query>> q(m, vector<query>(n - 1));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            cin >> q[i][j].id1 >> q[i][j].id2 >> q[i][j].type;
            q[i][j].id1--;
            q[i][j].id2--;
        }
    }
    vector<vector<int>> matrix(m, vector<int>(n));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            cin >> matrix[i][j];
        }
    }
    int l = 0, r = m + 1;
    while (r - l > 1) {
        vector<int> z(n);
        for (int i = 0; i < n; i++) {
            z[i] = (r + l) / 2;
        }
        int cnt = 0;
        for (int i = 0; i < m; i++) {
            vector<bool> val(2 * n - 1);
            for (int j = 0; j < n; j++) {
                val[j] = matrix[i][j] < z[j];
            }
            for (int k = 0; k < n - 1; k++) {
                if (q[i][k].type == 1) {
                    val[k + n] = val[q[i][k].id1] && val[q[i][k].id2];
                } else {
                    val[k + n] = val[q[i][k].id1] || val[q[i][k].id2];
                }
            }
            cnt += val.back();
        }
        if (cnt <= s) {
            l = (r + l) / 2;
        } else {
            r = (r + l) / 2;
        }
    }
    vector<int> z(n, l);
    l = 0, r = n;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        for (int i = 0; i <= mid; i++) {
            z[i]++;
        }
        int cnt = 0;
        for (int i = 0; i < m; i++) {
            vector<bool> val(2 * n - 1);
            for (int j = 0; j < n; j++) {
                val[j] = matrix[i][j] < z[j];
            }
            for (int k = 0; k < n - 1; k++) {
                if (q[i][k].type == 1) {
                    val[k + n] = val[q[i][k].id1] && val[q[i][k].id2];
                } else {
                    val[k + n] = val[q[i][k].id1] || val[q[i][k].id2];
                }
            }
            cnt += val.back();
        }
        if (cnt <= s) {
            l = (r + l) / 2;
        } else {
            r = (r + l) / 2;
        }
        for (int i = 0; i <= mid; i++) {
            z[i]--;
        }
    }
    for (int i = 0; i <= l; i++) {
        z[i]++;
    }
    for (int i = 0; i < n; i++) {
        cout << z[i] << ' ';
    }
    return 0;
}
/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1
 */