#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

int n;
vector<long long> a;

const int MAXN = 2e5;

gp_hash_table<long long, pair<long long, long long>> mem[MAXN];

pair<long long, long long> getans(long long r, int id) {
    if (id == 0) {
        return {r, r};
    }
    if (mem[id].find(r) != mem[id].end()) {
        return mem[id][r];
    }
    auto ans1 = getans(r % a[id], max(int(upper_bound(a.begin(), a.end(), r % a[id]) - a.begin() - 1), 0)),
    ans2 = getans(a[id] - 1, max(int(upper_bound(a.begin(), a.end(), a[id] - 1) - a.begin() - 1), 0));
    ans1.second += r / a[id], ans2.second += r / a[id] - 1;
    if (ans1.second > ans2.second) {
        return mem[id][r] = {ans1.first + r - r % a[id], ans1.second};
    } else {
        return mem[id][r] = {ans2.first + r - r % a[id] - a[id], ans2.second};
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    while (q--) {
        long long b;
        cin >> b;
        auto ans = getans(b, max(int(upper_bound(a.begin(), a.end(), b) - a.begin() - 1), 0));
        cout << ans.first << ' ' << ans.second << '\n';
    }
    return 0;
}