#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

int n;
vector<long long> a;

const int MAXN = 2e5;

gp_hash_table<long long, pair<long long, long long>> mem[MAXN];

void getans(long long r, int id) {
    if (id == 0) {
        mem[id][r] = {r, r};
        return;
    }
    if (mem[id].find(r) != mem[id].end()) {
        return;
    }
    long long r1 = r % a[id];
    int id1 = max(int(upper_bound(a.begin(), a.end(), r1) - a.begin() - 1), 0);
    long long r2 = a[id] - 1;
    int id2 = id - 1;
    getans(r1, id1),
    getans(r2 ,id2);
    long long ans1 = mem[id1][r1].second + r / a[id], ans2 = mem[id2][r2].second + r / a[id] - 1;
    if (ans1 > ans2) {
        mem[id][r] = {mem[id1][r1].first + r - r % a[id], ans1};
    } else {
        mem[id][r] = {mem[id2][r2].first + r - r % a[id] - a[id], ans2};
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    while (q--) {
        long long b;
        cin >> b;
        int id = max(int(upper_bound(a.begin(), a.end(), b) - a.begin() - 1), 0);
        if (id == 0) {
            cout << b << ' ' << b << '\n';
        } else {
            getans(b, id);
            cout << mem[id][b].first << ' ' << mem[id][b].second << '\n';
        }
    }
    return 0;
}