#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <map>
#include <set>

using namespace std;

#define int long long
#define endl '\n'

signed main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin >> n;
	vector<double> v(n);
	vector<double> l(n);

	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}

	for (int i = 0; i < n; i++) {
		cin >> l[i];
	}

	int m;
	cin >> m;
	vector<double> a(m - 1);
	for (int i = 0; i < m - 1; i++) {
		cin >> a[i];
	}
	vector<int> f(m + 1);
	f[0] = 0;
	for (int i = 0; i < m; i++) {
		cin >> f[i + 1];
	}

	vector<double> ban(m);

	double now = 0;

	for (int i = 0; i < n; i++) {
		now += (l[i] / v[i]);
	}

	ban[0] = now;

	for (int i = 0; i < m - 1; i++) {
		now = 0;
		for (int j = 0; j < n; j++) {
			now += (l[j] / (v[j] + a[i]));
		}
		ban[i + 1] = now;
	}

	int q;
	cin >> q;

	for (int i = 0; i < q; i++) {
		double s, t;
		cin >> s >> t;
		t -= s;
		bool flag = false;

		if (ban[0] <= t) {
			cout << 0 << endl;
			continue;
		}

		if (ban[m - 1] > t) {
			cout << f.back() << endl;
			continue;
		}

		int l1 = 0;
		int r = m - 1;

		while (r - l1 > 1) {
			int m = (l1 + r) / 2;
			if (ban[m] <= t) {
				r = m;
			} else {
				l1 = m;
			}
		}

		cout << f[r] << endl;
	}
}
