#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <map>
#include <set>

#pragma GCC_OPTIMIZE("ofast")

using namespace std;

#define int long long
#define endl '\n'

int n;
vector<int> arr;

int solve() {
	int ans = -1;
	for (int ii = 0; ii < (1 << n); ii++) {
		vector<bool> used(n);
		for (int j = 0; j < n; j++) {
		    //cout << ii << " " << (1 << j) << endl;
			if (((1 << j) & ii) != 0) {
                //cout << j << " ";
				used[j] = true;
			}
		}
		bool good = true;
		for (int i = 0; i < n; i++) {
			if (used[i] && used[(i + 1) % n] && used[(i + 2) % n] && used[(i + 3) % n]) {
				good = false;
				break;
			}
		}

		if (!good) {
			continue;
		}

		int now = 0;
		for (int i = 0; i < n; i++) {
			if (used[i]) {
				now += arr[i];
			}
		}

		ans = max(ans, now);
	}
	return ans;
}

signed main() {
	//ios_base::sync_with_stdio(NULL);
	//cin.tie(NULL);
	//cout.tie(NULL);
	cin >> n;
	arr.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}

	cout << solve() << endl;

	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int p, v;
		cin >> p >> v;
		p--;
		arr[p] = v;
		cout << solve() << endl;
	}
}
