#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <map>

#define ff  first
#define ss  second
#define pb  push_back
#define sz  size()

using namespace std;

typedef long long ll;
typedef pair<int, int> pr;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;

const ld eps = 10e-5;


vector<ll> l;
vector<ll> v;

ld tim(ll a) {
    ld ans = 0;
    for (int i = 0; i < l.sz; ++i) {
        ans += ((ld)l[i]) / (v[i] + a);
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    l.resize(n);
    v.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    int m;
    cin >> m;
    vector<ll> a(m);
    a[0] = 0;
    for (int i = 1; i < m; ++i) {
        cin >> a[i];
    }
    vector<ll> f(m);
    for (int i = 0; i < m; ++i) {
        cin >> f[i];
    }
    int q; cin >> q;
    for (int q1 = 0; q1 < q; ++q1) {
        ll s, t;
        cin >> s >> t;
        ll time = t - s;
        int l = -1, r = m;
        while (r - l > 1) {
            int med = (l + r) / 2;
            ll curA = a[med];
            if (tim(a[med]) <= (ld)time) {
                r = med;
            }
            else {
                l = med;
            }
        }
        if (r == 0)
            cout << 0;
        else
            cout << f[r - 1];
        cout << '\n';
    }

    return 0;
}

