#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <map>

#define ff  first
#define ss  second
#define pb  push_back
#define sz  size()

using namespace std;

typedef long long ll;
typedef pair<int, int> pr;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    vector<int> now(n, 1);
    vector<int> prev(n, 1);
    vector<int> next(n, 1);
    ll sum = n;
    cout << sum << ' ';
    for (int i = 1; i < n; ++i) {
        sum = 0;
        for (int j = 0; j < n - i; ++j) {
            int s = j;
            int f = j + i;
            if (f >= n)
                continue;
            if (now[j] != now[j + 1]) {
                next[j] = max(now[j], now[j + 1]);
            } else {
                if (v[s] != v[f]) {
                    if ((f == s + 1) || (prev[s + 1] < now[s])) {
                        next[j] = now[j] + 1;
                    } else {
                        next[j] = max(now[j], now[j + 1]);
                    }
                } else {
                   next[j] = max(now[j], now[j + 1]);
                }
            }
            sum += next[j];

        }
        prev = now;
        now = next;
        cout << sum << ' ';
    }

    return 0;
}