#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <bitset>
#include <map>

#define ff  first
#define ss  second
#define pb  push_back
#define sz  size()
#define rsz  resize()

using namespace std;

typedef long long ll;
typedef pair<int, int> pr;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vll a(n);
    vll pr(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (!i)
            pr[i] = a[i];
        else
            pr[i] = a[i] + pr[i - 1];
    }
    int res = -1;
    ll maxx = -1;
    for (int i = 1; i < n; ++i) {
        ll cur = pr[i - 1] * (pr.back() - pr[i - 1]);
        if (cur > maxx) {
            maxx = cur;
            res = i;
        }
    }
    cout << res;

    return 0;
}
