#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <bitset>
#include <map>

#define ff  first
#define ss  second
#define pb  push_back
#define sz  size()
#define rsz  resize()

using namespace std;

typedef long long ll;
typedef pair<int, int> pr;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;

const int NN = 30000;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, foo;
    cin >> n >> foo;
    vector<set<int> > del(NN);
    for (int i = 1; i < NN; ++i) {
        for (int j = 1; j < sqrt(i) + 2; ++j) {
            if (!(i % j)) {
                del[i].insert(j);
                del[i].insert(i / j);
            }
        }
    }
    long long ans = 0;
    vector<vector<int> > div(NN);
    for (int i = 0; i < NN; ++i) {
        for (auto it = del[i].begin(); it != del[i].end(); ++it)
            div[i].pb(*it);
    }

    for (int y = 1; y < NN - n; ++y) {
        int x = y + n;
        for (int i = 0; i < div[x].sz; ++i) {
            int a = div[x][i];
            int b = x / a;
            if ((a == foo) || (b == foo)) {
                continue;
            }
            int l = -1, r = div[y].sz;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (div[y][m] < a)
                    l = m;
                else
                    r = m;
            }
            int cnt1 = l + 1;
            if (!cnt1)
                continue;
            int c = div[y][l];
            r = l + 1;
            l = -1;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (y / div[y][m] >= b)
                    l = m;
                else
                    r = m;
            }
            if (r == cnt1)
                continue;
            if (y / div[y][r] >= b)
                continue;
            if (r > 0) {
                if (y / div[y][r - 1] < b)
                    --r;
            }
            ans += max(0, cnt1 - r);
        }
    }
    cout << ans;

    return 0;
}
