#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <bitset>
#include <map>

#define ff  first
#define ss  second
#define pb  push_back
#define sz  size()
#define rsz  resize()

using namespace std;

typedef long long ll;
typedef pair<int, int> pr;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vll a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vll dp(n - 1, 0);
    vll sum(n - 1, 0);
    if (n == 1) {
        int q;
        cin >> q;
        for (int j = 0; j < q; ++j) {
            ll s;
            cin >> s;
            cout << s << ' ' << s << '\n';
        }
        exit(0);
    }
    dp[0] = a[1] - 1;
    sum[0] = a[1] - 1;
    for (int i = 1; i < n - 1; ++i) {
        int cnt = (a[i + 1] - sum[i - 1]) / a[i];
        sum[i] = sum[i - 1] + cnt * a[i];
        dp[i] = dp[i - 1] + cnt;
    }

    int q;
    cin >> q;
    for (int q1 = 0; q1 < q; ++q1) {
        ll b;
        cin >> b;
        if (b == 1) {
            cout << "1 1\n";
            continue;
        }

        int near = upper_bound(sum.begin(), sum.end(), b) - sum.begin() - 1;
        if (near == - 1) {
            cout << b << ' ' << b << '\n';
            continue;
        }
        if (near == n - 1) {
            int cnt = (b - sum[near - 1]) / a[near];
            ll summ = sum[near - 1] + cnt * a[near];
            cnt += dp[near - 1];
            cout << summ << ' ' << cnt << '\n';
            continue;
        }
        int cnt = (b - sum[near]) / a[near + 1];
        ll summ = sum[near] + cnt * a[near + 1];
        cnt += dp[near];
        cout << summ << ' ' << cnt << '\n';
    }

    return 0;
}
