#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <bitset>
#include <map>

#define ff  first
#define ss  second
#define pb  push_back
#define sz  size()
#define rsz  resize()

using namespace std;

typedef long long ll;
typedef pair<int, int> pr;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;

const int NN = 3020;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vll a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vll b = a;
    int q;
    cin >> q;

        ll ans = 0;
        for (int r = 0; r < 4; ++r) {
            vll a1(n);
            for (int i = 0; i < n; ++i)
                a1[i] = a[(i + 1) % n];
            a = a1;
            vll dp(n, 0);
            vi last_used(n);
            vi first_used(n);
            vi sm_used(n); // 2 
            vi sm1_used(n); // 1 
            vi used(n); //  
            dp[0] = a[0];
            sm_used[0] = 0;
            sm1_used[0] = 0;
            used[0] = 1;
            if (n > 1) {
                dp[1] = (ll)a[0] + a[1];
                last_used[1] = 1;
                first_used[1] = 0;
                sm_used[1] = 0;
                sm1_used[1] = 1;
                used[1] = 2;
            }
            if (n > 2) {
                dp[2] = dp[1] + a[2];
                last_used[2] = 2;
                first_used[2] = 0;
                sm_used[2] = 1;
                sm1_used[1] = 1;
                used[2] = 3;
            }
            last_used[0] = 0;
            first_used[0] = 0;
            for (int i = 3; i < n - 1; ++i) {
                if (used[i - 1] < 3) {
                    dp[i] = dp[i - 1] + a[i];
                    last_used[i] = i;
                    first_used[i] = first_used[i - 1];
                    sm_used[i] = sm_used[i - 1];
                    sm1_used[i] = sm1_used[i - 1];
                    used[i] = used[i - 1] + 1;
                } else {
                    dp[i] = dp[i - 1];
                    last_used[i] = last_used[i - 1];
                    first_used[i] = first_used[i - 1];
                    sm_used[i] = sm_used[i - 1];
                    sm1_used[i] = sm1_used[i - 1];
                    used[i] = 0;
                }
                if (dp[i - 2] + a[i] > dp[i]) {
                    dp[i] = dp[i - 2] + a[i];
                    last_used[i] = i;
                    first_used[i] = first_used[i - 2];
                    used[i] = 1;
                    if (i - 1 == 2)
                        sm_used[i] = 0;
                    else
                        sm_used[i] = sm_used[i - 2];
                    if (i - 1 == 1)
                        sm1_used[i] = 0;
                    else
                        sm1_used[i] = sm1_used[i - 2];
                }
                if (dp[i - 3] + a[i] + a[i - 1] > dp[i]) {
                    dp[i] = dp[i - 3] + a[i] + a[i - 1];
                    used[i] = 2;
                    last_used[i] = i;
                    first_used[i] = first_used[i - 3];
                    if (i - 2 == 2)
                        sm_used[i] = 0;
                    else
                        sm_used[i] = sm_used[i - 3];
                    if (i - 2 == 1)
                        sm1_used[i] = 0;
                    else
                        sm1_used[i] = sm1_used[i - 3];
                    if (i - 1 == 2)
                        sm_used[i] = 1;
                }
                if (i > 3) {
                    if (dp[i - 4] + a[i] + a[i - 1] + a[i - 2] > dp[i]) {
                        dp[i] = dp[i - 4] + a[i] + a[i - 1] + a[i - 2];
                        used[i] = 3;
                        last_used[i] = i;
                        first_used[i] = first_used[i - 4];
                        if (i - 3 == 2)
                            sm_used[i] = 0;
                        else
                            sm_used[i] = sm_used[i - 4];
                        if (i - 3 == 1)
                            sm1_used[i] = 0;
                        else
                            sm1_used[i] = sm1_used[i - 4];
                        if (i - 1 == 2) {
                            sm_used[i] = 1;
                        }
                        if (i - 2 == 2) {
                            sm_used[i] = 1;
                        }
                        if (i - 2 == 1) {
                            sm1_used[i] = 1;
                        }
                    }
                } else {
                    if ((ll)a[i] + a[i - 1] + a[i - 2] > dp[i]) {
                        dp[i] = (ll)a[i] + a[i - 1] + a[i - 2];
                        used[i] = 3;
                        last_used[i] = i;
                        first_used[i] = 1;
                        sm_used[i] = 1;
                        sm1_used[i] = 1;
                    }
                }
            }
            if (n > 1)
                ans = max(ans, dp[n - 2]);
            else ans = a[0];
        }
        cout << ans << '\n';
        for (int q1 = 0; q1 < q; ++q1) {
            ll x, y;
            cin >> x >> y;
            --x;
            b[x] = y;
            a = b;



            ll ans = 0;
            for (int r = 0; r < n; ++r) {
                vll a1(n);
                for (int i = 0; i < n; ++i)
                    a1[i] = a[(i + 1) % n];
                a = a1;
                vll dp(n, 0);
                vi last_used(n);
                vi first_used(n);
                vi sm_used(n); // 2 
                vi sm1_used(n); // 1 
                vi used(n); //  
                dp[0] = a[0];
                sm_used[0] = 0;
                sm1_used[0] = 0;
                used[0] = 1;
                if (n > 1) {
                    dp[1] = (ll)a[0] + a[1];
                    last_used[1] = 1;
                    first_used[1] = 0;
                    sm_used[1] = 0;
                    sm1_used[1] = 1;
                    used[1] = 2;
                }
                if (n > 2) {
                    dp[2] = dp[1] + a[2];
                    last_used[2] = 2;
                    first_used[2] = 0;
                    sm_used[2] = 1;
                    sm1_used[1] = 1;
                    used[2] = 3;
                }
                last_used[0] = 0;
                first_used[0] = 0;
                for (int i = 3; i < n - 1; ++i) {
                    if (used[i - 1] < 3) {
                        dp[i] = dp[i - 1] + a[i];
                        last_used[i] = i;
                        first_used[i] = first_used[i - 1];
                        sm_used[i] = sm_used[i - 1];
                        sm1_used[i] = sm1_used[i - 1];
                        used[i] = used[i - 1] + 1;
                    } else {
                        dp[i] = dp[i - 1];
                        last_used[i] = last_used[i - 1];
                        first_used[i] = first_used[i - 1];
                        sm_used[i] = sm_used[i - 1];
                        sm1_used[i] = sm1_used[i - 1];
                        used[i] = 0;
                    }
                    if (dp[i - 2] + a[i] > dp[i]) {
                        dp[i] = dp[i - 2] + a[i];
                        last_used[i] = i;
                        first_used[i] = first_used[i - 2];
                        used[i] = 1;
                        if (i - 1 == 2)
                            sm_used[i] = 0;
                        else
                            sm_used[i] = sm_used[i - 2];
                        if (i - 1 == 1)
                            sm1_used[i] = 0;
                        else
                            sm1_used[i] = sm1_used[i - 2];
                    }
                    if (dp[i - 3] + a[i] + a[i - 1] > dp[i]) {
                        dp[i] = dp[i - 3] + a[i] + a[i - 1];
                        used[i] = 2;
                        last_used[i] = i;
                        first_used[i] = first_used[i - 3];
                        if (i - 2 == 2)
                            sm_used[i] = 0;
                        else
                            sm_used[i] = sm_used[i - 3];
                        if (i - 2 == 1)
                            sm1_used[i] = 0;
                        else
                            sm1_used[i] = sm1_used[i - 3];
                        if (i - 1 == 2)
                            sm_used[i] = 1;
                    }
                    if (i > 3) {
                        if (dp[i - 4] + a[i] + a[i - 1] + a[i - 2] > dp[i]) {
                            dp[i] = dp[i - 4] + a[i] + a[i - 1] + a[i - 2];
                            used[i] = 3;
                            last_used[i] = i;
                            first_used[i] = first_used[i - 4];
                            if (i - 3 == 2)
                                sm_used[i] = 0;
                            else
                                sm_used[i] = sm_used[i - 4];
                            if (i - 3 == 1)
                                sm1_used[i] = 0;
                            else
                                sm1_used[i] = sm1_used[i - 4];
                            if (i - 1 == 2) {
                                sm_used[i] = 1;
                            }
                            if (i - 2 == 2) {
                                sm_used[i] = 1;
                            }
                            if (i - 2 == 1) {
                                sm1_used[i] = 1;
                            }
                        }
                    } else {
                        if ((ll)a[i] + a[i - 1] + a[i - 2] > dp[i]) {
                            dp[i] = (ll)a[i] + a[i - 1] + a[i - 2];
                            used[i] = 3;
                            last_used[i] = i;
                            first_used[i] = 1;
                            sm_used[i] = 1;
                            sm1_used[i] = 1;
                        }
                    }
                }
                if (n > 1)
                    ans = max(ans, dp[n - 2]);
                else ans = a[0];
            }
            cout << ans << '\n';
        }


    return 0;
}
