#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<map>

using namespace std;

int main() {
    int n, x;
    cin >> n >> x;
    long long ans = 0;
    vector<vector<int>> del(3e6);
    for (int i = 1; i < n; i++) {
        for (int j = 1; j < n; j++) {
            if (i * j < del.size()) {
                del[i*j].push_back(i);
            }
        }
    }
    for (int i = 0; i < 3e6; i++) {
        sort(del[i].begin(), del[i].end());
    }
    for (int i = 2; i <= n; i++) {
        for (int j = max((n+i-1)/i,2) ; (j+i-1) <= n; j++) {
            if (i != x && j != x) {
                long long k = i * j - n;
                if (k > 0) {
                    long long xmin = (k+j-2) / (j - 1),xmax=i;
                    if (xmax > xmin) {
                        ans += lower_bound(del[k].begin(), del[k].end(), xmax) - lower_bound(del[k].begin(), del[k].end(), xmin);
                    }
                }
            }
        }
    }
    cout << ans;
}