#include<iostream>
#include<vector>
#include<map>
#include<cmath>
#include<algorithm>

using namespace std;

vector<vector<long long>> to;

void izm(int v, int l, int r, int l1, long long ne) {
	if(l > l1 || r <= l1) {
		return;
	}
	if (r - l == 1) {
		to[v][0] = 0;
		to[v][5] = ne;
		return;
	}
	izm(v * 2 + 1, l, (l + r) / 2, l1, ne);
	izm(v * 2 + 2, (l + r) / 2, r, l1, ne);
	long long s1 = (l + r) / 2 - l, s2 = r - (l + r) / 2;
	for (int i = 0; i < 16; i++) {
		to[v][i] = -1e9;
	}
	for (int i = 0; i < 16; i++) {
		for (int j = 0; j < 16; j++) {
			long long le1 = i / 4, ri1 = i % 4;
			long long le2 = j / 4, ri2 = j % 4;

			if (ri2 == s2) {
				ri2 += ri1;
			}
			if (le1 == s1) {
				le1 += le2;
			}
			if (le1 < 4 && ri2 < 4 && le2 + ri1 < 4) {
				to[v][4 * le1 + ri2] = max(to[v][4 * le1 + ri2], to[v * 2 + 1][i] + to[v * 2 + 2][j]);
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	to.resize(4 * n, vector<long long>(16, -1e9));
	for (int i = 0; i < n; i++) {
		long long k;
		cin >> k;
		izm(0, 0, n, i, k);
	}
	long long ans = 0;
	for (int i = 0; i < 16; i++) {
		long long le1 = i / 4, ri1 = i % 4;
		if (le1 + ri1 < 4) {
			ans = max(ans, to[0][i]);
		}
	}
	cout << ans << "\n";
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int no;
		long long ne;
		cin >> no >> ne;
		izm(0, 0, n, no - 1, ne);
		ans = 0;
		for (int i = 0; i < 16; i++) {
			long long le1 = i / 4, ri1 = i % 4;
			if (le1 + ri1 < 4) {
				ans = max(ans, to[0][i]);
			}
		}
		cout << ans << "\n";
	}
} 
