#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
#define ll long long
#define pb push_back
#define vi vector<ll>
#define vvi vector<vi>
#define pii pair<ll, ll>
#define ld long double
#define all(a) a.begin(), a.end()

const ll inf = 2e18;
const ll iNF = 2e9;
const ld eps = 1e-7;

using namespace std;

void solve() {
    int n, x; cin >> n >> x;
    vvi del(n * n + 1);
    for (int i = 1; i <= n * n; ++i) {
        for (int j = i; j <= n * n; j += i) {
            del[j].pb(i);
        }
    }
    ll ans = 0;
    for (int a = 1; a <= n; ++a) {
        for (int b = 1; b <= n; ++b) {
            if (a == x || b == x) continue;
            int S = a * b - n;
            if (S <= 0) continue;
            int pos_a = lower_bound(all(del[S]), a) - del[S].begin() - 1;
            int pos_b = lower_bound(all(del[S]), b) - del[S].begin();
            pos_b = del[S].size() - pos_b;
            ans += max(0, pos_a - pos_b + 1);
        }
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif
    solve();
}
