#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
#define ll long long
#define pb push_back
#define vi vector<ll>
#define vvi vector<vi>
#define pii pair<ll, ll>
#define ld long double
#define all(a) a.begin(), a.end()

const ll inf = 2e18;
const ll iNF = 2e9;
const ld eps = 1e-7;

using namespace std;

void solve() {
    ll n, x; cin >> n >> x;
    vvi del(n * n / 2 + 1);
    for (ll i = 1; i <= n * n / 2; ++i) {
        for (ll j = i; j <= n * n / 2; j += i) {
            del[j].pb(i);
        }
    }
    ll ans = 0;
    for (ll a = 1; a <= n; ++a) {
        for (ll b = 1; 2 * (a + b - 1) <= n; ++b) {
            if (a == x || b == x) continue;
            ll S = a * b - n;
            if (S <= 0 || S >= del.size()) continue;
            ll pos_a = lower_bound(all(del[S]), a) - del[S].begin() - 1;
            ll pos_b = lower_bound(all(del[S]), b) - del[S].begin();
            pos_b = del[S].size() - pos_b;
            ans += max(0LL, pos_a - pos_b + 1);
        }
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif
    solve();
}
