#include "bits/stdc++.h"
#define ll long long
#define pb push_back
#define vi vector<ll>
#define vvi vector<vi>
#define pii pair<ll, ll>
#define ld long double
#define all(a) a.begin(), a.end()

const ll inf = 2e18;
const ll INF = 2e9;
const ld eps = 1e-7;

using namespace std;

vi del[(int)2.25e6 + 1];
vi cnt[(int)2.25e6 + 1];
int sz[(int)2.25e6 + 1];

void solve() {
    ll n, x; cin >> n >> x;
    ll p = (n + 15) / 2 / 2;
    ll z = p * (n + 20 - 2 * p + 1) / 2;
    for (ll i = 1; i <= z; ++i) {
        for (ll j = i; j <= z; j += i) {
            sz[j]++;
        }
    }
    for (ll i = 1; i <= z; ++i) {
        del[i].reserve(sz[i]);
        cnt[i].reserve(sz[i]);
    }
    for (ll i = 1; i <= z; ++i) {
        for (ll j = i; j <= z; j += i) {
            del[j].pb(i);
        }
    }
    for (ll i = 1; i <= z - n; ++i) {
        ll it1 = 0, it2 = 0;
        while (it2 < del[i + n].size()) {
            if (it1 == del[i].size() || del[i][it1] >= del[i + n][it2]) {
                cnt[i + n].pb(it1 - 1);
                it2++;
            } else it1++;
        }
    }
    ll ans = 0;
    for (ll i = n + 1; i <= z; ++i) {
        for (ll j = 0; j < del[i].size(); ++j) {
            ll a = del[i][j];
            ll b = i / a;
            ll pos_a = cnt[i][j];
            ll pos_b = del[i - n].size() - cnt[i][del[i].size() - j - 1] - 1;
            if (a != x && b != x) ans += max(0LL, pos_a - pos_b + 1);
        }
    }
    for (int a = 1; a <= n; ++a) {
        for (int b = 1; b <= n; ++b) {
            if (a * b <= z) continue;
            if (a + b == n) ans++;
            if (2 * a + b == n) ans++;
            if (2 * b + a == n) ans++;
            if (2 * a + 2 * b == n) ans++;
        }
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif
    solve();
}
