#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
#define ll long long
#define pb push_back
#define vi vector<ll>
#define vvi vector<vi>
#define pii pair<ll, ll>
#define ld long double
#define all(a) a.begin(), a.end()
#define mp make_pair

const ll inf = 2e18;
const ll iNF = 2e9;
const ld eps = 1e-7;

using namespace std;

vi a;
vector<pii> cnt;

pii maximize(ll n, ll pos) {
    if (!n) return {0, 0};
    ll val = a[pos];
    pii ans;
    if (!pos) ans = mp(0, 0);
    else ans = cnt[pos - 1];
    if (ans.second <= n % val) return mp(ans.first + n / val, ans.second + n - n % val);
    else return mp(ans.first + n / val - 1, ans.second + n - n % val - val);
}

void solve() {
    ll n; cin >> n;
    a.resize(n); cnt.resize(n);
    for (ll i =  0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n - 1; ++i) {
        cnt[i] = maximize(a[i + 1] - 1, i);
    }
    ll q; cin >> q;
    while (q--) {
        ll b; cin >> b; ll pos = upper_bound(all(a), b) - a.begin() - 1;
        pii ans = maximize(b, pos);
        cout << ans.second << " " << ans.first << "\n";
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif
    solve();
}
