#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cassert>
#include <cmath>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

#define int long long

using namespace std;

typedef long long ll;
typedef pair<int, int> pa;

mt19937 rnd(228228);

const int N = 1e5;

int get(int x, int n) {
	int l = 1, r = 1e9;
	while (l + 1 < r) {
		int m = (l + r) / 2;
		if ((x - m) * (x + m) < n)
			r = m;
		else
			l = m;
	}
	return l;
}

signed main() {
	int n;
	cin >> n;
	for (int x = sqrt(n); x < sqrt(n) + 1e7; ++x) {
		int y = get(x, n);
		if (x * x - y * y == n) {
			cout << "Yes\n" << x << " " << y;
			return 0;
		}
	}
	cout << "NO";
}