#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cassert>
#include <cmath>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

#define int long long

using namespace std;

typedef long long ll;
typedef pair<int, int> pa;

mt19937 rnd(228228);

const int N = 1e5;

int get(int x, int n) {
	int l = 1, r = 1e9;
	while (l + 1 < r) {
		int m = (l + r) / 2;
		if ((x - m) * (x + m) < n)
			r = m;
		else
			l = m;
	}
	return l;
}

signed main() {
	int n;
	cin >> n;
	for (int y = 1; y < sqrt(n); ++y) {
		
		if ((n % y) == 0) {
			int x = n / y;
			if (x % 2 == y % 2)
			{
				cout << "Yes\n" << (x + y) / 2 << " " << (x - y) / 2;
				return 0;
			}
		}
	}
	cout << "No";
}