#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cassert>
#include <cmath>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

#define int long long

using namespace std;

typedef long long ll;
typedef pair<int, int> pa;

mt19937 rnd(228228);

const int N = 1e5;

int get(int x, int n) {
	int l = 1, r = 1e9;
	while (l + 1 < r) {
		int m = (l + r) / 2;
		if ((x - m) * (x + m) < n)
			r = m;
		else
			l = m;
	}
	return l;
}

void solve(int n) {
	//cin >> n;
	if (n == 0) {
		cout << "YES\n1 1";
		return;
	}
	/*
	if (n % 2) {
		int x = n / 2 + 1, y = n / 2;
		if (x * x - y * y == n) {
			cout << "Yes\n" << x << " " << y;
			return;
		}
	}
	/*
	if (n % 4 == 2) {
		cout << "NO";
		return;
	}
	*/
	for (int y = 1; y <= sqrt(n); ++y) {
		if (y > 3e8)
			break;
		if ((n % y) == 0) {
			int x = n / y;
			if (x % 2 == y % 2 && x != y)
			{
				cout << "Yes\n" << (x + y) / 2 << " " << (x - y) / 2;
				return;
			}
		}
	}
	cout << "No";
}

signed main() {
	
	int n;
	cin >> n;
	solve(n);
	return 0;
	
	for (int n = 1; n <= 100; ++n) {
		cout << n << ": ";
		solve(n);
		cout << '\n';
	}
	
}