#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cassert>
#include <cmath>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

#define int long long

using namespace std;

typedef long long ll;
typedef pair<int, int> pa;
typedef long double ld;

mt19937 rnd(228228);

const int N = 5e5;

int t[4 * N];
int tt[4 * N];

void upd(int v, int l, int r, int ps, int x) {
    if (l + 1 == r) {
        t[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (ps < m)
        upd(2 * v, l, m, ps, x);
    else
        upd(2 * v + 1, m, r, ps, x);
    t[v] = t[2 * v] + t[2 * v + 1];
}

void Upd(int v, int l, int r, int ps, int x) {
    if (l + 1 == r) {
        tt[v] += x;
        return;
    }
    int m = (l + r) / 2;
    if (ps < m)
        Upd(2 * v, l, m, ps, x);
    else
        Upd(2 * v + 1, m, r, ps, x);
    tt[v] = tt[2 * v] + tt[2 * v + 1];
}

int get(int v, int l, int r, int L, int R) {
    if (L <= l && r <= R)
        return tt[v];
    else if (l >= R || r <= L)
        return 0;
    else {
        int m = (l + r) / 2;
        return get(2 * v, l, m, L, R) + get(2 * v + 1, m, r, L, R);
    }
}

signed main() {

    int n;
    cin >> n;
    map<int, int> mp;
    vector<int> a(n), pr(n);
    vector<int> r, y;
    for (int& i : a) {
        cin >> i;
        y.push_back(i);
    }
    for (int i = 0; i <= n; ++i)
        y.push_back(i);
    y.push_back(1e18);
    sort(y.begin(), y.end());
    y.resize(unique(y.begin(), y.end()) - y.begin());
    for (int i = n - 1; i >= 0; --i) {
        a[i] = lower_bound(y.begin(), y.end(), a[i]) - y.begin();
        if (mp.count(a[i]) == 0) {
            r.push_back(-1e18);
            pr[i] = 1e18;
        }
        else {
            r.push_back(i - mp[a[i]]);
            pr[i] = mp[a[i]];
        }
        r[r.size() - 1] *= -1;
        y.push_back(r.back());
        mp[a[i]] = i;
    }
    reverse(r.begin(), r.end());
    int ans = 0;
    for (int i = 0; i < n; ++i)
        Upd(1, 0, N, lower_bound(y.begin(), y.end(), r[i]) - y.begin(), 1);

    for (int ln = 1; ln <= n; ++ln) {
        ans -= t[1];
        ans += get(1, 0, N, lower_bound(y.begin(), y.end(), ln) - y.begin(), N);
        Upd(1, 0, N, lower_bound(y.begin(), y.end(), r[n - ln]) - y.begin(), -1);
        upd(1, 0, N, a[ln - 1], 1);
        cout << ans << " ";
    }
}