#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cassert>
#define int long long

using namespace std;

typedef pair<int, int> pa;
typedef long double ld;

int gcd(int a, int b) {
    if (b > a)
        swap(a, b);
    while (b) {
        int c = a % b;
        a = b;
        b = c;
    }
    return a;
}

const int N = 3005;
int uk[N];

signed main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, x;
    cin >> n >> x;

    int bad = 0, ans = 0, mx = 0;
    vector<pair<int, pa>> vals;
    for (int d1 = 2; d1 <= n / 2 + 1; ++d1) {
        if (d1 == x)
            continue;
        for (int d2 = d1; d2 <= n; ++d2) {
            if (d1 == x || d2 == x)
                continue;
            int ab = d1 * d2;
            int cd = ab - n;
            if (cd <= 0)
                continue;
            vals.push_back({ {d1 * d2}, {d1, d2} });
        }
    }
    for (int j = 1; j < N; ++j)
        uk[j] = j;
    sort(vals.begin(), vals.end());
    for (auto i : vals) {
        for (int j = 1; j < N; ++j) {
            while (uk[j] * j + n < i.first)
                uk[j]++;

            if (uk[j] * j + n == i.first) {
                int d1 = i.second.first, d2 = i.second.second;
                int D1 = j, D2 = uk[j];
                if (d1 > D1&& d2 > D2) {
                    ++ans;
                }
                if (d1 != d2 && d2 > D1&& d1 > D2) {
                    ans++;
                }
                if (D1 != D2 && d2 > D1&& d1 > D2) {
                    ans++;
                }
                if (d1 != d2 && D1 != D2 && d1 > D1&& d2 > D2) {
                    ++ans;
                }
            }
        }
    }
    //cout << mx << '\n';
    cout << ans;

}   