#include <bits/stdc++.h>

using namespace std;

#define int long long
/*
{
struct Node {
    int x, prior, sz;
    Node *l, *r;
    Node() {
        l = nullptr;
        r = nullptr;
        sz = 0;
    }
    Node(int key) {
        l = nullptr;
        r = nullptr;
        x = key; prior = rand();
        sz = 1;
    }
};

typedef Node * PNode;

int get_sz(PNode root) {
    if (!root) return 0;
    return root->sz;
}

void upd(PNode & root) {
    if (!root) return;
    root->sz = 1 + get_sz(root->l) + get_sz(root->r);
    return;
}


void merge_(PNode & root, PNode left, PNode right) {
    if (!left) {
        root = right;
        return;
    }
    if (!right) {
        root = left;
        return;
    }
    if (left->prior > right->prior) {
        merge_(left->r, left->r, right);
        root = left;
    }
    else {
        merge_(right->l, left, right->r);
        root = right;
    }
    upd(root);
    return;
}

void split_kth(PNode root, PNode & left, PNode & right, int k) {
    if (!root) {
        left = nullptr;
        right = nullptr;
        return;
    }
    if (get_sz(root->l) >= k) {
        split_kth(root->l, left, root->l, k);
        right = root;
        upd(right);
    }
    else {
        split_kth(root->r, root->r, right, k - get_sz(root->l) - 1);
        left = root;
        upd(left);
    }
    return;
}

void p_b(PNode & root, int key) {
    PNode ins = new Node(key);
    merge_(root, root, ins);
}


void print(PNode root) {
    if (!root) return;
    print(root->l);
    cout << root->x << " ";
    print(root->r);
    return;
}


int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}
}
*/

int n;
vector<int> a;


int cost(int t) {
    int curr = n - 1, cnt = 0;
    while (curr >= 0 && t > 0) {
        int c = t / a[curr];
        t -= c * a[curr];
        cnt += c;
        curr--;
    }
    return cnt;
}

int32_t main()
{
    cin >> n; a.resize(n);
    bool check1 = true, check2 = true, check3 = true;
    if (n > 500) check1 = false;
    if (n != 60) check2 = false;
    vector<int> pw(60);
    pw[0] = 1;
    for (int i = 1; i < 60; i++) pw[i] = pw[i - 1] * 2;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] != pw[i]) check2 = false;
        if (a[i] > 500) check1 = false;
    }
    int q;
    cin >> q;
    if (q > 5) {
        check1 = false;
        check2 = false;
        check3 = false;
    }
    vector<int> b(q);
    for (int i = 0; i < q; i++) {
        cin >> b[i];
        if (b[i] > 500) check1 = false;
        if (b[i] > 2 * 1e5) check3 = false;
    }
    if (check1) {
        int ans1 = 0, ans2 = 0;
        for (int i = 0; i < q; i++) {
            for (int j = 1; j <= b[i]; j++) {
                int c = cost(j);
                if (c > ans1) {
                    ans1 = c;
                    ans2 = j;
                }
            }
            cout << ans2 << " " << ans1 << endl;
            ans1 = 0; ans2 = 0;
        }
        return 0;
    }
    if (check2) {
        for (int i = 0; i < q; i++) {
            for (int j = n - 1; j >= 0; j--) {
                if (a[j] - 1 <= b[i]) {
                    cout << a[j] - 1 << " " << j << endl;
                    break;
                }
            }
        }
        return 0;
    }
    if (check3) {
        const int maxn = 2 * 1e5 + 1;
        pair<int, int> ans[maxn];
        int cst[maxn];
        cst[1] = 1;
        cst[0] = 0;
        ans[1] = {1, 1};
        for (int i = 2; i < maxn; i++) {
            int ind = upper_bound(a.begin(), a.end(), i) - a.begin() - 1;
            cst[i] = cst[i - a[ind]] + 1;
            if (ans[i - 1].second > cst[i]) {
                ans[i] = ans[i - 1];
            }
            else {
                ans[i] = {i, cst[i]};
            }
        }
        for (int i = 0; i < q; i++) {
            cout << ans[b[i]].first << " " << ans[b[i]].second << endl;
        }
        return 0;
    }
}
