#include<bits/stdc++.h>
using namespace std;
#define ic(n) int n; cin >> n;
#define lc(n) long long n; cin >> n;
#define f(n) for(int i = 0; i < n; i++)
#define fj(n) for(int j = 0; j < n; j++)
#define fk(n) for(int k = 0; k < n; k++)
#define pb push_back
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define cn cout << '\n';
#define pri(a, n) for(int i = 0; i < n; i++) cout << a[i] << ' '; cout << '\n';
#define sc(a, n) int a[n]; for(int i = 0; i < n; i++) cin >> a[i];
#define int long long

const int inf = -1e15;

struct el
{
    int dp[4][4];
    el(int val)
    {
        f(4) fj(4) dp[i][j] = inf;
        dp[0][0] = 0;
        dp[1][1] = val;
    }
};
el mrg(el a, el b, bool t)
{
    el res;
    f(4) fj(4) res.dp[i][j] = inf;
    f(4)
    {
        for(int j = 0; j < 4 - i * t; j++)
        {
            for(int lr = 0; lr < 4; lr++)
            {
                for(int rl = 0; lr + lr < 4; rl++)
                {
                    res.dp[i][j] = max(res.dp[i][j], a.dp[i][lr] + b.dp[rl][j]);
                }
            }
        }
    }
    return res;
}
const int maxn = 40000;
class Tree
{
    el tree[4 * maxn];
 public:
    void build(int a[], int v, int vl, int vr)
    {
        if(vr - vl == 1)
        {
            tree[v] = el(a[vl]);
            return;
        }
        int m = (vl + vr) >> 1;
        build(a, 2 * v + 1, vl, m);
        build(a, 2 * v + 2, m, vr);
        tree[v] = mrg(tree[2 * v + 1], tree[2 * v + 2], v == 0);
    }
    void ch(int v, int vl, int vr, int i, int x)
    {
        if(vr - vl == 1)
        {
            tree[v] = el(x);
            return;
        }
        int m = (vl + vr) >> 1;
        if(i >= m) ch(2 * v + 2, m, vr, i, x);
        else ch(2 * v + 1, vl, m, i, x);
        tree[v] = mrg(tree[2 * v + 1], tree[2 * v + 2], v == 0);
    }
    int get()
    {
        int ans = 0;
        f(4) fj(4) ans = max(ans, tree[0].dp[i][j]);
        return ans;
    }
};
int get(int a[], int n)
{
    int dp[n][4][4];
    f(n) fj(4) fk(4) dp[i][j][k] = inf;
    dp[0][0][0] = 0;
    dp[0][1][1] = a[0];
    dp[1][0][0] = 0;
    dp[1][1][0] = a[1];
    dp[1][0][1] = a[0];
    dp[1][2][2] = a[0] + a[1];
    dp[2][0][0] = a[1];
    dp[2][1][0] = a[2];
    dp[2][2][0] = a[1] + a[2];
    dp[2][0][1] = a[0];
    dp[2][1][1] = a[0] + a[2];
    dp[2][0][2] = a[0] + a[1];
    dp[2][3][3] = a[0] + a[1] + a[2];
    for(int i = 3; i < n; i++)
    {
        if(i + 1 < n)
        {
            for(int k = 0; k < 4; k++)
            {
                int sm = 0;
                for(int j = 1; j < min(4ll, i + 1 - k); j++)
                {
                    sm += a[i - j + 1];
                    dp[i][j][k] = max(dp[i - j][0][k] + sm, dp[i][j][k]);
                }
                fj(4) dp[i][0][k] = max(dp[i - 1][j][k], dp[i][0][k]);
            }
        }
        else
        {
            for(int k = 0; k < 4; k++)
            {
                int sm = 0;
                for(int j = 1; j < min(4ll - k, i + 1 - k); j++)
                {
                    sm += a[i - j + 1];
                    dp[i][j][k] = max(dp[i - j][0][k] + sm, dp[i][j][k]);
                }
                fj(4) dp[i][0][k] = max(dp[i - 1][j][k], dp[i][0][k]);
            }
        }
    }
    /*f(n)
    {
        fj(4) cout << dp[i][j][0] << ' ';
        cout << '\n';
    }
    cout << '\n';
    f(n)
    {
        fj(4) cout << dp[i][j][1] << ' ';
        cout << '\n';
    }
    cout << '\n';
    f(n)
    {
        fj(4) cout << dp[i][j][2] << ' ';
        cout << '\n';
    }
    cout << '\n';*/
    int ans = 0;
    f(4) fj(4) ans = max(ans, dp[n - 1][i][j]);
    return ans;
}
signed main()
{
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    int a[n];
    f(n) cin >> a[i];
    cout << get(a, n) << '\n';
    int m;
    cin >> m;
    f(m)
    {
        int p, v;
        cin >> p >> v;
        a[p - 1] = v;
        cout << get(a, n) << '\n';
    }
}
