#include<bits/stdc++.h>
using namespace std;
#define ic(n) int n; cin >> n;
#define lc(n) long long n; cin >> n;
#define f(n) for(int i = 0; i < n; i++)
#define fj(n) for(int j = 0; j < n; j++)
#define fk(n) for(int k = 0; k < n; k++)
#define pb push_back
#define eb emplace_back
#define all(a) a.begin(), a.end()
#define cn cout << '\n';
#define pri(a, n) for(int i = 0; i < n; i++) cout << a[i] << ' '; cout << '\n';
#define sc(a, n) int a[n]; for(int i = 0; i < n; i++) cin >> a[i];
#define int long long

const int inf = -1e15;

struct el
{
    int dp[4][4], ln;
    el(int val = 0)
    {
        f(4) fj(4) dp[i][j] = inf;
        dp[0][0] = 0;
        dp[1][1] = val;
        ln = 1;
    }
};
el mrg(el a, el b, bool t, int vl, int vr)
{
    el res;
    f(4) fj(4) res.dp[i][j] = inf;
    res.ln = a.ln + b.ln;
    for(int i = 0; i < min(4ll, a.ln); i++)
    {
        for(int j = 0; j < min(4 - i * t, b.ln); j++)
        {
            for(int lr = 0; lr < min(4ll, a.ln - i); lr++)
            {
                for(int rl = 0; lr + rl < 4 && rl < min(4ll, b.ln - j); rl++)
                {
                    //cout << "GETTO " << vl << ' ' << vr << ' ' << i << ' ' << j << ' ' << lr << ' ' << rl << '\n';
                    res.dp[i][j] = max(res.dp[i][j], a.dp[i][lr] + b.dp[rl][j]);
                }
            }
        }
    }
    if(a.ln < 4)
    {
        for(int j = 0; j < min(4ll, b.ln); j++)
        {
            if(t && a.ln + j >= 4) break;
            for(int rl = 0; rl < min(4ll, b.ln - j) && a.ln + rl < 4; rl++)
            {
                //cout << "INSADE " << vl << ' ' << vr << ' ' << j << ' ' << rl << ' ' << a.dp[a.ln][a.ln] << ' ' << b.dp[rl][j] << '\n';
                res.dp[a.ln + rl][j] = max(res.dp[a.ln + rl][j], a.dp[a.ln][a.ln] + b.dp[rl][j]);
            }
        }
    }
    if(b.ln < 4)
    {
        for(int i = 0; i < min(4ll, a.ln); i++)
        {
            if(t && b.ln + i >= 4) break;
            for(int lr = 0; lr < min(4ll, a.ln - i) && b.ln + lr < 4; lr++)
            {
                res.dp[i][b.ln + lr] = max(res.dp[i][b.ln + lr], a.dp[i][lr] + b.dp[b.ln][b.ln]);
            }
        }
    }
    if(res.ln < 4)
    {
        res.dp[res.ln][res.ln] = max(res.dp[res.ln][res.ln], a.dp[a.ln][a.ln] + b.dp[b.ln][b.ln]);
    }
    /*if(t)
    {
        f(4)
        {
            fj(4) cout << a.dp[i][j] << ' ';
            cout << '\n';
        }
        cout << '\n';
        f(4)
        {
            fj(4) cout << b.dp[i][j] << ' ';
            cout << '\n';
        }
        cout << '\n';
    }*/
    return res;
}
const int maxn = 40000;
class Tree
{
    el tree[4 * maxn];
 public:
    void build(int a[], int v, int vl, int vr)
    {
        if(vr - vl == 1)
        {
            tree[v] = el(a[vl]);
            return;
        }
        int m = (vl + vr) >> 1;
        build(a, 2 * v + 1, vl, m);
        build(a, 2 * v + 2, m, vr);
        tree[v] = mrg(tree[2 * v + 1], tree[2 * v + 2], v == 0, vl, vr);
    }
    void ch(int v, int vl, int vr, int i, int x)
    {
        if(vr - vl == 1)
        {
            tree[v] = el(x);
            return;
        }
        int m = (vl + vr) >> 1;
        if(i >= m) ch(2 * v + 2, m, vr, i, x);
        else ch(2 * v + 1, vl, m, i, x);
        tree[v] = mrg(tree[2 * v + 1], tree[2 * v + 2], v == 0, vl, vr);
    }
    int get()
    {
        int ans = 0;
        f(4) fj(4) ans = max(ans, tree[0].dp[i][j]);
        return ans;
    }
};
signed main()
{
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    int a[n];
    f(n) cin >> a[i];
    Tree tr;
    tr.build(a, 0, 0, n);
    cout << tr.get() << '\n';
    int m;
    cin >> m;
    f(m)
    {
        int p, v;
        cin >> p >> v;
        tr.ch(0, 0, n, p - 1, v);
        cout << tr.get() << '\n';
    }
}
