#include <iostream>
#include <math.h>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long
#define inf (int)1'000'000'007

int32_t main()
{
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<int> l(n);
	vector<int> v(n);
	for (int i = 0; i < n; i++) cin >> v[i];
	for (int i = 0; i < n; i++) cin >> l[i];
	int m;
	cin >> m;
	vector<int> a(m - 1);
	for (int i = 0; i < m - 1; i++) cin >> a[i];
	vector<int> f(m);
	for (int i = 0; i < m; i++) cin >> f[i];
	vector<double> mx(m + 1, 0);
	mx[m] = 0;
	for (int i = 0; i < n; i++)
	{
		mx[0] += (double)l[i] / v[i];
		for (int j = 0; j < m - 1; j++) mx[j + 1] += (double)l[i] / (v[i] + a[j]);
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		int s, t;
		cin >> s >> t;
		s = t - s;
		if (s >= mx[0]) cout << 0 << '\n';
		else
		{
			int l = 0, r = m, mid;
			while (r - l > 1)
			{
				mid = (r + l) / 2;
				if (mx[mid] > s) l = mid;
				else r = mid;
			}
			cout << f[r - 1] << '\n';
		}
	}
	return 0;
}




