#include <iostream>
#include <math.h>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long
#define inf (int)1'000'000'007

int32_t main()
{
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	vector<int> b = a;
	sort(all(b));
	b.resize(unique(all(b)) - b.begin());
	map<int, int> back;
	for (int i = 0; i < b.size(); i++) back[b[i]] = i;
	for (int i = 0; i < n; i++) a[i] = back[a[i]];
	vector<int> kolvo(n, 0);
	vector<int> ans(n, 0);
	for (int i = 0; i < n; i++)
	{
		int curr = 0;
		for (int j = 0; i + j < n; j++)
		{
			if (kolvo[a[i + j]] == 0) curr++;
			kolvo[a[i + j]]++;
			ans[j] += curr;
		}
		for (int i = 0; i < n; i++) kolvo[i] = 0;
	}
	for (auto i : ans) cout << i << " ";
	return 0;
}




