#include <bits/stdc++.h>

#define int long long
using namespace std;

int n, m;
vector<int> v, l;
vector<int> a, f;

long double get(long double x) {
    long double rest = 0;
    for (int i = 0; i < n; ++i) {
        rest += (long double)l[i] / (v[i] + x);
    }
    return rest;
}

int getans(long double x) {
    if (a.empty() || x < a[0])
        return f[0];
    if (x > a.back())
        return f.back();
    int left = 0, right = m - 1, mid;
    while (right - left > 1) {
        mid = (left + right) / 2;
        if (a[mid] > x)
            right = mid;
        else
            left = mid;
    }
    return f[right];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    v.resize(n);
    l.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    for (int i = 0; i < n; ++i)
        cin >> l[i];
    cin >> m;
    a.resize(m - 1);
    f.resize(m);
    for (int i = 0; i < m - 1; ++i)
        cin >> a[i];
    for (int i = 0; i < m; ++i)
        cin >> f[i];

    int q;
    cin >> q;
    while (q--) {
        int s, t;
        cin >> s >> t;
        if (get(0) <= t - s) {
            cout << 0 << '\n';
            continue;
        }

        long double left = 0, right = 1e18, mid;
        for (int _ = 0; _ < 200; ++_) {

//            cout << left << " " << right << '\n';

            mid = (left + right) / 2.;
            if (get(mid) < t - s)
                right = mid;
            else
                left = mid;
        }
        cout << getans(left) << '\n';
    }

    return 0;
}
