#include <bits/stdc++.h>

#define int long long
using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // n == 2

    int n, m, s;
    cin >> n >> m >> s;

    if (n == 1) {
        cout << s << '\n';
        return 0;
    }

    if (n != 2) {
        cout << "0 1 2 3\n";
        return 0;
    }

    int c[m][n];
    vector<int> a(m), b(m), op(m);
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            cin >> a[i] >> b[i] >> op[i];
            --a[i], --b[i];
        }
    }

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j)
            cin >> c[i][j];
    }

    int left = 0, right = m + 1, mid;

    while (right - left > 1) {
//    for (int mid = 0; mid <= m; ++mid) {
        mid = (left + right) / 2;
        int now = 0;
        for (int i = 0; i < m; ++i) {
            if (op[i] == 2 && c[i][0] < mid)
                ++now;
        }

        if (now > s) {
            continue;
        }

        if (now == s) {
            cout << mid << " " << 0 << '\n';
            return 0;
        }

        vector<int> cur;
        for (int i = 0; i < m; ++i) {
            if ((op[i] == 2 && c[i][0] >= mid) || (op[i] == 1 && c[i][0] < mid))
                cur.push_back(c[i][1]);
        }

        sort(cur.begin(), cur.end());
        if (now + cur.size() < s);
        else {
            cout << mid << " " << cur[s - now - 1] + 1 << '\n';
            return 0;
        }
    }

    mid = left;

    vector<int> cur;
    for (int i = 0; i < m; ++i) {
        if ((op[i] == 2 && c[i][0] >= mid) || (op[i] == 1 && c[i][0] < mid))
            cur.push_back(c[i][1]);
    }

    int now = 0;
    for (int i = 0; i < m; ++i) {
        if (op[i] == 2 && c[i][0] < mid)
            ++now;
    }

    if (now == s) {
        cout << mid << " " << 0 << "\n";
        return 0;
    }

    sort(cur.begin(), cur.end());
    if (now + cur.size() < s)
        assert(false);
    else {
        cout << mid << " " << cur[s - now - 1] + 1 << '\n';
        return 0;
    }

    return 0;
}
