#include <bits/stdc++.h>
#define int long long
using namespace std;

int n;
vector<int> a;
vector<vector<vector<int>>> rsq;
vector<int> rsq1;

void build(int t, int l, int r) {
    if (l + 1 == r) {
        rsq1[t] = a[l];
    }
    else {
        int m = (l + r) / 2;
        build(t * 2 + 1, l, m);
        build(t * 2 + 2, m, r);

        for (int i1 = 0; i1 < 4; ++i1) {
            for (int j1 = 0; j1 < 4; ++j1) {
                if (i1 + j1 > 3)
                    break;
                for (int i = 0; i < 4; ++i) {
                    for (int j = 0; j < 4; ++j) {

                        if (i + i1 >= m - l || j + j1 >= r - m)
                            continue;

                        rsq[t][i][j] = max(rsq[t][i][j], rsq[t * 2 + 1][i][i1] + rsq[t * 2 + 2][j1][j]);
                    }
                }
            }
        }

        if (r - l < 4) {
            rsq1[t] = rsq1[t * 2 + 1] + rsq1[t * 2 + 2];
        }

        if (m - l < 4) {
            for (int j = 0; j < 4; ++j) {
                for (int j1 = 0; j1 < 4; ++j1) {
                    if (j + j1 >= r - m || m - l + j1 >= 4)
                        continue;
                    rsq[t][m - l + j1][j] = max(rsq[t][m - l + j1][j], rsq1[t * 2 + 1] + rsq[t * 2 + 2][j1][j]);
                }
            }
        }

        if (r - m < 4) {
            for (int i = 0; i < 4; ++i) {
                for (int i1 = 0; i1 < 4; ++i1) {
                    if (i + i1 >= m - l || i1 + r - m >= 4)
                        continue;
                    rsq[t][i][i1 + r - m] = max(rsq[t][i][i1 + r - m], rsq[t * 2 + 1][i][i1] + rsq1[t * 2 + 2]);
                }
            }
        }
    }
}

int get() {
    int res = 0;
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 4; ++j) {
            res = max(res, rsq[0][i][j]);
        }
    }
    return max(res, rsq1[0]);
}

void upd(int t, int l, int r, int x, int y, int now) {
    if (y <= l || r <= x)
        return;
    if (x <= l && r <= y) {
        rsq1[t] = now;
        return;
    }
    int m = (l + r) / 2;
    upd(t * 2 + 1, l, m, x, y, now);
    upd(t * 2 + 2, m, r, x, y, now);

    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 4; ++j) {
            rsq[t][i][j] = 0;
        }
    }

    for (int i1 = 0; i1 < 4; ++i1) {
        for (int j1 = 0; j1 < 4; ++j1) {
            if (i1 + j1 > 3)
                break;
            for (int i = 0; i < 4; ++i) {
                for (int j = 0; j < 4; ++j) {

                    if (i + i1 >= m - l || j + j1 >= r - m)
                        continue;

                    rsq[t][i][j] = max(rsq[t][i][j], rsq[t * 2 + 1][i][i1] + rsq[t * 2 + 2][j1][j]);
                }
            }
        }
    }

    if (r - l < 4) {
        rsq1[t] = rsq1[t * 2 + 1] + rsq1[t * 2 + 2];
    }

    if (m - l < 4) {
        for (int j = 0; j < 4; ++j) {
            for (int j1 = 0; j1 < 4; ++j1) {
                if (j + j1 >= r - m || m - l + j1 >= 4)
                    continue;
                rsq[t][m - l + j1][j] = max(rsq[t][m - l + j1][j], rsq1[t * 2 + 1] + rsq[t * 2 + 2][j1][j]);
            }
        }
    }

    if (r - m < 4) {
        for (int i = 0; i < 4; ++i) {
            for (int i1 = 0; i1 < 4; ++i1) {
                if (i + i1 >= m - l || i1 + r - m >= 4)
                    continue;
                rsq[t][i][i1 + r - m] = max(rsq[t][i][i1 + r - m], rsq[t * 2 + 1][i][i1] + rsq1[t * 2 + 2]);
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    a.resize(n);
    rsq1.resize(n * 4);

    for (int i = 0; i < n; ++i)
        cin >> a[i];

    rsq.resize(n * 4);
    for (int i = 0; i < n * 4; ++i) {
        rsq[i].resize(4);
        for (int j = 0; j < 4; ++j) {
            rsq[i][j].resize(4);
        }
    }

    build(0, 0, n);
    cout << get() << '\n';

    int q;
    cin >> q;

    for (int i = 0; i < q; ++i) {
        int p, v;
        cin >> p >> v;
        upd(0, 0, n, p - 1, p, v);
        cout << get() << '\n';
    }

    return 0;
}
