#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#define sz(x) (int)x.size()
#define fi first
#define se second
#define vi vector<int>
#define all(x) x.begin(), x.end()
#define vvi vector<vector<int>>
#define ve vector
#define pii pair<int, int>
#pragma GCC optimize("Ofast", "unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse4,ssse3,popcnt")

using namespace std;
const int INF = 1e9;

int main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int n, k;
	cin >> n;
	ve<double> le(n), sp(n);
	for (int i = 0; i < n; ++i) cin >> sp[i];
	for (int i = 0; i < n; ++i) cin >> le[i];
	int m;
	cin >> m;
	ve<pii> fin(m, {0, 0});
	for (int i = 1; i < m; ++i) cin >> fin[i].fi;
	for (int i = 0; i < m; ++i) cin >> fin[i].se;
	int q;
	cin >> q;
	int t1, t2;
	double t;
	while (q--) {
		cin >> t1 >> t2;
		t = t2 - t1;
		int mx = 0;
		for (int i = 0; i < n; ++i) {
			double vg = le[i] / t - sp[i];
			auto it = upper_bound(all(fin), (pii){vg, -INF});
			if (it != fin.begin()) {
				it--;
				mx = max(mx, it -> se);
			}
		}
		cout << mx << endl;
	}
	return 0;
}