#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#define sz(x) (int)x.size()
#define fi first
#define se second
#define vi vector<int>
#define all(x) x.begin(), x.end()
#define vvi vector<vector<int>>
#define ve vector
#define pii pair<int, int>
#define ll long long
#define pb emplace_back
#pragma GCC optimize("Ofast", "unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse4,ssse3,popcnt")
#define int ll

using namespace std;

struct event {
	int t;
	int d;
	int r;
	event(int r0, int t0, int d0) {
		r = r0, d = d0, t = t0;
	}
};

bool comp(event &a, event &b) {
	if (a.r == b.r) return a.t < b.t;
	return a.r < b.r;
}

signed main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	vi ar(n);
	for (int i = 0; i < n; ++i) cin >> ar[i];
	ve<ll> ans(n);
	map<int, int> last;
	ve<event> events;
	// int l = 2, r = 3;
	// events.pb(l - 1, 1, 1);
	// events.pb(r, 1, l - r - 2);
	for (int i = 0; i < n; ++i) {
		int l = -1;
		if (last.find(ar[i]) != last.end()) {
			l = last[ar[i]];
		}
		events.pb(n - i - 1, 2, n - 1);
		events.pb(n - l - 1, 2, 1 - n);
		events.pb(i - l - 1, 2, - l - 1);
		events.pb(n - l - 1, 2, l + 1);
		events.pb(0, 2, 1);
		events.pb(n - l - 1, 2, - 1);
		events.pb(0, 2, i);
		events.pb(n - i - 1, 2, -i);
		events.pb(0, 2, -i);
		events.pb(i - l - 1, 2, i);

		events.pb(0, 1, 1);
		events.pb(n - i - 1, 1, -1);
		events.pb(n - i - 1, 2, i + 1 - n);

		events.pb(0, 1, 1);
		events.pb(i - l - 1, 1, -1);
		events.pb(i - l - 1, 2, 1 + l - i);

		events.pb(0, 1, -1);
		events.pb(n - l - 1, 1, 1);
		events.pb(n - l - 1, 2, n - l - 1);
		last[ar[i]] = i;
	}
	for (int i = 0; i < n; ++i) events.pb(i, 3, i);
	sort(all(events), comp);
	int curp = 0, curd = 0;
	for (auto p : events) {
		if (p.t == 1) curd += p.d;
		if (p.t == 2) curp += p.d;
		if (p.t == 3) {
			ans[p.d] += curp;
			curp += curd;
		}
	}
	for (auto c : ans) cout << c << ' ';
	cout << endl;
	return 0;
}