#include <iostream>
#include <vector>
#define sz(x) (int)x.size()
#define fi first
#define se second
#define vi vector<int>
#define all(x) x.begin(), x.end()
#define vvi vector<vector<int>>
#define ve vector
#define pii pair<int, int>
#define pb emplace_back
#pragma GCC optimize("Ofast", "unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse4,ssse3,popcnt")

using namespace std;
int n, m, s;
ve<ve<pair<int, pii>>> bmlp;
vvi mat;

bool res_blmp(int num, vi &cur) {
	ve<bool> val(2 * n - 1);
	for (int i = 0; i < n; ++i) {
		val[i] = (mat[num][i] < cur[i]);
	}
	for (int i = 0; i < n - 1; ++i) {
		int a = bmlp[num][i].fi;
		int b = bmlp[num][i].se.fi;
		a--, b--;
		int op = bmlp[num][i].se.se;
		if (op == 1) val[n + i] = (val[a] && val[b]);
		else val[n + i] = (val[a] || val[b]);
	}
	return val.back();
}

bool t = false;

void gen(vi &cur) {
	if (t) return;
	if (sz(cur) == n) {
		int num = 0;
		for (int i = 0; i < m; ++i) {
			if (res_blmp(i, cur)) num++;
		}
		if (num == s) {
			t = true;
			for (auto i : cur) cout << i << ' ';
			cout << endl;
		}
		return;
	}
	for (int i = 0; i <= m; ++i) {
		cur.pb(i);
		gen(cur);
		if (t) return;
		cur.pop_back();
	}
}

int main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	cin >> n >> m >> s;
	bmlp.resize(m, ve<pair<int, pii>>(n - 1));
	bool t = true;
	for (int i = 0; i < m; ++i) {
		for (auto &p : bmlp[i]) {
			cin >> p.fi >> p.se.fi >> p.se.se;
			if (p.se.se != 1) t = false;
		}
	}
	mat.resize(m, vi(n));
	for (int i = 0; i < m; ++i) for (int j = 0; j < n; ++j) cin >> mat[i][j];
	vi ar;
	gen(ar);
	return 0;
}

// 4 3 2
// 1 2 1
// 3 4 1
// 5 6 2
// 1 2 2
// 3 5 1
// 4 6 2
// 1 4 1
// 2 3 1
// 5 6 2
// 0 1 2 2
// 2 2 1 0
// 1 0 0 1