#include <iostream>
#include <vector>
#include <climits>
using namespace std;


signed main() {
    int n;
    cin >> n;
    vector <pair <int, int>> line(n);
    for (auto& i : line)
        cin >> i.first;
    for (auto& i : line)
        cin >> i.second;

    double t_et = 0, s_sum = 0;
    for (auto i : line) {
        t_et += (double) i.second / i.first;
        s_sum += i.second;
    }

    int m;
    cin >> m;
    vector <pair <double, int>> fine(m + 1);
    fine[0] = {t_et, 0};
    for (int q = 1; q <= m - 1; q++) {
        int a;
        cin >> a;
        double my_t = 0;
        for (auto i : line) {
            my_t += (double) i.second / (i.first + a);
        }
        fine[q].first = my_t;
    }

    for (int i = 1; i <= m; i++)
        cin >> fine[i].second;

    int q;
    cin >> q;
    while (q--) {
        int a, b;
        cin >> a >> b;
        int t = b - a;
        int l = -1, r = m + 1;
        while (r - l > 1) {
            int w = (l + r) / 2;
            if (fine[w].first + 1e-5 > t)
                l = w;
            else
                r = w;
        }
        cout << fine[r].second << endl;
    }
    return 0;
}
