#include <iostream>
#include <vector>
#include <unordered_map>
#define int long long
using namespace std;

signed main() {
    cin.tie();
    cout.tie();
    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    vector<int> line(n);
    for (int &i : line)
        cin >> i;
    vector<int> ans(n);
    for (int i = 0; i < n; i++)
        ans[i] = (i + 1) * (n - i);

    vector<int> delta(n + 2);
    vector<int> after(n + 2);
    vector<int> got(n, -1);

    unordered_map<int, int> last;
    for (int i = 0; i < n; i++) {
        if (last.find(line[i]) != last.end())
            got[i] = last[line[i]];
        last[line[i]] = i;
    }

//    for (int j = n - 1; j > -1; j--) {
//        for (int i = j - 1; i > -1; i--) {
//            if (line[i] == line[j]) {
//                int d = j - i + 1;
//                delta[d]--;
//                int going = min(n - j - 1, i);
//                after[going + d]++;
//                if (going > 0) {
//                    after[n - going]++;
//                }
//                break;
//            }
//        }
//    }

    for (int j = n - 1; j > -1; j--) {
        int i = got[j];
        if (i == -1)
            continue;
        int d = j - i + 1;
        delta[d]--;
        int going = min(n - j - 1, i);
        after[going + d]++;
        if (going > 0) {
            after[n - going]++;
        }
    }

    int del = 0, d = 0;
    for (int i = 0; i < n; i++) {
        d += delta[i + 1];
        del += d;
        ans[i] += del;
        d += after[i + 1];
    }

    for (int i : ans)
        cout << i << " ";
    cout << endl;
    return 0;
}
