#include <iostream>
#include <vector>
#include <array>

using namespace std;

vector<array<int, 3>> op[1010];
int n, m, s, a, b, p;
vector<int> z;
int matrix[1001][11];

bool check() {
    int now = 0;
    for (int i = 0; i < m; i++) {
        vector<bool> val;
        for (int j = 0; j < n; j++)
            val.push_back(matrix[i][j] < z[j]);
        for (int j = 0; j < n - 1; j++) {
            if (op[i][j][2] == 2)
                val.push_back(val[op[i][j][0]] || val[op[i][j][1]]);
            else
                val.push_back(val[op[i][j][0]] && val[op[i][j][1]]);
        }
        if (val[2 * n - 2])
            now++;
    }
    return now == s;
}

void gen() {
    if (z.size() == n) {
        if (check()) {
            for (int i : z)
                cout << i << " ";
            exit(0);
        }
        return;
    }
    for (int i = 0; i <= m; i++) {
        z.push_back(i);
        gen();
        z.pop_back();
    }
}

signed main() {
    cin >> n >> m >> s;
    bool is_1 = true;
    for (int i = 0; i < m; i++) {
        op[i].resize(n - 1);
        for (int j = 0; j < n - 1; j++) {
            cin >> a >> b >> p;
            op[i][j] = {a - 1, b - 1, p};
            if (op[i][j][2] == 2)
                is_1 = false;
        }
    }

    if (is_1) {
        cout << m - s - 1 << " ";
        for (int i = 0; i < n - 1; i++)
            cout << m << " ";
        cout << endl;
        return 0;
    }

    for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
            cin >> matrix[i][j];

    gen();

    return 0;
}
