#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

signed main() {
    int n, x;
    cin >> n >> x;
    vector <vector <int>> cnt((n + 10) * (n + 10));
    for (int c = 1; c < n; c++) {
        for (int d = 1; d < n; d++) {
            cnt[c * d + n].push_back(c);
        }
    }

    for (auto& i : cnt)
        sort(i.begin(), i.end());

    int ans = 0;
    for (int a = 2; a <= n; a++) {
        for (int b = 2; b <= n; b++) {
            if (a == x || b == x)
                continue;
            auto right = upper_bound(cnt[a * b].begin(), cnt[a * b].end(), a);
            auto left = upper_bound(cnt[a * b].begin(), cnt[a * b].end(), (a * b - n) / b);
            ans += right - left;
        }
    }
    cout << ans << endl;
    return 0;
}
