#include <iostream>
#include <vector>
#define int long long
using namespace std;

const int N = 2e5 + 100;

signed main() {
    int n;
    cin >> n;
    vector <int> line(n);
    for (int& i : line)
        cin >> i;

    if (n == 60) {
        bool is_2 = true;
        for (int i = 0; i < n; i++)
            if (line[i] != ((long long) 1 << i))
                is_2 = false;
        if (is_2) {
            vector<int> can(n - 1);
            for (int i = 0; i < n - 1; i++)
                can[i] = (line[i + 1] - 1) / line[i];

            vector<int> pref_can(n - 1);
            if (n > 1)
                pref_can[0] = line[0] * can[0];
            for (int i = 1; i < n - 1; i++) {
                pref_can[i] = pref_can[i - 1] + line[i] * can[i];
            }

            vector<int> pref_cnt(n - 1);
            if (n > 1)
                pref_cnt[0] = can[0];
            for (int i = 1; i < n - 1; i++) {
                pref_cnt[i] = pref_cnt[i - 1] + can[i];
            }

            int q;
            cin >> q;
            while (q--) {
                int b;
                cin >> b;
                int l = -1, r = n - 1;
                while (r - l > 1) {
                    int m = (l + r) / 2;
                    if (pref_can[m] >= b)
                        r = m;
                    else
                        l = m;
                }

                int ans = 0, money = 0;
                if (r > 0)
                    ans = pref_can[l], money = pref_cnt[l];

                int more = (b - ans) / line[r];
                ans += more * line[r];
                money += more;
                cout << ans << " " << money << "\n";
            }
            return 0;
        }
    }
    vector <int> need(N);
    need[0] = 0;
    for (int i = 1; i < N; i++) {
        int l = 0, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (line[m] > i)
                r = m;
            else
                l = m;
        }
        need[i] = need[i - line[l]] + 1;
    }

    vector <pair <int, int>> mx(N);
    int mxy = 0, ind = 0;
    for (int i = 1; i < N; i++) {
        if (need[i] > mxy) {
            mxy = need[i], ind = i;
        }
        mx[i] = {mxy, ind};
    }

    int q;
    cin >> q;
    while (q--) {
        int b;
        cin >> b;
        cout << mx[b].second << " " << mx[b].first << endl;
    }
    return 0;
}
