#pragma GCC optimize("Ofast")
#pragma GCC target("avx")
#include <iostream>
#include<string>
#include<cmath>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#define ll long long
#define ld long double
struct bmlp {
    int a, b, op;
    bmlp():a(0), b(0), op(1){}
    bmlp(int a, int b, int op) : a(a), b(b), op(op) {}
};
int main() {
    std::ios_base::sync_with_stdio(0), cin.tie(0);
    int n, m, s;
    cin >> n >> m >> s;
    vector<vector<bmlp>> bm(m, vector<bmlp>(n - 1));
    vector<vector<int>> x(m, vector<int>(n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            int a, b, op;
            cin >> a >> b >> op;
            a--, b--;
            bm[i][j] = bmlp(a, b, op);
        }
    }
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> x[i][j];
        }
    }
    if (m <= 2) {
        if (m == 1) {
            for (int i = 0; i < n; ++i)
                cout << 0 << ' ';
            cout << '\n';
            return 0;
        }
        vector<int> z(n);
        vector<int> val(2 * n);
        for (int mask = 0; mask < (1 << n); ++mask) {
            for (int i = 0; i < n; ++i)
                z[i] = ((mask & (1 << i)) != 0);
            int ones = 0;
            for (int i = 0; i < m; ++i) {
                val.assign(2 * n, 0);
                for (int j = 0; j < n; ++j)
                    if (x[i][j] < z[j])
                        val[j] = 1;
                for (int p = 0; p < n - 1; ++p) {
                    int a, b, op;
                    a = bm[i][p].a, b = bm[i][p].b, op = bm[i][p].op;
                    if (op == 1) {
                        val[n + p] = (val[a] & val[b]);
                    } else {
                        val[n + p] = (val[a] | val[b]);
                    }
                }
                if (val[2 * n - 2] == 1)
                    ones++;
            }
            if (ones == s) {
                for (int fd = 0; fd < n; ++fd) {
                    cout << z[fd] << ' ';
                }
                cout << '\n';
                return 0;
            }
        }
    } else if (n <= 2) {
        if (n == 1) {
            for (int Z = 0; Z < m; ++Z) {
                int ones = 0;
                for (int i = 0; i < m; ++i) {
                    if (x[i][0] > Z)
                        ones++;
                    if (ones > s) {
                        ones = -1;
                        break;
                    }
                }
                if (ones == s) {
                    cout << Z;
                    return 0;
                }
            }
        } else {
            for (int Z1 = 0; Z1 < m; ++Z1) {
                for (int Z2 = 0; Z2 < m; ++Z2) {
                    int ones = 0;
                    for (int i = 0; i < m; ++i) {
                        if (bm[i][0].op == 1)
                            ones += ((x[i][0] > Z1) & (x[i][1] > Z2))
                        ones++;
                        if (ones > s) {
                            ones = -1;
                            break;
                        }
                    }
                    if (ones == s) {
                        cout << Z1 << ' ' << Z2;
                        return 0;
                    }
                }
            }
        }
    }
    return 0;
}