// Как же прекрасно не уметь читать и 1.5 часа решать другую задачу...

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <set>

using namespace std;

typedef int64_t ll;
typedef long double ld;

const ll INF = (ll)1e17 + 666;

struct Program {
    vector<ll> a;
    vector<ll> b;
    vector<ll> op;

    Program(ll n) {
        a.resize(n - 1);
        b.resize(n - 1);
        op.resize(n - 1);
    }
};

istream& operator >>(istream& in, Program& program) {
    for (ll i = 0; i < (ll)program.a.size(); ++i) {
        in >> program.a[i] >> program.b[i] >> program.op[i];
        --program.a[i];
        --program.b[i];
    }
    return in;
}

ll n, m, s;
vector<vector<ll>> arr;
vector<vector<ll>> t;
vector<Program> p;

ll f() {
    ll result = 0;
    vector<ll> v(2 * n - 1);
    for (ll i = 0; i < m; ++i) {
        for (ll j = 0; j < n; ++j) {
            v[j] = t[i][j];
        }
        for (ll j = n; j < 2 * n - 1; ++j) {
            ll a = p[i].a[j - n];
            ll b = p[i].b[j - n];
            ll op = p[i].op[j - n];
            if (op == 1) {
                v[j] = v[a] & v[b];
            }
            if (op == 2) {
                v[j] = v[a] | v[b];
            }
        }
        result += v.back();
    }
    return result;
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    cin >> n >> m >> s;
    p.resize(m, n);
    arr.resize(m, vector<ll>(n));
    t.resize(m, vector<ll>(n));
    for (ll i = 0; i < m; ++i) {
        cin >> p[i];
    }
    for (ll i = 0; i < m; ++i) {
        for (ll j = 0; j < n; ++j) {
            cin >> arr[i][j];
        }
    }
    ll left = 0;
    ll right = n + 1;
    while (right - left > 1) {
        ll mid = left + right >> 1;
        for (ll i = 0; i < m; ++i) {
            for (ll j = 0; j < mid; ++j) {
                t[i][j] = 1;
            }
            for (ll j = mid; j < n; ++j) {
                t[i][j] = 0;
            }
        }
        ll value = f();
        if (value <= s) {
            left = mid;
        } else {
            right = mid;
        }
    }
    ll pref = left;
    if (right == n + 1) {
        for (ll i = 0; i < n; ++i) {
            cout << m << " ";
        }
        cout << endl;
        return 0;
    }
    left = 0;
    right = m;
    while (right - left > 1) {
        ll mid = left + right >> 1;
        for (ll i = 0; i < m; ++i) {
            for (ll j = 0; j < pref; ++j) {
                t[i][j] = 1;
            }
            for (ll j = pref + 1; j < n; ++j) {
                t[i][j] = 0;
            }
        }
        for (ll i = 0; i < m; ++i) {
            t[i][pref] = arr[i][pref] < mid;
        }
        ll value = f();
        if (value <= s) {
            left = mid;
        } else {
            right = mid;
        }
    }
    for (ll i = 0; i < pref; ++i) {
        cout << m << " ";
    }
    cout << left << " ";
    for (ll i = pref + 1; i < n; ++i) {
        cout << 0 << " ";
    }
    cout << endl;
    return 0;
}

/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1
*/