// Мария Радионова - гений

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <set>

using namespace std;

typedef int64_t ll;
typedef long double ld;

const ll INF = (ll)(8e18) + 666;

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    ll n;
    cin >> n;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    a.emplace_back(INF);
    ll q;
    cin >> q;
    vector<ll> b(q);
    vector<ll> index(q);
    vector<pair<ll, ll>> result(q);

    for (ll i = 0; i < q; ++i) {
        cin >> b[i];
        index[i] = i;
    }
    sort(index.begin(), index.end(), [&](ll x, ll y) {
        return b[x] < b[y];
    });

    ll sum = 0;
    ll res = 0;
    ll ptr = 0;
    for (ll i : index) {
        while (true) {
            ll left = 0;
            ll right = ((a[ptr + 1] - sum) + a[ptr] - 1) / a[ptr];
            while (right - left > 1) {
                ll mid = left + right >> 1;
                if (sum + a[ptr] * mid <= b[i]) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            sum += a[ptr] * left;
            res += left;
            if (sum + a[ptr] >= a[ptr + 1]) {
                ++ptr;
            } else {
                break;
            }
        }
        result[i] = make_pair(sum, res);
    }

    for (auto i : result) {
        cout << i.first << " " << i.second << "\n";
    }

    return 0;
}
