#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
using namespace std;

const int N = 1e3, M = 1e3;

int m, n, s, z[500000];
vector<vector<int>> a, b, op, x;

void f(int it) {
    if (it == n) {
        int cnt1 = 0;
        for (int i = 0; i < m; i++) {
            vector<int> np(2 * n - 1);
            for (int p = 0; p < n; p++) {
                np[p] = x[i][p] < z[p];
            }
            for (int p = 0; p < n - 1; p++) {
                np[n + p] = (op[i][p] == 1 ?
                             np[a[i][p]] & np[b[i][p]] :
                             np[a[i][p]] | np[b[i][p]]);
            }
            cnt1 += np.back();
            if (cnt1 > s) {
                return;
            }
        }
        if (cnt1 == s) {
            for (int x = 0; x < n; x++) {
                cout << z[x] << ' ';
            }
            exit(0);
        }
        return;
    }
    for (int zz = m; zz >= 0; zz--) {
        z[it] = zz;
        f(it + 1);
    }
}

int check() {
    int cnt1 = 0;
    for (int i = 0; i < m; i++) {
        vector<int> np(2 * n - 1);
        for (int p = 0; p < n; p++) {
            np[p] = x[i][p] < z[p];
        }
        for (int p = 0; p < n - 1; p++) {
            np[n + p] = (op[i][p] == 1 ?
                         np[a[i][p]] & np[b[i][p]] :
                         np[a[i][p]] | np[b[i][p]]);
        }
        cnt1 += np.back();
    }
    return cnt1;
}

void solve(int lf, int rg, int minimum) {
    int mid = (lf + rg) / 2;
    int l0 = minimum - 1, r0 = m;
    while (l0 + 1 < r0) {
        int mid0 = (l0 + r0) / 2;
        for (int iter = 1; iter <= 1; iter++) {
            int l1 = minimum - 1, r1 = m, z0 = mid0;
            for (int i = lf; i <= mid; i++) {
                z[i] = mid0;
            }
            for (int i = mid + 1; i <= rg; i++) {
                z[i] = m;
            }
            if (check() >= s) {
                r0 = mid0;
                while (l1 + 1 < r1) {
                    int mid1 = (l1 + r1) / 2;
                    for (int i = mid + 1; i <= rg; i++) {
                        z[i] = mid1;
                    }
                    if (check() >= s) {
                        r1 = mid1;
                    } else {
                        l1 = mid1;
                    }
                }
                for (int i = mid + 1; i <= rg; i++) {
                    z[i] = r1;
                }
                if (check() == s) {
                    for (int i = 0; i < n; i++) {
                        cout << z[i] << ' ';
                    }
                    exit(0);
                }
            } else {
                l0 = mid0;
            }
        }
    }
    int must_r = r0;
    int l1 = minimum - 1, r1 = m, z0 = r0;
    for (int iter = 1; iter <= 1; iter++) {
        for (int i = lf; i <= mid; i++) {
            z[i] = r0;
        }
        for (int i = mid + 1; i <= rg; i++) {
            z[i] = m;
        }
        if (check() >= s) {
            while (l1 + 1 < r1) {
                int mid1 = (l1 + r1) / 2;
                for (int i = mid + 1; i <= rg; i++) {
                    z[i] = mid1;
                }
                if (check() >= s) {
                    r1 = mid1;
                } else {
                    l1 = mid1;
                }
            }
            for (int i = mid + 1; i <= rg; i++) {
                z[i] = r1;
            }
            if (check() == s) {
                for (int i = 0; i < n; i++) {
                    cout << z[i] << ' ';
                }
                exit(0);
            }
        }
    }
    solve(lf, mid, must_r);
    solve(mid + 1, rg, r1);
}

void PUNKS_NOT_DEAD() {
    cin >> n >> m >> s;
    a.resize(m, vector<int>(n - 1));
    b.resize(m, vector<int>(n - 1));
    op.resize(m, vector<int>(n - 1));
    x.resize(m, vector<int>(n));
    bool goodand = true;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];
            a[i][j]--, b[i][j]--;
            if (op[i][j] != 1) {
                goodand = false;
            }
        }
    }
    bool goodxij = true;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            cin >> x[i][j];
            if (x[i][j] != i) {
                goodxij = false;
            }
        }
    }
    if (s == 0) {
        for (int i = 0; i < n; i++) {
            cout << 0 << ' ';
        }
        exit(0);
    }
    solve(0, n - 1, 1);
    exit(0);
    if (n == 2 && m <= 100000) {
        int l0 = 0, r0 = m;
        while (l0 + 1 < r0) {
            int mid0 = (l0 + r0) / 2;
            for (int iter = 1; iter <= 1; iter++) {
                int l1 = 0, r1 = m, z0 = mid0;
                z[0] = z0;
                z[1] = r1;
                if (check() >= s) {
                    r0 = mid0;
                    while (l1 + 1 < r1) {
                        int mid = (l1 + r1) / 2;
                        z[0] = z0;
                        z[1] = mid;
                        if (check() >= s) {
                            r1 = mid;
                        } else {
                            l1 = mid;
                        }
                    }
                    z[0] = z0;
                    z[1] = r1;
                    if (check() == s) {
                        cout << z0 << ' ' << r1;
                        exit(0);
                    }
                } else {
                    l0 = mid0;
                }
            }
        }
        int l1 = 0, r1 = m, z0 = r0;
        z[0] = z0;
        z[1] = r1;
        if (check() >= s) {
            while (l1 + 1 < r1) {
                int mid = (l1 + r1) / 2;
                z[0] = z0;
                z[1] = mid;
                if (check() >= s) {
                    r1 = mid;
                } else {
                    l1 = mid;
                }
            }
            z[0] = z0;
            z[1] = r1;
            if (check() == s) {
                cout << z0 << ' ' << r1;
                exit(0);
            }
        }
        exit(0);
        vector<int> open2[2000];
        for (int i = 0; i < m; i++) {
            for (int j = 1; j < n; j++) {
                open2[x[i][j] + 1].push_back(i);
            }
        }
        vector<int> np(2 * n - 1);
        for (int z0 = 0; z0 <= m; z0++) {
            int cnt1 = 0;
            for (int z1 = 0; z1 <= m; z1++) {
                z[0] = z0;
                z[1] = z1;
                for (auto iter : open2[z1]) {
                    np[0] = x[iter][0] < z[0];
                    np[1] = x[iter][1] < z[1];
                    int p = 0;
                    np[n + p] = (op[iter][p] == 1 ?
                                 np[a[iter][p]] & np[b[iter][p]] :
                                 np[a[iter][p]] | np[b[iter][p]]);
                    cnt1 += np[2];
                }
                if (cnt1 == s) {
                    cout << z0 << ' ' << z1;
                    exit(0);
                }
            }
        }
    } else if (goodxij) {
        for (int z = 0; z < n; z++) {
            cout << s << ' ';
        }
    } else if (goodand) {
        set<pair<int, int>> st;
        vector<pair<int, int>> mx(m, pair<int, int>(-1, -1));
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                mx[i] = max(mx[i], {x[i][j], j});
            }
            st.insert(mx[i]);
        }
        vector<int> ans(n, m);
        while (st.size() != s) {
            auto [mx, who] = *prev(st.end());
            st.erase(prev(st.end()));
            ans[who] = mx;
        }
        for (auto x : ans) {
            cout << x << ' ';
        }
    } else if (n <= 100) {
        solve(0, n - 1, 1);
    }
    else {
        f(0);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    PUNKS_NOT_DEAD();
}