#pragma optimize ("O3,Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma target ("sse,sse2,sse3,ssse3,sse4,avx,amx,abx,av2,tune=native")
#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
using namespace std;

int m, n, s, z[500000], np[700000];
vector<vector<int>> a, b, op, x;

int check() {
    int cnt1 = 0;
    for (int i = 0; i < m; i++) {
        for (int p = 0; p < n; p++) {
            np[p] = x[i][p] < z[p];
        }
        for (int p = 0; p < n - 1; p++) {
            np[n + p] = (op[i][p] == 1 ?
                         np[a[i][p]] & np[b[i][p]] :
                         np[a[i][p]] | np[b[i][p]]);
        }
        cnt1 += np[2 * n - 2];
    }
    return cnt1;
}

void solve(int lf, int rg, int minimum) {
    int mid = (lf + rg) / 2;
    int l0 = minimum - 1, r0 = m;
    while (l0 + 1 < r0) {
        int mid0 = (l0 + r0) / 2;
        int l1 = minimum - 1, r1 = m, z0 = mid0;
        for (int i = lf; i <= mid; i++) {
            z[i] = mid0;
        }
        for (int i = mid + 1; i <= rg; i++) {
            z[i] = m;
        }
        if (check() >= s) {
            r0 = mid0;
            while (l1 + 1 < r1) {
                int mid1 = (l1 + r1) / 2;
                for (int i = mid + 1; i <= rg; i++) {
                    z[i] = mid1;
                }
                if (check() >= s) {
                    r1 = mid1;
                } else {
                    l1 = mid1;
                }
            }
            for (int i = mid + 1; i <= rg; i++) {
                z[i] = r1;
            }
            if (check() == s) {
                for (int i = 0; i < n; i++) {
                    cout << z[i] << ' ';
                }
                exit(0);
            }
        } else {
            l0 = mid0;
        }
    }
    int must_r = r0;
    int l1 = minimum - 1, r1 = m, z0 = r0;
    for (int i = lf; i <= mid; i++) {
        z[i] = r0;
    }
    for (int i = mid + 1; i <= rg; i++) {
        z[i] = m;
    }
    if (check() >= s) {
        while (l1 + 1 < r1) {
            int mid1 = (l1 + r1) / 2;
            for (int i = mid + 1; i <= rg; i++) {
                z[i] = mid1;
            }
            if (check() >= s) {
                r1 = mid1;
            } else {
                l1 = mid1;
            }
        }
        for (int i = mid + 1; i <= rg; i++) {
            z[i] = r1;
        }
        if (check() == s) {
            for (int i = 0; i < n; i++) {
                cout << z[i] << ' ';
            }
            exit(0);
        }
    }
    solve(lf, mid, must_r);
    solve(mid + 1, rg, r1);
}

void PUNKS_NOT_DEAD() {
    cin >> n >> m >> s;
    a.resize(m, vector<int>(n - 1));
    b.resize(m, vector<int>(n - 1));
    op.resize(m, vector<int>(n - 1));
    x.resize(m, vector<int>(n));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];
            a[i][j]--, b[i][j]--;
        }
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            cin >> x[i][j];
        }
    }
    if (s == 0) {
        for (int i = 0; i < n; i++) {
            cout << 0 << ' ';
        }
        exit(0);
    }
    solve(0, n - 1, 1);
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    PUNKS_NOT_DEAD();
}