#include <iostream>
#include <map>
#include <algorithm>
#include <vector>

using namespace std;

struct counter{
    map<int, int> cnt;
    int c = 0;

    void add(int v){
        cnt[v]++;
        c += (cnt[v] == 1);
    }

    void red(int v){
        cnt[v]--;
        c -= (cnt[v] == 0);
    }

    int get(){
        return c;
    }

};

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    for (int len = 1; len <= n; len++){
        counter c;
        int cur = 0;
        for (int i = 0; i < len; i++){
            c.add(a[i]);
        }
        cur += c.get();
        for (int i = len; i < n; i++){
            c.add(a[i]);
            c.red(a[i - len]);
            cur += c.get();
        }
        cout << cur << ' ';
    }
    cout << "\n";
    return 0;
}
