#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;


vector<pair<int, int> > solve(vector<int> &x, vector<int> & a){
    int n = a.size();
    int sum = 0;
    int cnt = 0;
    int pos = 0;
    vector<pair<int, int> > ans;
    for (int i = 0; i < n - 1; i++){
        int nx = a[i + 1] - 1;
        int d = nx - sum;
        int sum1 = sum + (d / a[i]) * a[i];
        int cnt1 = cnt + (d / a[i]);
        while (pos < x.size() && x[pos] < sum1){
            int nx1 = x[pos];
            int d1 = nx1 - sum;
            int sup = (d1 / a[i]);
            int sum2 = sum + sup * a[i];
            int cnt2 = cnt + sup;
            ans.push_back({sum2, cnt2});
            pos++;
        }
        sum = sum1;
        cnt = cnt1;
    }
    while (pos < x.size()){
        if (sum + a[n - 1] <= x[pos]){
            int d = (x[pos] - sum);
            int sum1 = sum + (d / a[n - 1]) * a[n - 1];
            int cnt1 = cnt + (d / a[n - 1]);
            ans.push_back({sum1, cnt1});
        }else{
            ans.push_back({sum, cnt});
        }
        pos++;
    }
    return ans;
}

signed main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }

    int q;
    cin >> q;
    vector<int> b(q);
    for (int i = 0; i < q; i++){
        cin >> b[i];

    }
    vector<pair<int, int> > sup;
    for (int i = 0; i < q; i++){
        sup.push_back({b[i], i});
    }
    sort(sup.begin(), sup.end());
    vector<int> x;
    for (auto i : sup){
        x.push_back(i.first);
    }
    vector<pair<int, int> > ans = solve(x, a);
    vector<pair<int, int> > answer(q);
    for (int i = 0; i < q; i++){
        answer[sup[i].second] = ans[i];
    }
    for (int i = 0; i < q; i++){
        cout << answer[i].first << ' ' << answer[i].second << "\n";
    }
    return 0;
}
