#include <iostream>
#include <vector>

using namespace std;



int n;
vector<int> a;

bool check(int mask){
    vector<int> s;
    for (int i = 0; i < n; i++){
        s.push_back(((mask >> i) & 1));
    }
    for (int i = 0; i < n; i++){
        int nx1 = (i + 1) % n;
        int nx2 = (i + 2) % n;
        int nx3 = (i + 3) % n;
        if (s[i] && s[nx1] && s[nx2] && s[nx3]){
            return true;
        }
    }
    return false;
}

int get(){
    int ans = 0;
    for (int mask = 0; mask < (1 << n); mask++){
        if (check(mask)){
            continue;
        }
        int cur = 0;
        for (int i = 0; i < n; i++){
            cur += (a[i] * ((mask >> i) & 1));
        }
        ans = max(ans, cur);
    }
    return ans;
}

int main()
{
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    cout << get() << "\n";
    int q;
    cin >> q;
    for (int i = 0; i < q; i++){
        int pos, val;
        cin >> pos >> val;
        pos--;
        a[pos] = val;
        cout << get() << "\n";
    }

    return 0;
}
