#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long I;

int main() {
    I n, len2, dis2, sid2, result, d = 0;
    cin >> n;
    vector<I> as(n);
    vector<pair<I, I>> ps(n);
    vector<I> diffs(n, 0);
    for (I i = 0; i < n; ++i) {
        cin >> as[i];
        ps[i] = {as[i], i};
    }

    sort(ps.begin(), ps.end());
    for (I i = 0; i < n - 1; ++i) {
        if (ps[i].first != ps[i + 1].first) {
            continue;
        }
        len2 = ps[i + 1].second - ps[i].second - 1;
        dis2 = min(n - ps[i].second, ps[i + 1].second + 1) - 1;
        sid2 = max(n - ps[i].second, ps[i + 1].second + 1) - 1;
        ++diffs[len2];
        --diffs[dis2];
        --diffs[sid2];
    }

    for (I i = 1; i < n; ++i) {
        diffs[i] += diffs[i - 1];
    }
    for (I i = 1; i < n; ++i) {
        diffs[i] += diffs[i - 1];
    }

    for (I i = 0; i < n; ++i) {
        if (i == 0) {
            cout << n;
        } else {
            result = (n - i) * (i + 1) - diffs[i - 1];
            cout << result;
        }
        if (i < n - 1) {
            cout << " ";
        }
    }
    cout << endl;
    return 0;
}