#include <iostream>
#include <map>
#include <vector>
#include <cmath>
using namespace std;
typedef long long I;

pair<I, I> process(I num, map<I, pair<I, I>>& costs, bool isN) {
    if (num == 0) {
        return {0, 0};
    }
    auto pos = costs.lower_bound(num);
    if (pos == costs.end() || pos->first > num) {
        --pos;
    }
    if (pos->first == num) {
        return pos->second;
    }
    //cout << num;
    if (isN) {
        --num;
    }
    //cout << " " << num << endl;
    I takesIn = num / pos->first;
    I rest = num % pos->first;
    I ifLeave = (takesIn - 1) + pos->second.second;
    auto ifFull = process(rest, costs, false);
    if (ifLeave >= ifFull.second + takesIn) {
        return {(takesIn - 1) * pos->first + pos->second.first, ifLeave};
    } else {
        return {ifFull.first + takesIn * pos->first, ifFull.second + takesIn};
    }
}

int main() {
    I n, q, b;
    cin >> n;
    vector<I> as(n);
    map<I, pair<I, I>> costs;
    for (I i = 0; i < n; ++i) {
        cin >> as[i];
    }

    costs.insert({1, {1, 1}});
    for (I i = 1; i < n; ++i) {
        costs.insert({as[i], process(as[i], costs, true)});
    }
    /*for (auto x : costs) {
        cout << x.first << " " << x.second.first << " " << x.second.second << endl;
    }*/
    cin >> q;
    for (I i = 0; i < q; ++i) {
        cin >> b;
        auto res = process(b, costs, false);
        cout << res.first << " " << res.second << endl;
    }
    return 0;
}