#include<bits/stdc++.h>
#define int long long
#define pb push_back
#define ld long double
const int inf = 1e16;

using namespace std;

int n;
vector<int> a;
vector<int> dp;
vector<int> pr;

vector<int> bestp;

void relax(int &an, int b, int i, int p) {
	if (b > an) {
		an = b;
		pr[i] = p;
	}
}

void relaxans(int &an, int b) {
	int d = 0;
	int best = -inf;
	int num = 0;
	for (int i = 1; i <= b; i++) {
		if (dp[n - i] + d > best) {
			num = i;
			best = dp[n - i] + d;
		}
		d += a[n - i];
	}
	if (best > an) {
		an = best;
		bestp.resize(0);
		d = n - num;
		while(d != -1) {
			bestp.pb(d);
			d = pr[d];
		}
	}
}


void full(){
	for (int i = 4; i < n; i++) {
		dp[i] = 0;
		relax(dp[i], dp[i - 1], i, i - 1);
		relax(dp[i], dp[i - 2] + a[i - 1], i, i - 2);
		relax(dp[i], dp[i - 3] + a[i - 1] + a[i - 2], i, i - 3);
		relax(dp[i], dp[i - 4] + a[i - 1] + a[i - 2] + a[i - 3], i, i - 4);
	}
}

int ansver() {
	int ans = 0;

	dp[0] = 0;
	dp[1] = -inf;
	dp[2] = -inf;
	dp[3] = a[1] + a[2];
	pr[0] = -1;
	pr[3] = 0;
	full();
	relaxans(ans, 4);

	dp[0] = -inf;
	dp[1] = a[0];
	dp[2] = -inf;
	dp[3] = a[0] + a[2];

	pr[1] = -1;
	pr[3] = 1;
	full();
	relaxans(ans, 3);

	dp[0] = -inf;
	dp[1] = -inf;
	dp[2] = a[0] + a[1];
	dp[3] = a[0] + a[1];
	pr[2] = -1;
	pr[3] = 2;
	full();
	relaxans(ans, 2);

	dp[0] = 0;
	dp[1] = 0;
	dp[2] = -inf;
	dp[3] = a[2];
	pr[0] = -1;
	pr[1] = 0;
	pr[3] = 1;
	full();
	relaxans(ans, 4);

	dp[0] = 0;
	dp[1] = -inf;
	dp[2] = a[1];
	dp[3] = a[1];
	pr[0] = -1;
	pr[2] = 0;
	pr[3] = 2;
	full();
	relaxans(ans, 4);

	dp[0] = -inf;
	dp[1] = a[0];
	dp[2] = a[0];
	dp[3] = a[0];
	pr[1] = -1;
	pr[2] = 1;
	pr[3] = 2;
	full();
	relaxans(ans, 3);

	dp[0] = -inf;
	dp[1] = -inf;
	dp[2] = -inf;
	dp[3] = a[0] + a[1] + a[2];
	pr[3] = -1;
	full();
	relaxans(ans, 1);

	return ans;
}

signed main() {
	cin >> n;
	a.resize(n);
	dp.resize(n);
	pr.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int ans = ansver();
	cout << ans << '\n';
	int q;
	cin >> q;
	int p, u;
	
	for (int i = 0; i < q; i++) {
		cin >> p >> u;
		p--;
		int left = -1;
		int right = bestp.size();
		while (left + 1 < right) {
			int m = (left + right) / 2;
			if (bestp[m] >= p) {
				left = m;
			} else {
				right = m;
			}
		}
		if (left == -1 || bestp[left] != p) {
			// нет в пустых
			if (u >= a[p]) {
				ans += u - a[p];
				a[p] = u;
			} else {
				a[p] = u;
				ans = ansver();
			}
		} else {
			if (u <= a[p]) {
				a[p] = u;
			} else {
				a[p] = u;
				ans = ansver();
			}
		}

		cout << ans << '\n';
	}
}

/*
g++ a_test.cpp -std=c++11 -O2 -Wall -Wextra -oa_test
&& time ./a_test
*/