#include <iostream>
#include <vector>
#include <deque>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <cmath>
using namespace std;
using ll = long long;

int main() {
    cout.tie(0);
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;
    vector<int> tasks(n);
    for (int i = 0; i < n; i++) {
        cin >> tasks[i];
    }
    vector<int> profile(n);
    for (int i = 1; i <= n; i++) {
        int v = 0;
        for (int start = 0; start <= n - i; start++) {
            set<int> va;
            for (int j = start; j < start + i; j++) {
                va.insert(tasks[j]);
            }
            v += va.size();
        }
        profile[i - 1] = v;
    }
    for (auto now : profile) cout << now << ' ';
}