#include <iostream>
#include <vector>
#include <deque>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <cmath>
using namespace std;
using ull = unsigned long long;

int main() {
    ull n;
    cin >> n;
    vector<ull> a(n), p(n);
    cin >> a[0];
    p[0] = a[0];
    for (int i = 1; i < n; i++) {
        cin >> a[i];
        p[i]= a[i] + p[i - 1];
    }

    int needi = 0, maxp = 0;

    for (int i = 0; i < n; i++) {
        ull curp = p[i] * (p[n - 1] - p[i]);
//        cerr << "If we cut after element #" << i + 1 << ", then result will be " << curp << '\n';
        if (curp >= maxp) {
//            cerr << "Which seems to be >= " << maxp << "\n\n";
            maxp = curp;
            needi = i;
        }
    }
    cout << needi + 1;
    return 0;
}