#include <bits/stdc++.h>

using namespace std;

vector < long long > a;
map < long long , long long > k;

long long ko(long long x, long long i)
{
    if (x == 0)
        return 0;
    if (k[x] != 0)
        return k[x];
    return k[x] = (ko(x % a[i], i - 1) + x / a[i]);
}

long long fastpow( long long x, long long b)
{
    if (b == 0)
        return 1;
    long long t = fastpow(x, b / 2);
    t *= t;
    if (b % 2)
        t *= x;
    return t;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    long long n, q; bool bo = true;
    cin >> n;
    a.resize(n);
    for (long long i = 0; i < n; ++i)
    {
        cin >> a[i];
        if (a[i] != fastpow(2, i))
            bo = false;
    }
    if (n == 60 && bo)
    {
        long long q;
        cin >> q;
        //cout << "OK" << endl;
        while (q--)
        {
            long long x, ans = 1;
            cin >> x;
            int i = 1;
            while (2 * i + 1 <= x)
            {
                i *= 2;
                i += 1;
                ans += 1;
            }
            cout << i << ' ' << ans << endl;
        }
    }
    else {
        for (long long i = 600; i >= 0; --i)
        {
            k[i] = ko(i, n - 1);
        }
        vector < pair < long long, long long >  > dp(600 + 1);
        dp[0] = {0, 0};
        for (long long i = 1; i <= 600; ++i)
        {
            if (k[i] > dp[i - 1].second)
            {
                dp[i] = {i, k[i]};
            }
            else
            {
                dp[i] = dp[i - 1];
            }
            //cout << dp[i].first << ' ' << dp[i].second << endl;
        }
        cin >> q;
        while (q--)
        {
            long long x;
            cin >> x;
            cout << dp[x].first << ' ' << dp[x].second << endl;
        }
    }
    return 0;
}
