#include <iostream>
#include <cmath>
#include <math.h>
#include <algorithm>
#include <vector>
#include <map>



using namespace std;
vector<int>a; int n;
long long count() {
	vector<vector<vector<long long>>> dp(n, vector<vector<long long>>(4, vector<long long>(4, 0)));
	dp[0][1][1] = a[0];
	for (int i = 1; i < n; i++) {
		for (int end = 0; end < 4; end++) {
			for (int start = 0; start < 4; start++) {
				if (end == 0) {
					dp[i][end][start] = max({ dp[i - 1][0][start], dp[i - 1][1][start], dp[i - 1][2][start], dp[i - 1][3][start] });
				}
				else dp[i][end][start] = dp[i - 1][end - 1][start] + a[i];
			}
		}
	}
	long long ans;
	for (int end = 0; end < 4; end++) {
		for (int start = 0; start < 4 - end; start++) {
			ans = max(ans, dp[n - 1][end][start]);
		}
	}
	return ans;
}

int main() {
	int q, j, x;
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	cout << count()<<endl;
	cin >> q;
	for (int i = 0; i < q; i++) {
		cin >> j >> x;
		a[j - 1] = x;
		cout << count()<<endl;
	}
	
}
