#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;
constexpr ll inf = ll(1e18);

int main()
{
	int n = 0;
	cin >> n;

	vector <ll> l(n), v(n);
	for (int i = 0; i < n; ++i)
		cin >> v[i];
	for (int i = 0; i < n; ++i)
		cin >> l[i];

	int m = 0;
	cin >> m;
	vector <ll> a(m + 1), f(m + 1);
	for (int i = 1; i < m; ++i)
		cin >> a[i];
	for (int i = 1; i <= m; ++i)
		cin >> f[i];
	a[0] = f[0] = 0;
	a.back() = inf;

	vector <ld> times(m + 1);
	for (int i = 0; i <= m; ++i)
		for (int j = 0; j < n; ++j)
			times[i] += ld(l[j]) / ld(v[j] + a[i]);

	int q = 0;
	cin >> q;

	while (q--)
	{
		int st = 0, en = 0;
		cin >> st >> en;
		ld t = en - st;

		if (t >= times[0])
		{
			cout << "0\n";
			continue;
		}

		int left = 0, right = m;
		while (right - left > 1)
		{
			int middle = (left + right) >> 1;
			if (t >= times[middle])
				right = middle;
			else
				left = middle;
		}

		cout << f[right] << '\n';
	}
}