#include <iostream>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

void add(int x, vector <int>& used, int& cnt)
{
	if (!used[x])
		++cnt;

	++used[x];
}

void del(int x, vector <int>& used, int& cnt)
{
	--used[x];

	if (!used[x])
		--cnt;
}

int main()
{
	int n = 0;
	cin >> n;
	vector <int> arr(n), val(n);
	for (int i = 0; i < n; ++i)
	{
		int buf = 0;
		cin >> buf;
		arr[i] = buf;
		val[i] = buf;
	}

	sort(val.begin(), val.end());
	val.resize(unique(val.begin(), val.end()) - val.begin());
	map <int, int> match;
	for (int i = 0; i < val.size(); ++i)
		match[val[i]] = i;
	for (int i = 0; i < n; ++i)
		arr[i] = match[arr[i]];

	vector <int> ans = { n };
	for (int len = 2; len <= n; ++len)
	{
		vector <int> used(val.size());
		int cnt = 0, r = 0;
		while (r < len)
			add(arr[r++], used, cnt);

		ans.push_back(cnt);
		while (r < n)
		{
			del(arr[r - len], used, cnt);
			add(arr[r++], used, cnt);
			ans.back() += cnt;
		}
	}

	for (int x : ans)
		cout << x << ' ';

	return 0;
}