#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, x = 0;
	cin >> n >> x;

	ll ans = 0;
	for (int a = 1; a <= n; ++a)
	{
		for (int b = 1; b <= n + 1 - a; ++b)
		{
			int area = a * b - n;
			if (a == x || b == x)
				continue;
			if (area <= 0)
				continue;

			for (int div = 1; div * div <= area; ++div)
			{
				if (area % div != 0)
					continue;

				int fraction = area / div;

				if (div < a && fraction < b)
					++ans;
				if (div < b && fraction < a && div != fraction)
					++ans;
			}
		}
	}

	cout << ans;

	return 0;
}