#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;
using ll = long long;

int main()
{
	int n = 0;
	cin >> n;

	vector <ll> a(n);
	bool binary = true;
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
		
		if (a[i] != (1 << i))
			binary = false;
	}
	reverse(a.begin(), a.end());

	int q = 0;
	cin >> q;

	if (binary)
	{
		while (q--)
		{
			ll b = 0;
			cin >> b;

			ll k = floorl(log2(b + 1));
			cout << (1 << k) - 1 << ' ' << k << '\n';
		}
	}

	while (q--)
	{
		ll b_max = 0;
		cin >> b_max;

		ll max_cnt = 0, ans_b = 0;
		for (int b = 1; b <= b_max; ++b)
		{
			ll cnt = 0, b_buf = b;
			for (int i = 0; i < n; ++i)
			{
				cnt += b_buf / a[i];
				b_buf %= a[i];
			}

			if (cnt > max_cnt)
			{
				max_cnt = cnt;
				ans_b = b;
			}
		}

		cout << ans_b << ' ' << max_cnt << '\n';
	}

	return 0;
}