#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	vector <ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	a.push_back(ll(2e18));

	int q = 0;
	cin >> q;

	while (q--)
	{
		ll b = 0;
		cin >> b;

		ll current = 0, cnt = 0;
		for (int i = 0; i < n; ++i)
		{
			ll ncur = min(b, a[i + 1] - 1);
			ll add = (ncur - current) / a[i];
			if (add <= 0)
				break;

			cnt += add;
			current += add * a[i];
		}

		cout << current << ' ' << cnt << '\n';
	}

	return 0;
}