#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF = 2e18 + 109;

vector<int> v;
int n;

bool check1() {
    for (int i = 0; i < n; i++) {
        if (v[i] != (1 << i)) {
            return false;
        }
    }
    return true;
}


int steps(int b) {
    int st = 0;
    for (int i = n - 1; i >= 0; i--) {
        if (!b) {
            break;
        }
        st += b / v[i];
        b %= v[i];
    }
    return st;
}


signed main() {
    cin.tie(NULL);

    cin >> n;

    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    int q;
    cin >> q;

    if (check1()) {
        while (q--) {
            int b;
            cin >> b;

            int max_steps = -INF, sum;
            for (int i = 0; i <= 60; i++) {
                int x = (1 << i) - 1;
                if (x > b) {
                    break;
                }
                int tmp = steps(x);
                if (tmp > max_steps) {
                    max_steps = tmp;
                    sum = x;
                }
                tmp = steps(b);
                if (tmp > max_steps) {
                    max_steps = tmp;
                    sum = b;
                }
            }
            cout << sum << " " << max_steps << "\n";
        }
        return 0;
    }

    while (q--) {
        int b;
        cin >> b;

        int max_steps = -INF, sum;
        for (int i = 1; i <= b; i++) {
            int tmp = steps(i);
            if (tmp > max_steps) {
                max_steps = tmp;
                sum = i;
            }
        }
        cout << sum << " " << max_steps << "\n";
    }
    return 0;
}
