#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF = 2e18 + 109;

vector<int> v;
int n;

bool check1() {
    for (int i = 0; i < n; i++) {
        if (v[i] != (1ll << i)) {
            return false;
        }
    }
    return true;
}


int steps(int b) {
    int st = 0, bord = n;
    while (b > 0) {
        int l = 0, r = bord, m;
        while (l + 1 < r) {
            m = (l + r) / 2;
            if (b >= v[m]) {
                l = m;
            } else {
                r = m;
            }
        }
        st += b / v[l];
        b %= v[l];
        bord = l;
    }
    return st;
}


signed main() {
    cin.tie(NULL);

    cin >> n;

    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    int q;
    cin >> q;

    if (n == 60 && check1()) {
        while (q--) {
            int b;
            cin >> b;

            int pow;
            for (pow = 60; (1ll << pow) - 1 > b; pow--) {}
            cout << (1ll << pow) - 1 << " " << pow << "\n";
        }
        return 0;
    }

    while (q--) {
        int b;
        cin >> b;

        int max_steps = -INF, sum;//
        for (int i = b - 1; i <= b; i++) {
            int tmp = steps(i);
            if (tmp > max_steps) {
                max_steps = tmp;
                sum = i;
            }
        }
        cout << sum << " " << max_steps << "\n";
    }

    return 0;
}

