#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

//#include <string>
#include <set>
//#include <unordered_set>
//#include <map>
//#include <unordered_map>
//#include <bitset>

///#pragma GCC optimize("Ofast")
#define all(a) a.begin(), a.end()
#define int long long
#define ft first
#define sd second

using namespace std;

void fast_IO() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

const int INF = 1e18;
const int DEBUG = 0;

int n;
vector<int> a;

void szh() {
    vector<pair<int, int>> a1(n);
    for (int i = 0; i < n; ++i) {
        a1[i].ft = a[i];
        a1[i].sd = i;
    }
    sort(all(a1));
    int id = 0;
    for (int i = 0; i < n; ++i) {
        if (i != 0 && a1[i].ft != a1[i - 1].ft) {
            id++;
        }
        a[a1[i].sd] = id;
    }
}

vector<int> lst;
vector<int> l;
vector<int> r;

void init() {
    ///ifstream cin("test.in"); ofstream cout("test.out");
    ///fast_IO();
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    szh();
    lst.resize(n, -1);
    l.resize(n, -1);
    r.resize(n, n);
    ///cin.close(); cout.close();
}

signed main()
{
    ///ifstream cin("test.in"); ofstream cout("test.out");
    ///fast_IO();
    init();
    for (int i = 0; i < n; ++i) {
        l[i] = lst[a[i]];
        lst[a[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        lst[a[i]] = n;
    }
    /*
    for (int i = n - 1; i >= 0; --i) {
        r[i] = lst[a[i]];
        lst[a[i]] = i;
    }
    */
    if (DEBUG) {
        for (int i = 0; i < n; ++i) {
            cout << l[i] << " ";
        }
        cout << endl;
        for (int i = 0; i < n; ++i) {
            cout << r[i] << " ";
        }
        cout << endl;
    }

    vector<int> s;
    s.resize(n + 1);
    for (int i = 1; i <= n; ++i) {
        s[i] = i * (n - i + 1);
    }
    for (int i = 0; i < n; ++i) {
        if (l[i] != -1) {
            for (int len = i - l[i] + 1; len <= r[i]; ++len) {
                //cout << max((int)0, (min(l[i], r[i] - len) - max((int)0, i - len + 1) + 1)) << endl;
                s[len] -= max((int)0, (min(l[i], r[i] - len) - max((int)0, i - len + 1) + 1));
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        cout << s[i] << " ";
    }
    return 0;
    ///cin.close(); cout.close();
}
/*
5
1 3 2 1 2

3
10 10 10

*/
