#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

//#include <string>
//#include <set>
//#include <unordered_set>
//#include <map>
//#include <unordered_map>
//#include <bitset>

///#pragma GCC optimize("Ofast")
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;

void fast_IO() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

const int INF = 1e18;
const int DEBUG = 0;

const int MAXB = 2e5 + 10;

int n;
vector<int> a;
int q;
vector<int> b;

void init() {
    ///ifstream cin("test.in"); ofstream cout("test.out");
    ///fast_IO();
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    cin >> q;
    b.resize(q);
    for (int i = 0; i < q; ++i) {
        cin >> b[i];
    }
    ///cin.close(); cout.close();
}

void main1() {
    vector<int> dp(MAXB);
    vector<int> mx(MAXB);
    vector<int> val(MAXB);
    int id = 0;
    dp[0] = 0;
    mx[0] = 0;
    val[0] = 0;
    for (int i = 1; i < MAXB; ++i) {
        //cout << "OK" << endl;
        dp[i] = dp[i - a[id]] + 1;
        if (id < n - 1 && a[id + 1] <= i + 1) {
            id++;
        }
        val[i] = val[i - 1];
        mx[i] = mx[i - 1];
        if (dp[i] > mx[i]) {
            val[i] = i;
            mx[i] = dp[i];
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << val[b[i]] << " " << mx[b[i]] << endl;
    }
}

signed main()
{
    ///ifstream cin("test.in"); ofstream cout("test.out");
    ///fast_IO();
    init();
    bool smallb = 1;
    for (int i = 0; i < q; ++i) {
        if (b[i] >= MAXB) {
            smallb = 0;
        }
    }
    if (smallb) {
        main1();
        return 0;
    }

    for (int i = 0; i < q; ++i) {
        int val = 1;
        int cnt = 1;
        while (val * 2 < b[i]) {
            val *= 2;
            cnt++;
        }
        cout << val << " " << cnt << endl;
    }

    return 0;
    ///cin.close(); cout.close();
}


/*
4
1 5 10 50
3
2
8
50

*/
