#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

//#include <string>
//#include <set>
//#include <unordered_set>
//#include <map>
//#include <unordered_map>
//#include <bitset>

///#pragma GCC optimize("Ofast")
#define all(a) a.begin(), a.end()
#define int long long
#define ft first
#define sd second

using namespace std;

void fast_IO() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

const int INF = 1e18;
const int DEBUG = 0;

const int MAXB = 2e5 + 10;

int n;
vector<int> a;
int q;
vector<int> b;

void init() {
    ///ifstream cin("test.in"); ofstream cout("test.out");
    ///fast_IO();
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    cin >> q;
    b.resize(q);
    for (int i = 0; i < q; ++i) {
        cin >> b[i];
    }
    ///cin.close(); cout.close();
}

void main1() {
    vector<int> dp(MAXB);
    vector<int> mx(MAXB);
    vector<int> val(MAXB);
    int id = 0;
    dp[0] = 0;
    mx[0] = 0;
    val[0] = 0;
    for (int i = 1; i < MAXB; ++i) {
        //cout << "OK" << endl;
        dp[i] = dp[i - a[id]] + 1;
        if (id < n - 1 && a[id + 1] <= i + 1) {
            id++;
        }
        val[i] = val[i - 1];
        mx[i] = mx[i - 1];
        if (dp[i] > mx[i]) {
            val[i] = i;
            mx[i] = dp[i];
        }
    }
    for (int i = 0; i < q; ++i) {
        cout << val[b[i]] << " " << mx[b[i]] << endl;
    }
}

void main2() {
    for (int i = 0; i < q; ++i) {
        int val = 0;
        int cnt = 0;
        while ((val + 1) * 2 - 1 <= b[i]) {
            val = (val + 1) * 2 - 1;
            cnt++;
        }
        cout << val << " " << cnt << endl;
    }
}

void main3() {
    if (n == 1) {
        for (int i = 0; i < q; ++i) {
            cout << b[i] << " " << b[i] << endl;
        }
        return;
    }
    for (int i = 0; i < q; ++i) {
        if (b[i] < a[1]) {
            cout << b[i] << " " << b[i] << endl;
            continue;
        }
        int val = a[1] - 1;
        int cnt = a[1] - 1;
        int id = 1;
        while (id < n) {
            while (id < n - 1 && val + a[id] >= a[id + 1]) {
                id++;
            }
            if (id == n - 1) {
                cnt += (b[i] - val) / a[id];
                val += ((b[i] - val) / a[id]) * a[id];
                break;
            }
            int kol = min((b[i] - val) / a[id], (a[id + 1] - 1 - val) / a[id]);
            cnt += kol;
            val += a[id] * kol;
            id++;
        }
        cout << val << " " << cnt << endl;
    }
}

signed main()
{
    ///ifstream cin("test.in"); ofstream cout("test.out");
    ///fast_IO();
    init();
/*
    bool smallb = 1;
    for (int i = 0; i < q; ++i) {
        if (b[i] >= MAXB) {
            smallb = 0;
        }
    }
    if (smallb) {
        main1();
        return 0;
    }
    bool ai2 = 1;
    int val = 1;
    for (int i = 0; i < n; ++i) {
        if (a[i] != val) {
            ai2 = 0;
        }
        val *= 2;
    }
    if (ai2 && n == 60) {
        main2();
        return 0;
    }
    if (q <= 5) {
        main3();
        return 0;
    }
*/
    vector<pair<int, int>> b2(q);
    vector<pair<int, int>> ans(q);
    for (int i = 0; i < q; ++i) {
        b2[i] = {b[i], i};
    }
    sort(all(b2));

    if (n == 1) {
        for (int i = 0; i < q; ++i) {
            cout << b[i] << " " << b[i] << endl;
        }
        return 0;
    }

    int val = a[1] - 1;
    int cnt = a[1] - 1;
    int id = 1;

    for (int i = 0; i < q; ++i) {
        if (b2[i].ft < a[1]) {
            ans[b2[i].sd] = {b2[i].ft, b2[i].ft};
            continue;
        }
        while (id < n) {
            while (id < n - 1 && val + a[id] >= a[id + 1]) {
                id++;
            }
            if (id == n - 1) {
                cnt += (b2[i].ft - val) / a[id];
                val += ((b2[i].ft - val) / a[id]) * a[id];
                break;
            }
            int kol = min((b2[i].ft - val) / a[id], (a[id + 1] - 1 - val) / a[id]);

            cnt += kol;
            val += a[id] * kol;
            id++;
            if ((b2[i].ft - val) / a[id] == 0) {
                break;
            }
        }
        id--;
        ans[b2[i].sd] = {val, cnt};
    }
    for (int i = 0; i < q; ++i) {
        cout << ans[i].ft << " " << ans[i].sd << endl;
    }

    return 0;
    ///cin.close(); cout.close();
}


/*

4
1 3 12 15
4
11 22 9 5

6
1 2 12 17 25 34
3
46
42
3

4
1 5 10 50
3
2
8
50


4
1 8 9 30
45
76
75
48
47
46
40
39
38
37
36
35
34
33
32
31
30
29
28
27
26
25
24
23
22
21
20
19
18
17
16
15
14
13
12
11
10
9
8
7
6
5
4
3
2
1
*/
