#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

//#include <string>
//#include <set>
//#include <unordered_set>
//#include <map>
//#include <unordered_map>
//#include <bitset>

///#pragma GCC optimize("Ofast")
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;

void fast_IO() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

const int INF = 1e18;
const int DEBUG = 0;

int n;
vector<int> a;
int q;

void init() {
    ///ifstream cin("test.in"); ofstream cout("test.out");
    fast_IO();
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    cin >> q;
    ///cin.close(); cout.close();
}

int f(int x) {
    return (x + n) % n;
}

vector<int> dp;

void get() {
    int mx = 0;
    for (int id = 0; id < 4; ++id) {
        dp[0] = 0;
        dp[1] = a[f(id + 1)];
        dp[2] = a[f(id + 1)] + a[f(id + 2)];
        dp[3] = a[f(id + 1)] + a[f(id + 2)] + a[f(id + 3)];
        for (int i = 4; i < n; ++i) {
            dp[i] = max(max(dp[i - 1], dp[i - 2] + a[f(id + i)]), max(dp[i - 3] + a[f(id + i)] + a[f(id + i - 1)], dp[i - 4]+ a[f(id + i)] + a[f(id + i - 1)] + a[f(id + i - 2)]));
        }
        mx = max(mx, dp[n - 1]);
    }
    cout << mx << endl;
}

signed main()
{
    ///ifstream cin("test.in"); ofstream cout("test.out");
    ///fast_IO();
    init();
    dp.resize(n);
    get();
    for (int i = 0; i < q; ++i) {
        int p, v;
        cin >> p >> v;
        p--;
        a[p] = v;
        get();
    }
    return 0;
    ///cin.close(); cout.close();
}
/*
6
1 2 3 4 5 6
2
6 0
2 5

6
1 2 12 17 25 34
3
46
42
3

*/
