#include <bits/stdc++.h>

using namespace std;

#define endl '\n'

ostream &operator<<(ostream &out, const pair<int, int> &p) {
    out << p.first << p.second;
}

const int INF = 2e9;

bool cmp(double a, double b) {
    return a > b;
}

int oneCounter(int mask) {
    int ans = 0;
    while(mask) {
        if (mask & 1)
            ans++;
        mask >>= 1;
    }
    return ans;
}

signed main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    int v[n], L[n];
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> L[i];
    }
    double limit = 0;
    for (int i = 0; i < n; i++) {
        limit += 1. * L[i] / v[i];
    }
    int m;
    cin >> m;
    int a[m];
    a[0] = 0;
    for (int i = 1; i < m; i++) {
        cin >> a[i];
    }
    int f[m + 1];
    f[0] = 0;
    for (int i = 1; i < m + 1; i++) {
        cin >> f[i];
    }
    vector<double> p(m + 1, INF);
    for (int j = 0; j <= m; j++) {
        for (int mask = 1; mask < (1 << n); mask++) {
            double sum = 0;
            for (int i = 0; i < n; i++) {
                if ((mask >> i) & 1) {
                    sum += 1. * L[i] / (v[i] + 1. * a[j]);
                } else {
                    sum += 1. * L[i] / v[i];
                }
            }
            p[j] = min(p[j], sum);
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int s, t;
        cin >> s >> t;
        auto it = lower_bound(p.begin(), p.end(), t - s, cmp) - p.begin();
        cout << f[it] << endl;
    }
    return 0;

}
