#include <bits/stdc++.h>

using namespace std;

#define DEBUGh

void solve() {
    int n;
    cin >> n;
    vector<long double> v(n);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    vector<long double> lens(n);
    for (int i = 0; i < n; ++i)
        cin >> lens[i];
    int m;
    cin >> m;
    vector<long double> vmax(m - 1);
    for (int i = 0; i < m - 1; ++i)
        cin >> vmax[i];
    vector<long long> straf(m);
    for (int i = 0; i < m; ++i)
        cin >> straf[i];
    long double TMAX = 0.0;
    long double eps = 1e-5;
    for (int i = 0; i < n; ++i)
        TMAX += lens[i] / v[i];
    vector<long double> parts(m + 1);
    parts[0] = TMAX;
    for (int i = 0; i < m - 1; ++i) {
        long double T = 0;
        for (int j = 0; j < n; ++j)
            T += lens[j] / (v[j] + vmax[i]);
        parts[i + 1] = T;
    }
    parts.back() = -1;
    reverse(parts.begin(), parts.end());
    int q;
    cin >> q;
    for (int it = 0; it < q; ++it) {
        int lb = 0, rb = m + 1;
        long long A, B;
        cin >> A >> B;
        B -= A;
        long double timer = B;
        while (rb - lb > 1) {
            int mid = (lb + rb) / 2;
            if (parts[mid] <= timer + eps)
                lb = mid;
            else
                rb = mid;
        }
        lb = m - lb;
        if (lb == 0) {
            cout << "0\n";
        } else {
            cout << straf[lb - 1] << '\n';
        }
    }
}

int main() {
    #ifdef DEBUG
        freopen("Btest.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
