#include <bits/stdc++.h>

using namespace std;

#define DEBU

const int SZ_SMALL = 2000, MAXN = 200000, CHMO = 300;

int cnt[MAXN], vals[MAXN];

void solve() {
     int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> vals[i];
    vector<int> v1(n);
    for (int i = 0; i < n; ++i)
        v1[i] = vals[i];
    sort(v1.begin(), v1.end());
    v1.resize(unique(v1.begin(), v1.end()) - v1.begin());
    for (int i = 0; i < n; ++i)
        vals[i] =  (lower_bound(v1.begin(), v1.end(), vals[i]) - v1.begin());
    for (int i = 0; i < MAXN; ++i)
        cnt[i] = 0;
    vector<int> ans(n);
    int kolvo = 0;
    for (int i = 0; i < n; ++i) {
        int fin = min(SZ_SMALL, n - i);
        for (int j = 0; j < fin; ++j) {
            if (cnt[vals[j + i]]++ == 0)
                ++kolvo;
            ans[j] += kolvo;
        }
        for (int j = fin - 1; j >= 0; --j) {
            if (cnt[vals[j + i]]-- == 1)
                --kolvo;
        }
    }
    vector<pair<short, pair<int, int>>> tasks;
    tasks.reserve(n + n + 2);
    for (int i = 0; i < n; ++i)
        for (int j = SZ_SMALL + i; j < n; ++j)
            tasks.push_back({i / CHMO, {j, i}});
    sort(tasks.begin(), tasks.end());
    int L = 0, R = -1;
    for (int i = 0; i < tasks.size(); ++i) {
        int lb = tasks[i].second.second, rb = tasks[i].second.first;
        while (R < rb) {
            if (cnt[vals[++R]]++ == 0)
                ++kolvo;
        }
        while (L > lb) {
            if (cnt[vals[--L]]++ == 0)
                ++kolvo;
        }
        while (R > rb) {
            if (--cnt[vals[R--]] == 0)
                --kolvo;
        }
        while (L < lb) {
            if (--cnt[vals[L++]] == 0)
                --kolvo;
        }
        ans[rb - lb] += kolvo;
    }
    for (auto x : ans)
        cout << x << ' ';
    cout << '\n';
}

int main() {
    #ifdef DEBUG
        freopen("Ctest.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
