#include <bits/stdc++.h>

using namespace std;

#define DEBUGh

vector<int> simple;

const int MAXN = 10000;

int p[MAXN];


void solve() {
    simple.reserve(10000);
    p[1] = 1;
    for (int i = 2; i < MAXN; ++i) {
        p[i] = -1;
    }
    for (int i = 2; i < MAXN; ++i) {
        if (p[i] == -1) {
            p[i] = i;
            simple.push_back(i);
        }
        for (int j = 0; j < simple.size() && simple[j] <= i && simple[j] * i < MAXN; ++j)
            p[i * simple[j]] = simple[j];
    }
    int n, X, ans = 0;
    cin >> n >> X;
    for (int b = 1; b < n; ++b) {
        if (b == X)
            continue;
        for (int c = 1; b * c < n; ++c) {
            int x = n - b * c;
            vector<pair<int, int>> dels;
            while (x != 1) {
                if (dels.size() == 0 || dels.back().first != p[x])
                    dels.push_back({p[x], 0});
                ++dels.back().second;
                x /= p[x];
            }
            x = n - b * c;
            //cout << "B " << b << " ; C" << c << endl;
            queue<pair<int, int>> q;
            q.push({0, 1});
            while (!q.empty()) {
                int pos =  q.front().first, col = q.front().second;
                q.pop();
                if (pos == dels.size()) {
                    //cout << x << " col " << col << endl;
                    if (col < b && c + x / col != X)
                        ++ans;
                    continue;
                }
                for (int i = 0; i <= dels[pos].second; ++i) {
                    q.push({pos + 1, col});
                    col *= dels[pos].first;
                    if (col >= b)
                        break;
                }
            }
        }
    }

    cout << ans << endl;
}

int main() {
    #ifdef DEBUG
        freopen("Btest.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
