#include <bits/stdc++.h>

using namespace std;

#define DEBUGf

void solve() {
    int n;
    cin >> n;
    vector<long long> v(n);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    vector<pair<long long, long long>> dp(n);
    for (int i = 1; i < n; ++i) {
        long long sum = v[i] - 1, k = 0;
        while (sum > 0) {
            auto it = upper_bound(v.begin(), v.end(), sum);
            --it;
            long long F = *it;
            k += sum / F;
            sum %= F;
        }
        dp[i] = {v[i] - 1, k};
    }
    for (int i = 1; i < n; ++i) {
        if (dp[i].second < dp[i - 1].second)
            dp[i] = dp[i - 1];
    }
    int q;
    cin >> q;
    for (int iter = 0; iter < q; ++iter) {
        long long b, b1;
        cin >> b;
        b1 = b;
        auto it = upper_bound(v.begin(), v.end(), b);
        --it;
        pair<long long, long long> cur = dp[it - v.begin()];
        long long k = 0;
        while (b > 0) {
            auto it = upper_bound(v.begin(), v.end(), b);
            --it;
            long long F = *it;
            k += b / F;
            b %= F;
        }
        if (k > cur.second)
            cur = {b1, k};
        cout << cur.first << " " << cur.second << '\n';
    }
}

int main() {
    #ifdef DEBUG
        freopen("Ctest.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
