#include <bits/stdc++.h>

using namespace std;

#define DEBUGf

void solve() {
    int n;
    cin >> n;
    vector<long long> v(n);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    vector<pair<long long, long long>> dp(n);
    for (int i = 1; i < n; ++i) {
        long long sum = v[i] - 1, k = 0;
        while (sum > 0) {
            auto it = upper_bound(v.begin(), v.end(), sum);
            --it;
            long long F = *it;
            k += sum / F;
            sum %= F;
        }
        dp[i] = {v[i] - 1, k};
    }
    for (int i = 1; i < n; ++i) {
        if (dp[i].second < dp[i - 1].second)
            dp[i] = dp[i - 1];
    }
    int q;
    cin >> q;
    for (int iter = 0; iter < q; ++iter) {
        pair<long long, long long> ans = {1, 1};
        long long b;
        cin >> b;
        for (long long t = 1; t <= b; ++t) {
            long long sum = t, k = 0;
            while (sum > 0) {
                auto it = upper_bound(v.begin(), v.end(), sum);
                --it;
                long long F = *it;
                k += sum / F;
                sum %= F;
            }
            if (ans.second < k)
                ans = {t, k};
        }
        cout << ans.first << " " << ans.second << endl;
    }
}

int main() {
    #ifdef DEBUG
        freopen("Ctest.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
