#include <bits/stdc++.h>

using namespace std;

#define DEBUGf

void solve() {
    int n;
    cin >> n;
    vector<long long> v(n);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    vector<pair<long long, long long>> dp(n);
    for (int i = 0; i < n - 1; ++i) {
        long long is = v[i + 1] - 1 - dp[i].second;
        long long k = dp[i].first;
        long long ideal = dp[i].second;
        k += is / v[i];
        ideal += v[i] * (is / v[i]);
        dp[i + 1] = {k, ideal};
    }
    int q;
    cin >> q;
    for (int iter = 0; iter < q; ++iter) {
        long long b;
        cin >> b;
        auto it = upper_bound(v.begin(), v.end(), b);
        --it;
        long long is = b - dp[it - v.begin()].second;
        long long k = dp[it - v.begin()].first;
        long long ideal = dp[it - v.begin()].second;
        k += is / v[it - v.begin()];
        ideal += v[it - v.begin()] * (is / v[it - v.begin()]);
        cout << ideal << ' ' << k << '\n';
    }
}

int main() {
    #ifdef DEBUG
        freopen("Ctest.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
