#include <bits/stdc++.h>

using namespace std;

#define DEBUGu

bool good(int a, int b) {
    a = a * 8 + b;
    if ((a & 60) == 60)
        return false;
    if ((a & 30) == 30)
        return false;
    if ((a & 15) == 15)
        return false;
    return true;
}

bool valid(int i, int a, int b) {
    if (i == 2)
        return a == b;
    if (i == 3)
        return (a & 3) == (b>>1);
    if (i == 4)
        return (a & 1) == (b>>2);
    return true;
}

void solver(vector<long long> &v) {
    int n = v.size();
    vector<vector<vector<long long>>> dp(n, vector<vector<long long>>(8, vector<long long>(8)));
    for (int i = 0; i < 8; ++i) {
        if (i & 4)
            dp[2][i][i] += v[0];
        if (i & 2)
            dp[2][i][i] += v[1];
        if (i & 1)
            dp[2][i][i] += v[2];
    }
    for (int i = 2; i < n - 1; ++i) {
        for (int fmask = 0; fmask < 8; ++fmask) {
            for (int mask = 0; mask < 8; ++mask) {
                if (!valid(i, fmask, mask))
                    continue;
                dp[i + 1][fmask][(mask & 3) * 2] = max(dp[i + 1][fmask][(mask & 3) * 2], dp[i][fmask][mask]);
                if (mask != 7)
                    dp[i + 1][fmask][((mask & 3) * 2 + 1)] = max(dp[i + 1][fmask][((mask & 3) * 2 + 1)],
                    dp[i][fmask][mask] + v[i + 1]);
            }
        }
    }
    /*for (int i = 0; i < n; ++i) {
        cout << i + 1 << endl;
        for (int lmask = 0; lmask < 8; ++lmask) {
            cout << lmask << ":\n";
            for (int mask = 0; mask < 8; ++mask)
                cout << mask << " " << dp[i][lmask][mask] << "; ";
            cout << endl;
        }
        cout << endl << endl;
    }*/
}

bool gooderrr(int mask, int n) {
    vector<int> v(n + 3);
    for (int i = 0; i < n; ++i)
        if (mask & (1 << i))
            v[i] = 1;
    v[n] = v[0];
    v[n + 1] = v[1];
    v[n + 2] = v[2];
    for (int i = 0; i < n; ++i)
        if (v[i] && v[i + 1] && v[i + 2] && v[i + 3])
            return false;
    return true;
}

void solve() {
    int n;
    cin >> n;
    if (n < 7) {
        vector<long long> v(n);
        for (int i = 0; i < n; ++i)
            cin >> v[i];
        int q;
        cin >> q;
        for (int i = -1; i < q; ++i) {
            if (i != -1) {
                int a, b;
                cin >> a >> b;
                v[a - 1] = b;
            }
            long long ans = 0;
            for (int mask = 0; mask < (1 << n); ++mask) {
                if (gooderrr(mask, n)) {
                    long long cur = 0;
                    for (int j = 0; j < n; ++j)
                    if (mask & (1 << j))
                        cur += v[j];
                    ans = max(cur, ans);
                }
            }
            cout << ans << endl;
        }
        return;
    }
    vector<vector<long long>> mass;
    vector<long long> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    for (int i = 0; i < n; ++i) {
        if (i % 6 == 0)
            mass.push_back({});
        mass.back().push_back(v[i]);
    }
    if (mass.back().size() < 6) {
        for (auto x : mass.back())
            mass[mass.size() - 2].push_back(x);
        mass.pop_back();
    }
    vector<vector<vector<long long>>> dp(mass.size(), vector<vector<long long>>(8, vector<long long>(8)));
    for (int i = 0; i < mass.size(); ++i);

}

int main() {
    #ifdef DEBUG
        freopen("Dtest.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}

