#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<int> vec(n);
    vector<int> all[5001];
    int max_ = -1;
    for (int i = 0; i < n; i++) {
        cin >> vec[i];
        max_ = max(max_, vec[i]);
        if (max_ < 5001) {
            all[vec[i]].push_back(i);
        }
    }
    if (max_ > 5000 && n <= 50) {
        for (int i = 1; i <= n; i++) {
            int sum = 0;
            for (int j = 0; j < n - i + 1; j++) {
                set<int> need;
                for (int k = j; k < j + i; k++) {
                    need.insert(vec[k]);
                }
                sum += need.size();
            }
            cout << sum << ' ';
        }
    }
    if (n > 50 && n <= 5000 && max_ > 5000) {
        vector<int>sum(n, 0);
        for (int i = 0; i < n; i++) {
            set<int> need;
            for (int j = i; j < n; j++) {
                need.insert(vec[j]);
                sum[j - i] += need.size();
            }
        }
        for (auto x: sum) {
            cout << x << ' ';
        }
    }
    if (max_ <= 5000 && n <= 5000) {
        int arr[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                arr[i][j] = 0;
            }
        }
        for (int i = 0; i < n; i++) {
            arr[i][i] = 1;
        }
        cout << n << ' ';
        for (int k = 2; k <= n; k++) {
            int sum = 0;
            for (int i = 0; i < n - k + 1; i++) {
                int j = i + k - 1;
                int q = vec[j];
                int index = lower_bound(all[q].begin(), all[q].end(), j) - all[q].begin() - 1;
                //cout << i << ' ' << j << ' ' << index << ' ' << all[q][index] << endl;
                if (index < 0 || all[q][index] < i) {
                    arr[i][j] = arr[i][j - 1] + 1;
                } else {
                    arr[i][j] = arr[i][j - 1];
                }
                sum += arr[i][j];
            }
            cout << sum << ' ';
        }
    }
}
