#include <iostream>
#include <vector>
#define int long long

using namespace std;

const int MAXN = 2 * 1e5;

int32_t main() {
    int n;
    cin >> n;
    vector<int> vec(n);
    for (int i = 0; i < n; i++) {
        cin >> vec[i];
    }
    int q;
    cin >> q;
    int pred[MAXN + 1];
    for (int i = 1; i <= MAXN; i++) {
        int sum = 0;
        int h = i;
        for (int k = n - 1; k >= 0 && h != 0; k--) {
            sum += (h / vec[k]);
            h %= vec[k];
        }
        pred[i] = sum;
    }
    int preff[MAXN + 1];
    preff[1] = 1;
    int max_ = 1;
    for (int i = 2; i <= MAXN; i++) {
        if (pred[i] > pred[max_]) {
            preff[i] = i;
            max_ = i;
        } else {
            preff[i] = max_;
        }
    }
    for (int i = 0; i < q; i++) {
        int x;
        cin >> x;
        cout << preff[x] << ' ' << pred[preff[x]] << endl;
    }
}
