#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define ff first
#define ss second
#define pb emplace_back
#define pii pair<int, int>
#define mp make_pair
#define all(x) x.begin(), x.end()

const int maxn = (1 << 18);
int sum[2 * maxn];
int pr[2 * maxn];
int q[2 * maxn];
int a[maxn];
int n;

void add_pr(int i, int l, int r, int left, int right, int x, int y)
{
    if (right - left < 1)
        return;
    if (right <= l || left >= r)
        return;
    if (left <= l && r <= right)
    {
        pr[i] += x + (l - left) * y;
        q[i] += y;
        return;
    }
    add_pr(i * 2, l, (l + r) / 2, left, right, x, y);
    add_pr(i * 2 + 1, (l + r) / 2, r, left, right, x, y);
}

void add_sum(int i, int l, int r, int left, int right, int x)
{
    if (right - left < 1)
        return;
    if (right <= l || left >= r)
        return;
    if (left <= l && r <= right)
    {
        sum[i] += x;
        return;
    }
    add_sum(i * 2, l, (l + r) / 2, left, right, x);
    add_sum(i * 2 + 1, (l + r) / 2, r, left, right, x);
}

int get(int i, int l, int r, int pos)
{
    int ans = sum[i] + pr[i] + q[i] * (pos - l);
    if (r - l > 1)
    {
        if (pos < (l + r) / 2)
            ans += get(i * 2, l, (l + r) / 2, pos);
        else
            ans += get(i * 2 + 1, (l + r) / 2, r, pos);
    }
    return ans;
}

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    map<int, int> m;
    for (int i = 0; i < n; i++)
    {
        int len = i + 1;
        if (m.find(a[i]) != m.end())
            len = i - m[a[i]];
        m[a[i]] = i;

        int kek = n - i;
        if (len <= kek)
        {
            add_pr(1, 0, maxn, 0, len, 0, 1);
            //add_sum(1, 0, maxn, len, kek, len);
            add_pr(1, 0, maxn, len, kek, len, 0);
            add_pr(1, 0, maxn, kek, kek + len, len, -1);
        }
        else
        {
            int j = len + kek;
            if (j % 2 == 0)
            {
                add_pr(1, 0, maxn, 0, j / 2, 0, 1);
                add_pr(1, 0, maxn, j / 2, j, j / 2, -1);
            }
            else
            {
                add_pr(1, 0, maxn, 0, j / 2 + 1, 0, 1);
                add_pr(1, 0, maxn, j / 2 + 1, j, j / 2, -1);
            }
        }
    }
    for (int i = 1; i <= n; i++)
        cout << get(1, 0, maxn, i) << " ";
}
