#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ff first
#define ss second
#define pb emplace_back
#define pii pair<int, int>
#define mp make_pair
#define all(x) x.begin(), x.end()

const int maxn = (1 << 16);
int dp[2 * maxn][4][4];
int a[maxn];
int n, q;

void update(int i, int l, int r, int j)
{
    for (int c1 = 0; c1 <= 3; c1++)
        for (int c2 = 0; c2 <= 3; c2++)
            dp[i][c1][c2] = 0;
    int len = r - l;
    if (len <= 8)
    {
        for (int mask = 0; mask < (1 << len); mask++)
        {
            int k = 0;
            bool fl = 1;
            for (int e = 0; e < len; e++)
            {
                if (mask & (1 << e))
                    k++;
                else
                    k = 0;
                if (k > 3)
                    fl = 0;
            }
            if (!fl)
                continue;
            int c1 = 0;
            for (int e = 0; e < len; e++)
            {
                if (mask & (1 << e))
                    c1++;
                else
                    break;
            }
            int c2 = 0;
            for (int e = len - 1; e >= 0; e--)
            {
                if (mask & (1 << e))
                    c2++;
                else
                    break;
            }
            if (c1 > 3 || c2 > 3)
                continue;
            int cur = 0;
            for (int e = 0; e < len; e++)
            {
                if (mask & (1 << e))
                    cur += a[l + e];
            }
            dp[i][c1][c2] = max(dp[i][c1][c2], cur);
        }
        return;
    }
    if (j < (l + r) / 2)
        update(i * 2, l, (l + r) / 2, j);
    else
        update(i * 2 + 1, (l + r) / 2, r, j);

    for (int k1 = 0; k1 <= 3; k1++)
        for (int k2 = 0; k2 <= 3; k2++)
            for (int c1 = 0; c1 <= 3 && c1 + k1 < len; c1++)
                for (int c2 = 0; c2 + c1 <= 3 && c2 + k2 < len; c2++)
                {
                    int cur = dp[i * 2][k1][c1] + dp[i * 2 + 1][c2][k2];
                    dp[i][k1][k2] = max(dp[i][k1][k2], cur);
                }
}

int get_ans()
{
    int ans = 0;
    for (int c1 = 0; c1 <= 3; c1++)
        for (int c2 = 0; c1 + c2 <= 3; c2++)
            ans = max(ans, dp[1][c1][c2]);
    return ans;
}

signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        update(1, 0, n, i);
    }
    cout << get_ans() << "\n";
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        int j, x;
        cin >> j >> x;
        j--;
        a[j] = x;
        update(1, 0, n, j);
        cout << get_ans() << "\n";
    }
}
