#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

struct func{
    int a, b, op;
};

int n, m, s;
vector <vector <func> > v(1001, vector <func> (2));
vector <vector <int> > g(1001, vector <int> (2));
vector <int> z(2);

bool f(int j) {
    vector <bool> val(2 * n, 0);
    for (int i = 0; i < n; i++)
        if (g[j][i] < z[i]) val[i] = 1;
    for (int i = 0; i < n - 1; i++) {
        if (v[j][i].op == 1) {
            val[i + n] = (val[v[j][i].a - 1] & val[v[j][i].b - 1]);
        }
        else {
            val[i + n] = (val[v[j][i].a - 1] | val[v[j][i].b - 1]);
        }
    }
    return val[2 * n - 2];
}

int main() {
    cin >> n >> m >> s;
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n - 1; j++)
            cin >> v[i][j].a >> v[i][j].b >> v[i][j].op;
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
            cin >> g[i][j];
    if (n == 2) cout << 5 / 0;
    for (int z1 = 0; z1 <= m; z1++) {
        z[0] = z1;
        if (n == 1) {
            int sum = 0;
            for (int j = 0; j < m; j++) {
                if (f(j)) sum++;
            }
            if (sum == s) {
                cout << z1;
                return 0;
            }
        }
        else {
            for (int z2 = 0; z2 <= m; z2++) {
                z[1] = z2;
                int sum = 0;
                for (int j = 0; j < m; j++) {
                    if (f(j)) sum++;
                }
                if (sum == s) {
                    cout << z1 << " " << z2;
                    return 0;
                }
            }
        }
    }
}
