#define _USE_MATH_DEFINES
#pragma GCC optimize("O3")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define int long long 

bool DEBUG = false;
int n, x;

int gcd(int a, int b, int& x, int& y) {
    if (b == 0) {
        x = 1, y = 0;
        return a;
    }

    int x0, y0;
    auto d = gcd(b, a % b, x0, y0);
    x = y0;
    y = x0 - (a / b) * y0;
    return d;
}

bool check(int a, int b, int c) {
    return ((a * b - n) % c == 0 && (a * b - n) / c > 0 && (a * b - n) / c < b);
}

int getcnt(int a, int c) {  // ab - cd = n
    //  -     [1..n] [1..n]
    int b, d, g = gcd(a, c, b, d);
    d *= -1;
    if (n % g != 0) return 0;
    b *= (n / g);
    d *= (n / g);
    cout << a << " " << b << " " << c << " " << d << '\n';



    return 0;
}

int stupid() {
    int ans = 0;
    for (int a = 1; a <= n; a++) {
        if (a == x) continue;
        for (int b = 1; b <= n; b++) {
            if (b == x) continue;
            for (int c = 1; c < a; c++) {
                if (check(a, b, c)) ans++;
            }
        }
    }
    return ans;
}

signed main() {
    kekek;
    if (0) {
        cin >> n >> x;
        if (0) {
            int ans = 0;
            for (int a = 1; a < n; a++) {
                if (a == x) continue;
                for (int c = 1; c < a; c++) {
                    ans += getcnt(a, c);
                }
            }
            cout << ans;
        } else {
            cout << stupid();
        }
    } else {
        int a, b, x, y;
        cin >> a >> b;
        cout << gcd(a, b, x, y) << " " << x << " " << y << '\n';
    }

    return 0;
}