#define _USE_MATH_DEFINES
#pragma GCC optimize("O3")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define int long long

const int inf = 1e15;
int n;
vector<int> a, need;

bool check(int mask) {
    for (int i = 0; i < n && need[i] != 2; i++) {
        mask = (mask << 1) + need[i];
    }

    while (mask >= 15) {
        if ((mask & 15) == 15) return false;
        mask >>= 1;
    }
    return true;
}

int getans2() {
    int ans = 0;
    vector<vector<int>> dp(n, vector<int>(16, -inf));
    for (int mask = 0; mask < 15; mask++) {     // don't use 1111
        int a3 = mask & 1, a2 = (mask >> 1) & 1, a1 = (mask >> 2) & 1, a0 = (mask >> 3) & 1;
        if (need[0] != 2) {
            if (need[0] != a0) continue;
        }
        if (need[1] != 2) {
            if (need[1] != a1) continue;
        }
        if (need[2] != 2) {
            if (need[2] != a2) continue;
        }
        if (need[3] != 2) {
            if (need[3] != a3) continue;
        }

        ans = max(dp[3][mask] = a[0] * a0 + a[1] * a1 + a[2] * a2 + a[3] * a3, ans);
    }

    for (int i = 4; i < n; i++) {
        for (int mask = 0; mask < 15; mask++) {
            if (i == n - 1 && !check(mask)) continue;

            if (need[i] != 2 && (mask & 1) != need[i]) continue;
            dp[i][mask] = dp[i - 1][(mask >> 1)] + a[i] * (mask & 1);
            if ((mask >> 1) != 7) {
                dp[i][mask] = max(dp[i][mask], dp[i - 1][8 + (mask >> 1)] + a[i] * (mask & 1));
            }

            ans = max(ans, dp[i][mask]);
        }
    }
    return ans;
}

int getans() {
    int ans = 0;

    for (int mask = 0; mask < 15; mask++) {     // n-3 n-2 n-1 0
        need[0] = (mask & 1);
        need[n - 1] = (mask >> 1) & 1;
        need[n - 2] = (mask >> 2) & 1;
        need[n - 3] = (mask >> 3) & 1;
        ans = max(ans, getans2());
    } 
    need[n - 3] = 2;
    for (int mask = 0; mask < 15; mask++) {     // n-2 n-1 0 1
        need[1] = mask & 1;
        need[0] = (mask >> 1) & 1;
        need[n - 1] = (mask >> 2) & 1;
        need[n - 2] = (mask >> 3) & 1;
        ans = max(ans, getans2());
    }
    need[n - 2] = 2;
    for (int mask = 0; mask < 15; mask++) {     // n-1 0 1 2
        need[2] = mask & 1;
        need[1] = (mask >> 1) & 1;
        need[0] = (mask >> 2) & 1;
        need[n - 1] = (mask >> 3) & 1;
        ans = max(ans, getans2());
    }
    need[1] = 2;
    need[2] = 2;
    return ans;
}

signed main() {
    kekek;
    cin >> n;
    a.resize(n);
    need.resize(n, 2);
    for (auto& i : a) {
        cin >> i;
    }

    cout << getans() << '\n';
    int q;
    cin >> q;
    while (q--) {
        int p, v;
        cin >> p >> v;
        a[--p] = v;
        cout << getans() << '\n';
    }
    

    return 0;
}