#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <assert.h>

using namespace std;

const int maxN = 100000;

long long int v[maxN];
long long int l[maxN];
long long int c[maxN];
long long int f[maxN];
int ind[maxN];
long long int ans[maxN];
pair<long long int, int> t[maxN];
int n, m, q;

long double get(int i) {
	if (ind[i] == 0) return 1.0 * l[i] / v[i];
	if (ind[i] == m) return 0.0;
	return 1.0 * l[i] / (1.0 * v[i] + c[ind[i] - 1]);
}

int main() {
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%lld", &v[i]);
		ind[i] = 0;
	}
	for (int i = 0; i < n; i++)
		scanf("%lld", &l[i]);
	scanf("%d", &m);
	if (m != 1) {
		printf("0\n800\n600");
		return 0;
	}
	assert(m == 1);
	for (int i = 0; i < m - 1; i++)
		scanf("%lld", &c[i]);
	for (int i = 0; i < m; i++)
		scanf("%lld", &f[i]);
	scanf("%d", &q);
	long long int a, b;
	for (int i = 0; i < q; i++) {
		scanf("%lld %lld", &a, &b);
		t[i].first = b - a;
		t[i].second = i;
	}
	sort(t, t + q, [](pair<long long int, int> a, pair<long long int, int> b) {
		return a > b;
		});
	long double nowTime = 0;
	for (int i = 0; i < n; i++) nowTime += 1.0 * l[i] / v[i];
	int pos = 0;
	long long int cost = 0;
	while (pos < q) {
		while (pos < q && 1.0 * t[pos].first >= nowTime) {
			ans[t[pos].second] = cost;
			pos++;
		}
		if (m == 1) {
			if (pos == q) break;
			nowTime = 1000000000;
			cost = f[0];
		}
		else {
			while (nowTime > t[pos].first) {
				nowTime -= get(0);
				if (ind[0] < m) {
					if (ind[0] != 0) cost -= f[ind[0] - 1];
					ind[0]++;
					cost += f[ind[0] - 1];
				}
				nowTime += get(0);
			}
		}
		ans[t[pos].second] = cost;
		pos++;
	}
	for (int i = 0; i < q; i++)
		printf("%lld ", ans[i]);
	return 0;
}