#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

using namespace std;

struct inf {
	int l, r;
	inf() {}
	inf(int l, int r) {
		this->l = l;
		this->r = r;
	}
};

bool operator<(const inf& a, const inf& b) {
	if ((a.r - a.l) == (b.r - b.l)) return a.l < b.l;
	return (a.r - a.l) < (b.r - b.l);
}
const int maxN = 200000;

vector<int> mas[maxN];
set<inf> mn;
set<pair<int, int>> act1;
set<pair<int, int>> act2;
int arr[maxN];
long long int n;

int main() {
	scanf("%lld", &n);
	for (int i = 0; i < n; i++)
		scanf("%d", &arr[i]);
	map<int, int> numb;
	int cnt = 1;
	for (int i = 0; i < n; i++)
		if (numb[arr[i]] == 0)
			numb[arr[i]] = cnt++;
	for (int i = 0; i < n; i++)
		arr[i] = numb[arr[i]] - 1;
	for (int i = 0; i < n; i++)
		mas[arr[i]].push_back(i);
	for (int i = 0; i < n; i++) {
		if (mas[i].size() > 1)
			for (int j = 0; j < mas[i].size() - 1; j++)
				mn.insert(inf(mas[i][j], mas[i][j + 1]));
	}
	long long int bad = 0;
	long long int add = 0;
	long long int sub = 0;
	for (long long int i = 1; i <= n; i++) {
		long long int res = i * (n - i + 1);
		while (mn.size() > 0) {
			auto now = *mn.begin();
			if (now.r - now.l + 1 <= i) {
				mn.erase(now);
				act1.insert({ -now.l, now.r });
				act2.insert({ now.r, now.l });
				sub++;
			}
			else break;
		}
		while (act1.size() > 0) {
			auto now = *act1.begin();
			if (-now.first + i - 1 >= n) {
				if (act2.find({ now.second, -now.first }) == act2.end()) {
					add++;
				}
				else {
					sub--;
				}
				act1.erase(now);
			}
			else break;
		}
		while (act2.size() > 0) {
			auto now = *act2.begin();
			if (now.first - i + 1 < 0) {
				if (act1.find({ -now.second, now.first }) == act1.end()) {
					add++;
				}
				else {
					sub--;
				}
				act2.erase(now);
			}
			else break;
		}
		bad += sub - add;
		printf("%lld\n", res - bad);
	}
	return 0;
}