#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <assert.h>
#include <set>

using namespace std;

const int maxN = 300000;

struct inf {
	int i, j, f;
};

int* arr[maxN];
inf* bmlp[maxN];
int n, m, s;
set<int> o;
set<int> a;
int tree[4 * maxN];

int tree2[4 * maxN];

void build(int L = 0, int R = m - 1, int id = 1) {
	if (L == R) tree[id] = 0;
	else {
		int M = (R + L) / 2;
		build(L, M, id * 2);
		build(M + 1, R, id * 2 + 1);
		tree[id] = tree[id * 2] + tree[id * 2 + 1];
	}
}

void update(int i, int val, int L = 0, int R = m - 1, int id = 1) {
	if (i < L || i > R) return;
	if (L == R) tree[id] += val;
	else {
		int M = (R + L) / 2;
		update(i, val, L, M, id * 2);
		update(i, val, M + 1, R, id * 2 + 1);
		tree[id] = tree[id * 2] + tree[id * 2 + 1];
	}
}

int get(int l, int r, int L = 0, int R = m - 1, int id = 1) {
	if (r < L || l > R) return 0;
	if (l <= L && R <= r) return tree[id];
	int M = (R + L) / 2;
	return get(l, r, L, M, id * 2) + get(l, r, M + 1, R, id * 2 + 1);
}

void build2(int L = 0, int R = m - 1, int id = 1) {
	if (L == R) tree2[id] = 0;
	else {
		int M = (R + L) / 2;
		build2(L, M, id * 2);
		build2(M + 1, R, id * 2 + 1);
		tree2[id] = tree2[id * 2] + tree2[id * 2 + 1];

	}
}

void update2(int i, int val, int L = 0, int R = m - 1, int id = 1) {
	if (i < L || i > R) return;
	if (L == R) tree2[id] += val;
	else {
		int M = (R + L) / 2;
		update2(i, val, L, M, id * 2);
		update2(i, val, M + 1, R, id * 2 + 1);
		tree2[id] = tree2[id * 2] + tree2[id * 2 + 1];
	}
}

int get2(int l, int r, int L = 0, int R = m - 1, int id = 1) {
	if (r < L || l > R) return 0;
	if (l <= L && R <= r) return tree2[id];
	int M = (R + L) / 2;
	return get2(l, r, L, M, id * 2) + get2(l, r, M + 1, R, id * 2 + 1);
}

int main() {
	scanf("%d %d %d", &n, &m, &s);
	if (n == 1) {
		printf("%d", s);
		return 0;
	}
	build();
	build2();

	assert(n == 2);
	for (int i = 0; i < m; i++) {
		bmlp[i] = new inf[n - 1];
		for (int j = 0; j < n - 1; j++)
			scanf("%d %d %d", &bmlp[i][j].i, &bmlp[i][j].j, &bmlp[i][j].f);
	}
	for (int i = 0; i < m; i++) {
		arr[i] = new int[n];
		for (int j = 0; j < n; j++)
			scanf("%d", &arr[i][j]);
	}
	for (int j = 0; j < m; j++) {
		if (bmlp[j][0].f == 2) {
			o.insert(arr[j][1]);
			update(arr[j][1], 1);
		}
		else {
			a.insert(arr[j][1]);
		}
	}
	int ii = 0, jj = 0;
	int cnt = 0;
	for (int i = 0; i <= m; i++) {
		while (o.size() > 0) {
			if (*o.begin() < i) {
				o.erase(*o.begin());
				update(*o.begin(), -1);
				cnt++;
			}
			else break;
		}
		while (a.size() > 0) {
			if (*a.begin() < i) {
				a.erase(*a.begin());
				update2(*a.begin(), 1);
			}
			else break;
		}
		int L = 0, R = m + 1;
		int add = 0;
		while (R - L > 1) {
			int M = (R + L) / 2;
			cnt = 0;
			cnt = get(0, L) + get2(0, L);
			if (cnt + add > s) R = M;
			else L = M;
		}
		if (cnt + add == s) {
			ii = i;
			jj = L;
		}
	}
	printf("%d %d", ii, jj);
	return 0;
}