#include <bits/stdc++.h>
using namespace std;

typedef long double ld;
typedef long long ll;

int n;
vector<ld> v;
vector<ld> l;

int m;
vector<ld> a;
vector<ll> f;

int q;
vector<ld> s;
vector<ld> t;
vector<ld> d;
vector<ld> forb;

bool check(ld dv, int mach) {
	ld _d = 0;
	for ( int i = 0; i < n; ++i )
		_d += l[i] / (v[i] + dv);
	return _d <= d[mach];
}

ll compute(ld e) {
	if ( e < 1e-5 ) return 0;
	int pos = lower_bound(a.begin(), a.end(), e) - a.begin();
	return f[pos];
}

int main() {
	cin >> n;
	v = vector<ld>(n);
	l = vector<ld>(n);
	for ( int i = 0; i < n; ++i ) cin >> v[i];
	for ( int i = 0; i < n; ++i ) cin >> l[i];
	cin >> m;
	a = vector<ld>(m - 1);
	for ( int i = 0; i < m - 1; ++i ) cin >> a[i];
	f = vector<ll>(m);
	for ( int i = 0; i < m; ++i ) cin >> f[i];

	cin >> q;
	s = vector<ld>(q);
	t = vector<ld>(q);
	for ( int i = 0; i < q; ++i ) cin >> s[i] >> t[i];

	d = vector<ld>(q);
	for ( int i = 0; i < q; ++i ) d[i] = t[i] - s[i];
	forb = vector<ld>(q);

	for ( int i = 0; i < q; ++i ) {
		ld lft = 0;
		ld rgt = 1e10;
		while ( rgt - lft > (1e-6) ) {
			ld mid = (lft + rgt) / 2;
			if ( check(mid, i) ) {
				rgt = mid;
			} else {
				lft = mid;
			}
		}
		forb[i] = lft;
	}

	vector<ll> ans(q, 0);
	for ( int i = 0; i < q; ++i ) ans[i] = compute(forb[i]);

	for ( int i = 0; i < q; ++i )
		cout << ans[i] << endl;
	return 0;
}