#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
#define int ll

signed main() {
	int n;
	cin >> n;
	vector<ll> _a(n);
	for ( int i = 0; i < n; ++i ) cin >> _a[i];

	//Compressing
	vector<ll> b = _a;
	sort(b.begin(), b.end());
	b.erase(unique(b.begin(), b.end()), b.end());
	for ( int i = 0; i < n; ++i ) _a[i] = lower_bound(b.begin(), b.end(), _a[i]) - b.begin();

	//Step 1
	vector<vector<ll>> vals(n, vector<ll>(0));
	for ( int i = 0; i < n; ++i ) vals[_a[i]].push_back(i);

	vector<int> s(n, 0);
	vector<pair<pair<int, int>, bool>> queries = {};
	vector<int> consts = {};
	vector<int> speed = {};
	vector<ll> c;
	int a;
	for ( int block = 0; block < n; ++block ) {
		c = vals[block];
		for ( int i = 0; i < c.size(); ++i ) {
			if ( i != 0 ) {
				a = c[i] - c[i-1] - 1;
				n -= c[i-1] + 1;
			} else {
				a = c[0];
			}
			// a - d + 1 0 a n - d
			// a - d + 1 <= 0 ==> d >= a + 1 d___ >= a
			// n - d >= a ==> d <= n - a ==> d___ <= n - a - 1
			// 0....a a + 1
			queries.push_back({{a, n - a - 1}, false});
			consts.push_back(a+1);
			speed.push_back(0);

			// 0 a - d + 1   a   n - d
			// a - d + 1 > 0 d < a + 1 d___ <= a - 1
			// d___ <= n - a - 1
			// a - d + 1 ..... a a - a + d - 1 + 1 = d
			queries.push_back({{0, min(a-1, n-a-1)}, true});
			consts.push_back(1);
			speed.push_back(1);

			// a - d + 1 0  n - d  a
			// a - d + 1 <= 0 ==> d >= a + 1 d___ >= a
			// n - d < a ==> d > n - a ==> d___ >= n - a
			// 0...n-d n - min_d + 1
			queries.push_back({{max(a, n-a), n-1}, true});
			consts.push_back(n - max(a, n-a));
			speed.push_back(-1);

			// 0    a - d + 1  n - d  a
			// a - d + 1 > 0 d < a + 1 d___ <= a - 1
			// n - d < a ==> d > n - a ==> d___ >= n - a
			// n - d - a + d - 1 + 1 = n - a
			// a - d + 1 > n - d a + 1 > n///
			queries.push_back({{n - a, a - 1}, false});
			consts.push_back(n - a);
			speed.push_back(0);
			if ( i != 0 ) {
				n += c[i-1] + 1;
			}
		}
	}

	vector<int> add_up(n + 1, 0);
	for ( int i = 0; i < queries.size(); ++i ) {
		int l = queries[i].first.first;
		int r = queries[i].first.second;
		int x = consts[i];
		if ( r < l ) continue;
		add_up[l] += x;
		add_up[r+1] -= x;
	}
	int cur = 0;
	for ( int i = 0; i < n; ++i ) {
		cur += add_up[i];
		s[i] += cur;
	}

	for ( int i = 0; i < queries.size(); ++i ) {
		int cur = 0;
		if ( queries[i].first.second < queries[i].first.first ) continue;

		for ( int j = queries[i].first.first; j <= queries[i].first.second; ++j ) {
			s[j] += cur;
			cur += speed[i];
		}
	}


	for ( int i = 0; i < n; ++i ) cout << s[i] << " ";
	cout << endl;
	return 0;
}