#include <bits/stdc++.h>
using namespace std;

//

typedef long long ll;
const ll INF = 1e18;

int n;
vector<ll> a;

int q;
vector<int> p;
vector<ll> v;

vector<vector<ll>> dp;

bool check(int mask) {
	vector<bool> state(8, false);
	for ( int i = 0; i < 8; ++i ) state[i] = (mask&(1<<i)) != 0;
	for ( int i = 0; i < 4; ++i ) {
		bool subflag = true;
		for ( int j = i; j < i + 4; ++j ) subflag = subflag && state[j];
		if ( subflag ) return false;
	}
	return true;
}

ll find_ans() {
	if ( n == 4 ) {
		vector<ll> b = a;
		sort(b.begin(), b.end());
		return b[1] + b[2] + b[3];
	}

	ll ans = 0;

	for ( int start = 0; start < 16; ++start ) {
		if ( start == 15 ) continue;
		dp = vector<vector<ll>>(n, vector<ll>(16, -INF));
		dp[3][start] = 0;
		for ( int i = 0; i < 4; ++i ) if ( (start&(1<<i)) != 0 ) dp[3][start] += a[3 - i];

		for ( int i = 4; i < n; ++i ) {
			for ( int mask = 0; mask < 16; ++mask ) {
				if ( mask == 15 ) continue;
				dp[i][mask] = max(dp[i][mask], dp[i-1][mask>>1] + ((int)(mask&1)) * a[i]);
				dp[i][mask] = max(dp[i][mask], dp[i-1][8 + (mask>>1)] + ((int)(mask&1)) * a[i]);
			}
		}

		for ( int suff = 0; suff < 16; ++suff ) {
			if ( suff == 15 ) continue;
			if ( check((suff*16) + start) ) ans = max(ans, dp[n-1][suff]);
		}
	}

	return ans;
}

int main() {
	cin >> n;
	a = vector<ll>(n);
	for ( int i = 0; i < n; ++i ) cin >> a[i];

	cin >> q;
	p = vector<int>(q);
	v = vector<ll>(q);
	for ( int i = 0; i < q; ++i ) cin >> p[i] >> v[i];

	for ( int i = 0; i < q; ++i ) p[i]--;

	cout << find_ans() << endl;

	for ( int i = 0; i < q; ++i ) {
		a[p[i]] = v[i];

		cout << find_ans() << endl;
	}
	return 0;
}