#include <bits/stdc++.h>
#pragma GCC optimize ("Ofast")
using namespace std;

vector<int> vs, ls;
vector<int> brd, cst;

typedef long double ld;

const ld EPS = 1e-8;

bool check(int med, int total) {
    //cout << "CHECK: " << med << total << endl;
    ld time = 0;
    for (int i = 0; i < vs.size(); i++) {
        //cout << ls[i] << "/ " << vs[i] + med << endl;
        time += ((ld)ls[i]) / (vs[i] + med);
    }
    //cout << "total: " << total << " vs " << time << endl;
    return total <= time + EPS;
}

int main() {
    int n;
    cin >> n;
    vs.resize(n);
    ls.resize(n);
    for (int i = 0; i < n; i++) cin >> vs[i];
    for (int i = 0; i < n; i++) cin >> ls[i];
    int m;
    cin >> m;
    brd.resize(m);
    for (int i = 1; i < brd.size(); i++) {
        cin >> brd[i];
    }
    cst.resize(m);
    for (int i = 0; i < cst.size(); i++) cin >> cst[i];
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int s, t;
        cin >> s >> t;
        int total = t - s;
        int L = -1;
        int R = brd.back() + 1;
        while (R - L > 1) {
            int med = L + (R - L) / 2;
            if (check(med, total)) {
                L = med;
            } else {
                R = med;
            }
            //cout << "BS " << L << " | " << R << endl;
        }
        int ZZZ = R;
        int ans = 0;
        L = -1;
        R = brd.size();
        while (R - L > 1) {
            int med = (L + R) / 2;
            //cout << "BS " << L << " | " << R << " : " << brdendl;
            if (brd[med] < ZZZ) {
                L = med;
            } else {
                R = med;
            }

        }
        if (L >= 0) ans = cst[L];
        cout << ans << '\n';
    }

    return 0;
}

/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100



3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
1
20 70

45 100
 */