#include <bits/stdc++.h>
#pragma GCC optimize ("Ofast")
using namespace std;

vector<int> arr;
vector<int> s;

const int N = 2e5 + 166;
int alive[N];
int curr;
vector<int> pos[N];

void add(int l, int r, int v) {
    for (int i = l; i <= r; i++) {
        s[i] += v;
    }
}

void increment(int l, int r, int v=1) {
    int b = 0;
    for (int i = l; i <= r; i++) {
        s[i] += b;
        b += v;
    }
};


void prints() {
    cout << "S: ";
    for (auto el: s) {
        cout << el << " ";
    }
    cout << endl;
}

void linear(int l, int t=1) {
    add(0, l - 1, l * t);
    increment(0, l - 1, -t);
}

int plseq[N];
const int V = 53;

int main() {
    int n;
    cin >> n;
    arr.resize(n);
    s.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    auto brr = arr;
    sort(brr.begin(), brr.end());
    brr.resize(unique(brr.begin(), brr.end()) - brr.begin());

    for (int i = 0; i < n; i++) {
        arr[i] = lower_bound(brr.begin(), brr.end(), arr[i]) - brr.begin();
    }
    for (int i = 0; i < n; i++) {
        pos[arr[i]].push_back(i);
    }

    if (brr.size() <= 53) {
        for (int st = 0; st < n; st++) {
            vector<int> ev;
            for (int t = 0; t < V; t++) {
                if (pos[t].size() == 0) continue;
                int L = -1;
                int R = pos[t].size();
                //cout << "t: " << t << endl;
                while(R - L > 1) {
                    int med = (L + R) /2 ;
                    if (pos[t][med] < st) {
                        L = med;
                    } else {
                        R = med;
                    }
                }
                //cout <<"st: " << st << " " << R << " " << endl;
                if (R == pos[t].size()) continue;
                ev.push_back(pos[t][R] - st);
            }
            sort(ev.begin(), ev.end());
            /*cout << "ev: ";
            for (auto el: ev) cout << el << " ";
            cout << endl;*/
            for (auto el: ev) {
                plseq[el]++;
                plseq[n - st]--;
            }
        }

        /*cout << "plseq: ";
        for (auto el: plseq) {
            cout << el << " ";
        } cout << endl;*/

        for (int i = 0; i < n; i++) {
            plseq[i + 1] += plseq[i];
            s[i] += plseq[i];
        }
    } else {
        for (int st = 0; st < n; st++) {
            curr = 0;
            for (int j = 0; j + st < n; j++) {
                if (alive[arr[st + j]] != st + 1) {
                    curr++;
                    alive[arr[st + j]] = st + 1;
                }
                s[j] += curr;
            }
        }
    }

    for (auto el: s) cout << el << " ";
    cout << endl;
    return 0;
}

/*
5
1 3 2 1 2

3
10 10 10
 */