#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;

vector<vector<int>> table, op, a, b;
vector<int> ans;
vector<int> curr;
int n, m, s;
vector<int> val;

bool dfs(int we, int row) {
    if (val[we] != -1) return val[we];
    //cout << "dfs " << we << " " << row << endl;
    //int ac =
    if (op[row][we - n] == 1) {
        val[we] = dfs(a[row][we - n] - 1, row) && dfs(b[row][we - n] - 1, row);
    } else {
        val[we] = dfs(a[row][we - n] - 1, row) || dfs(b[row][we - n] - 1, row);
    }
    return val[we];
}

/*struct SegmentTree {
    struct Node {
        int sum;
        int add;
        Node() {sum = add = 0;}
    };
    vector<Node> T;
    SegmentTree(int n) {
        int sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        T.resize(2 * n);
    };

    void rec_plus(int we, int l, int r, int L, int R, int pls) {
        if (r < L || R < l) continue;
        if (L <= l && r <= R) {
            T[we].sum += pls * (r - l + 1);
            T[we].add += pls;
            return;
        }
        int mid = (l + r) / 2;
        T[2 * we].sum += T[we].add * (mid - l + 1);
        T[2 * we + 1].sum += T[we].add * (r - mid);
        T[2 * we].add += T[we].add;
        T[2 * we + 1].add += T[we].add;
        T[we].add = 0;
        rec_plus(2 * we, l, mid, L, R, pls);
        rec_plus(2 * we + 1, mid + 1, r, L, R, pls);
        T[we].sum = T[we * 2].sum + T[we * 2 + 1].sum;
    }

    void add(int l, int r, int pls) {
        rec_plus(1, 0, T.size() / 2 - 1, l, r, pls);
    }

    void rec_get(int we)
};*/

vector<vector<int>> cnts;

bool check() {
    int cnt = 0;
    for (int i = 0; i < m; i++) {
        val.clear();
        val.resize(2 * n - 1, -1);
        for (int j = 0; j < n; j++) {
            val[j] = table[i][j] < curr[j];
        }
        cnt += dfs(val.size() - 1, i);
        /*if (i == m - 1) {
            cout << "val: ";
            for (auto el: val) cout << el << " ";
            cout << endl;
        }*/
    }
    /*cout << "cnt: " << cnt << endl;
    cout << "curr: ";
    for (auto el: curr) {
        cout << el << " ";
    }
    cout << endl << "-----" << endl;
    exit(0);*/
    if (cnt != s) return 0;
    ans = curr;
    return 1;
}

bool gen(int c=0) {
    if (c == curr.size()) {
        return check();
    }
    for (int i = 0; i <= m; i++) {
        curr[c] = i;
        if (gen(c + 1)) return 1;
    }
    return 0;
}

int main() {
    cin.sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> s;
    table.resize(m, vector<int>(n));
    op.resize(m, vector<int>(n - 1));
    a.resize(m, vector<int>(n - 1));
    b.resize(m, vector<int>(n - 1));
    for (int i = 0; i < a.size(); i++) {
        for (int j = 0; j < a[i].size(); j++) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];
        }
    }

    for (int i = 0; i < table.size(); i++) {
        for (int j = 0; j < table[i].size(); j++) {
            cin >> table[i][j];
        }
    }

    curr.resize(n);
    if (n == 2) {
        cnts.resize(m + 2, vector<int>(m + 2));
        for (int i = 0; i < m; i++) {
            for (int v1 = 0; v1 < 2; v1++) {
                for (int v2 = 0; v2 < 2; v2++) {
                    val.clear();
                    val.resize(2 * n - 1, -1);
                    val[0] = v1;
                    val[1] = v2;
                    int res = dfs(val.size() - 1, i);
                    if (res) {
                        int s1, s2;
                        int e1, e2;
                        if (v1 == 0) {
                            s1 = 0;
                            e1 = table[i][0];
                        } else {
                            s1 = table[i][0] + 1;
                            e1 = m;
                        }
                        if (v2 == 0) {
                            s2 = 0;
                            e2 = table[i][1];
                        } else {
                            s2 = table[i][1] + 1;
                            e2 = m;
                        }

                        cnts[s1][s2]++;
                        cnts[s1][e2 + 1]--;
                        cnts[e1 + 1][s2]--;
                        cnts[e1 + 1][e2 + 1]++;
                    }
                }
            }
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < m - 1; j++) {
                cnts[i][j + 1] += cnts[i][j];
            }
        }

        for (int i = 0; i < m - 1; i++) {
            for (int j = 0; j < m; j++) {
                cnts[i + 1][j] += cnts[i][j];
            }
        }

        for (int i = 0; i < m; i++) {
            for (int j = 0; j < m; j++) {
                if (cnts[i][j] == s) {
                    ans = {i, j};

                }
            }
        }

    } else {
        gen();
    }

    for (auto el: ans) {
        cout << el << " ";
    }
    cout << endl;
    return 0;
}

/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1
 */