#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;
int n, q;
vector<int> arr;
vector<vector<int>> dp;

void prepare() {
    dp.clear();
    dp.resize(arr.size(), {-1, -1, -1, -1});
}

int do_dp() {
    int ans = 0;
    for (int i = 0; i < dp.size(); i++) {
        int last = 0;
        for (int c = 0; c < dp[i].size(); c++) {
            if (dp[i][c] != -1) continue;
            if (c != 0) {
                if (dp[i - 1][c - 1] != -2) {
                    dp[i][c] = dp[i - 1][c - 1] + arr[i];
                } else dp[i][c] = -2;
            } else {
                dp[i][c] = -2;
                for (int c2 = 0; c2 < dp[i].size(); c2++) {
                    if (dp[i - 1][c2] != -2) {
                        dp[i][c] = max(dp[i][c], dp[i - 1][c2]);
                    }
                }
            }

            last = max(last, dp[i][c]);
        }

        for (int c = 0; c < dp[i].size(); c++) {
            ans = max(ans, dp[i][c]);
        }
    }
    return ans;
}

int calc() {
    int ans = 0;

    prepare();
    dp[0] = {0, -2, -2, -2};
    ans = do_dp();
    // 0 ...

    prepare();
    dp[0] = {-2, arr[0], -2, -2};
    dp[n - 1] = {-2, -2, -2, -2};
    ans = max(ans, do_dp());
    // 1 ... 0

    prepare();
    dp[0] = {-2, -2, arr[0] + arr[n - 1], -2};
    dp[n - 1] = {-2, -2, -2, -2};
    dp[n - 2] = {-2, -2, -2, -2};
    ans = max(ans, do_dp());
    // 1 ... 0 1

    prepare();
    dp[0] = {-2, -2, -2, arr[0] + arr[n - 1] + arr[n - 2]};
    dp[n - 1] = {-2, -2, -2, -2};
    dp[n - 2] = {-2, -2, -2, -2};
    dp[n - 3] = {-2, -2, -2, -2};
    ans = max(ans, do_dp());
    // 1 ... 0 1 1

    /*prepare();
    dp[0] = {-2, -2, -2, -2};
    dp[1] = {-2, -2, arr[0] + arr[1], -2};
    dp[n - 1] = {-2, -2, -2, -2};
    ans = max(ans, do_dp());
    // 1 1 ... 0

    prepare();
    do[0] = */

    return ans;
}

int main() {
    cin.sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    arr.resize(n);
    for (int i = 0; i < n ; i++) cin >> arr[i];
    cout << calc() << endl;
    cin >> q;
    while (q --> 0) {
        int p, v;
        cin >> p >> v;
        arr[p - 1] = v;
        cout << calc() << '\n';
    }
    return 0;
}

/*
6
1 2 3 4 5 6
2
6 0
2 5
 */