#include <iostream>

//#pragma pack(push, 1)
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse4,sse4,popcnt,abm,mmx,avx,tune=native")
//#pragma GCC optimize("fast-math")

using namespace std;

const long double EPS = 0.00000001;
const long double EPS2 = 0.000001;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    long double v[n], l[n];
    long double sumT = 0;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
        sumT += l[i] / v[i];
    }
    int m;
    cin >> m;
    int a[m], f[m];
    a[0] = 0;
    for (int i = 1; i < m; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> f[i];
    }
    int q;
    cin >> q;
    int s[q], t[q];
    for (int i = 0; i < q; ++i) {
        cin >> s[i] >> t[i];
        long double left = 0, right = 1000000001;
        long double delta = sumT - (t[i] - s[i]);
        while (right - left > EPS) {
            long double mid = left + (right - left) / 2;
            long double newDelta = 0;
            for (int x = 0; x < n; ++x) {
                newDelta += (l[x] / v[x]) - (l[x] / (v[x] + mid));
            }
            if (newDelta < delta) {
                left = mid;
            } else {
                right = mid;
            }
        }
        bool was = false;
        int res = 0;
        for (int i = 0; i < m - 1; ++i) {
            if (a[i] < left && left <= a[i + 1]) {
                res = f[i];
                was = true;
            }
        }
        if ((!was || left > a[m - 1]) && res > EPS) {
            res = f[m - 1];
        }
        cout << res << endl;
    } 
}
