#include <iostream>

//#pragma pack(push, 1)
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse4,sse4,popcnt,abm,mmx,avx,tune=native")
//#pragma GCC optimize("fast-math")

using namespace std;

bool lt(long double a, long double b, long double EPS) {
    return b - a > -EPS;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    long double v[n], l[n];
    long double sumT = 0;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
        sumT += l[i] / v[i];
    }
    int m;
    cin >> m;
    int a[m], f[m];
    a[0] = 0;
    for (int i = 1; i < m; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> f[i];
    }
    int q;
    cin >> q;
    int s[q], t[q];
    for (int i = 0; i < q; ++i) {
        cin >> s[i] >> t[i];
        long double left = 0, right = 1000000001;
        long double delta = sumT - (t[i] - s[i]);
        while (right - left > 0.000000001) {
            long double mid = left + (right - left) / 2;
            long double newDelta = 0;
            for (int x = 0; x < n; ++x) {
                newDelta += (l[x] / v[x]) - (l[x] / (v[x] + mid));
            }
            if (lt(newDelta, delta, 0.000001)) {
                left = mid;
            } else {
                right = mid;
            }
        }
        bool was = false;
        int res = 0;
        if (left < 0.0000001) {
            cout << 0 << endl;
            continue;
        }
        for (int i = 0; i < m - 1; ++i) {
            if (lt(a[i], left, 0.000000001) && lt(left, a[i + 1], 0.000001)) {
                res = f[i];
                was = true;
            }
        }
        if (!was || lt(a[m - 1], left, 0.000000001)) {
            res = f[m - 1];
        }
        cout << res << endl;
    } 
}
