#include <iostream>
#include <algorithm>

#pragma pack(push, 1)
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse4,popcnt,abm,mmx,avx,tune=native")
#pragma GCC optimize("fast-math")

using namespace std;

int cnt[100001];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    int a[n];
    int coco[n];
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        coco[i] = a[i];
    }
    sort(coco, coco + n);
    for (int i = 0; i < n; ++i) {
        int left = 0, right = n;
        while (right - left > 1) {
            int mid = left + (right - left) / 2;
            if (coco[mid] <= a[i]) {
                left = mid;
            } else {
                right = mid;
            }
        }
        a[i] = left;
    }
    int answers[n];
    for (int d = 1; d <= n; ++d) {
        fill(cnt, cnt + n, 0); 
        answers[d - 1] = 0;
        int currentAns = 0;
        for (int end = 0; end < n; ++end) {
            if (cnt[a[end]] == 0) {
                ++currentAns;
            }
            ++cnt[a[end]];
            if (end >= d) {
                --cnt[a[end - d]];
                if (cnt[a[end - d]] == 0) {
                    --currentAns;
                }
            }
            if (end >= d - 1) {
                answers[d - 1] += currentAns;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        cout << answers[i] << ' ';
    }
    cout << '\n';
}
