#include <iostream>
#include <bitset>
#include <cstdlib>
#include <ctime>
#include <algorithm>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <set>
#include <iomanip>
#include <complex>

#define fast ios_base::sync_with_stdio(0), cin.tie(), cout.tie()
#define endl '\n'
#define ll long long
#define int ll

using namespace std;

signed main() {
    fast;
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n;i++){
        cin >> a[i];
    }
    int q;
    cin >> q;
    vector<pair<int,int>> Q(q);
    for(int i = 0; i < q;i++){
        cin >> Q[i].first >> Q[i].second;
    }
    if(n < 15){
        auto solve = [&]()
        {
            int sum = 0;
            for(int i = 0; i < n;i++) {
                sum += a[i];
            }
            int LW = sum;
            for(int i = 1; i < 1<<n;i++){
                int res = 0;
                vector<int> ban;
                for(int j = 0; j < n;j++){
                    if(i&(1<<j)){
                        ban.push_back(j);
                        res += a[j];
                    }
                }
                ban.push_back(ban.front()+n);
                for(int j = 1; j < ban.size();j++){
                    if(abs(ban[j]-ban[j-1]) > 4){
                        res = sum;
                    }
                }

                LW = min(LW,res);
            }
            return sum-LW;
        };
        vector<int> answer(Q.size()+1);
        answer[0] = solve();
        for(int i = 1; i < answer.size();i++){
            a[Q[i-1].first-1] = Q[i-1].second;
            answer[i] = solve();
        }
        for(auto to:answer){
            cout << to << endl;
        }
        exit(0);
    }
    auto solve = [&]()
    {
        int mn = 1e18;
        for(int i = 0; i < 5;i++){
            for(int j = 0; j < 5;j++){
                int sum = a[i] + a[n-j-1];
                int L = i+1;
                int R = n-j-2;
                if(i + j > 3){
                    continue;
                }
                vector<int> cur(R-L+1);
                for(int p = L,k = 0; p <= R;p++,k++){
                    cur[k] = a[p];
                }
                if(cur.size() < 4){
                    mn = min(mn,sum);
                    continue;
                }
                vector<int> dp(cur.size(),1e18);
                for(int p = 0; p < 4;p++){
                    dp[p] = cur[p];
                }
                for(int p = 4; p < dp.size();p++){
                    for(int k = p-4;k<p;k++){
                        dp[p] = min(dp[p],dp[k] + cur[p]);
                    }
                }
                for(int p = dp.size()-1,free = 0;free<4;p--,free++){
                    mn = min(mn,sum + dp[p]);
                }
            }
        }
        return mn;
    };
    int sum = 0;
    for(int i = 0; i < n;i++){
        sum += a[i];
    }
    vector<int> answer(q+1,sum);
    answer[0] -= solve();
    for(int i = 1; i < answer.size();i++){
        sum -= a[Q[i-1].first-1];
        a[Q[i-1].first-1] = Q[i-1].second;
        sum += a[Q[i-1].first-1];
        answer[i] = sum - solve();
    }
    for(auto to:answer){
        cout << to << endl;
    }
    return 0;
}
