#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int maxn = 5001;

int n;
int used[maxn];
vector<int> s, a;

void solve(int st) {
    unordered_set<int> h;
    for (int i = st; i < n; i++) {
        h.insert(a[i]);
        s[i - st] += sz(h);
    }
}

void solve2(int st) {
    memset(used, 0, sizeof used);
    int cnt = 0;
    for (int i = st; i < n; i++) {
        if (used[a[i]] == 0) {
            cnt++;
            used[a[i]] = 1;
        }
        s[i - st] += cnt;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    cin >> n;
    a.resize(n);
    s.resize(n);
    int p = 1;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] > 5000) {
            p = 0;
        }
    }

    for (int i = 0; i < n; i++) {
        if (p == 0) solve(i);
        else solve2(i);
    }
    for (int i = 0; i < n; i++) {
        cout << s[i] << " ";
    }
    cout << "\n";


    return 0;
}
