#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int n, m, s;
vector<vector<int>> a, b, op, x;

bool solve(vector<int> &z) {
    int cnt[2] = {0, 0};
    for (int i = 0; i < m; i++) {
        vector<int> val(2 * n - 1);
        for (int j = 0; j < n; j++) {
            val[j] = (x[i][j] < z[j]);
        }
        for (int j = 0; j < n - 1; j++) {
            if (op[i][j] == 1) {
                val[n + j] = (val[a[i][j]] && val[b[i][j]]);
            } else {
                val[n + j] = (val[a[i][j]] && val[b[i][j]]);
            }
        }
        cnt[val.back()]++;
    }
    if (cnt[0] == s && cnt[1] == m - s) {
        return true;
    }
    return false;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    cin >> n >> m >> s;
    a.resize(m, vector<int> (n - 1));
    b.resize(m, vector<int> (n - 1));
    op.resize(m, vector<int> (n - 1));
    x.resize(m, vector<int> (n));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];
            a[i][j]--;
            b[i][j]--;
        }
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            cin >> x[i][j];
        }
    }
    if (n == 1) {
        for (int i = 0; i <= m; i++) {
            vector<int> z = {i};
            if (solve(z)) {
                cout << i << "\n";
                return 0;
            }
        }
    } else {
        for (int i = 0; i <= m; i++) {
            for (int j = 0; j <= m; j++) {
                vector<int> z = {i, j};
                if (solve(z)) {
                    cout << i << " " << j << "\n";
                    return 0;
                }
            }
        }
    }

    return 0;
}

/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1
*/
