#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int maxn = 200 * 1000 + 1;
int dp[maxn];
int an[maxn];

int n;
vector<int> a;

int get_cnt(int v) {
    int res = 0;
    int cur = lower_bound(all(a), v) - a.begin();
    cur = min(cur, n - 1);
    //cout << "res = " << v << " ";
    while (v > 0) {
        res += v / a[cur];
        v %= a[cur];
        cur--;
    }
    //cout << res << "\n";
    return res;
}

/*
4
1 5 10 50
3
2
8
50
*/

void precalc() {
    dp[0] = 0;
    dp[1] = 1;
    an[1] = 1;
    int mx = 1;
    int cur = 0;
    for (int i = 2; i < maxn; i++) {
        while (cur < n && a[cur] <= i) cur++;
        cur--;
        dp[i] = dp[i - a[cur]] + 1;
        if (dp[mx] < dp[i]) {
            mx = i;
        }
        an[i] = mx;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    cin >> n;
    a.resize(n);
    int pos = 1;
    int val = 1;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (!(n == 60 && a[i] == (1ll << i))) {
            pos = 0;
        }
        if (a[i] > 200 * 1000) {
            val = 0;
        }
    }
    if (val) {
        precalc();
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int b;
        cin >> b;
        if (n == 60 && pos) {
            int ans = 0;
            while ((1ll << ans) - 1 <= b) ans++;
            ans--;
            cout << (1ll << ans) - 1 << " " << ans << "\n";
            continue;
        }
        if (val == 1) {
            int ans = an[b];
            cout << ans << " " << dp[ans] << "\n";
            continue;
        }
        int ans = 0;
        int ind = 0;
        for (int j = 1; j <= b; j++) {
            int res = get_cnt(j);
            if (res > ans) {
                ans = res;
                ind = j;
            }
        }
        cout << ind << " " << ans << "\n";
    }

    return 0;
}
