#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int n;
vector<int> a;

int check(int v) {
    int cnt = 0;
    int pos = 1;
    int last = 0;
    int res = 0;
    for (int i = 0; i < n; i++) {
        if (v&(1<<i)) {
            if (pos == 1) cnt++;
            last++;
            res += a[i];
            if (last > 3) return 0;
        } else {
            last = 0;
            pos = 0;
        }
    }
    if (pos == 0 && last + cnt > 3) {
        return 0;
    }
    return res;
}

int solve() {
    int ans = 0;
    for (int i = 0; i < (1 << n); i++) {
        ans = max(ans, check(i));
    }
    return ans;
}

const int maxn = 40001;
vector<vector<int>> dp, dp0, dp1, dp2;

int solve2() {

    dp0[0][0] = 0;
    dp1[0][1] = a[0];
    dp1[1][0] = a[0];
    dp2[1][2] = a[0] + a[1];
    dp2[2][0] = a[0] + a[1];
    for (int i = 0; i < n; i++) {
        if (i == 0) {
            dp[i][0] = 0;
            dp[i][1] = a[i];
        } else {
            for (int j = 0; j <= 3; j++) {
                dp[i][0] = max(dp[i][0], dp[i - 1][j]);
                if (i > 0) {
                    dp0[i][0] = max(dp0[i][0], dp0[i - 1][j]);
                }
                if (i > 1) {
                    dp1[i][0] = max(dp1[i][0], dp1[i - 1][j]);
                }
                if (i > 2) {
                    dp2[i][0] = max(dp2[i][0], dp2[i - 1][j]);
                }
            }
            if (i > 0) {
                dp0[i][1] = dp0[i - 1][0] + a[i];
                dp0[i][2] = dp0[i - 1][1] + a[i];
                dp0[i][3] = dp0[i - 1][2] + a[i];
            }
            if (i > 1) {
                dp1[i][1] = dp1[i - 1][0] + a[i];
                dp1[i][2] = dp1[i - 1][1] + a[i];
                dp1[i][3] = dp1[i - 1][2] + a[i];
            }
            if (i > 2) {
                dp2[i][1] = dp2[i - 1][0] + a[i];
                dp2[i][2] = dp2[i - 1][1] + a[i];
                dp2[i][3] = dp2[i - 1][2] + a[i];
            }
            dp[i][1] = dp[i - 1][0] + a[i];
            dp[i][2] = dp[i - 1][1] + a[i];
            dp[i][3] = dp[i - 1][2] + a[i];
        }
    }
    int ans = dp[n - 1][0];
    ans = max(dp1[n - 1][2], ans);
    ans = max(dp1[n - 1][1], ans);
    ans = max(dp2[n - 1][1], ans);
    ans = max(dp0[n - 1][1], ans);
    ans = max(dp0[n - 1][2], ans);
    ans = max(dp0[n - 1][3], ans);
    return ans;
}

inupdate(int x, int dif) {
    if (x == 0) {
        dp0[0][0] = 0;
        dp1[0][1] = a[0] + dif;
    }
    if (x <= 1) {
        dp1[1][0] = a[0];
        dp2[1][2] = a[0] + a[1] + dif;
    }
    dp1[1][0] = a[0];
    dp2[1][2] = a[0] + a[1];
    dp2[2][0] = a[0] + a[1];
    for (int i = 0; i < n; i++) {
        if (i == 0) {
            dp[i][0] = 0;
            dp[i][1] = a[i];
        } else {
            for (int j = 0; j <= 3; j++) {
                dp[i][0] = max(dp[i][0], dp[i - 1][j]);
                if (i > 0) {
                    dp0[i][0] = max(dp0[i][0], dp0[i - 1][j]);
                }
                if (i > 1) {
                    dp1[i][0] = max(dp1[i][0], dp1[i - 1][j]);
                }
                if (i > 2) {
                    dp2[i][0] = max(dp2[i][0], dp2[i - 1][j]);
                }
            }
            if (i > 0) {
                dp0[i][1] = dp0[i - 1][0] + a[i];
                dp0[i][2] = dp0[i - 1][1] + a[i];
                dp0[i][3] = dp0[i - 1][2] + a[i];
            }
            if (i > 1) {
                dp1[i][1] = dp1[i - 1][0] + a[i];
                dp1[i][2] = dp1[i - 1][1] + a[i];
                dp1[i][3] = dp1[i - 1][2] + a[i];
            }
            if (i > 2) {
                dp2[i][1] = dp2[i - 1][0] + a[i];
                dp2[i][2] = dp2[i - 1][1] + a[i];
                dp2[i][3] = dp2[i - 1][2] + a[i];
            }
            dp[i][1] = dp[i - 1][0] + a[i];
            dp[i][2] = dp[i - 1][1] + a[i];
            dp[i][3] = dp[i - 1][2] + a[i];
        }
    }
    int ans = dp[n - 1][0];
    ans = max(dp1[n - 1][2], ans);
    ans = max(dp1[n - 1][1], ans);
    ans = max(dp2[n - 1][1], ans);
    ans = max(dp0[n - 1][1], ans);
    ans = max(dp0[n - 1][2], ans);
    ans = max(dp0[n - 1][3], ans);
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    //freopen("input.txt", "r", stdin);
    //freopen("output_slow.txt", "w", stdout);

    int q;
    cin >> n;
    dp.resize(n, vector<int> (4, 0));
    dp0.resize(n, vector<int> (4, 0));
    dp1.resize(n, vector<int> (4, 0));
    dp2.resize(n, vector<int> (4, 0));
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cin >> q;
    if (n > 3) {
        cout << solve2() << "\n";
    } else {
        cout << solve() << "\n";
    }
    for (int i = 0; i < q; i++) {
        int p, v;
        cin >> p >> v;
        p--;
        a[p]= v;
        if (n > 3) {
            cout << solve2() << "\n";
        } else {
            cout << solve() << "\n";
        }
    }

    return 0;
}
