#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast,no-stack-protector")

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    long long n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i<n; i++)
        cin >> a[i];
    vector<long long> ans(n);
    for(int i = 0; i<n; i++)
        ans[i] = (n-i)*(i+1);
    map<int, int> q;
    vector<pair<int, int> > e;
    for(int i = 0; i<n; i++){
        if(q.find(a[i])!=q.end())
            e.emplace_back(q[a[i]], i);
        q[a[i]] = i;
    }
    vector<int> cs(n+1);
    int m = e.size();
    for(int i = 0; i<m; i++)
        cs[e[i].second-e[i].first]++;
    long long cnt = 0, sm = 0;
    for(int i = 0; i<n; i++){
        sm += cnt;
        cnt += cs[i];
        sm += cs[i];
        ans[i] -= sm;
    }
    cs.assign(n, 0);
    for(int i = 0; i<m; i++){
        cs[e[i].second+1]++;
        cs[n-e[i].first]++;
    }
    cnt = 0, sm = 0;
    for(int i = 0; i<n; i++){
        //cout << cs[i] << ' ';
        sm += cnt;
        cnt += cs[i];
        sm += cs[i];
        ans[i] += sm;
    }
    //cout << endl;
    for(int i = 0; i<n; i++)
        cout << ans[i] << ' ';

    return 0;
}
/*
5
1 3 2 1 2

3
10 10 10
*/
