#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast,no-stack-protector")

struct Seq{

    int a, b, it;

    Seq(){}

};

istream& operator>>(istream &i, Seq &a){
    i >> a.a >> a.b >> a.it;
    a.a--;
    a.b--;
    return i;
}

int n, m, s;
vector<vector<int> > a;
vector<vector<Seq> > b;
vector<int> ans;

/*int solve(int it){
    //cout << it << endl;
    if(it==0){
        int jij = 0;
        for(int i = 0; i<m; i++){
            vector<int> val(2*n-1);
            for(int j = 0; j<n; j++)
                val[j] = (a[i][j]<ans[j]);
            for(int j = 0; j<n-1; j++){
                if(b[i][j].it==1)
                    val[n+j] = (val[b[i][j].a]&val[b[i][j].b]);
                else
                    val[n+j] = (val[b[i][j].a]|val[b[i][j].b]);
            }
            jij += val[2*n-2];
        }
        if(jij==s){
            for(int i = 0; i<n; i++)
                cout << ans[i] << ' ';
            exit(0);
        }
        return jij;
    }
    if(it==1){
        int l = -1, r = m;
        while(r-l>1){
            int m = (l+r)/2;
            ans.push_back(m);
            if(solve(0)>s)
                r = m;
            else
                l = m;
            ans.pop_back();
        }
        return 0;
    }
    for(int i = 0; i<=m; i++){
        ans.push_back(i);
        solve(it-1);
        ans.pop_back();
    }
    return 0;
}*/

pair<int, int> solve(int it){
    /*cout << it << ") ";
    for(int i = 0; i<ans.size(); i++)
        cout << ans[i] << ' ';
    cout << endl;*/
    if(it==0){
        int jij = 0;
        for(int i = 0; i<m; i++){
            vector<int> val(2*n-1);
            for(int j = 0; j<n; j++)
                val[j] = (a[i][j]<ans[j]);
            for(int j = 0; j<n-1; j++){
                if(b[i][j].it==1)
                    val[n+j] = (val[b[i][j].a]&val[b[i][j].b]);
                else
                    val[n+j] = (val[b[i][j].a]|val[b[i][j].b]);
            }
            jij += val[2*n-2];
        }
        if(jij==s){
            for(int i = 0; i<n; i++)
                cout << ans[i] << ' ';
            exit(0);
        }
        return {jij, jij};
    }
    ans.push_back(0);
    pair<int, int> kek = solve(it-1);
    int mn = kek.first;
    ans.pop_back();
    if(kek.first>s)
        return kek;
    ans.push_back(m);
    kek = solve(it-1);
    int mx = kek.second;
    ans.pop_back();
    if(kek.second<s)
        return kek;
    int l = -1, r = m;
    while(r-l>1){
        int m = (l+r)/2;
        ans.push_back(m);
        if(solve(it-1).first>s)
            r = m;
        else
            l = m;
        ans.pop_back();
    }
    return {mn, mx};
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> s;
    a.resize(m, vector<int>(n));
    b.resize(m, vector<Seq>(n-1));
    for(int i = 0; i<m; i++)
        for(int j = 0; j<n-1; j++)
            cin >> b[i][j];
    for(int i = 0; i<m; i++)
        for(int j = 0; j<n; j++)
            cin >> a[i][j];
    solve(n);
    cout << "WTF?!";

    return 0;
}
/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1
*/
