#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast,no-stack-protector")

struct Seq{

    int a, b, it;

    Seq(){
        a = 0;
        b = 0;
        it = 0;
    }

};

bool operator!=(Seq &a, Seq &b){
    return (a.a!=b.a)||(a.b!=b.b)||(a.it!=b.it);
}

istream& operator>>(istream &i, Seq &a){
    i >> a.a >> a.b >> a.it;
    a.a--;
    a.b--;
    return i;
}

int n, m, s;
vector<vector<int> > a;
vector<vector<Seq> > b;
vector<int> ans;

int check(){
    int jij = 0;
    /*cout << '\n';
    cout << "---\n";
    for(int i = 0; i<m; i++){
        for(int j = 0; j<n; j++)
            cout << a[i][j] << '<' << ans[j] << ' ';
        cout << '\n';
    }
    cout << "---\n";*/
    for(int i = 0; i<m; i++){
        vector<bool> val(2*n-1);
        for(int j = 0; j<n; j++)
            val[j] = (a[i][j]<ans[j]);
        for(int j = 0; j<n-1; j++){
            if(b[i][j].it==1)
                val[j+n] = (val[b[i][j].a]&val[b[i][j].b]);
            else
                val[j+n] = (val[b[i][j].a]|val[b[i][j].b]);
        }
        /*cout << i << ") ";
        for(int j = 0; j<2*n-1; j++)
            cout << val[j] << ' ';
        cout << '\n';*/
        //cout << val[2*n-2] << ' ';
        jij += val[2*n-2];
    }
    //cout << '\n';
    return jij;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> s;
    ans.resize(n);
    a.resize(m, vector<int>(n));
    b.resize(m, vector<Seq>(n-1));
    vector<Seq> pjij(n-1);
    for(int i = 0; i<m; i++)
        for(int j = 0; j<n-1; j++)
            cin >> b[i][j];
    for(int i = 0; i<m; i++)
        for(int j = 0; j<n; j++)
            cin >> a[i][j];
    int l = -1, r = n*m+1;
    while(r-l>1){
        int M = (l+r)/2;
        int sm = M;
        for(int i = 0; i<n; i++){
            if(sm>=m){
                ans[i] = m;
                sm -= m;
            }
            else{
                ans[i] = sm;
                sm = 0;
            }
        }
        //for(int i = 0; i<n; i++)
            //cout << ans[i] << ' ';
        //cout << '\n';
        int k = check();
        //cout << l << ':' << r << '=' << M << ' ' << check() << endl;
        if(k>s)
            r = M;
        if(k==s){
            for(int i = 0; i<n; i++)
                cout << ans[i] << ' ';
            return 0;
        }
        if(k<s)
            l = M;
    }

    return 0;
}
/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1

2 2 1
1 2 1
1 2 2
0 0
1 1

3 3 2
1 2 1
3 4 1
1 2 1
3 4 1
1 2 1
3 4 1
0 2 1
1 1 2
2 0 0

3 3 2
1 2 1
3 4 2
1 2 1
3 4 2
1 2 1
3 4 2
0 2 1
1 1 2
2 0 0
*/
