#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast,no-stack-protector")

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, x;
    cin >> n >> x;
    long long ans = 0;
    for(int a = 2; a<n; a++){
        if(a==x)
            continue;
        for(int b = 2; b<n; b++){
            if(b==x)
                continue;
            for(int c = max(1, (a*b-n)/(b-1)); c<a&&c<=a*b-n; c++){
                /// O(n^4)
                //for(int d = 1; d<b; d++)
                    //ans += (a*b-c*d==n);
                /// O(n^3)
                //cout << a << '*' << b << ' ' << c << ' ' << (a*b-c>=n) << '&' << (a*b-c*(b-1)<=n) << '&' << ((a*b-n)%c==0) << endl;
                //ans += ((a*b-c>=n)&&(a*b-c*(b-1)<=n)&&((a*b-n)%c==0));
                /// O(n^3) but some faster
                ans += ((a*b-n)%c==0);
            }
        }
    }
    cout << ans;

    return 0;
}
/*
3 0

5 0

5 3
*/
