#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <string.h>
#include <vector>
#include <random>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast,no-stack-protector")

int n;
vector<long long> a;
map<long long, long long> mem;

long long calc(long long b){
    if(mem.find(b)!=mem.end())
        return mem[b];
    long long ans = 0;
    for(int j = n-1; j>=0; j--){
        if(a[j]>b)
            continue;
        long long k = (b-(j==0?0:a[j-1]))/a[j];
        if(b-k*a[j]>(j==0?0:a[j-1]))
            k++;
        if(b-k*a[j]<0)
            k--;
        if(k==0)
            k = 1;
        //cout << b << ':' << a[j] << ' ' << k << endl;
        ans += k;
        b -= k*a[j];
    }
    return mem[b] = ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    a.resize(n);
    for(int i = 0; i<n; i++)
        cin >> a[i];
    int q;
    cin >> q;
    for(int i = 0; i<q; i++){
        long long b;
        cin >> b;
        if(n==60){
            long long it = 0;
            while((1ll<<(it+1))<=b)
                it++;
            if((1ll<<(it+1))-1==b)
                cout << b << ' ' << it+1 << '\n';
            else
                cout << (1ll<<it)-1 << ' ' << it << '\n';
            continue;
        }
        long long ans = 0, sm = 0;
        for(int j = 1; j<=b; j++){
            long long jij = calc(j);
            if(jij>sm){
                sm = jij;
                ans = j;
            }
        }
        cout << ans << ' ' << sm << '\n';
    }

    return 0;
}
/*
4
1 5 10 50
3
2
8
50

6
1 2 4 8 16 32
2
14
15
*/
