#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast,no-stack-protector")

const long long INF = 1000000000000000000;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<long long> a(n);
    for(int i = 0; i<n; i++)
        cin >> a[i];
    int q;
    cin >> q;
    for(int i = 0; i<q; i++){
        long long b;
        cin >> b;
        if(n==1||b<a[1]){
            cout << b << ' ' << b << '\n';
            continue;
        }
        long long ans = a[1]-1, sm = a[1]-1;
        int mn = -1;
        while(true){
            int l = mn, r = n;
            while(r-l>1){
                int m = (l+r)/2;
                if(a[m]>=sm)
                    r = m;
                else
                    l = m;
            }
            if(r==n)
                break;
            int j = r;
            /// O(n)
            long long jij = (min(b, ((j+1==n)?INF:(a[j+1]-1)))-sm)/a[j];
            sm += jij*a[j];
            ans += jij;
            /// O(b)
            /*while(true){
                if(sm+a[j]>b)
                    break;
                if(j+1<n&&sm+a[j]>=a[j+1])
                    break;
                ans++;
                sm += a[j];
            }*/
            mn = j;
        }
        cout << sm << ' ' << ans << '\n';
    }

    return 0;
}
/*
4
1 5 10 50
3
2
8
50

6
1 2 4 8 16 32
2
14
15
*/
