#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast,no-stack-protector")

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    vector<pair<int, int> > b(n);
    for(int i = 0; i<n; i++){
        cin >> a[i];
        b[i] = make_pair(a[i], i);
    }
    sort(b.rbegin(), b.rend());
    vector<bool> u(n);
    long long ans = 0;
    for(int i = 0; i<n; i++){
        int it = b[i].second;
        if((u[(it-3+n)%n]&&u[(it-2+n)%n]&&u[(it-1+n)%n])||(u[(it+3)]&&u[it+2]&&u[(it+1)]))
            continue;
        ans += a[it];
        u[it] = true;
    }
    cout << ans;

    return 0;
}
/*
4
1 5 10 50
3
2
8
50

6
1 2 4 8 16 32
2
14
15

3
1 3 4
4
10
100
1000
10000

4
1 2 3 4
10
3
4
5
6
7
8
9
10
100
1000
*/
