#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#include <bits/stdc++.h>
using namespace std;
#define endl '\n'
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define len(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define int long long
void solve();
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    return 0;
}

int n;
vector<int> a;

const int maxn = 1e6 + 7;

pair<int, int> calced[maxn];
int vals[maxn], upb[maxn];
int vals_sz = 0;


void gen_vals(int v){
    while (v != 0){
        vals[vals_sz++] = v;
        auto it = upper_bound(all(a), v); it--;
        int i = *it;
        v %= i;
    }
}


pair<int, int> calc(int v){
    int vind = lower_bound(vals, vals + vals_sz, v) - vals;
    if (calced[vind].first != -1)
        return calced[vind];
    if (v == 0){
        return calced[vind] = {0, 0};
    }
    int i = upb[vind];

    auto calced1 = calc(v % i);
    auto calced2 = calc(i - 1);

    int val1 = calced1.first + v / i; int ans1 = calced1.second + (v / i) * i;
    int val2 = calced2.first + (v - (i - 1)) / i; int ans2 = calced2.second + ((v - (i - 1)) / i) * i;
    if (val1 > val2){
        return calced[vind] = {val1, ans1};
    }
    return calced[vind] = {val2, ans2};
}



void solve(){
    cin >> n; a.resize(n); forn (i, n) cin >> a[i];
    int q; cin >> q; vector<int> qs(q); forn (i, q) cin >> qs[i];


    for (auto i : a) gen_vals(i - 1); vals[vals_sz++] = 0;
    for (auto i : qs) gen_vals(i);
    sort(vals, vals + vals_sz); vals_sz = unique(vals, vals + vals_sz) - vals;

    forn (i, vals_sz) calced[i] = {-1, -1};
    int cura = 0;

    for (int i = 1; i < vals_sz; ++i){
        while (cura + 1 < len(a) && a[cura + 1] <= vals[i]) ++cura;
        upb[i] = a[cura];
    }

    for (auto i : vals)
        calc(i);

    for (auto v : qs){
        auto res = calc(v);
        cout << res.second << ' ' << res.first << endl;
    }
}