#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;
typedef long double ldouble;

#ifdef LOCAL
#define TEST ""
const ll sz = 100;
#else
const ll sz = 2e5;
#endif

void calc(ll i, lvec &dp, lvec &a, ll mini) {
    dp[i] = dp[i - 1];
    if (i > mini + 1) dp[i] = max(dp[i], a[i - 2] + dp[i - 2]);
    if (i > mini + 2) dp[i] = max(dp[i], a[i - 2] + a[i - 3] + dp[i - 3]);
    if (i > mini + 3) dp[i] = max(dp[i], a[i - 2] + a[i - 3] + a[i - 4] + dp[i - 4]);
}

int main() {
#ifdef TEST
    cerr << "Test " << TEST << "\n";
#endif
#ifdef  LOCAL
    cerr << "LOCAL\n";
#ifdef TEST
    char in_file[100] = "in_";
    strcat(in_file, TEST);
    cerr << "Input file : " << in_file << "\n";
    if (!freopen(in_file, "r", stdin)) cerr << "No input found\n";
    if (!freopen("out", "w", stdout)) cerr << "Output failed\n";
#endif
#endif
    ll n, q;
    cin >> n;
    lvec v(n);
    for(auto &el : v) cin >> el;
    bool smpl = true;
    for(ll i = 0; i < n; i ++) {
        smpl &= (v[i] == (1LL << i)) ;
    }
    cin >> q;
    if(smpl) {
        while (q--) {
            ll b;
            cin >> b;
            bitset<100> bt(b);
            lpair ans = {bt.count(), b};
            for (ll i = 0; i < 100; i++) {
                if (bt[i]) {
                    bt.reset(i);
                    ans = max({i, bt.to_ullong()}, ans);
                }
                bt.set(i);
            }
            cout << ans.second << " " << ans.first << "\n";
        }
        return 0;
    }
    lvec req(sz + 1);
    for(ll i = 1; i < sz + 1; i ++) {
        ll delta = *(--upper_bound(v.begin(), v.end(), i));
        req[i] = req[i - delta] + 1;
    }
    cerr << "tick";
    vector<lpair> best;
    best.push_back({0, 0});
    for(ll i = 1; i < sz + 1; i ++) {
        lpair ans = max(best.back(), {req[i], i});
        best.push_back(ans);
    }
    cerr << "tick";
    while(q--) {
        ll b;
        cin >> b;
        cout << best[b].second << " " << best[b].first << "\n";
    }
    return 0;
}