#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;
vector <int> v;
vector <int> l;
vector <int> a;

double check(int m) {
    long double ans = 0;
    for (int i = 0; i < v.size(); i++) {
        ans += l[i] / (double)(v[i] + a[m]);
    }
    return ans;
}

int main() {
    int n;
    cin >> n;
    v.resize(n);
    l.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    for (int j = 0; j < n; j++) {
        cin >> l[j];
    }
    int m;
    cin >> m;
    a.resize(m, 0);
    for (int i = 1; i < m; i++) {
        cin >> a[i];
    }
    a.push_back((1 << 30));
    vector <int> f(m + 1, 0);
    for (int i = 1; i <= m; i++) {
        cin >> f[i];
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int s, t;
        cin >> s >> t;
        int L = 0, r = m + 1;
        while (L + 1 < r) {
            int m = (L + r) / 2;
            if (check(m) < (t - s) + 1e-8)
                r = m;
            else 
                L = m;
            continue;
        }
        if (check(L) <= (t - s) + 1e-8)cout << f[L] << endl;
        else cout << f[L + 1] << endl;
    }
}
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100
*/