#include <iostream>
#include <vector>

using namespace std;

int main() {
	int n;
	cin >> n;
	int road[10][2];
	for (int i = 0; i < n; i++) {
		cin >> road[i][0];
	}
	for (int i = 0; i < n; i++) {
		cin >> road[i][1];
	}
	int m;
	cin >> m;
	vector<double> ans(m + 1);
	for (int i = 0; i < n; i++) {
		ans[0] += (double)road[i][1] / road[i][0];
	}
	for (int j = 1; j < m; j++) {
		int a;
		cin >> a;
		for (int i = 0; i < n; i++) {
			ans[j] += (double)road[i][1] / (road[i][0] + a);
		}
	}
	int f[100000];
	for (int i = 0; i < m; i++) {
		cin >> f[i];
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int s, t, time;
		cin >> s >> t;
		time = t - s;
		int left = -1, right = m;
		while (right - left > 1) {
			int middle = (left + right) / 2;
			if (time < ans[middle]) {
				left = middle;
			}
			else {
				right = middle;
			}
		}
		if (right == 0) {
			cout << "0\n";
		}
		else {
			cout << f[right - 1] << "\n";
		}
	}
	return 0;
}