#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pb(x) push_back(x)
#define mp(x, y) make_pair(x, y)
#define ld long double
#define fi first
#define se second

int getans(vector<int>& vec, int a) {
	int ans = 0;
	for (int i = vec.size() - 1; i >= 0; --i) {
        ans += a / vec[i];
		a = a % vec[i];
	}
	return ans;
}

int main() {
	int n;
	cin >> n;
	vector<ll> tick;
	vector<ll> pref(n, 0);
	bool flag = true;
	for (ll i = 0; i < n; ++i) {
		ll x;
		cin >> x;
		if (i != 0) {
			if (x != tick.back()) {
				flag = false;
			}
		}
		tick.pb(x);
	}
	if (n == 60 && flag) {
		pref[0] = 0;
		for (ll i = 1; i < n; ++i) {
			pref[i] = pref[i - 1] + ceil((tick[i] + 0.0) / tick[i - 1]) - 1;
		}
		//cout << pref;
		//cout << "BANHAMMERv2.0\n";
		ll q;
		cin >> q;
		//cout << "BANHAMMER";
		for (ll i = 0; i < q; ++i) {
			ll b;
			cin >> b;
			++b;
			ll l = 0;
			ll r = n;
			while (l + 1 != r) {
				ll m = (l + r) / 2;
				if (tick[m] < b) {
					l = m;
				}
				else {
					r = m;
				}
			}
			//cout << "l " << l << '\n';
			ll need_b = b / tick[l] * tick[l] - 1;
			ll ans = pref[l] + b / tick[l] - 1;
			cout << need_b << ' ' << ans << '\n';
		}
		return 0;
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int b;
		cin >> b;
		int max_ans = 0;
		int ans = 0;
		for (int j = 1; j <= b; ++j) {
			int now = getans(tick, j);
			if (now > max_ans) {
				max_ans = now;
				ans = j;
			}
		}
		cout << ans << ' ' << max_ans << '\n';
	}
}
