//#pragma GCC optimize ("unroll_loops,fast_math")
//#pragma GCC target ("avx,avx2")

#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <algorithm>

#define ll long long
#define sz(v) (int)v.size()
#define forn(i, n) for (int i = 0; i < n; ++i)
#define forln(i, l, n) for (int i = l; i < n; ++i)
#define cinv(v) for (auto& x: v) cin >> x
#define fr first
#define se second
#define all(v) v.begin(), v.end()
#define pb push_back
#define pii pair<int, int>
#define pll pair<ld, ld>
#define ld long double
#define hm unordered_map

using namespace std;

const ll inf = (ll)2e9;
const ll N = 5001;

random_device rd;
mt19937 rnd(rd());

vector<vector<int>> goo, a;

void kek (vector<int>& ans, int s) {
    int m = sz (a), n = sz (a[0]), cnt = 0;
    forn (i, m) {
        vector<bool> val(2 * n - 1);
        forn (j, n) {
            val[j] = a[i][j] < ans[j];
        }
        forn (j, n - 1) {
            int _a = goo[i * (n - 1) + j][0], _b = goo[i * (n - 1) + j][1], op = goo[i * (n - 1) + j][2];
            if (op == 1) val[j + n] = (val[_a - 1] & val[_b - 1]);
            else {
                val[j + n] = (val[_a - 1] | val[_b - 1]);
            }
        }
        if (val.back()) ++cnt;
    }
    if (cnt == s) {
        for (auto& x: ans) cout << x << ' ';
        exit(0);
    }

}

void gen (vector<int>& ans, int n, int k, int s) {
    if (sz (ans) == n) {
        kek (ans, s);
        return;
    }
    forn (i, k + 1) {
        ans.pb (i);
        gen (ans, n, k, s);
        ans.pop_back();
    }
}

int main () {
    ios_base::sync_with_stdio (false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int n, m, s;
    cin >> n >> m >> s;
    goo = vector<vector<int>> (m * (n - 1), vector<int> (3));
    for (auto& v: goo) cinv (v);
    a = vector<vector<int>> (m, vector<int> (n));
    forn (i, m) {
        forn (j, n) cin >> a[i][j];
    }
    vector<int> ans;
    gen (ans, n, m, s);



}
/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1

*/