//#pragma GCC optimize ("unroll_loops,fast_math")
//#pragma GCC target ("avx,avx2")

#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <algorithm>

#define ll long long
#define sz(v) (int)v.size()
#define forn(i, n) for (int i = 0; i < n; ++i)
#define forln(i, l, n) for (int i = l; i < n; ++i)
#define cinv(v) for (auto& x: v) cin >> x
#define fr first
#define se second
#define all(v) v.begin(), v.end()
#define pb push_back
#define pii pair<int, int>
#define pll pair<ld, ld>
#define ld long double
#define hm unordered_map
//#define int ll

using namespace std;

const ll inf = (ll)2e9;
const ll N = (int)2e5 + 10;
//const ll N = (int)65;

//tg: @galebickosikasa

random_device rd;
mt19937 rnd(rd());

int max (vector<int>& v) {
    int mx = v[0];
    for (auto& x: v) mx = max (mx, x);
    return mx;
}

int max (vector<vector<int>>& v) {
    int mx = -1;
    for (auto& x: v) mx = max (mx, max (x));
    return mx;
}

int get_ans (vector<int>& goo) {
    int n = sz (goo);
    vector<vector<int>> dp (n, vector<int> (3)), used (n, vector<int> (3));
    dp[0][0] = goo[0];
    forln (i, 1, n) {
        if (i >= 2) dp[i][0] = max(dp[i - 2]) + goo[i];
        else dp[i][0] = goo[i];
        dp[i][1] = dp[i - 1][0] + goo[i];
        if (i >= 2) dp[i][2] = dp[i - 1][1] + goo[i];
    }
    return max (dp);
}

int main () {
    int n;
    cin >> n;
    vector<int> goo (n);
    cinv (goo);
    int q;
    cin >> q;
    cout << get_ans(goo) << '\n';
    while (q--) {
        int k, x;
        cin >> k >> x;
        --k;
        goo[k] = x;
        cout << get_ans(goo) << '\n';
    }




}
/*
6
1 2 3 4 5 6
2
6 0
2 5


 */