#include <bits/stdc++.h>
#define int long long
using namespace std;

int n, q;
vector<int> v;
vector<vector<vector<int>>> dp;
vector<int> ans;

void relax(int &a, int b) {
    a = max(a, b);
}

void go(int flag) {
    if (flag) {
        int a, b;
        cin >> a >> b;
        v[a - 1] = b;
    }
    dp.assign(4, vector<vector<int>>(n, vector<int>(4, 0)));
    for (int i = 0; i < 4; i++) {
        for (int j = 1 + i; j < n; j++) {
            relax(dp[i][j][0], dp[i][j - 1][0]);
            for (int k = 1; k < 4; k++) {
                dp[i][j][k] = dp[i][j - 1][k - 1] + v[j];
                relax(dp[i][j][0], dp[i][j - 1][k]);
            }
        }
    }
    ans.assign(4, 0);
    for (int i = 0; i < 4; i++) {
        for (int j = 0; j < 4; j++) {
            if (i + j > 3) continue;
            relax(ans[i], dp[i][n - 1][j]);
        }
        for (int j = 0; j < i; j++) {
            ans[i] += v[j];
        }
    }
    int maxans = -1;
    for (auto e : ans) relax(maxans, e);
    cout << maxans << "\n";
    return;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    v.resize(n);
    for (auto &e : v) cin >> e;
    cin >> q;
    dp.assign(4, vector<vector<int>>(n, vector<int>(4, 0)));
    go(0);
    while (q--) {
        go(1);
    }
}
