#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <utility>
#include <iomanip>
using namespace std;
#define int long long

int n;

inline void relax(int p1, int p2) {
	int x = (p1 + p2) / 2;
	int y = p2 - x;
	if ((p1 + p2) % 2 == 0 && x >= 1 && y >= 1) {
		cout << "Yes\n" << x << " " << y << "\n";
		exit(0);
	}
}

void solve() {
	
	cin >> n;
	if (n == 0) {
		cout << "Yes\n1 1";
		return;
	}
	for (int i = 1; i * i <= n; ++i) {
		if (n % i == 0) {
			relax(i, n / i);
			relax(n / i, i);
		}
	}
	cout << "No";
}

int32_t main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // DEBUG'
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
}