#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <utility>
#include <iomanip>
#include <unordered_set>
using namespace std;
#define int long long

vector <int> add;
vector <int> pref;

void addlen(int l, int r, int k = 1) {
	if (r - 1 >= 0) add[r - 1] += k;
	if (l - 2 >= 0) add[l - 2] -= k;
}

void sadd(int l, int r, int c) {
	if (l > r) return;
	if (r - 1 >= 0) pref[r - 1] += c;
	if (l - 2 >= 0) pref[l - 2] -= c;
}

void solve() {
	int n;
	cin >> n;
	vector <int> a(n);
	add.resize(n);
	pref.resize(n);
	for (auto& i : a) cin >> i;
	vector <int> d(n);
	map <int, vector <int>> mp;
	for (int i = 0; i < n; ++i) {
		mp[a[i]].push_back(i);
	}
	
	for (auto& vt : mp) {
		auto b = vt.second;
		b.push_back(n);
		for (int i = 0; i + 1 < b.size(); ++i) {
			addlen(1, min(b[i + 1] - b[i], b[i] + 1));
			sadd(b[i] + 2, b[i + 1] - b[i], b[i] + 1);
			sadd(b[i + 1] - b[i] + 1, b[i] + 1, b[i + 1] - b[i]);
			sadd(max(b[i] + 2, b[i + 1] - b[i] + 1), b[i + 1], b[i + 1] + 1);
			addlen(max(b[i] + 2, b[i + 1] - b[i] + 1), b[i + 1], -1);
		}
	}
	int tadd = 0, sum = 0;
	for (int i = n - 1; i >= 0; --i) {
		tadd += add[i];
		sum += pref[i];
		d[i] += (i + 1) * tadd + sum;
	}
	for (auto& i : d) cout << i << " ";
}

int32_t main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // DEBUG'
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
}