#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <utility>
#include <iomanip>
#include <unordered_set>
using namespace std;
//#define int long int
//#define ld long double

int cnt(int a, int b, int cd) {
	int add = 0;
	for (int c = 1; c * c <= cd; ++c) {
		if (cd % c == 0) {
			int d = cd / c;
			if (a > c&& b > d) ++add;
			if (c != d && a > d&& b > c) ++add;
		}
	}
	return add;
}

int solve(int n, int x) {
	int ans = 0;
	for (int a = n + 1; a >= 1 && clock() <= CLOCKS_PER_SEC; --a) {
		if (a == x) continue;
		for (int b = max(a, (n - 1) / a + 1); b <= n + 1; ++b) {
			if (b == x || a * b <= n) continue;
			int cd = a * b - n;
			int to = cnt(a, b, cd);
			ans += to;
			if (a != b) ans += to;
		}
	}
	return ans;
}

void solve() {
	int n, x;
	//cin >> n >> x;
	n = 3000;
	x = 0;
	cout << solve(n, x);
}

int32_t main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // DEBUG'
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
}