#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <utility>
#include <iomanip>
#include <unordered_set>
using namespace std;
#define int long long
#define ld long double

const int MAXC = 1000000;

int solve(vector <int> a) {
	int n = a.size();
	int ans = 0;
	for (int mask = 0; mask < (1ll << n); ++mask) {
		int mask1 = mask;
		vector <int> take(n);
		for (int i = 0; i < n; ++i) {
			take[i] = mask1 % 2;
			mask1 /= 2;
		}
		int fl = 1;
		for (int i = 0; i + 4 <= n && fl; ++i) {
			if (take[i] && take[i + 1] && take[i + 2] && take[i + 3]) fl = 0;
		}
		int p1 = 0;
		while (p1 < n && take[p1] == 1) ++p1;
		--p1;
		int p2 = n - 1;
		while (p2 > p1&& take[p2] == 1) --p2;
		++p2;
		if ((p1 + 1) + (n - 1 - p2 + 1) >= 4) fl = 0;
		if (fl == 0) continue;
		int now = 0;
		for (int i = 0; i < n; ++i) {
			now += take[i] * a[i];
		}
		if (now > ans) ans = now;
	}
	return ans;
}

void solve() {
	int n;
	cin >> n;
	vector <int> a(n);
	for (auto& i : a) cin >> i;
	cout << solve(a) << "\n";
	int q;
	cin >> q;
	while (q--) {
		int pos, val;
		cin >> pos >> val;
		--pos;
		a[pos] = val;
		cout << solve(a) << "\n";
	}
}

int32_t main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // DEBUG'
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
}