#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n; cin >> n;
    vector<int> limit(n);
    vector<int> length(n);
    for (int i = 0; i < n; i++) {
        cin >> limit[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> length[i];
    }
    int m; cin >> m;
    vector<int> segments(m + 1);
    segments[0] = 0;
    for (int i = 1; i < m; i++) {
        cin >> segments[i];
    }
    vector<int> sanction(m);
    for (int i = 0; i < m; i++) {
        cin >> sanction[i];
    }
    int q; cin >> q;
    for (int i = 0; i < q; i++) {
        int l, r; cin >> l >> r;
        int ans;
        int T = r - l;
        double left = 0;
        double right = 1e9;
        for (int i = 0; i < 100; i++) {
            double middle = (left + right) / 2;
            double t = 0;
            for (int j = 0; j < n; j++) {
                t += length[j] / (limit[j] + middle);
            }
            if (t <= T) {
                right = middle;
            } else {
                left = middle;
            }
        }
        //cout << left << " " << right << endl;
        if (left < 1e-5) {
            cout << 0 << endl;
            continue;
        }
        int l1 = 0;
        int r1 = m + 1;
        while (r1 - l1 > 1) {
            int m1 = (l1 + r1) / 2;
            if (segments[m1] <= left) l1 = m1;
            else r1 = m1;
        }
        cout << sanction[l1] << endl;
    }
}