#include <iostream>
#include <vector>
#define int long long

using namespace std;

vector<int> sz;
int n;

vector<int> ans(200005);
vector<pair<int, int>> pref_ans(200005);

int find(int i) {
    int left = 0;
    int right = n + 1;
    while (right - left > 1) {
        int middle = (left + right) / 2;
        if (sz[middle] > i) right = middle;
        else left = middle;
    }
    return left;
}

int answer(int b) {
    int res = 0;
    for (int i = n - 1; i >= 0; i--) {
        res += (b / sz[n - 1]);
        b %= sz[n - 1];
    }
    return res;
}

bool is2k(int a) {
    while (a > 1) {
        a /= 2;
        if (a % 2 == 0) return false;
    }
    return true;
}

signed main() {
    cin >> n;
    sz.resize(n);
    int status = 0;
    for (int i = 0; i < n; i++) {
        cin >> sz[i];
    }
    ans[0] = 0;
    ans[1] = 1;
    for (int i = 2; i < ans.size(); i++) {
        int f = find(i);
        ans[i] = ans[i % sz[f]] + (i / sz[f]);
    }
    pref_ans[0] = make_pair(ans[0], 0);
    for (int i = 1; i < ans.size(); i++) {
        if (pref_ans[i - 1].second < ans[i]) {
            pref_ans[i] = make_pair(i, ans[i]);
        } else {
            pref_ans[i] = pref_ans[i - 1];
        }
    }
    int q; cin >> q;
    for (int i = 0; i < q; i++) {
        int bq;
        cin >> bq;
        cout << pref_ans[bq].first << " " << pref_ans[bq].second << endl;
    }
}