#include <iostream>
#include <vector>

using namespace std;

vector<long long> sz;
int n;

vector<long long> ans;
vector<pair<long long, long long>> pref_ans;

int find(long long i) {
    int left = 0;
    int right = n;
    while (right - left > 1) {
        int middle = (left + right) / 2;
        if (sz[middle] > i) right = middle;
        else left = middle;
    }
    return left;
}

signed main() {
    cin >> n;
    sz.resize(n);
    ans.resize(200005);
    pref_ans.resize(200005);
    for (int i = 0; i < n; i++) {
        cin >> sz[i];
    }
    ans[0] = 0;
    ans[1] = 1;
    //cout << 1 << endl;
    for (long long i = 2; i < ans.size(); i++) {
        int f = find(i);
        long long res = i % sz[f];
        ans[i] = ans[res] + (i / sz[f]);
    }
    //cout << 1 << endl;
    pref_ans[0] = make_pair(ans[0], 0);
    for (int i = 1; i < ans.size(); i++) {
        if (pref_ans[i - 1].second < ans[i]) {
            pref_ans[i] = make_pair(i, ans[i]);
        } else {
            pref_ans[i] = pref_ans[i - 1];
        }
    }
    int q; cin >> q;
    for (int i = 0; i < q; i++) {
        int bq;
        cin >> bq;
        cout << pref_ans[bq].first << " " << pref_ans[bq].second << endl;
    }
}