#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

vector<long long> sz;
int n;

vector<long long> ans;
vector<pair<long long, long long>> pref_ans;

int find(long long i) {
    int left = 0;
    int right = n;
    while (right - left > 1) {
        int middle = (left + right) / 2;
        if (sz[middle] > i) right = middle;
        else left = middle;
    }
    return left;
}
bool is2k(long long a) {
    while (a > 1) {
        if (a % 2 != 0) return false;
        a /= 2;
    }
    return true;
}

signed main() {
    cin >> n;
    sz.resize(n);
    int status = 0;
    if (n != 60) status = 1;
    for (int i = 0; i < n; i++) {
        cin >> sz[i];
        if (!is2k(sz[i])) {
            //cout << sz[i] << endl;
            status = 1;
        }
    }
    if (status == 0) {
        vector<long long> minus1;
        long long a = 1;
        for (int i = 0; i < 63; i++) {
            minus1.push_back(a - 1);
            a *= 2;
        }
        /*for (int i = 0; i < 60; i++) {
            cout << minus1[i] << " ";
        }
        cout << endl;*/
        int q; cin >> q;
        for (int i = 0; i < q; i++) {
            long long bq; cin >> bq;
            int j = 0;
            for (;j < 60; j++) {
                if (minus1[j] > bq) {
                    j--;
                    break;
                }
            }
            cout << minus1[j] << " " << j << endl;
        }
    }
    if (status == 1) {
        ans.resize(200005);
        pref_ans.resize(200005);
        ans[0] = 0;
        ans[1] = 1;
        //cout << 1 << endl;
        for (long long i = 2; i < ans.size(); i++) {
            int f = find(i);
            long long res = i % sz[f];
            ans[i] = ans[res] + (i / sz[f]);
        }
        //cout << 1 << endl;
        pref_ans[0] = make_pair(ans[0], 0);
        for (int i = 1; i < ans.size(); i++) {
            if (pref_ans[i - 1].second < ans[i]) {
                pref_ans[i] = make_pair(i, ans[i]);
            } else {
                pref_ans[i] = pref_ans[i - 1];
            }
        }
        int q;
        cin >> q;
        for (int i = 0; i < q; i++) {
            int bq;
            cin >> bq;
            cout << pref_ans[bq].first << " " << pref_ans[bq].second << endl;
        }
    }
}