#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

int main()
{
    int n;
    cin >> n;
    vector<ll> v(n);
    for (int i = 0; i < n; i++) cin >> v[i];
    vector<ll> l(n);
    for (int i = 0; i < n; i++) cin >> l[i];
    int m;
    cin >> m;
    vector<ll> a(m);
    for (int i = 1; i < m; i++) cin >> a[i];
    vector<ll> f(m + 1);
    for (int i = 1; i <= m; i++) cin >> f[i];
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int s, t;
        cin >> s >> t;
        int time = t - s;
        int left = -1, right = m;
        while (right - left > 1) {
            int mid = (left + right) / 2;
            //cout << "mid = " << mid << endl;
            double cur = 0;
            for (int i = 0; i < n; i++) cur += (double)l[i] / (v[i] + a[mid]);
            //cout << "cur = " << cur << endl;
            if (cur > time) {
                left = mid;
            }
            else {
                right = mid;
            }
        }
        cout << f[right] << '\n';
    }
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
