#include <bits/stdc++.h>

using namespace std;
#define pb push_back
// #define int long long
const int maxn = 1e6 + 228;
const int ntr = 0;
vector<int> tree(4 * maxn), METKA(4 * maxn), sons(4 * maxn);
vector<int> S;

void refresh(int v) {
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
    sons[v] = sons[2 * v + 1] + sons[2 * v + 2];
}

void build_tree(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = S[l];
        sons[v] = 1;
    } else if (l + 1 < r) {
        int m = (l + r) / 2;
        build_tree(2 * v + 1, l, m);
        build_tree(2 * v + 2, m, r);
        refresh(v);
    }
}

void push(int v) {
    if (METKA[v] == 0) {return;}
    METKA[2 * v + 1] += METKA[v];
    METKA[2 * v + 2] += METKA[v];
    tree[v] += (METKA[v]) * sons[v];
    METKA[v] = 0;
}

void update(int v, int l, int r, int lq, int rq, int x) {
    if (r <= lq || l >= rq) {
        return;
    }
    if (l >= lq && rq >= r) {
        METKA[v] += x;
        push(v);
        push(2 * v + 1);
        push(2 * v + 2);
        int v2 = (v - 1) / 2;
        while (v2 > 0) {
            refresh(v2);
            v2 = (v2 - 1) / 2;
        }
        refresh(0);
    } else {
        int m = (l + r) / 2;
        update(2 * v + 1, l, m, lq, rq, x);
        update(2 * v + 2, m, r, lq, rq, x);
    }
}

int answer(int v, int l, int r, int lq, int rq) {
    if (r <= lq || l >= rq) {
        return ntr;
    }
    push(v);
    push(2 * v + 1);
    push(2 * v + 2);
    if (l >= lq && rq >= r) {
        return tree[v];
    } else {
        int m = (l + r) / 2;
        return answer(2 * v + 1, l, m, lq, rq) + answer(2 * v + 2, m, r, lq, rq);
    }
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    if (n <= 5000) {
        vector<int> A(n), B(n);
        for (int i = 0; i < n; i++) {cin >> A[i]; B[i] = A[i];}
        sort(B.begin(), B.end());
        unordered_map<int, int> heh;
        heh[B[0]] = 0;
        int cake = 1;
        for (int j = 1; j < n; j++) {
            if (B[j - 1] != B[j]) {
                heh[B[j]] = cake;
                cake++;
            }
        }
        vector<int> na;
        for (auto p : A) na.pb(heh[p]);
        A = na;
        S.resize(n);
        vector<bool> used(n);
        for (int start = 0; start < n; start++) {
            fill(used.begin(), used.end(), false);
            int cnt = 0;
            for (int i = start; i < n; i++) {
                if (!used[A[i]]) {
                    cnt++;
                }
                used[A[i]] = true;
                S[i - start] += cnt;
            }
        }
        for (auto num : S) {
            cout << num << ' ';
        }
        return 0;
    }
    vector<int> nA(n), B(n);
    for (int i = 0; i < n; i++) {cin >> nA[i]; B[i] = nA[i];}
    sort(B.begin(), B.end());
    unordered_map<int, int> heh;
    heh[B[0]] = 1;
    int cake = 2;
    for (int j = 1; j < n; j++) {
        if (B[j - 1] != B[j]) {
            heh[B[j]] = cake;
            cake++;
        }
    }
    vector<int> A;
    for (auto p : nA) A.pb(heh[p]);
    S.resize(n);
    int newn = pow(2, ceil(log2(n)));
    build_tree(0, 0, newn);
    for (int x = 1; x < cake; x++) {
        int ld = 0;
        for (int i = n - 1; i >= 0; i--) {
            if (A[i] == x) {
                ld = 0;
            } else {
                if (i == n - 1) {
                    ld = 1e9;
                } else {
                    ld++;
                }
            }
            if (ld != 1e9) {
                update(0, 0, newn, ld + 1, n - i + 1, 1);
            }
        }
    }
    for (int d = 1; d <= n; d++) {
        cout << answer(0, 0, newn, d, d + 1) << ' ';
    }
}





















/*
СЕГОДНЯ
У НАС ОБЗОР
НА КОНФЕТУ
ПРОИЗВОДСТВА
ШЕКСНИНСКОЙ
КОНДИТЕРСКОЙ
ФАБРИКИ
КОТОРАЯ НАЗЫВАЕТСЯ
КОЧЕГАР ПЕТЯ
 */