#pragma region Include
#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<assert.h>
using namespace std;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		in >> v[i];
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v)
{
	for (int i = 0; i < v.size(); i++)
		out << v[i] << ' ';

	if (!v.empty())
		out << '\n';

	return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> v)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
			out << v[i][j] << ' ';

		out << '\n';
	}

	return out;
}
#pragma endregion

long long check_n = 0;
void ans(long long a, long long b)
{
	assert(a * a - b * b == check_n);
	cout << "Yes\n" << a << ' ' << b << '\n';
}

long long get_odd(long long a)
{
	return 2 * a + 1;
}

int main()
{
	//long long x;
	//cin >> x;
	//for (long long i = 1; ; i += 2)
	//{
	//	cout << (i * i) % x << '\n';
	//	if (i != 1 && (i * i) % x == 1)
	//	{
	//		cout << "cycle: " << i;
	//		break;
	//	}
	//}

	long long n;
	while (cin >> n)
	{
		check_n = n;
		if (n == 0)
		{
			ans(1, 1);
			continue;
		}

		if (n == 1)
		{
			cout << "No\n";
			continue;
		}

		long long pow2 = 0;

		while (!(n & 1))
		{
			++pow2;
			n >>= 1;
		}

		if (pow2 % 2 == 0)
		{
			if (n > 1)
			{
				ans((1ll << (pow2 / 2)) * (n + 1) / 2, (1ll << (pow2 / 2)) * (n - 1) / 2);
			}
			else
			{
				bool flag = true;
				for (int i = 0; i <= pow2; i++)
				{
					long long d1 = 1ll << i, d2 = 1ll << (pow2 - i);
					if ((d1 + d2) % 2 == 0 && d2 - d1 > 0)
					{
						ans((d1 + d2) / 2, (d2 - d1) / 2);
						flag = false;
						break;
					}
				}
				if (flag)
					cout << "No\n";
			}
		}
		else
		{
			bool flag = true;
			if (n == 1)
			{
				for (int i = 0; i <= pow2; i++)
				{
					long long d1 = 1ll << i, d2 = 1ll << (pow2 - i);
					if ((d1 + d2) % 2 == 0 && d2 - d1 > 0)
					{
						ans((d1 + d2) / 2, (d2 - d1) / 2);
						flag = false;
						break;
					}
				}
				if (flag)
					cout << "No\n";
			}
			else
			{
				if (pow2 == 3)
				{
					ans(get_odd((n / 2) * 2 + 1), get_odd((n / 2) * 2));
				}
				else
				{
					cout << "No\n";
				}
			}
		}
	}
}