#pragma region Include
#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<assert.h>
using namespace std;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		in >> v[i];
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v)
{
	for (int i = 0; i < v.size(); i++)
		out << v[i] << ' ';

	if (!v.empty())
		out << '\n';

	return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> v)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
			out << v[i][j] << ' ';

		out << '\n';
	}

	return out;
}
#pragma endregion

int main()
{
	int n;
	cin >> n;
	vector<long long> v(n);
	cin >> v;

	long long sum = 0;
	for (int i = 0; i < n; i++)
		sum += v[i];

	vector<long long> p_sum(n);
	p_sum[0] = v[0];

	for (int i = 1; i < n; i++)
		p_sum[i] = p_sum[i - 1] + v[i];

	int best_i = 0;
	for (int i = 0; i < n; i++)
		if (abs(p_sum[i] - (sum - p_sum[i])) < abs(p_sum[best_i] - (sum - p_sum[best_i])))
			best_i = i;

	cout << best_i + 1 << '\n';
}