#include<iomanip>
#include<iostream>
#include<vector>
#include<set>
#include<map>
using namespace std;
multiset<int> sp;
/*int make(vector<int> &a, int p) {
    sp.clear();
    int ans = 0;
    int col = 0;
    for(int i = 0; i <= p - 1; ++i) {
        if(sp.find(a[i]) == sp.end()) {
            ++col;
        }
        sp.insert(a[i]);
    }
    ans += col;
    for(int i = p; i < a.size(); ++i) {
        sp.erase(sp.find(a[i - p]));
        if(sp.find(a[i - p]) == sp.end()) {
            --col;
        }
        if(sp.find(a[i]) == sp.end()) {
            ++col;
        }
        sp.insert(a[i]);
        ans += col;
    }
    return ans;
}*/
int make(vector<int> &pred, int p) {
    int ans = 0;
    int col = 0;
    vector<int> is(pred.size(), 0);
    for(int i = 0; i <= p - 1; ++i) {
        if(pred[i] != -1 && pred[i] >= i - p + 1) {
            is[pred[i]] = 1;
        }
        else {
            ++col;
        }
    }
    ans += col;
    for(int i = p; i < pred.size(); ++i) {
        if(is[i - p] == 0) {
            --col;
        }
        if(pred[i] != -1 && pred[i] >= i - p + 1) {
            is[pred[i]] = 1;
        }
        else {
            ++col;
        }
        ans += col;
    }
    return ans;
}
int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    map<int, int> pred;
    vector<int> pref(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        if(pred.find(a[i]) == pred.end()) {
            pref[i] = -1;
        }
        else {
            pref[i] = pred[a[i]];
        }
        pred[a[i]] = i;
    }
    for(int i = 1; i <= n; ++i) {
        int ans = make(pref, i);
        cout << ans << " ";
    }
    return 0;
}
