#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> num(n);
    for (int i = 0; i < n; i++)
        cin >> num[i];

    unordered_map<int, int> last;
    vector<int> add_up_to(n, 0);
    for (int i = 0; i < n; i++)
    {
        if (last.count(num[i]) == 1)
            add_up_to[i - last[num[i]] - 1]++;
        else
            add_up_to[i]++;
        last[num[i]] = i;
    }

    vector<ll> add(n, 0);
    ll sum = 0;
    for (int i = n - 1; i >= 0; i--)
    {
        sum += add_up_to[i];
        add[i] = sum;
    }

    vector<int> suff(n);
    unordered_set<int> unique;
    for (int i = n - 1; i >= 0; i--)
    {
        unique.insert(num[i]);
        suff[n - 1 - i] = unique.size();
    }

    vector<ll> ans(n);
    ans[0] = n;
    for (int i = 1; i < n; i++)
        ans[i] = ans[i - 1] - suff[i - 1] + add[i];

    for (ll x : ans)
        cout << x << " ";

    return 0;
}