#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

ll fastpow(ll p, ll q, ll mod)
{
    if (q == 0)
        return 1;

    ll z = fastpow(p, q / 2, mod);
    if (q % 2 == 0)
        return (z * z) % mod;
    else
        return (((z * z) % mod) * p) % mod;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, x;
    cin >> n >> x;

    ll ans = 0;
    for (ll a = 2; a <= n; a++)
    {
        if (a == x)
            continue;

        for (ll c = 1; c < a; c++)
        {
//            ll mn = (-n + a * 10000) % a;
//            ll rc = fastpow(c, a - 2, a);
//            ll start = (mn * rc) % a;
//            if (start == 0)
//                start += a;
            ll start = 1;
            while (start < a + 1 && (n + c * start) % a != 0)
                start++;
            if (start == a + 1)
                continue;

            ll last = n / (a - c);
            if (n % (a - c) == 0)
                last--;

            if (last % a > start % a)
                last -= ((last % a) - (start % a));
            else
                last -= (a + (last % a) - (start % a));

            if (last >= start)
            {
                ans += (last - start) / a + 1;

                ll sb = (n + c * start) / a;
                if (sb <= x && x <= last)
                    ans--;
            }
        }
    }

    cout << ans << endl;

    return 0;
}