#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int n;
vector<ll> num;

ll calc(ll x)
{
    ll ans = 0;
    for (int i = n - 1; i >= 0; i--)
    {
        ans += x / num[i];
        x %= num[i];
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;

    num.resize(n);
    for (int i = 0; i < n; i++)
        cin >> num[i];

    vector<ll> start(n, 0);
    for (int i = 1; i < n; i++)
        start[i] = start[i - 1] + ((num[i] - start[i - 1] - 1) / num[i - 1]) * num[i - 1];

    int q;
    cin >> q;

    for (int i = 0; i < q; i++)
    {
        ll x;
        cin >> x;

        int a = upper_bound(num.begin(), num.end(), x) - num.begin() - 1;
        ll alt = start[a] + ((x - start[a]) / num[a]) * num[a];

        ll cx = calc(x);
        ll calt = calc(alt);
        if (cx > calt)
            cout << x << " " << cx << endl;
        else
            cout << alt << " " << calt << endl;
    }

    return 0;
}