#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int n;
vector<ll> num;

void shift_left(vector<ll> &num)
{
    int n = num.size();
    ll x = num[0];
    for (int i = 0; i < n - 1; i++)
        num[i] = num[i + 1];
    num[n - 1] = x;
}

void shift_right(vector<ll> &num)
{
    int n = num.size();
    ll x = num[n - 1];
    for (int i = n - 1; i > 0; i--)
        num[i] = num[i - 1];
    num[0] = x;
}

ll calc()
{
    ll ans = 0;

    for (int i = 0; i < 5; i++)
        shift_left(num);

    for (int iter = 0; iter < 10; iter++)
    {
        vector<ll> dp(n, 0);
        dp[0] = num[0];
        for (int i = 1; i < n; i++)
        {
            for (int j = 2; j < 5 && i - j + 2 >= 0; j++)
            {
                ll val = 0;
                if (i - j >= 0)
                    val = max(val, dp[i - j]);
                if (i - j - 1 >= 0)
                    val = max(val, dp[i - j - 1]);
                for (int k = i - j + 2; k <= i; k++)
                    val += num[k];
                dp[i] = max(dp[i], val);
            }
        }

        ans = max(ans, dp[n - 2]);
        ans = max(ans, dp[n - 3]);
        shift_right(num);
    }

    for (int i = 0; i < 5; i++)
        shift_left(num);

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;

    num.resize(n);
    for (int i = 0; i < n; i++)
        cin >> num[i];

    int q;
    cin >> q;

    cout << calc() << endl;
    for (int i = 0; i < q; i++)
    {
        int a;
        ll b;
        cin >> a >> b;

        num[a - 1] = b;
        cout << calc() << endl;
    }

    return 0;
}