#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,avx,avx2,abm,mmx")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;};
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;};

const int MAXN = 2e5 + 10;

int n;
int a[MAXN];

void read() {
	cin >> n;
	for (int i = 1; i <= n; i++)
		cin >> a[i];
}

struct event{
	int pos, x, d, len;
	event() {}
	event(int p, int a, int b, int c) {
		pos = p, x = a, d = b, len = c;
	}
};



vector<event> have;

void add(int len, int pos) {
	int Len = n - pos + 1;
	int l = min(len, Len);
	int r = max(len, Len);
	if (l - 1 > 0)
	have.push_back({1, 1, 1, l - 1});
	if (r - l + 1 > 0)
	have.push_back({l, l, 0, r - l + 1});
	if (l - 1 > 0)
	have.push_back({r + 1, l - 1, -1, l - 1});
}

void build() {
	map<int, int> last;
	for (int i = 1; i <= n; i++) {
		int len = i - last[a[i]];
		add(len, i);
		last[a[i]] = i;
	}
}

ll ans[MAXN];



void calc() {	
	for (auto i : have) {
		int now = i.x;
		for (int pos = i.pos; pos <= i.pos + i.len - 1; pos++) {
			ans[pos] += now;
			now += i.d;
		}
	}
}

void run() {
	build();
	calc();
}

void write() {
	for (int i = 1; i <= n; i++)
		cout << ans[i] << " ";
	cout << endl;
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}

