#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,avx,avx2,abm,mmx")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;};
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;};

struct program{
	int a, b, op;
	program() {}
};
	
int n, m;
vector<vector<int> > a;
vector<vector<program> > have;

void read() {
	cin >> m >> n;
	have.resize(n);
	for (int i = 0; i < n; i++) {
		have[i].resize(m - 1);
		for (auto &j : have[i])
			cin >> j.a >> j.b >> j.op, j.a--, j.b--;
	}
	a.resize(n, vector<int> (m, 0));
	for (auto &i : a)
		for (auto &j : i)
			cin >> j;
}

vector<int> ans;

bool check(int pos, vector<int> & z) {
	vector<bool> now;
	for (int i = 0; i < m; i++)
		now.push_back(a[pos][i] < z[i]);
	for (auto i : have[pos]) {
		if (i.op == 1) {
			now.push_back(now[i.a] && now[i.b]);
		}
		else {
			now.push_back(now[i.a] || now[i.b]);
		}
	}
	return now.back();
}

int check(vector<int> z) {
	int ans = 0;
	for (int i = 0; i < n; i++)
		ans += check(i, z);
	return ans;
}

void solve_group_one() {
	if (m == 1) {
		for (int x = 0; x <= n; x++) {
			if (check({x})) {
				ans = {x};
				return;
			}
		}
	}
	else {
		for (int x = 0; x <= n; x++) {
			for (int y = 0; y <= n; y++) {
				if (check({x, y})) {
					ans = {x, y};
					return;
				}
			}
		}
	}
	assert(false);
}

void run() {
	if (m <= 2 && n <= 1000)
		solve_group_one();
}

void write() {
	for (auto i : ans)
		cout << i << " ";
	cout << endl; 
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}

