#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,avx,avx2,abm,mmx")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;};
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;};

#define int ll
const int MAXN = 2e5 +10;
int n;
int a[MAXN];

void read() {
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}
}

int pref[MAXN];

void build() {
	pref[0] = 0;
	for (int i = 1; i <= n; i++)
		pref[i] = pref[i - 1] + a[i];
}

int get(int l, int r) {
	return pref[r] - pref[l - 1];
}

int calc(int pos) {
	return get(1, pos) * get(pos + 1, n);
}

int ans;

void run() {
	build();
	ans = 1;
	for (int i = 1; i < n; i++) {
		if (calc(ans) < calc(i))
			ans = i;
	}
}

void write() {
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}

