#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,avx,avx2,abm,mmx")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;};
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;};
#define int ll
int n;
vector<ll> a;

void read() {
	cin >> n;
	a.resize(n);
	for (auto &i : a)
		cin >> i;
}


pair<int, int> solve(int x) {
	pair<int, int> ans = {0, x};
	while (x) {
		int fx = (--upper_bound(all(a), x)) - a.begin();
		fx = a[fx];
		ans.first += x / fx;
		x %= fx;
	}
	return ans;
}

pair<int, int> stupid(int x) {
	pair<int, int> ans = {0, 0};
	chkmax(ans, solve(x));
	for (int i = 0; i < n; i++)
		if (a[i] - 1 <= x)
			chkmax(ans, solve(a[i] - 1));
	return {ans.second, ans.first};	
}

vector<pair<int, int> > ans;

void run() {
	int q;
	cin >> q;
	while (q--) {
		int b;
		cin >> b;
		ans.push_back(stupid(b));
	}
}

void write() {
	for (auto i : ans)
		cout << i.first << " " << i.second << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}

