//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,avx,avx2,abm,mmx")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;};
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;};

#define int ll

int n;
vector<int> a;

void read() {
	cin >> n;
	a.resize(n);
	for (auto &i : a)
		cin >> i;
}

vector<pair<int, int>> pref;
vector<pair<int, int>> pref_max;

pair<int, int> make(pair<int, int> x, int now, int prev) {
	if (prev == 1) {
		return {now - 1, now - 1};
	}
	int it = (now - prev) / prev;
	//cout << x.first << " " << x.second << " " << now << " " << prev << " it = " << it << endl; 
	x.first += it;
	x.second += prev * it;
	//x.second++;
	return x;
}

void build() {
	pref.push_back({1, 1});
	if (n >= 2)
		pref.push_back({a[1] - 1, a[1] - 1});
	for (int i = 2; i < n; i++) {
		pref.push_back(make(pref[i - 1], a[i], a[i - 1]));
	}
	//cout << "puhh" << endl;
	pref_max.push_back(pref[0]);
	for (int i = 1; i < n; i++)
		pref_max.push_back(max(pref[i], pref_max[i - 1]));
}

pair<int, int> get_ans(int x) {
	int pos = --upper_bound(all(a), x) - a.begin();
	//cout << "x = " << x << endl;
	pair<int, int> ans = pref_max[pos];
	//cout << "fans = " << ans.first << " " << ans.second << endl;
	//cout << "pos = " << pos << endl;
	//cout << "pref = " << pref[pos].first << " " << pref[pos].second << endl;
	chkmax(ans, make(pref[pos], x + 1, a[pos]));
	return ans;
}

vector<pair<int, int> > ans;

void run() {
	build();
	//cout << "puhh" << endl;
	//cout << "pref = " << endl;
	//for (int i = 0; i < n; i++)
	//	cout << pref[i].first << " " << pref[i].second << endl;
	//cout << endl;
	//return;
	int q;
	cin >> q;
	while (q--) {
		int x;
		cin >> x;
		ans.push_back(get_ans(x));
	}
}

void write() {
	for (auto i : ans)
		cout << i.second << " " << i.first << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}

