#include <bits/stdc++.h>
#define int long long

using namespace std;

int n;
vector<int> mass;
vector<pair<int, int>> arr;

pair<int, int> check(int b) {
    int l = 0;
    int r = mass.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        //cout << l << " " << r << " " << mass[m] << " " << b << endl;
        if (mass[m] <= b) {
            l = m;
        }
        else {
            r = m;
        }
    }
    return make_pair(mass[l], l);
}

int check_new(int b) {
    int l = 0;
    int r = arr.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (arr[m].first <= b) {
            l = m;
        }
        else {
            r = m;
        }
    }
    return l;
}

pair<int, int> otv(int b) {
    if (b <= 20000) {
        return arr[b];
    }
    int k = check_new(b);
    pair<int, int> to = check(b);
    int xxx = to.first;
    int yyy = to.second;
    pair<int, int> x1 = otv(b % xxx);
    pair<int, int> x2 = otv(xxx - 1);
    x1 = make_pair(x1.first + b - (b % xxx), x1.second + b / xxx);
    x2 = make_pair(x2.first + (b / xxx - 1) * xxx, x2.second + b / xxx - 1);
    if (x1.second > x2.second) {
        return x1;
    }
    return x2;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n;
    mass.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> mass[i];
    }

    cin >> q;
    arr.push_back(make_pair(0, 0));
    for (int i = 1; i < 20001; ++i) {
        //cout << i << " " << check(i).first << " " << check(i).second << endl;
        if (arr[i - check(i).first].second + 1 > arr[i - 1].second) {
            arr.push_back(make_pair(i, arr[i - check(i).first].second + 1));
        }
        else {
            arr.push_back(arr[i - 1]);
        }
    }

    for (int i = 0; i < q; ++i) {
        int b;
        cin >> b;
        cout << otv(b).first << " " << otv(b).second << endl;
    }
}
