#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>
#include <functional>
using namespace std;

const int INF = 1000000001;

int main() {
	int n;
	cin >> n;
	vector <long long int> v(n);
	vector <long long int> len(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> len[i];
	}
	
	int m;
	cin >> m;
	vector <long long int> a(m);
	a[0] = 0;
	vector <long long int> f(m);
	for (int i = 0; i < m - 1; i++) {
		cin >> a[i + 1];
	}
	for (int i = 0; i < m; i++) {
		cin >> f[i];
	}

	int q;
	cin >> q;
	int long long dp_s, dp_f;
	for (int i = 0; i < q; i++) {
		cin >> dp_s >> dp_f;
		int long long t = dp_f - dp_s;
		int l = 0, r = m;
		while (l + 1 < r) {
			int mid = (l + r) / 2;
			double dp_t = 0;
			for (int j = 0; j < n; j++) {
				if (v[j] + a[mid] == 0) {
					dp_t = INF;
					break;
				}
				dp_t += (double)(len[j]) / (v[j] + a[mid]);
			}
			if (dp_t <= t) {
				r = mid;
			}
			else {
				l = mid;
			}
		}
		if (l == 0) {
			double dp_t = 0;
			for (int j = 0; j < n; j++) {
				if (v[j] == 0) {
					dp_t = INF;
					break;
				}
				dp_t = (double)(len[j]) / v[j];
			}
			if (dp_t <= t) {
				cout << 0;
			}
			else {
				cout << f[0];
			}
		}
		else {
			cout << f[l];
		}
		cout << "\n";
	}
	return 0;
}