#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>
#include <functional>
#include <map>
using namespace std;

const int INF = 1000000001;

int main() {
	int n;
	cin >> n;
	vector <long long int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}

	vector <long long int> dp_sum(n);
	dp_sum[0] = arr[0];
	for (int i = 1; i < n; i++) {
		dp_sum[i] = dp_sum[i - 1] + arr[i];
	}

	long long int min_dis = -1;
	int ans = -1;
	for (int i = 0; i < n; i++) {
		long long int x = dp_sum[i];
		long long int y = dp_sum[n - 1] - dp_sum[i];
		if (x < y) {
			swap(x, y);
		}
		if ((ans == -1) || (min_dis > dp_sum[n - 1] - (y * 2))) {
			ans = i;
			min_dis = dp_sum[n - 1] - (y * 2);
		}
	}
	cout << ans + 1;
//	system("pause");
	return 0;
}