#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

#define int long long 
#define endl "\n"
#define double long double 
#define pii pair<int, int>
#define vec vector
#define pb push_back
#define $(x) (int)((x).size())
#define dbg(x) cout << #x << " = " << (x) << endl;

using namespace std;

void solve(); signed main() {
	// freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(6);
	solve();
	return 0;
}

const double INF = 1e18;
const int MAXN = 2e5 + 10;
double v[MAXN];
double l[MAXN];

void solve() {
	int n; 
	cin >> n;
	
	for (int i = 0; i < n; ++i) {
		cin >> v[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
	}

	int m;
	cin >> m;
	vec<double> a(m - 1);
	vec<double> f(m);
	for (double i = 0; i < m - 1; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < m; ++i) {
		cin >> f[i];
	}

	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		double s, t;
		cin >> s >> t;
		double T = t - s;
		double L = 0, R = m;

		double tmp = 0;
		for (int j = 0; j < n; ++j) {
			tmp += l[j] / v[j];
		}

		if (tmp <= T) {
			cout << 0 << endl;
			continue;
		}

		while (R - L > 1) {
			double mid = (R + L) / 2;
			double cur = 0;
			for (int j = 0; j < n; ++j) {
				cur += l[j] / (v[j] + a[mid] - 1.);
			}
			if (cur <= T) {
				R = mid;
			}
			else {
				L = mid;
			}
		}

		cout << (int)f[R] << endl;
	}
}