#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

#define int long long 
#define endl "\n"
#define double long double 
#define pii pair<int, int>
#define vec vector
#define pb push_back
#define $(x) (int)((x).size())
#define dbg(x) cout << #x << " = " << (x) << endl;

using namespace std;

void solve(); signed main() {
	// freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(6);
	solve();
	return 0;
}

void solve() {
	int n, x;
	cin >> n >> x;

	int ans = 0;
	for (int a = 2; a <= 500; ++a) {
		for (int b = 2; b <= 500; ++b) {
			if (a != x && b != x) {
				int t = a * b - n;
				if (t <= 0) continue;
				int d = 1;
				vec<int> divs;
				while (d * d < t) {
					if (t % d == 0) {
						int d1 = d, d2 = t / d;
						divs.pb(d1);
						divs.pb(d2);
					}
					d++;
				}
				if (d * d == t) {
					divs.pb(d);
				}
				sort(divs.begin(), divs.end());

				int id1 = lower_bound(divs.begin(), divs.end(), a) - divs.begin();
				int id2 = lower_bound(divs.begin(), divs.end(), b) - divs.begin();
				id2--;
				id1--;
				if (id1 == -1 || id2 == -1) continue; 
				int cur = t / divs[id1];
				int curid = lower_bound(divs.begin(), divs.end(), cur) - divs.begin();
				if (curid > id2) {
					continue;
				}
				int l = -1, r = id1;
				while (r - l > 1) {
					int mid = (r + l) / 2;
					int cur = t / divs[mid];
					int curid = lower_bound(divs.begin(), divs.end(), cur) - divs.begin();
					if (curid <= id2) {
						r = mid;
					}
					else {
						l = mid;
					}
				}
				ans += (id1 - r + 1);
			}
		}
	}

	cout << ans << endl;	
}