#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

#define int long long 
#define endl "\n"
#define double long double 
#define pii pair<int, int>
#define vec vector
#define pb push_back
#define $(x) (int)((x).size())
#define dbg(x) cout << #x << " = " << (x) << endl;

using namespace std;

void solve(); signed main() {
	// freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(6);
	solve();
	return 0;
}

const int MAXN = 2e5 + 10, INF = 1e18;
int n;
vec<int> a;

void query() {
	int mx = -INF;
	for (int mask = 0; mask < (1 << n); ++mask) {
		vec<int> b;
		int sum = 0;
		for (int i = 0; i < n; ++i) {
			if ((mask >> i) & 1) {
				b.pb(1);
			}
			else {
				b.pb(0);
			}
		}
		for (int i = 0; i < n; ++i) {
			b.pb(b[i]);
		}
		bool flag = false;
		for (int i = 0; i < 2 * n - 3; ++i) {
			if (b[i] && b[i + 1] && b[i + 2] && b[i + 3]) {
				flag = true;
				break;
			}
		}
		if (flag) continue;
		for (int i = 0; i < n; ++i) {
			if (b[i]) {
				sum += a[i];
			}
		}
		mx = max(sum, mx);
	}
	cout << mx << endl;
}

void solve() {
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	int q;
	cin >> q;
	query();

	for (int i = 0; i < q; ++i) {
		int p, v;
		cin >> p >> v;
		p--;
		a[p] = v;
		query();
	}
}