#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

inline sum(int a, int b, int c, int d)
{
    return (a == b ? 1 : 2) * (c == d ? (a > c && b > d ? 1 : 0) : ((a > c && b > d ? 1 : 0) + (a > d && b > c ? 1 : 0)));
}

int main()
{
    ios_base::sync_with_stdio(false);
    //freopen("input.txt", "r", stdin);
    int n, x;
    cin >> n >> x;
    vector<vector<int> > div(n * n + 1);
    for (int i = 1; i <= n; i++)
    {
        for (int j = i; i + j <= n + 1; j++)
        {
            div[i * j].push_back(i);
        }
    }
    int cnt = 0;
    for (int a = 1; a < n + 1; a++)
    {
        for (int b = a; b < n + 1; b++)
        {
            if (a != x && b != x && a * b > n)
            {
                int p = a * b - n;
                for (int i = 0; i < div[p].size(); i++)
                {
                    int c = div[p][i];
                    int d = p / c;
                    cnt += sum(a, b, c, d);
                }
            }
        }
    }
    cout << cnt << endl;
    return 0;
}
