#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

int n;
vector<long long> a;

long long rec(long long b)
{
    if (b == 0)
    {
        return 0;
    }
    int left = 0, right = n;
    while (left + 1 < right)
    {
        int mid = (left + right) / 2;
        if (a[mid] > b)
        {
            right = mid;
        }
        else
        {
            left = mid;
        }
    }
    long long k = b / a[left];
    return rec(b - a[left] * k) + k;
}

int main()
{
    ios_base::sync_with_stdio(false);
    //freopen("input.txt", "r", stdin);
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    int q;
    cin >> q;
    for (int k = 0; k < q; k++)
    {
        long long b;
        cin >> b;
        long long ans = 0;
        long long cur = 0;
        for (long long i = 1; i <= b; i++)
        {
            long long p = rec(i);
            if (ans < p)
            {
                ans = p;
                cur = i;
            }
        }
        cout << cur << " " << ans << endl;
    }
    return 0;
}
