#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

int n;
vector<long long> a;

long long rec(long long b)
{
    if (b == 0)
    {
        return 0;
    }
    int left = 0, right = n;
    while (left + 1 < right)
    {
        int mid = (left + right) / 2;
        if (a[mid] > b)
        {
            right = mid;
        }
        else
        {
            left = mid;
        }
    }
    long long k = b / a[left];
    return rec(b - a[left] * k) + k;
}

int main()
{
    ios_base::sync_with_stdio(false);
    //freopen("input.txt", "r", stdin);
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    int q;
    cin >> q;
    vector<pair<long long, int> > b(q);
    for (int i = 0; i < q; i++)
    {
        cin >> b[i].first;
        b[i].second = i;
    }
    sort(b.begin(), b.end());
    vector<pair<long long, long long> > qans(q);
    long long i = 1;
    long long ans = 0;
    long long cur = 0;
    for (int k = 0; k < q; k++)
    {
        int id = b[k].second;
        long long p = 0;
        for (; i <= b[k].first; i++)
        {
            p = rec(i);
            if (ans < p)
            {
                ans = p;
                cur = i;
            }
        }
        qans[id].first = cur;
        qans[id].second = ans;

    }
    for (int i = 0; i < q; i++)
    {
        cout << qans[i].first << " " << qans[i].second << endl;
    }
    return 0;
}
