#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

long long Max(const vector<long long> &a)
{
    long long x = -1;
    for (int i = 0; i < a.size(); i++)
    {
        x = max(x, a[i]);
    }
    return x;
}

int main()
{
    ios_base::sync_with_stdio(false);
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector<long long> a(2 * n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        a[i + n] = a[i];
    }
    vector<vector<long long> > d(2 * n, vector<long long> (4, 0));
    int q;
    cin >> q;
    for (int k = 0; k <= q; k++)
    {
        long long ans = -1;
        for (int s = 0; s <= 3; s++)
        {
            for (int j = 0; j <= 3; j++)
            {
                for (int i = 0; i < 2 * n; i++)
                {
                    d[i][j] = 0;
                }
            }
            d[s][1] = a[s];
            for (int i = s + 1; i < s + n; i++)
            {
                d[i][0] = Max(d[i - 1]);
                d[i][1] = d[i - 1][0] + a[i];
                d[i][2] = d[i - 1][1] + a[i];
                d[i][3] = d[i - 1][2] + a[i];
            }
            ans = max(ans, d[s + n - 1][0]);
        }
        cout << ans << endl;
        if (k != q)
        {
            int v, x;
            cin >> v >> x;
            v--;
            a[v] = x;
            a[v + n] = x;
        }
    }
    return 0;
}
