import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Objects;
import java.util.Scanner;

public class Main {
    PrintWriter out;
    Scanner sc;

    public static void main(String [] arg) {
        new Main().run();
    }

    public void run() {
        sc = new Scanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();

    }

    public void solve() {
        int n = nextInt();
        boolean flag = false;
        int [] arr = new int[n];
        for (int i = 0; i < n; i++) {
            arr[i] = nextInt();
            if (arr[i] > 5000) {
                flag = true;
            }
        }
        HashMap<Integer, Integer> m = new HashMap<>();
        int num = 0;
        for (int i = 0; i < n; i++) {
            if (m.containsKey(arr[i])) {
                arr[i] = m.get(arr[i]);
            } else {
                m.put(arr[i], num);
                arr[i] = num;
                num++;
            }
        }

        if (n > 500) {
            for (int i = 1; i <= n; i++) {

                int[] map = new int[5001];
                int ans = 0;
                int count = 0;
                for (int j = 0; j < i; j++) {
                    if (map[arr[j]] == 0) {
                        count++;
                    }
                    map[arr[j]] = map[arr[j]] + 1;
                }
                ans += count;
                for (int j = i; j < n; j++) {
                    if (map[arr[j - i]] == 1) {
                        count--;
                    }
                    map[arr[j - i]] = map[arr[j - i]] - 1;

                    if (map[arr[j]] == 0) {
                        count++;
                    }
                    map[arr[j]] = map[arr[j]] + 1;
                    ans += count;
                }
                out.print(ans + " ");
            }
            return;
        }

        for (int i = 1; i <= n; i++) {
            HashMap<Integer, Integer> map = new HashMap<>();
            int ans = 0;
            int count = 0;
            for (int j = 0; j < i; j++) {
                if (!map.containsKey(arr[j])) {
                    map.put(arr[j], 1);
                    count++;
                } else {
                    map.put(arr[j], map.get(arr[j]) + 1);
                }
            }
            ans += count;
            for (int j = i; j < n; j++) {
                if (map.get(arr[j - i]) == 1) {
                    count--;
                }
                map.put(arr[j - i], map.get(arr[j - i]) - 1);

                if (!map.containsKey(arr[j])) {
                    map.put(arr[j], 0);
                    count++;
                } else if (map.get(arr[j]) == 0) {
                    count++;
                }
                map.put(arr[j], map.get(arr[j]) + 1);
                ans += count;
            }
            out.print(ans + " ");
        }
    }



    public int nextInt() {
        return sc.nextInt();
    }

    public long nextLong() {
        return  sc.nextLong();
    }

    public String nextToken() {
        return sc.next();
    }
}