import java.io.PrintWriter;
import java.util.Scanner;

public class Main {
    PrintWriter out;
    Scanner sc;

    public static void main(String [] arg) {
        new Main().run();
    }

    public void run() {
        sc = new Scanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();

    }

    public void solve() {
        int n = nextInt();
        int [] arr = new int[n];
        for (int i = 0; i < n; i++) {
            arr[i] = nextInt();
        }
        long [] pr = new long[n];
        long [] suf = new long[n];
        pr[0] = arr[0];
        for (int i = 1; i < n; i++) {
            pr[i] = pr[i - 1] + arr[i];
        }
        suf[n - 1] = arr[n - 1];
        for (int i = n - 2; i >= 0; i--) {
            suf[i] = suf[i + 1] + arr[i];
        }
        long max = 0;
        int ind = 1;
        for (int i = 0; i < n - 1; i++) {
            long c = pr[i] * suf[i + 1];
            if (c >= max) {
                max = c;
                ind = i + 1;
            }
        }

        out.println(ind);
    }

    public int nextInt() {
        return sc.nextInt();
    }

    public long nextLong() {
        return  sc.nextLong();
    }

    public String nextToken() {
        return sc.next();
    }
}

