import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

public class Main {
    PrintWriter out;
    Scanner sc;

    public static void main(String [] arg) {
        new Main().run();
    }

    public void run() {
        sc = new Scanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();

    }

    public boolean comp(long a, long b, long c, long d) {
        if (a == d && b == c) {
            return true;
        }
        BigInteger q = BigInteger.valueOf(a);
        q = q.multiply(BigInteger.valueOf(b));
        BigInteger w = BigInteger.valueOf(c);
        w = w.multiply(BigInteger.valueOf(d));
        return (q.compareTo(w) > 0);
    }

    public void solve() {
        int n = nextInt();
        int [] arr = new int[n];
        for (int i = 0; i < n; i++) {
            arr[i] = nextInt();
        }
        long [] pr = new long[n];
        long [] suf = new long[n];
        pr[0] = arr[0];
        for (int i = 1; i < n; i++) {
            pr[i] = pr[i - 1] + arr[i];
        }
        suf[n - 1] = arr[n - 1];
        for (int i = n - 2; i >= 0; i--) {
            suf[i] = suf[i + 1] + arr[i];
        }
        long maxA = 0;
        long maxB = 0;
        int ind = 0;
        for (int i = 0; i < n - 1; i++) {
            //long c = pr[i] * suf[i + 1];
            if (comp(pr[i], suf[i + 1], maxA, maxB)) {
                maxA = pr[i];
                maxB = suf[i + 1];
                ind = i + 1;
            }
        }

        out.println(ind);
    }

    public int nextInt() {
        return sc.nextInt();
    }

    public long nextLong() {
        return  sc.nextLong();
    }

    public String nextToken() {
        return sc.next();
    }
}

