import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

public class Main {
    PrintWriter out;
    Scanner sc;

    public static void main(String [] arg) {
        new Main().run();
    }

    public void run() {
        sc = new Scanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();

    }

    public void solve() {
        int n = nextInt();
        if (n == 1) {
            return;
        }
        long [] arr = new long[n];
        for (int i = 0; i < n; i++) {
            arr[i] = nextLong();
        }
        long [] dp = new long[n];
        dp[0] = arr[1] - 1;
        for (int i = 1; i < n - 1; i++) {
            dp[i] = (arr[i + 1] - 1 - dp[i - 1] * arr[i - 1]) / arr[i];
        }
//        for (int i = 0; i < n; i++) {
//            System.out.print(dp[i] + " ");
//        }
//        System.out.println();

        int q = nextInt();
        for (int i = 0; i < q; i++) {
            long b = nextLong();
            long sum = 0;
            long count = 0;
            int j = 0;
            while (sum < b && j < n - 1) {
                sum += dp[j] * arr[j];
                count += dp[j];
                j++;
            }
            if (sum > b) {
                sum -= dp[j - 1] * arr[j - 1];
                count -= dp[j - 1];
                count += (b - sum) / arr[j - 1];
                sum += (b - sum) / arr[j - 1] * arr[j - 1];
            } else if (sum < b){
                count += (b - sum) / arr[n - 1];
                sum += (b - sum) / arr[n - 1] * arr[n - 1];
            }

            out.println(sum + " " + count);
        }
//        for (int i = 0; i < q; i++) {
//            long b = nextLong();
//            long count = 0;
//            long sum = 0;
//            long addS = 0;
//            long addC = 0;
//            if (b >= arr[n - 1] * 2) {
//                addC = (b / arr[n - 1] - 1);
//                addS = arr[n - 1] * (b / arr[n - 1] - 1);
//                b -= arr[n - 1] * (b / arr[n - 1] - 1);
//
//            }
//            int j = 0;
//            while (sum < b && j < n - 1) {
//                if ((arr[j + 1] - 1 - sum) / arr[j] * arr[j] + sum >= b) {
//                    count += (b - sum) / arr[j];
//                    sum += (b - sum) / arr[j] * arr[j];
//                    break;
//                }
//                count += (arr[j + 1] - 1 - sum) / arr[j];
//                sum += (arr[j + 1] - 1 - sum) / arr[j] * arr[j];
//                j++;
//            }
//            if (b - sum == arr[n - 1]) {
//                sum += arr[n - 1];
//                count += 1;
//            }
//            sum += addS;
//            count += addC;
//            out.println(sum + " " + count);
//        }
    }

    public int nextInt() {
        return sc.nextInt();
    }

    public long nextLong() {
        return  sc.nextLong();
    }

    public String nextToken() {
        return sc.next();
    }
}


