import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

public class Main {
    PrintWriter out;
    Scanner sc;

    public static void main(String [] arg) {
        new Main().run();
    }

    public void run() {
        sc = new Scanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();

    }

    public void solve() {
        int n = nextInt();
        if (n == 1) {
            nextInt();
            int q = nextInt();
            for (int i = 0; i < q; i++) {
                long b = nextLong();
                out.println(b + " " + b);
            }
            return;
        }
        long [] arr = new long[n];
        for (int i = 0; i < n; i++) {
            arr[i] = nextLong();
        }
        long [] dp = new long[n];
        dp[0] = arr[1] - 1;
        long sumH = dp[0];
        for (int i = 1; i < n - 1; i++) {
            dp[i] = (arr[i + 1] - 1 - sumH) / arr[i];
            sumH += dp[i] * arr[i];
        }
//        for (int i = 0; i < n; i++) {
//            System.out.print(dp[i] + " ");
//        }
//        System.out.println();

        int q = nextInt();
        for (int i = 0; i < q; i++) {
            long b = nextLong();
            long sum = 0;
            long count = 0;
            int j = 0;
            while (sum < b && j < n - 1) {
                sum += dp[j] * arr[j];
                count += dp[j];
                j++;
            }
            if (sum > b) {
                sum -= dp[j - 1] * arr[j - 1];
                count -= dp[j - 1];
                count += (b - sum) / arr[j - 1];
                sum += (b - sum) / arr[j - 1] * arr[j - 1];
            } else if (sum < b){
                count += (b - sum) / arr[n - 1];
                sum += (b - sum) / arr[n - 1] * arr[n - 1];
            }

            out.println(sum + " " + count);
        }

    }

    public int nextInt() {
        return sc.nextInt();
    }

    public long nextLong() {
        return  sc.nextLong();
    }

    public String nextToken() {
        return sc.next();
    }
}


