#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <cmath>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector <int> a(n), all;
    for (auto& u : a) {
        cin >> u;
        all.emplace_back(u);
    }
    sort(all.begin(), all.end());
    all.resize(unique(all.begin(), all.end()) - all.begin());
    for (auto& u : a)
        u = lower_bound(all.begin(), all.end(), u) - all.begin();
    vector <long long> ans(n);
    vector <int> cnt(all.size(), 0);
    int cur_cnt = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            if (!cnt[a[j]]) {
                cnt[a[j]] = 1;
                cur_cnt++;
            }
            ans[j - i] += cur_cnt;
        }
        cnt.resize(0);
        cnt.resize(all.size(), 0);
        cur_cnt = 0;
    }
    for (auto& u : ans)
        cout << u << ' ';
}