#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <cmath>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector <long long> a(n);
    for (auto& u : a)
        cin >> u;
    bool f = 1;
    for (int i = 0; i < n; i++) {
        f = f && ((1 << i) == a[i]);
    }
    if (f) {
        int q;
        cin >> q;
        for (int i = 0; i < q; i++) {
            long long b;
            int ans = 0;
            cin >> b;
            int max_cnt = 1;
            for (int i = 1; i <= n; i++) {
                if ((1ll << i) - 1 <= b)
                    max_cnt = i;
            }
            if (max_cnt != n) {
                cout << (1ll << max_cnt) - 1 << ' ' << max_cnt << '\n';
            }
            else {
                long long val = (1ll << (n - 1)) - 1;
                int cnt = n - 1 + (b - val) / a.back();
                val += (b - val) / a.back() * a.back();
                cout << val << ' ' << cnt << '\n';
            }
        }

        return 0;
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        long long b;
        long long ans = 0, pos = 0;
        cin >> b;
        for (int j = 1; j <= b; j++) {
            int tmp = j;
            long long cur_ans = 0;
            while (tmp > 0) {
                int ind = upper_bound(a.begin(), a.end(), tmp) - a.begin() - 1;
                cur_ans += tmp / a[ind];
                tmp %= a[ind];
            }
            if (ans < cur_ans) {
                pos = j;
                ans = cur_ans;
            }
        }
        cout << pos << ' ' << ans << '\n';
    }
}