#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;

using namespace std;

void Compress(vector <int64>& a) {
	vector <int64> b = a;
	sort(b.begin(), b.end());
	for (auto& i : a) {
		i = (int)(lower_bound(b.begin(), b.end(), i) - b.begin());
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector <int64> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	if (n <= 5000) {
		Compress(a);
		vector <int64> res(n, 0);
		for (int d = 1; d <= n; d++) {
			vector <int> cnt(n, 0);
			int zero = n;
			for (int i = 0; i < d - 1; i++) {
				if (cnt[a[i]] == 0) {
					zero--;
				}
				cnt[a[i]]++;
			}
			for (int R = d - 1; R < n; R++) {
				int L = R - d + 1;
				if (cnt[a[R]] == 0) {
					zero--;
				}
				cnt[a[R]]++;
				res[d - 1] += n - zero;
				if (cnt[a[L]] == 1) {
					zero++;
				}
				cnt[a[L]]--;
			}
		}
		for (auto i : res) {
			cout << i << ' ';
		}
		cout << '\n';
		return 0;
	}
//	vector <vector <int>> cnt(n, vector <int>(31, 0));
//	cnt[0][a[0]]++;
//	for (int i = 1; i < n; i++) {
//		cnt[i] = cnt[i - 1];
//		cnt[i][a[i]]++;
//	}
	vector <int64> res(n, 0);
	for (int d = 1; d <= n; d++) {
		vector <int> cnt(31, 0);
		int zero = 31;
		for (int i = 0; i < d - 1; i++) {
			if (cnt[a[i]] == 0) {
				zero--;
			}
			cnt[a[i]]++;
		}
		for (int R = d - 1; R < n; R++) {
			int L = R - d + 1;
			if (cnt[a[R]] == 0) {
				zero--;
			}
			cnt[a[R]]++;
			res[d - 1] += 31 - zero;
			if (cnt[a[L]] == 1) {
				zero++;
			}
			cnt[a[L]]--;
		}
	}
	for (auto i : res) {
		cout << i << ' ';
	}
	cout << '\n';

}
/*
5
1 3 2 1 2

3
10 10 10
*/
