#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;
const int64 INF = 1'000'000'000'000'000'001;

using namespace std;

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector <int64> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int64 sum = 0;
	for (int i = 0; i < n; i++) {
		sum += a[i];
	}
	int64 cur_sum = 0;
	int64 min_del = INF, res = -1;
	for (int i = 0; i < n - 1; i++) {
		cur_sum += a[i];
		int64 cur = abs(sum / 2 - cur_sum);
		if (cur < min_del) {
			min_del = cur;
			res = i + 1;
		}
	}
	cout << res << '\n';
}
/*
3
1 2 3
*/