#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;

using namespace std;

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int n, x;
	cin >> n >> x;
	int64 res = 0;
	for (int64 a = 1; a <= n * 4; a++) {
		for (int64 b = 1; b <= n * 4; b++) {
			if (a == x || b == x) {
				continue;
			}
			int64 m = a * b - n;
			for (int64 i = 1; i * i <= m; i++) {
				if (m % i != 0) {
					continue;
				}
				int64 x = i, y = m / i;
				if (x < a && y < b) {
					res += 2;
					if (i * i == m) {
						res--;
					}
				}
			}
		}
	}
	cout << res << '\n';
}
