#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long

using namespace std;
using namespace __gnu_pbds;

int gn;
vector<int> dp;
vector<int> sum;
vector<int> s;


pair<int, int> dp_rec(int n)
{
    int k;
    int L = 0;
    int R = gn;
    while (R - L > 1)
    {
        int M = (L + R) / 2;
        if (s[M] <= n) L = M;
        else R = M;
    }
    k = L;
    if (n == s[k] && dp[k] != 0) return {dp[k], sum[k]};
    int f, t;
    if (n % s[k] == 0)
    {
        if (n == 1) return {1, 1};
        if (n == s[k])
        {
            f = dp_rec(n - 1).first;
            t = dp_rec(n - 1).second;
            dp[k] = f;
            sum[k] = t;
            return {f, t};
        }
        pair<int, int> v = {n / s[k] - 1 + dp[k], n - s[k] + sum[k]};
        if (v.first > n / s[k])
        {
            f = v.first;
            t = v.second;
        }
        else
        {
            f = n / s[k];
            t = n;
        }
        return {f, t};
    }
    pair<int, int> v = dp_rec(n % s[k]);
    if (n / s[k] - 1 + dp[k] > n / s[k] + v.first)
    {
        f = n / s[k] - 1 + dp[k];
        t = (n / s[k] - 1) * s[k] + sum[k];
    }
    else
    {
        f = n / s[k] + v.first;
        t = n / s[k] * s[k] + v.second;
    }
    return {f, t};
}


int32_t main()
{
    //ifstream inp("input.txt");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    gn = n;
    dp.resize(n);
    sum.resize(n);
    dp[0] = 1;
    sum[0] = 1;
    s.resize(n);
    for (int i(0); i < n; ++i) cin >> s[i];
    for (int i: s) dp_rec(i);
    int q;
    cin >> q;
    for (int i(0); i < q; ++i)
    {
        int b;
        cin >> b;
        pair<int, int> v = dp_rec(b);
        cout << v.second << ' ' << v.first << endl;
    }
    return 0;
}
