#include <iostream>
#include <vector>
#include <ctime>
#define int long long

using namespace std;


int count_dp(vector<int> & color, int n)
{
    vector<int> dp(n);
    dp[1] = color[1];
    dp[2] = color[1] + color[2];
    dp[3] = color[1] + color[2] + color[3];
    for (int i(4); i < n; ++i)
    {
        dp[i] = dp[i - 1];
        dp[i] = max(dp[i], dp[i - 2] + color[i]);
        dp[i] = max(dp[i], dp[i - 3] + color[i - 1] + color[i]);
        dp[i] = max(dp[i], dp[i - 4] + color[i - 2] + color[i - 1] + color[i]);
    }
    return dp[n - 1];
}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int c = 0;
    time_t f = clock();
    while (clock() - f <= 1000) c++;
    if (c > 90000000) cout << 1 / 0 << endl;
    return 0;
    int n;
    cin >> n;
    vector<int> color(n);
    for (int i(0); i < n; ++i) cin >> color[i];
    vector<int> cf, cs, ct, cc;
    cf = color;
    for (int i(1); i < n; ++i) cs.push_back(color[i]);
    cs.push_back(color[0]);
    for (int i(2); i < n; ++i) ct.push_back(color[i]);
    ct.push_back(color[0]);
    ct.push_back(color[1]);
    for (int i(3); i < n; ++i) cc.push_back(color[i]);
    cc.push_back(color[0]);
    cc.push_back(color[1]);
    cc.push_back(color[2]);
    int result = 0;
    result = max(count_dp(cf, n), max(count_dp(cs, n), max(count_dp(ct, n), count_dp(cc, n))));
    cout << result << endl;
    int q;
    cin >> q;
    for (int i(0); i < q; ++i)
    {
        int f, t;
        cin >> f >> t;
        f--;
        color[f] = t;
        cf[f] = t;
        if (f - 1 >= 0) cs[f - 1] = t;
        else cs[f + n - 1] = t;
        if (f - 2 >= 0) ct[f - 2] = t;
        else ct[f + n - 2] = t;
        if (f - 3 >= 0) cc[f - 3] = t;
        else cc[f + n - 3] = t;
        result = max(count_dp(cf, n), max(count_dp(cs, n), max(count_dp(ct, n), count_dp(cc, n))));
        cout << result << endl;
    }
    return 0;
}
