#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
typedef long long ll;
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n, m, q, s, t;
    cin >> n;
    vector<int> limit(n);
    vector<int> road(n);
    for (int i = 0; i < n; i++)
        cin >> limit [i];
    for (int i = 0; i < n; i++)
        cin >> road[i];
    cin >> m;
    vector<int> bill_limit(m - 1);
    vector<int> bill(m);
    for (int i = 0; i < m - 1; i++)
        cin >> bill_limit[i];
    for (int i = 0; i < m; i++)
        cin >> bill[i];
    cin >> q;
    double min_time = 0;
    for (int i = 0; i < n; i++)
        min_time += double(road[i]) / double(limit[i]);
    for (int k = 0; k < q; k++)
    {
        cin >> s >> t;
        if (t - s >= min_time)
            cout << 0 << '\n';
        else if (m == 1)
        {
            cout << bill[0] << '\n';
            continue;
        }
        else
        {
            ll l, r;
            if (bill_limit.size() - 1ll >= 0ll)
            l = 0;
            r = bill_limit[bill_limit.size() - 1] + 1ll;
            double mx = 0;
            while (l < r - 1)
            {
                ll mid = (l + r) / 2;
                mx = 0;
                for (int i = 0; i < n; i++)
                {
                    mx += double(road[i]) / double(limit[i] + mid);
                }
                if (mx > t - s)
                    l = mid;
                else
                    r = mid;
            }
            ll diff = l;
            double kek = 0;
            for (int i = 0; i < n; i++)
                kek += double(road[i]) / double(limit[i] + r);
            if (kek != t - s)
                diff++;
            l = -1, r = m - 1;
            while (l < r - 1)
            {
                ll mid = (l + r) / 2;
                if (bill_limit[mid] >= diff)
                    r = mid;
                else
                    l = mid;
            }
            cout << bill[r] << '\n';
        }
    }
    return 0;
}
