#include <iostream>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <cmath>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

#define ll long long 
#define all(x) x.begin(), x.end()
//#define for(i, x) for (int i=0; i<x; i++)
#define pairll pair <long long, long long>
#define pairint pair <int, int>


vector <int> z;
int n, m;

void choosez() {
	for (int i = 0; i < n; i++) {
		z[i] = rand() % (m + 1);
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int s;
	cin >> n >> m >> s;
	vector <vector <int>> x(m, vector <int>(n));
	vector <vector <int>> a(m, vector <int>(n - 1));
	vector <vector <int>> b(m, vector <int>(n - 1));
	vector <vector <int>> op(m, vector <int>(n - 1));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n - 1; j++) {
			cin >> a[i][j] >> b[i][j] >> op[i][j];
		}
	}

	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			cin >> x[i][j];
		}
	}

	vector <vector <bool>> val(m, vector <bool>(2 * n - 1));
	z.resize(n);
	int it = 0;
	while (it < 1e8 / (n * m)) {
		it++;
		choosez();
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				val[i][j] = (x[i][j] < z[j]);
			}
			for (int p = 0; p < n - 1; p++) {
				if (op[i][p] == 1) {
					val[i][n + p] = (val[i][a[i][p]] & val[i][b[i][p]]);
				}
				else {
					val[i][n + p] = (val[i][a[i][p]] | val[i][b[i][p]]);
				}
			}
		}
		int sans = 0;
		for (int i = 0; i < m; i++) {
			if (val[i][2 * n - 2] == 1) sans++;
		}
		if (sans == s) {
			for (int h : z) {
				cout << h << " ";
			}
			return 0;
		}
	}

	return 0;
}

/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1

*/