#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.size(), x.begin()
#define sz(x) int(x.size())
#define int long long
#ifndef MY
    #define endl '\n'
#endif // MY

ostream& operator << (ostream& out, const vector < int > lst) {
    for (auto x : lst) {
        out << x << ' ';
    }
    out << endl;
    return out;
}

const int N = 2e5 + 5;
int up[N];
int down[N];
map < int, int > prv;
int n;

void update(int l, int r) {
    int a = l, b = n - r - 1;
    if (a > b) {
        swap(a, b);
    }
    int m = r - l + 1;
    up[m]++;
    up[m + a + 1]--;
    down[m + b + 1]++;
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (prv[x] == 0) {
            prv[x] = i + 1;
            continue;
        }
        update(prv[x] - 1, i);
        prv[x] = i + 1;
    }
    int pl = 0, mn = 0, sum = 0;
    for (int i = 1; i <= n; i++) {
        int ans = i * (n - i + 1);
        pl += up[i];
        mn += down[i];
        sum = sum + pl - mn;
        cout << ans - sum << ' ';
    }
    return 0;
}
