#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.size(), x.begin()
#define sz(x) int(x.size())
//#define int long long
#ifndef MY
    #define endl '\n'
#endif // MY
typedef vector < vector < int > > Vector;
ostream& operator << (ostream& out, const vector < int > lst) {
    for (auto x : lst) {
        out << x << ' ';
    }
    out << endl;
    return out;
}

Vector up;
Vector lst;
Vector op;
Vector pos;
vector < int > ans;
int cnt = 0;
int m, n;

void update(int v, int x) {
    //cout << x << ' ' << v << endl;
    while (true) {
        op[x][v] = 3;
        if (v == 2 * n - 2) {
            //cout << "!!\n";
            cnt++;
            return;
        }
        int p = up[x][v];
        if (op[x][p] == 3) {
            return;
        }
        if (op[x][p] == 0) {
            op[x][p] = 1;
            return;
        }
        v = p;
    }
}

void build() {
    ans.resize(n);
    up.resize(m);
    lst.resize(m);
    op.resize(m);
    pos.resize(m);
    for (int i = 0; i < m; i++) {
        up[i].resize(2 * n);
        op[i].resize(2 * n);
        pos[i].resize(n);
        lst[i].resize(n);
    }
}

int main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int s;
    cin >> n >> m >> s;
    build();
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            int a, b, t;
            cin >> a >> b >> t;
            a--, b--;
            op[i][n + j] = t - (t == 1);
            up[i][a] = n + j;
            up[i][b] = n + j;
        }
    }

    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            cin >> lst[i][j];
            pos[lst[i][j]][j] = i;
        }
    }
    for (int i = 0; i < n && cnt < s; i++) {
        for (int j = 1; j <= m && cnt < s; j++) {
            ans[i] = j;
            update(i, pos[j - 1][i]);
        }
    }
    //cout << cnt << endl;
    cout << ans;
    return 0;
}
