#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.size(), x.begin()
#define sz(x) int(x.size())
#define int long long
#ifndef MY
    #define endl '\n'
#endif // MY

typedef pair < int, int > pii;

ostream& operator << (ostream& out, const vector < int > lst) {
    for (auto x : lst) {
        out << x << ' ';
    }
    out << endl;
    return out;
}

const int N = 2e5 + 5;
const int inf = 1e18;
int lst[N];
pii dp[N];
int n;

int find(int x, int in) {
    if (x == 0) {
        return 0;
    }
    int l = 0, r = in;
    while (l + 1 != r) {
        int m = (l + r) / 2;
        if (lst[m] <= x){
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

pii cnt(int x, int in) {
    if (in == 0) {
        return {x, x};
    }
    int a = x / lst[in];
    int b = x % lst[in];
    pii k = cnt(b, find(b, in));
    k.F += a, k.S += a * lst[in];
    return max(k, dp[in]);
}

void build() {
    for (int i = 1; i < n; i++) {
        dp[i] = {1, lst[i]};
        dp[i] = max(dp[i], cnt(lst[i] - 1, i - 1));
    }
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    int a = 1, b = 1, cnt = 1;
//    while (b < inf) {
//        int c = a + b;
//        cout << cnt << ' ' << c << endl;
//        cnt++;
//        a = b;
//        b = c;
//    }
//    return 0;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> lst[i];
    }
    build();
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int x;
        cin >> x;
        pii k = cnt(x, find(x, n));
        cout << k.S << ' ' << k.F << endl;
    }
    return 0;
}
