#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e6;
int arr[MAXN], a[MAXN];
int tree[MAXN], add[MAXN];
int lef[MAXN], last[MAXN];

void push(int v) {
    int v1 = v * 2;
    int v2 = v * 2 + 1;
    add[v1] += add[v];
    add[v2] += add[v];
    tree[v] += add[v];
    add[v] = 0;
}

void update(int v, int vl, int vr, int l, int r, int val) {
    if (l >= vr || r <= vl) {
        return;
    }
    if (l <= vl && r >= vr) {
        add[v] += val;
        return;
    }
    int vm = (vl + vr) / 2;
    update(v * 2, vl, vm, l, r, val);
    update(v * 2 + 1, vm, vr, l, r, val);
}

int get(int v, int vl, int vr, int l, int r) {
    push(v);
    if (l >= vr || r <= vl) {
        return 1e9;
    }
    if (l <= vl && r >= vr) {
        return tree[v];
    }
    int vm = (vl + vr) / 2;
    int res1 = get(v * 2, vl, vm, l, r);
    int res2 = get(v * 2 + 1, vm, vr, l, r);
    return min(res1, res2);
}

main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
        a[i] = arr[i];
    }
    sort(a, a + n);
    int k = unique(a, a + n) - a;
    map<int, int> b;
    for (int i = 0; i < k; ++i) {
        b[a[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        arr[i] = b[arr[i]];
    }
    fill(last, last + n, -1);
    for (int i = 0; i < n; ++i) {
        lef[i] = last[arr[i]];
        last[arr[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        update(1, 0, n, 0, min(n - i, i - lef[i]), 1);
        update(1, 0, n, max(n - i, i - lef[i]), n - lef[i], -1);
    }
    int cur = 0;
    for (int i = 0; i < n; ++i) {
        cur += get(1, 0, n, i, i + 1);
        cout << cur << " ";
    }
    return 0;
}
