#include <bits/stdc++.h>
using namespace std;

const int MAXN = 2e6;

int n, m, s;
vector<vector<array<int, 3>>> f;
vector<vector<int>> arr;
int z[MAXN];

bool get(int i, int j) {
    if (j >= n) {
        return j;
    }
    return arr[i][j] < z[j];
}

bool check() {
    int cnt = 0;
    for (int i = 0; i < m; ++i) {
        for (int j = n; j < 2 * n - 1; ++j) {
            if (f[i][j - n][2] == 1) {
                arr[i][j] = get(i, f[i][j - n][0]) && get(i, f[i][j - n][1]);
            }
        }
        cnt += (bool)(arr[i][2 * n - 2]);
    }
    return cnt == s;
}

void solve(int k) {
    if (k == 0) {
        if (check()) {
            for (int i = 0; i < n; ++i) {
                cout << z[i] << " ";
            }
            exit(0);
        }
        return;
    }
    for (int i = 0; i < 3; ++i) {
        z[n - k] = i;
        solve(k - 1);
    }
}

main() {
    cin >> n >> m >> s;
    f.resize(m, vector<array<int, 3>>(n - 1));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            cin >> f[i][j][0] >> f[i][j][1] >> f[i][j][2];
        }
    }
    arr.resize(m, vector<int>(2 * n - 1));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> arr[i][j];
        }
    }
    solve(n);
    return 0;
}
