#include <bits/stdc++.h>
using namespace std;

const int MAXN = 2e6;

int n, m, s;
vector<vector<array<int, 3>>> f;
vector<vector<int>> arr;
int z[MAXN], z1[MAXN];
int rev[MAXN];

bool get(int i, int j) {
    if (j >= n) {
        return arr[i][j];
    }
    return arr[i][j] < z[j];
}

bool check() {
    int cnt = 0;
    for (int i = 0; i < m; ++i) {
        for (int j = n; j < 2 * n - 1; ++j) {
            if (f[i][j - n][2] == 1) {
                arr[i][j] = get(i, f[i][j - n][0]) && get(i, f[i][j - n][1]);
            } else {
                arr[i][j] = get(i, f[i][j - n][0]) || get(i, f[i][j - n][1]);
            }
        }
        cnt += (bool)(arr[i][2 * n - 2]);
    }
    return cnt == s;
}

void solve(int k) {
    if (k == 0) {
        if (check()) {
            for (int i = 0; i < n; ++i) {
                z1[i] = z[i];
            }
        }
        return;
    }
    for (int i = 0; i <= m; ++i) {
        z[n - k] = i;
        solve(k - 1);
    }
}

struct s_set
{
    set<int> h;
    set<int> t;
    int cnt;

    void insert(int x) {
        if (h.size() < s - cnt) {
            h.insert(x);
        } else {
            auto it = h.end();
            it--;
            int y = *it;
            if (y < x) {
                t.insert(x);
            } else {
                h.erase(y);
                h.insert(x);
                t.insert(y);
            }
        }
        assert(h.size() <= s - cnt);
    }

    void erase(int x) {
        if (t.count(x)) {
            t.erase(x);
        } else {
            h.erase(x);
            if (!t.empty()) {
                h.insert(*t.begin());
                t.erase(t.begin());
            }
        }
        assert(h.size() <= s - cnt);
    }

    int get_s() {
        if (h.size() < s - cnt) {
            return -2;
        } else {
            if (h.empty()) {
                return -1;
            }
            auto it = h.end();
            it--;
            return *it;
        }
    }
};

void operator++(s_set &st) {
    st.cnt++;
    if (st.h.size() > s - st.cnt) {
        auto it = st.h.end();
        it--;
        int x = *it;
        st.h.erase(x);
        st.t.insert(x);
    }
    assert(st.h.size() <= s - st.cnt);
}

ostream &operator<<(ostream &out, s_set st) {
    for (auto elem : st.h) {
        out << elem << " ";
    }
    out << "| ";
    for (auto elem : st.t) {
        out << elem << " ";
    }
    return out;
}

main() {
    cin >> n >> m >> s;
    f.resize(m, vector<array<int, 3>>(n - 1));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            cin >> f[i][j][0] >> f[i][j][1] >> f[i][j][2];
            f[i][j][0]--;
            f[i][j][1]--;
        }
    }
    arr.resize(m, vector<int>(2 * n - 1));
    bool fl = true;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> arr[i][j];
            if (arr[i][j] != i) {
                fl = false;
            }
        }
    }
    if (n <= 10 && m <= 2) {
        solve(n);
        for (int i = 0; i < n; ++i) {
            cout << z1[i] << " ";
        }
        return 0;
    }
    if (fl || n == 1 || s == 0 || s == m) {
        for (int i = 0; i < n; ++i) {
            cout << s << " ";
        }
        return 0;
    }
    if (n == 2) {
        s_set all;
        all.cnt = 0;
        for (int i = 0; i < m; ++i) {
            rev[arr[i][0] + 1] = i;
            if (f[i][0][2] == 2) {
                all.insert(arr[i][1]);
            }
        }
        int x = all.get_s();
        if (x != -2) {
            cout << 0 << " " << x + 1;
            return 0;
        }
        for (int i = 1; i <= m; ++i) {
            if (f[rev[i]][0][2] == 2) {
                ++all;
                all.erase(arr[rev[i]][1]);
            } else {
                all.insert(arr[rev[i]][1]);
            }
            int x = all.get_s();
            if (x != -2) {
                cout << i << " " << x + 1;
                return 0;
            }
        }
    }
    return 0;
}
/**
2 4 1
1 2 2
1 2 1
1 2 2
1 2 1
0 3
1 2
2 1
3 0
*/
