#include <bits/stdc++.h>
using namespace std;

const int MAXN = 2e6;

int n, m, s;
vector<vector<array<int, 3>>> f;
vector<vector<int>> arr, p, revv, is_t;
int z[MAXN], z1[MAXN];
int rev[MAXN];

inline bool get(int i, int j) {
    if (j >= n) {
        return arr[i][j];
    }
    return arr[i][j] < z[j];
}

inline bool check(int i, int j) {
    if (f[i][j][2] == 1) {
        return is_t[i][f[i][j][0]] && is_t[i][f[i][j][1]];
    } else {
        return is_t[i][f[i][j][0]] || is_t[i][f[i][j][1]];
    }
}

inline bool check() {
    int cnt = 0;
    for (int i = 0; i < m; ++i) {
        for (int j = n; j < 2 * n - 1; ++j) {
            if (f[i][j - n][2] == 1) {
                arr[i][j] = get(i, f[i][j - n][0]) && get(i, f[i][j - n][1]);
            } else {
                arr[i][j] = get(i, f[i][j - n][0]) || get(i, f[i][j - n][1]);
            }
        }
        cnt += (bool)(arr[i][2 * n - 2]);
    }
    return cnt == s;
}

void solve(int k) {
    if (k == 0) {
        if (check()) {
            for (int i = 0; i < n; ++i) {
                z1[i] = z[i];
            }
        }
        return;
    }
    for (int i = 0; i <= m; ++i) {
        z[n - k] = i;
        solve(k - 1);
    }
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n >> m >> s;
    f.resize(m, vector<array<int, 3>>(n - 1));
    p.resize(m, vector<int>(2 * n - 1, -1));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            cin >> f[i][j][0] >> f[i][j][1] >> f[i][j][2];
            f[i][j][0]--;
            f[i][j][1]--;
            p[i][f[i][j][0]] = j + n;
            p[i][f[i][j][1]] = j + n;
        }
    }
    revv.resize(m + 1, vector<int>(2 * n - 1));
    arr.resize(m, vector<int>(2 * n - 1));
    is_t.resize(m, vector<int>(2 * n - 1, 0));
    bool fl = true;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> arr[i][j];
            revv[arr[i][j] + 1][j] = i;
            if (arr[i][j] != i) {
                fl = false;
            }
        }
    }
    if (fl || n == 1 || s == 0 || s == m) {
        for (int i = 0; i < n; ++i) {
            cout << s << " ";
        }
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        z[i] = 0;
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (cnt == s) {
            for (int j = 0; j < n; ++j) {
                cout << z[j] << " ";
            }
            return 0;
        }
        while (z[i] < m) {
            z[i]++;
            is_t[revv[z[i]][i]][i] = 1;
            int x1 = revv[z[i]][i];
            int y = i;
            y = p[x1][y];
            while (y != -1) {
                if (is_t[x1][y]) {
                    break;
                }
                if (check(x1, y - n)) {
                    is_t[x1][y] = 1;
                }
                if (y == 2 * n - 2) {
                    cnt += is_t[x1][y];
                }
                y = p[x1][y];
                if (cnt == s) {
                    for (int j = 0; j < n; ++j) {
                        cout << z[j] << " ";
                    }
                    return 0;
                }
            }
        }
        if (cnt == s) {
            for (int j = 0; j < n; ++j) {
                cout << z[j] << " ";
            }
            return 0;
        }
    }
    return 0;
}
/**
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1
*/
