#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 2e5, INF = 1e18;
int arr[MAXN];
array<array<int, 4>, 4> tree[MAXN];

void pull(int v, int vl, int vr) {
    int v1 = v * 2;
    int v2 = v * 2 + 1;
    int vm = (vl + vr) / 2;
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 4; ++j) {
            tree[v][i][j] = 0;
        }
    }
    for (int i = 0; i < 4; ++i) {
        int r = 4;
        if (v == 1) {
            r = 4 - i;
        }
        for (int j = 0; j < r; ++j) {
            for (int p = 0; p < 4; ++p) {
                for (int q = 0; q < 4 - p; ++q) {
                    if (i == vm - vl) {
                        if (p != vm - vl) {
                            continue;
                        }
                    }
                    if (j == vr - vm) {
                        if (q != vr - vm) {
                            continue;
                        }
                    }
                    if (p == vm - vl) {
                        if (i != vm - vl) {
                            continue;
                        }
                    }
                    if (q == vr - vm) {
                        if (j != vr - vm) {
                            continue;
                        }
                    }
                    if (i + p > vm - vl && i != vm - vl) {
                        continue;
                    }
                    if (j + q > vr - vm && j != vr - vm) {
                        continue;
                    }
                    if (i == vm - vl) {
                        if (j == vr - vm) {
                            if (i + j < 4) {
                                tree[v][i + j][j + i] = max(tree[v][i + j][j + i], tree[v1][i][p] + tree[v2][q][j]);

                            }
                        } else {
                            if (v == 1) {
                                if (i + q + j < 4) {
                                    tree[v][i + q][j] = max(tree[v][i + q][j], tree[v1][i][p] + tree[v2][q][j]);
                                }
                            } else {
                                if (i + q < 4) {
                                    tree[v][i + q][j] = max(tree[v][i + q][j], tree[v1][i][p] + tree[v2][q][j]);
                                }
                            }
                        }
                    } else {
                        if (j == vr - vm) {
                            if (v == 1) {
                                if (i + j + p < 4) {
                                    tree[v][i][j + p] = max(tree[v][i][j + p], tree[v1][i][p] + tree[v2][q][j]);
                                }
                            } else {
                                if (j + p < 4) {
                                    tree[v][i][j + p] = max(tree[v][i][j + p], tree[v1][i][p] + tree[v2][q][j]);
                                }
                            }
                        } else {
                            tree[v][i][j] = max(tree[v][i][j], tree[v1][i][p] + tree[v2][q][j]);
                        }
                    }
                }
            }
        }
    }
}

void build(int v, int vl, int vr) {
    if (vr - vl == 1) {
        for (int i = 0; i < 4; ++i) {
            for (int j = 0; j < 4; ++j) {
                if (i != 1 || j != 1) {
                    tree[v][i][j] = 0;
                } else {
                    tree[v][i][j] = arr[vl];
                }
            }
        }
        return;
    }
    int vm = (vl + vr) / 2;
    build(v * 2, vl, vm);
    build(v * 2 + 1, vm, vr);
    pull(v, vl, vr);
}

void update(int v, int vl, int vr, int ind, int val) {
    if (ind >= vr || ind < vl) {
        return;
    }
    if (vr - vl == 1) {
        for (int i = 0; i < 4; ++i) {
            for (int j = 0; j < 4; ++j) {
                if (i != 1 || j != 1) {
                    tree[v][i][j] = 0;
                } else {
                    tree[v][i][j] = val;
                }
            }
        }
        return;
    }
    int vm = (vl + vr) / 2;
    update(v * 2, vl, vm, ind, val);
    update(v * 2 + 1, vm, vr, ind, val);
    pull(v, vl, vr);
}

int get() {
    int res = 0;
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 4; ++j) {
            if (tree[1][i][j] > res) {
                res = tree[1][i][j];
            }
        }
    }
    return res;
}

main() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }
    int q;
    build(1, 0, n);
    cout << get() << endl;
    cin >> q;
    while (q--) {
        int p, v;
        cin >> p >> v;
        p--;
        arr[p] = v;
        update(1, 0, n, p, v);
        cout << get() << endl;
    }
    return 0;
}
/**
6
1 2 3 4 5 6
2
6 0
2 5
*/
