//#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int long long

int n;
vector<int> pref2;
vector<int> pref;

void add(int l, int r, int first_val, int step) {
	if (l >= n)
		return;
	if (r < l)
		return;
	//cout << l << " " << r << " " << first_val << " " << step << endl;
	pref[l] += first_val;
	if (r != n - 1) {
		pref[r + 1] -= first_val;
	}
	if (l != n - 1)
		pref2[l + 1] += step;
	if (r != n - 1)
		pref2[r + 1] -= step;
	if (r != n - 1)
		pref[r + 1] -= step * (r - l);
}

void calc() {
	for (int i = 0; i < n; i++) {
		pref[i] += pref2[i];
		if (i != n - 1) {
			pref2[i + 1] += pref2[i];
			pref[i + 1] += pref[i];
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	pref.resize(n);
	pref2.resize(n);
	vector<int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	map<int, vector<int>> m;
	for (int i = 0; i < n; i++) {
		m[arr[i]].push_back(i);
	}
	for (auto & el : m) {
		for (int i = 0; i < (int) el.second.size() - 1; i++) {
			int diff = el.second[i + 1] - el.second[i];
			int x = el.second[i];
			int y = el.second[i + 1];
			//cout << "# " << x << " " << y << endl;
			add(diff, n - 1 - x, x + 1, 0);
			add(n - x, n - 1, x, -1);
			add(diff, y - 1, -x, 1);
		}
	}
	calc();
	for (int i = 0; i < n; i++) {
		cout << (i + 1) * (n - i) - pref[i] << " ";
	}
	cout << endl;
}
