//#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int long long
int n;

int count(int a, int b) {
	int ans = 0;
	int y = a * b - n;
	if (y <= 0) {
		return 0;
	}
	for (int c = 1; c < a;  c++) {
		if (y % c == 0) {
			int d = y / c;
			if (d < b && d > 0) {
				ans++;
			}
		}
	}
	return ans;
}

int gcd(int a, int b) {
	while (a) {
		b %= a;
		swap(a, b);
	}
	return b;
}

pair<int, int> get_some(int a, int b, int c) {
	if (a == 0) {
		return {0, c / b};
	}
	auto pp = get_some(b % a, a, c);
	return {pp.second - (b / a) * pp.first, pp.first};
}

pair<int, int> get_pos(int a, int b, pair<int, int> pp) {
	int kek = b / gcd(a, b);
	int kek2 = a / gcd(a, b);
	if (pp.first > 0) {
		int kek3 = pp.first / kek;
		if (pp.first % kek == 0)
			kek3--;
		return {pp.first - kek3 * kek, pp.second + kek3 * kek2};
	}
	int kek3 = abs(pp.first) / kek + 1;
	return {pp.first + kek3 * kek, pp.second - kek3 * kek2};
}

int count(int a, int b, int x) {
	if (x % gcd(a, b) != 0) {
		return 0;
	}
	pair<int, int> some = get_some(a, b, x);
	pair<int, int> first_pos = get_pos(a, b, some);
	if (first_pos.second <= 0) {
		return 0;
	}
	pair<int, int> first_pos2 = get_pos(b, a, {some.second, some.first});
	return (first_pos2.second - first_pos.first) / (b / gcd(a, b)) + 1;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int x;
	cin >> n >> x;
	int ans = 0;
	for (int i = 1; i <= n; i++) {
		ans -= 2 * count(x, i);
	}
	ans += count(x, x);
	for (int a = 1; a <= n; a++) {
		for (int b = 1; a * b <= n; b++) {
			int aa = b;
			int bb = a;
			ans += count(aa, bb, n - a * b);
		}
	}
	cout << ans << endl;
}
