#define _GLIBCXX_DEBUG
//#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int long long

int n;
vector<int> a;

unordered_map<int, pair<int, int>> cached;

pair<int, int> add(int x, int y, pair<int, int> p) {
	return {p.first + x, p.second + x * y};
}

pair<int, int> solve(int x) {
	if (x == 0) {
		return {0, 0};
	}
	if (cached.count(x)) {
		return cached[x];
	}
	int ans = 0;
	int ind = upper_bound(a.begin(), a.end(), x) - 1 - a.begin();
	int cnt = x / a[ind];
	int kek = x - cnt * a[ind];
	if (cnt > 1) {
		cnt--;
		kek += a[ind];
	}
	auto pp = max(solve(a[ind] - 1), add(cnt, a[ind], solve(kek)));
	return cached[x] = pp;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int q;
	cin >> q;
	vector<int> b(q);
	for (int i = 0; i < q; i++) {
		cin >> b[i];
	}
	for (int el : b) {
		auto pp = solve(el);
		cout << pp.second << " " << pp.first << endl;
	}
}
