//#define _GLIBCXX_DEBUG
//#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int long long

int n;
vector<int> a;

unordered_map<int, pair<int, int>> cached;

pair<int, int> add(int x, int y, pair<int, int> p) {
	return {p.first + x, p.second - x * y};
}

pair<int, int> solve(int x) {
	if (x == 0) {
		return {0, 0};
	}
	if (cached.count(x)) {
		return cached[x];
	}
	int ans = 0;
	int ind = upper_bound(a.begin(), a.end(), x) - 1 - a.begin();
	if (ind == 0) {
		return {x, -x};
	}
	int cnt = x / a[ind];
	int kek = x - cnt * a[ind];
	if (cnt > 1) {
		kek = a[ind] - 1;
	}
	auto pp1 = solve(a[ind] - 1);
	auto pp2 = solve(kek);
	int cnt2 = x + pp2.second;
	cnt2 /= a[ind];
	pp2.first += cnt2;
	pp2.second -= a[ind] * cnt2;
	auto pp = max(pp1, pp2);
	return cached[x] = pp;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int q;
	cin >> q;
	vector<int> b(q);
	for (int i = 0; i < q; i++) {
		cin >> b[i];
	}
	int cur_max = 1;
	int cur = 1;
	for (int i = 0; i < n - 1; i++) {
		int lel = (a[i + 1] - cur_max - 1) / a[i];
		if (i == -1)
			lel--;
		cur += lel;
		cur_max += a[i] * lel;
		cached[a[i + 1]] = {cur, -cur_max};
	}
	for (int el : b) {
		auto pp = solve(el);
		cout << -pp.second << " " << pp.first << endl;
	}
}
