#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<cassert>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<bitset>
#include<cmath>
#include<random>
#include<algorithm>
//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
//#pragma GCC optimize("unroll-loops")

using namespace std;

typedef long long ll;
typedef long double ldob;

//#define int ll
#define double ldob
#define loop(i, n) for(int i = 0; i < n; ++i)
#define loop1(i, n) for(int i = 1; i <= n; ++i)
#define all(x) x.begin(), x.end()
#define pb push_back
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

const int N = 3e5 + 7;

int n, m, s;
vector <ti> q[N];
vector <int> tab[N], now;

bool check() {
	vector <bool> cur0(2 * n), cur1(2 * n);
	loop(i, n) {
		cur0[i] = tab[0][i] < now[i];
		cur1[i] = tab[1][i] < now[i];
	}
	loop(i, n - 1) {
		int a0, b0, op0, a1, b1, op1;
		tie(a0, b0, op0) = q[0][i];
		tie(a1, b1, op1) = q[1][i];
		cur0[i + n] = (op0 ? cur0[a0] || cur0[b0] : cur0[a0] && cur0[b0]);
		cur1[i + n] = (op1 ? cur1[a1] || cur1[b1] : cur1[a1] && cur1[b1]);
	}
    return cur0[2 * n - 2] + cur1[2 * n - 2] == s;
}

void solve3(int pos, int len) {
	if (len == pos) {
		if (check()) {
			loop(i, len)
				cout << now[i];
			exit(0);
		}
		return;
	}
	now.pb(0);
	solve3(pos + 1, len);
	now.pop_back();
	now.pb(1);
	solve3(pos + 1, len);
	now.pop_back();
	now.pb(2);
	solve3(pos + 1, len);
	now.pop_back();
}

void solve4() {
	loop(i, n)
		cout << s << " ";
}

void solve5() {
	loop(i, n - 1)
		cout << m << " ";
	cout << s;
}

void solve() {
	cin >> n >> m >> s;
	bool ok = 1;
	loop(i, m) {
		loop(j, n - 1) {
			int a, b, op;
			cin >> a >> b >> op;
			q[i].pb(make_tuple(a - 1, b - 1, op - 1));
			if (op == 2)
				ok = 0;
		}
	}
	int x;
	loop(i, m) {
		loop(j, n) {
			cin >> x;
			tab[i].pb(x);
		}
	}
	if (ok)
		solve5();
	else if (n <= 10 && m <= 2) 
		solve3(0, n);
	else
		solve4();
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}