#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <algorithm>
#include "math.h"
#include "assert.h"
using namespace std;

#define ll long long
#define ull unsigned ll
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define vec vector
#define x first
#define y second
#define pb push_back
#define eb emplace_back

#pragma GCC optimize("unroll-loops")

template<class T>
inline ostream &operator<<(ostream &out, const vec<T> &v)
{
    if(v.empty())
        return out;
    out << *v.begin();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

template<class T>
inline istream &operator>>(istream &in, vec<T> &v)
{
    for(auto it = v.begin(); it != v.end(); ++it)
        in >> *it;
    return in;
}

template<class T1, class T2>
inline ostream &operator<<(ostream &out, const pair<T1, T2> &p)
{
    return out << p.x << ' ' << p.y;
}

template<class T1, class T2>
inline istream &operator>>(istream &in, pair<T1, T2> &p)
{
    return in >> p.x >> p.y;
}

//===================================================================================
//===================================================================================

pair<ll, ll> get_ans(ll x, ll y)
{
    if((x % 2) != (y % 2))
        return {-1, -1};
    ll a = (x + y) / 2;
    ll b = y - a;
    if(a > 0 && b > 0)
        return {a, b};
    return {-1, -1};
}

#define push_ans(_p) {auto p##__LINE__ = _p; if(p##__LINE__.x > 0 && p##__LINE__.y > 0) return p##__LINE__;}

pair<ll, ll> solve(ll n)
{
    if(n % 2 == 0 && (n / 2) % 2 != 0)
        return {-1, -1};

    //vec<ll> factor1 = {1}, factor2 = {n};
    push_ans(get_ans(1, n));
    /*for(ll i = 2 * (ll)(sqrt(n) / 2) + 3; i > 0; i -= 1)
    {
        if(n % i == 0)
        {
            push_ans(get_ans(i, n / i));
        }
    }*/
    if(n % 2 == 0)
    {
        push_ans(get_ans(2, n / 2));
    }

    /*vec<ll>::reverse_iterator l, r;
    l = factor1.rbegin();
    r = factor2.rbegin();
    for(; r != factor2.rend(); ++l, ++r)
    {
        if((*l % 2) == (*r % 2))
        {
            ll a = (*l + *r) / 2;
            ll b = *r - a;
            if(a > 0 && b > 0)
                return {a, b};
        }
    }*/
    assert(false);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);


    ll n;
    cin >> n;
    if(n == 0)
    {
        cout << "Yes\n1 1" << endl;
        return 0;
    }
    auto ans = solve(n);
    if(ans.x > 0 && ans.y > 0)
        cout << "Yes\n" << ans << endl;
    else
        cout << "No" << endl;
}