#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <algorithm>
#include "math.h"
#include "assert.h"
#include <cstdlib>
using namespace std;

#define ll long long
#define ld long double
#define ull unsigned ll
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define vec vector
#define x first
#define y second
#define pb push_back
#define eb emplace_back

#pragma GCC optimize("unroll-loops")

template<class T>
inline ostream &operator<<(ostream &out, const vec<T> &v)
{
    if(v.empty())
        return out;
    out << *v.begin();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

template<class T>
inline istream &operator>>(istream &in, vec<T> &v)
{
    for(auto it = v.begin(); it != v.end(); ++it)
        in >> *it;
    return in;
}

template<class T1, class T2>
inline ostream &operator<<(ostream &out, const pair<T1, T2> &p)
{
    return out << p.x << ' ' << p.y;
}

template<class T1, class T2>
inline istream &operator>>(istream &in, pair<T1, T2> &p)
{
    return in >> p.x >> p.y;
}

//===================================================================================
//===================================================================================

ll solve(ll n, ll x)
{
    // A bit better than stupid
    ll ans = 0;
    for(ll a = 2; a <= n; ++a)
    {
        if(a == x)
            continue;

        for(ll b = 2; a + b <= n + 1; ++b)
        {
            if(b == x)
                continue;

            for(ll c = a - 1; c > 0; --c)
            {
                ll tmp = (a * b - n) / c;
                if((a * b - n) % c == 0)
                    if(0 < tmp && tmp < b)
                        ++ans;
            }
        }
    }
    return ans;
}

int main()
{
    ll n, x;
    cin >> n >> x;
    cout << solve(n, x) << endl;
}