#ifdef _MSC_VER
	#define _CRT_SECURE_NO_WARNINGS
	#include <__msvc_all_public_headers.hpp>
#else
	#include <bits/stdc++.h>
	#define _MSC_VER 2000
#endif

#define uint			unsigned int
#define int				long long
#define double			long double
#define all(q)			q.begin(), q.end()
#define fora(q)			for(auto &p : q)
#define foru(q)			for (int x = 0; x < q; x++)

using namespace std;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie();
	cout.tie();
	cout.precision(20);

	int n = 0, x = 0, ans = 0;
	cin >> n >> x;

	deque <deque <int>> divs(3000 * 3000 + 1);

	for (int i = 1; i <= n; i++)
		for (int j = i; j < divs.size(); j += i)
			divs[j].push_back(i);

	for (int c = 1; c < n - 1; c++)
	{
		for (int d = 1; d < n - c; d++)
		{
			int sum = c * d + n;

			for (int i = 0; i < divs[sum].size(); i++)
			{
				int ds = sum / divs[sum][i];

				if (divs[sum][i] > c && ds > d && divs[sum][i] != x && ds != x)
					ans++;
			}
		}
	}

	cout << ans << endl;

	if (_MSC_VER < 1920)
		system("Pause");
	return 0;
}