#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#define _MSC_VER 2000
#endif

#define uint			unsigned int
#define int				long long
#define double			long double
#define all(q)			q.begin(), q.end()
#define fora(q)			for(auto &p : q)
#define foru(q)			for (int x = 0; x < q; x++)

using namespace std;

int n = 0;
deque <int> s;

deque <pair <set<int>, int>> all;

int rec(set <int> arr = {})
{
	for (int i = 0; i < n; i++)
		if (arr.count(i) && arr.count((i + 1) % n) && arr.count((i + 2) % n) && arr.count((i + 3) % n))
			return -1;

	int ans = 0;
	for (auto& p : arr)
		ans += s[p];

	all.push_back({ arr, ans });

	for (int i = 0; i < n; i++)
	{
		if (arr.count(i) == 0)
		{
			arr.insert(i);
			ans = max(ans, rec(arr));
			arr.erase(i);
		}
	}

	return ans;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie();
	cout.tie();
	cout.precision(20);

	cin >> n;
	s.resize(n);

	fora(s)
		cin >> p;

	int q = 0;
	cin >> q;

	cout << rec() << endl;

	foru(q)
	{
		int b1 = 0, b2 = 0;
		cin >> b1 >> b2;

		for (auto& p : all)
		{
			if (p.first.count(b1 - 1))
			{
				p.second += b2 - s[b1 - 1];
			}
		}

		int ans = 0;
		for (auto& p : all)
			ans = max(ans, p.second);

		s[b1 - 1] = b2;

		cout << ans << endl;
	}

	if (_MSC_VER < 1920)
		system("Pause");
	return 0;
}