#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>

using namespace std;

bool comp(pair<int, int> p1, pair<int, int> p2) {
    return (p1.first <= p2.first);
}

int max(int a, int b) {
    if (a > b) {
        return a;
    }
    return b;
}
int main() {
    int n, x, ans;
    cin >> n >> x;
    vector<vector<pair<int, int>>> s(n * n);
    ans = 0;
    for (int i = 1; i < n; i++) {
        for (int j = 1; j < n; j++) {
            pair<int, int> w;
            w.first = i;
            w.second = j;
            s[i * j].push_back(w);
        }
    }
    for (auto v: s) {
        sort(v.begin(), v.end(), comp);
    }

    for(int a = 2; a < n; a++) {
        if (a != x) {
            for( int b = floor(n / a + 1); b < n; b++) {
                if (b != x) {

                    int l = 0;
                    int r = s[a * b - n].size();
                    while (r - l > 1) {
                        int m = (r + l) / 2;
                        if (s[a * b - n][m].first < a) {
                            l = m;
                        } else {
                            r = m;
                        }
                    }
                    int l1 = -1;
                    int r1 = s[a * b - n].size() - 1;
                    while (r1 - l1 > 1) {
                        int m = (r1 + l1) / 2;
                        if (s[a * b - n][m].second >= b) {
                            l1 = m;
                        } else {
                            r1 = m;
                        }
                    }
                    ans += max(r1 - l + 1, 0);
                }
            }
        }
    }
    cout << ans << endl;
    return 0;
}