#include <iostream>
#include<algorithm>
#include<set>
#include<vector>
#include<map>
#include<iomanip>
#include<string>

#define ll long double
#define eps 0.00001

using namespace std;

/*vector<ll> t, a;

void build(int v, int l, int r)
{
    if (l == r)
        t[v] = a[l];
    else
    {
        int m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m + 1, r);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
}

void change(int v, int l, int r, int x)
{
    if (l == r)
        t[v] = x;
    else
    {
        int m = (l + r) / 2;
        change(2 * v, l, m, x);
        change(2 * v + 1, m + 1, r, x);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
}

ll get(int v, int l, int r, int askl, int askr)
{
    if (r < askl || l > askr)
        return 0;
    if (askl <= l && askr >= r)
        return t[v];
    int m = (l + r) / 2;
    return get(2 * v, l, m, askl, askr) + get(2 * v + 1, m + 1, r, askl, askr);
}*/

vector<ll> a;

int find(int x)
{
    int l = 0, r = a.size() - 1;
    while (l < r)
    {
        int m = (l + r) / 2;
        if (a[m] == x)
            return m;
        if (a[m] < x)
        {
            if (m == a.size() - 1)
                return m;
            if (a[m + 1] > x)
                return m;
            l = m + 1;
        }
        else r = m - 1;
    }
    return l;
}

int main()
{
    int n;
    cin >> n;
    a.resize(n);
    for (ll& i : a) cin >> i;
    int q;
    cin >> q;
    vector<ll> b(q);
    ll maxq = 0;
    for (int i = 0; i < q; i++)
    {
        cin >> b[i];
        maxq = max(maxq, b[i]);
    }
    vector<int> dp(maxq + 1);
    for (int i = 0; i < min(a[0], maxq + 1); i++)
        dp[i] = 0;
    for (int i = a[0]; i <= maxq; i++)
    {
        int pos = find(i);
        dp[i] = 1 + dp[i - a[pos]];
    }
    vector<int> prefmax(maxq + 1);
    for (int i = 1; i <= maxq; i++)
        prefmax[i] = dp[prefmax[i - 1]] < dp[i] ? i : prefmax[i - 1];
    for (ll i : b)
        cout << prefmax[i] << " " << dp[prefmax[i]] << endl;
}
