#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <ostream>
#include <istream>
#include <string>
#include <random>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>

using namespace std;

#define int long long
#define pb push_back
#define all(a) (a).begin(), (a).end()

ostream& operator << (ostream& a, const vector<int> &b) {
    for (auto k : b) cout << k << " ";
    cout << "\n";
    return a;
}

#define LOCAL

#ifdef LOCAL
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
    #define dbg(x)
#endif

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    if (n > (1 << 30)) {
        int s = sqrt(n) + 1;
        int y;
        for (int x = s; x * x <= 4611686018427387903; x++){
            y = sqrt(x * x - n);
            if (y * y + n == x * x && y != 0) {
                cout << "Yes\n" <<  x<< " " << y << "\n";
                return 0;
            }
        }
        cout << "No";
        return 0;
    }
    int kek;
    int pw = pow(2, 55);
    for (int i = 1; i * i + n <= pw; i++) {
        kek = sqrt(n + i * i);
        if (kek * kek == n + i * i && kek != 0) {
            cout << "Yes\n";
            cout << kek << " " << i << "\n";
            return 0;
        }
    }
    cout << "No";
}
/*
help
*/
