#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <ostream>
#include <istream>
#include <string>
#include <random>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <time.h>

using namespace std;

#pragma GCC optimize("Ofast")

#define int long long
#define pb push_back
#define all(a) (a).begin(), (a).end()

ostream& operator << (ostream& a, const vector<int> &b) {
    for (auto k : b) cout << k << " ";
    cout << "\n";
    return a;
}

#define LOCAL

#ifdef LOCAL
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
    #define dbg(x)
#endif

mt19937 my_rand(time(0));

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    if (n == 0) {
        cout << "Yes\n1 1";
        return 0;
    }
    if (n % 2 == 0 && n % 4) {
        cout << "No\n";
        return 0;
    }
    if (n > pow(2, 57)) {
        int y;
        int x;
        for (int _ = 0; _ < 4e7; _++) {
            x = my_rand() % (1 << 31);
            y = sqrt(x * x - n);
            if (y * y + n == x * x && y != 0) {
                cout << "Yes\n" <<  x<< " " << y << "\n";
                return 0;
            }
        }
        cout << "No";
        return 0;
    }
    int kek;
    int pw = pow(2, 57);
    for (int i = 1; i * i + n <= pw; i++) {
        kek = sqrt(n + i * i);
        if (kek * kek == n + i * i && kek != 0) {
            cout << "Yes\n";
            cout << kek << " " << i << "\n";
            return 0;
        }
    }
    cout << "No";
}
/*
help//
*/
