#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <ostream>
#include <istream>
#include <string>
#include <random>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <time.h>

using namespace std;

//#pragma GCC optimize("Ofast")

#define int long long
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define ld long double

ostream& operator << (ostream& a, const vector<int> &b) {
    for (auto k : b) cout << k << " ";
    cout << "\n";
    return a;
}

#define LOCAL

#ifdef LOCAL
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
    #define dbg(x)
#endif

inline void solve(const vector<int>&a, const int& n, const int& b) {
    int val = 0, steps = 0, help, cur;
    for (int i = 1; i <= b; i++) {
        help = i;
        cur = 0;
        for (int j = n - 1; j >= 0; j--) {
            cur += help / a[j];
            help %= a[j];
        }
        if (cur > steps) {
            steps = cur;
            val = i;
        }
    }
    cout << val << " " << steps << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int q;
    cin >> q;
    while (q--) {
        int b;
        cin >> b;
        solve(a, n, b);
    }
}
/*

*/
