#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <ostream>
#include <istream>
#include <string>
#include <random>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <time.h>

using namespace std;

//#pragma GCC optimize("Ofast")

#define int long long
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define ld long double
#define pii pair<int, int>

ostream& operator << (ostream& a, const vector<int> &b) {
    for (auto k : b) cout << k << " ";
    cout << "\n";
    return a;
}

#define LOCAL

#ifdef LOCAL
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
    #define dbg(x)
#endif

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int dp[n][4][4];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 4; j++) {
            for (int k = 0; k < 4; k++) dp[i][j][k] = 0;
        }
    }
    dp[0][1][1] = a[0];
    dp[0][0][0] = 0;
    dp[1][2][2] = a[0] + a[1];
    dp[1][1][0] = a[1];
    dp[2][3][3] = a[0] + a[1] + a[2];
    dp[2][2][0] = a[1] + a[2];
    dp[2][1][1] = a[0] + a[2];
    dp[2][0][2] = a[0] + a[1];
    dp[2][0][1] = a[0];
    dp[2][0][0] = a[1];
    dp[2][0][1] = a[2];
    dp[1][0][1] = a[0];
    dp[1][0][0] = 0;
    for (int i = 3; i < n; i++) {
        for (int k = 0; k < 4; k++) {
            dp[i][0][k] = max(dp[i - 1][1][k], max(dp[i - 1][2][k], dp[i - 1][3][k]));
            dp[i][1][k] = dp[i-1][0][k] + a[i];
            dp[i][2][k] = dp[i-1][1][k] + a[i];
            dp[i][3][k] = dp[i-1][2][k] + a[i];
        }
    }
    int ans = 0;
    for (int j = 0; j < 4; j++) {
        for (int k = 0; k < 4 - j; k++) {
            ans = max(ans, dp[n - 1][j][k]);
        }
    }
    cout << ans;
}
/*
*/
