#include <iostream>
#include <cmath>
using namespace std;

bool found = 0;
int64_t n;
long double res;

void binsearch(int64_t l, int64_t r) {
	int64_t m = 0;
	if (r - l > 1 && !found) {
		if (l * 2 + 1 > n && n)
			return;
		m = (l + r) / 2;
		res = sqrtl(m * m + n);
		if (abs(res - int64_t(res)) < 1e-9 && (int64_t(res) * int64_t(res) - m * m == n)) {
			cout << "Yes\n";
			cout << int64_t(res) << ' ' << m;
			found = 1;
			return;
		}
		binsearch(l, m);
		binsearch(m, r);
	}
}

int main() {
	cin >> n;
	if (n > 67108864)
		throw;
	binsearch(0, sqrt(4611686018427387903 - n));
	if (!found)
		cout << "No";
	return 0;
}