#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int n, q;
vector<pair<int64_t, pair<int64_t, int>>> a;
int64_t b;

int binsearch(int l, int r) {
    int m;
    while (r - l > 1) {
        m = (l + r) / 2;
        if (a[m].first > b)
            r = m;
        else if (m == n - 1 || a[m + 1].first > b)
            return m;
        else
            l = m;
    }
    return l;
}

int main(){
    cin >> n;
    a.resize(n, { 0, {0, 0} });
    cin >> a[0].first;
    int64_t t;
    for (int i = 1; i < n; ++i) {
        cin >> a[i].first;
        t = a[i].first - 1;
        for (int j = i - 1; j >= 0; --j) {
            a[i].second.first += t / a[j].first;
            t %= a[j].first;
        }
        if (a[i].second.first >= a[i - 1].second.first)
            a[i].second.second = i;
        else {
            a[i].second.second = i - 1;
            a[i].second.first = a[i - 1].second.first;
        }
    }
    cin >> q;
    int c;
    int ind = 0, index;
    for (int i = 0; i < q; ++i) {
        cin >> b;
        c = 0;
        t = b;
        while (b) {
            if (!c) {
                ind = binsearch(0, n);
                c += b / a[ind].first;
                b %= a[ind].first;
            }
            else {
                index = binsearch(0, n);
                c += b / a[index].first;
                b %= a[index].first;
            }
        }
        if (c > a[ind].second.first)
            cout << t << ' ' << c;
        else
            cout << a[a[ind].second.second].first - 1 << ' ' << a[ind].second.first;
        cout << '\n';
    }
    return 0;
}
