#include <bits/stdc++.h>

using namespace std;

int main() {
    const float EPS = 1e-7;
    int n; cin >> n;
    vector<int> limits(n);
    for (int i = 0; i < n; i++) {
        cin >> limits[i];
    }
    vector<int> lens(n);
    for (int i = 0; i < n; i++) {
        cin >> lens[i];
    }
    int m; cin >> m;
    vector<int> speeds(m);
    speeds[0] = 0;
    for (int i = 1; i < m; i++) {
        cin >> speeds[i];
    }
    vector<int> taxes(m + 1);
    taxes[0] = 0;
    for (int i = 1; i < m + 1; i++) {
        cin >> taxes[i];
    }
    vector<int> times(m, 0);
    for (int i = 0; i < m; i++) {
        float new_ = 0;
        for (int j = 0; j < n; j++) {
            new_ += lens[j] / (limits[j] + speeds[i]);
            cout << new_ << ' ';
        }
        times[i] = new_ + 1 - 1e-7;
    }
    int ncars; cin >> ncars;
    for (int i = 0; i < ncars; i++) {
        int s, t; cin >> s >> t;
        int time = t - s;
        int l, r; l = -1; r = m - 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (times[mid] <= time) {
                r = mid;
            } else {
                l = mid;
            }
        }
        if (times[r] > time) {
            r++;
        }
        cout << taxes[r] << endl;
    }
}
