import sys


def main():
    EPS = 1e-7
    n = int(sys.stdin.readline())
    limits = list(map(int, sys.stdin.readline().split()))
    lens = list(map(int, sys.stdin.readline().split()))
    m = int(sys.stdin.readline())
    speeds = [0] + list(map(int, sys.stdin.readline().split()))
    taxes = [0] + list(map(int, sys.stdin.readline().split()))
    times = [0] * m
    for i in range(m):
        new_ = 0
        for j in range(n):
            new_ += lens[j] / (limits[j] + speeds[i])
        times[i] = int(new_ + 1 - EPS)
    for i in range(int(sys.stdin.readline())):
        s, t = map(int, sys.stdin.readline().split())
        time = t - s
        l, r = -1, m - 1
        while (r - l > 1):
            mid = (l + r) // 2
            if (times[mid] <= time):
                r = mid
            else:
                l = mid
        if (times[r] > time):
            r += 1
        print(taxes[r])