import sys


def get_val(b, noms, n):
    ans = 0
    while b != 0:
        l, r = 0, n
        while r - l > 1:
            mid = (l + r) // 2
            if noms[mid] > b:
                r = mid
            else:
                l = mid
        ans += b // noms[l]
        b %= noms[l]
    return ans


def get_max(b, noms, prefs, n):
    l, r = 0, n
    while r - l > 1:
        mid = (l + r) // 2
        if noms[mid] > b:
            r = mid
        else:
            l = mid
    return prefs[l]


def sol1(n, noms, q, bs):
    dp = [(0, (1, 1)) for i in range(200001)]
    dp[1] = (1, (1, 1))
    max_nom = 0
    for i in range(2, 200001):
        while max_nom < n - 1 and i == noms[max_nom + 1]:
            max_nom += 1
        if i == noms[max_nom]:
            dp[i] = (1, dp[i - 1][1])
        else:
            new = min(dp[i - noms[max_nom]][0] + 1, dp[i - 1][0] + 1)
            if new > dp[i - 1][1][0]:
                dp[i] = (new, (new, i))
            else:
                dp[i] = (new, dp[i - 1][1])
    for i in range(q):
        t = bs[i]
        print(*(dp[t][1][::-1]))



def sol2(n, noms, q, bs):
    prefs = [(0, 0)]
    for i in range(1, n):
        val = get_val(noms[i] - 1, noms, n)
        if val > prefs[i - 1][1]:
            prefs.append((noms[i] - 1, val))
        else:
            prefs.append(prefs[i - 1])
    for i in range(q):
        b = bs[i]
        ans = (0, 0)
        ans = max(ans, get_max(b, noms, prefs, n))
        val = get_val(b, noms, n)
        if ans[1] < val:
            ans = (b, val)
        for i in range(n):
            b1 = b
            b1 -= b1 % noms[i]
            b1 -= 1
            val = get_val(b1, noms, n)
            if val > ans[1]:
                ans = (b1, val)
        print(*ans)


#from random import randint


#n = randint(1, 10)
#noms = [1]
#for i in range(n - 1):
    #noms.append(noms[i] + randint(1, 20))
#q = randint(1, 10)
#for i in range(q):
    #b = randint(1, 300)
    #ans1, ans2 = sol1(n, noms, q, [b]), sol2(n, noms, q, [b])
    #if ans1 != ans2:
        #print(ans1, ans2, sep='\n')
        #break


n = int(sys.stdin.readline())
noms = list(map(int, sys.stdin.readline().split()))
q = int(sys.stdin.readline())
bs = [int(sys.stdin.readline()) for i in range(q)]
if max(bs) <= 200000:
    sol1(n, noms, q, bs)
else:
    sol2(n, noms, q, bs)