#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
vector<double> A;
vector<double> V;
double m;
double bin_p(double num) {
    double l = 0;
    double r = m;
    while (r - l > 1) {
        double center = (r + l) / 2;
        if (A[center] >= num) {
            r = center;
        } else {
            l = center;
        }
    }
    return l;
}
double bin_p2(double num) {
    double l = 0;
    double r = m;
    while (r - l > 1) {
        double center = (r + l) / 2;
        if (V[center] > num) {
            r = center;
        } else {
            l = center;
        }
    }
    return l;
}
int main() {
    double n, q, leng;
    leng = 0;
    cin >> n;
    V.resize(n);
    for (double i = 0; i < n ; ++i) {
        cin >> V[i];
    }
    vector<double> L(n);
    for (double i = 0; i < n; ++i) {
        cin >> L[i];
        leng += L[i];
    }
    cin >> m;
    A.resize(m);
    A[0] = 0;
    for (double i = 1; i < m; ++i) {
        cin >> A[i];
    }
    vector<double> F(m);
    for (double i = 0; i < m; ++i) {
        cin >> F[i];
    }
    cin >> q;
    double s, f, time, v;
    for (double i = 0; i < q; ++i) {
        cin >> s >> f;
        v = leng / (f - s);
        auto idx = bin_p2(v);
        double e = v - V[idx];
        if (e > 0) {
            cout << F[bin_p(e)] << "\n";
        } else {
            cout << 0 << "\n";
        }
    }

}
