#include <bits/stdc++.h>
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,mmx,abm,tune=native")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
using namespace std;

int n, m, s;
vector <vector <vector <int> > > num;
vector <vector <int> > a;

inline int count_func(const vector <vector <int> >&kek, const vector <int>&num, const vector <int>&z) {
    vector <int> val(2 * n - 1);
    for (int i = 0; i < n; i++)
        val[i] = (num[i] < z[i]);
    int step = n;
    for (auto el : kek) {
        int a = el[0], b = el[1], op = el[2];
        if (op == 1)
            val[step] = (val[a] & val[b]);
        else
            val[step] = (val[a] | val[b]);
        step++;
    }
    return val.back();
}

vector <int> cur;

inline void gen() {
    if ((int)cur.size() == n) {
        int lol = 0;
        for (int i = 0; i < m; i++)
            lol += count_func(num[i], a[i], cur);
        if (lol == s) {
            for (auto el : cur)
                cout << el << " ";
            exit(0);
        }
    }
    else {
        for (int i = 0; i <= m; i++) {
            cur.push_back(i);
            gen();
            cur.pop_back();
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n >> m >> s;
    num.resize(m);
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            int a, b, op;
            cin >> a >> b >> op;
            a--;
            b--;
            num[i].push_back({a, b, op});
        }
    }
    a.resize(m);
    bool fl = true;
    for (int i = 0; i < m; i++) {
        a[i].resize(n);
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
            if (a[i][j] != i)
                fl = false;
        }
    }
    if (m <= 2 && n <= 10) {
        gen();
        return 0;
    }
    if (fl) {
        for (int i = 0; i < n; i++)
            cout << s << " ";
        return 0;
    }
    if (n == 1) {
        int lft = 0, rght = m;
        while (rght - lft > 1) {
            int mid = (rght + lft) >> 1;
            int smth = 0;
            for (int i = 0; i < m; i++)
                smth += count_func(num[i], a[i], {mid});
            if (smth <= s)
                lft = mid;
            else
                rght = mid;
        }
        cout << lft;
        return 0;
    }
    int lft = 0, rght = m;
    while (rght - lft > 1) {
        int mid = (rght + lft) >> 1;
        int smth = 0;
        for (int i = 0; i < m; i++)
            smth += count_func(num[i], a[i], {mid, 0});
        if (smth <= s)
            lft = mid;
        else
            rght = mid;
    }
    for (int z1 = lft; z1 <= lft; z1++) {
        int l = 0, r = m;
        while (r - l > 1) {
            int mid = (r + l) >> 1;
            int lol = 0;
            for (int i = 0; i < m; i++)
                lol += count_func(num[i], a[i], {z1, mid});
            if (lol == s) {
                cout << z1 << " " << mid;
                return 0;
            }
            if (lol <= s)
                l = mid;
            else
                r = mid;
        }
        int smth = 0;
        for (int i = 0; i < m; i++)
            smth += count_func(num[i], a[i], {z1, l});
        if (smth == s) {
            cout << z1 << " " << l;
            return 0;
        }
    }
    return 0;
}
