#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <utility>
#include <algorithm>

#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define fx(x, a) for (auto &x : a)
#define all(x) x.begin(), x.begin()
#define siz(x) (int)x.size()
#define lb lower_bound
#define ub upper_bound

using namespace std;


typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef vector<ch> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef long long ll;
typedef unsigned long long ull;


const int MX = 100010;
const int INF = 1e9 + 50;
const int MOD = 1000000007;

int main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    int d = 1;
    while (d * d <= n) {
        if (n % d == 0) {
            ll a = d;
            ll b = n / d;
            ll x = a + b;
            if (x % 2 != 0) {
                ++d;
                continue;
            }
            x /= 2;
            ll y = b - x;
            cout << "Yes\n";
            cout << x << ' ' << y;
            return 0;
        }
        ++d;
    }
    cout << "No\n";

}