#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <utility>
#include <algorithm>
#include <cassert>

/*#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")*/

#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define fx(x, a) for (auto &x : a)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()
#define lb lower_bound
#define ub upper_bound

using namespace std;


typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef vector<ch> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef long long ll;
typedef unsigned long long ull;
typedef vector<vector<bool>> vvb;
typedef vector<bool> vb;

const int MX = 100010;
const int INF = 1e9 + 50;
const int MOD = 1000000007;

const double EPS = 1e-9;

int a[MX];
int b[MX];
int op[MX];
bool ct[MX][2];
int table[MX][2];


signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, s;
    cin >> n >> m >> s;
    assert(n != 1);
    if (n == 1) {
        cout << s - 1;
        return 0;
    }
    fi(0, m) {
        cin >> a[i] >> b[i] >> op[i];
    }
    fi(0, m) {
        fj(0, n) {
            cin >> table[i][j];
        }
    }
    for (int cur = 0; cur <= m; ++cur) {
        for (int cur2  = 0; cur2 <= m; ++ cur2) {
            int ans = 0;
            fi(0, m) {
                int res;
                ct[i][0] = table[i][0] < cur;
                ct[i][1] = table[i][1] < cur2;
                if (op[i] == 1)
                    res = ct[i][0] && ct[i][1];
                else
                    res = ct[i][0] || ct[i][1];
                ans += res;
            }
            if (ans == s) {
                cout << cur << ' ' << cur2 << '\n';
                return 0;
            }
        }
    }
}