#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <utility>
#include <algorithm>
#include <cmath>

#ifndef LOCAL
#pragma GCC optimize("O3")
    #pragma GCC optimize("unroll-loops")
    #pragma GCC optimize("fast-math")
#endif
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define fx(x, a) for (auto &x : a)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()
#define lb lower_bound
#define ub upper_bound

using namespace std;


typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef vector<ch> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef long long ll;
typedef unsigned long long ull;


const int INF = 1e9 + 50;
const int MOD = 1000000007;


str to_str(int a) {
    str res;
    bool min = a < 0;
    do {
        res += '0' + a % 10;
        a /= 10;
    } while (a);
    if (min)
        res += '-';
    reverse(all(res));
    return res;
}

ll gcd(ll a, ll b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

const int MX = 3000 + 2999 * 2999 + 1;
int ld[MX];
bool is_prime[MX];
vi primes;


signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    primes.reserve(2000000);
    fill(ld, ld + MX, -1);
    fi(2, MX) {
        if (ld[i] == -1) {
            primes.push_back(i);
            is_prime[i] = true;
            ld[i] = i;
        }
        fx(x, primes) {
            if (x > ld[i] || 1ll * i * x >= MX)
                break;
            ld[1ll * i * x] = x;
        }
    }
    int n, x;
    cin >> n >> x;


    int cnt = 0;

    rep(c, 1, n) {
        rep(d, 1, n) {

            int ab = n + c * d;
            if (is_prime[ab])
                continue;
            int cab = ab;
            vpii divs;
            divs.reserve(15);
            divs.push_back({ld[ab], 1});
            cab /= ld[ab];
            while (cab != 1) {
                if (ld[cab] != divs.back().first)
                    divs.push_back({ld[cab], 0});
                cab /= ld[cab];
                ++divs.back().second;
            }

            int pnum = divs.size();
            vi cur(pnum, 0);
            int a = 1;
            int b = ab;
            int divsnum = 1;
            fx(x, divs)
                divsnum *= x.second + 1;
            fi(1, divsnum) {
                fj(0, pnum) {
                    if (cur[j] != divs[j].second) {
                        ++cur[j];
                        a *= divs[j].first;
                        b = ab / a;
                        if (a > c && b > d && a != x && b != x) {
                            ++cnt;
                        }
                        break;
                    } else {
                        a /= pow(divs[j].first, cur[j]);
                        cur[j] = 0;
                    }
                }
            }

        }
    }
    cout << cnt;
}