#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <utility>
#include <algorithm>

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define fx(x, a) for (auto &x : a)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()
#define lb lower_bound
#define ub upper_bound

using namespace std;


typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef vector<ch> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef long long ll;
typedef unsigned long long ull;


const int MX = 40010;
const int INF = 1e9 + 50;
const int MOD = 1000000007;


str to_str(int a) {
    str res;
    bool min = a < 0;
    a = abs(a);
    do {
        res += '0' + a % 10;
        a /= 10;
    } while (a);
    if (min)
        res += '-';
    reverse(all(res));
    return res;
}

vi arr;
vi invalid;

void solve() {
    int n = arr.size();
    int mx = 0;
    rep(mask, 0, (1 << n)) {
        int ans = 0;
        fi(0, n) {
            if ((1 << i) & mask)
                ans += arr[i];
        }
        bool good = true;
        fx(x, invalid) {
            if ((x & mask) == x) {
                good = false;
                break;
            }
        }
        if (good) {
            mx = max(mx, ans);
        }

    }
    cout << mx << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    fi(0, n) {
        int x = 0;
        fj(i, i + 4)
            x += (1 << (j % n));
        invalid.push_back(x);
    }
    arr.resize(n);
    fi(0, n)
        cin >> arr[i];
    solve();
    int q;
    cin >> q;
    fi(0, q) {
        int ind, x;
        cin >> ind >> x;
        --ind;
        arr[ind] = x;
        solve();
    }
}