#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <numeric>
#include <assert.h>
#include <chrono>
#include <ctime>
#include <random>
using namespace std;

#define all(x) (x).begin(), (x).end()

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    map<int, vector<int>> pos;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pos[a[i]].emplace_back(i);
    }
    vector<int> ans(n + 1);
    for (auto &i : pos) {
        int last = 0;
        for (auto j : i.second) {
            for (; last <= j; ++last) {
                for (int x = j; x < n; ++x) {
                    ans[x - last + 1] += 1;
                }
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        cout << ans[i] << " ";
    }
}
