#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <numeric>
#include <assert.h>
#include <chrono>
#include <ctime>
#include <random>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define int long long
signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    map<int, vector<int>> pos;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pos[a[i]].emplace_back(i);
    }
    vector<int> ans(n + 1);
    vector<int> sum(n + 1);
    vector<int> good(n + 1);
    vector<int> bad(n + 1);

    for (auto &i : pos) {
        int last = 0;
        for (auto j : i.second) {
            int first = 0;
            int mid = j - last;
            int second = n - 1 - last;
            int cur = 1;
            for (int x = first; x < mid; ++x) {
                ans[x] += cur++;
            }
            for (int x = mid; x <= second - mid; ++x) {
                ans[x] += cur;
            }
            for (int x = second - mid + 1; x <= second; ++x) {
                ans[x] += --cur;
            }
            last = j + 1;
        }
    }
    for (int i = 0; i < n; ++i) {
      cout << ans[i]  << " ";
    }
}
