#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <numeric>
#include <assert.h>
#include <chrono>
#include <ctime>
#include <random>
using namespace std;

#define all(x) (x).begin(), (x).end()

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    map<int, vector<int>> pos;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        pos[a[i]].emplace_back(i);
    }
    vector<int> ans(n + 1);
    vector<int> sum(n + 1);
    vector<int> good(n + 1);
    vector<int> bad(n + 1);

    for (auto &i : pos) {
        int last = 0;
        for (auto j : i.second) {
            int first = 0;
            int mid = j - last;
            int second = n - 1 - last;

            good[first] += 1;
            int ptr = 1;
            for (int x = first; x <= second; ++x) {
                ans[x] += ptr;
                if (x <= min(second - mid, mid) - 1) {
                    ++ptr;
                } else if (x >= max(second - mid, mid)) {
                    --ptr;
                }
            }

            bad[second - mid + 1] += 1;
            bad[mid + 1] += 1;

            last = j + 1;
        }
    }
    int b = 0, g = 0, sm = 0;
    int add = 0;
    for (int i = 0; i < n; ++i) {
        b += bad[i];
        g += good[i];
        sm -= sum[i];
        add += g;
        add -= b;
        sm += add;
        cout << ans[i] << " ";
    }
}
