#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <numeric>
#include <assert.h>
#include <chrono>
#include <ctime>
#include <random>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define int long long

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int q;
    cin >> q;

    vector<tuple<int, int, int, int>> ans = {{1, 1, 0, 1}};
    int s = 1, cur = 1;
    while (s < 1e18) {
        auto p = upper_bound(all(a), s);
        --p;
        while ((p + 1) != a.end() && s + *p >= *(p + 1)) {
            ++p;
        }
        int l = 1, r = (1e18 - s) / *p + 2;
        while ((r - l) > 1) {
            int m = (l + r) / 2;
            if ((p + 1 == a.end() && s + *p * m <= 1e18) || ((p + 1) != a.end() && s + *p * m < *(p + 1))) {
                l = m;
            } else {
                r = m;
            }
        }
        ans.emplace_back(s, cur, l, *p);
        s += *p * l;
        cur += l;
    }
    while (q--) {
        int b;
        cin >> b;
        auto it = upper_bound(all(ans), (tuple<int, int, int, int>){b, 1e18, 1e18, 1e18});
        --it;
        auto [x, y, z, v] = *it;
        int len = min((b - x) / v, z);
        cout << x + len * v << " " <<  y + len << '\n';
    }
}
