#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

int main()
{
    int n;
    cin >> n;
    vector<int> v(n);
    long long ok = 0;
    for(int i = 0;i < n; ++i)
    {
        cin >> v[i];
    }
    vector<int> l(n);
    for(int i = 0;i < n; ++i)
    {
        cin >> l[i];
        ok += l[i] * 1.0 / v[i];
    }
    int m;
    cin >> m;
    vector<int> g(m, 0);
    for(int i = 1;i < m; ++i)
    {
        cin >> g[i];
    }
    vector<int> f(m);
    for(int i = 0;i < m; ++i)
    {
        cin >> f[i];
    }
    int q;
    cin >> q;
    for(int qq = 0;qq < q; ++qq)
    {
        double s, t;
        cin >> s >> t;
        t -= s;
        if(ok <= t)
        {
            cout << 0 << '\n';
            continue;
        }
        int l1 = 0, r = m;
        while(l1 + 1 < r)
        {
            int m1 = (l1 + r) / 2;
            double s = 0;
            for(int i = 0;i < n; ++i)
            {
                s += (l[i] * 1.0 / (v[i] + g[m1]));
            }
            if (s > t)
            {
                l1 = m1;
            }
            else
            {
                r = m1;
            }
        }
        cout << f[l1] << '\n';
    }
}

