#include <bits/stdc++.h>
//#define int long long 

#define ff first
#define ss second 

#define pii pair<int, int>
#define mp make_pair 

#define pb push_back 
#define eb emplace_back 

#define all(x) (x).begin(), (x).end()


using namespace std;
typedef long long ll; 
typedef long double ld; 
const int maxn = 40000 + 10, mod = 1e9 + 7, MAXN = 1e6 + 7;
const ll inf = 1e18;
mt19937 rnd(time(0));
int n; 
int a[maxn];
const int L = 4; 
const int block = 200; 
ll dp[L][maxn / block][4][4];  
int idd[L][maxn]; 
vector<int> comp[L][maxn / block]; 

ll solve(int ptr, int idx, int L, int R) {    
    deque<int> ms;
    for (auto v : comp[ptr][idx]) ms.pb(v); 
    if (L + R >= (int)ms.size()) return 0; 
    ll add = 0; 
    for (int i = 0; i < L; ++i) {
        add += a[ms[0]]; 
        ms.pop_front(); 
    }
    for (int i = 0; i < R; ++i) {
        add += a[ms.back()]; 
        ms.pop_back();  
    }
    ms.pop_back();
    if ((int)ms.size()) ms.pop_front();
    vector<ll> dp((int)ms.size() + 1);            
    ll ans = 0; 
    for (int i = 1; i < (int)ms.size() + 1; ++i) {                
        dp[i] = max(dp[i], dp[i - 1]); 
        ll cur = 0; 
        for (int j = 1; j <= 3; ++j) {
            if (i - j < 0) continue;
            cur += a[ms[i - j]]; 
            dp[i] = max(dp[i], cur); 
            ans = max(ans, dp[i]);
            if (i - j - 1 < 0) continue;  
            dp[i] = max(dp[i], dp[i - j - 1] + cur); 
            ans = max(ans, dp[i]);
        }
    }
    return ans + add; 
}

void upd(int idx) {
    for (int i = 0; i < L; ++i) {
        for (int l1 = 0; l1 < L; ++l1) {
            for (int r1 = 0; r1 < L; ++r1) {
                dp[i][idd[i][idx] / block][l1][r1] = solve(i, idd[i][idx] / block, l1, r1);                  
            }
        }
    }    
}

ll get(int ptr) {
    vector<vector<ll> > dpp(maxn / block + 1, vector<ll> (4, 0ll));
    ll ans = 0; 
    for (int i = 1; i <= maxn / block; ++i) {
        for (int l1 = 0; l1 < L; ++l1) {
            for (int l2 = 0; l2 < L; ++l2) {
                dpp[i][l2] = max(dpp[i][l2], dpp[i - 1][l2]); 
                for (int lst = 0; lst < L; ++lst) {
                    if (l1 + lst < L) {
                        dpp[i][l2] = max(dpp[i][l2], dpp[i - 1][lst] + dp[ptr][i - 1][l1][l2]); 
                        ans = max(ans, dpp[i][l2]); 
                    }                        
                }                                                                           
            }
        }                
    }
    return ans;       
}

ll get() {
    ll ans = 0;
    for (int i = 0; i < L; ++i) {
        ans = max(ans, get(i));             
    }        
    return ans;     
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; 
    }    
    vector<int> tt;
    for (int i = 0; i < 3 * n; ++i) {
        tt.pb(i % n); 
    }    
    for (int i = 0; i < L; ++i) {
        for (int j = 1; j < n; ++j) {
            comp[i][(j - 1) / block].pb(tt[i + j]);             
            idd[i][tt[i + j]] = j - 1; 
        }
    }
    for (int ptr = 0; ptr < L; ++ptr) {
        for (int i = 0; i < maxn / block; ++i) {
            if ((int)comp[ptr][i].size() == 0) continue; 
            while (comp[ptr][i].size() < L) {
                comp[ptr][i].pb(n); 
            }
        }
    }
    int q; cin >> q;        
    for (int ptr = 0; ptr < L; ++ptr) {
        for (int i = 0; i < maxn / block; ++i) {
            for (int l1 = 0; l1 < L; ++l1) {
                for (int r1 = 0; r1 < L; ++r1) {
                    dp[ptr][i][l1][r1] = solve(ptr, i, l1, r1); 
                }
            }
        }
    }
    cout << get() << '\n';
    for (int test = 0; test < q; ++test) {
        int p, v; cin >> p >> v, --p;
        a[p] = v; 
        upd(p);  
        cout << get() << '\n'; 
    }        
}

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin);
  freopen("TASK.out", "w", stdout);      
#endif 
    ios_base::sync_with_stdio(false); 
    int t = 1;
    for (int i = 0; i < t; ++i) solve(); 
    return 0; 
}                                                