#include <bits/stdc++.h>
#define int long long 

#define ff first
#define ss second 

#define pii pair<int, int>
#define mp make_pair 

#define pb push_back 
#define eb emplace_back 

#define all(x) (x).begin(), (x).end()


using namespace std;
typedef long long ll; 
typedef long double ld; 
const int maxn = 40000 + 7, mod = 1e9 + 7, MAXN = 1e6 + 7;
const ll inf = 1e18;
mt19937 rnd(time(0));

int n; 
int a[maxn];
const int L = 4; 
int id[L][maxn]; 
vector<int> perm[L];

struct node {
    int ptr[L][L]; 
};

node null; 

node merge(node L1, node R1) {
    node ans; 
    for (int i = 0; i < 4; ++i) {        
        for (int j = 0; j < 4; ++j) {
            ans.ptr[i][j] = 0;        
        }
    }
    for (int l1 = 0; l1 < L; ++l1) {
        for (int r1 = 0; r1 < L; ++r1) {
            for (int l2 = 0; l2 < L; ++l2) {
                for (int r2 = 0; r2 < L; ++r2) {
                    if (r1 + l2 >= L) continue; 
                    ans.ptr[l1][r2] = max(ans.ptr[l1][r2], L1.ptr[l1][r1] + R1.ptr[l2][r2]);
                }            
            }
        }
    }
    return ans;
} 

int solve(deque<int> t, int L, int R) {
    int sm = 0;
    for (auto v : t) sm += v; 
    if (L + R > t.size()) return 0;  
    if (L + R == t.size()) {        
        if (R == 0) return sm;
        if (L == 0) return sm;
        return 0;          
    }    
    int add = 0; 
    for (int i = 0; i < L; ++i) {
        add += t[0]; 
        t.pop_front(); 
    }
    for (int i = 0; i < R; ++i) {
        add += t.back(); 
        t.pop_back(); 
    }                    
    t.pop_back();
    if (t.size()) t.pop_front();
    vector<ll> dp((int)t.size() + 1);            
    int ans = 0; 
    for (int i = 1; i < (int)t.size() + 1; ++i) {                
        dp[i] = max(dp[i], dp[i - 1]); 
        ll cur = 0; 
        for (int j = 1; j <= 3; ++j) {
            if (i - j < 0) continue;
            cur += t[i - j]; 
            dp[i] = max(dp[i], cur); 
            ans = max(ans, dp[i]);
            if (i - j - 1 < 0) continue;  
            dp[i] = max(dp[i], dp[i - j - 1] + cur); 
            ans = max(ans, dp[i]);
        }
    }
    return ans + add;                     
}

node upd1(int ptr, int l, int r) {
    node ans;
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 4; ++j) ans.ptr[i][j] = 0; 
    }
    deque<int> t;
    for (int i = l; i <= r; ++i) {
        t.pb(perm[ptr][i]);                 
    }                 
    for (int l1 = 0; l1 < L; ++l1) {
        for (int r1 = 0; r1 < L; ++r1) {
            ans.ptr[l1][r1] = solve(t, l1, r1);             
        }
    }
    return ans; 
}

struct Tree {
    vector<node> tree; 
    int len = 1;
    void build(int siz = maxn) {
        while (len < siz) len <<= 1; 
        tree.resize(len + len - 1);
        for (int i = 0; i < tree.size(); ++i) {
            for (int j = 0; j < L; ++j) {
                for (int j1 = 0; j1 < L; ++j1) {
                    tree[i].ptr[j][j1] = 0; 
                }
            }             
        }
    }
    int get() {                         
        int ans = 0; 
        for (int i = 0; i < L; ++i) {
            for (int j = 0; j < L; ++j) {
                ans = max(ans, tree[0].ptr[i][j]); 
            }
        } 
        return ans; 
    }
    void upd(int l, int r, int l1, int r1, int rt, int x, int ptr) {
        if (max(l, l1) > min(r, r1)) return; 
        if (r - l <= 17) {
            tree[rt] = upd1(ptr, l, r);
            return; 
        }         
        int t = (l + r) / 2; 
        upd(l, t, l1, r1, rt * 2 + 1, x, ptr); 
        upd(t + 1, r, l1, r1, rt * 2 + 2, x, ptr); 
        node L1 = tree[rt * 2 + 1]; 
        node R1 = tree[rt * 2 + 2];
        tree[rt] = merge(L1, R1); 
    }
    void upd(int id, int x, int ptr) {
        upd(0, len - 1, id, id, 0, x, ptr); 
    }
}; 

Tree ms[L];

int get() {
    int ans = 0; 
    for (int i = 0; i < L; ++i) {
        ans = max(ans, ms[i].get()); 
    }
    return ans; 
}

void solve() {
    for (int i = 0; i < L; ++i) ms[i].build(); 
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i]; 
    }    
    vector<int> tt;
    for (int i = 0; i < 3 * n; ++i) {
        tt.pb(i % n); 
    }    
    for (int i = 0; i < L; ++i) {
        for (int j = 1; j < n; ++j) {
            perm[i].pb(a[tt[i + j]]); 
            id[i][tt[i + j]] = j - 1; 
        }
    }
    for (int i = 0; i < L; ++i) {
        for (int p = 0; p < L * L; ++p) perm[i].pb(0); 
    }            
    for (int i = 0; i < L; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            ms[i].upd(j, perm[i][j], i);  
        }
    }
    int q; cin >> q;        
    cout << get() << '\n'; 
    for (int test = 0; test < q; ++test) {
        int p, v; cin >> p >> v, --p; 
        a[p] = v; 
        for (int i = 0; i < L; ++i) {
            perm[i][id[i][p]] = v; 
            ms[i].upd(id[i][p], v, i);  
        }
        cout << get() << '\n'; 
    }        
}

signed main() {
#ifdef LOCAL
  freopen("TASK.in", "r", stdin);
  freopen("TASK.out", "w", stdout);      
#endif 
    ios_base::sync_with_stdio(false); 
    int t = 1;
    for (int i = 0; i < t; ++i) solve(); 
#ifdef LOCAL
    cerr << clock() / (ld)CLOCKS_PER_SEC; 
#endif
    return 0; 
}                                                