#include <iostream>
#include <vector>
#include <algorithm>

#define ll long long

using namespace std;

ll MAXQ = 200001;

int main() {
    ll n;
    cin >> n;
    vector <ll> a(n);
    for (ll i = 0; i < n; i++)
        cin >> a[i];
    ll cnt = 0;
    vector <ll> query(MAXQ);
    for (ll i = 1; i < MAXQ; i++) {
        if (cnt != n - 1 && a[cnt + 1] == i)
            cnt++;
        query[i] = query[i - a[cnt]] + 1;
    }
    vector <pair <ll, ll>> ans(MAXQ);
    for (ll i = 1; i < MAXQ; i++) {
        ans[i].first = query[i];
        ans[i].second = i;
    }
    for (ll i = 1; i < MAXQ; i++) 
        ans[i] = max(ans[i], ans[i - 1]);
    ll q;
    cin >> q;
    while (q--) {
        ll pos;
        cin >> pos;
        cout << ans[pos].second << " " << ans[pos].first << endl;
    }
    return 0;
}