#include <iostream>
#include <array>

#define INF 100000000000000000
#define max(a,b) (((a) > (b)) ? (a) : (b));

std::array<long long, 4> now;
std::array<long long, 4> next;

int n;
long long data[400005];
int q;

long long get(int f)
{
    now[0] = 0;
    now[1] = -INF;
    now[2] = -INF;
    now[3] = -INF;

    for (int i = (f + 1); i != f; i = ((i + 1) % n))
    {
        int p = (i - 1) % n;
        next = std::array<long long, 4>{ -INF, -INF, -INF, -INF };
        next[0] = max(next[0], now[0]); 
        next[0] = max(next[0], now[1]); 
        next[0] = max(next[0], now[2]); 
        next[0] = max(next[0], now[3]);

        next[1] = max(next[1], now[0] + data[i]);

        next[2] = max(next[2], now[0] + data[i]);
        next[2] = max(next[2], now[1] + data[i]);

        next[3] = max(next[3], now[0] + data[i]);
        next[3] = max(next[3], now[1] + data[i]);
        next[3] = max(next[3], now[2] + data[i]);
        now = next;
    }
    long long mx = max(now[0], now[1]);
    mx = max(mx, now[2]);
    mx = max(mx, now[3]);
    return mx;
}

int main()
{
    std::ios_base::sync_with_stdio(false);
    std::cin >> n;
    for (int i = 0; i < n; i++)
    {
        std::cin >> data[i];
    }
    long long mx = 0;
    mx = max(get(0), get(1));
    mx = max(mx, get(2));
    mx = max(mx, get(3));
    std::cout << mx << '\n';
    std::cin >> q;
    for (int i = 0; i < q; i++)
    {
        int num, v;
        std::cin >> num >> v; num--;
        data[num] = v;
        long long mx = 0;
        mx = max(get(0), get(1));
        mx = max(mx, get(2));
        mx = max(mx, get(3));
        std::cout << mx << '\n';
    }
    return 0;
}