#include <cstring>
#include <string>
#include <iostream>
#include <vector>

using namespace std;


bool comp(int x, int y) {
    return x > y;
}

int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);
    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    vector<int> l(n);
    for (int i = 0; i < n; ++i)
        cin >> l[i];
    int m;
    cin >> m;
    vector<int> a(m);
    a[0] = 0;
    for (int i = 1; i < m; ++i)
        cin >> a[i];
    vector<int> f(m + 1);
    f[0] = 0;
    for (int i = 1; i <= m; ++i)
        cin >> f[i];
    vector<double> fastest(m);
    for (int i = 0; i < m; ++i)
    {
        for (int j = 0; j < n; ++j)
            fastest[i] += (l[j] * (double(1.0))) / (v[j] + a[i]);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i)
    {
        int y, z, x;
        cin >> y >> z;
        x = z - y;
        if (x <= fastest[m - 1])
        {
            cout << f[m] << '\n';
            continue;
        }
        int le = -1, ri = m - 1;
        while (le < ri - 1)
        {
            int mid = (le + ri + 1) / 2;
            if (fastest[mid] > x)
                le = mid;
            else
                ri = mid;

        }
        cout << f[ri] << '\n';
    }
}