#include <cstring>
#include <string>
#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

/*
Node tr[1000000];
int SZ = 0;

struct Node
{
    int l, r, lbond, rbond, pushed = 0, s = 0;

    void push(int x)
    {
        pushed += x;
    }

    void push()
    {
        if (rbond - lbond == 1)
            return;
        tr[l].push(pushed);
        tr[r].push(pushed);
    }

    int get()
    {
        return s + pushed * (rbond - lbond);
    }

    void update()
    {
        if (rbond - lbond == 1)
            return;
        s = tr[l].get() + tr[r].get();
    }



    int get(int x, int y)
    {
        if (rbond <= x || y <= lbond)
            return 0;
        if (x <= lbond && rbond <= y)
            return this->get();
        push();
        update();
        return tr[l].get(x, y) + tr[r].get(x, y);
    }

    void update(int x, int y, int z)
    {
        if (rbond <= x || y <= lbond)
            return;
        if (x <= lbond && rbond <= y)
            return push(z);
        push();
        tr[++SZ] = tr[l];
        l = SZ - 1;
        tr[++SZ] = tr[r];
        r = SZ - 1;
        tr[l].update(x, y, z);
        tr[r].update(x, y, z);
        update();
    }
};*/



int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);
    int n;
    cin >> n;   
    vector<int> a(n);
    vector<int> pre(n);
    long long sum = 0;
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        pre[i] = a[i];
        if (i)
            pre[i] += pre[i - 1];
    }
    int in = 0;
    for (int i = 0; i < n; ++i)
    {
        if (abs(pre[in] - pre[n - 1] + pre[in]) > abs(pre[i] - pre[n - 1] + pre[i]))
            in = i;
    }
    cout << in + 1 << '\n';
}