#include <cstring>
#include <string>
#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>

#define int long long
#define x first
#define y second

using namespace std;

/*
Node tr[1000000];
int SZ = 0;

struct Node
{
    int l, r, lbond, rbond, pushed = 0, s = 0;

    void push(int x)
    {
        pushed += x;
    }

    void push()
    {
        if (rbond - lbond == 1)
            return;
        tr[l].push(pushed);
        tr[r].push(pushed);
    }

    int get()
    {
        return s + pushed * (rbond - lbond);
    }

    void update()
    {
        if (rbond - lbond == 1)
            return;
        s = tr[l].get() + tr[r].get();
    }



    int get(int x, int y)
    {
        if (rbond <= x || y <= lbond)
            return 0;
        if (x <= lbond && rbond <= y)
            return this->get();
        push();
        update();
        return tr[l].get(x, y) + tr[r].get(x, y);
    }

    void update(int x, int y, int z)
    {
        if (rbond <= x || y <= lbond)
            return;
        if (x <= lbond && rbond <= y)
            return push(z);
        push();
        tr[++SZ] = tr[l];
        l = SZ - 1;
        tr[++SZ] = tr[r];
        r = SZ - 1;
        tr[l].update(x, y, z);
        tr[r].update(x, y, z);
        update();
    }
};*/



int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    int q;
    cin >> q;
    vector<int> b(q);
    for (int i = 0; i < q; ++i)
        cin >> b[i];
    a.push_back((int)1e18 + 1);
    vector<pair<int, int>> pre(n);
    if (n == 1)
    {
        for (int i = 0; i < q; ++i)
        {
            cout << b[i] << ' ' << b[i] << '\n';
        }
        return 0;
    }
    pre[0] = { a[1] - 1, a[1] - 1 };
    for (int i = 1; i < n; ++i)
    {
        int pos = (a[i + 1] - 1 - pre[i - 1].x) / a[i];
        pre[i] = { pre[i - 1].x + pos * a[i], pre[i - 1].y + pos };
    }
    for (int p : b)
    {
        int i = upper_bound(pre.begin(), pre.end(), make_pair(p, (int)1e18 + 2)) - pre.begin() - 1;
        if (i == -1)
        {
            cout << p << ' ' << p << '\n';
            continue;
        }
        //assert(a[i + 1] > p);
        int pos = (p - pre[i].x) / a[i + 1];
        cout << pre[i].x + pos * a[i + 1] << ' ' << pre[i].y + pos << '\n';
    }
}