#include <cstring>
#include <string>
#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>

#define int long long
#define x first
#define y second

using namespace std;

/*
Node tr[1000000];
int SZ = 0;

struct Node
{
    int l, r, lbond, rbond, pushed = 0, s = 0;

    void push(int x)
    {
        pushed += x;
    }

    void push()
    {
        if (rbond - lbond == 1)
            return;
        tr[l].push(pushed);
        tr[r].push(pushed);
    }

    int get()
    {
        return s + pushed * (rbond - lbond);
    }

    void update()
    {
        if (rbond - lbond == 1)
            return;
        s = tr[l].get() + tr[r].get();
    }



    int get(int x, int y)
    {
        if (rbond <= x || y <= lbond)
            return 0;
        if (x <= lbond && rbond <= y)
            return this->get();
        push();
        update();
        return tr[l].get(x, y) + tr[r].get(x, y);
    }

    void update(int x, int y, int z)
    {
        if (rbond <= x || y <= lbond)
            return;
        if (x <= lbond && rbond <= y)
            return push(z);
        push();
        tr[++SZ] = tr[l];
        l = SZ - 1;
        tr[++SZ] = tr[r];
        r = SZ - 1;
        tr[l].update(x, y, z);
        tr[r].update(x, y, z);
        update();
    }
};*/



int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    vector<pair<int, int>> dp(n, { 0, 0 });
    dp[0].x = a[0];
    dp[1].x = a[0] + a[1];
    dp[2].x = a[0] + a[1] + a[2];
    dp[1].y = a[1];
    dp[2].y = a[1] + a[2];
    dp[3].y = a[1] + a[2] + a[3];
    int tmp;
    for (int i = 3; i < n - 1; ++i)
    {
        tmp = 0;
        for (int j = 0; j < 3 && i - j - 1 > 0; ++j)
        {
            tmp += a[i - j];
            dp[i].x = max(dp[i - j - 2].x + tmp, dp[i].x);
            dp[i].y = max(dp[i - j - 2].y + tmp, dp[i].y);
        }
    }
    tmp = 0;
    for (int j = 0; j < 3 && n - j - 2 > 0; ++j)
    {
        tmp += a[n - 1 - j];
        dp[n - 1].y = max(dp[n - j - 3].y + tmp, dp[n - 1].y);
    }
    int ans = 0;
    for (int i = 0; i < n; ++i)
        ans = max(ans, max(dp[i].x, dp[i].y));
    cout << ans << '\n';
    int q;
    cin >> q;
    for (int k = 0; k < q; ++k)
    {
        int p, v;
        cin >> p >> v;
        a[p - 1] = v;
        dp.assign(n, { 0, 0 });
        dp[0].x = a[0];
        dp[1].x = a[0] + a[1];
        dp[2].x = a[0] + a[1] + a[2];
        dp[1].y = a[1];
        dp[2].y = a[1] + a[2];
        dp[3].y = a[1] + a[2] + a[3];
        tmp = 0;
        for (int i = 3; i < n - 1; ++i)
        {
            tmp = 0;
            for (int j = 0; j < 3 && i - j - 1 > 0; ++j)
            {
                tmp += a[i - j];
                dp[i].x = max(dp[i - j - 2].x + tmp, dp[i].x);
                dp[i].y = max(dp[i - j - 2].y + tmp, dp[i].y);
            }
        }
        tmp = 0;
        for (int j = 0; j < 3 && n - j - 2 > 0; ++j)
        {
            tmp += a[n - 1 - j];
            dp[n - 1].y = max(dp[n - j - 3].y + tmp, dp[n - 1].y);
        }
        ans = 0;
        for (int i = 0; i < n; ++i)
            ans = max(ans, max(dp[i].x, dp[i].y));
        cout << ans << '\n';
    }
}