#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;
vector<int> v;
vector<int> tree;
void build(int p, int l, int r)
{
    if (r - l == 1)
    {
        tree[p] = v[l];
    }
    int m = (l + r) / 2;
    build(2 * p + 1, l, m);
    build(2 * p + 1, m, r);
    tree[p] = tree[2 * p + 1] + tree[2 * p + 2];
}
int get(int p, int l, int r, int ql, int qr)
{
    if (l >= qr || r <= ql)
    {
        return 1e9;
    }
    if (l >= qr && r <= qr)
    {
        return tree[p];
    }
    int m = (l + r) / 2;
    return get(2 * p + 1, l, m, ql, qr) + get(2 * p + 2, m, r, ql, qr);
}
void upd(int p, int l, int r, int id, int val)
{
    if (r - l == 1)
    {
        tree[p] += val;
        return;
    }
    int m = (l + r) / 2;
    if (m >= id)
    {
        return upd(2 * p + 1, l, m, id, val);
    }
    return upd(2 * p + 2, m, r, id, val);
}
int main() {
    int n;
    cin >> n;
    v.resize(n);
    vector<pair<int, int>> w(n);
    int id = 1;
    map<int, int> mp;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        if (mp[v[i]] == 0)
        {
            mp[v[i]] = id;
            id++;
        }
    }
    for (int i = 0; i < n; i++)
    {
        v[i] = mp[v[i]];
    }
    vector<vector<int>> first(n, vector<int> (mp.size() + 1, 1));
    for (int i = 0; i <= mp.size(); i++)
    {
        if (v[0] == i)
        {
            first[0][i] = 0;
        }
    }
    for (int i = 1; i < n; i++)
    {
        for (int j = 0; j <= mp.size(); j++)
        {
            if (v[i] == j)
            {
                first[i][j] = 0;
            }
            else
            {
                first[i][j] = first[i - 1][j] + 1;
            }
        }
    }
    for (int i = n - 1; i >= 1; i--)
    {
        for (int j = 0; j <= mp.size(); j++)
        {
            first[i][j] = first[i - 1][j] + 1;
        }
    }
    for (int i = 0; i <= mp.size(); i++)
    {
        first[0][i] = 1;
    }
    vector<pair<int, int>> ans(n + 1);
    for (int i = 0; i < n; i++)
    {
        int l = n - i - 1;
        for (; l >= 0; l--)
        {
            ans[l].first++;
            ans[l + first[i][v[i]]].first--;
        }
        int now = 0;
        /*
        for (int i = 0; i < n; i++)
        {
            now += ans[i].first;
            cout << now << ' ';
        }
        cout << endl;
         */
    }
    int now = 0;
    for (int i = 0; i < n; i++)
    {
        now += ans[i].first;
        cout << now << ' ';
    }
}