#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
using namespace std;
#define int long long
int sol(vector<int> v)
{
    int n = v.size();
    vector<vector<int>> dp(n, vector<int> (1<<3));
    for (int i = 0; i < (1<<3); i++)
    {
        int summ = 0;
        for (int j = 0; j < 3; j++)
        {
            if (i>>j&1)
            {
                summ += v[j];
            }
        }
        dp[2][i] = summ;
    }

    for (int i = 3; i < n; i++)
    {
        for (int j = 0; j < (1<<3); j++)
        {
            if (j != (1<<3) - 1)
            {
                dp[i][j>>1] = max(dp[i][j>>1], dp[i - 1][j]);
                dp[i][(j>>1)|(1<<2)] = max(dp[i][(j>>1)|(1<<2)], dp[i - 1][j] + v[i]);
            }
            else
            {
                dp[i][j>>1] = max(dp[i][j>>1], dp[i - 1][j]);
            }
        }

    }
    return *max_element(dp.back().begin(), dp.back().end());
}
signed main()
{
    int n;
    cin >> n;
    vector<int> v(n);
    int summ = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> v[i];
        summ += v[i];
    }
    if (n < 4)
    {
        cout << summ;
        return 0;
    }
    int ans = 0;
    for (int i = 0; i < 4; i++)
    {
        vector<int> w;
        for (int j = i + 1; j < n; j++)
        {
            w.push_back(v[j]);
        }
        for (int j = 0; j < i; j++)
        {
            w.push_back(v[j]);
        }
        ans = max(ans, sol(w));

    }
    cout << ans;
}