#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define all(x) x.begin(), x.end()

int n, m;
vector<pair<long double, long double> > s;
vector<pair<long long, long double> > v;
vector<long double> cars;

bool check (int k, int t) {
    long double a = 0;
    for (int i = 0; i < n; i++) {
        a += s[i].fi / (s[i].se + v[k].se);
    }
    return a <= cars[t] + 1e-6;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
//    cout << fixed << setprecision(15);
    cin >> n;
    s.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i].se;
    }
    for (int i = 0; i < n; i++) {
        cin >> s[i].fi;
    }
    sort(all(s));
    cin >> m;
    v.resize(m + 1);
    for (int i = 1; i < m; i++) {
        cin >> v[i].se;
    }
    for (int i = 1; i <= m; i++) {
        cin >> v[i].fi;
    }
    v[m].se = 1e18;
    sort(all(v));
    reverse(all(v));
    int q;
    cin >> q;
    cars.resize(q);
    for (int i = 0; i < q; i++) {
        long double a, b;
        cin >> a >> b;
        cars[i] = b - a;
        int l = 0, r = m + 1;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            if (check(mid, i))
                l = mid;
            else
                r = mid;
        }
        cout << v[l].fi << '\n';
    }

    return 0;
}
/*
 3
 10 20 30
 400 500 600
 6
 1 5 10 12 16
 100 300 600 800 1000 1500
 3
 10 100
 20 70
 45 100
 */