#include <iostream>
#include <algorithm>

using namespace std;

bool cmp(pair <int, int> a, pair <int, int> b) {
	return a.first * (b.second * b.second) > b.first * (a.second * a.second);
}

int main()
{
	int n;
	cin >> n;
	pair <int, int>* peaces = new pair <int, int>[n];
	for (int i = 0; i < n; i++) {
		cin >> peaces[i].second;
	}
	double first_time = 0;
	for (int i = 0; i < n; i++) {
		cin >> peaces[i].first;
		first_time += (double)peaces[i].first / peaces[i].second;
	}
	sort(peaces, peaces + n, cmp);
	int m;
	cin >> m;
	if (m != 1) {
		int* a = new int[m - 1];
		for (int i = 0; i < m - 1; i++) {
			cin >> a[i];
		}
		int* f = new int[m];
		for (int i = 0; i < m; i++) {
			cin >> f[i];
		}
		int q;
		cin >> q;
		for (int i = 0; i < q; i++) {
			int s, t;
			cin >> s >> t;
			int need = t - s;
			int left = -1;
			int right = f[m - 1] * n;
			while (right - left > 1) {
				int mid = (right + left) / 2;
				int now = mid;
				double time = 0;
				int j1 = upper_bound(f, f + m, now / n) - f;
				if (j1 == m || f[j1] > now / n) {
					j1--;
				}
				if (j1 != -1 && j1 != m - 1) {
					now -= f[j1] * n;
				}
				else if (j1 == m - 1) {
					now -= f[j1] * n;
				}
				for (int i = 0; i < n; i++) {
					int j = upper_bound(f, f + m, now + f[j1]) - f;
					if (j == m || f[j] > now) {
						j--;
					}
					if (j != -1 && j != m - 1) {
						time += (double)peaces[i].first / (peaces[i].second + a[j]);
						now -= f[j] - f[j1];
					}
					else if (j == -1) {
						time += (double)peaces[i].first / (peaces[i].second);
					}
					else {
						now -= f[j] - f[j1];
					}
				}
				if (time <= need) {
					right = mid - now;
				}
				else {
					left = mid;
				}
			}
			cout << right << endl;
		}
	}
	if (m == 1) {
		int a, f;
		cin >> a >> f;
		int q;
		cin >> q;
		int* mines_time = new int[n];
		for (int i = 0; i < n; i++) {
			mines_time[i] = (double)peaces[i].first / peaces[i].second - (double)peaces[i].first / (peaces[i].second + a);
		}
		sort(mines_time, mines_time + n);
		reverse(mines_time, mines_time + n);
		for (int i = 0; i < q; i++) {
			int s, t;
			cin >> s >> t;
			int need = t - s;
			int j = 0;
			int time = first_time;
			while (time > need && j < n) {
				time -= mines_time[j];
				j++;
			}
			cout << f * j << endl;
		}
	}
}
