#include <bits/stdc++.h>

#define int long long

using namespace std;
int a000 = 0, a001 = 1, a010 = 2, a011 = 3, a100 = 4, a101 = 5, a110 = 6, a111 = 7;
string s[8];

bool ch (int a, int b){
    if (b == 7 && a % 2 == 1)
        return false;
    if (a == 7 && b >= 4)
        return false;
    if (a % 4 == 3 && b / 2 == 3)
        return false;
    return true;
}

struct st{
    int a[8][8], maxf[2][8], maxs[2][8];
    st operator+(st b){
        st ans;
        for (int i = 0; i < 8; ++i) {
            for (int j = 0; j < 8; ++j) {
                ans.a[i][j] = max(maxf[0][i] + b.maxs[1][j], maxf[1][i] + b.maxs[0][j]);
                ans.a[i][j] = max(ans.a[i][j], a[i][a001] + b.a[a110][j]);
                ans.a[i][j] = max(ans.a[i][j], a[i][a101] + b.a[a110][j]);
                ans.a[i][j] = max(ans.a[i][j], a[i][a011] + b.a[a100][j]);
                ans.a[i][j] = max(ans.a[i][j], a[i][a011] + b.a[a101][j]);
                ans.a[i][j] = max(ans.a[i][j], a[i][a001] + b.a[a101][j]);
                ans.a[i][j] = max(ans.a[i][j], a[i][a101] + b.a[a101][j]);
                ans.a[i][j] = max(ans.a[i][j], a[i][a001] + b.a[a100][j]);
                ans.a[i][j] = max(ans.a[i][j], a[i][a101] + b.a[a100][j]);
            }
        }
        ans.rec();
        return ans;
    }
    void rec(){
        for (int k = 0; k < 8; ++k) {
            maxf[0][k] = a[k][0];
            maxs[0][k] = a[0][k];
        }
        for (int m = 0; m < 8; ++m) {
            for (int l = 1; l < 7; ++l) {
                if (l % 2 == 0)
                    maxf[0][m] = max(maxf[0][m], a[m][l]);
                if (l < 4)
                    maxs[0][m] = max(maxs[0][m], a[l][m]);
            }
        }
        for (int i = 0; i < 8; ++i) {
            maxf[1][i] = max(maxf[0][i], max(a[i][7], a[i][3]));
            maxf[1][i] = max(maxf[1][i], max(a[i][1], a[i][5]));
            maxs[1][i] = max(maxs[0][i], max(a[i][7], a[i][6]));
            maxs[1][i] = max(maxs[1][i], max(a[i][5], a[i][4]));
        }
    }
};

struct treap{
    vector <st> a;
    treap(int n){
        a.resize(4 * n);
    }
    void inc(int v, int vl, int vr, int pos, st val){
        if (pos < vl || vr <= pos)
            return;
        if (vl == vr - 1){
            a[v] = val;
            return;
        }
        int m = (vl + vr) / 2;
        inc(2 * v + 1, vl, m, pos, val);
        inc(2 * v + 2, m, vr, pos, val);
        a[v] = a[2 * v + 1] + a[2 * v + 2];
    }
};

st what(const vector <int> &a){
    st ans;
    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 8; ++j) {
            ans.a[i][j] = 0;
        }
    }
    if (a.size() == 3){
        for (int k = 0; k < 8; ++k) {
            if (k % 2 == 1)
                ans.a[k][k] += a[2];
            if ((k / 2) % 2 == 1)
                ans.a[k][k] += a[1];
            if (k >= 4)
                ans.a[k][k] += a[0];
        }
    }
    if (a.size() == 4){
        for (int i = 0; i < 2; ++i) {
            for (int j = 0; j < 2; ++j) {
                for (int k = 0; k < 2; ++k) {
                    for (int l = 0; l < 2; ++l) {
                        if (ch(i, j * 4 + k * 2 + l))
                            ans.a[i * 4 + j * 2 + k][j * 4 + k * 2 + l] = a[0] * i + a[1] * j + a[2] * k + a[3] * l;
                    }
                }
            }
        }
    }
    if (a.size() == 5){
        for (int i = 0; i < 2; ++i) {
            for (int j = 0; j < 2; ++j) {
                for (int k = 0; k < 2; ++k) {
                    for (int l = 0; l < 2; ++l) {
                        for (int m = 0; m < 2; ++m) {
                            if (ch(i * 2 + j, k * 4 + l * 2 + m))
                                ans.a[i * 4 + j * 2 + k][k * 4 + l * 2 + m] = a[0] * i + a[1] * j + a[2] * k + a[3] * l + a[4] * m;
                        }
                    }
                }
            }
        }
    }
    ans.rec();
    return ans;
}

signed main() {
    s[0] = "000";
    s[1] = "001";
    s[2] = "010";
    s[3] = "011";
    s[4] = "100";
    s[5] = "101";
    s[6] = "110";
    s[7] = "111";
    int n;
    cin >> n;
    treap t = treap(n / 3 + 1);
    vector <int> all;
    for (int i = 0; i < n / 3 - 1; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        all.push_back(a);
        all.push_back(b);
        all.push_back(c);
        vector <int> kkkk;
        kkkk.push_back(a);
        kkkk.push_back(b);
        kkkk.push_back(c);
        t.inc(0, 0, n / 3 + 1, i, what(kkkk));
    }
    vector <int> kkkk;
    for (int j = 0; j < 3 + n % 3; ++j) {
        int x;
        cin >> x;
        all.push_back(x);
        kkkk.push_back(x);
    }
    t.inc(0, 0, n / 3 + 1, n / 3 - 1, what(kkkk));
    int res = 0;
    for (int k = 0; k < 8; ++k) {
        for (int i = 0; i < 8; ++i) {
            if (ch(i, k)){
               // cout << k << " " << i << " " << res << endl;
                res = max(res, t.a[0].a[k][i]);
            }
        }
    }
    cout << res << "\n";
    int q;
    cin >> q;
    for (int l = 0; l < q; ++l) {
        int aa, bb;
        cin >> aa >> bb;
        aa--;
        all[aa] = bb;
        vector <int> kkk;
        if (aa >= n / 3 * 3 - 3){
            aa = n / 3 * 3 - 3;
            for (int i = n / 3 * 3 - 3; i < n; ++i) {
                kkk.push_back(all[i]);
            }
        }
        else{
            for (int i = aa / 3 * 3 ; i < aa / 3 * 3 + 3; ++i) {
                kkk.push_back(all[i]);
            }
        }
        t.inc(0, 0, n / 3 + 1, aa / 3, what(kkk));
        int res = 0;
        for (int k = 0; k < 8; ++k) {
            for (int i = 0; i < 8; ++i) {
                if (ch(i, k)){
                    // cout << k << " " << i << " " << res << endl;
                    res = max(res, t.a[0].a[k][i]);
                }
            }
        }
        cout << res << "\n";
    }
}


