#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <utility>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

using namespace std;

#define ll long long
#define pb push_back

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<ll> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	vector<ll> l(n);
	vector<double> s(n);
	double sec = 0;
	for (int i = 0; i < n; i++) {
		cin >> l[i];
		s[i] = (double)l[i] / v[i];
		sec += s[i];
	}
	int m;
	cin >> m;
	vector<ll> a(m - 1);
	for (int i = 0; i < m - 1; i++) {
		cin >> a[i];
	}
	vector<ll> f(m);
	for (int i = 0; i < m; i++) {
		cin >> f[i];
	}
	int q;
	cin >> q;
	ll st, t;
	for (int i = 0; i < q; i++) {
		cin >> st >> t;
		ll time = t - st;
		if (time >= sec) {
			cout << 0 << "\n";
		}
		else {
			int le = 0, ri = m - 1, mi;
			while (ri - le > 1) {
				mi = (le + ri) / 2;
				double ans = 0;
				for (int j = 0; j < n; j++) {
					ans += (double)l[j] / (v[j] + a[mi]);
				}
				if (ans >= time) {
					le = mi;
				}
				else {
					ri = mi;
				}
			}
			cout << f[ri] << "\n";
		}
	}
	return 0;
}