#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

using namespace std;

#define ll long long
#define pb push_back
vector<ll> a;
vector<pair<ll, int>> as;
vector<bool> used;

bool cmp(const pair<ll, int>& a, const pair<ll, int>& b) {
	return a.first > b.first;
}

ll col(int n) {
	as.assign(n, {});
	used.assign(n, false);
	for (int i = 0; i < n; i++) {
		as[i] = { a[i], i };
	}
	sort(as.begin(), as.end(), cmp);
	ll ans = 0;
	for (int i = 0; i < n; i++) {
		pair<ll, int> p = as[i];
		int j = p.second;
		if (j == 0) {
			if (!(used[1] && used[2] && used[3]) && !(used[1] && used[2] && used[n - 1]) && !(used[1] && used[n - 1] && used[n - 2]) && !(used[n - 1] && used[n - 2] && used[n - 3])) {
				used[j] = true;
				ans += a[j];
			}
		}
		else if (j == 1) {
			if (!(n >= 5 && used[4] && used[2] && used[3]) && !(used[3] && used[2] && used[0]) && !(used[2] && used[0] && used[n - 1]) && !(used[n - 1] && used[n - 2] && used[0])) {
				used[j] = true;
				ans += a[j];
			}
		}
		else if (j == 2) {
			if (!(n >= 6 && used[5] && used[4] && used[3]) && !(n >= 5 && used[4] && used[3] && used[1]) && !(used[1] && used[0] && used[3]) && !(used[n - 1] && used[0] && used[1])) {
				used[j] = true;
				ans += a[j];
			}
		}
		else if (j < n - 3) {
			if (!(used[j - 3] && used[j - 2] && used[j - 1]) && !(used[j - 2] && used[j - 1] && used[j + 1]) && !(used[j - 1] && used[j + 1] && used[j + 2]) && !(used[j + 1] && used[j + 2] && used[j + 3])) {
				used[j] = true;
				ans += a[j];
			}
		}
		else if (j == n - 3) {
			if (!(used[j - 3] && used[j - 2] && used[j - 1]) && !(used[j - 2] && used[j - 1] && used[j + 1]) && !(used[j - 1] && used[j + 1] && used[j + 2]) && !(used[j + 1] && used[j + 2] && used[0])) {
				used[j] = true;
				ans += a[j];
			}
		}
		else if (j == n - 2) {
			if (!(used[j - 3] && used[j - 2] && used[j - 1]) && !(used[j - 2] && used[j - 1] && used[j + 1]) && !(used[j - 1] && used[j + 1] && used[0]) && !(used[j + 1] && used[0] && used[1])) {
				used[j] = true;
				ans += a[j];
			}
		}
		else {
			if (!(used[j - 3] && used[j - 2] && used[j - 1]) && !(used[j - 2] && used[j - 1] && used[0]) && !(used[j - 1] && used[0] && used[1]) && !(used[0] && used[1] && used[2])) {
				used[j] = true;
				ans += a[j];
			}
		}
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	cout << col(n) << "\n";
	/*for (int i = 0; i < n; i++) {
		cout << used[i] << " ";
	}
	cout << "\n";*/
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int p, v;
		cin >> p >> v;
		p--;
		a[p] = v;
		cout << col(n) << "\n";
		/*for (int i = 0; i < n; i++) {
			cout << used[i] << " ";
		}
		cout << "\n";*/
	}
	return 0;
}