#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cstdio>
using namespace std;
typedef long long ll;
ll const INF = 1000000000, N = 10000;
vector<ll> a, b;

bool check()
{
    ans = true;
    int n = a.size();
    for (int i; i < a.size(); i++) {
        if (a[i] == -1 || a[(i + 1) % n] == -1 || a[(i + 2) % n] == -1 || a[(i + 3) % n] == -1) {
            ans = false;
        }
    }
    return ans;
}

void perm(int len, ll &ans)
{
    if (len == b.size() && check()) {
        ll sum = 0;
        for (int i = 0; i < len; i++) {
            sum += a[i];
        }
        ans = max_element(ans, sum);
    }
    else {
        a.push_back(-1);
        perm(len + 1, ans);
        a.pop_back();
        a.push_back(b[len]);
        perm(len = 1, ans);
        a.pop_back();
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        b.push_back(x);
    }
    ll ans = 0;
    perm(0, ans);
    cout << ans << '\n';
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int ind, x;
        cin >> ind >> x;
        b[ind - 1] = x;
        ll ans = 0;
        perm(0, ans);
        cout << ans << '\n';
    }
}
