#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cstdio>
using namespace std;
typedef long long ll;
ll const INF = 1000000000, N = 10000;
vector<ll> a;
vector<pair<int, int>> p;

ll check(ll x)
{
    ll ans = 0;
    while (x > 0) {
        int l = -1, r = a.size();
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (a[mid] > x) {
                r = mid;
            }
            else {
                l = mid;
            }
        }
        ll k = a[l];
        ll num = x / k;
        ans += num;
        x -= k * num;
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll n, x, ans = 0;
    cin >> n;

    for (int i = 0; i < n; i++) {
        ll x;
        cin >> x;
        a.push_back(x);
    }
    int cnt = 0, ind = -1;
    for (int i = 1; i < 2 * 100020; i++) {
        int x = check(i);
        if (cnt < x) {
            cnt = x;
            ind = i;
        }
        p.push_back(make_pair(cnt, ind));
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        ll x, answer = 0;
        cin >> x;
        cout << p[x - 1].second << " " << p[x - 1].first << endl;
    }
}
