#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cstdio>
using namespace std;
typedef long long ll;
ll const INF = 1000000000, N = 10000;
vector<ll> a, pp;
vector<pair<int, int>> p;

ll check(ll x)
{
    ll ans = 0;
    while (x > 0) {
        int l = -1, r = a.size();
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (a[mid] > x) {
                r = mid;
            }
            else {
                l = mid;
            }
        }
        ll k = a[l];
        ll num = x / k;
        ans += num;
        x -= k * num;
    }
    return ans;
}

bool f(int x) {
    bool flag = true;
    while (x > 0) {
        if (x % 2) {
            flag = false;
        }
        x /= 2;
    }
    return flag;
}

int main()
{
    bool flag = true;
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll n, x, ans = 0;
    cin >> n;

    for (int i = 0; i < n; i++) {
        ll x;
        cin >> x;
        if (!f(x)) {
            flag = false;
        }
        a.push_back(x);
    }
    if (!flag) {
        int cnt = 0, ind = -1;
        for (int i = 1; i < 2 * 100020; i++) {
            int x = check(i);
            if (cnt < x) {
                cnt = x;
                ind = i;
            }
            p.push_back(make_pair(cnt, ind));
        }
        int q;
        cin >> q;
        for (int i = 0; i < q; i++) {
            ll x, answer = 0;
            cin >> x;
            cout << p[x - 1].second << " " << p[x - 1].first << endl;
        }
    }
    else {
        pp.push_back(1);
        for (int i = 1; i < n; i++) {
            if (a[i] - 1 == a[i - 1]) {
                pp.push_back(pp[pp.size() - 1]);
            }
            else {
                pp.push_back(a[i] - 1);
            }
        }
        int q;
        cin >> q;
        for (int i = 0; i < q; i++) {
            ll x, answer = 0;
            cin >> x;
            if (x >= a[a.size() - 1] * 2) {
                ll num;
                if (x % a[a.size() - 1] != 0) {
                    num = x / a[a.size() - 1] - 1;
                }
                else {
                    num = x / a[a.size() - 1] - 1;
                }
                x = x - num * a[a.size() - 1];
                answer += num;
            }
            int l = -1, r = n;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                if (a[mid] > x) {
                    r = mid;
                }
                else {
                    l = mid;
                }
            }
            ll y = check(x), z = check(pp[l]);
            if (y > z) {
                cout << x + answer * a[a.size() - 1] << " " << y + answer << '\n';
            }
            else {
                cout << pp[l] + answer * a[a.size() - 1] << " " << z + answer << '\n';
            }

        }
    }
}
