#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define ft first
#define sd second

using namespace std;

int n;
ll v[200005];
pair<ll, ll> mx[200005];

pair<ll, ll> f(ll x) {
    //cout << x << "\n";
    if (x == 0) return {0, 0};
    int l = 0, r = n;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (v[m] <= x) {
            l = m;
        } else {
            r = m;
        }
    }
    if (l == 0) return {x, x};
    ll y = mx[l].sd + (x / v[l] - 1);
    pair<ll, ll> curr = f(x % v[l]);
    ll u = (x / v[l]) + curr.sd;
    if (y >= u) {
        return {(x / v[l] - 1) * v[l] + mx[l].ft, y};
    } else {
        return {(x / v[l]) * v[l] + curr.ft, u};
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    mx[0] = {1, 1};
    for (int i = 1; i < n; ++i) {
        //cout << "\n!!! " << v[i] << "\n";
        mx[i] = f(v[i] - 1);
    }
    /*for (int i = 0; i < n; ++i) {
        cout << mx[i].ft << " " << mx[i].sd << "    ";
    }
    cout << "\n";*/
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        ll a;
        cin >> a;
        pair<ll, ll> p = f(a);
        cout << p.ft << " " << p.sd << "\n";
    }
    return 0;
}

