#include<iostream>
#include<random>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<string>
#include<time.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

const int MAXN = 1e5;
const int INF = 1e9;

/*

int a[MAXN], tree[4 * MAXN], add[4 * MAXN];

void build(int ind, int l, int r) {
	add[ind] = 0;
	if (l - r == 1) {
		tree[ind] = a[l];
		return;
	}
	int m = (l + r) / 2;
	build(ind * 2 + 1, l, m);
	build(ind * 2 + 2, m, r);
	tree[ind] = max(tree[ind * 2 + 1], tree[ind * 2 + 1]);
}

void push(int ind, int l, int r) {
	tree[ind] += add[ind];
	if (l - r != 1) {
		add[ind * 2 + 1] += add[ind];
		add[ind * 2 + 2] += add[ind];
	}
	add[ind] = 0;
}

int query_max(int ind, int l, int r, int q_l, int q_r) {
	push(ind, l, r);
	if (q_l >= r || q_r <= l) {
		return -INF;
	}
	if (q_l <= l && r <= q_r) {
		return tree[ind];
	}
	int m = (l + r) / 2;
	return max(query_max(ind * 2 + 1, l, m, q_l, q_r), query_max(ind * 2 + 2, m, r, q_l, q_r));
}

int segm_plus(int ind, int l, int r, int q_l, int q_r, int delta) {
	push(ind, l, r);
	if (q_l >= r || q_r <= l) {
		return;
	}
	if (q_l <= l && r <= q_r) {
		add[ind] += delta;
		push(ind, l, r);
		return;
	}
	int m = (l + r) / 2;
	segm_plus(ind * 2 + 1, l, m, q_l, q_r, delta);
	segm_plus(ind * 2 + 2, m, r, q_l, q_r, delta);
	tree[ind] = max(tree[ind * 2 + 1], tree[ind * 2 + 1]);
}

*/

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n; cin >> n;

	vector<int> triag(n + 1), rect(n + 2);

	vector<int> a(n), prev(n);
	map<int, int> mp;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		prev[i] = mp[a[i]];
		mp[a[i]] = i + 1;
		triag[n - i + prev[i]]++;
		rect[n - i]++;
		rect[n - prev[i] + 1]--;
		//cout << i << " " << prev[i] << endl;
	}
	for (int i = 1; i < n + 1; ++i) {
		triag[i] += triag[i - 1];
		//cout << i << " " << triag[i] << endl;
	}
	for (int i = 1; i < n + 2; ++i) {
		rect[i] += rect[i - 1];
		//cout << i << " " << rect[i] << endl;
	}
	

	vector<int> s(n + 1, 0);
	s[1] = n;
	for (int len = 2; len <= n; ++len) {
		s[len] = s[len - 1] - rect[len - 1] + triag[n + 1 - len];
	}

	for (int i = 1; i <= n; ++i) {
		cout << s[i] << " ";
	}

	//system("pause");
	return 0;
}