#include<iostream>
#include<random>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<string>
#include<time.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

const int MAXN = 1e5;
const int INF = 1e9;

/*

int a[MAXN], tree[4 * MAXN], add[4 * MAXN];

void build(int ind, int l, int r) {
	add[ind] = 0;
	if (l - r == 1) {
		tree[ind] = a[l];
		return;
	}
	int m = (l + r) / 2;
	build(ind * 2 + 1, l, m);
	build(ind * 2 + 2, m, r);
	tree[ind] = max(tree[ind * 2 + 1], tree[ind * 2 + 1]);
}

void push(int ind, int l, int r) {
	tree[ind] += add[ind];
	if (l - r != 1) {
		add[ind * 2 + 1] += add[ind];
		add[ind * 2 + 2] += add[ind];
	}
	add[ind] = 0;
}

int query_max(int ind, int l, int r, int q_l, int q_r) {
	push(ind, l, r);
	if (q_l >= r || q_r <= l) {
		return -INF;
	}
	if (q_l <= l && r <= q_r) {
		return tree[ind];
	}
	int m = (l + r) / 2;
	return max(query_max(ind * 2 + 1, l, m, q_l, q_r), query_max(ind * 2 + 2, m, r, q_l, q_r));
}

int segm_plus(int ind, int l, int r, int q_l, int q_r, int delta) {
	push(ind, l, r);
	if (q_l >= r || q_r <= l) {
		return;
	}
	if (q_l <= l && r <= q_r) {
		add[ind] += delta;
		push(ind, l, r);
		return;
	}
	int m = (l + r) / 2;
	segm_plus(ind * 2 + 1, l, m, q_l, q_r, delta);
	segm_plus(ind * 2 + 2, m, r, q_l, q_r, delta);
	tree[ind] = max(tree[ind * 2 + 1], tree[ind * 2 + 1]);
}

*/

struct oper {
	int a, b, op;
};


int n, m, s;

vector<vector<int>> real_g;
vector<vector<oper>> orders;

vector<vector<int>> val;

int check(int m0, int m1) {
	int res = 0;
	for (int i = 0; i < m; ++i) {
		res += (((real_g[i][0] < m0) + (real_g[i][1] < m1) + orders[i][0].op) >= 3);
	}
	return res;
}

int check5(vector<int> msk) {
	vector<vector<int>> val(m, vector<int>(2 * n - 1));
	int cnt = 0;
	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < n; ++j) {
			val[i][j] = (real_g[i][j] < msk[j]);
		}
		for (int j = n; j < (2 * n - 1); ++j) {
			val[i][j] = ((orders[i][j - n].op + val[i][orders[i][j - n].a] + val[i][orders[i][j - n].b]) >= 3);
		}
		cnt += val[i][2 * n -  2];
	}
	return cnt;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	

	cin >> n >> m >> s;
	orders.resize(m, vector<oper>(n - 1));
	real_g.resize(m, vector<int>(n));
	
	bool test5 = true;
	bool test4 = true;

	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < n - 1; ++j) {
			cin >> orders[i][j].a >> orders[i][j].b >> orders[i][j].op;
			if (orders[i][j].op == 2) {
				test5 = false;
			}
			orders[i][j].a--;
			orders[i][j].b--;
		}
	}

	for (int i = 0; i < m; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> real_g[i][j];
			if (real_g[i][j] != i) {
				test4 = false;
			}
		}
	}

	if (n == 1) {
		cout << s << endl;
		return 0;
	}
	if (n == 2 && m <= 1000) {
		int l0 = 0, r0 = m + 1;
		int l1, r1;
		while (r0 - l0 != 1) {
			int m0 = l0;
			l1 = 0; r1 = m + 1;
			while ((r1 - l1) != 1) {
				int m1 = (l1 + r1) / 2;
				int cnt = check(m0, m1);
				if (cnt == s) {
					cout << m0 << " " << m1 << endl;
					return 0;
				}
				if (cnt < s) {
					l1 = m1;
				}
				else {
					r1 = m1;
				}
			}
			l0++;
		}
		//cout << l0 << " " << r0;
		return 0;
	}
	if (test4 || m == 1) {
		for (int i = 0; i < n; ++i) {
			cout << s << " ";
		}
		cout << endl;
		return 0;
	}
	if (test5) {
		for (int i = 0; i < n-1; ++i) {
			cout << m << " ";
		}
		cout << s << endl;
		return 0;
	}
	if (n <= 10 && m == 2) {
		int deg3 = 1;
		for (int i = 0; i < n; ++i) {
			deg3 *= 3;
		}
		for (int mask = 0; mask < deg3; ++mask) {
			vector<int> msk;
			int loc = mask;
			while (loc != 0) {
				msk.pb(loc % 3);
				loc /= 3;
			}
			while (sz(msk) < n) {
				msk.pb(0);
			}
			if (check5(msk) == s) {
				for (auto el : msk) {
					cout << el << " ";
				}
				return 0;
			}
		}
	}
	if (n == 2 && m <= 100000) {
		int l0 = 0, r0 = m + 1;
		int l1, r1;
		for (int i = 0; i < 100000; ++i) {
			int m0 = rand() % (m + 1);
			l1 = 0; r1 = m + 1;
			while ((r1 - l1) != 1) {
				int m1 = (l1 + r1) / 2;
				int cnt = check(m0, m1);
				if (cnt == s) {
					cout << m0 << " " << m1 << endl;
					return 0;
				}
				if (cnt < s) {
					l1 = m1;
				}
				else {
					r1 = m1;
				}
			}
			l0++;
		}
		//cout << l0 << " " << r0;
		return 0;
	}
	if (n <= 100) {
		for (int i = 0; i < 100000; ++i) {
			vector<int> msk(n);
			for (int j = 0; j < n; ++j) {
				msk[j] = ((rand() * 10 * (rand() % 2)) + rand()) % (m + 1);
			}
			if (check5(msk) == s) {
				for (auto el : msk) {
					cout << el << " ";
				}
				return 0;
			}
		}
		//cout << l0 << " " << r0;
		return 0;
	}

	//vector<int> z(n);

	

	system("pause");
	return 0;
}