#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#define cerr if (false) cerr
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

template <typename It>
void output(It b, It e, ostream &out) {
    while (b != e) {
        out << (*b) << ' ';
        ++b;
    }
    out << endl;
}

struct Fenw {
    int n;
    vector<int> t;

    Fenw(int n) : n(n), t(n) {}

    void upd(int i, int val) {
        for (; i < n; i = (i | (i + 1))) {
            t[i] += val;
        }
    }

    int get(int i) {
        int res = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            res += t[i];
        }
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input();
    vector<int> arr(n);
    map<int, int> coord;
    for (int &i : arr) {
        i = input();
        coord[i] = 0;
    }
    int iter = 0;
    for (auto &[key, val] : coord) {
        val = iter++;
    }
    for (int &i : arr) {
        i = coord[i];
    }

    vector<int> cnt(n);
    vector<ll> ans(n);
    vector<int> pr(n), used(n, -1);
    for (int i = 0; i < n; ++i) {
        pr[i] = used[arr[i]];
        used[arr[i]] = i;
    }
//    output(all(pr), cerr);
    for (int i = 0; i < n; ++i) {
        if (pr[i] != -1) {
            --cnt[pr[i]];
        }
        ++cnt[i];
//        output(all(cnt), cerr);
        int cur_sum = 0;
        for (int j = i; j >= 0; --j) {
            cur_sum += cnt[j];
            ans[i - j] += cur_sum;
        }
    }
    output(all(ans), cout);
}
