#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#define cerr if (false) cerr
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

template <typename It>
void output(It b, It e, ostream &out) {
    while (b != e) {
        out << (*b) << ' ';
        ++b;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input();
    int x = input();

    ll ans = 0;
    unordered_map<int, int> mem;
    for (int a = 1; a <= n; ++a) {
        for (int b = 1; a + b - 1 <= n; ++b) {
            if (a == x || b == x || a * b <= n) {
                continue;
            }
            int cd = a * b - n;
            if (mem.find(cd) != mem.end()) {
                ans += mem[cd];
                continue;
            }
            int cur = 0;
            for (int i = 1; i * i <= cd; ++i) {
                if (cd % i == 0) {
                    if (i < a && cd / i < b) {
                        ++cur;
                    }
                    if (i * i != cd && cd / i < a && i < b) {
                        ++cur;
                    }
                }
            }
            ans += cur;
            mem[cd] = cur;
        }
    }
    cout << ans << endl;
}
