#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
#define endl '\n'
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#define cerr if (false) cerr
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

template <typename It>
void output(It b, It e, ostream &out) {
    while (b != e) {
        out << (*b) << ' ';
        ++b;
    }
}

constexpr int N = 40404;
int arr[N];
int dp[N][4][4];
int n;

int calc() {
    int ans = 0;
    for (int t = 0; t < 4; ++t) {
        dp[1][t][1] = arr[(t + 1) % n];
        dp[1][t][2] = arr[(t + 1) % n];
        dp[1][t][3] = arr[(t + 1) % n];
        for (int i = 2; i < n; ++i) {
            int ii = (i + t) % n;
            dp[i][t][0] = max(max(dp[i - 1][t][0],
                                  dp[i - 1][t][1]),
                              max(dp[i - 1][t][2],
                                  dp[i - 1][t][3]));
            dp[i][t][1] = dp[i - 1][t][0] + arr[ii];
            dp[i][t][2] = dp[i - 1][t][1] + arr[ii];
            dp[i][t][3] = dp[i - 1][t][2] + arr[ii];
        }
        for (int pr = 0; pr < 4; ++pr) {
            ans = max(ans, dp[n - 1][t][pr]);
        }
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    n = input();
    for (int i = 0; i < n; ++i) {
        arr[i] = input();
    }

    cout << calc() << endl;
    int q = input();
    while (q--) {
        int p = input() - 1;
        int v = input();
        arr[p] = v;
        cout << calc() << endl;
    }
}
