#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
//#define endl '\n'
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#define cerr if (false) cerr
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

template <typename It>
void output(It b, It e, ostream &out) {
    while (b != e) {
        out << (*b) << ' ';
        ++b;
    }
    out << endl;
}

void rel(int &i, int j) {
    if (i < j) {
        i = j;
    }
}

constexpr int N = 40404;
constexpr int SQ = 205;
int arr[N];
int dp[N][2][4];
int out[N][2];

struct Block {
    int n;
    vector<int> ans;

    Block(vector<int> &cur) : n(sz(cur)), ans(4) {
        assert(n <= SQ);
        dp[0][0][1] = arr[0];
        dp[0][0][2] = arr[0];
        dp[0][0][3] = arr[0];
        for (int t = 0; t < 2; ++t) {
            for (int i = 1; i < n; ++i) {
                dp[i][t][0] = max(max(dp[i - 1][t][0],
                                      dp[i - 1][t][1]),
                                  max(dp[i - 1][t][2],
                                      dp[i - 1][t][3]));
                dp[i][t][1] = dp[i - 1][t][0] + arr[i];
                dp[i][t][2] = dp[i - 1][t][1] + arr[i];
                dp[i][t][3] = dp[i - 1][t][2] + arr[i];
            }
        }
        for (int pr = 0; pr < 4; ++pr) {
            rel(ans[0], dp[n - 1][0][pr]);
            rel(ans[1], dp[n - 1][1][pr]);
            rel(ans[2], dp[n - 2][0][pr]);
            rel(ans[3], dp[n - 2][1][pr]);
        }
    }
};

int n;
vector<Block> blocks[4];
vector<vector<int>> who[4];
vector<int> cur;

int calc() {
    int ans = 0;
    for (int t = 0; t < 4; ++t) {
        int cnt = sz(blocks[t]);
        out[0][0] = max(blocks[t][0].ans[0], blocks[t][0].ans[1]);
        out[0][1] = max(blocks[t][0].ans[2], blocks[t][0].ans[3]);

        for (int i = 1; i < cnt; ++i) {
            out[i][0] = max(out[i - 1][0] + blocks[t][i].ans[1],
                            out[i - 1][1] + blocks[t][i].ans[0]);
            out[i][1] = max(out[i - 1][0] + blocks[t][i].ans[3],
                            out[i - 1][1] + blocks[t][i].ans[2]);
        }
        ans = max(ans, out[cnt - 1][1]);

        out[0][0] = blocks[t][0].ans[1];
        out[0][1] = blocks[t][0].ans[3];

        for (int i = 1; i < cnt; ++i) {
            out[i][0] = max(out[i - 1][0] + blocks[t][i].ans[1],
                            out[i - 1][1] + blocks[t][i].ans[0]);
            out[i][1] = max(out[i - 1][0] + blocks[t][i].ans[3],
                            out[i - 1][1] + blocks[t][i].ans[2]);
        }
        ans = max(ans, out[cnt - 1][0]);
        ans = max(ans, out[cnt - 1][1]);
    }
    return ans;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    n = input();
    for (int i = 0; i < n; ++i) {
        arr[i] = input();
    }
    for (int t = 0; t < 4; ++t) {
        for (int j = 0; j < n; ++j) {
            int i = (j + t) % n;
            cur.emplace_back(arr[i]);
            if (sz(cur) == SQ) {
                blocks[t].emplace_back(cur);
                who[t].emplace_back(cur);
                cur.clear();
            }
        }
        if (sz(cur)) {
            blocks[t].emplace_back(cur);
            who[t].emplace_back(cur);
            cur.clear();
        }
    }

    cout << calc() << endl;
    int q = input();
    while (q--) {
        int p = input() - 1;
        int v = input();
        arr[p] = v;
        for (int t = 0; t < 4; ++t) {
            int np = (p + t) % n;
            int ind = np / SQ;
            who[t][ind][np % SQ] = v;
            blocks[t][ind] = Block(who[t][ind]);
        }
        cout << calc() << endl;
    }
}
