#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <queue>
#include <deque>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 2e5 + 228;
int n;
ll a[mx], pref[mx], suf[mx];

signed main() {
	fast_io();
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 1; i <= n; ++i) {
		pref[i] = pref[i - 1] + a[i - 1];
	}
	for (int i = 1; i <= n; ++i) {
		suf[i] = suf[i - 1] + a[n - i];
	}
	ll best = -1;
	int ans = 0;
	for (int i = 1; i < n; ++i) {
		if (chkmax(best, pref[i] * suf[n - i])) {
			ans = i;
		}
	}
	cout << ans << endl;
}
