#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <iomanip>
#include <string>
#include <algorithm>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <queue>
#include <deque>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream& out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 2e5 + 228;
int n, q;
ll a[mx];
pair<ll, ll> cnt[mx];

pair<ll, ll> request(ll x) {
	if (x == 0) {
		return {0, 0};
	}
	int pos = upper_bound(a, a + n, x) - a - 1;
	ll g = x / a[pos] - 1;
	pair<ll, ll> res = {g + cnt[pos].first, g * a[pos] + cnt[pos].second};
	pair<ll, ll> new_res = request(x - (g + 1) * a[pos]);
	new_res.first += g + 1;
	new_res.second += (g + 1) * a[pos];
	chkmax(res, new_res);
	return res;
}

signed main() {
	fast_io();
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 1; i < n; ++i) {
		cnt[i] = request(a[i] - 1);
	}
	cin >> q;
	for (int i = 0; i < q; ++i) {
		ll b;
		cin >> b;
		pair<ll, ll> ans = request(b);
		cout << ans.second << " " << ans.first << "\n";
	}
}
