#include <bits/stdc++.h>

#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const ld pi = 3.1415926;
const char el = '\n';
const int inf = 1000'000'000, mod = 1000'000'007;
const ll llinf = 1e18;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << el
#define left left228
#define right right228
#define prev prev228

template<typename T> bool uin(T &a, const T &b) { if (b < a) { a = b; return 1; } return 0; }
template<typename T> bool uax(T &a, const T &b) { if (b > a) { a = b; return 1; } return 0; }
template<class iterator> void output(iterator begin, iterator end, char p = ' ', ostream & out = cout) { while(begin != end) { out << (*begin) << p; begin++; } out << el; }
template<class T> void output(T x, char p = ' ', ostream & out = cout) { output(all(x), p, out); }

mt19937 rnd(time(nullptr));

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> v(n), line(n);
    forn(i, n) cin >> v[i];
    forn(i, n) cin >> line[i];
    int m;
    cin >> m;
    vector<ld> a(m - 1);
    forn(i, m - 1) cin >> a[i];
    vector<int> f(m);
    forn(i, m) cin >> f[i];
    int q;
    cin >> q;
    forn(i, q) {
        int s, t;
        cin >> s >> t;
        t -= s;
        ld l = 0.0, r = 1000000001.0;
        ld tm;
        while(r - l > 1e-6) {
            ld mid = (l + r) / 2.0;
            tm = 0;
            forn(k, n) tm += (ld)line[k] / ((ld)v[k] + mid);
            if (tm <= (ld)t) r = mid;
            else l = mid;
        }
        if (l == 0) {
            cout << 0 << el;
            continue;
        }
        int j = lower_bound(all(a), l) - a.begin();
        cout << f[j] << el;
    }
    return 0;
}
