#include <bits/stdc++.h>

#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const ld pi = 3.1415926;
const char el = '\n';
const int inf = 1000'000'000, mod = 1000'000'007;
const ll llinf = 1e18;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << el
#define left left228
#define right right228
#define prev prev228

template<typename T> bool uin(T &a, const T &b) { if (b < a) { a = b; return 1; } return 0; }
template<typename T> bool uax(T &a, const T &b) { if (b > a) { a = b; return 1; } return 0; }
template<class iterator> void output(iterator begin, iterator end, char p = ' ', ostream & out = cout) { while(begin != end) { out << (*begin) << p; begin++; } out << el; }
template<class T> void output(T x, char p = ' ', ostream & out = cout) { output(all(x), p, out); }

mt19937 rnd(time(nullptr));

struct Tree {
    vector<vector<int>> g;
    vector<int> op, p;
    vector<char> ok;
    Tree() {}
    Tree(int n) {
        ok.assign(n + n - 1, 0);
        g.resize(n + n - 1);
        p.resize(n + n - 1);
        op.resize(n + n - 1);
        forn(i, n - 1) {
            int a, b;
            cin >> a >> b >> op[n + i];
            a--; b--;
            g[i + n].push_back(a); g[i + n].push_back(b);
            p[a] = p[b] = i + n;
            op[n + i] = 3 - op[n + i];
        }
        p[n + n - 2] = n + n - 2;
    }
    bool change(int v) {
        ok[v] = 1;
        if (p[v] == v)
            return 1;
        if (ok[p[v]]) return 0;
        op[p[v]]--;
        if (!op[p[v]]) return change(p[v]);
        return 0;
    }
};
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, s;
    cin >> n >> m >> s;
    vector<Tree> a(m);
    forn(i, m) {
        a[i] = Tree(n);
    }
    vector<vector<int>> b(m, vector<int>(n));
    forn(i, m) forn(j, n) cin >> b[i][j];
    vector<int> z(n);
    vector<pair<int, int>> c;
    c.reserve(m);
    for (int j = 0; j < n && s > 0; ++j) {
        c.clear();
        forn(i, m) c.emplace_back(b[i][j], i);
        sort(all(c));
        forn(i, m) {
            int v = c[i].y;
            if (a[v].change(j)) s--;
            z[j]++;
            if (!s) break;
        }
    }
    output(z);
    return 0;
}
