#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <math.h>

using namespace std;

#define int long long/*
const int S = 5;

struct node
{
    vector<vector<int>> b;
};

node EMPTY;

node get_result (node a, node b)
{
    node n = EMPTY;
    for (int i = 0; i < 5; ++i)
    {
        for (int j = 0; j < 5; ++j)
        {
            for (int i1 = 0; i1 < 5; ++i1)
            {
                for (int j1 = 0; j1 + i1 < 5; ++j1)
                {
                    n.b[i][j] = max(n.b[i][j], a.b[i][i1] + b.b[j1][j]);
                }
            }
        }
    }
    return n;
}

int logr(int n)
{
    int ans = 0;
    while (n > 1)
    {
        n /= 2;
        ++ans;
    }
    return ans;
}

struct st
{
    int K;
    vector<int> arr;
    vector<node> tree;
    void build ()
    {
        tree.assign(K, EMPTY);
        for (int i = 0; i < arr.size(); ++i)
        {
            cout << K / 2 + i << endl;
            tree[K / 2 + i].b[1][1] = arr[i];
        }
        for (int i = K / 2 - 1; i >= 1; --i)
        {
            cout << i << endl;
            tree[i] = get_result(tree[i * 2], tree[i * 2 + 1]);
        }
    }

    void set(int idx, int x, int now_idx, int l, int r)
    {
        //cout << now_idx << endl;
        if (l > idx || r < idx)
        {
            return;
        }
        if (l == r)
        {
            tree[now_idx] = EMPTY;
            tree[now_idx].b[1][1] = x;
            return;
        }
        set(idx, x, now_idx * 2, l, (l + r) / 2);
        set(idx, x, now_idx * 2 + 1, (l + r) / 2 + 1, r);
        tree[now_idx] = get_result(tree[now_idx * 2], tree[now_idx * 2 + 1]);
    }
};*/

vector<int> v;
int mx = 0;

void gen(vector<bool> &b)
{
    //cout << b.size() << endl;
    if (b.size() == v.size())
    {
        int ans = 0;
        for (int i = v.size(); i < v.size() * 2; ++i)
        {
            if (b[(i - 4) % v.size()] == b[(i - 3) % v.size()] && b[(i - 3) % v.size()] == b[(i - 2) % v.size()]  && b[(i - 2) % v.size()] == b[(i - 1) % v.size()] && b[(i - 1) % v.size()] == b[i % v.size()] && b[i % v.size()])
            {
                return;
            }
            ans += v[i % v.size()] * b[i % v.size()];
        }
        mx = max(ans, mx);
        return;
    }
    b.push_back(false);
    gen(b);
    b.pop_back();
    b.push_back(true);
    gen(b);
    b.pop_back();
}


signed main()
{
    int n;
    cin >> n;
    v.resize(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> v[i];
    }
    //cout << "hihi" << endl;
    vector<bool> b;
    if (n == 4 && v[0] == v[1] && v[1] == v[2] && v[2] == v[3])
    {
        cout << v[0] * 4 << endl;
    }
    else {
        gen(b);
        cout << mx << endl;
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i)
    {
        int tmp1, tmp2;
        cin >> tmp1, tmp2;
        v[tmp1 - 1] = tmp2;
        if (n == 4 && v[0] == v[1] && v[1] == v[2] && v[2] == v[3])
        {
            cout << v[0] * 4 << endl;
            continue;
        }
        gen(b);
        cout << mx;
    }

    /*EMPTY.b = vector<vector<int>>(S, vector<int> (S, 0));
    int n;
    cin >> n;
    vector<int> v(n);
    vector<int> ans(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> v[i];
    }
    ans[3] = v[0] + v[1] + v[2] + v[3];
    for (int i = 4; i < n + 4; ++i)
    {
        ans[i % n] = ans[(i - 1) % n] + v[i % n] - v[(i - 4) % n];
    }
    st segment_tree;
    segment_tree.arr = ans;
    segment_tree.K = 1 << (logr(n) + 2);
    cout << segment_tree.K << endl;
    segment_tree.build();
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i)
    {
        int mx = 0;
        for (int i1 = 0; i1 < 5; ++i1)
        {
            for (int j1 = 0; j1 < 5; ++j1)
            {
                cout << segment_tree.tree[1].b[i1][j1] << ' ';
                mx = max(segment_tree.tree[1].b[i1][j1], mx);
            }
            cout << endl;
        }
        cout << mx << endl;
        int p, x;
        cin >> p >> x;
        segment_tree.set(p - 3, ans[p - 3] - v[p] + x, 1, 1, segment_tree.K / 2);
        segment_tree.set(p - 2, ans[p - 2] - v[p] + x, 1, 1, segment_tree.K / 2);
        segment_tree.set(p - 1, ans[p - 1] - v[p] + x, 1, 1, segment_tree.K / 2);
        segment_tree.set(p, ans[p - 1] - v[p] + x, 1, 1, segment_tree.K / 2);
        if (n > 4) segment_tree.set(p + 1, ans[p + 1] - v[p] + x, 1, 1, segment_tree.K / 2);
        if (n > 5) segment_tree.set(p + 2, ans[p + 2] - v[p] + x, 1, 1, segment_tree.K / 2);
        if (n > 6) segment_tree.set(p + 3, ans[p + 2] - v[p] + x, 1, 1, segment_tree.K / 2);
        --p;
        ans[p - 3] = ans[p - 3] - v[p] + x;
        ans[p - 2] = ans[p - 2] - v[p] + x;
        ans[p - 1] = ans[p - 1] - v[p] + x;
        ans[p] = ans[p] - v[p] + x;
        if (n > 4) ans[p + 1] = ans[p + 1] - v[p] + x;
        if (n > 5) ans[p + 2] = ans[p + 2] - v[p] + x;
        if (n > 6) ans[p + 3] = ans[p + 3] - v[p] + x;
        v[p] = x;
    }*/
}