#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

using ll = long long;
using pii = pair <int, int>;

const int oo = 1e9 + 4;
const int SZ = 2e5 + 4;

int n;
vector <int> a;
vector <ll> ans;

void read() {
    cin >> n;
    a.resize(n);
    for (auto &t : a) cin >> t;
}

void add(int l, int r) {
    int t = r - l + 1;
    for (int i = t; i <= n; i++) {
        ans[i - 1] -= min({i - t + 1, l + 1, n - r});
    }
}

map <int, int> last;

void solve() {
    ans.resize(n);
    for (int i = 0; i < n; i++)
        ans[i] = 1ll * (n - i) * (i + 1);
    for (int i = 0; i < n; i++) {
        if (last.count(a[i])) {
            add(last[a[i]], i);
        }
        last[a[i]] = i;
    }
    for (auto t : ans) cout << t << ' ';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();
}
