#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

using ll = long long;
using pii = pair <int, int>;

const int oo = 1e9 + 4;
const int SZ = 2e5 + 4;
bool str = 0, deb = 0;

int n;
vector <int> a;

void read() {
    cin >> n;
    a.resize(n);
    for (auto &t : a) cin >> t;
}

struct node {
    ll val;
    ll f, d;
    node() : val(0), f(0), d(0) {}
    node(ll x) : val(x), f(0), d(0) {}
};

struct stree {
    int K;
    vector <node> st;

    node mer(node a, node b) {
        return node(a.val + b.val);
    }

    stree() {}
    stree(vector <ll> a) {
        int n = a.size();
        K = 1; while (K < n) K *= 2;
        st.resize(2 * K, node());
        for (int i = 0; i < n; i++)
            st[i + K] = node(a[i]);
        for (int i = K - 1; i > 0; i--)
            st[i] = mer(st[2 * i], st[2 * i + 1]);
    }

    void push(int v, int l, int r) {
        int len = r - l + 1;
        ll mn = (st[v].f * 2 + st[v].d * (len - 1)) * len / 2;
        st[v].val -= mn;
        if (len > 1) {
            st[2 * v].f += st[v].f;
            st[2 * v + 1].f += st[v].f;
            st[2 * v].d += st[v].d;
            st[2 * v + 1].d += st[v].d;
        }
        st[v].f = st[v].d = 0;
    }

    void upd(ll f, ll d, int l, int r, int ll = 0, int rr = -1, int v = 1) {
        if (rr < 0) {
            rr = K - 1;
            if (deb) cout << "ahaha " << d << ' ' << f << ' ' ;
            f -= l * d;
            if (deb) cout << f << endl;
        }
        if (deb) cout << "ST: " << f << ' ' << d << ' ' << l << ' ' << r << ' ' << ll << ' ' << rr << endl;
        push(v, ll, rr);
        if (r < l || rr < l || r < ll) return;
        if (l <= ll && rr <= r) {
            st[v].f += f;
            st[v].d += d;
           if (deb)  cout << ll << ' ' << rr << ' ' << f << ' ' << d << endl;
            push(v, ll, rr);
            return;
        }
        int m = (ll + rr) / 2;
        upd(f, d, l, r, ll, m, 2 * v);
        upd(f + d * (m - ll + 1), d, l, r, m + 1, rr, 2 * v + 1);
        st[v] = mer(st[2 * v], st[2 * v + 1]);
    }

    ll get(int t, int ll = 0, int rr = -1, int v = 1) {
        if (rr < 0) rr = K - 1;
        push(v, ll, rr);
        if (ll == rr) return st[v].val;
        int m = (ll + rr) / 2;
        if (t <= m) return get(t, ll, m, 2 * v);
        else return get(t, m + 1, rr, 2 * v + 1);
    }

    void print() {
//
//        cout << "! : ";
//        for (auto t : st) cout << t.val << ' '; cout << endl;
//        cout << "!2 : ";

        for (int i = 0; i < n; i++)
            cout << get(i) << ' ';
        cout << endl;
    }
};

stree res;

void add(int l, int r) {
    int t = r - l + 1;
    int bl = l + 1, br = n - r;
    int ll, rr;

    if (deb) cout << l + 1 << ' ' << r  + 1 << ' ' << t << endl;

    // 1 : t <= len <= min(bl, br)
    ll = t, rr = t + min(br, bl) - 1;
    if (deb) cout << "! " << ll << ' ' << rr << ' ' << 1 << ' ' << 1 << endl;
    res.upd(1, 1, ll - 1, rr - 1);

    if (deb) res.print();

    // 2 : between min & max
    ll = rr + 1, rr = t + max(bl, br) - 1;

    if (deb) cout << "! " << ll << ' ' << rr << ' ' << min(bl, br) << ' ' << 0 << endl;

    res.upd(min(bl, br), 0, ll - 1, rr - 1);
if (deb)
    res.print();

    // 3 : len > max
    ll = rr + 1, rr = n;

    if (deb) cout << "! " << ll << ' ' << rr << ' ' << min(bl, br) << ' ' << -1 << endl;

    res.upd(min(bl, br), -1, ll - 1, rr - 1);

    if (deb) res.print();
}

vector <ll> solve() {
    vector <ll> ans;
    map <int, int> last;
    ans.resize(n);
    for (int i = 0; i < n; i++)
        ans[i] = 1ll * (n - i) * (i + 1);

    res = stree(ans);
    if (deb) res.print();

    for (int i = 0; i < n; i++) {
        if (last.count(a[i])) {
            add(last[a[i]], i);
        }
        last[a[i]] = i;
    }
    if (!str) {
        for (int i = 0; i < n; i++) {
            ans[i] = res.get(i);
            cout << ans[i] << ' ';
        }
    }
    return ans;
}

vector <ll> solve0() {
    vector <ll> ans(n, 0);
    for (int len = 1; len <= n; len++) {
        for (int i = 0; i <= n - len; i++) {
            set <int> r;
            for (int j = 0; j < len; j++)
                r.insert(a[i + j]);
            ans[len - 1] += r.size();
        }
    }
    if (str) return ans;
    for (auto t : ans) cout << t << ' ';
    return ans;
}

mt19937 rnd(19937);

void gen() {
    n = rnd() % 10 + 2;
    a.resize(n);
    for (int i = 0; i < n; i++)
        a[i] = rnd() % 1000;
}

void stress() {
    while (1) {
        gen();
        auto A = solve0();
        auto B = solve();
        if (A != B) {
            cout << "aAaAA" << endl;
            cout << n << endl;
            for (auto t : a) cout << t << ' '; cout << endl;
            cout << "OK: ";
            for (auto t : A) cout << t << ' '; cout << endl;
            cout << "NE: ";
            for (auto t : B) cout << t << ' '; cout << endl;
            break;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    if (str)
        stress();
    else {
        read();
        solve();
    }
}
