#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

using ll = long long;
using pii = pair <int, int>;

const int oo = 1e9 + 4;
const int SZ = 2e5 + 4;

struct cm {
    int a, b, op;
};

int n, m, s;
vector <vector <cm>> c;
vector <vector <int>> tab;
bool xi1 = 1, ands = 1;

void read() {
    cin >> n >> m >> s;
    c.resize(m);
    for (int i = 0; i < m; i++) {
        c[i].resize(n - 1);
        for (int p = 0; p < n - 1; p++) {
            cin >> c[i][p].a >> c[i][p].b >> c[i][p].op;
            c[i][p].a--;
            c[i][p].b--;
            ands &= (c[i][p].op == 1);
        }
    }
    tab.resize(m, vector <int> (n, 0));
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++) {
            cin >> tab[i][j];
            xi1 &= (tab[i][j] == i - 1);
        }
}

bool get(int id, const vector <int> &z) {
    vector <bool> val(2 * n - 1, 0);
    for (int i = 0; i < n; i++)
        val[i] = (tab[id][i] < z[i]);
    for (int p = 0; p < n - 1; p++) {
        int ap = c[id][p].a, bp = c[id][p].b;
        val[n + p] = (c[id][p].op == 1 ? (val[ap] & val[bp]) : (val[ap] | val[bp]));
    }
    return val[2 * n - 2];
}

int c0unt(const vector <int> &z) {
    int cnt = 0;
    for (int i = 0; i < m; i++)
        cnt += get(i, z);
    return cnt;
}

void go(int i = 0, vector <int> z = vector <int> (n, 0)) {
    if (i == n) {
        if (c0unt(z) == s) {
            for (auto t : z) cout << t << ' ';
            exit(0);
        }
        return;
    }
    for (int j = 0; j <= m; j++) {
        z[i] = j;
        go(i + 1, z);
    }
}

void solven10m3() {
    go();
}

void solven2m1000() {
    vector <int> z(n, 0);
    if (n == 1) {
        int l1 = -1, r1 = m + 1;
        bool ok = 0;
        while (r1 - l1 > 1 && !ok) {
            int m1 = (l1 + r1) / 2;
            z[0] = m1;
            int cz = c0unt(z);
            if (cz == s) {
                cout << z[0];
                exit(0);
            }
            if (cz <= s) l1 = m1; else r1 = m1;
        }
    } else {
        for (z[0] = m; z[0] >= 0; z[0]--) {
            int l1 = -1, r1 = m + 1;
            bool ok = 0;
            while (r1 - l1 > 1 && !ok) {
                int m1 = (l1 + r1) / 2;
                z[1] = m1;
                int cz = c0unt(z);
                if (cz == s) {
                    cout << z[0] << ' ' << z[1];
                    exit(0);
                }
                if (cz <= s) l1 = m1; else r1 = m1;
            }
        }
    }
}

void solveands() {
    cout << s << ' ';
    for (int i = 1; i < n; i++) cout << m << ' ';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    if (n <= 10 && m <= 2)
        solven10m3();
    else if (n <= 2 && m <= 1000)
        solven2m1000();
    else if (ands)
        solveands();
}
