#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

using ll = long long;
using pii = pair <int, int>;

const int oo = 1e9 + 4;
const int SZ = 2e5 + 4;

int n, q;
vector <ll> a;

void read() {
    cin >> n;
    a.resize(n);
    for (auto &t : a) cin >> t;
    cin >> q;
}

map <ll, ll> mem;

ll go (ll n) {
    if (mem.count(n)) return mem[n];
    if (!n) return 0;
    int k = upper_bound(a.begin(), a.end(), n) - a.begin() - 1;
    ll l = a[k];
    return mem[n] = n / l + go(n % l);
}

void solve() {
    while (q--) {
        ll b;
        cin >> b;
        ll mx = 0, i = 0;
        for (ll j = 0; j <= b; j++)
            if (go(j) > mx) {
                mx = go(j);
                i = j;
            }
        cout << i << ' ' << mx << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();
}
