#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#define int long long
#pragma GCC optimize("O3")
using namespace std;


inline void fastio()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}


signed main()
{
    fastio();
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    map<int, int> last_map;
    vector<int> prev(n);
    for (int i = 0; i < n; i++)
        prev[i] = i;
    for (int i = 0; i < n; i++)
    {
        int el = a[i];
        if (last_map.count(el) == 1)
        {
            prev[i] = last_map[el];
        }
        last_map[el] = i;
    }
    /*for (int i = 0; i < n; i++)
        cout << prev[i] << ' ' ;
    cout << endl;*/

    vector<int> last_v(n, 1);
    vector<int> this_v;
    cout << n << ' ';
    for (int i = 1; i < n; i++)
    {
        int sum = 0;
        this_v.resize(n-i);
        for (int j = 0; j < n-i; j++)
        {
            this_v[j] = last_v[j] + 1;
            if (prev[j+i] >= j && prev[j+i] < j+i) this_v[j]--;
            //cout << s[i][j] << ' ';
            sum += this_v[j];
        }
        cout << sum << ' ';
        last_v.swap(this_v);
    }

    return 0;
}
