#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#define int long long
#pragma GCC optimize("O3")
using namespace std;


inline void fastio()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}


signed main()
{
    fastio();
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    map<int, int> last_map;
    vector<int> prev(n);
    vector<int> prev_len(n, 0);
    for (int i = 0; i < n; i++)
        prev[i] = i;
    for (int i = 0; i < n; i++)
    {
        int el = a[i];
        if (last_map.count(el) == 1)
        {
            prev[i] = last_map[el];
            prev_len[i - prev[i]]++;
        }
        last_map[el] = i;
    }

    vector<int> prev_len_prefix(n);
    prev_len_prefix[0] = 0;
    for (int i = 1; i < n; i++)
    {
        prev_len_prefix[i] = prev_len_prefix[i-1] + prev_len[i];
        if (prev[i-1] != i-1)
            prev_len_prefix[i]--;
    }

    vector<set<int>> last_sets(n);
    last_sets[0] = {a[n-1]};
    for (int i = 1; i < n; i++)
    {
        last_sets[i] = last_sets[i-1];
        last_sets[i].insert(a[n-i-1]);
    }
    int last_sum = n;
    int last_bit = 1;

    /*for (int i = 0; i <n; i++)
        cout << prev_len_prefix[i] << ' ' ;
    cout << endl;*/
    cout << n << ' ';
    for (int i = 1; i < n; i++)
    {
        int sum = last_sum - last_bit + n-i;
        //cout << last_sum << ' ' << last_bit << ' ' << n-i << ' ';
        sum -= prev_len_prefix[i];
        cout << sum << ' ' ;

        last_sum = sum;
        last_bit = last_sets[i].size();
    }

    return 0;
}

/*
this_v.resize(n-i);
        int sum = last_sum - last_v[n-i-1] + n-i;
        for (int j = 0; j < n-i; j++)
        {
            if (prev[j+i] >= j && prev[j+i] < j+i)
            {
                this_v[j]--;
                sum--;
            }
        }
        cout << sum << ' ';
        last_v.swap(this_v);
        last_sum = sum;
*/
