/// YUR3K ///
#include <iostream>
#include <vector>
#pragma GCC optimize ("O3")
#define int long long
using namespace std;


inline void fastio()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

signed main()
{
    fastio();

    int n, x;
    cin >> n >> x;

    int ans = 0;
    int mirror = 0;
    for (int a = 2; a < n; a++)
    {
        if (a == x)
            continue;
        for (int b = 2; (a + b <= n+1) && (b <= a); b++)
        {
            if (b == x)
                continue;

            int poly = a * b - n;
            for (int c = 1; c <= poly; c++)
            {
                if (poly % c) continue;
                if (c < a && poly < c*b)
                {
                    ans++;
                    if (a == b)
                        mirror++;
                    //cout << a << ' ' << b << ' ' << c << ' ' << poly/c << endl;
                }
            }
        }
    }

    cout << 2 * ans - mirror;

    return 0;
}
