/// YUR3K ///
#include <iostream>
#include <vector>
#include <cmath>
#pragma GCC optimize ("O3")
#define int long long
using namespace std;


inline void fastio()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

signed main()
{
    fastio();

    int n, x;
    cin >> n >> x;

    int ans = 0;
    int mirror = 0;
    for (int a = 2; a < n; a++)
    {
        if (a == x)
            continue;
        for (int b = 2; (a + b <= n+1) && (b <= a); b++)
        {
            if (b == x)
                continue;

            int poly = a * b - n;
            int this_ans = 0;
            for (int c = 1; c <= sqrt(poly); c++)
            {
                if (poly % c) continue;

                if (c < a && poly < c*b)
                {
                    this_ans++;
                    if (c * c == poly)
                        this_ans--;
                }
                if (c < b && poly < c*a)
                    this_ans++;
                //cout << a << ' ' << b << ' ' << c << ' ' << poly/c << endl;
            }

            ans += this_ans;
            if (a == b) mirror += this_ans;
        }
    }

    cout << 2 * ans - mirror;

    return 0;
}
