/// YUR3K ///
#include <iostream>
#include <vector>
#include <map>
#define int long long
#pragma GCC optimize("O3")
using namespace std;
vector<int> a;
vector<int> b;
map<int, pair<int, int>> precalc;


pair<int, int> max_papers(int max_val) // { what_to_ask_for, what_we_get }
{
    if (max_val == 0)
        return {0, 0};

    int mpl = 0;
    int mpr = a.size();
    while(mpr - mpl > 1)
    {
        int mpm = (mpl + mpr) >> 1;
        if (a[mpm] <= max_val)
            mpl = mpm;
        else
            mpr = mpm;
    }

    if (mpl == 0)
        return {max_val, max_val};
    int mpv = a[mpl];


    if (precalc.count(max_val%mpv) == 0)
        precalc[max_val%mpv] = max_papers(max_val % mpv);
    if (precalc.count(mpv-1) == 0)
        precalc[mpv-1] = max_papers(mpv - 1);
    auto ans_big = precalc[max_val%mpv];
    auto ans_small = precalc[mpv-1];

    if (ans_big.second + max_val/mpv > ans_small.second + max_val/mpv-1)
        return { ans_big.first + max_val-max_val%mpv, ans_big.second + max_val/mpv };
    else
        return { ans_small.first + max_val-max_val%mpv-mpv, ans_small.second + max_val/mpv-1 };
}


inline void fastio()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}
signed main()
{
    fastio();

    int n;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    int q;
    cin >> q;
    b.resize(q);
    for (int i = 0; i < q; i++)
        cin >> b[i];

    for (int i = 0; i < q; i++)
    {
        auto ans = max_papers(b[i]);
        cout << ans.first << ' ' << ans.second << '\n';
    }

    return 0;
}
