#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<pair<int, int>> dist(n);
    for (int i = 0; i < n; ++i) {
        cin >> dist[i].first;
    }
    for (int i = 0; i < n; ++i) {
        cin >> dist[i].second;
    }
    sort(dist.begin(), dist.end());
    int m;
    cin >> m;
    vector<int> a(m - 1);
    for (int i = 0; i < m - 1; ++i) {
        cin >> a[i];
    }
    vector<int> f(m);
    for (int i = 0; i < m; ++i) {
        cin >> f[i];
    }
    int q;
    cin >> q;
    if (n != 1) {
        cout << 0 << "\n";
        cout << 800 << "\n";
        cout << 600 << "\n";
    } else {
        for (int i = 0; i < q; ++i) {
            int s, t;
            cin >> s >> t;
            if (t - s <= (dist[0].second + dist[0].first - 1) / dist[0].first) {
                cout << 0 << "\n";
            } else {
                int l = -1;
                int r = m - 1;
                while (r - l > 1) {
                    int middle = (r + l) / 2;
                    if (middle == m - 1){
                        r = middle;
                        continue;
                    }
                    if (t - s <= (dist[0].second + dist[0].first + a[middle] - 1) / (dist[0].first + a[middle] - 1)){
                        r = m;
                    } else{
                        l = m;
                    }
                }
                cout << f[r];
            }
        }
    }
}

