#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>

using namespace std;

#define int long long

int help(vector<int> a) {
    vector<vector<int>> dp(a.size(), vector<int>(4, 0));
    dp[0][0] = 0;
    dp[0][1] = a[0];
    for (int i = 1; i < a.size(); ++i) {
        dp[i][0] = *max_element(dp[i - 1].begin(), dp[i - 1].end());
        for (int j = 1; j <= 3; ++j) {
            dp[i][j] = a[i] + dp[i - 1][j - 1];
        }
    }
    return dp[dp.size() - 1][0];
}

signed main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    int ans = 0;
    for (int j = 0; j < 4; ++j) {
        vector<int> b(n);
        for (int i = j; i < n; ++i) {
            b[i - j] = a[i];
        }
        for (int i = n - j; i < n; ++i) {
            b[i] = a[i - (n - j)];
        }
        ans = max(ans, help(b));
    }
    cout << ans << "\n";
    for (int i1 = 0; i1 < q; ++i1) {
        int p, v;
        cin >> p >> v;
        a[p - 1] = v;
        ans = 0;
        for (int j = 0; j < 4; ++j) {
            vector<int> b(n);
            for (int i = j; i < n; ++i) {
                b[i - j] = a[i];
            }
            for (int i = n - j; i < n; ++i) {
                b[i] = a[i - (n - j)];
            }
            ans = max(ans, help(b));
        }
        cout << ans << "\n";
    }
}

