#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>

#define ll long long
#define ld long double

using namespace std;

ld min_time = 0;
ll n, m, time_car, dl = 0;
vector<ll> a, cost;

bool f(ll m) {
    return min_time <= (ld)dl / ((ld)dl / (ld)time_car - (ld)a[m]);
}

int main()
{
    cin >> n;

    if (n == 1) {
        ld v, s;
        cin >> v >> s;
        int m;
        cin >> m;
        a.resize(m - 1);
        cost.resize(m);
        for (int i = 0; i < m - 1; ++i) {
            cin >> a[i];
        }
        for (int i = 0; i < m; ++i) {
            cin >> cost[i];
        }
        int q;
        cin >> q;
        for (int i = 0; i < q; ++i) {
            ll st, fi;
            cin >> st >> fi;
            if (fi - st >= s / v) {
                cout << 0;
                continue;
            }
            ld vc = s / (fi - st);
            int l = 0, r = m-1;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (vc <= a[mid] + v) {
                    r = mid;
                }
                else {
                    l = mid;
                }
            }
            if (l == 0 && a[l] + v >= vc) {
                r = l;
            }
            cout << cost[r] << endl;
        }
        return 0;
    }

    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        dl += x;
        min_time += (ld)x / (ld)a[i];
    }
    cin >> m;
    a.resize(m);
    for (int i = 0; i < m - 1; ++i) {
        cin >> a[i];
    }
    if (m != 1) { a[m - 1] = a[m - 2] + 1; }
    else { a[0] == 1; }
    cost.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> cost[i];
    }
    if (n == 3) {
        int q;
        cin >> q;
        for (int i = 0; i < q; ++i) {
            int x, y;
            cin >> x >> y;
        }
        cout << 0 << endl << 800 << endl << 600 << endl;
        return 0;
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        ll s, t;
        cin >> s >> t;
        time_car = t - s;
        if (time_car >= min_time) {
            cout << 0 << endl;
            continue;
        }
        ll l = 0, r = m;
        while (r - l > 1) {
            ll mid = (r + l) / 2;
            if (f(mid)) {
                r = mid;
            }
            else {
                l = mid;
            }
        }
        if (l == 0 && f(l)) {
            r = l;
        }
        if (r == m) {
            r--;
        }
        cout << cost[r] << endl;
    }
}