#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

#define ll long long
#define ld long double

int main()
{
    iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    
    int n;
    cin >> n;
    vector<ll> a(n + 1);
    a[0] = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i + 1];
    }
    int q;
    cin >> q;
    vector<ll> b(q);
    ll mx = 0;
    for (int i = 0; i < q; ++i) {
        cin >> b[i];
        if (b[i] > mx) { mx = b[i]; }
    }
    vector<pair<ll, ll>> dp(mx + 1);
    for (int i = 0; i <= mx; ++i) {
        if (i == 0) { dp[i] = { 0,0 }; continue; }
        if (i == 1) { dp[i] = { 1,1 }; continue; }
        int l = 1, r = n + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (a[m] > i) {
                r = m;
            }
            else {
                l = m;
            }
        }
        dp[i] = { i, i / a[l] + dp[i % a[l]].second };
    }
    pair<ll, ll> mx_in = { 1,1 };
    for (int i = 2; i <= mx; ++i) {
        if (mx_in.second > dp[i].second) {
            dp[i] = mx_in;
        }
        else {
            mx_in = dp[i];
        }
    }
    for (int i = 0; i < b.size(); ++i) {
        cout << dp[b[i]].first << " " << dp[b[i]].second << endl;
    }
}