#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <utility>
#include <cstdlib>
#include <stack>
#include <queue>
#include <deque>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

int main()
{
    /*ios_base::sync_with_stdio(0) ;
    cin.tie(0);
    cout.tie(0);*/
    int n;
    cin >> n;
    vector<int> v(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    vector<int> l(n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    int m;
    cin >> m;
    vector<int> a(m + 1, 0);
    for (int i = 0; i < m - 1; ++i) {
        cin >> a[i + 1];
    }
    a[a.size() - 1] = 2000000000;
    vector<ld> times(m + 1, 0);
    vector<int> f(m + 1, 0);
    for (int i = 0; i < m + 1; ++i) {
        if (i == 0)
        {
            f[i] = 0;
        }
        else {
            cin >> f[i];
        }
        for (int j = 0; j < n; ++j) {
            times[i] += l[j] / (v[j] + a[i]);
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int s, t;
        cin >> s >> t;
        int time = t - s;
        int l = 0, r = m + 1;
        if (times[0] < time) {
            r = 0;
        }
        while (r - l > 1)
        {
            int mid = (l + r) / 2;
            if (times[mid] > time)
            {
                l = mid;
            }
            else
            {
                r = mid;
            }
        }
        cout << f[r] << endl;
    }
}