//
// Created by olymp on 18.01.2020.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

ll mx(vector<ll> a)
{
    if (a.size() != 0) {
        ll mx = a[0];
        for (int i = 0; i < a.size(); ++i) {
            mx = max(mx, a[i]);
        }
        return mx;
    }
    return 0;
}

int answer(vector<int> v)
{
    ll mxx = 0;
    int n = v.size();
    for (int step = 0; step < n; ++step) {
        vector<vector<ll>> dp(n, vector<ll>(4, 0));
        dp[(step + 0) % n][0] = 0;
        dp[(step + 0) % n][1] = v[(step + 0) % n];
        dp[(step + 1) % n][0] = mx(dp[(step + 0) % n]);
        dp[(step + 1) % n][1] = dp[(step + 0) % n][0] + v[(step + 1) % n];
        dp[(step + 1) % n][2] = v[(step + 0) % n] + v[(step + 1) % n];
        dp[(step + 2) % n][0] = mx(dp[(step + 1) % n]);
        dp[(step + 2) % n][1] = v[(step + 2) % n] + mx(dp[(step + 0) % n]);
        dp[(step + 2) % n][2] = v[(step + 2) % n] + v[(step + 1) % n] + dp[(step + 0) % n][0];
        dp[(step + 2) % n][3] = v[(step + 0) % n] + v[(step + 1) % n] + v[(step + 2) % n];
        dp[(step + 3) % n][0] = mx(dp[(step + 2) % n]);
        dp[(step + 3) % n][1] = v[(step + 3) % n] + mx(dp[(step + 1) % n]);
        dp[(step + 3) % n][2] = v[(step + 3) % n] + v[(step + 2) % n] + mx(dp[(step + 0) % n]);
        dp[(step + 3) % n][3] = v[(step + 3) % n] + v[(step + 2) % n] + v[(step + 1) % n];
        for (int i = 4; i < n - 1; ++i) {
            dp[(step + i) % n][0] = mx(dp[(step + i - 1) % n]);
            dp[(step + i) % n][1] = v[(step + i) % n] + mx(dp[(step + i - 2) % n]);
            dp[(step + i) % n][2] = v[(step + i) % n] + v[(step + i - 1) % n] + mx(dp[(step + i - 3) % n]);
            dp[(step + i) % n][3] = v[(step + i) % n] + v[(step + i - 1) % n] + v[(step + i - 2) % n] + mx(dp[(step + i - 4) % n]);
        }
        mxx = max(mxx, mx(dp[(step + n - 2) % n]));
    }
    return mxx;
}

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    for (int i = 0; i < q + 1; ++i) {
        if (i != 0)
        {
            int p, v;
            cin >> p >> v;
            --p;
            a[p] = v;
        }
        cout << answer(a) << endl;
    }

}