#include <algorithm>
#include <iostream>
#include <vector>

#define int long long
#define float long double

using namespace std;

bool check(int value, int n, int m, int q, int t, vector <int> &v, vector <int> &L, vector <int> &a)
{
    float sum = 0;
    for (int i = 0; i < n; ++i)
    {
        sum += ((float)L[i]) / ((float)(v[i]) + (float)(value));
    }
    return sum <= ((float)t);
}

int bs(int n, int m, int q, int t, vector <int> &v, vector <int> &LL, vector <int> &a)
{
    if (check(0, n, m, q, t, v, LL, a))
        return -1;
    int L = 0, R = m - 1, mid;
    while (L + 1 < R)
    {
        mid = L + (R - L) / 2;
        if (check(a[mid], n, m, q, t, v, LL, a))
        {
            R = mid;
        }
        else
        {
            L = mid;
        }
    }
    return R;
}

signed main()
{
    int n, m, q;
    cin >> n;
    vector <int> v(n), L(n);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    for (int i = 0; i < n; ++i)
        cin >> L[i];
    cin >> m;
    vector <int> a(m), f(m);
    for (int i = 0; i < m - 1; ++i)
        cin >> a[i];
    if (m == 1)
        cout << f[0];
    for (int i = 0; i < m; ++i)
        cin >> f[i];
    cin >> q;
    vector <int> ans(q);
    int s, t, e;
    for (int i = 0; i < q; ++i)
    {
        cin >> s >> t;
        t -= s;
        e = bs(n, m, q, t, v, L, a);
        if (e == -1)
            ans[i] = 0;
        else
            ans[i] = f[e];
    }
    for (int i = 0; i < q; ++i)
        cout << ans[i] << endl;
    return 0;
}
