#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <tuple>
#include <set>

#define int long long
#define float long double

using namespace std;

int f(vector <int> &a, int L, int R)
{
    vector <int> dp1(R - L);
    dp1[L + 0] = a[L + 0];
    dp1[L + 1] = a[L + 0] + a[L + 1];
    dp1[L + 2] = a[L + 0] + a[L + 1] + a[L + 2];
    dp1[L + 3] = max({a[L + 3] + dp1[L + 1], a[L + 3] + a[L + 2] + dp1[L + 0], a[L + 3] + a[L + 2] + a[L + 1]});
    for (int i = L + 4; i < R; ++i)
    {
        dp1[i] = max({a[i] + dp1[i - 2], a[i] + a[i - 1] + dp1[i - 3], a[i] + a[i - 1] + a[i - 2] + dp1[i - 4]});
    }
    return max(dp1[R - 1], dp1[R - 2]);
}

signed main()
{
    int n, q;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    cin >> q;
    vector <int> ans(q);
    for (int i = 0, p, v; i < q; ++i)
    {
        cin >> p >> v;
        a[p - 1] = v;
        ans[i] = max({n >= 5 ? f(a, 1, n) : 0, f(a, 0, n - 1), n >= 6 ? (f(a, 2, n - 1) + a[0]) : 0, f(a, 1, n - 2) + a[n - 1], n >= 7 ? (f(a, 3, n - 1) + a[0] + a[1]) : 0, n >= 5 ? (f(a, 1, n - 3) + a[n - 1] + a[n - 2]) : 0, n >= 8 ? (f(a, 4, n - 1) + a[0] + a[1] + a[2]) : 0, n >= 6 ? (f(a, 1, n - 4) + a[n - 1] + a[n - 2] + a[n - 3]) : 0});
    }
    for (int i = 0; i < q; ++i)
        cout << ans[i] << endl;
    return 0;
}
