#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <cstdlib>
#include <ctime>
#include <iomanip>
using namespace std;

#define int long long
typedef pair<int, int> pii;
#define pb push_back
#define debug(x) cout << #x << ": " << x << '\n';
//typedef long long ll;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int N = 1e5 + 10;
int a[N], f[N], v[N], l[N];
const double eps = 1e-7;

signed main() {
    fast();
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) cin >> v[i];
    for (int i = 0; i < n; i++) cin >> l[i];
    int m;
    cin >> m;
    for (int i = 1; i <= m - 1; i++) {
        cin >> a[i];
    }
    for (int i = 1; i <= m; i++) {
        cin >> f[i];
    }
    int q;
    cin >> q;
    while (q--) {
        int ll = 0, rr = m;
        int s, t;
        cin >> s >> t;
        t -= s;
        while (ll < rr) {
            int mm = (ll + rr) / 2;
            double tt = t;
            for (int j = 0; j < n; j++) {
                tt -= (l[j] * 1.0 / (v[j] + a[mm]));
            }
            if (tt > -eps) {
                rr = mm;
            } else {
                ll = mm + 1;
            }
        }
        cout << f[ll] << '\n';
    }
    return 0;
}