#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <cstdlib>
#include <ctime>
#include <iomanip>
#include <set>
#include <map>
using namespace std;

//#define int long long
typedef pair<int, int> pii;
#define pb push_back
#define debug(x) cout << #x << ": " << x << '\n';
//typedef long long ll;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

signed main() {
    fast();
    int n, m, s;
    cin >> n >> m >> s;
    vector<vector<int>> x(m, vector<int> (2 * n - 1));
    vector<vector<int>> a(m, vector<int> (n - 1));
    vector<vector<int>> b(m, vector<int> (n - 1));
    vector<vector<int>> op(m, vector<int> (n - 1));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];
            a[i][j]--; b[i][j]--;
        }
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            cin >> x[i][j];
        }
    }
    int ll = 0, rr = m * n;
    while (ll < rr) {
        int mm = (ll + rr) / 2;
        vector<int> yy(n);
        int tmp = mm;
        for (int i = 0; i < n; i++) {
            int cur = min(tmp, m);
            tmp -= cur;
            yy[i] = cur;
        }
        int cnt = 0;
        for (int i = 0; i < m; i++) {
            for (int j = n; j < 2 * n - 1; j++) {
                int p = x[i][a[i][j - n]];
                if (a[i][j - n] < n) p = (p < yy[a[i][j - n]]);
                int q = x[i][b[i][j - n]];
                if (b[i][j - n] < n) q = (q < yy[b[i][j - n]]);
                if (op[i][j - n] == 1) {
                    x[i][j] = (p & q);
                } else {
                    x[i][j] = (p | q);
                }
            }
            if (x[i][2 * n - 2] == 1) cnt++;
        }
        if (cnt < s) ll = mm + 1;
        else rr = mm;
    }
    for (int i = 0; i < n; i++) {
        int cur = min(m, ll);
        ll -= cur;
        cout << cur << ' ';
    }
    return 0;
}