#define _USE_MATH_DEFINES
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cmath>
#include <cstring>
#include <queue>
#include <deque>
#include <cstdlib>
#include <ctime>
#include <iomanip>
#include <set>
#include <map>
using namespace std;

#define int long long
#define double long double
typedef pair<int, int> pii;
#define pb push_back
#define debug(x) cout << #x << ": " << x << '\n';
//typedef long long ll;
#define fi first
#define se second
#define mp make_pair

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int N = 4e5 + 10;
const int NN = 8;
int a[2 * NN + 10];
int t[2 * NN + 10][4][4];
int len[2 * NN + 10];
int temp[4][4];

void mrg(int a[4][4], int b[4][4], int lb, int c[4][4], int lc) {
    for (int i = 0; i < 4; i++)
        for (int j = 0; j < 4; j++) a[i][j] = 0;
    for (int j = 0; j < 4; j++) {
        temp[0][j] = c[0][j];
        for (int i = 1; i < 4; i++) {
            temp[i][j] = max(temp[i - 1][j], c[i][j]);
        }
    }
    for (int i = 0; i < 4; i++) {
        for (int j = 0; j < 4; j++) {
            if (i + j >= lb) continue;
            for (int k = 0; k < min(4ll, lc); k++) {
                a[i][k] = max(a[i][k], b[i][j] + temp[3 - j][k]);
            }
        }
    }
    if (lb <= 3) {
        for (int i = 0; i < lc && lb + i <= 3; i++) {
            for (int j = 0; j + i < lc; j++) {
                a[lb + i][j] = max(a[lb + i][j], b[lb][lb] + c[i][j]);
            }
        }
    }
    if (lc <= 3) {
        for (int i = 0; i < lb; i++) {
            for (int j = 0; j + i < lb && j + lc <= 3; j++) {
                a[i][j + lc] = max(a[i][j + lc], b[i][j] + c[lc][lc]);
            }
        }
    }
    if (lb + lc <= 3) a[lb + lc][lb + lc] = max(a[lb + lc][lb + lc], b[lb][lb] + c[lc][lc]);
}

void upd(int v, int tl, int tr, int i) {
    if (tl > i || tr < i) return;
    if (tl == tr) {
        t[v][1][1] = a[i];
        return;
    }
    int tm = (tl + tr) / 2;
    upd(2 * v, tl, tm, i);
    upd(2 * v + 1, tm + 1, tr, i);
    mrg(t[v], t[2 * v], (tm - tl + 1), t[2 * v + 1], (tr - tm));
    return;
}

int get() {
    int res = 0;
    for (int i = 0; i < 4; i++) {
        for (int j = 0; j + i < 4; j++) {
            res = max(res, t[1][i][j]);
        }
    }
    return res;
}

signed main() {
    fast();
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        upd(1, 0, n - 1, i);
    }
    int q;
    cin >> q;
    cout << get() << '\n';
    for (int i = 0; i < q; i++) {
        int p, v;
        cin >> p >> v;
        p--;
        a[p] = v;
        upd(1, 0, n - 1, p);
        cout << get() << '\n';
    }
    return 0;
}