#include <bits/stdc++.h>

using namespace std;

#define int long long

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 mt(seed);

bool check(int x, int y) {
    int mask = (x << 3) ^ y;
    for (int i = 0; i < 3; i++) {
        bool z = true;
        for (int j = i; j < i + 4; j++)
            if (!(mask & (1 << j))) z = false;
        if (z) return false;
    }
    return true;
}

int32_t main() {
    #ifdef LOCAL
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
        //freopen("common.in, "r", stdin);
        //freopen("common.out, "w", stdout);
    #endif
    cout.precision(20);
    int n; cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    int q; cin >> q;
    vector <vector <vector <int> > > dp(n, vector <vector <int> >(8, vector <int>(8)));
    for (int mask = 0; mask < 8; mask++) {
        for (int i = 0; i < 3; i++) {
            if (mask & (1 << (2 - i))) {
                dp[2][mask][mask] += a[i];
            }
        }
    }
    for (int i = 2; i < n - 1; i++) {
        for (int f = 0; f < 8; f++) {
            for (int mask = 0; mask < 8; mask++) {
                dp[i + 1][f][((mask << 1) | 8) ^ 8] = max(dp[i][f][mask], dp[i + 1][f][((mask << 1) | 8) ^ 8]);
                if (mask != 7) {
                    dp[i + 1][f][((mask << 1) | 8) ^ 9] = max(dp[i][f][mask] + a[i + 1], dp[i + 1][f][((mask << 1) | 8) ^ 9]);
                }
            }
        }
    }
    int ans = 0;
    for (int f = 0; f < 8; f++) {
        for (int mask = 0; mask < 8; mask++) {
            if (check(mask, f))
                ans = max(ans, dp[n - 1][f][mask]);
        }
    }
    cout << ans << "\n";
    for (int iq = 0; iq < q; iq++) {
        int k, x;
        cin >> k >> x;
        k--; a[k] = x;
        if (k <= 1000) {
            for (int i = 0; i < n; i++)
                for (int f = 0; f < 8; f++)
                    for (int mask = 0; mask < 8; mask++)
                        dp[i][f][mask] = 0;
            for (int mask = 0; mask < 8; mask++) {
                for (int i = 0; i < 3; i++) {
                    if (mask & (1 << (2 - i))) {
                        dp[2][mask][mask] += a[i];
                    }
                }
            }
            for (int i = 2; i < n - 1; i++) {
                for (int f = 0; f < 8; f++) {
                    for (int mask = 0; mask < 8; mask++) {
                        dp[i + 1][f][((mask << 1) | 8) ^ 8] = max(dp[i][f][mask], dp[i + 1][f][((mask << 1) | 8) ^ 8]);
                        if (mask != 7) {
                            dp[i + 1][f][((mask << 1) | 8) ^ 9] = max(dp[i][f][mask] + a[i + 1], dp[i + 1][f][((mask << 1) | 8) ^ 9]);
                        }
                    }
                }
            }
            ans = 0;
            for (int f = 0; f < 8; f++) {
                for (int mask = 0; mask < 8; mask++) {
                    if (check(mask, f))
                        ans = max(ans, dp[n - 1][f][mask]);
                }
            }
            cout << ans << "\n";
        } else {
            for (int i = k - 99; i < n; i++)
                for (int f = 0; f < 8; f++)
                    for (int mask = 0; mask < 8; mask++)
                        dp[i][f][mask] = 0;
            for (int i = k - 100; i < n - 1; i++) {
                for (int f = 0; f < 8; f++) {
                    for (int mask = 0; mask < 8; mask++) {
                        dp[i + 1][f][((mask << 1) | 8) ^ 8] = max(dp[i][f][mask], dp[i + 1][f][((mask << 1) | 8) ^ 8]);
                        if (mask != 7) {
                            dp[i + 1][f][((mask << 1) | 8) ^ 9] = max(dp[i][f][mask] + a[i + 1], dp[i + 1][f][((mask << 1) | 8) ^ 9]);
                        }
                    }
                }
            }
            ans = 0;
            for (int f = 0; f < 8; f++) {
                for (int mask = 0; mask < 8; mask++) {
                    if (check(mask, f))
                        ans = max(ans, dp[n - 1][f][mask]);
                }
            }
            cout << ans << "\n";
        }
    }
    return 0;
}
