#include <iostream>
#include <vector>

using namespace std;


int bin_find(vector<double>& x, double n){
    int start = 0;
    int ending = x.size();
    while(ending - start > 1){
        // cout << start << " " << ending << endl;
        int g = (start + ending - 1) / 2;
        if(x[g] == n){
            return g;
        }
        else if(x[g] > n){
            start = g + 1;
        }
        else{
            ending = g + 1;
        }
        ++g;
    }
    return start;

}


int main(){
    int n;
    cin >> n;
    vector<int> v(n);
    for(int c = 0; c < n; ++c){
        cin >> v[c];
    }
    vector<int> l(n);
    for(int c = 0; c < n; ++c){
        cin >> l[c];
    }
    int m;
    cin >> m;
    vector<int> a(m);
    a[0] = 0;
    for(int c = 1; c < m; ++c){
        cin >> a[c];
    }
    vector<int> f(m);
    vector<double> mint(m);
    for(int c = 0; c < m; ++c){
        cin >> f[c];
        double t = 0;
        for(int x = 0; x < n; ++ x){
            t += (float)(l[x]) / (a[c] + v[x]);
        }
        mint[c] = t;
    }
    int q;
    cin >> q;
    for(int x = 0; x < q; ++x){
        int in;
        int out;
        cin >> in >> out;
        int t = out - in;
        int g = bin_find(mint, t);
        if(g == 0){
            cout << 0 << endl;
        }
        else{
            cout << f[g - 1] << endl;
        }
    }
    return 0;
}

