#include <bits/stdc++.h>


using namespace std;
typedef long long ll;
typedef vector<ll> vl;
typedef pair<ll, ll> pl;
typedef long double ld;

#define divup(x, y) ((x + y - 1) / y)

ll gcd(ll a, ll b) {
    while(b != 0) {
        ll temp = b;
        b = a % b;
        a = temp;
    }

    return a;
}

ll lcm(ll a, ll b) {
    return (a / gcd(a, b)) * b;
}

#warning check 10**9 in addfrac!
pair<ll, ll> addfrac(pair<ll, ll> a, pair<ll, ll> b) {
    ll gv = gcd(a.second, b.second);
    ll denomc = (a.second / gv) * b.second;
    ll enumc = (a.first * (b.second / gv)) + (b.first * (a.second / gv));

    return make_pair(enumc, denomc);
}

void fractest() {
    pair<ll, ll> f = addfrac(make_pair(5, 3), make_pair(7, 2));

    cout << f.first << ' ' << f.second << '\n';
}

int main() {
    // fractest();
    ll n; cin >> n;

    vector<ll> v(n);
    for(ll i = 0; i < n; i++) cin >> v[i];

    vector<ll> l(n);
    for(ll i = 0; i < n; i++) cin >> l[i];

    ll m; cin >> m;

    vector<ll> a(m);
    a[0] = 0;
    for(ll i = 1; i < m; i++) cin >> a[i];


    vector<ll> f(m + 1);
    f[0] = 0;
    for(ll i = 1; i < m + 1; i++) cin >> f[i];

    if(m == 1) {
        ld tnormmx = 0;
        for(ll i = 0; i < n; i++) tnormmx += (ld)(l[i]) / (ld)(v[i] + a[m - 1]);

        if(tnormmx < 0) {
            cout << "jfghvkhfhui";
            return 0;
        }

        ll q; cin >> q;
        for(ll testi = 0; testi < q; testi++) {
            ll si, ti; cin >> si >> ti;

            ll dt = ti - si;
            if(dt <= tnormmx) cout << f[1] << '\n';
            else cout << "0\n";
        }

        return 0;
    }

    ld tnorm0 = 0;
    for(ll i = 0; i < n; i++) tnorm0 += (ld)(l[i]) / (ld)(v[i]);

    ld tnormmx = 0;
    for(ll i = 0; i < n; i++) tnormmx += (ld)(l[i]) / (ld)(v[i] + a[m - 1]);

    ll q; cin >> q;
    for(ll testi = 0; testi < q; testi++) {
        ll si, ti; cin >> si >> ti;
        ll dt = ti - si;
        // test all-ok
        if(dt >= tnorm0) {
            cout << "0\n";
            continue;
        }

        if(dt < tnormmx) {
            cout << f[m] << '\n';
            continue;
        }

        // cout << "not-0: ";

        ll bsl = -1, bsr = m - 1;
        while(bsl + 1 < bsr) {
            ll cv = bsl + (bsr - bsl) / 2;

            ld tnorm = 0;
            for(ll i = 0; i < n; i++) tnorm += (ld)(l[i]) / (ld)(v[i] + a[cv]);

            if(dt >= tnorm) bsr = cv;
            else bsl = cv;
        }

        cout << f[bsr] << '\n';
    }

    return 0;
}
