#include <iostream>
#include <vector>
int main() {
    int n;
    std::cin >> n;
    std::vector<int> v;
    for (int i = 0; i < n; ++i)
    {
        int x;
        std::cin >> x;
        v.push_back(x);
    }
    std::vector<int> l;
    for (int i = 0; i < n; ++i)
    {
        int x;
        std::cin >> x;
        l.push_back(x);
    }
    int m;
    std::cin >> m;
    std::vector<int> a(m-1);
    for (int i = 0; i < m - 1; ++i)
        std::cin >> a[i];
    std::vector<double> t(n);
    for (int i = 0; i < n; ++i)
        t[i] = double(l[i]) / v[i];
    std::vector<double> t_rest(n);
    double T0 = 0;
    for (auto& it : t)
        T0 += it;
    for (int i = 0; i < n; ++i)
    {
        t_rest[i] = T0 - t[i];
    }
    std::vector<int> f(m);
    for (int i = 0; i < m; ++i)
        std::cin >> f[i];
    std::vector<std::vector<int>> v_borders(n);
    for (int j = 0; j < n; ++j)
    {
        v_borders[j] = std::vector<int>(m - 1);
        for (int i = 0; i < m - 1; ++i)
        {
            v_borders[j][i] = v[j] + a[i];
        }
    }
    std::vector<double> T(m - 1);
    for (int i = 0; i < m - 1; ++i)
    {
        T[i] = 0;
        for (int j = 0; j < n; ++j)
            T[i] += double(l[j]) / v_borders[j][i];
    }
    int q;
    std::cin >> q;
    for (int i = 0; i < q; ++i)
    {
        int s, t;
        std::cin >> s >> t;
        int time = t - s;
        if (time > T0)
        {
            std::cout << 0 << std::endl;
        }
        else
        {
            int left = 0, right = m - 1;
            int res = 0;
            while (left != right)
            {
                if (left == right - 1)
                {
                    if (time < T[left])
                    {
                        res = right;
                        break;
                    }
                    else
                    {
                        res = left;
                        break;
                    }
                }
                int med = (left + right) / 2;
                if (time > T[med])
                    right = med;
                else
                    left = med;
            }
            std::cout << f[res] << std::endl;
        }
    }



    
    
}