#include <iostream>
#include <vector>

bool multBigger(long long a, long long b, long long c, long long d)
{
    long long w = a + b;
    if (a > b)
        std::swap(a, b);
    if (c > d)
        std::swap(c, d);
    long long int k = a - c;
    return w - 2 * c - k > 0;
}
int main()
{

    
    int n;
    std::cin >> n;
    long long int weight = 0;
    std::vector<int> arr(n);

    int cut = n / 2;
    long long int weight_left = 0;
    for (int i = 0; i < n; ++i)
    {
        std::cin >> arr[i];
        weight += arr[i];
        if (i <= cut)
            weight_left += arr[i];
    }
    
    bool changed = true;
    while (changed)
    {
        long long int current = weight_left * (weight - weight_left);
       // if (cut > 0 && (weight_left - arr[cut]) * (weight - weight_left + arr[cut]) > current)
        if (cut > 0 && multBigger(weight_left - arr[cut], weight - weight_left + arr[cut], weight_left, weight - weight_left))
        {
            weight_left -= arr[cut];
            --cut;
            changed = true;
           
        }
       // else if (cut < n - 1 && (weight_left + arr[cut + 1]) * (weight - weight_left - arr[cut + 1]) > current)
        else if (cut < n - 1 && multBigger(weight_left + arr[cut + 1], weight - weight_left - arr[cut + 1], weight_left, weight - weight_left))
        {
            weight_left += arr[cut + 1];
            ++cut;
            changed = true;
        }
        else
        {
            changed = false;
        }
    }
    std::cout << cut + 1;
    
    /*
    int last = 0;
    long long int w = arr[0];
    long long int max_p = (w) * (weight - w);
    int ind_of_max = 0;
    while (last < arr.size() - 1)
    {
        ++last;
        w += arr[last];
        long long int p = w * (weight - w);
        if (p > max_p)
        {
            max_p = p;
            ind_of_max = last;
        }
    }
    std::cout << ind_of_max + 1;*/
    return 0;
}