#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

long long n, q;
const long long inf = 1e18 + 5;
vector<long long> a(n + 1);

pair<long long, long long> solve(long long x) {
    if (x == 0) return { 0ll, 0ll };
    int l = 0;
    int r = n + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (a[m] <= x) {
            l = m;
        }
        else {
            r = m;
        }
    }
    long long ans2 = (x / a[l]);
    long long ans1 = a[l] * ans2;
    if (x - ans1 < a[l] - 1) {
        ans2--;
        ans1 = a[l] * ans2;
    }
   
    pair<long, long> ans = solve(a[l] - 1);
    if (a[l] == 1){
       ans2 = (x / a[l]);
       ans1 = a[l] * ans2;
       ans.first = ans1;
       ans.second = ans2;
    }
    else {
        ans.first += ans1;
        ans.second += ans2;
     }
   
    

    
    return ans;
}

int main() {
    cin >> n;
    a.resize(n + 1);
    for (long long i = 1; i <= n; i++) {
        cin >> a[i];
    }
   
    cin >> q;
    for (long long i = 0; i < q; i++) {
        long long b;
        cin >> b;
        pair<long long, long long> ans = solve(b);
        cout << ans.first << " " << ans.second << endl;
    }
}