#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

long long n, q;
const long long inf = 1e18 + 5;
vector<long long> a(n + 1);

pair<long long, long long> solve1(long long x) {
    if (x == 0) return { 0ll, 0ll };
    int l = 0;
    int r = n + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (a[m] <= x) {
            l = m;
        }
        else {
            r = m;
        }
    }
    cout << l << endl;
    pair<long, long> ans = solve1(a[l] - 1);
    long long ans2 = (x - ans.first) / a[l];
    long long ans1 = a[l] * ans2;
    ans.first += ans1;
    ans.second += ans2;




    return ans;
}

pair<long long, long long> solve2(long long x) {
    long long sum = 0;
    long long ans = 0;
    int i = 1;
    while (x >= a[i]) {
        long long p = x;
        if (i != n) {
            p = min(p, a[i + 1] - 1);
        }
        
        long long cnt = p / a[i];
        ans += cnt;
        sum += a[i] * cnt;
        x -= a[i] * cnt;
        i++;
    }
    return { sum, ans };
}

int main() {
    cin >> n;
    a.resize(n + 1);
    for (long long i = 1; i <= n; i++) {
        cin >> a[i];
    }

    cin >> q;
    for (long long i = 0; i < q; i++) {
        long long b = i;
        cin >> b;
        pair<long long, long long> ans = solve2(b);
        cout << ans.first << " " << ans.second << endl;
    }
}
