#include <string>
#include <algorithm>
#include <vector>
#include <iostream>
#include <time.h>
#include <fstream>
#include <set>

using namespace std;

vector<int> ar;
int n;

int f()
{
	int ans = 0;
	for (int i = 0; i < (1 << n); ++i)
	{
		vector<int> ar2 = vector<int>();
		int j = i;
		while (j > 0)
		{
			ar2.push_back(j % 2);
			j /= 2;
		}
		while (ar2.size() < n)
			ar2.push_back(0);
		for (int i = 0; i < n; ++i)
			ar2.push_back(ar2[i]);
		int cnt = 0;
		int maxcnt = 0;
		for (int i = 0; i < 2 * n; ++i)
		{
			cnt += ar2[i];
			if (ar2[i] == 0)
				cnt = 0;
			maxcnt = max(maxcnt, cnt);
		}
		if (maxcnt >= 4)
			continue;
		cnt = 0;
		for (int i = 0; i < n; ++i)
		{
			cnt += ar2[i] * ar[i];
		}
		if (cnt > ans)
			ans = cnt;
	}
	return ans;
}

signed main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output2.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i)
	{
		int a;
		cin >> a;
		ar.push_back(a);
	}
	int q;
	cin >> q;
	cout << f() << endl;
	for (int i = 0; i < q; ++i)
	{
		int p, v;
		cin >> p >> v;
		ar[p - 1] = v;
		cout << f() << endl;
	}
}