#include <iostream>
#include <vector>
#include <queue>;

using namespace std;

// count of couputres;
int bin_search (vector<long long int>& a, int cash, int l, int r);
long long int couperes(vector<long long int>& a, int cash);

int main () {
    int n = 0;
    cin >> n;
    vector<long long int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int q = 0;
    cin >> q;
    vector <long long int> b(q);

    for (int i = 0; i < q; i++) {
        cin >> b[i];
    }

    vector<long long int> dp(20000, 1); // qupurs of i;
    vector<long long int> best_for(20000, 0); // indexes of best
    for (int i = 1; i < 20000; i++) {
        dp[i] = couperes(a, i + 1);
        if (dp[best_for[i - 1]] < dp[i]) best_for[i] = i;
        else best_for[i] = best_for[i - 1];
    }

    for (int i = 0; i < q; i++) {
        int cash = best_for[b[i] - 1];
        int answ = dp[cash];
        cout << cash + 1 << " " << answ  << endl;
    }
}

long long int couperes(vector<long long int>& a, int cash) {
    int answ = 0;
    while (cash > 0) {
        answ++;
        //cout << bin_search(a, cash, 0, a.size()) << endl;
        cash -= a[bin_search(a, cash, 0, a.size())];
    }
    return answ;
}

int bin_search (vector<long long int>& a, int cash, int l, int r) {
    if (r - l <= 1) {
        if (a[r] <= cash) return r;
        else return l;
    }
    int c = (r + l) / 2;
    if (a[c] > cash) return bin_search(a, cash, l, c);
    else return bin_search(a, cash, c, r);
}

