#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


#define int long long


using ld = long double;


signed main() {
    fast_io();

    int n;
    cin >> n;

    vector<ld> v(n), l(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }

    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }

    int m;
    cin >> m;

    vector<int> a(m), f(m + 1);
    for (int i = 0; i < m - 1; ++i) {
        cin >> a[i + 1];
    }

    for (int i = 0; i < m; ++i) {
        cin >> f[i + 1];
    }

    vector<ld> tb(m + 1);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            tb[j] += l[i] / (v[i] + a[j]);
        }
    }

    reverse(tb.begin(), tb.end());

    int q;
    cin >> q;

    int s, t;
    while (q--) {
        cin >> s >> t;

        ld ct = t - s;

        int i = lower_bound(tb.begin(), tb.end(), ct) - tb.begin();
        --i;

        cout << f[m - i] << '\n';
    }

    return 0;
}
