#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


#define int long long


signed main() {
    fast_io();

    int n, m, s;
    cin >> n >> m >> s;

    vector<vector<int>> p(m, vector<int>(2 * n - 1));
    vector<vector<int>> cval(m, vector<int>(2 * n - 1));
    vector<vector<int>> other(m, vector<int>(2 * n - 1));
    vector<vector<int>> a(m, vector<int>(n - 1)), b(m, vector<int>(n - 1)), op(m, vector<int>(n - 1));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];

            --a[i][j];
            --b[i][j];

            other[i][a[i][j]] = b[i][j];
            other[i][b[i][j]] = a[i][j];

            p[i][a[i][j]] = n + j;
            p[i][b[i][j]] = n + j;
        }
    }

    vector<vector<int>> cord(n, vector<int>(m));

    int c;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> c;

            cord[j][c] = i;
        }
    }

    if (s == 0) {
        for (int i = 0; i < n; ++i) {
            cout << 0 << ' ';
        }

        return 0;
    }

    vector<int> answ(n);

    int kurlik = 0;
    for (int i = 0; i < n; ++i) {
        bool b = false;
        for (int cur = 0; cur < m; ++cur) {
            int line = cord[i][cur];

            int cv = i;
            cval[line][cv] = 1;
            while (cv != 2 * n - 2) {
                int cp = p[line][cv];

                if (cval[line][cp]) {
                    break;
                }

                if (op[line][cp - n] == 2) {
                    cval[line][cp] = 1;
                } else if (cval[line][other[line][cv]]) {
                    cval[line][cp] = 1;
                } else {
                    break;
                }

                cv = cp;
            }

            if (cv == 2 * n - 2) {
                if (++kurlik == s) {
                    answ[i] = cur + 1;
                    b = true;
                    break;
                }
            }
        }

        if (b) {
            break;
        }

        answ[i] = m;
    }

    for (int i = 0; i < n; ++i) {
        cout << answ[i] << ' ';
    }

    return 0;
}
