#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


#define int long long


int solve(int a, int b, int n) {
    int res = 0;

    for (int f = 1; f < b; ++f) {
        int k = n - f * a;

        if (k < b - f) {
            return res;
        }

        if (k % (b - f) != 0) {
            continue;
        }

        int e = k / (b - f);

        if (e >= a) {
            continue;
        }

        ++res;
    }

    return res;
}


signed main() {
    fast_io();

    int n, x;
    cin >> n >> x;

    int answ = 0;

    for (int a = 1; a < n; ++a) {
        if (a == x) {
            continue;
        }

        answ += solve(a, a, n);

        for (int b = 1; b < a; ++b) {
            if (b == x) {
                continue;
            }

            answ += 2 * solve(a, b, n);
        }
    }

    cout << answ;

    return 0;
}
