#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 2e5 + 10, MAGIC = 500;
int n, m, s;
std::vector<std::vector<int>> a, val;
struct seg_op
{
	int a, b, op;
};
std::vector<seg_op> v[N];
std::vector<std::pair<int,int>> check[N];
inline int updVal(int i, int j) {
	if (j >= m) {
		if (v[i][j - m].op == 1) {
			val[i][j] = (val[i][v[i][j - m].a] & val[i][v[i][j - m].b]);
		}
		else {
			val[i][j] = (val[i][v[i][j - m].a] | val[i][v[i][j - m].b]);
		}
	}
	return val[i][j];
}
inline int checker1(int x0) {
	int s = 0;
	FOR(i, n) {
		s += (val[i][0] = a[i][0] < x0);
	}
	return s;
}
int checker(std::vector<int> &x) {
	int s = 0;
	FOR(i, n) {
		for (int j = 0; j < m; ++j) {
			val[i][j] = a[i][j] < x[j];
		}
		for (int j = m; j < 2 * m - 1; ++j) {
			updVal(i, j);
		}
		s += val[i][2 * m - 1];
	}
	return s;
}
void doRec(int lvl, std::vector<int> x) {
	if (lvl == m) {
		for (auto e : x) {
			std::cout << e << ' ';
		}
		return;
	}
	int l = 0, r = n + 1;
	while (r - l > 1) {
		int tm = (l + r) / 2;
		std::vector<int> newX = x;
		newX.pb(tm);
		while ((int)newX.size() < m) newX.pb(n);
		if (checker(newX) > s) {
			r = tm;
		}
		else {
			l = tm;
		}
	}
	x.pb(l);
	doRec(lvl + 1, x);
}
int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::cin >> m >> n >> s;
	a.resize(n, std::vector<int>(m));
	val.resize(n, std::vector<int>(2 * m - 1, 0));
	FOR(i, n) {
		FOR(j, m - 1) {
			int a1, b1, c1;
			std::cin >> a1 >> b1 >> c1;
			--a1; --b1;
			v[i].pb({a1, b1, c1});
		}
	}
	FOR(i, n) {
		FOR(j, m) {
			std::cin >> a[i][j];
			check[j].pb({a[i][j], i});
		}
	}
	FOR(j, m) {
		std::sort(check[j].begin(), check[j].end());
	}
	std::vector<int> x;
	doRec(0, x);
}