#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 3e5 + 10, MAGIC = 500;
int n, m, s;
std::vector<std::vector<int>> a, val, pred, state;
struct seg_op
{
	int a, b, op;
};
std::vector<seg_op> v[N];
std::vector<std::pair<int,int>> check[N];
inline int updVal(int i, int j) {
	if (j >= m) {
		if (v[i][j - m].op == 1) {
			val[i][j] = (val[i][v[i][j - m].a] & val[i][v[i][j - m].b]);
		}
		else {
			val[i][j] = (val[i][v[i][j - m].a] | val[i][v[i][j - m].b]);
		}
	}
	return val[i][j];
}
inline int checker1(int x0) {
	int s = 0;
	FOR(i, n) {
		s += (val[i][0] = a[i][0] < x0);
	}
	return s;
}
int checker(int j1, int x) {
	int s = 0;
	FOR(i, n) {
		val[i][j1] = a[i][j1] < x;
		for (int j = m; j < 2 * m - 1; ++j) {
			updVal(i, j);
		}
		s += val[i][2 * m - 2];
	}
	return s;
}
void recountOneState(int i, int j) {
	if (j >= m) {
		int a = v[i][j - m].a, b = v[i][j - m].b;
		if (v[i][j - m].op == 1) {
			if (state[i][a] == 0 || state[i][b] == 0) {
				state[i][j] = 0;
				return;
			}
			if (state[i][a] == 1 && state[i][b] == 1) {
				state[i][j] = 1;
				return;
			}
			state[i][j] = 2;
		}
		else {
			if (state[i][a] == 0 && state[i][b] == 0) {
				state[i][j] = 0;
				return;
			}
			if (state[i][a] == 1 || state[i][b] == 1) {
				state[i][j] = 1;
				return;
			}
			state[i][j] = 2;
		}
	}
}
void setX(int j, int x) {
	for (int i = 0; i < n; ++i) {
		state[i][j] = (a[i][j] < x);
		int nowX = pred[i][j];
		while (nowX != -1) {
			recountOneState(i, nowX);
			nowX = pred[i][nowX];
		}
	}
}
void recountState(int j) {
	for (int i = 0; i < n; ++i) {
		// val[i][j] = (a[i][j] < x);
		state[i][j] = 2;
		int nowX = pred[i][j];
		while (nowX != -1) {
			recountOneState(i, nowX);
			// debug(i << ' ' << nowX << ' ' << state[i][nowX])
			nowX = pred[i][nowX];
		}
	}
}
void doRec(int lvl, std::vector<int> &x) {
	if (lvl == m) {
		FOR(i, m) {
			std::cout << 0 << ' ';
		}
		exit(0);
	}
	recountState(lvl);
	int cnt1 = 0;
	FOR(i, n) {
		if (state[i][2 * m - 2] == 1) {
			cnt1++;
		}
	}
	if (cnt1 >= s) {
		setX(lvl, 0);
		doRec(lvl + 1, x);
	}
	else {
		std::vector<int> kek;
		FOR(i, n) {
			if (state[i][2 * m - 2] == 2) {
				kek.pb(a[i][lvl]);
			}
		}
		std::sort(kek.begin(), kek.end());
		for (int j = 0; j < kek.size(); ++j) {
			if (j + cnt1 + 1 == s) {
				FOR(j, lvl) {
					std::cout << 0 << ' ';
				}
				std::cout << kek[j] + 1 << ' ';
				for (int j = m - lvl - 1; j >= 0; --j) {
					std::cout << n << ' ';
				}
				exit(0);
			}
		}
		assert(false);
	}
}
int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::cin >> m >> n >> s;
	a.resize(n, std::vector<int>(m));
	val.resize(n, std::vector<int>(2 * m - 1, 1));
	pred.resize(n, std::vector<int>(2 * m - 1, -1));
	state.resize(n, std::vector<int>(2 * m - 1, 1));
	FOR(i, n) {
		FOR(j, m - 1) {
			int a1, b1, c1;
			std::cin >> a1 >> b1 >> c1;
			--a1; --b1;
			v[i].pb({a1, b1, c1});
			pred[i][a1] = j + m;
			pred[i][b1] = j + m;
		}
	}
	FOR(i, n) {
		FOR(j, m) {
			std::cin >> a[i][j];
			// check[j].pb({a[i][j], i});
		}
	}
	// FOR(j, m) {
	// 	std::sort(check[j].begin(), check[j].end());
	// }
	std::vector<int> x;
	doRec(0, x);
	assert(false);
}