#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 3e5 + 10, MAGIC = 500;
struct vertex
{
	ll dp[4][4], sz;

	vertex() {
		memset(dp, -1, sizeof(dp));
	}
	friend vertex operator+(vertex a, vertex b) {
		vertex answ;
		FOR(L1, 4) {
			FOR(R1, 4) {
				if (a.dp[L1][R1] == -1) continue;
				FOR(L2, 4) {

					if (R1 + L2 >= 4) break;

					FOR(R2, 4) {

						if (b.dp[L2][R2] == -1) continue;

						if (L1 == a.sz && R2 == b.sz) {
							if (L1 + L2 < 4 && R1 + R2 < 4)
								answ.dp[L1 + L2][R1 + R2] = std::max(answ.dp[L1 + L2][R1 + R2], a.dp[L1][R1] + b.dp[L2][R2]);
						}
						else if (L1 == a.sz) {
							if (L1 + L2 < 4)
								answ.dp[L1 + L2][R2] = std::max(answ.dp[L1 + L2][R1], a.dp[L1][R1] + b.dp[L2][R2]);
						}
						else if (R2 == b.sz) {
							if (R1 + R2 < 4)
								answ.dp[L1][R1 + R2] = std::max(answ.dp[L1][R1 + R2], a.dp[L1][R1] + b.dp[L2][R2]);
						}
						else {
							answ.dp[L1][R2] = std::max(answ.dp[L1][R2], a.dp[L1][R1] + b.dp[L2][R2]);
						}
					}
				}
			}
		}
		answ.sz = a.sz + b.sz;
		return answ;
	}
};
vertex tree[4 * N];
void upd(int v, int tl, int tr, int i, int x) {
	// tree[v].sz = (tr - tl + 1);
	if (tl == tr) {
		tree[v] = vertex();
		tree[v].sz = 1;
		tree[v].dp[0][0] = 0;
		tree[v].dp[1][1] = x;
		return;
	}
	int tm = (tl + tr) / 2;
	if (tm >= i) {
		upd(v * 2, tl, tm, i, x);
	}
	else {
		upd(v * 2 + 1, tm + 1, tr, i, x);
	}
	tree[v] = tree[v * 2] + tree[v * 2 + 1];
}
ll answ() {
	ll x = 0;
	FOR(L, 4) {
		FOR(R, 4) {
			if (L + R >= 4) break;
			x = std::max(x, tree[1].dp[L][R]);
			// debug(L << ' ' << R << ' ' << tree[1].dp[L][R])
		}
	}
	return x;
}
int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	int n;
	std::cin >> n;
	FOR(i, n) {
		int a;
		std::cin >> a;
		upd(1, 0, n - 1, i, a);
	}
	std::cout << answ() << '\n';
	int q;
	std::cin >> q;
	FOR(i, q) {
		int ind, x;
		std::cin >> ind >> x;
		--ind;
		upd(1, 0, n - 1, ind, x);
		std::cout << answ() << '\n';
	}
}  