#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <numeric>
#include <random>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <tuple>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;

const ld eps = 1e-9;
const ll INF = 1e15;
const ld pi = atan2(0, -1);
const ll mod = 1e9 + 7;
const ll P = 179, Q = 239;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool equal(ld a, ld b) {
	return abs(a - b) < eps;
}

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}


bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll n, m, k;
vector <bool> used;

int main() {
	cin >> n;
	if (n == 0) {
		cout << "Yes\n";
		cout << 1 << ' ' << 1;
		return 0;
	}
	ll beg = clock();
/*	ll opa = sqrt(n);
	while (opa * opa < n) {
		++opa;
	}
	while (opa * opa > n) {
		--opa;
	}*/
	for (ll i = 1; i * i <= n; ++i) {
		if (n % i == 0) {
			ll a = i, b = n / i;
			if (a < b && ((a + b) & 1) == 0) {
				ll x = (a + b) >> 1;
				ll y = (b - a) >> 1;
				cout << "Yes\n";
				cout << x << ' ' << y;
				return 0;
			}
		}
		if (clock() - beg > 990) break;
	}
	cout << "No";
	return 0;
}