#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <numeric>
#include <random>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <tuple>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;

const ld eps = 1e-9;
const ll INF = 1e15;
const ld pi = atan2(0, -1);
const ll mod = 1e9 + 7;
const ll P = 179, Q = 239;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool equal(ld a, ld b) {
	return abs(a - b) < eps;
}

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}


bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll n, m, k;
vector <bool> used;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n;
	vector <ll> a(n);
	for (auto& x : a) {
		cin >> x;
	}
	vector <pair <ll, ll>> opa;
	ll cur = 0;
	ll flex = 0;
	for (int i = 0; i < n - 1; ++i) {
		ll k = (a[i + 1] - cur - 1) / a[i];
		opa.push_back({ cur + a[i] * k, flex + k });
		cur += a[i] * k;
		flex += k;
	}
//	for (auto& x : opa) {
//		cout << "(" << x.first << ' ' << x.second << ") ";
//	}
	ll q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		ll b;
		cin >> b;
		pair <ll, ll> tmp(b, INF);
		auto it = upper_bound(opa.begin(), opa.end(), tmp);
		if (it == opa.begin()) {
			ll base = 0;
			ll cnt = 0;
			ll j = 0;
			cnt += (b - base) / a[j];
			base += (b - base) / a[j] * a[j];
			cout << base << ' ' << cnt << '\n';
		}
		else {
			--it;
			ll base = it->first;
			ll cnt = it->second;
			ll j = it - opa.begin() + 1;
			cnt += (b - base) / a[j];
			base += (b - base) / a[j] * a[j];
			cout << base << ' ' << cnt << '\n';
		}
	}
	return 0;
}
/*
4
1 5 10 50
3
2
8
50
*/