#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

inline void maxi(ll& a, ll b) noexcept {
	if (b > a) {
		a = b;
	}
}

inline ll mmax(ll a, ll b) noexcept {
	if (a > b) return a;
	return b;
}

ll n;
ll a[40'001];
ll dp[4][40'001][4];

void recalc() {
	for (int ptr = 0; ptr < 4; ++ptr) {
		dp[ptr][1][0] = dp[ptr][1][1] = dp[ptr][1][2] = dp[ptr][1][2] = 0;
		for (int i = 2; i <= n; ++i) {
			dp[ptr][i][0] = mmax(mmax(dp[ptr][i - 1][0], dp[ptr][i - 1][1]), mmax(dp[ptr][i - 1][2], dp[ptr][i - 1][3]));
			for (int j = 1; j < 4; ++j) {
				dp[ptr][i][j] = dp[ptr][i - 1][j - 1] + a[((i - 1) + ptr) % n];
			}
		}
	}
}

int main() noexcept {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	recalc();
	ll ans = 0;
	for (int i = 0; i < 4; ++i) {
		for (auto& x : dp[i][n]) {
			maxi(ans, x);
		}
	}
	cout << ans << '\n';
	ll q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		ll p, v;
		cin >> p >> v;
		--p;
		a[p] = v;
		recalc();
		ll ans = 0;
		for (int i = 0; i < 4; ++i) {
			for (int j = 0; j < 4; ++j) {
				ans = mmax(ans, dp[i][n][j]);
			}
		}
		cout << ans << '\n';
	}
	return 0;
}
/*
6
1 2 3 4 5 6
2
6 0
2 5
*/