#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector")

#include <iostream>
#include <vector>

using namespace std;

inline void maxi(long long& a, long long b) noexcept {
	if (b > a) {
		a = b;
	}
}

inline long long mmax(long long a, long long b) noexcept {
	if (a > b) return a;
	return b;
}

long long n;
long long a[40001];
long long dp[4][4][40001];

void recalc() {
	for (int ptr = 0; ptr < 4; ++ptr) {
		dp[ptr][0][1] = dp[ptr][1][1] = dp[ptr][2][1] = dp[ptr][3][1] = 0;
		for (int i = 2; i <= n; ++i) {
			dp[ptr][0][i] = mmax(mmax(dp[ptr][0][i - 1], dp[ptr][1][i - 1]), mmax(dp[ptr][2][i - 1], dp[ptr][3][i - 1]));
			for (int j = 1; j < 4; ++j) {
				dp[ptr][j][i] = dp[ptr][j - 1][i - 1] + a[((i - 1) + ptr) % n];
			}
		}
	}
}

int main() noexcept {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	recalc();
	long long ans = 0;
	for (int i = 0; i < 4; ++i) {
		for (int j = 0; j < 4; ++j) {
			maxi(ans, dp[i][j][n]);
		}
	}
	cout << ans << '\n';
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int p, v;
		cin >> p >> v;
		--p;
		a[p] = v;
		recalc();
		long long ans = 0;
		for (int i = 0; i < 4; ++i) {
			for (int j = 0; j < 4; ++j) {
				maxi(ans, dp[i][j][n]);
			}
		}
		cout << ans << '\n';
	}
	return 0;
}
/*
6
1 2 3 4 5 6
2
6 0
2 5
*/