#include <bits/stdc++.h>

using namespace std;

#define int long long

constexpr int MAXN = 80'100;
int dp[2][5][MAXN];
vector<int> a, da;
int ans = 0;

void calc(string s) {
    if (s.size() < a.size()) {
        calc(s + "0");
        calc(s + "1");
        return;
    }
    s += s;
    int cnt = 0;
    for (auto ch : s) {
        if (ch == '0') cnt = 0;
        else cnt++;
        if (cnt == 4) return;
    }
    int cans = 0;
    for (int i = 0; i < a.size(); i++) {
        if (s[i] == '1') {
            cans += a[i];
        }
    }
    ans = max(cans, ans);
}

void calcdp(int n) {
    for (int i = 0; i < 5; i++) {
        memset(dp[0][i], 0, sizeof dp[0][i]);
        memset(dp[1][i], 0, sizeof dp[1][i]);
        dp[0][i][i] = dp[1][i][i] = 0;
        for (int j = i + 1; j < i + n; j++) {
            dp[0][i][j] = max(dp[1][i][j - 1], dp[0][i][j - 1]);
            if (j - i == 1) {
                dp[1][i][j] = da[j];
            } else if (j - i == 2) {
                dp[1][i][j] = da[j] + da[j - 1];
            } else {
                dp[1][i][j] = max({
                    dp[0][i][j - 1] + da[j],
                    dp[0][i][j - 2] + da[j] + da[j - 1],
                    dp[0][i][j - 3] + da[j] + da[j - 1] + da[j - 2]
                });
            }
            ans = max({ans, dp[1][i][j], dp[0][i][j]});
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    da = a;
    for (int i = 0; i < n; i++) {
        da.push_back(a[i]);
    }
    for (int i = 0; i < n; i++) {
        da.push_back(a[i]);
    }
    calcdp(n);
    cout << ans << '\n';
    int q;
    cin >> q;
    ans = 0;
    for (int i = 0; i < q; i++) {
        int p, v;
        cin >> p >> v;
        p--;
        a[p] = v;
        da[p] = v;
        da[p + n] = v;
        da[p + 2 * n] = v;
        calcdp(n);
        cout << ans << '\n';
        ans = 0;
    }
    return 0;
}