#include <iostream>
#include <string>
#include <algorithm>
#include <math.h>
#include <vector>
#include <iomanip>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <random>

using namespace std;

#define _GLIBCXX_DEBUG

#define FR(i, n) for (ll i = 0; i < (n); i++)
#define FOR(i, L, R) for (ll i = (L); i < (R); i++)
#define all(a) (a.begin(), a.end())

typedef long long ll;
typedef pair <int, int> pii;
typedef double db;

ll MX = 1e18;

bool stress(ll n, bool out) {

	FOR(X, 1, 1e3) {

		FOR(Y, 1, 1e3) {

			if (X * X - Y * Y == n) {

				if (out) cout << "str " << X << ' ' << Y << '\n';
				return true;

			}

		}

	}

	return false;

}

bool ac(ll n, bool out) {

	bool ans = 0; ll x = -1, y = -1;
	ll A = 1; ll B;

	while (A * A <= n) {

		if (n % A == 0) {

			B = n / A;

			if ((B - A) % 2 == 0) {

				y = (B - A) / 2;
				x = B - y;

				if (x > 0 && x < MX && y > 0 && y < MX) {

					if (out) cout << x << ' ' << y << '\n';
					return true;

					//ans = 1;
					//break;
				}
			}

		}

		A++;
	}

	return false;
}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	ll n; cin >> n;

	bool ans = ac(n, 0);
	
	/*FR(i, (1 << 10)) {
	
		if (ac(i, 0) != stress(i, 0)) {
		
			cout << i << '\n';

			ac(i, 1);
			stress(i, 1);
			break;

		}

	}*/
	
	if (n == 0) cout << "Yes\n 1 1";
	else if (ans) cout << "Yes\n", ac(n, 1);
	else cout << "No";

	return 0;
}