#include <iostream>
#include <string>
#include <algorithm>
#include <math.h>
#include <vector>
#include <iomanip>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <random>
#include <bitset>

using namespace std;

#define _GLIBCXX_DEBUG

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef pair <int, int> pii;
typedef long double db;

int n; 
vector <int> a;

int sm(int x) {

    int ans = 0; int j = 0;
    while (x > 0) {
    
        if (x % 2 == 1) ans += a[j];

        x = (x >> 1);
        j++;

    }
    return ans;
}

vector <int> C;
bool check(int x) {

    if (n < 4) return true;

    FR(i, n + 3) C[i] = 0;

    int j = 0;
    while (x > 0) {

        if (x % 2 == 1) C[j] = 1;

        x = (x >> 1);
        j++;

    }

    C[n] = C[0]; C[n + 1] = C[1]; C[n + 2] = C[2];
    int last = -1;

    FR(i, n + 3) {
    
        if (C[i] == 1) {
        
            if (i - last >= 4) return false;

        } 
        else last = i;

    }

    return true;
}

int ch() {

    int ans = 0;
    FR(i, (1 << n)) {


        if (check(i)) {
            ans = max(ans, sm(i));
        }
    }

    return ans;

}

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);


    cin >> n; 
    a.resize(n);
    FR(i, n) cin >> a[i];

    int q; cin >> q;

    C.resize(n + 3);
    cout << ch();

    return 0;
}