#include <bits/stdc++.h>

using namespace std;

const int MAX_M = 1e5 + 42;
const int MAX_N = 42;
long long l[MAX_N];
long long v[MAX_N];
long long a[MAX_M];
long long f[MAX_M];
long long INF = 1e9 + 42;
int m, n;
const long double eps = 1e-6;

long double get_sum(int x) {
    long double sum = 0;
    for (int i = 0; i < n; i++) {
        sum += (long double)l[i] / (v[i] + a[x - 1]);
    }
    return sum;
}

int bin(long long k) {
    int left = 0;
    int right = m;
    while (right - left > 1) {
        int mid = (right + left) / 2;
        if (get_sum(mid) > k) {
            left = mid;
        } else {
            right = mid;
        }
    }
    return left;
}

int main() {
   // freopen("input.txt", "r", stdin);
    cin >> n;
    long double sum = 0;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i];
        sum += (long double)l[i] / v[i];
    }
    cin >> m;
    a[0] = 0;
    for (int i = 1; i < m; i++) {
        cin >> a[i];
    }
    a[m] = INF;
    for (int i = 0; i < m; i++) {
        cin >> f[i];
    }
    int q;
    cin >> q;
    while (q--) {
        long long T, S;
        cin >> S >> T;
        if (sum <= T - S) {
            cout << 0 << "\n";
            continue;
        }
        cout << f[bin(T - S) - 1] << "\n";
    }
    return 0;
}
