#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 10;
const int MAX_M = 1042;
int op[MAX_M][MAX_N];
int a[MAX_M][MAX_N];
int b[MAX_M][MAX_N];
int x[MAX_M][MAX_N];
int val[MAX_M][MAX_N * 2];
int n, m, s;
vector < int > cnt[MAX_M];

void get(vector < int >& z, int i) {
    for (int j = 0; j < n; j++) {
        if (x[i][j] < z[j]) {
            val[i][j] = 1;
        } else {
            val[i][j] = 0;
        }
    }
    for (int j = n; j < 2 * n - 1; j++) {
        if (op[i][j - n] == 1) {
            val[i][j] = (val[i][a[i][j - n]] & val[i][b[i][j - n]]);
        } else {
            val[i][j] = (val[i][a[i][j - n]] | val[i][b[i][j - n]]);
        }
    }
}

int get_all(vector < int >& z) {
    int ans = 0;
    for (int i = 0; i < m; i++) {
        get(z, i);
        ans += val[i][2 * n - 2];
    }
    return ans;
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> s;
    if (n > 2) {
        assert(0);
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];
            a[i][j]--;
            b[i][j]--;
        }
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            cin >> x[i][j];
            cnt[x[i][j]].push_back(i);
        }
    }
    if (n == 1) {
        vector < int > now;
        now.push_back(0);
        int ans = get_all(now);
        now.pop_back();
        for (int i = 1; i <= m; i++) {
            int k = cnt[i - 1][0];
            ans -= val[k][2 * n - 2];
            now.push_back(i);
            get(now, k);
            ans += val[k][2 * n - 2];
            if (ans == s) {
                cout << i;
                return 0;
            }
            now.pop_back();
        }
        cout << 0;
        return 0;
    }
    vector < int > now;
    for (int i = 0; i <= m; i++) {
        now.clear();
        now.push_back(i);
        now.push_back(0);
        ans = get_all(now);
        now.pop_back();
        if (ans  == s) {
            cout << i << " " << 0;
            return 0;
        }
        for (int j = 1; j <= m; j++) {
            int k1 = cnt[j - 1][0];
            int k2 = cnt[j - 1][1];
            ans -= val[k1][2 * n - 2];
            ans -= val[k2][2 * n - 2];
            now.push_back(j);
            get(now, k1);
            get(now, k2);
            ans += val[k1][2 * n - 2];
            ans += val[k2][2 * n - 2];
            now.pop_back();
            if (ans == s) {
                cout << i << " " << j;
                return 0;
            }
        }
    }
    //cout << 0 << " " << 0;
    return 0;
}
