#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define ll long long
#define int long long
const int inf = 1e9;
const int mod = 1e9 + 7;

int n;

void read() {
    cin >> n;
}

void solve() {
    for (int k = 1; k * k < n; ++k) {
        if (n % k == 0) {
            int k2 = n / k;
            if (!((k + k2) & 1)) {
                cout << "Yes\n";
                cout << ((k + k2) >> 1ll) << " " << ((k2 - k) >> 1ll);
                return;
            }
        }
    }
    cout << "No\n";
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}
