#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define ll long long
//#define int long long
#define F first
#define S second
const int inf = 1e9;
const int mod = 1e9 + 7;
const int SZ = 1e5 + 4;
const double EPS = 1e-7;

int n;
double v[14];
double l[14];
int m;
int a[SZ];
int f[SZ];
int q;
pair<double, double> t[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    cin >> m;
    for (int i = 1; i < m; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> f[i];
    }
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> t[i].first >> t[i].second;
    }
}

bool check(double e, double t) {
    double tim = 0;
    for (int i = 0; i < n; ++i) {
        tim += l[i] / (v[i] + e);
    }
    return tim <= t;
}

void solve() {
    for (int i = 0; i < q; ++i) {
        double lo = -1e-5, hi = 2e9;
        while (hi - lo > EPS) {
            double m = lo + (hi - lo) / 2;
            if (check(m, t[i].second - t[i].first)) {
                hi = m;
            } else {
                lo = m;
            }
        }
        int l = -1, r = m;
        while (r - l > 1) {
            int mid = l + (r - l) / 2;
            if (a[mid] >= hi) {
                r = mid;
            }
            else {
                l = mid;
            }
        }
        cout << f[r - 1] << "\n";
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}
