#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define ll long long
//#define int long long
#define F first
#define S second
const int inf = 1e9;
const int mod = 1e9 + 7;
const int SZ = 2e5 + 4;
const double EPS = 1e-5;

int n;
int a[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
}

void solve() {
    map<int, int> x;
    vector<int> r(n, n);
    for (int i = 0; i < n; ++i) {
        if (x.count(a[i])) {
            r[x[a[i]]] = i;
        }
        x[a[i]] = i;
    }
    vector<int> ans(n + 1, 0);
    for (int i = 0; i < n; ++i) {
        for (int l = 1; l <= n; ++l) {
            int lo = max(0, i - l + 1);
            int hi = min(i, r[i] - l);
            ans[l] += max(0, hi - lo + 1);
        }
    }
    for (int l = 1; l <= n; ++l) {
        cout << ans[l] << " ";
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}
