#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <bitset>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define ll long long
//#define int long long
#define F first
#define S second
const int inf = 1e9;
const int mod = 1e9 + 7;
const int SZ = 3e5 + 4;
const double EPS = 1e-5;

int n, m, s;
vector<vector<int>> a;

struct oper {
    int a, b, op;
};
vector<oper> x[SZ];

void read() {
    cin >> m >> n >> s;
    a.resize(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m - 1; ++j) {
            int a, b, op;
            cin >> a >> b >> op;
            --a, --b;
            x[i].push_back({ a, b, op });
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
}

void solve() {
    if (n <= 2 && m <= 10) {
        int pw = 1;
        for (int i = 0; i < m; ++i) {
            pw *= 3;
        }
        for (int p = 0; p < pw; ++p) {
            vector<int> z(m);
            int y = 1;
            for (int i = 0; i < m; ++i) {
                z[i] = p / y % 3;
                y *= 3;
            }
            int ans = 0;
            for (int i = 0; i < n; ++i) {
                vector<bool> t(m);
                for (int j = 0; j < m; ++j) {
                    t[j] = (a[i][j] < z[j]);
                    for (auto& q : x[i]) {
                        t.push_back(q.op == 1 ? t[q.a] && t[q.b] : t[q.a] || t[q.b]);
                    }
                }
                ans += t.back();
            }
            if (ans == s) {
                for (int i = 0; i < m; ++i) {
                    cout << z[i] << " ";
                }
                return;
            }
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}
