#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define ll long long
//#define int long long
#define F first
#define S second
const int inf = 1e9;
const int mod = 1e9 + 7;
const int SZ = 2e5 + 4;
const double EPS = 1e-5;

int n, x;

void read() {
    cin >> n >> x;
}

void solve() {
    int ans = 0;
    for (int a = 2; a < n; ++a) {
        for (int b = (n + a - 1) / a; b < n; ++b) {
            if (a == x || b == x) continue;
            for (int c = a - 1; c > 0; --c) {
                if ((a * b - n + c - 1) / c >= b) break;
                if ((a * b - n) % c == 0) {
                    ++ans;
                }
            }
        }
    }
    cout << ans;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}