#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define ll long long
#define int long long
#define F first
#define S second
const int inf = 1e9;
const int mod = 1e9 + 7;
const int SZ = 2e5 + 4;
const double EPS = 1e-5;

int n;
int a[SZ];
int q;
int b[SZ];
bool z = true;

void read() {
    cin >> n;
    int pw = 1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (pw != a[i]) {
            z = false;
        }
        pw <<= 1ll;
    }
    cin >> q;
    for (int i = 0; i < q; ++i) {
        cin >> b[i];
    }
}

void solve() {
    if (z) {
        for (int i = 0; i < q; ++i) {
            int x = 0;
            ++b[i];
            while (b[i]) {
                ++x;
                b[i] >>= 1ll;
            }
            cout << (1ll << (x - 1)) - 1 << " " << x - 1 << "\n";
        }
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}