#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define ll long long
#define int long long
#define F first
#define S second
const int inf = 1e9;
const int mod = 1e9 + 7;
const int SZ = 5e5 + 4;
const double EPS = 1e-5;

int n;
int a[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    a[n] = 1e18 + 1;
}

void solve() {
    vector<pair<int, int>> ans;
    ans.push_back({ a[1] - 1, a[1] - 1 });
    for (int i = 1; i < n; ++i) {
        ans.push_back({ ans.back().first + (a[i + 1] - ans.back().first) / a[i] * a[i], ans.back().second + (a[i + 1] - ans.back().first) / a[i] });
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int b;
        cin >> b;
        if (b < a[1]) {
            cout << b << " " << b << "\n";
            continue;
        }
        int lo = 0, hi = ans.size();
        while (hi - lo > 1) {
            int m = lo + ((hi - lo) >> 1ll);
            if (ans[m].first <= b) {
                lo = m;
            }
            else {
                hi = m;
            }
        }
        cout << ans[lo].first << " " << ans[lo].second << "\n";
    }
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}