#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#define int long long
#define all(c) c.begin(), c.end()
using namespace std;

void fast_io() {
#ifdef DEBUG
	freopen("in.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

signed main() {
	fast_io();
	int n;
	cin >> n;
	vector<int> ans(n);
	for (int i = 0; i < n; i++) {
		ans[i] = (i + 1) * (n - i);
	}
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<int> event;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if (a[i] == a[j]) {
				event.push_back(j - i);
			}
		}
	}
	sort(all(event));
	int j = 0;
	for (int i = 0; i < n; i++) {
		while (j < event.size() && event[j] <= i) {
			j++;
		}
		ans[i] -= j;
		if (ans[i] <= 0) {
			ans[i] = 1;
		}
	}
	for (int i : ans) {
		cout << i << " ";
	}
	cout << "\n";

	return 0;
}