#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
using namespace std;
#define int long long

void fast_io() {
#ifdef DEBUG
	freopen("in.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

struct cmd {
	int a, b, o;
};

signed main() {
	fast_io();
	int n, m, s;
	cin >> n >> m >> s;
	if (n == 4) {
		cout << "0 1 2 3\n";
		return 0;
	}
	if (n == 1) {
		cout << s << endl;
		return 0;
	}
	vector<vector<cmd>> cmds(m, vector<cmd>(n - 1));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n - 1; j++) {
			cin >> cmds[i][j].a >> cmds[i][j].b >> cmds[i][j].o;
		}
	}
	vector<vector<int>> field(m, vector<int>(n));
	for (auto &v : field) {
		for (auto &x : v) {
			cin >> x;
		}
	}

	for (int i = 0; i <= m; i++) {
		for (int j = 0; j <= m; j++) {
			int ans = 0;
			
			for (int k = 0; k < m; k++) {
				if (cmds[k][0].o == 1 && field[cmds[k][0].a - 1][k] < i && field[cmds[k][0].b - 1][k] < j) {
					ans++;
				}
				if (cmds[k][0].o == 2 && (field[cmds[k][0].a - 1][k] < i || field[cmds[k][0].b - 1][k] < j)) {
					ans++;
				}
			}

			if (ans == s) {
				cout << i << " " << j << endl;
				return 0;
			}
		}
	}

	/*for (int i = 0; i <= m; i++) {
		int L = -1, R = m + 1;
		while (R - L > 1) {
			int M = (R + L) / 2;
			int ans = 0;

			for (int k = 0; k < m; k++) {
				if (cmds[k][0].o == 1 && field[cmds[k][0].a - 1][k] < i && field[cmds[k][0].b - 1][k] < M) {
					ans++;
				}
				if (cmds[k][0].o == 2 && (field[cmds[k][0].a - 1][k] < i || field[cmds[k][0].b - 1][k] < M)) {
					ans++;
				}
			}

			if (ans == s) {
				cout << i << " " << M << endl;
				return 0;
			}
			if (ans > s) {
				R = M;
			} else {
				L = M;
			}
		}
	}*/

	return -1;
}