#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#define int long long
#define all(c) c.begin(), c.end()
using namespace std;

void fast_io() {
#ifdef DEBUG
	freopen("in.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

int n;
vector<int> a;

int get(int n);

signed main() {
	fast_io();
	int n;
	cin >> n;
	
	a.resize(n);
	bool ok = true;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (i != 0 && a[i] != 2 * a[i - 1]) {
			ok = false;
		}
	}
	if (ok) {
		int q;
		cin >> q;
		while (q--) {
			int b;
			cin >> b;
			int i = 0;
			while (i < n && a[i] - 1 <= b) {
				i++;
			}
			if (i != n)  {
				cout << a[i - 1] - 1 << " " << i - 1 << endl;
			} else {
				int ans = a[n - 1] - 1 + ((b - a[n - 1] + 1) / a[n - 1]) * a[n - 1];
				int cnt = n - 1 + (b - a[n - 1] + 1) / a[n - 1];
				cout << ans << " " << cnt << endl;
			}
		}
		return 0;
	}

	int q;
	cin >> q;
	while (q--) {
		int b;
		cin >> b;
		int ans = 0, cnt = 0;
		for (int i = 1; i <= b; i++) {
			int now = get(i);
			if (now > cnt) {
				cnt = now;
				ans = i;
			}
		}
		cout << ans << " " << cnt << endl;
	}
	return 0;
}

int get(int n) {
	int res = 0;
	int i = lower_bound(all(a), n) - a.begin();
	while (i >= 0) {
		while (n - a[i] >= 0) {
			n -= a[i];
			res++;
		}
		i--;
	}
	return res;
}