#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;

int mymax(vector<int> a, int x){
    int maxi = 0;
    for (int i = 0; i <= x; ++i) if (a[maxi] < a[i]) maxi = i;
    return maxi;
}

signed main(){
    int n, q, i, j;
    cin >> n;
    vector<int> a(n);
    for (i = 0; i < n; ++i) cin >> a[i];
    vector<int> dp(a[a.size() - 1] + 1, 1e9);
    dp[0] = 0;
    dp[1] = 1;
    for (i = 2; i < dp.size(); ++i){
        for (j = 0; j < n; ++j){
            if (i - a[j] >= 0) dp[i] = min(dp[i], dp[i - a[j]]) + 1;
        }
    }
    //for (i = 1; i < 501; ++i) cout << "dp[" << i << "] = " << dp[i] << endl;
    cin >> q;
    vector<pair<int, int> > ans;
    for (i = 0; i < q; ++i){
        cin >> j;
        ans.push_back(make_pair(mymax(dp, j), dp[mymax(dp, j)]));
    }
    for (i = 0; i < ans.size(); ++i) cout << ans[i].first << " " << ans[i].second << endl;
}
