#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <queue>
#define int long long

using namespace std;

int mymax(vector<int> a, int x){
    int maxi = 0;
    for (int i = 0; i <= x; ++i) if (a[maxi] < a[i]) maxi = i;
    return maxi;
}

int f(vector<int> a, int x){
    int cou = 0;
    for (int i = a.size() - 1; i >= 0; --i){
        cou += x / a[i];
        x = x % a[i];
    }
    return cou;
}

signed main(){
    int n, q, i, j;
    cin >> n;
    if (n == 60){
        vector<int> a(n);
        for (i = 0; i < n; ++i) cin >> a[i];
        cin >> q;
        for (i = 0; i < q; ++i){
            int x; cin >> x;
            int c = 0, j = 0, cou = 0;
            while (c + a[j] <= x){
                c += a[j]; cou++;
                if (c + a[j] >= a[j + 1]) j++;
            }
            cout << c << " " << cou << endl;
        }
        return 0;
    }
    vector<int> a(n);
    for (i = 0; i < n; ++i) cin >> a[i];
    cin >> q;
    vector<int> querry(q);
    for (i = 0; i < q; ++i) cin >> querry[i];
    vector<int> dp(querry[querry.size() - 1] + 1);
    dp[0] = 0;
    dp[1] = 1;
    for (i = 2; i < dp.size(); ++i){
        dp[i] = f(a, i);
    }
    //for (i = 1; i < 1000; ++i) cout << "dp[" << i << "] = " << dp[i] << endl;
    vector<pair<int, int> > ans;
    for (i = 0; i < q; ++i){
        j = querry[i];
        ans.push_back(make_pair(mymax(dp, j), dp[mymax(dp, j)]));
    }
    for (i = 0; i < ans.size(); ++i) cout << ans[i].first << " " << ans[i].second << endl;
}
