import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class D2 {

    static BufferedReader in;
    static StringTokenizer st;

    private static int nextInt() {
        return Integer.parseInt(st.nextToken());
    }

    static int x[][];
    static int op[];
    static int n, m, s;

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        st = new StringTokenizer(in.readLine());
        n = nextInt();
        m = nextInt();
        s = nextInt();
        int c = 0;
        op = new int[m];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n - 1; j++) {
                st = new StringTokenizer(in.readLine());
                int a = nextInt();
                int b = nextInt();
                int o = nextInt();
                if (o == 2) c++;
                op[i] = o;
            }
        }
        x = new int[n][m];
        for (int i = 0; i < m; i++) {
            st = new StringTokenizer(in.readLine());
            for (int j = 0; j < n; j++) {
                x[j][i] = nextInt();
            }
        }
        if (n == 2) {
            int l = -1;
            int r = m;
            while (l + 1 < r) {
                int g = (l + r) >> 1;
                if (fn(g) >= s) {
                    r = g;
                } else {
                    l = g;
                }
            }
            int ans = r;
            System.out.print(r + " ");
            l = -1;
            r = m;
            while (l + 1 < r) {
                int g = (l + r) >> 1;
                if (fnk(g, ans) >= s) {
                    r = g;
                } else l = g;
            }
            if (fnk(r, ans) == s) System.out.println(r);
        } else if (n == 1) {
            System.out.println(s);
        }
    }

    private static int fnk(int g, int ans) {
        int k = 0;
        for (int i = 0; i < m; i++) {
            if (op[i] == 2) {
                if (x[0][i] < ans || x[1][i] < g) k++;
            } else {
                if (x[1][i] < ans && x[1][i] < g) k++;
            }
        }
        return k;
    }

    private static int fn(int g) {
        int k = 0;
        for (int i = 0; i < m; i++) {
            if (op[i] == 2) {
                k++;
            } else if (x[0][i] < g) {
                k++;
            }
        }
        return k;
    }
}