import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class D3 {
    static BufferedReader in;
    static StringTokenizer st;

    private static int nextInt() {
        return Integer.parseInt(st.nextToken());
    }

    static int x[][];
    static int op[][];
    static int a[][];
    static int b[][];
    static int n, m, s;

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        st = new StringTokenizer(in.readLine());
        n = nextInt();
        m = nextInt();
        s = nextInt();
        int c = 0;
        op = new int[m][n - 1];
        a = new int[m][n - 1];
        b = new int[m][n - 1];
        ans = new int[n];
        color = new int[n];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n - 1; j++) {
                st = new StringTokenizer(in.readLine());
                int ap = nextInt();
                int bp = nextInt();
                int o = nextInt();
                op[i][j] = o;
                a[i][j] = ap - 1;
                b[i][j] = bp - 1;
            }
        }
        x = new int[n][m];
        for (int i = 0; i < m; i++) {
            st = new StringTokenizer(in.readLine());
            for (int j = 0; j < n; j++) {
                x[j][i] = nextInt();
                if(x[j][i]!=i-1)c++;
            }
        }
        if (n == 2) {
            int l = -1;
            int r = m;
            while (l + 1 < r) {
                int g = (l + r) >> 1;
                if (fn(g) >= s) {
                    r = g;
                } else {
                    l = g;
                }
            }
            int ans = r;
            System.out.print(r + " ");
            l = -1;
            r = m;
            while (l + 1 < r) {
                int g = (l + r) >> 1;
                if (fnk(g, ans) >= s) {
                    r = g;
                } else l = g;
            }
            System.out.println(r);
        } else if (n == 1) {
            System.out.println(s);
        } else if (c == 0) {
            for (int i = 0; i < n; i++) {
                System.out.print(s + " ");
            }
        } else {
            dfs(2 * n - 2, 0);
            PrintWriter out = new PrintWriter(System.out);
            for (int i = 0; i < n; i++) {
                out.print(ans[i] + " ");
            }
            out.close();
        }
    }

    static int ans[];
    static int color[];
    static int mn = 1;

    static void dfs(int tk, int c) {
        if (tk < n) {
            ans[tk] = m;
            if (color[c] == 0) {
                ans[tk] = 0;
                if (c == 0) ans[tk] = s;
            }
            color[c] = 1;
            return;
        }
        int at = a[0][tk - n];
        int bt = b[0][tk - n];
        if (op[0][tk - n] == 1) {
            dfs(at, c);
            dfs(bt, c);
        } else {
            dfs(at, c);
            dfs(bt, mn++);
        }
    }

    private static int fnk(int g, int ans) {
        int k = 0;
        for (int i = 0; i < m; i++) {
            if (op[i][0] == 2) {
                if (x[0][i] < ans || x[1][i] < g) k++;
            } else {
                if (x[0][i] < ans && x[1][i] < g) k++;
            }
        }
        return k;
    }

    private static int fn(int g) {
        int k = 0;
        for (int i = 0; i < m; i++) {
            if (op[i][0] == 2) {
                k++;
            } else if (x[0][i] < g) {
                k++;
            }
        }
        return k;
    }
}
