#include "bits/stdc++.h"

#define le(v) ((int)v.size())
#define pb push_back

using namespace std;

struct Q { int a, b, op; };

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n, m, s;
	cin >> n >> m >> s;
	vector<vector<Q>> ops(m, vector<Q>(n - 1));
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n - 1; j++) {
			cin >> ops[i][j].a >> ops[i][j].b >> ops[i][j].op;
			ops[i][j].a--; ops[i][j].b--;
		}
	}
	vector<vector<int>> table(m, vector<int>(n));
	for (int i = 0; i < m; i++)
		for (int j = 0; j < n; j++)
			cin >> table[i][j];
	auto eval = [&table, &ops, n](int i, const vector<int> &z) {
		vector<bool> val(2 * n - 1);
		for (int j = 0; j < n; j++) {
			val[j] = (table[i][j] < z[j]);
		}
		for (int j = 0; j < n - 1; j++) {
			assert(ops[i][j].a < le(val));
			assert(ops[i][j].b < le(val));
			bool A = val[ops[i][j].a];
			bool B = val[ops[i][j].b];
			assert(j + n < le(val));
			if (ops[i][j].op == 1) {
				val[j + n] = (A && B);
			} else {
				val[j + n] = (A || B);
			}
		}
		// for (bool b : val)
		// 	cout << b << " ";
		// cout << endl;
		// cout << val.back() << " ";
		return val.back() ? 1 : 0;
	};
	// cout << eval(0, {0, 1, 2, 3}) << endl;
	// cout << eval(1, {0, 1, 2, 3}) << endl;
	// for (int i = 0; i < m; i++) {
	// 	cout << eval(i, {0, 1, 2, 3});
	// }
	int l = -1;
	int r = m * n;
	while (r - l > 1) {
		int mid = (l + r) / 2;
		int excess = mid;
		vector<int> z;
		for (int i = 0; i < n; i++) {
			z.pb(min(m, excess));
			excess -= z.back();
		}
		int sum = 0;
		for (int i = 0; i < m; i++) {
			sum += eval(i, z);
		}
		if (sum >= s) {
			r = mid;
		} else {
			l = mid;
		}
	}
	int excess = r;
	vector<int> z;
	for (int i = 0; i < n; i++) {
		z.pb(min(m, excess));
		excess -= z.back();
	}
	for (int x : z) {
		cout << x << " ";
	}
}