/*
	things to remember:
		- check for overflow
		- check for array out of bounds errors
		- do something instead of do nothing
		- always test your code
		- do not fall into despair
		- stay calm and focused
		- stepan is not going to make it
*/

#include "bits/stdc++.h"

#define pb push_back
#define mp make_pair
#define mt make_tuple
#define le(v) ((int)v.size())
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

void check_max(ll &x, ll y) {
	if (x < y) x = y;
}

const int N = (1 << 16);

ll T[N * 2 + 1][1 << 3][1 << 3];
int A[N];

bool bad[1 << 3][1 << 3];
bool good[1 << 20];

void update(int i, int tl, int tr) {
	int m = (tr + tl) / 2;
	for (int a = 0; a < (1 << 3); a++)
		for (int b = 0; b < (1 << 3); b++)
			T[i][a][b] = -1e18;
	if (tr - tl >= 6) {
		for (int b = 0; b < (1 << 3); b++)
			for (int c = 0; c < (1 << 3); c++)
				if (!bad[b][c])
					for (int a = 0; a < (1 << 3); a++)
						for (int d = 0; d < (1 << 3); d++)
							T[i][a][d] = max(T[i][a][d],
								T[i + 1][a][b] + T[i + (m - tl) * 2][c][d]);
	} else if (tr - tl >= 3) {
		for (int mask = 0; mask < (1 << (tr - tl)); mask++) {
			if (good[mask]) {
				ll S = 0;
				for (int j = 0; j < tr - tl; j++)
					if ((1 << j) & mask)
						S += A[j + tl];
				check_max(T[i][mask & 7][(mask & (7 << (tr - tl - 3))) >> (tr - tl - 3)], S);
			}
		}
	}
}
void init(int i, int tl, int tr) {
	if (tl + 1 == tr) return;
	int m = (tl + tr) / 2;
	init(i + 1, tl, m);
	init(i + (m - tl) * 2, m, tr);
	update(i, tl, tr);
}
void change(int i, int tl, int tr, int j) {
	if (tl + 1 != tr) {
		int m = (tl + tr) / 2;
		if (j < m) change(i + 1, tl, m, j);
		else change(i + (m - tl) * 2, m, tr, j);
		update(i, tl, tr);
	}
}
int n;
ll calc() {
	ll rez = 0;
	if (n <= 10) {
		for (int mask = 0; mask < (1 << n); mask++) {
			if (good[mask | (mask << n)]) {
				ll S = 0;
				for (int i = 0; i < n; i++) {
					if ((1 << i) & mask) {
						S += A[i];
					}
				}
				rez = max(rez, S);
			}
		}
	} else
	for (int a = 0; a < (1 << 3); a++) {
		for (int b = 0; b < (1 << 3); b++) {
			if (good[b | (a << 3)]) {
				rez = max(rez, T[0][a][b]);
			}
		}
	}
	return rez;
}
signed main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	for (int mask = 0; mask < (1 << 20); mask++) {
		good[mask] = true;
		for (int i = 0; i < 20; i++) {
			if (((1 << i) & mask)
				&& ((1 << (i + 1)) & mask)
				&& ((1 << (i + 2)) & mask)
				&& ((1 << (i + 3)) & mask)) {
				good[mask] = false;
			}
		}
	}
	for (int a = 0; a < (1 << 3); a++)
		for (int b = 0; b < (1 << 3); b++) {
			bad[a][b] = !good[a | (b << 3)];
		}
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> A[i];
	}
	init(0, 0, n);
	cout << calc() << "\n";
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int j, x;
		cin >> j >> x;
		j--;
		A[j] = x;
		change(0, 0, n, j);
		cout << calc() << "\n";
	}
}