#include <bits/stdc++.h>

using namespace std;

#define double long double
#define left left228
#define right right228
#define index index228
#define list list228

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b < a) a = b;
}

int n, m, s;
vector<int> z;
vector< vector<int> > x, val, op, fir, sec;

int get() {
	for (int i = 1; i <= m; ++i) {
		for (int j = 1; j <= n; ++j) {
			if (x[i][j] < z[j]) {
				val[i][j] = 1;
			} else {
				val[i][j] = 0;
			}
		}
	}
	int res = 0;
	for (int row = 1; row <= m; ++row) {
		for (int i = 1; i < n; ++i) {
			if (op[row][i] == 1) {
				val[row][n + i] = val[row][fir[row][i]] & val[row][sec[row][i]];
			} else {
				val[row][n + i] = val[row][fir[row][i]] | val[row][sec[row][i]];
			}
		}
		res += val[row][n * 2 - 1];
	}
	return res;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> s;
	x.resize(m + 1, vector<int> (n + 1));
	val.resize(m + 1, vector<int> (2 * n + 1, 0));
	op.resize(m + 1, vector<int> (n + 1, 0));
	fir.resize(m + 1, vector<int> (n + 1, 0));
	sec.resize(m + 1, vector<int> (n + 1, 0));
	z.resize(n + 1, 0);
	for (int i = 1; i <= m; ++i) {
		for (int j = 1; j < n; ++j) {
			cin >> fir[i][j] >> sec[i][j] >> op[i][j];
		}
	}
	for (int i = 1; i <= m; ++i) {
		for (int j = 1; j <= n; ++j) {
			cin >> x[i][j];
		}
	}
	// for (int ind = 1; ind <= n; ++ind) {
	// 	while (z[ind] < m && get() < s) {
	// 		++z[ind];
	// 	}
	// }
	int l = 0, r = n;
	while (r - l > 1) {
		int mid = (l + r) >> 1;
		for (int ind = 1; ind <= mid; ++ind) {
			z[ind] = m;
		}
		for (int ind = mid + 1; ind <= n; ++ind) {
			z[ind] = 0;
		}
		if (get() <= s) {
			l = mid;
		} else {
			r = mid;
		}
	}
	if (get() == s) {
		for (int i = 1; i <= n; ++i) {
			cout << z[i] << ' ';
		}
		cout << '\n';
		return 0;
	}
	int c = r;
	l = 0, r = m + 1;
	while (r - l > 1) {
		int mid = (l + r) >> 1;
		z[c] = mid;
		if (get() <= s) {
			l = mid;
		} else {
			r = mid;
		}
	}
	z[c] = l;
	for (int i = 1; i <= n; ++i) {
		cout << z[i] << ' ';
	}
	cout << '\n';
	return 0;
}




/*

4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1

*/



