#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#include <bits/stdc++.h>

using namespace std;


#define double long double
#define left left228
#define right right228
#define index index228
#define list list228

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

const int N = 40 * 1000 + 228;
const long long INF = 1e13 + 228;
const int K = 230;

int n, q;
int a[N];
long long dp[1000][4], mx[1000][4];
bool ok[N][4];
vector<int> b[N];

int block_index[N];
int inside_pos[N];
long long value[1000][4][4];
vector< pair<int, int> > goods[1000];

void build(int bi) {
	int sz = (int)b[bi].size();
	goods[bi].clear();
	for (int fir = 0; fir < 4; ++fir) {
		for (int sec = 0; sec < 4; ++sec) {
			value[bi][fir][sec] = -INF;
		}
	}
	long long cur = 0;
	for (int fir = 0; fir < 4; ++fir) {
		cur = 0;
		for (int i = 0; i < fir; ++i) {
			cur += b[bi][i];
		}
		int posl = fir + 1;
		int posr = sz - 1;
		if (posl <= posr) {
			for (int i = posl; i <= posr; ++i) {
				for (int j = 0; j < 4; ++j) {
					dp[i][j] = -INF;
				}
			}
			dp[posl][0] = 0;
			dp[posl][1] = b[bi][posl];
			for (int i = posl; i < posr; ++i) {
				for (int j = 0; j < 4; ++j) {
					uax(dp[i + 1][0], dp[i][j]);
					if (j + 1 <= 3) {
						uax(dp[i + 1][j + 1], dp[i][j] + b[bi][i + 1]);
					}
				}
			}
			for (int j = 0; j < 4; ++j) {
				uax(value[bi][fir][j], cur + dp[posr][j]);
			}
		}
	}
	for (int fir = 0; fir < 4; ++fir) {
		for (int sec = 0; sec < 4; ++sec) {
			if (value[bi][fir][sec] > 0) goods[bi].push_back({fir, sec});
		}
	}
}

int mb = 0;


void solve() {
	long long res = 0;
	for (int fir = 0; fir < 4; ++fir) {
		for (int i = 1; i <= mb; ++i) {
			for (int j = 0; j < 4; ++j) {
				dp[i][j] = 0;
			}
		}
		for (int i = 0; i < 4; ++i) {
			dp[1][i] = value[1][fir][i];
		}
		int x, y;
		for (int i = 1; i < mb; ++i) {
			mx[i][0] = dp[i][0];
			for (int j = 1; j < 4; ++j) {
				mx[i][j] = max(dp[i][j], mx[i][j - 1]);
			}
			for (auto p : goods[i + 1]) {
				x = p.first;
				y = p.second;
				uax(dp[i + 1][y], value[i + 1][x][y] + mx[i][3 - x]);
			}
		}
		for (int y = 0; y <= 3 - fir; ++y) {
			uax(res, dp[mb][y]);
		}
	}
	cout << res << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		b[1 + (i - 1) / K].push_back(a[i]);
		block_index[i] = 1 + (i - 1) / K;
		inside_pos[i] = (int)b[block_index[i]].size() - 1;
		uax(mb, block_index[i]);
	}
	for (int i = 1; i <= mb; ++i) {
		build(i);
	}
	cin >> q;
	solve();
	while(q--) {
		int p, v;
		cin >> p >> v;
		b[block_index[p]][inside_pos[p]] = v;
		build(block_index[p]);
		solve();
	}
	return 0;
}




/*

6
1 2 3 4 5 6
2
6 0
2 5

8
1 2 3 1 3 2 1 4 
0


*/



