#include <bits/stdc++.h>

#define int long long
#define double long double
#define endl '\n'
using namespace std;

struct trio {
    int a;
    int b;
    int op;
};

int chr(vector<trio> &arr, vector<int> &t, int n, int m, vector<int> &kek) {
    vector<bool> val;
    for (int i = 0; i < n; i++) {
        val.push_back(t[i] < kek[i]);
    }
    for (auto &x : arr) {
        if (x.op == 1) {
            val.push_back(val[x.a - 1] && val[x.b - 1]);
        } else {
            val.push_back(val[x.a - 1] || val[x.b - 1]);
        }
    }
    return val.back() ? 1 : 0;
}

bool check(vector<vector<trio>> &arr, vector<vector<int>> &t, int s, int n, int m, vector<int> &kek) {
    int sm = 0;
    for (int i = 0; i < m; i++) {
        sm += chr(arr[i], t[i], n, m, kek);
    }
    return sm == s;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin.tie(nullptr);
    int n, m, s;
    cin >> n >> m >> s;
    vector<vector<trio>> arr(m);
    int a, b, op;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            cin >> a >> b >> op;
            arr[i].push_back({a, b, op});
        }
    }
    vector<vector<int>> t(m, vector<int>(n));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < m; j++) {
            cin >> t[i][j];
        }
    }
    for (int i = 0; i < (int) pow(m + 1, n); i++) {
        vector<int> kek;
        int k = i;
        for (int j = 0; j < n; j++) {
            kek.push_back(k % (m + 1));
            k /= (m + 1);
        }
        if (check(arr, t, s, n, m, kek)) {
            for (auto x : kek) {
                cout << x << " ";
            }
            cout << endl;
            break;
        }
    }
}