#include <iostream>
#include <vector>
#include <unordered_set>

using namespace std;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	vector<int> ans(n);
	for (int i = 0; i < n; ++i)
	{
		unordered_set<int> s;
		for (int len = 1; i + len <= n; ++len)
		{
			s.insert(a[i + len - 1]);
			ans[len - 1] += s.size();
		}
	}

	for (auto x : ans)
		cout << x << " ";

	return 0;
}