#include <algorithm>
#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	vector<int> ans(n);

	vector<int> v;
	set<int> myS;
	for (auto x : a)
		myS.insert(x);
	for (auto x : myS)
		v.push_back(x);

	for (int i = 0; i < n; ++i)
		a[i] = lower_bound(v.begin(), v.end(), a[i]) - v.begin();

	for (int i = 0; i < n; ++i)
	{
		int cnt[5002] = {};
		int c = 0;
		for (int len = 1; i + len <= n; ++len)
		{
			if (cnt[a[i + len - 1]] == 0)
				++c, cnt[a[i + len - 1]] = 1;
			ans[len - 1] += c;
		}
	}

	for (auto x : ans)
		cout << x << " ";

	return 0;
}