#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
using ll = long long;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	ll sumBegin = 0, sumEnd = 0;
	vector<ll> a(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
		sumEnd += a[i];
	}

	ll ind = 0, dif = 2e9;
	for (int i = 0; i < n; ++i)
	{
		sumBegin += a[i];
		sumEnd -= a[i];
		ll curDif = abs(sumBegin - sumEnd);
		if (curDif < dif)
		{
			dif = curDif;
			ind = i;
		}
	}

	cout << ind + 1 << endl;

	return 0;
}