#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	vector<ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	int q = 0;
	cin >> q;

	vector<tuple<ll, ll, ll>> c;
	c.emplace_back(0, 0, 0);

	ll sum = 0, num = 0;
	for (int i = 0; i < n - 1; ++i)
	{
		ll curNum = (a[i + 1] - sum + a[i] - 1) / a[i] - 1;
		num += curNum, sum += curNum * a[i];
		c.emplace_back(sum, num, i + 1);
	}

	ll b = 0;
	for (int i = 0; i < q; ++i)
	{
		cin >> b;
		auto [sum1, num1, ind] = *--lower_bound(c.begin(), c.end(), make_tuple(b, 1e18, 1e18));

		ll plus = (b - sum1) / a[ind];
		ll ansNum = num1 + plus;
		ll ansSum = sum1 + a[ind] * plus;

		cout << ansSum << " " << ansNum << "\n";
	}

	return 0;
}