import random


class network:
    def __init__(self, a=0, b=0, c=0, d=0):
        self.a = a
        self.b = b
        self.c = c
        self.d = d
        self.s = 0

    def __repr__(self):
        return str(self.a) + ' ' + str(self.b) + ' ' + str(self.c) + ' ' + str(self.d)

    def score(self, x_train, y_train):
        self.s = 0
        for i in range(len(x_train)):
            self.s += (x_train[i] ** 3 * self.a + x_train[i] ** 2 * self.b + x_train[i] * self.c + self.d - y_train[i]) ** 2
        return self.s

    def __lt__(self, other):
        return self.s < other.s

    def mutation(self, mx):
        return network(random.uniform(self.a - mx, self.a + mx), random.uniform(self.b - mx, self.b + mx), random.uniform(self.c - mx, self.c + mx), random.uniform(self.d - mx, self.d + mx))


def run_evol(x_train, y_train, mx):
    popul = []
    for x in range(40):
        popul.append(network())
    for i in range(10000):
        for x in popul:
            x.score(x_train, y_train)
        popul.sort()
        for i in range(4, 40):
            popul[i] = popul[i % 4].mutation(1)
    return popul[0]


x_train = [0] * 30
y_train = [0] * 30
for n in range(3, 30):
    x_train[n] = n
    vars = 0
    for a in range(2, n):
        for b in range(2, n):
            for c in range(1, a):
                for d in range(1, b):
                    if a * b - c * d == n:
                        vars += 1
    y_train[n] = vars
print(run_evol(x_train, y_train, 1))