#include <bits/stdc++.h>

using namespace std;

vector<int> pref(string &s)
{
    int n = s.size();
    vector<int> pi(n);
    for (int i = 1; i < n; ++i)
    {
        int j = pi[i - 1];
        while (j > 0 && s[i] != s[j])
        {
            j = pi[j - 1];
        }
        if (s[i] == s[j])
        {
            j++;
        }
        pi[i] = j;
    }
    return pi;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
        b[i] = a[i];
    }
    sort(b.begin(), b.end());
    int cnt = 0;
    map<int, int> s23;
    for (int i = 0; i < n; ++i)
    {
        if (i > 0)
        {
            if (b[i] > b[i - 1])
            {
                cnt++;
            }
        }
        s23[b[i]] = cnt;
    }
    for (int i = 0; i < n; ++i)
    {
        b[i] = s23[a[i]];
    }
    vector<int> result(n);
    for (int i = 1; i <= n; ++i)
    {
        int s = 0;
        vector<int> s2(5001);
        for (int j = 0; j < i; ++j)
        {
            if (s2[b[j]] == 0)
            {
                s++;
            }
            s2[b[j]]++;
        }
        result[i - 1] += s;
        for (int j = i; j < n; ++j)
        {
            s2[b[j - i]]--;
            if (s2[b[j - i]] == 0)
            {
                s--;
            }
            if (s2[b[j]] == 0)
            {
                s++;
            }
            s2[b[j]]++;
            result[i - 1] += s;
        }
    }
    for (int i = 0; i < n; ++i)
    {
        cout << result[i] << ' ';
    }
    return 0;
}
