#include <bits/stdc++.h>

using namespace std;

#define int long long

vector<int> pref(string &s)
{
    int n = s.size();
    vector<int> pi(n);
    for (int i = 1; i < n; ++i)
    {
        int j = pi[i - 1];
        while (j > 0 && s[i] != s[j])
        {
            j = pi[j - 1];
        }
        if (s[i] == s[j])
        {
            j++;
        }
        pi[i] = j;
    }
    return pi;
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> a[i];
    }
    vector<int> res;
    vector<int> cost;
    res.push_back(0);
    cost.push_back(0);
    int cnt = 0;
    int sum = 0;
    for (int i = 0; i < n - 1; ++i)
    {
        int tmpsum = sum;
        cnt += (a[i + 1] - tmpsum) / a[i];
        sum += (a[i + 1] - tmpsum) / a[i] * a[i];
        if ((a[i + 1] - tmpsum) % a[i] == 0)
        {
            cnt--;
            sum -= a[i];
        }
        res.push_back(cnt);
        cost.push_back(sum);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i)
    {
        int b;
        cin >> b;
        int f = upper_bound(cost.begin(), cost.end(), b) - cost.begin();
        f--;
        if (f == 0)
        {
            cout << b << ' ' << b << endl;
            continue;
        }
        if (f == n - 1)
        {
            cout << cost[f] + (b - cost[f]) / a[f] * a[f] << ' ' << res[f] + (b - cost[f]) / a[f] << endl;
            continue;
        }
        cout << cost[f] << ' ' << res[f] << endl;
    }
}
