#include <iostream>
#include <fstream>
#include <sstream>
#include <cmath>
#include <vector>
#include <string>
#include <algorithm>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

struct BMLP
{
    int a;
    int b;
    int op;
};
vector <vector <BMLP> > A;
vector <vector <int> > tab;
bool check = false;
int n, m, s;
bool checker(vector <int> Z)
{
    vector <vector <int> > B = tab;
    int i, j, cou = 0;
    for (i = 0; i < m; i++)
    {
        for (j = 0; j < n; j++)
        {
            B[i][j] = (B[i][j] < Z[j]);
        }
        for (j = 0; j < n - 1; j++)
        {
            if (A[i][j].op == 1)
            {
                B[i].push_back(B[i][A[i][j].a] && B[i][A[i][j].b]);
            }
            else
            {
                B[i].push_back(B[i][A[i][j].a] || B[i][A[i][j].b]);
            }
        }
        cou = cou + B[i][B[i].size() - 1];
    }
    if (cou == s)
        return(true);
    return(false);
}
void gen(vector <int> Z)
{
    if (check)
        return;
    if (Z.size() == n)
    {
        if (checker(Z))
        {
            for (int i = 0; i < Z.size(); i++)
            {
                cout << Z[i] << " ";
            }
            check = true;
        }
        return;
    }
    for (int i = m; i >= 0; i--)
    {
        vector <int> B = Z;
        B.push_back(i);
        gen(B);
    }
    return;
}
bool comp(vector <int> A, vector <int> B)
{
    int max1, max2;
    max1 = max2 = -1e9;
    for (int i = 0; i < A.size(); i++)
    {
        max1 = max(max1, A[i]);
        max2 = max(max2, B[i]);
    }
    return(max1 < max2);
}

int main()
{
    int i, j;
    cin >> n >> m >> s;
    A.resize(m, vector <BMLP> (n - 1));
    vector <int> gr4;
    bool checker2 = true;
    int cou = 0;
    for (i = 0; i < m; i++)
    {
        for (j = 0; j < n - 1; j++)
        {
            cin >> A[i][j].a >> A[i][j].b >> A[i][j].op;
            A[i][j].b--;
            A[i][j].a--;
            if (A[i][j].op == 1)
                cou++;
        }
    }
    tab.resize(m, vector <int> (n));
    for (i = 0; i < m; i++)
    {
        gr4.push_back(i);
        for (j = 0; j < n; j++)
        {
            cin >> tab[i][j];
            if (tab[i][j] != i)
            {
                checker2 = false;
            }
        }
    }
    if (cou == m * (n - 1))
    {
        stable_sort(tab.begin(), tab.end(), comp);
        int maxi = -1e9;
        for (j = 0; j < n; j++)
        {
            maxi = max(maxi, tab[s + 1][j]);
        }
        for (i = 0; i < n; i++)
        {
            cout << maxi << " ";
        }
        return 0;
    }
    /*if (checker2 && cou != m * (n - 1))
    {
        stable_sort(gr4.begin(), gr4.end());
        for (i = 0; i < n; i++)
        {
            cout << gr4[s] << " ";
        }
        return 0;
    }*/
    if (n <= 10 && m <= 4)
    {
        vector <int> TMP;
        gen(TMP);
    }
    else
    {
        for (i = 0; i < n; i++)
        {
            vector <int> Y;
            for (j = 0; j < m; j++)
            {
                Y.push_back(tab[j][i]);
            }
            stable_sort(Y.begin(), Y.end());
            cout << Y[s] << " ";
        }
    }
    return 0;
}
/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1
*/
