#include <bits/stdc++.h>

using namespace std;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int maxn = 200005;
int mas[maxn];
int ans[maxn];
int cur[maxn];
int lef[maxn];

unordered_map <int, int> last;

int tree[4 * maxn];
pair <int, int> tre[4 * maxn];

void add(int l, int r, int tl, int tr, int v, int val) {
    if (l == tl && r == tr) {
        tree[v] += val;
    } else {
        int m = (r + l) / 2;
        if (tr <= m) {
            add(l, m, tl, tr, v * 2, val);
        } else if (tl > m) {
            add(m + 1, r, tl, tr, v * 2 + 1, val);
        } else {
            add(l, m, tl, m, v * 2, val);
            add(m + 1, r, m + 1, tr, v * 2 + 1, val);
        }
    }
}

int get(int l, int r, int v, int pos) {
    if (l == r) {
        return tree[v];
    } else {
        int m = (r + l) / 2;
        if (pos <= m) {
            return tree[v] + get(l, m, v * 2, pos);
        } else {
            return tree[v] + get(m + 1, r, v * 2 + 1, pos);
        }
    }
}

void add_tr(int l, int r, int tl, int tr, int v, int a, int b) {
    if (l == tl && r == tr) {
        tre[v].first += a;
        tre[v].second += b;
    } else {
        int m = (r + l) / 2;
        if (tr <= m) {
            add_tr(l, m, tl, tr, v * 2, a, b);
        } else if (tl > m) {
            add_tr(m + 1, r, tl, tr, v * 2 + 1, a, b);
        } else {
            add_tr(l, m, tl, m, v * 2, a, b);
            add_tr(m + 1, r, m + 1, tr, v * 2 + 1, a + b * (m - tl + 1), b);
        }
    }
}

int get_tr(int l, int r, int v, int pos) {
    if (l == r) {
        return tre[v].first;
    } else {
        int m = (r + l) / 2;
        if (pos <= m) {
            return tre[v].first + tre[v].second * (pos - l) + get_tr(l, m, v * 2, pos);
        } else {
            return tre[v].first + tre[v].second * (pos - l) + get_tr(m + 1, r, v * 2 + 1, pos);
        }
    }
}

signed main() {
    fast();
    int n, a, b, i, j, c, p, k;
    cin >> n;
    for (i = 1; i <= n; i++) {
        cin >> mas[i];
    }
    for (i = 1; i <= n; i++) {
        a = mas[i];
        if (last.find(a) != last.end()) {
            lef[i] = last[a];
        } else {
            lef[i] = 0;
        }
        last[a] = i;
    }
    int kol;
    for (i = 1; i <= n; i++) {
        a = lef[i] + 1;
        b = i;
        c = n;
        p = min(b - a + 1, c - b + 1);
        k = 1;
        j = max(p + 1, c - a + 1 - p + 1);
        if (j <= c - a + 1)
            add_tr(1, n, j, c - a + 1, 1, c - a + 1 - j + 1, -1);
        add_tr(1, n, 1, p, 1, 1, 1);
        if (p + 1 <= c - a + 1 - p) {
            add(1, n, p + 1, c - a + 1 - p, 1, p);
        }
    }
    for (i = 1; i <= n; i++) {
        ans[i] += get(1, n, 1, i);
        ans[i] += get_tr(1, n, 1, i);
    }
    for (i = 1; i <= n; i++) {
        cout << ans[i] << " ";
    }
    return 0;
}
