#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

void sol1(vector<int> &lst){
    int n = lst.size();
    vector<int> ans(n);
    for (int len = 1; len <= n; len++){
        for (int i = 0; i <= n - len; i++){
            set<int> st;
            for (int j = i; j < i + len; j++)
                st.insert(lst[j]);
            ans[len - 1] += st.size();
        }
    }
    for (int el : ans)
        cout << el << " ";
}

void sol2(vector<int> &lst){
    int n = lst.size();

    vector<int> prev(n, -1);
    map<int, int> mp;
    for (int i = 0; i < n; i++){
        if (mp.find(lst[i]) != mp.end())
            prev[i] = mp[lst[i]];
        mp[lst[i]] = i;
    }

    vector<vector<int>> dp(n, vector<int> (n + 1));
    for (int i = 0; i < n; i++)
        dp[i][1] = 1;

    for (int i = 0; i < n - 1; i++)
        for (int len = 1; len <= i + 1; len++){
            dp[i + 1][len + 1] += dp[i][len];
            if (prev[i + 1] <= i - len)
                dp[i + 1][len + 1]++;
        }
    for (int len = 1; len <= n; len++){
        int ans = 0;
        for (int i = len - 1; i < n; i++)
            ans += dp[i][len];
        cout << ans << " ";
    }
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n; cin >> n;
    vector<int> lst(n);
    for (int i = 0; i < n; i++)
        cin >> lst[i];
//    if (n <= 50){
//        sol1(lst);
//        return 0;
//    }
    sol2(lst);
    return 0;
}