#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

void sol2(vector<int> &lst){
    int n = lst.size();

    vector<int> prev(n, -1);
    map<int, int> mp;
    for (int i = 0; i < n; i++){
        if (mp.find(lst[i]) != mp.end())
            prev[i] = mp[lst[i]];
        mp[lst[i]] = i;
    }

    vector<vector<int>> dp(n, vector<int> (n + 1));
    for (int i = 0; i < n; i++)
        dp[i][1] = 1;

    for (int i = 0; i < n - 1; i++)
        for (int len = 1; len <= i + 1; len++){
            dp[i + 1][len + 1] += dp[i][len];
            if (prev[i + 1] <= i - len)
                dp[i + 1][len + 1]++;
        }
    for (int len = 1; len <= n; len++){
        int ans = 0;
        for (int i = len - 1; i < n; i++)
            ans += dp[i][len];
        cout << ans << " ";
    }
}

void sol3(vector<int> &lst){
    int n = lst.size();

    vector<int> prev(n, -1);
    map<int, int> mp;
    for (int i = 0; i < n; i++){
        if (mp.find(lst[i]) != mp.end())
            prev[i] = mp[lst[i]];
        mp[lst[i]] = i;
    }

    vector<int> pref(n + 2);
    for (int i = 0; i < n; i++){
        pref[1]++;
        pref[(i - prev[i]) + 1]--;
    }

    vector<int> fn(n);
    set<int> st;
    for (int i = n - 1; i > 0; i--){
        st.insert(lst[i]);
        fn[n - i] = st.size();
    }

    vector<int> ans(n + 1);
    ans[1] = n;
    for (int i = 1; i < n; i++){
        pref[i + 1] += pref[i];
        ans[i + 1] = ans[i] - fn[i] + pref[i + 1];
    }

    for (int i = 1; i <= n; i++)
        cout << ans[i] << ' ';
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n; cin >> n;
    vector<int> lst(n);
    for (int i = 0; i < n; i++)
        cin >> lst[i];
    if (n <= 5000)
        sol2(lst);
    else
        sol3(lst);
    return 0;
}