#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

struct Node{
    int a, b, op;
};

int check(int a, int b, vector<vector<Node>> &func, vector<vector<int>> &lst){
    int ans = 0;
    for (int i = 0; i < lst.size(); i++){
        if (func[i][0].op == 1 && lst[i][0] < a && lst[i][1] < b)
            ans++;
        else if (func[i][0].op == 2 && (lst[i][0] < a || lst[i][1] < b))
            ans++;
    }
    return ans;
}

void sol1(int n, int m, int need, vector<vector<Node>> &func, vector<vector<int>> &lst){
    if (n == 1){
        vector<int> v(m);
        for (int i = 0; i < m; i++)
            v[i] = lst[i][0];
        sort(v.begin(), v.end());
        v.push_back(m);
        cout << v[need];
        return;
    }
    int a = -1, b = m, c;
    while (b - a > 1){
        c = (a + b) / 2;

        int left = -1, right = m + 1, mid;
        while (right - left > 1){
            mid = (right + left) / 2;
            if (check(c, mid, func, lst) >= need)
                right = mid;
            else
                left = mid;
        }

        if (right == m + 1)
            a = c;
        else if (left == -1 && check(0, right, func, lst) > need)
            b = c;
        else{
            cout << c << " " << mid;
            return;
        }
    }
}

int main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m, need;
    cin >> n >> m >> need;
    vector<vector<Node>> func(m, vector<Node> (n - 1));
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n - 1; j++){
            cin >> func[i][j].a >> func[i][j].b >> func[i][j].op;
            func[i][j].a--;
            func[i][j].b--;
        }
    vector<vector<int>> lst(m, vector<int> (n));
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
            cin >> lst[i][j];
    if (n <= 2){
        sol1(n, m, need, func, lst);
        return 0;
    }
    return 0;
}