#include <bits/stdc++.h>

using namespace std;

#define ll long long

#define ft first
#define sd second
#define pb push_back
#define eb emplace_back

const ll INF = 1e18;

vector<vector<vector<ll>>> dp(4, vector<vector<ll>> (4));

void init(vector<int> &lst){
    int n = lst.size();
    for (int i = 0; i < 4; i++)
        for (int j = 0; j < 4; j++)
            dp[i][j].resize(n);

    for (int st = 0; st < 4; st++){
        for (int i = 1, pos = st; i < n; i++, pos = (pos + 1) % n){
            ll mx = 0;
            for (int j = 0; j < 4; j++)
                mx = max(mx, dp[st][j][i - 1]);
            dp[st][0][i] = mx;

            for (int j = 1; j < 4; j++){
                dp[st][j][i] = dp[st][j - 1][i - 1] + lst[pos];
            }
        }
    }
}

ll get(){
    ll ans = 0;
    for (int i = 0; i < 4; i++)
        for (int j = 0; j < 4; j++)
            ans = max(ans, dp[i][j].back());
    return ans;
}

void change(int indx, int val, vector<int> &lst){
    int n = lst.size();
    for (int st = 0; st < 4; st++){
        for (int i = (indx - st + n) % n + 1, pos = indx; i < n; i++, pos = (pos + 1) % n){
            ll mx = 0;
            for (int j = 0; j < 4; j++)
                mx = max(mx, dp[st][j][i - 1]);
            dp[st][0][i] = mx;

            for (int j = 1; j < 4; j++){
                dp[st][j][i] = dp[st][j - 1][i - 1] + lst[pos];
            }
        }
    }
}

signed main(){
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n; cin >> n;
    vector<int> lst(n);
    for (int i = 0; i < n; i++)
        cin >> lst[i];
    init(lst);
    cout << get() << "\n";
    int q; cin >> q;
    int pos, val;
    for (int i = 0; i < q; i++){
        cin >> pos >> val;
        lst[pos - 1] = val;
        change(pos - 1, val, lst);
        cout << get() << "\n";
    }
    return 0;
}