#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector,inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,sse4a,avx,avx2,bmi,bmi2,abm,mmx,adx,aes,xop")

#include <bits/stdc++.h>

using namespace std;

#define int __int128

const double TIME = CLOCKS_PER_SEC * 0.5;

void output(int x) {
  string s;
  while (x > 0) {
    s.push_back(x % 10 + '0');
    x = x / 10;
  }
  reverse(s.begin(), s.end());
  cout << s;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  auto tic = clock();
  long long n;
  cin >> n;
  if (n == 0) {
    cout << "YES\n1 1";
    return 0;
  }
  for (int a = 1; a * a <= n; ++a) {
    if (clock() - tic >= TIME)
      break;
    if (n % a != 0)
      continue;
    int b = n / a;
    if (b < a)
      continue;
    int x = (a + b) / 2;
    int y = (b - a) / 2;
    if (x < y)
      swap(x, y);
    if (x < 1 || y < 1)
      continue;
    if (x >= (1LL<<62))
      break;
    if ((x + y) * (x - y) == n) {
      cout << "YES\n";
      output(x);
      cout << ' ';
      output(y);
      return 0;
    }
  }
  cout << "NO";
  return 0;
}