//#pragma GCC optimize("Ofast,fast-math,unroll-loops,no-stack-protector,inline")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,sse4a,avx,avx2,bmi,bmi2,abm,mmx,adx,aes,xop")

#include <bits/stdc++.h>

using namespace std;
//#define int long long

struct Instr {
  int a, b, t;
};

struct Line {
  vector<int> arr;
  vector<Instr> instr;

  bool operator<(const Line &oth) const {
    return arr < oth.arr;
  }
};

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int n, m, s;
  cin >> n >> m >> s;
  vector<Line> matr(m);
  for (auto &line : matr) {
    line.arr.resize(n);
    line.instr.resize(n - 1);
    for (auto &el : line.instr) {
      cin >> el.a >> el.b >> el.t;
      el.a--, el.b--, el.t--;
    }
  }
  for (auto &line : matr) {
    for (auto &el : line.arr)
      cin >> el;
  }
  if (n == 1) {
    return cout << s, 0;
  } else if (n == 2) {
    sort(matr.begin(), matr.end());
    vector<int> pref(m);
    pref[0] = matr[0].instr[0].t;
    vector<int> kthor(m, -1);
    vector<int> revand(m, -1);
    vector<int> revor(m, -1);
    int kthorsz = 0;
    pref[0] = matr[0].instr[0].t;
    for (int i = 1; i < m; ++i) {
      pref[i] = pref[i - 1];
      if (matr[i].instr[0].t) {
        pref[i]++;
        kthor[kthorsz++] = i;
        revor[matr[i].arr[1]] = i;
      } else {
        revand[matr[i].arr[1]] = i;
      }
    }
    for (int z0 = 0; z0 <= m; ++z0) {
      int cs = s;
      if (z0 > 0)
        cs = s - pref[z0 - 1];
      if (cs == 0)
        return cout << z0 << ' ' << 0, 0;
      for (int z1 = 1; z1 <= m; ++z1) {
        if (revand[z1 - 1] != -1 && revand[z1 - 1] < z0)
          cs--;
        if (revand[z1 - 1] == -1 && revor[z1 - 1] >= z0)
          cs--;
        if (cs == 0)
          return cout << z0 << ' ' << z1, 0;
      }
    }
    assert(false);
  }

  return 0;
}

