#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroint-loops,no-stack-protector,inline")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,sse4a,avx,avx2,bmi,bmi2,abm,mmx,adx,aes,xop"
#endif

#include <bits/stdc++.h>

using namespace std;

#define int __int128

typedef long long ll;

const int MAXN = 200000;
int arr[MAXN];
int n;

int zhadnik(int b) {
  int cnt = 0;
  for (int i = n - 1; i >= 0; --i) {
    if (b < arr[i])
      continue;
    cnt += b / arr[i];
    b %= arr[i];
    if (b == 0)
      break;
  }
  return cnt;
}

int input() {
  ll x;
  cin >> x;
  return x;
}

void output(int x) {
  if (x == 0) {
    cout << 0;
    return;
  }
  string s;
  while (x > 0) {
    s.push_back(x % 10 + '0');
    x /= 10;
  }
  reverse(s.begin(), s.end());
  cout << s;
}

void output(int a, int b) {
  output(a);
  cout << ' ';
  output(b);
  cout << '\n';
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  n = input();
  for (int i = 0; i < n; ++ i) {
    arr[i] = input();
  }
  int Q = input();
  int q = Q;
  while (q--) {
    int sb = input();
    if (sb <= 500) {
      int mxsum = 0;
      int mxb = 0;
      for (int b = 1; b <= sb; ++b) {
        int nans = zhadnik(b);
        if (nans > mxsum) {
          mxsum = nans;
          mxb = b;
        }
      }
      output(mxb, mxsum);
      continue;
    }
    int b = sb;
    int cnt = 0;
    int mxans = 0;
    int mxb = 0;
    for (int i = n - 1; i >= 0; --i) {
      if (b < arr[i])
        continue;
      cnt += b / arr[i];
      b %= arr[i];
      int nans = zhadnik(sb - b - 1);
      if (nans > mxans) {
        mxans = nans;
        mxb = sb - b - 1;
      }
      if (b == 0)
        break;
    }
    if (cnt > mxans) {
      mxans = cnt;
      mxb = sb;
    }
    output(mxb, mxans);
  }
  return 0;
}
