// Task131.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//
#pragma GCC optimize("Ofast")
#include <iostream>
#include <cmath>
using namespace std;

int count_sum(int * used, int len, int * colors) {
    int OK = 1;
    for (int k = 0; k < len; k++)
    {
        int idx1 = k;
        int idx2 = (k + 1) % len;
        int idx3 = (k + 2) % len;
        int idx4 = (k + 3) % len;
        if (used[idx1] && used[idx2] && used[idx3] && used[idx4]) {
            //cout << k << " " << j << endl;
            OK = 0;
            break;
        }
    }
    if (OK == 0) {
        return 0;
    }
    else
    {
        int res = 0;
        for (int i = 0; i < len; i++)
        {
            if (used[i]) {
                res += colors[i];
            }
        }
        return(res);
    }
   
}



int main()
{
    int n;
    cin >> n;
    if(n <= 10){
        int* a = new int[n];

        int q;


        for (int i = 0; i < n; i++)
        {
            cin >> a[i];
        }

        cin >> q;
        q++;
        int* p = new int[q];
        int* v = new int[q];
        p[0] = 1;
        v[0] = a[0];
        for (int i = 1; i < q; i++)
        {
            cin >> p[i];
            cin >> v[i];
        }

        for (int i = 0; i < q; i++)
        {
            a[p[i] - 1] = v[i];
            long long max_res = -1;

            for (int j = 0; j < pow(2, n); j++)
            {
                int val = j;
                int* used = new int[n];
                for (int i = 0; i < n; i++)
                {
                    used[i] = (int)(val >= pow(2, n - i - 1));
                    if (used[i]) {
                        val -= pow(2, n - i - 1);
                    }
                    //cout << used[i] << " ";
                }
                //cout << endl;
                long long res = count_sum(used, n, a);
                if (res > max_res) {
                    max_res = res;
                }
            }
            cout << max_res << endl;
        }

    }
    else
    {
        int* a = new int[n];

        int q;


        for (int i = 0; i < n; i++)
        {
            cin >> a[i];
        }

        cin >> q;
        q++;
        int* p = new int[q];
        int* v = new int[q];
        p[0] = 1;
        v[0] = a[0];
        for (int i = 1; i < q; i++)
        {
            cin >> p[i];
            cin >> v[i];
        }

        for (int i = 0; i < q; i++)
        {
            a[p[i] - 1] = v[i];
            int* sorted_a = new int[n];
            int* used_a = new int[n];
            int* copy_a = new int[n];
            for (int j = 0; j < n; j++)
            {
                copy_a[j] = a[j];
                used_a[j] = 0;
            }
            for (int j = 0; j < n; j++)
            {
                int max_v = -1;
                int max_idx = -1;
                for (int k = 0; k < n; k++)
                {
                    if (copy_a[k] > max_v) {
                        max_v = copy_a[k];
                        max_idx = k;
                    }
                }
                sorted_a[j] = max_idx;
                copy_a[max_idx] = -2;
            }

            for (int j = 0; j < n; j++)
            {
                used_a[sorted_a[j]] = true;

                if ((used_a[(sorted_a[j] - 2 + n) % n] && used_a[(sorted_a[j] - 3 + n) % n] && used_a[(sorted_a[j] + 2 + n) % n] && used_a[(sorted_a[j] + 3 + n) % n])) {
                    if (a[(sorted_a[j] - 1 + n) % n] + a[(sorted_a[j] + 1 + n) % n] > a[sorted_a[j]]) {
                        used_a[sorted_a[j]] = false;
                        continue;
                    }
                }
                bool OK = 1;
                for (int k = 0; k < n; k++)
                {
                    int idx1 = k;
                    int idx2 = (k + 1) % n;
                    int idx3 = (k + 2) % n;
                    int idx4 = (k + 3) % n;
                    if (used_a[idx1] && used_a[idx2] && used_a[idx3] && used_a[idx4]) {
                        //cout << k << " " << j << endl;
                        OK = 0;
                        break;
                    }
                }
                used_a[sorted_a[j]] = OK;
            }

            for (int j = 0; j < n; j++)
            {
                // cout << used_a[j] << " ";
            }
            //cout << endl;
            for (int j = 0; j < n; j++)
            {
                // cout << sorted_a[j] << " ";
            }
            // cout << endl;
            int res = 0;
            for (int j = 0; j < n; j++)
            {
                if (used_a[j]) {
                    res += a[j];
                }
            }
            cout << res << endl;
        }
    }
}

