#include <bits/stdc++.h>
// #pragma GCC optimize("O3")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC optimize("fast-math")

using namespace std;

void solve();

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

signed main() {

	// fast();

	#ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif

	solve();
}

vector <int> ans;
vector <int> lef_in;
vector <int> rig_in;

int cnt = 0;
int n;

void add(int pos, int d) {

	if (pos - d >= lef_in[pos])
		cnt = n - pos;
	else 
		cnt = 0;
}

void add1(int pos, int d) {

	if (max(pos - d + 1, 0) > lef_in[pos])
		cnt++;
}

void del(int pos, int d) {

	if (rig_in[pos] >= pos + d)
		cnt = -(n - d - pos);
	else 
		cnt = 0;
}

void solve() {
	
	cin >> n;

	ans.resize(n);
	lef_in.resize(n);
	rig_in.resize(n);

	for (auto &d: ans)
		cin >> d;

	map <int, vector <int>> kek;

	for (int i = 0; i < n; ++i) 
		kek[ans[i]].push_back(i);

	for (auto &d: kek) {
		int x = d.first;
		vector <int> y = d.second;
		lef_in[y[0]] = -1;
		rig_in[y.back()] = n + 1;
		for (int i = 0; i < y.size(); ++i) {
			if (i) 
				lef_in[y[i]] = y[i - 1];

			if (i + 1 < y.size()) 
				rig_in[y[i]] = y[i + 1];			
		} 
	}

	vector <pair<int, int>> fir;

	for (int pos = 0; pos < n; ++pos) 
		fir.push_back({rig_in[pos] - pos, n - pos});

	sort(fir.begin(), fir.end());

	vector <int> pref_sum(n);

	pref_sum[0] = fir[0].second;

	for (int i = 1; i < n; ++i) 
		pref_sum[i] = pref_sum[i - 1] + fir[i].second;

	vector <int> otv(n + 1);

	for (int i = 0; i < n; ++i) 
		cout << fir[i].first << " " << fir[i].second << endl;

	for (int k = 1; k <= n; ++k) {

		cnt = 0;
		for (int i = 0; i < k; ++i)
			add1(i, k);

		otv[k] = cnt * (n - k + 1);
		pair <int, int> flex = {k, -1};

		int j = lower_bound(fir.begin(), fir.end(), flex) - fir.begin();

		// int t = otv[k];

		// if (j != n) {
		// 	if (j == 0) 
		// 		otv[k] -= pref_sum[n - 1] - (n - j) * k;
		// 	else 
		// 		otv[k] -= pref_sum[n - 1] - pref_sum[n - 1 - j] - (n - j) * k;
		// }

		// cout << otv[k] - t << endl;

		for (int i = j; i < n; ++i) 
			if (n - fir[i].second + k < n)
				otv[k] -= fir[i].second - k;

		for (int i = k; i < n; ++i) {

			add(i, k);
			otv[k] += cnt;
		}
	}

	for (int i = 1; i <= n; ++i) 
		cout << otv[i] << " ";
}