#include <bits/stdc++.h>
// #define int long long
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("O3")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unswitch-loops")
#pragma GCC target("avx", "sse", "sse2", "sse4", "avx2")

using namespace std;

void solve();

void fast() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}	

signed main() {

	fast();

	#ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif

	solve();
}

vector <long long> ans;

int cnt_way(int b) {

	int cnt = 0;

	while (b) {
		int j = upper_bound(ans.begin(), ans.end(), b) - ans.begin();
		
		j--;

		cnt += b / ans[j];
		b %= ans[j];
	}

	return cnt;
}

void solve() {

	int n;
	cin >> n;

	ans.resize(n);

	for (auto &d: ans) 
		cin >> d;

	bool flag = true;

	for (int i = 1; i < ans.size(); ++i) {
		if (ans[i] != ans[i - 1] * 2) {
			flag = false;
			break;			
		} 
	}

	if (flag && n == 60) {
		int q;
		cin >> q;

		for (int u = 0; u < q; ++u) {
			long long b;
			cin >> b;

			long long i = 0;
			long long step = 1;

			while (step <= b + 1) {
				step *= 2;
				i++;
			}

			i--;
			step /= 2;

			cout << step - 1 << " " << i << endl; 
		}

		return;
	}


	int q;
	cin >> q;

	long long mx = 0;
	long long pos = 0;

	for (int u = 0; u < q; ++u) {
		long long b;
		cin >> b;

		for (long long i = b; i >= max(1ll, b - 100000); --i) {
			int cnt = cnt_way(i);
			if (mx < cnt) {
				mx = cnt;
				pos = i;
			}

		}

		cout << pos << " " << mx << endl;
	}
}