#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

#define int long long int

using namespace std;

int n, m;
vector<int> v, lens, a, f;
double Tcrit = 0;

bool check(double mid, double T){
    double t = 0;
    for(int i = 0; i < n; i++){
        t += (double)(lens[i]) / ((double)(v[i]) + mid);
    }
    return t <= T;
}

signed main() {
    cin >> n;
    v.resize(n);
    lens.resize(n);
    for(int i = 0; i < n; i++)cin >> v[i];
    for(int i = 0; i < n; i++){
        cin >> lens[i];
        Tcrit += (double)(lens[i]) / v[i];
    }
    cin >> m;
    a.resize(m, 0);
    f.resize(m);
    for(int i = 1; i < m; i++)cin >> a[i];
    for(int i = 0; i < m; i++)cin >> f[i];
    int q; cin >> q;
    for(int i = 0; i < q; i++){
        int s, t; cin >> s >> t;
        double T = (double)(t) - s;
        double l = 0, r = 1e10;
        if(T >= Tcrit){
            cout << 0 << "\n";
            continue;
        }
        for(int j = 0; j < 100; j++){
            double mid = (l + r) / 2;
            if(check(mid, T))r = mid;
            else l = mid;
        }
        auto it = (upper_bound(a.begin(), a.end(), r) - a.begin() - 1);
        assert(it >= 0 && it < m);
        cout << f[it] << "\n";
    }
    return 0;
}