#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <set>
#include <unordered_set>

using namespace std;

const int maxN = 5005;
int n;
int a[maxN];
int dp[maxN][maxN];
int cnt[maxN];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    vector<int> coords(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
        coords[i] = a[i];
    }
    sort(coords.begin(), coords.end());
    coords.erase(unique(coords.begin(), coords.end()), coords.end());
    for(int i = 0; i < n; i++)a[i] = (lower_bound(coords.begin(), coords.end(), a[i]) - coords.begin());
    for(int i = 0; i < n; i++) {
        for (int j = 0; j < maxN; j++)cnt[j] = 0;
        int ans = 0;
        for (int j = i; j < n; j++) {
            cnt[a[j]]++;
            if (cnt[a[j]] == 1)ans++;
            dp[i][j] = ans;
        }
    }
    for (int d = 1; d <= n; d++) {
        int summ = 0;
        for (int i = 0; i <= n - d; i++) {
            summ += dp[i][i + d - 1];
        }
        cout << summ << " ";
    }
    return 0;
}