#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <set>
#include <unordered_set>
#include <unordered_map>

#define int long long int

using namespace std;

const int maxN = 5005;
const int maxN2 = 2e5 + 10;
int n;
int a[maxN2];
int dp[maxN][maxN];
int cnt[maxN];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    vector<int> coords(n);
    for(int i = 0; i < n; i++){
        cin >> a[i];
        coords[i] = a[i];
    }
    sort(coords.begin(), coords.end());
    coords.erase(unique(coords.begin(), coords.end()), coords.end());
    for(int i = 0; i < n; i++)a[i] = (lower_bound(coords.begin(), coords.end(), a[i]) - coords.begin());
    if(n <= 5000) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < maxN; j++)cnt[j] = 0;
            int ans = 0;
            for (int j = i; j < n; j++) {
                cnt[a[j]]++;
                if (cnt[a[j]] == 1)ans++;
                dp[i][j] = ans;
            }
        }
        for (int d = 1; d <= n; d++) {
            int summ = 0;
            for (int i = 0; i <= n - d; i++) {
                summ += dp[i][i + d - 1];
            }
            cout << summ << " ";
        }
    }else{
        unordered_map<int, vector<int>> ind;
        for(int i = 0; i < n; i++){
            if(ind[a[i]].empty())ind[a[i]].push_back(-1);
            ind[a[i]].push_back(i);
        }
        vector<int> d(n + 2, 0);
        for(auto i : ind){
            for(int j = 1; j < i.second.size(); j++){
                int start = i.second[j - 1] + 1;
                for(int k = start; k <= i.second[j]; k++){
                    d[i.second[j] - k + 1]++;
                    d[n - k + 2]--;
                }
            }
        }
        int now = 0;
        for(int i = 1; i <= n; i++) {
            now += d[i];
            cout << now << " ";
        }
    }
    return 0;
}