#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>
#include <set>
#include <unordered_set>
#include <unordered_map>

using namespace std;

int n, m, s;

struct node{
    int a, b, op;
    node(int a = 0, int b = 0, int op = 0){
        this->a = a;
        this->b = b;
        this->op = op;
    }
};

struct prog{
    node p[10];
};

prog pr[3005];
bool mp[3005][3005];

bool checkPr(int i){
    vector<bool> val(2 * n);
    for(int j = 0; j < n; j++)val[j] = mp[i][j];
    for(int j = 0; j < n - 1; j++){
        if(pr[i].p[j].op == 1)val[n + j] = val[pr[i].p[j].a] & val[pr[i].p[j].b];
        if(pr[i].p[j].op == 2)val[n + j] = val[pr[i].p[j].a] | val[pr[i].p[j].b];
    }
    return val[2 * n - 2];
}

bool check(){
    int ans = 0;
    for(int i = 0; i < m; i++)ans += checkPr(i);
    return ans == s;
}

int a[3005][3005];


signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> s;
    for(int i = 0; i < m; i++){
        for(int j = 1; j < n; j++){
            int x, y, op; cin >> x >> y >> op; x--; y--;
            pr[i].p[j - 1].a = x;
            pr[i].p[j - 1].b = y;
            pr[i].p[j - 1].op = op;
        }
    }
    for(int i = 0; i < m; i++){
        for(int j = 0; j < n; j++)cin >> a[i][j];
    }
    if(n == 1){
        for(int z1 = 0; z1 <= m; z1++){
            for(int i = 0; i < m; i++)mp[i][0] = (bool)(a[i][0] < z1);
            if(check()){
                cout << z1 << "\n";
                return 0;
            }
        }
    }else{
        for(int z1 = 0; z1 <= m; z1++){
            for(int z2 = 0; z2 <= m; z2++) {
                for(int i = 0; i < m; i++){
                    mp[i][0] = (bool)(a[i][0] < z1);
                    mp[i][1] = (bool)(a[i][1] < z2);
                }
                if (check()) {
                    cout << z1 << " " << z2 << "\n";
                    return 0;
                }
            }
        }
    }
    return 0;
}