#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pii pair<int, int>
#define ft first
#define sd second
//#define int long long

struct opp {
	int a, b;
	bool op;
	opp() {};
	opp(int a_, int b_, bool op_) {
		a = a_;
		b = b_;
		op = op_;
	}
};


int n, m, s;

vector<vector<opp>> progs;
vector<vector<int>> x;
vector<vector<int>> rev; // rev[i][j]   i -      j

inline int checkfull(int z) { //s,  z0, z1, .. zz = m, z(z + 1), .. = 0 // O(n * m)
	try {
		int curs = 0;
		for (int i = 0; i < m; i++) {
			vector<int> val(n - 1);
			for (int j = 0; j < n - 1; j++)
				if (progs[i][j].op) //or
					val[j] = (progs[i][j].a < n ? progs[i][j].a < z : val[progs[i][j].a - n]) || (progs[i][j].b < n ? progs[i][j].b < z : val[progs[i][j].b - n]);
				else
					val[j] = (progs[i][j].a < n ? progs[i][j].a < z : val[progs[i][j].a - n]) && (progs[i][j].b < n ? progs[i][j].b < z : val[progs[i][j].b - n]);
			if (val[n - 2])
				curs++;
		}
		return curs;
	}
	catch (exception e) {
		while (true);
	}
}

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);

	cin >> n >> m >> s;
	progs.resize(m, vector<opp>(n - 1));
	x.resize(m, vector<int>(n));
	rev.resize(n, vector<int>(m));
	for (int i = 0; i < m; i++)
		for (int j = 0; j < n - 1; j++) {
			int op;
			cin >> progs[i][j].a >> progs[i][j].b >> op;
			progs[i][j].a--;
			progs[i][j].b--;
			progs[i][j].op = op - 1;
		}
	for (int i = 0; i < m; i++)
		for (int j = 0; j < n; j++) {
			cin >> x[i][j];
			rev[j][x[i][j]] = i;
		}
	if (n == 1)
		cout << s;
	else {
		// c z,  checkfull(z) <= s
		int l = 0, r = m + 1;
		int lastcheckfull_l = -1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			int cur = checkfull(m);
			if (cur > s)
				r = m;
			else
				l = m;
		}
		int curs = 0;
		vector<vector<bool>> val(m, vector<bool>(n - 1));
		vector<int> z(n);
		for (int i = 0; i < l; i++)
			z[i] = m;
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n - 1; j++)
				if (progs[i][j].op) //or
					val[i][j] = (progs[i][j].a < n ? progs[i][j].a < l : val[i][progs[i][j].a - n]) || (progs[i][j].b < n ? progs[i][j].b < l : val[i][progs[i][j].b - n]);
				else
					val[i][j] = (progs[i][j].a < n ? progs[i][j].a < l : val[i][progs[i][j].a - n]) && (progs[i][j].b < n ? progs[i][j].b < l : val[i][progs[i][j].b - n]);
			if (val[i][n - 2])
				curs++;
		}
		while (curs < s) {
			int st = rev[l][z[l]];
			z[l]++;
			if (!val[st][n - 2]) {
				for (int j = 0; j < n - 1; j++)
					if (progs[st][j].op) //or
						val[st][j] = (progs[st][j].a < n ? x[st][progs[st][j].a] < z[progs[st][j].a] : val[st][progs[st][j].a - n]) || (progs[st][j].b < n ? x[st][progs[st][j].b] < z[progs[st][j].b] : val[st][progs[st][j].b - n]);
					else
						val[st][j] = (progs[st][j].a < n ? x[st][progs[st][j].a] < z[progs[st][j].a] : val[st][progs[st][j].a - n]) && (progs[st][j].b < n ? x[st][progs[st][j].b] < z[progs[st][j].b] : val[st][progs[st][j].b - n]);
				if (val[st][n - 2])
					curs++;
			}
		}
		for (int i = 0; i < n; i++)
			cout << z[i] << ' ';
		int x = 0;
	}
}
/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1
*/