#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pii pair<int, int>
#define ft first
#define sd second
#define int long long

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<ll> a(n);
	int group = 2;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (n != 60 || a[i] != (1 << i))
			group = 3;
	}
	int q;
	cin >> q;
	if (group == 2) {
		for (int i = 0; i < q; i++) {
			ll b;
			cin >> b;
			int cur = 59;
			while (a[cur] > b + 1)
				cur--;
			cout << (1 << cur) << ' ' << max(1ll, cur) << '\n';
		}
	}
	else if (group == 3) {
		vector<int> maxans(200001);
		vector<int> makeans(200001);
		maxans[1] = 1;
		makeans[1] = 1;
		for (int i = 2; i <= 200000; i++) {
			int b = i;
			int curans = 0;
			while (b != 0) {
				int cur = upper_bound(a.begin(), a.end(), b) - a.begin() - 1;
				curans += b / a[cur];
				b -= (b / a[cur]) * a[cur];
			}
			if (curans > maxans[i - 1]) {
				maxans[i] = curans;
				makeans[i] = i;
			}
			else {
				maxans[i] = maxans[i - 1];
				makeans[i] = makeans[i - 1];
			}
		}
		for (int i = 0; i < q; i++) {
			int b;
			cin >> b;
			cout << makeans[b] << ' ' << maxans[b] << '\n';
		}
	}
}