#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <stack>
#include <queue>
#include <deque>

using namespace std;

#define ll long long
#define ld long double
#define mp make_pair
#define pii pair<int, int>
#define ft first
#define sd second


int n;
vector<ll> a;

vector<ll> dp;
vector<ll> makedp;

pair<ll, ll> countans(int b) {
	if (b == 0)
		return mp(0, 0);
	int i = upper_bound(a.begin(), a.end(), b) - a.begin() - 1;
	int c = b / a[i];
	pair<ll, ll> ans = mp((c - 1) * a[i] + makedp[i], c - 1 + dp[i]);
	auto otherans = countans(b - c * a[i]);
	if (otherans.second + c > ans.second) {
		ans = otherans;
		ans.second += c;
		ans.first += (c) * a[i];
	}
	return ans;
}

int32_t main() {
	cin.tie(NULL);
	cout.tie(NULL);
	ios_base::sync_with_stdio(false);

	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];

	dp.resize(n); // ans if b is equal to a[i] - 1;
	makedp.resize(n);

	dp[0] = 0;
	for (int i = 1; i < n; i++) {
		auto t = countans(a[i] - 1);
		dp[i] = t.second;
		makedp[i] = t.first;
	}
	int q;
	cin >> q;
	for (; q > 0; q--) {
		int b;
		cin >> b;
		auto ans = countans(b);
		cout << ans.ft << ' ' << ans.sd << '\n';
	}
	/*int group = 2;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (n != 60 || a[i] != (1ll << i))
			group = 3;
	}
	int q;
	cin >> q;
	if (group == 2) {
		for (int i = 0; i < q; i++) {
			ll b;
			cin >> b;
			int cur = 59;
			while (a[cur] > b + 1)
				cur--;
			cout << max((1ll << cur) - 1, 1ll) << ' ' << max(1ll, cur) << '\n';
		}
	}
	else if (group == 3) {
		vector<int> maxans(2000001);
		vector<int> makeans(2000001);
		maxans[1] = 1;
		makeans[1] = 1;
		for (int i = 2; i <= 2000000; i++) {
			int b = i;
			int curans = 0;
			while (b != 0) {
				int cur = upper_bound(a.begin(), a.end(), b) - a.begin() - 1;
				curans += b / a[cur];
				b -= (b / a[cur]) * a[cur];
			}
			if (curans > maxans[i - 1]) {
				maxans[i] = curans;
				makeans[i] = i;
			}
			else {
				maxans[i] = maxans[i - 1];
				makeans[i] = makeans[i - 1];
			}
		}
		for (int i = 0; i < q; i++) {
			int b;
			cin >> b;
			cout << makeans[b] << ' ' << maxans[b] << '\n';
		}
	}*/
}