#include<stdio.h>
#include<vector>

using namespace std;

const int INF = 2 * 1000 * 1000 * 1000;

int main()
{
    int n;
    scanf("%d", &n);
    vector<long long> a(1 + n);
    for(int i = 1; i <= n; ++i){
        scanf("%d", &a[i]);
    }
    int q;
    scanf("%d", &q);
    vector<int> b(1 + q);
    int max_el = 0;
    for(int i = 1; i <= q; ++i){
        scanf("%d", &b[i]);
        if(b[i] > max_el){
            max_el = b[i];
        }
    }
    vector<int> dp(1 + max_el, INF);
    dp[0] = 0;
    int k = 1;
    for(int i = 1; i <= max_el; ++i){
        if((k < n) && (i >= a[k+1])){
            ++k;
        }
        dp[i] = dp[i - a[k]] + 1;
    }
    vector<pair<int, int>> pref(1 + max_el);
    pref[0] = {0, 0};
    for(int i = 1; i <= max_el; ++i){
        if(pref[i-1].first < dp[i]){
            pref[i] = {dp[i], i};
        }
        else{
            pref[i] = pref[i-1];
        }
    }
    for(int i = 1; i <= q; ++i){
        printf("%d %d\n", pref[b[i]].second, pref[b[i]].first);
    }
    return 0;
}
