#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool ch(int ind, vector<double> dist, vector<double> velosity, vector<double> add, double begin, double end) {
    double time = 0;
    for(int i = 0; i < dist.size(); i ++) {
        time += dist[i] / (velosity[i] + add[ind]);
    }
    return time <= (end - begin + 1) + 1e-5;
}

int main() {
    int n;
    cin >> n;
    vector<double> velocity(n);
    vector<double> dist(n);
    for(int i = 0; i < n; i ++) {
        cin >> velocity[i];
    }
    for(int i = 0; i < n; i ++) {
        cin >> dist[i];
    }
    int m;
    cin >> m;
    vector<double> add_speed(m, 0);
    for(int i = 0; i < m - 1; i ++) {
        cin >> add_speed[i + 1];
    }
    vector<double> check(m, 0);
    for(int i = 0; i < m; i ++) {
        cin >> check[i];
    }
    int q;
    cin >> q;
    for(int i = 0; i < q; i ++) {
        double s, t;
        cin >> s >> t;
        int l = -1, r = m;
        while(l + 1 < r) {
            int middle = (l + r) / 2;
            if(ch(middle,dist,velocity,add_speed,s,t)) {
                r = middle;
            }
            else {
                l = middle;
            }
        }
        if(l == -1) {
            cout << 0 << endl;
        }
        else {
            cout << check[l] << endl;
        }
    }
    return 0;
}

// Не судите строго, у меня лапки.