#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define int long long

bool ch(int ind, vector<int>& dist, vector<int>& velosity, vector<int>& add, int begin, int end) {
    double time = 0;
    for(int i = 0; i < dist.size(); i ++) {
        time += (double)dist[i] / ((double) velosity[i] + (double) add[ind]);
    }
    return time <= (end - begin) + 1e-5;
}

int32_t main() {
    int n;
    cin >> n;
    vector<int> velocity(n);
    vector<int> dist(n);
    for(int i = 0; i < n; i ++) {
        cin >> velocity[i];
    }
    for(int i = 0; i < n; i ++) {
        cin >> dist[i];
    }
    int m;
    cin >> m;
    vector<int> add_speed(m, 0);
    for(int i = 0; i < m - 1; i ++) {
        cin >> add_speed[i + 1];
    }
    vector<int> check(m, 0);
    for(int i = 0; i < m; i ++) {
        cin >> check[i];
    }
    int q;
    cin >> q;
    for(int i = 0; i < q; i ++) {
        int s, t;
        cin >> s >> t;
        int l = -1, r = m;
        while(l + 1 < r) {
            int middle = (l + r) / 2;
            if(ch(middle,dist,velocity,add_speed,s,t)) {
                r = middle;
            }
            else {
                l = middle;
            }
        }
        if(l == -1) {
            cout << 0 << endl;
        }
        else {
            cout << check[l] << endl;
        }
    }
    return 0;
}

// Не судите строго, у меня лапки.

/*void print(set<int> a, int l, int r) {
    cout << l << ' ' << r << endl;
    for(auto i : a) {
        cout << i << ' ';
    }
    cout << endl;
}

int32_t main() {
    int n;
    cin >> n;
    vector<int> in(n);
    vector<int> ans(n + 1);
    for(int i = 0; i < n; i ++) {
        cin >> in[i];
    }
    int r = 1;
    multiset<int> is_ended;
    set<int> cur;
    bool flag1 = true;
    bool flag2 = false;
    for(int i = 0; i < n; i ++) {
        while(r < n + 1 && flag1) {
            is_ended.insert(in[r - 1]);
            cur.insert(in[r - 1]);
            ans[r - i] += cur.size();
            r++;
        }
        if(flag1) {
            is_ended.erase(is_ended.find(in[i]));
            if (is_ended.find(in[i]) == is_ended.end()) {
                cur.erase(cur.find(in[i]));
            }
            ans[n - i - 1] += cur.size();
        }
        if(flag2) {
            r = n;
        }
        while(r > i && flag2) {
            is_ended.erase(is_ended.find(in[r - 1]));
            if (is_ended.find(in[r - 1]) == is_ended.end()) {
                cur.erase(cur.find(in[r - 1]));
            }
            r--;
            ans[r - i] += cur.size();
        }
        if(flag2) {
            r = i + 2;
        }
        flag1 = !flag1;
        flag2 = !flag2;
    }
    for(int i = 1; i < n + 1; i ++) {
        cout << ans[i] << ' ';
    }
    cout << endl;
    return 0;
}*/