#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        test_cnt = 100;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }

    for (int i = 0; i < test_cnt; ++i) {
        entry(i);

        while (DEV) {
            int ch = fgetc(stdin);
            if (ch == -1) {
                return 0;
            }
            if (!isspace(ch)) {
                ungetc(ch, stdin);
                break;
            }
        }
    }
}

template<typename T>
bool relmax(T &pl, T const val) {
    if (pl < val) {
        pl = val;
        return true;
    }
    return false;
}

template<typename T>
bool relmin(T &pl, T const val) {
    if (pl > val) {
        pl = val;
        return true;
    }
    return false;
}

using ll = long long;

using ld = __float128;

void entry(int test_id) {
    (void) test_id;
    int n;
    cin >> n;
    vector<int> len(n), lim(n);
    for (int &x : lim) { cin >> x; }
    for (int &x : len) { cin >> x; }
    int m;
    cin >> m;
    vector<int> a(m - 1);
    for (int &x : a) { cin >> x; }
    vector<int> f(m);
    for (int &x : f) { cin >> x; }
    int q;
    cin >> q;
    vector<pair<int, int>> qs;
    for (int i = 0; i < q; ++i) {
        int s, t;
        cin >> s >> t;
        qs.emplace_back(t - s, i);
    }
    for (int i = 0; i < q; ++i) {
        bool flg = false;
        for (int j = 0; j < m; ++j) {
            ld time = 0;
            for (int h = 0; h < n; ++h) {
                ld speed = (j > 0 ? a[j-1]: 0) + lim[h];
                ld dt = ld(len[h]) / speed;
                time += dt;
            }
            if (time <= ld(qs[i].first)) {
                cout << (j > 0 ? f[j-1]: 0) << "\n";
                flg = true; break;
            }
        }
        if (!flg) {
            cout << f[m-1] << "\n";
        }
    }
}