#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        test_cnt = 100;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }

    for (int i = 0; i < test_cnt; ++i) {
        entry(i);

        while (DEV) {
            int ch = fgetc(stdin);
            if (ch == -1) {
                return 0;
            }
            if (!isspace(ch)) {
                ungetc(ch, stdin);
                break;
            }
        }
    }
}

template<typename T>
bool relmax(T &pl, T const val) {
    if (pl < val) {
        pl = val;
        return true;
    }
    return false;
}

template<typename T>
bool relmin(T &pl, T const val) {
    if (pl > val) {
        pl = val;
        return true;
    }
    return false;
}

using ll = long long;

using ld = __float128;

void entry(int test_id) {
    (void) test_id;
    int n;
    cin >> n;
    vector<int> a(n);
    for (int& x : a) {cin >> x;}
    vector<int> ans(n);
    map<int, vector<int>> s;
    for (int i = 0; i < n; ++i) {
        s[a[i]].push_back(i);
    }
    vector<int> z(n);
    for (auto const& [j, poss] : s) {
        for (int i : poss) {
            /*for (int d = 1; d <= n; ++d) {
                ans[d-1] += d;
            }*/
            z[0] += 1;
        }
        for (int t = 0; t < poss.size()-1; ++t) {
            int i1 = poss[t];
            int i2 = poss[t+1];
            /*for (int d = (i2-i1+1); d <= n; ++d) {
                ans[d-1] -= i1 - i2 + d;
            }*/
            z[i2-i1] -= 1;
        }
        int i = poss.back();
        /*for (int d = n-i; d <= n; ++d) {
            ans[d-1] -= d - (n-i);
        }*/
        if (i != 0) {
            z[n - i] -= 1;
        }
        i = poss.front();
        /*for (int d = i + 1; d <= n; ++d) {
            ans[d-1] -= d - i - 1;
        }*/
        if (i < n-1) {
            z[i+1] -= 1;
        }
        if (DEV) {
            cout << "after processing " << j <<": ";
            for (int x : ans) {cout << x << " ";}
            cout << "\n";
        }
    }
    for (int i = 0; i < n; ++i) {
        int x = z[i];
        for (int j = i; j < n; ++j) {
            ans[j] += x * (j-i+1);
        }
    }
    for (int x :ans) {
        cout <<x << " ";
    }cout << "\n";
}