#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        test_cnt = 100;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }

    for (int i = 0; i < test_cnt; ++i) {
        entry(i);

        while (DEV) {
            int ch = fgetc(stdin);
            if (ch == -1) {
                return 0;
            }
            if (!isspace(ch)) {
                ungetc(ch, stdin);
                break;
            }
        }
    }
}

template<typename T>
bool relmax(T &pl, T const val) {
    if (pl < val) {
        pl = val;
        return true;
    }
    return false;
}

template<typename T>
bool relmin(T &pl, T const val) {
    if (pl > val) {
        pl = val;
        return true;
    }
    return false;
}

using ll = long long;

using ld = __float128;

struct Op {
    int p1;
    int p2;
    bool kind; // false = AND, true = OR
};

void entry(int test_id) {
    (void) test_id;
    int n, m, s;
    cin >> n  >> m >> s;
    vector<vector<Op>> P(m, vector<Op>(n-1));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n-1; ++j) {
            int a,b,op;
            cin >> a >> b >> op;
            P[i][j].p1 = a-1;
            P[i][j].p2 = b-1;
            P[i][j].kind = (op == 2);
        }
    }
    vector<vector<int>> val(m, vector<int>(2*n-1));
    vector<vector<int>> par(m, vector<int>(2*n-1));
    for (int j = 0; j < m; ++j) {
        for (int i = 0; i < n-1; ++i) {
            par[j][P[j][i].p1] = par[j][P[j][i].p2] = n + i;
        }
    }
    vector<vector<int>> tab(m, vector<int>(n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> tab[i][j];
        }
    }

    vector<int> z(n);

    auto eval = [&](int j, int i) {
        while (i != 2*n-2) {
            int p = par[j][i];
            bool lhs = val[j][P[j][p-n].p1];
            bool rhs = val[j][P[j][p-n].p2];
            bool t;
            if (P[j][p-n].kind) {
                t = lhs || rhs;
            } else {
                t = lhs && rhs;
            }
            if (t != val[j][p]) {
                val[j][p] = t;
                i = p;
            } else {
                break;
            }
        }
        return bool(val[j][2*n-2]);
    };

    int rem = s;

    vector<vector<int>> pos_of(n, vector<int>(m));
    for (int j = 0; j < n; ++j) {
        for (int i = 0; i < m; ++i) {
            pos_of[j][tab[i][j]] = i;
        }
    }

    for (int j = 0; j < n; ++j) {
        while (rem > 0 && z[j] < m) {
            int i;
            /*for (i = 0; i < m; ++i) {
                if (tab[i][j] == z[j]) {
                    break;
                }
            }*/
            i = pos_of[j][z[j]];
            if (DEV) {
                // cout << "touching input of line " << i << "\n";
            }
            bool res1 = val[i][2*n-2];
            ++z[j];
            val[i][j] = 1;
            bool res2 = eval(i, j);
            if (res2 && !res1){
                if (DEV) {
                    cout << "now " << i << " is true\n";
                }
                --rem;
            }
           /* if (DEV) {
                cout << "-----\n";
                //cout << "cur z: ";
                for (int x : z) {cout << x << " ";};
                cout << "\ntrues: ";
                for (int i = 0; i < m; ++i) {
                    if (eval(i)) {cout << i << " ";}
                }
                cout << "\n-----\n";
            }*/
        }
    }

    /*int cnt = 0;
    for (int i = 0; i < m; ++i) {
        if (eval(i)) {++cnt;}
    }*/

    if (DEV) {
        for (auto fn : val) {
            for (auto x : fn) {
                cout << x << " ";
            }
            cout << "\n";
        }
    }

    for (int x : z) {
        cout << x << " ";
    }
    cout << endl;
    // assert(cnt == s);
 }