#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        test_cnt = 100;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }

    for (int i = 0; i < test_cnt; ++i) {
        entry(i);

        while (DEV) {
            int ch = fgetc(stdin);
            if (ch == -1) {
                return 0;
            }
            if (!isspace(ch)) {
                ungetc(ch, stdin);
                break;
            }
        }
    }
}

template<typename T>
bool relmax(T &pl, T const val) {
    if (pl < val) {
        pl = val;
        return true;
    }
    return false;
}

template<typename T>
bool relmin(T &pl, T const val) {
    if (pl > val) {
        pl = val;
        return true;
    }
    return false;
}

using ll = long long;

using ld = __float128;

void entry(int test_id) {
    (void) test_id;
    int n;
    cin >> n;
    int x;
    cin >> x;
    ll ans = 0;

    //vector<vector<bool>> ok(n+1, vector<bool>(n+1));
    vector<vector<pair<int, int>>> mp(n * n + 1);
    for (int a = 1; a <= n; ++a) {
        /*if (a == x) {continue;}
        for (int b = 1; b <= n; ++b) {
            if (b == x) {continue;}
            int t = a * b - n;
            if (t <= 0) {
                continue;
            }
            for (int h = 1; h*h <= t; ++h) {
                if (t % h != 0) {continue;}
                int hh = t/h;
                if (min(h, hh) >= min(a,b)) {continue;}
                if (max(h,hh) >= max(a,b)){ continue;}
                ++ans;
                if (hh != h && max(h, hh) < min(a, b)) {
                    ++ans;
                }
            }
        }*/
        for (int b = 1; b <= n; ++b) {
            mp[a * b].emplace_back(a, b);
        }
    }
    for (int s = 1; s <= n * n; ++s) {
        sort(mp[s].begin(), mp[s].end());
        reverse(mp[s].begin(), mp[s].end());
    }
    for (int s = 1; s + n <= n * n; ++s) {
        auto const &small = mp[s];
        auto const &large = mp[s + n];
        // auto it = remove_if(large.begin(), large.end(), [&](pair<int, int> y) {return x == y.first || x == y.second;});
        //large.resize(it - large.begin());
        //int cnt_drop = 0;
        int p1 = 0;
        int p2 = 0;
        for (auto l : large) {
            if (l.first == x || l.second == x) { continue; }
            /*for (int _i = cnt_drop; _i < small.size(); ++_i) {
                auto t = small[_i];
                if (t.first >= l.first) {
                    ++cnt_drop;
                    continue;
                }
                if (t.second >= l.second) {
                    break;
                }
                if (t.first < l.first && t.second < l.second) {
                    ++ans;
                }
            }*/
            while (/*p1 <= p2 && */p1 < small.size() && small[p1].first >= l.first) {
                ++p1;
            }
            while (p2 < small.size() && /*p1 <= p2 && */small[p2].second < l.second) {
                ++p2;
            }
            ans += p2 - p1;
        }
    }
    cout << ans << "\n";
}