#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#pragma GCC optimize("Ofast")
#endif

#include <bits/stdc++.h>

using namespace std;

void entry(int test_id);

int main() {
    int test_cnt = 1;
    if (DEV) {
        test_cnt = 100;
        freopen("input.txt", "r", stdin);
    } else {
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }

    for (int i = 0; i < test_cnt; ++i) {
        entry(i);

        while (DEV) {
            int ch = fgetc(stdin);
            if (ch == -1) {
                return 0;
            }
            if (!isspace(ch)) {
                ungetc(ch, stdin);
                break;
            }
        }
    }
}

template<typename T>
bool relmax(T &pl, T const val) {
    if (pl < val) {
        pl = val;
        return true;
    }
    return false;
}

template<typename T>
bool relmin(T &pl, T const val) {
    if (pl > val) {
        pl = val;
        return true;
    }
    return false;
}

using ll = long long;

using ld = __float128;

/*const int ALLOC_MEM_SZ = 160 * 1024 * 1024;
char ALLOC_MEM[ALLOC_MEM_SZ];
int ALLOC_POS = ALLOC_MEM_SZ;

void* operator new(size_t n) {
    //void* ret = ALLOC_MEM + ALLOC_POS;
    ALLOC_POS -= n;
    return ALLOC_MEM + ALLOC_POS;
}

void  operator delete (void* p) {
    (void) p;
}*/
int n;

struct Solver {
    vector<ll> a;
    vector<ll> dp[4] = {vector<ll>(n + 1), vector<ll>(n + 1), vector<ll>(n + 1), vector<ll>(n + 1)};
    int off;

    void recount(int pos) {
        pos = max(pos - 4, 0);
        dp[0][0] = 0;
        for (int i = pos; i < n; ++i) {
            ll prev[4] = {dp[0][i + 1], dp[1][i + 1], dp[2][i + 1], dp[3][i + 1]};
            for (int h = 0; h < 4; ++h) {
                dp[h][i + 1] = -1e18;
            }
            for (int h = 0; h < 4; ++h) {
                if (h < 3) {
                    relmax(dp[h + 1][i + 1], dp[h][i] + a[i]);
                }
                relmax(dp[0][i + 1], dp[h][i]);
            }
            // ll next[4] = {dp[_i][0][i+1], dp[_i][1][i+1], dp[_i][2][i+1], dp[_i][3][i+1]};
//if (prev[0] == next[0] && prev[1] == next[1] && prev[2] == next[2] && prev[3] == next[3]) {break;}
        }

    }

    void put(int i, int x) {
        i = (i - off + n) % n;
        a[i] = x;
        recount(i);
    }

    void init() {
        auto b = a;
        for (int i = 0; i < n; ++i) {
            a[i] = b[(i+off)%n];
        }
        recount(0);
    }


    ll get() {
        return dp[0][n];
    }
};

// vector<pair<int, int>> mp[10'000'001];
void entry(int test_id) {
    (void) test_id;
    cin >> n;
    vector<ll> a(n);
    for (ll &x : a) { cin >> x; }
    int q;
    cin >> q;


    Solver solve[4];
    for (int i = 0; i < 4; ++i) {
        solve[i].a = a;
        solve[i].off = i;
        solve[i].init();
    }
    for (int j = 0; j <= q; ++j) {
        if (j > 0) {
            int p, v;
            cin >> p >> v;
            --p;
            for (int i = 0; i < 4; ++i) {
                solve[i].put(p, v);
            }
        }
        ll ans = -1e18;
        for (int i = 0; i < 4; ++i) {
            relmax(ans, solve[i].get());
        }
        cout << ans << "\n";

    }

}