#include <bits/stdc++.h>

using namespace std;

int n, m, tim;
vector<int> v, len, a, f;

int check(int pos) {
    double res_time = 0;
    for (int i = 0; i < n; i++) {
        int can = a[pos] + v[i];
        res_time += (double)len[i] / (double)can;
    }
    return res_time <= tim;
}

void solve() {
    int s, t;
    cin >> s >> t;
    tim = t - s;
    int l = -1, r = m;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (check(mid)) {
            r = mid;
        } else {
            l = mid;
        }
    }
    cout << f[r] << endl;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    v.resize(n);
    len.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> len[i];
    }
    cin >> m;
    a.resize(m + 1);
    a[0] = 0;
    f.resize(m + 1);
    f[0] = 0;
    for (int i = 1; i < m; i++) {
        cin >> a[i];
    }
    for (int i = 1; i <= m; i++) {
        cin >> f[i];
    }
    a.push_back(1e9);

    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        solve();
    }

    return 0;
}
/*


3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
1 100

*/

