#include <bits/stdc++.h>

using namespace std;

#define time time179

const long double eps = 1e-14;

vector<int> a;
vector<int> f;
vector<long double> time;

int get(int x)
{
    if (time.back() + eps >= x) return time.size() - 1;
    if (x >= time[0] - eps) return -1;
    int L = 0;
    int R = time.size() - 1;
    while (R - L > 1)
    {
        int m = L + (R - L) / 2;
        if (time[m] + eps >= x) L = m;
        else R = m;
    }
    return L;
}

int main()
{
    int n;
    cin >> n;
    vector<int> v(n), l(n);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    for (int i = 0; i < n; ++i)
        cin >> l[i];
    int m;
    cin >> m;
    a.resize(m - 1);
    for (int i = 0; i < m - 1; ++i)
        cin >> a[i];
    f.resize(m);
    for (int i = 0; i < m; ++i)
        cin >> f[i];
    int q;
    cin >> q;
    time.resize(m);
    for (int i = 0; i < m; ++i)
    {
        int d = 0;
        if (i > 0) d = a[i - 1];
        for (int j = 0; j < n; ++j)
            time[i] += ((long double) l[j]) / (d + v[j]);
    }
    for (int i = 0; i < q; ++i)
    {
        int s, t;
        cin >> s >> t;
        int res = get(t - s);
        if (res == -1) cout << 0 << endl;
        else cout << f[res] << endl;

    }
}
