#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string>

using namespace std;

struct command {
	int a;
	int b;
	int op;
};

int main() {
	int n, m, s, a, b, op;

	cin >> n >> m >> s;

	vector<vector<command>> row(m);

	vector<vector<int>> table(m, vector<int>(n, -1));
	vector<pair<int, int>> edges(m);

	bool check_group3 = true;
	bool check_group4 = true;

	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n - 1; j++) {
			cin >> a >> b >> op;

			if (op != 1)
				check_group3 = false;

			row[i].push_back(command({ a, b, op }));
		}
	}

	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			cin >> table[i][j];

			if (table[i][j] != i)
				check_group4 = false;
		}
	}

	//solution
	if (check_group4)
		for (int i = 0; i < n; i++) {
			cout << s << " ";
		}
	else if (check_group3) {
		for (int i = 0; i < n - 1; i++) {
			cout << m << " ";
		}
		cout << s;
	}
	else if (n == 1) {
		for (int z_check = 0; z_check < m; z_check++) {
			int count = 0;

			for (int i = 0; i < m; i++) {
				vector<int> val;

				for (int j = 0; j < n; j++) {
					val.push_back(table[i][j] < z_check);
				}
				for (int j = 0; j < n - 1; j++) {
					if (row[i][j].op == 1) {
						val.push_back((table[i][row[i][j].a - 1] < z_check) && (table[i][row[i][j].b - 1] < z_check));
					}
					if (row[i][j].op == 2) {
						val.push_back((table[i][row[i][j].a - 1] < z_check) || (table[i][row[i][j].b - 1] < z_check));
					}
				}

				count += val[2 * n - 2];
			}

			if (count == s) {
				cout << z_check << " ";
				return 0;
			}
		}
	}
	else if (n == 2) {
		vector<int> z_check(2);

		for (z_check[0] = 0; z_check[0] < m; z_check[0]++) {
			for (z_check[1] = 0; z_check[1] < m; z_check[1]++) {
				int count = 0;

				for (int i = 0; i < m; i++) {
					vector<int> val;

					for (int j = 0; j < n; j++) {
						val.push_back(table[i][j] < z_check[j]);
					}

					for (int j = 0; j < n - 1; j++) {
						if (row[i][j].op == 1) {
							val.push_back(val[row[i][j].a - 1] && val[row[i][j].b - 1]);
						}
						if (row[i][j].op == 2) {
							val.push_back(val[row[i][j].a - 1] || val[row[i][j].b - 1]);
						}
					}

					count += val[2 * n - 2];
				}

				if (count == s) {
					for (int i = 0; i < z_check.size(); i++) {
						cout << z_check[i] << " ";
					}

					return 0;
				}
			}
		}
	}
	else if (n == 3) {
		vector<int> z_check(3);

		for (z_check[0] = 0; z_check[0] < m; z_check[0]++) {
			for (z_check[1] = 0; z_check[1] < m; z_check[1]++) {
				for (z_check[2] = 0; z_check[2] < m; z_check[2]++) {
					int count = 0;

					for (int i = 0; i < m; i++) {
						vector<int> val;

						for (int j = 0; j < n; j++) {
							val.push_back(table[i][j] < z_check[j]);
						}

						for (int j = 0; j < n - 1; j++) {
							if (row[i][j].op == 1) {
								val.push_back(val[row[i][j].a - 1] && val[row[i][j].b - 1]);
							}
							if (row[i][j].op == 2) {
								val.push_back(val[row[i][j].a - 1] || val[row[i][j].b - 1]);
							}
						}

						count += val[2 * n - 2];
					}

					if (count == s) {
						for (int i = 0; i < z_check.size(); i++) {
							cout << z_check[i] << " ";
						}

						return 0;
					}
				}
			}
		}
	}
	else if (n == 4) {
		vector<int> z_check(4);

		for (z_check[0] = 0; z_check[0] < m; z_check[0]++) {
			for (z_check[1] = 0; z_check[1] < m; z_check[1]++) {
				for (z_check[2] = 0; z_check[2] < m; z_check[2]++) {
					for (z_check[3] = 0; z_check[3] < m; z_check[3]++) {
						int count = 0;

						for (int i = 0; i < m; i++) {
							vector<int> val;

							for (int j = 0; j < n; j++) {
								val.push_back(table[i][j] < z_check[j]);
							}

							for (int j = 0; j < n - 1; j++) {
								if (row[i][j].op == 1) {
									val.push_back(val[row[i][j].a - 1] && val[row[i][j].b - 1]);
								}
								if (row[i][j].op == 2) {
									val.push_back(val[row[i][j].a - 1] || val[row[i][j].b - 1]);
								}
							}

							count += val[2 * n - 2];
						}

						if (count == s) {
							for (int i = 0; i < z_check.size(); i++) {
								cout << z_check[i] << " ";
							}

							return 0;
						}
					}
				}
			}
		}
	}
}