#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string>
#include <queue>

using namespace std;

vector<vector<int>> dividers;

void FindDividers(int numb) {
	for (int i = 1; i <= sqrt(numb); i++) {
		if (numb % i == 0) {
			dividers[numb].push_back(i);
		}
	}
}

int countGoodDivisers(int numb, int a, int b) {
	int counter = 0;

	for (int i = 0; i < dividers[numb].size(); i++) {
		int firstDiv = dividers[numb][i];
		int secondDiv = numb / dividers[numb][i];

		if (firstDiv < a && secondDiv < b) {
			//cout << "Good four: " << a << " " << b << " " << firstDiv << " " << secondDiv << "\n";
			if (a != b)
				counter += 2;
			else
				counter++;
		}
		if (firstDiv != secondDiv && firstDiv < b && secondDiv < a) {
			//cout << "Good four: " << a << " " << b << " " << secondDiv << " " << firstDiv << "\n";
			if (a != b)
				counter += 2;
			else
				counter++;
		}
	}

	return counter;
}

int main() {
	int n, x;

	cin >> n >> x;

	dividers = vector<vector<int>>(n * n, vector<int>());
	for (int i = 1; i < n * n; i++) {
		FindDividers(i);
	}

	long long ans = 0;

	for (int i = 2; i <= n; i++) {
		for (int j = max(i, (n / i) + 1); j <= n - i + 1; j++) {
			if (i != x && j != x) {
				ans += countGoodDivisers((i * j - n), i, j);
			}
		}
	}

	cout << ans;
}