#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string>
#include <queue>

using namespace std;

vector<int> divPairsCount;

void CountDivPairs(int numb) {
	for (int i = 1; i <= sqrt(numb); i++) {
		if (numb % i == 0 && i != numb / i) {
			divPairsCount[numb] += 2;
		}
		else if (numb % i == 0) {
			divPairsCount[numb] += 1;
		}
	}
}

int CountGoodDivisers(int numb, int a, int b) {
	int counter = 0;

	for (int i = 1; i <= sqrt(numb); i++) {
		if (numb % i == 0) {
			if (i < a && (numb / i) < b) {
				//cout << "Good four: " << a << " " << b << " " << i << " " << numb / i << "\n";
				counter++;
			}
			if (numb / i != i && i < b && (numb / i) < a) {
				//cout << "Good four: " << a << " " << b << " " << numb / i << " " << i << "\n";
				counter++;
			}
		}
	}

	return counter;
}

int main() {
	int n, x;

	cin >> n >> x;

	long long ans = 0;
	divPairsCount = vector<int>(2 * n);

	for (int i = 1; i < 2 * n; i++) {
		CountDivPairs(i);
	}

	if (n > 500 && x == 0) {
		int minPart = 1;

		while (minPart * minPart <= n) {
			minPart++;
		}

		//cout << "MinPart: " << minPart << "\n";

		for (int i = minPart; i < n; i++) {
			int addPart = n % i;

			ans += divPairsCount[addPart] * 2;

			if (addPart + n / i == i) {
				ans--;

				int square_check = (i * (addPart + n / i) - n);
				if (sqrt(square_check) != (int)sqrt(square_check)) {
					ans++;
				}
			}
		}
	}
	else {
		for (int i = 2; i <= n; i++) {
			for (int j = 2; j <= n; j++) {
				if (i != x && j != x) {
					ans += CountGoodDivisers((i * j - n), i, j);
				}
			}
		}
	}

	cout << ans;
}