#include <iostream>
#include <vector>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <algorithm>
using namespace std;
#define int long long
#define double long double
const double EPS = 0.00001;


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int amount;
    cin >> amount;
    double max_time = 0;
    vector< pair< double, double > > route(amount);
    for (int i = 0; i < amount; ++i){
        cin >> route[i].second;
    }
    for (int i = 0; i < amount; ++i){
        cin >> route[i].first;
        max_time += route[i].first / route[i].second;
    }
    int over;
    cin >> over;
    double edge[over - 1];
    for (int i = 0; i < over - 1; ++i){
        cin >> edge[i];
    }
    vector< int > fee(over);
    for (int i = 0; i < over; ++i){
        cin >> fee[i];
    }
    vector< double > t(over);
    for (int i = 0; i < over - 1; ++i){
        t[over - 1 - i] = 0;
        for (int j = 0; j < amount; ++j){
            t[over - 1 - i] += route[j].first / (route[j].second + edge[i]);
        }
    }
    t[0] = 0;
    int req;
    cin >> req;
    for (int z = 0; z < req; ++z){
        double start, stop;
        cin >> start >> stop;
        double time = stop - start;
        if (abs(time - max_time) <= EPS || time > max_time){
            cout << "0\n";
            continue;
        }
        int ans = lower_bound(t.begin(), t.end(), time) - t.begin();
        ans = over - ans;
        cout << fee[ans] << "\n";
    }
    return 0;
}


/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100
 */