#include <iostream>
#include <vector>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <algorithm>
using namespace std;
#define int long long


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int amount;
    cin >> amount;
    int line[amount];
    int id[amount];
    int numb[amount];
    set< int > uniq;
    vector< int > un;
    map< int, int > where;
    int numb_i = 0;
    for (int i = 0; i < amount; ++i) {
        cin >> line[i];
        auto t = uniq.find(line[i]);
        if (t == uniq.end()){
            uniq.insert(line[i]);
            un.push_back(line[i]);
            id[i] = numb_i;
            where[line[i]] = numb_i;
            ++numb_i;
        }else{
            id[i] = where[line[i]];
        }
    }
    vector< int > space[un.size()];
    for (int i = 0; i < amount; ++i){
        space[id[i]].push_back(i);
    }
    for (int i = 0; i < un.size(); ++i){
        for (int j = 0; j < space[i].size() - 1; ++j){
            space[i][j] = space[i][j + 1] - space[i][j] - 1;
        }
        space[i].pop_back();
    }
    int dist[amount];
    for (int i = 0; i < amount; ++i){
        dist[i] = 0;
    }
    for (int i = 0; i < un.size(); ++i){
        for (int j = 0; j < space[i].size(); ++j){
            ++dist[space[i][j]];
        }
    }
    for (int i = 1; i < amount; ++i){
        dist[i] += dist[i - 1];
    }
    for (int d = 1; d <= amount; ++d){
        int ans = d * (amount - d + 1);
        if (d > 1){
            ans -= dist[d - 2];
        }
        cout << ans << ' ';
    }
    return 0;
}