#include <iostream>
#include <vector>
#include <stack>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#define int long long
#define double long double

vector< int > money;


int count(int needed){
    int ans = 0;
    while (needed > 0){
        int i = upper_bound(money.begin(), money.end(), needed) - money.begin();
        --i;
        ans += needed / money[i];
        needed %= money[i];
    }
    return ans;
}


int count_1(int needed){
    while (needed > 0){
        int i = upper_bound(money.begin(), money.end(), needed) - money.begin();
        --i;
        if (money[i] == 1){
            return needed;
        }
        needed %= money[i];
    }
    return 0;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int amount;
    bool ez = true;
    cin >> amount;
    money.resize(amount);
    int current = 1;
    for (int i = 0; i < amount; ++i){
        cin >> money[i];
        if (money[i] != current){
            ez = false;
        }
        current *= 2;
    }
    int req;
    cin >> req;
    for (int z = 0; z < req; ++z){
        int needed;
        cin >> needed;
        int i = upper_bound(money.begin(), money.end(), needed) - money.begin();
        --i;
        int maximum = money[i];
        int number = needed / maximum;
        int a = count(needed);
        int b = count(number * maximum - 1);
        if (a > b){
            cout << needed << ' ' << a << "\n";
        }else{
            cout << number * maximum - 1 << ' ' << b << "\n";
        }
    }
    return 0;
}