#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#define int long long
using namespace std;
#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")

const int INF = 1e18;

bool check(vector<int> v) {
    int cnt = 0;
    for (int i = 0; i < v.size() * 2; ++i) {
        if (v[i % v.size()] == 1) {
            ++cnt;
        } else {
            if (cnt > 3) {
                return false;
            }
            cnt = 0;
        }
    }
    return cnt <= 3;
}

int count(vector<int> v, vector<int> mask) {
    int ans = 0;
    for (int i = 0; i < v.size(); ++i) {
        ans += v[i] * mask[i];
    }
    return ans;
}

int n, ans = 0;
vector<int> v, now, moo;

void gen(int prevprevprev, int prevprev, int prev) {
    if (now.size() == n) {
        if (!check(now)) return;
        if (count(v, now) > ans) {
            moo = now;
        }
        ans = max(ans, count(v, now));

        return;
    }
    now.push_back(0);
    gen(prevprev, prev, 0);
    now.pop_back();
    if (prevprevprev == 1 && prevprev == 1 && prev == 1) {
        return;
    }
    now.push_back(1);
    gen(prevprev, prev, 1);
    now.pop_back();
}

signed main() {
    cin >> n;
    v.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    gen(0, 0, 0);
    cout << ans << endl;
    int q;
    cin >> q;
    ++q;
    while (--q) {
        int ind, val;
        cin >> ind >> val;
        v[ind - 1] = val;
        ans = 0;
        gen(0, 0, 0);
        cout << ans << endl;
    }
}