#include <bits/stdc++.h>

#define f first
#define s second
#define ll long long
#define pii pair<int, int>
#define ld long double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) int(a.size())
#define eb emplace_back
#define output(a) cout << #a << " ! "; for (auto& el : a) cout << el << ' '; cout << endl;
#define sun(a) a.resize(unique(all(a)) - a.begin())

using namespace std;

struct op {
    int a, b, p;

    op() {}
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, s;
    cin >> n >> m >> s;

    if (s == 0) {
        for (int i = 0; i < n; ++i) {
            cout << 0 << ' ';
        }
        return 0;
    }

    vector<vector<op>> a(m, vector<op>(n - 1));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            cin >> a[i][j].a >> a[i][j].b >> a[i][j].p;
            --a[i][j].a;
            --a[i][j].b;
        }
    }

    vector<vector<int>> x(m, vector<int>(n)), px(n, vector<int>(m));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> x[i][j];
            px[j][x[i][j]] = i;
        }
    }

    vector<int> need(m);
    for (int i = 0; i < m; ++i) {
        int l = -1, r = n;
        while (l < r - 1) {
            int md = (l + r) / 2;
            vector<bool> val(2 * n - 1);
            for (int j = 0; j < md; ++j) {
                val[j] = 1;
            }
            for (int j = 0; j < n - 1; ++j) {
                val[j + n] = (a[i][j].p == 1 ? (val[a[i][j].a] & val[a[i][j].b]) :
                                    (val[a[i][j].a] | val[a[i][j].b]));
            }
            if (val.back()) {
                r = md;
            } else {
                l = md;
            }
        }
        need[i] = r;
    }

    vector<int> z(n);
    int i = 0;

    int cur = 0;

    vector<int> cnt(m);

    while (1) {
        if (z[i] == m) {
            ++i;
        }
        ++z[i];
        int t = px[i][z[i] - 1];
        ++cnt[t];
        if (cnt[t] == need[t]) {
            ++cur;
        }
        if (cur == s) {
            for (int el : z) {
                cout << el << ' ';
            }
            return 0;
        }
    }
    return 0;
}
