#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int n;
vector<vector<int>> least;
vector<vector<vector<int>>> g;

bool push(int cv, int r, int x) {
    if (!least[r][cv]) {
        return false;
    }
    least[r][cv] -= x;
    if (!least[r][cv]) {
        for (int nv : g[r][cv]) {
            ll res = push(nv, r, x);
            if (res) {
                return true;
            }
        }
        if (cv == 2 * n - 2) {
            return true;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int m, s;
    cin >> n >> m >> s;
    g.resize(m, vector<vector<int>>(2 * n - 1));
    least.resize(m, vector<int>(2 * n - 1, 1));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            int a, b, op;
            cin >> a >> b >> op;
            g[i][a - 1].push_back(j + n);
            g[i][b - 1].push_back(j + n);
            least[i][j + n] = 3 - op;
        }
    }
    vector<vector<int>> table(m, vector<int>(n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> table[i][j];
        }
    }

    vector<vector<int>> ind(n, vector<int>(m));
    for (int j = 0; j < n; ++j) {
        for (int i = 0; i < m; ++i) {
            ind[j][table[i][j]] = i;
        }
    }

    vector<int> z(n, 0);
    for (int i = 0; i < n && s; ++i) {
        do {
            z[i]++;
            bool res = push(i, ind[i][z[i] - 1], 1);
            if (res) {
                s--;
            }
        } while (z[i] < m && s);
    }
    for (int i : z) {
        cout << i << " ";
    }
    cout << endl;
}
