#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    vector<ll> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }

    int q;
    cin >> q;
    vector<pair<ll, int>> b(q);
    for (int i = 0; i < q; ++i) {
        cin >> b[i].first;
        b[i].second = i;
    }
    sort(b.begin(), b.end());

    ll prev = 0;
    ll prev_cnt = 0;
    int cur_q = 0;
    vector<pair<ll, ll>> ans(q);
    for (int i = 0; i < n; ++i) {
        ll next;
        if (i == n - 1) {
            next = 1e18;
        } else {
            ll k = (v[i + 1] - prev - 1) / v[i];
            next = k * v[i] + prev;
        }

        while (cur_q < q && b[cur_q].first <= next) {
            ll incr = (b[cur_q].first - prev) / v[i];
            ans[b[cur_q].second] = {prev + v[i] * incr, prev_cnt + incr};
            cur_q++;
        }

        if (i < n - 1) {
            prev_cnt += (next - prev) / v[i];
            prev = next;
        }
    }

    for (auto i : ans) {
        cout << i.first << " " << i.second << endl;
    }
}
