#include <iostream>
#include <vector>

using namespace std;

#define int long long

int n;

bool check(int mask){
    int num = (mask << n) + mask;
    for (int i = 0; i < 18; i++){
        if (((num >> i) & 15) == 15){
            return false;
        }
    }
    return true;
}

signed main() {
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int q; cin >> q;
    int ans = -1;
    for (int mask = 0; mask < (1 << n); mask++){
        if (!check(mask)) continue;
        int res = 0;
        for (int i = 0; i < n; i++){
            if ((mask >> i) & 1){
                res += a[i];
            }
        }
        ans = max(ans, res);
    }
    cout << ans << endl;
    for (int i = 0; i < q; i++){
        int p, u; cin >> p >> u;
        a[p - 1] = u;
        ans = -1;
        for (int mask = 0; mask < (1 << n); mask++){
            if (!check(mask)) continue;
            int res = 0;
            for (int i = 0; i < n; i++){
                if ((mask >> i) & 1){
                    res += a[i];
                }
            }
            if (ans < res){
                ans = res;
            }
        }
        cout << ans << endl;
    }
    return 0;
}
