#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#define int long long
#define ll long long
#define pi pair<int, int>
#define pll pair<ll, ll>
#define F first
#define S second

using namespace std;

const int MAXN = 10;
const int MAXM = 100007;
long double v[MAXN], l[MAXN];
int a[MAXN], f[MAXN];
int n, m;

long double EPS = 1e-6;

bool is_good(int e, long double t) {
	long double time = 0;
	for (int i = 0; i < n; ++i) {
		time += (l[i]) / (v[i] + e);
	}
	return EPS <= t - time;
}

int INF = 1000000000000000000;
signed main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> v[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
	}
	cin >> m;
	a[0] = 0;
	for (int i = 0; i < m - 1; ++i) {
		cin >> a[i + 1];
	}
	for (int i = 0; i < m; ++i) {
		cin >> f[i];
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int s, t;
		cin >> s >> t;
		int time = t - s;
		if (is_good(0, time)) {
			cout << "0\n";
			continue;
		}
		int l = 0;
		int r = INF;
		while (r - l > 1) {
			int mid = (r + l) / 2;
			if (is_good(mid, time)) {
				r = mid;
			}
			else {
				l = mid;
			}
		}
		if (m == 1) {
			cout << f[0] << '\n';
			continue;
		}

		auto u = lower_bound(a, a + m - 1, r);
		int k = u - a;
		cout << f[k - 1] << '\n';
	}
	return 0;
}