#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#define int long long
#define ll long long
#define pi pair<int, int>
#define pll pair<ll, ll>
#define F first
#define S second

using namespace std;

const int MAXN = 200007;
int t[4 * MAXN], add[4 * MAXN];
void push(int n) {
	if (2 * n + 2 > MAXN * 2 + 500) {
		t[n] += add[n];
		add[n] = 0;
	}
	t[n] += add[n];
	add[2 * n + 1] += add[n];
	add[2 * n + 2] += add[n];
	add[n] = 0;
}

void add_x(int n, int l, int r, int a, int b, int x) {
	if ((a <= l) && (r <= b)) {
		add[n] += x;
		return;
	}
	if ((a >= r) || (l >= b)) {
		return;
	}
	int m = (l + r) / 2;
	add_x(2 * n + 1, l, m, a, b, x);
	add_x(2 * n + 2, m, r, a, b, x);
}

int n;

map<int, int> mapa;

signed main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	int pow2 = 1;
	while (pow2 < n) {
		pow2 *= 2;
	}
	for (int i = 0; i < n; ++i) {
		int a;
		cin >> a;
		if (mapa[a] == 0) {
			mapa[a] = i + 1;
			continue;
		}
		int l = mapa[a] - 1;
		int r = i;
		add_x(0, 0, pow2, r - l + 1, r - l + 1 + l + 1, 1);
		add_x(0, 0, pow2, r - l + 1, r - l + 1 + n - r - 1 + 1, 1);
		add_x(0, 0, pow2, r - l + 1, r - l + 2, -1);
		mapa[a] = i + 1;
	}
	for (int i = 0; i < 2 * n + 500; ++i) {
		push(i);
	}

	for (int i = 0; i < n; ++i) {
		int d = i + 1;
		cout << (n - d + 1) * d - t[pow2 - 1 + d] << ' ';
	}
}