#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <algorithm>
#define int long long
#define ll long long
#define pi pair<int, int>
#define pll pair<ll, ll>
#define F first
#define S second

using namespace std;

const int MAXN = 200007;
int t[4 * MAXN], add[4 * MAXN];
void push(int n) {
	if (2 * n + 2 > MAXN * 2 + 500) {
		t[n] += add[n];
		add[n] = 0;
	}
	t[n] += add[n];
	add[2 * n + 1] += add[n];
	add[2 * n + 2] += add[n];
	add[n] = 0;
}

void add_x(int n, int l, int r, int a, int b, int x) {
	if ((a <= l) && (r <= b)) {
		add[n] += x;
		return;
	}
	if ((a >= r) || (l >= b)) {
		return;
	}
	int m = (l + r) / 2;
	add_x(2 * n + 1, l, m, a, b, x);
	add_x(2 * n + 2, m, r, a, b, x);
}

int n;

map<int, int> mapa;
int a[MAXN];
unordered_set<int> s;
int ans[MAXN];

signed main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < n; ++i) {
		for (int j = i; j < n; ++j) {
			s.insert(a[j]);
			mapa[a[j]]++;
			ans[j - i] += s.size();
		}
		mapa.clear();
		s.clear();
	}
	for (int i = 0; i < n; ++i) {
		cout << ans[i] << ' ';
	}
}