#include <iostream>
#include <vector>
#include <fstream>
#include <assert.h>
#include <set>
#include <map>
#include <algorithm>
#define int long long
#define ll long long
#define pi pair<int, int>
#define pll pair<ll, ll>
#define F first
#define S second

using namespace std;

const int MAXN = 40007;
int n;
int a[MAXN];
bool used[MAXN];

bool isMaskGood() {
	for (int i = 0; i < n; ++i) {
		int k = 0;
		for (int j = 0; j < 4; ++j) {
			if (used[i + j]) {
				++k;
			}
		}
		if (k == 4) {
			return false;
		}
	}
	return true;
}

void bSolveT() {
	for (int i = n; i < n + n; ++i) {
		a[i] = a[i - n];
	}
	int ans = 0;
	for (int mask = 0; mask < (1ll << n); ++mask) {
		for (int i = 0; i < n; ++i) {
			used[i] = (mask >> i) & 1;
		}
		for (int i = n; i < n + n; ++i) {
			used[i] = used[i - n];
		}
		int cur = 0;
		if (isMaskGood()) {
			for (int i = 0; i < n; ++i) {
				if (used[i]) {
					cur += a[i];
				}
			}
		}
		ans = max(ans, cur);
	}
	cout << ans << '\n';
}

void brute() {
	bSolveT();
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int p, v;
		cin >> p >> v;
		a[p - 1] = v;
		bSolveT();
	}
}

signed main() {
	cin.sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	if (n <= 10) {
		brute();
		return 0;
	}
	return 0;
}