#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<cmath>
#include<algorithm>

using namespace std;

#define int long long

int n, m;
vector<double> v;
vector<double> l;
vector<double> a;
vector<double> f;

double func(int x) {
	double maxtime = 0;
	for (int i = 0; i < n; i++) {
		maxtime += l[i] / (v[i] + a[x]);
	}
	return maxtime;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	v.resize(n);
	l.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> l[i];
	}
	cin >> m;
	a.resize(m);
	f.resize(m + 1);
	a[0] = 0;
	f[0] = 0;
	for (int i = 1; i < m; i++) {
		cin >> a[i];
	}
	for (int i = 1; i <= m; i++) {
		cin >> f[i];
	}
	double mintime = 0;
	for (int i = 0; i < n; i++) {
		mintime += l[i] / v[i];
	}
	double maxtime = 0;
	for (int i = 0; i < n; i++) {
		maxtime += l[i] / (v[i] + a[m - 1]);
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		double s, t;
		cin >> s >> t;
		double timer = t - s;
		if (timer >= mintime) {
			cout << 0 << "\n";
		}
		else if (timer < maxtime) {
			cout << f[m] << "\n";
		}
		else {
			int ll = 0;
			int r = m - 1;
			while (ll + 1 < r) {
				int mid = (ll + r) / 2;
				if (func(mid) <= timer) {
					r = mid;
				} else {
					ll = mid;
				}
			}
			cout << (int)f[r] << "\n";
		}
	}
} 