#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<cmath>
#include<algorithm>

using namespace std;

#define int long long

struct node {
	int a, b, op;
};


int n, m, s;
vector<vector<node>> vecc;
vector<vector<int>> x;
vector<int> ans;

void solve(vector<int> z) {
	if (z.size() < n) {
		z.push_back(3);
		solve(z);
		z.back() = 2;
		solve(z);
		z.back() = 1;
		solve(z);
		z.back() = 0;
		solve(z);
	}
	else {
		int cnt = 0;
		for (int i = 0; i < m; i++) {
			vector<int> val(2 * n);
			for (int j = 0; j < n; j++) {
				val[j + 1] = (x[i][j] < z[j]);
			}
			for (int j = n + 1; j < 2 * n; j++) {
				int a = vecc[i][j - n - 1].a;
				int b = vecc[i][j - n - 1].b;
				int op = vecc[i][j - n - 1].op;
				if (op == 1) {
					val[j] = (val[a] & val[b]);
				}
				else {
					val[j] = (val[a] | val[b]);
				}
			}
			cnt += val[2 * n - 1];
		}
		if (cnt == s) {
			ans = z;
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> s;
	if (n <= 2) {
		if (n == 1) {
			cout << s;
			return 0;
		}
		vector<node> vec(m);
		for (int i = 0; i < m; i++) {
			cin >> vec[i].a >> vec[i].b >> vec[i].op;
		}
		vector<vector<int>> a(m, vector<int>(n));
		vector<pair<int, int>> sec;
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				cin >> a[i][j];
				if (j == 1) {
					sec.push_back({ a[i][j], i });
				}
			}
		}
		sort(sec.begin(), sec.end());
		for (int z1 = 0; z1 <= m; z1++) {
			vector<int> v;
			int cnt = 0;
			for (int i = 0; i < m; i++) {
				if (a[i][0] < z1) {
					v.push_back(1);
				}
				else {
					v.push_back(0);
				}
				if (vec[i].op == 2 && v[i] == 1) {
					cnt++;
				}
			}
			if (cnt == s) {
				cout << z1 << " " << 0;
				return 0;
			}
			for (int z2 = 0; z2 < m; z2++) {
				int id = sec[z2].second;
				int a1 = v[id];
				int a2 = 1;
				int res1, res2;
				if (vec[id].op == 1) {
					if (a1 == 1) {
						res1 = 0;
						res2 = 1;
					}
					else {
						res1 = 0;
						res2 = 0;
					}
				}
				else {
					if (a1 == 1) {
						res1 = 1;
						res2 = 1;
					}
					else {
						res1 = 0;
						res2 = 1;
					}
				}
				if (res1 == res2) {
					continue;
				}
				else {
					if (res2 > res1) {
						cnt++;
					}
					else {
						cnt--;
					}
					if (cnt == s) {
						cout << z1 << " " << z2 + 1;
						return 0;
					}
				}
			}
		}
	}
	if (m <= 2) {
		vecc.resize(m, vector<node>(n - 1));
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n - 1; j++) {
				cin >> vecc[i][j].a >> vecc[i][j].b >> vecc[i][j].op;
			}
		}
		x.resize(m, vector<int>(n));
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				cin >> x[i][j];
			}
		}
		solve({});
		for (int i = 0; i < n; i++) {
			cout << ans[i] << ' ';
		}
	}
}