#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<cmath>
#include<algorithm>

using namespace std;

#define int long long

struct node {
	int a, b, op;
};


int n, m, s;
vector<vector<node>> vecc;
vector<vector<int>> x;
vector<int> ans;

void solve(vector<int> z) {
	if (z.size() < n) {
		z.push_back(3);
		solve(z);
		z.back() = 2;
		solve(z);
		z.back() = 1;
		solve(z);
		z.back() = 0;
		solve(z);
	}
	else {
		int cnt = 0;
		for (int i = 0; i < m; i++) {
			vector<int> val(2 * n);
			for (int j = 0; j < n; j++) {
				val[j + 1] = (x[i][j] < z[j]);
			}
			for (int j = n + 1; j < 2 * n; j++) {
				int a = vecc[i][j - n - 1].a;
				int b = vecc[i][j - n - 1].b;
				int op = vecc[i][j - n - 1].op;
				if (op == 1) {
					val[j] = (val[a] & val[b]);
				}
				else {
					val[j] = (val[a] | val[b]);
				}
			}
			cnt += val[2 * n - 1];
		}
		if (cnt == s) {
			ans = z;
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m >> s;
	if (n <= 2) {
		if (n == 1) {
			cout << s;
			return 0;
		}
		vector<node> vec(m);
		for (int i = 0; i < m; i++) {
			cin >> vec[i].a >> vec[i].b >> vec[i].op;
		}
		vector<vector<int>> a(m, vector<int>(n));
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				cin >> a[i][j];
			}
		}
		vector<int> pos1(m);
		vector<int> pos2(m);
		for (int i = 0; i < m; i++) {
			pos1[a[i][0]] = i;
			pos2[a[i][1]] = i;
		}
		vector<int> cnt(m + 1);
		cnt[0] = 0;
		for (int i = 0; i < m; i++) {
			cnt[i + 1] = cnt[i] + (vec[pos1[i]].op == 2);
		}
		if (cnt[m] >= s) {
			for (int i = 0; i <= m; i++) {
				if (cnt[i] == s) {
					cout << i << " " << 0;
					return 0;
				}
			}
		}
		else {
			int cnttt = cnt[m];
			for (int i = 0; i < m; i++) {
				cnttt += (vec[pos2[i]].op == 1);
				if (cnttt == s) {
					cout << m << ' ' << i + 1;
					return 0;
				}
			}
		}
	}
	if (m <= 2) {
		vecc.resize(m, vector<node>(n - 1));
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n - 1; j++) {
				cin >> vecc[i][j].a >> vecc[i][j].b >> vecc[i][j].op;
			}
		}
		x.resize(m, vector<int>(n));
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < n; j++) {
				cin >> x[i][j];
			}
		}
		solve({});
		for (int i = 0; i < n; i++) {
			cout << ans[i] << ' ';
		}
	}
}