#include<iostream>
#include<vector> 
#include<set>
#include<map>
#include<algorithm>
#include<cmath>

using namespace std;

#define int long long

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> maxcnt(n);
    for (int i = 0; i < n - 1; i++) {
        maxcnt[i] = (a[i + 1] - 1) / a[i];
    }
    int q;
    cin >> q;
    vector<int> sum(n + 1);
    sum[0] = maxcnt[0] * a[0];
    for (int i = 1; i < n; i++) {
        sum[i] = sum[i - 1] + a[i] * maxcnt[i];
    }
    vector<int> cntt(n + 1);
    cntt[0] = maxcnt[0];
    for (int i = 1; i < n - 1; i++) {
        cntt[i] = cntt[i - 1] + maxcnt[i];
    }
    for (int i = 0; i < q; i++) {
        int b;
        cin >> b;/*
        int cnt = 0;
        int sum = 0;
        for (int j = 0; j < n - 1; j++) {
            int t = b / a[j];
            if (t <= maxcnt[j]) {
                cnt += t;
                sum += t * a[j];
                break;
            }
            else {
                cnt += maxcnt[j];
                sum += maxcnt[j] * a[j];
                b -= maxcnt[j] * a[j];
            }
        }
        if (b > 0) {
            cnt += b / a[n - 1];
            sum += (b / a[n - 1]) * a[n - 1];
        }
        cout << sum << " " << cnt << "\n";*/
        if (b < sum[0]) {
            cout << b << " " << b << "\n";
            continue;
        }
        int l = 0;
        int r = n - 1;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (sum[mid] <= b) {
                l = mid;
            }
            else {
                r = mid;
            }
        }
        int s = sum[l];
        int cnt = cntt[l];
        b -= s;
        cnt += b / a[r];
        s += (b / a[r]) * a[r];
        cout << s << " " << cnt << "\n";
    }
} 