#include<iostream>
#include<vector> 
#include<set>
#include<map>
#include<algorithm>
#include<cmath>

using namespace std;

#define int long long

vector<bool> v;
int n;

int check(int num) {
    if (v[(num + 1) % n] == 1 && v[(num + 2) % n] == 1 && v[(num + 3) % n] == 1) {
        return 0;
    }
    if (num > 0 && v[num - 1] == 1 && v[(num + 1) % n] == 1 && v[(num + 2) % n] == 1) {
        return 0;
    }
    if (num > 1 && v[num - 2] == 1 && v[num - 1] == 1 && v[(num + 1) % n] == 1) {
        return 0;
    }
    if (num > 2 && v[num - 3] == 1 && v[num - 2] == 1 && v[num - 1] == 1) {
        return 0;
    }
    return 1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    if (n <= 10) {
        int ans = 0;
        for (int i = 1; i < (1 << n); i++) {
            vector<int> v;
            int cnt = 0;
            for (int j = 0; j < n; j++) {
                if ((i >> j) & 1) {
                    v.push_back(j);
                    cnt += a[j];
                }
            }
            bool fl = 1;
            if (v.size() >= 3) {
                v.push_back(v[0] + n);
                v.push_back(v[1] + n);
                v.push_back(v[2] + n);
            }
            for (int j = 0; j < v.size(); j++) {
                if (j + 3 < v.size() && v[j] + 1 == v[j + 1] && v[j + 1] + 1 == v[j + 2] && v[j + 2] + 1 == v[j + 3]) {
                    fl = 0;
                }
            }
            if (fl == 0) {
                continue;
            }
            ans = max(ans, cnt);
        }
        cout << ans << "\n";
        for (int k = 0; k < q; k++) {
            int p, v;
            cin >> p >> v;
            a[p - 1] = v;
            ans = 0;
            for (int i = 1; i < (1 << n); i++) {
                vector<int> v;
                int cnt = 0;
                for (int j = 0; j < n; j++) {
                    if ((i >> j) & 1) {
                        v.push_back(j);
                        cnt += a[j];
                    }
                }
                bool fl = 1;
                if (v.size() >= 3) {
                    v.push_back(v[0] + n);
                    v.push_back(v[1] + n);
                    v.push_back(v[2] + n);
                }
                for (int j = 0; j < v.size(); j++) {
                    if (j + 3 < v.size() && v[j] + 1 == v[j + 1] && v[j + 1] + 1 == v[j + 2] && v[j + 2] + 1 == v[j + 3]) {
                        fl = 0;
                    }
                }
                if (fl == 0) {
                    continue;
                }
                ans = max(ans, cnt);
            }
            cout << ans << "\n";
        }
        return 0;
    }
    vector<pair<int, int>> vec;
    for (int i = 0; i < n; i++) {
        vec.push_back({ a[i], i });
    }
    sort(vec.rbegin(), vec.rend());
    int ans = 0;
    v.resize(n);
    for (int i = 0; i < n; i++) {
        int num = vec[i].second; 
        v[num] = check(num);
        ans += v[num] * a[i];
    }
    cout << ans;
} 