#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#define ll long long
#define ld long double

const ld eps = 1e-5;

using namespace std;

int main() {
	int n;
	cin >> n;
	vector<ll> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	vector<ll> len(n);
	for (int i = 0; i < n; i++)
		cin >> len[i];
	int m;
	cin >> m;
	vector<ll> maxim(m);
	vector<ll> fine(m);
	maxim[0] = 0;
	for (int i = 1; i < m; i++)
		cin >> maxim[i];
	for (int i = 0; i < m; i++)
		cin >> fine[i];
	int q;
	cin >> q;
	for (int ij = 0; ij < q; ij++) {
		ll S, T;
		cin >> S >> T;
		T -= S;
		int L = -1;
		int R = m;
		while (R - L > 1) {
			int M = (L + R) / 2;
			ld need = 0;
			for (int i = 0; i < n; i++) {
				ld dist = len[i];
				dist /= (v[i] + maxim[M]);
				need += dist;
			}
			if (need - T > eps)
				L = M;
			else
				R = M;
		}
		if (L == -1)
			cout << 0 << endl;
		else
			cout << fine[L] << endl;
	}
}