#include <iostream>
#include <vector>
#include <algorithm>
#define ll long long

using namespace std;

const int N = 40001;
int n;
ll dp[N][4][4];

void dp_init() {
	for (int i = 0; i <= n; i++) {
		for (int j1 = 0; j1 < 4; j1++) {
			for (int j2 = 0; j2 < 4; j2++) {
				dp[i][j1][j2] = 0;
			}
		}
	}
}


ll calc(vector<ll>& a) {
	for (int j2 = 0; j2 < 4; j2++){
		for (int i = 0; i < n; i++) {
			for (int j1 = 0; j1 < 4; j1++) {
				int j3 = j2;
				if (i < 3 && i == j2) {
					j3++;
				}
				dp[i + 1][0][j2] = max(dp[i + 1][0][j2], dp[i][j1][j2]);
				if (i < n - 1) {
					if (j1 < 3) {
						dp[i + 1][j1 + 1][j3] = max(dp[i + 1][j1 + 1][j3], dp[i][j1][j2] + a[i]);
					}
				}
				else {
					if (j1 + j2 < 3) {
						dp[i + 1][j1 + 1][j3] = max(dp[i + 1][j1 + 1][j3], dp[i][j1][j2] + a[i]);
					}
				}
			}
		}
	}
	ll ans = 0;
	for (int j1 = 0; j1 < 4; j1++) {
		for (int j2 = 0; j2 < 4; j2++) {
			ans = max(ans, dp[n][j1][j2]);
		}
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cin >> n;
	vector<ll> a(n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	
	dp_init();
	cout << calc(a) << endl;;
	int q;
	cin >> q;

	for (int i = 0; i < q; i++) {
		int ind; ll x;
		cin >> ind >> x;
		a[ind - 1] = x;
		dp_init();
		cout << calc(a) << "\n";
	}
}