#include <bits/stdc++.h>

#define int long long
#define endl "\n"
#define pii pair<int, int>
#define F first 
#define S second
#define B begin
#define E end

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int INF = 1e9;
const double EPS = 1e-9;
const ll P = 1e9 + 7;
const ll Q = 47;

void hello()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
}

void show(vector <int>& arr)
{
	for (auto i : arr)
		cout << i << " ";
	cout << endl;
}

void show(vector <vector <int>>& arr)
{
	for (auto i : arr)
		show(i);
	cout << endl;
}

signed main()
{
	hello();

	int n;
	cin >> n;
	vector <int> seq(n);
	for (int i = 0; i < n; ++i)
		cin >> seq[i];
	vector <int> order = seq;
	sort(order.B(), order.E());
	order.resize(unique(order.B(), order.E()) - order.B());
	for (int i = 0; i < n; ++i)
		seq[i] = lower_bound(order.B(), order.E(), seq[i]) - order.B();

	vector <int> res(n);
	vector <int> cnts(n), sums(n), cntb(n), sumb(n);
	vector <int> next(n, -1);
	vector <int> used(n, n);
	for (int i = n - 1; i >= 0; --i)
	{
		next[i] = used[seq[i]];
		used[seq[i]] = i;
	}

	for (int i = 0; i < n; ++i)
	{

		int len = next[i] - i;
		if (i > len)
		{
			for (int j = 0; j < len; ++j)
				cnts[j]++;
			for (int j = len; j < i; ++j)
				sums[j] += next[i] - i;
			for (int j = max(i, len); j < next[i]; ++j)
			{
				cntb[j]++;
				sumb[j] += next[i];
			}
		}
		else
		{
			for (int j = 0; j < i; ++j)
				cnts[j]++;
			for (int j = i; j < len; ++j)
				sums[j] += i + 1;
			for (int j = max(i, len); j < next[i]; ++j)
			{
				cntb[j]++;
				sumb[j] += next[i];
			}
		}
	}

	// show(cnts);
	// show(sums);
	// show(sumb);
	// show(cntb);

	for (int i = 0; i < n; ++i)
	{
		res[i] = (i + 1) * cnts[i] + sums[i] + sumb[i] - cntb[i] * (i);
	}

	show(res);
}