#include <bits/stdc++.h>

#define int long long
#define endl "\n"
#define pii pair<int, int>
#define F first 
#define S second
#define B begin
#define E end

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

const int INF = 1e9;
const double EPS = 1e-9;
const ll P = 1e9 + 7;
const ll Q = 47;

void hello()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
}

void show(vector <int>& arr)
{
	for (auto i : arr)
		cout << i << " ";
	cout << endl;
}

void show(vector <vector <int>>& arr)
{
	for (auto i : arr)
		show(i);
	cout << endl;
}

struct ev
{
	int a, b, op;
	ev(){}
	ev(int ta, int tb, int top)
	{
		a = ta, b = tb, op = top;
	}
};

signed main()
{
	hello();

	int n, m, s;
	cin >> n >> m >> s;
	
	vector <vector <ev>> funcs(m, vector <ev>(n - 1));
	bool f1 = 0;
	for (int i = 0; i < m; ++i)
		for (int j = 0; j < n - 1; ++j)
		{
			cin >> funcs[i][j].a >> funcs[i][j].b >> funcs[i][j].op;
			--funcs[i][j].a;
			--funcs[i][j].b;
			--funcs[i][j].op;
			f1 |= funcs[i][j].op;
		}

	bool f2 = 0;
	vector <vector <int>> matr(m, vector <int>(n));
	for (int i = 0; i < m; ++i)
		for (int j = 0; j < n; ++j)
		{
			cin >> matr[i][j];
			f2 |= matr[i][j] != i;
		}

	if (m <= 2)
	{
		int mask = 0;
		while (true)
		{
			vector <int> poses;
			int tmask = mask;
			for (int i = 0; i < 10; ++i)
			{
				poses.push_back(tmask % 3);
				tmask /= 3;
			}
			vector <vector <int>> vals(m, vector <int>(2 * n - 1));
			for (int i = 0; i < m; ++i)
				for (int j = 0; j < n; ++j)
					vals[i][j] = poses[j] > matr[i][j];
			for (int i = 0; i < m; ++i)
				for (int j = n; j < 2 * n - 1; ++j)
					if (funcs[i][j - n].op)
						vals[i][j] = vals[i][funcs[i][j - n].a] || vals[i][funcs[i][j - n].b];
					else
						vals[i][j] = vals[i][funcs[i][j - n].a] && vals[i][funcs[i][j - n].b];

			int cnt = 0;
			for (int i = 0; i < m; ++i)
				cnt += vals[i].back();
			if (cnt == s)
			{
				show(poses);
				return 0;
			}
			++mask;
		}
	}

	if (!s)
	{
		for (int i = 0; i < n; ++i)
			cout << 0 << " ";
		return 0;
	}

	if (!f1)
	{
		int ind = 0;
		vector <int> res(n);
		for (int i = 0; i < m; ++i)
			if (matr[i][0] <= s - 1)
				for (int j = 0; j < n; ++j)
					res[j] = max(res[j], matr[i][j] + 1);
		show(res);
		return 0;
	}
	if (!f2)
	{
		for (int i = 0; i < n; ++i)
			cout << s << " ";
		cout << endl;
		return 0;
	}
}