#include <bits/stdc++.h>
#ifdef DEBUG
#define __GLIBCXX_DEBUG
#endif // DEBUG

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 3e5 + 5;

int m, n, s;
vector <int> op[maxn], a[maxn], b[maxn];
vector <int> x[maxn];
int z[maxn];
bool cres[maxn];
vector <int> vthis[maxn];

bool vget[2 * maxn];
inline void getcres(int pos) {
    for (int i = 0; i < n; i++) {
        vget[i] = (x[pos][i] < z[i]);
    }
    for (int i = n; i < 2 * n - 1; i++) {
        if (op[pos][i - n] == 1)
            vget[i] = vget[a[pos][i - n]] & vget[b[pos][i - n]];
        else
            vget[i] = vget[a[pos][i - n]] | vget[b[pos][i - n]];
    }
    cres[pos] = vget[2 * n - 2];
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif // DEBUG
    cin >> n >> m >> s;

    bool ispz5 = true;
    for (int i = 0; i < m; i++) {
        op[i].resize(n - 1);
        a[i].resize(n - 1);
        b[i].resize(n - 1);
        for (int j = 0; j < n - 1; j++) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];
            if (op[i][j] == 2)
                ispz5 = false;
            a[i][j]--;
            b[i][j]--;
        }
    }
    for (int i = 0; i < n; i++) {
        vthis[i].resize(m);
    }
    bool ispz4 = true;
    for (int i = 0; i < m; i++) {
        x[i].resize(n);
        for (int j = 0; j < n; j++) {
            cin >> x[i][j];
            if (x[i][j] != i)
                ispz4 = false;
            vthis[j][x[i][j]] = i;
        }
    }
    if (ispz4) {
        for (int i = 0; i < n; i++) {
            cout << s << " ";
        }
        return 0;
    }

    int curs = 0;
    if (curs == s) {
        for (int i = 0; i < n; i++) {
            cout << z[i] << " ";
        }
        return 0;
    }
    for (int i = (ispz5 ? n - 1 : 0); i < n; i++) {
        while (z[i] < m) {
            int pos = vthis[i][z[i]];
            z[i]++;
            curs -= (int)cres[pos];
            getcres(pos);
            curs += (int)cres[pos];
            //cerr << i << " " << z[i] << " " << curs << "\n";
            if (curs == s) {
                for (int i = 0; i < n; i++) {
                    cout << z[i] << " ";
                }
                return 0;
            }
        }
    }
    return 0;
}
