#include <bits/stdc++.h>

using namespace std;

int n;
vector<int> a;

const int MAXN = 2e5;

pair<long long, long long> ans[MAXN];

pair<long long, long long> getans(long long r, int id) {
    if (id == 0) {
        return {r, r};
    }
    if (r % a[id] == a[id] - 1) {
        return {ans[id].first + r - a[id] + 1, ans[id].second + r / a[id]};
    }
    auto ans2 = getans(r % a[id], max(int(upper_bound(a.begin(), a.end(), r % a[id]) - a.begin() - 1), 0));
    if (ans[id].second + r / a[id] - 1 < ans2.second + r / a[id]) {
        return {ans2.first + r - r % a[id], ans2.second + r / a[id]};
    } else {
        return {ans[id].first + r - r % a[id] - a[id], ans[id].second + r / a[id] - 1};
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    for (int i = 1; i < n; i++) {
        ans[i] = getans(a[i] - 1, i - 1);
    }
    int q;
    cin >> q;
    while (q--) {
        long long b;
        cin >> b;
        auto answer = getans(b, max(int(upper_bound(a.begin(), a.end(), b) - a.begin() - 1), 0));
        cout << answer.first << ' ' << answer.second << '\n';
    }
    return 0;
}