#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <stack>
#include <deque>
#include <queue>
#include <map>
#include <set>

using namespace std;

#define int long long
#define endl '\n'

struct op {
	int a;
	int b;
	int op;
};

signed main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	int n, m, s;
	cin >> n >> m >> s;

	vector<vector<op> > arr(m, vector<op>(n - 1));

	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n - 1; j++) {
			int a, b, op;
			cin >> a >> b >> op;
			a--;
			b--;
			arr[i][j].a = a;
			arr[i][j].b = b;
			arr[i][j].op = op;
		}
	}

	vector<vector<int> > val(m, vector<int>(n));

	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n; j++) {
			cin >> val[i][j];
		}
	}

	if (n == 1) {
		for (int z = 0; z < m; z++) {
			vector<vector<int> > now(m, vector<int>(n));
			for (int i = 0; i < m; i++) {
				now[i][0] = (val[i][0] < z);
			}
			int ans = 0;
			for (int i = 0; i < m; i++) {
				ans += now[i][0];
			}

			if (ans == s) {
				cout << z;
				return 0;
			}
		}
	}

	if (n <= 10 && m <= 2) {
		if (m == 1) {
			for (int ii = 0; ii < (1 << n); ii++) {
				vector<int> z(n);
				for (int i = 0; i < n; i++) {
					if (ii & (1 << i)) {
						z[i] = 1;
					} else {
						z[i] = 0;
					}
				}

				int ans = 0;
				for (int i = 0; i < m; i++) {
					vector<int> val1(n * 2 - 1);
					for (int j = 0; j < n; j++) {
						val1[j] = (val[i][j] < z[j]);
					}
					for (int j = 0; j < n - 1; j++) {
						if (arr[i][j].op == 1) {
							val1[j + n] = val1[arr[i][j].a] & val1[arr[i][j].b];
						} else {
							val1[j + n] = val1[arr[i][j].a] | val1[arr[i][j].b];
						}
					}
					ans += val1.back();
				}

				if (ans == s) {
					for (int i = 0; i < n; i++) {
						cout << z[i] << " ";
						return 0;
					}
				}
			}
		} else {
			vector<int> pows(11);
			pows[0] = 1;
			for (int i = 0; i < 11; i++) {
				pows[i] = pows[i - 1] * 3;
			}

			for (int ii = 0; ii < pows[n]; ii++) {
				vector<int> z(n);

				for (int i = n - 1; i >= 0; i--) {
					if (ii >= pows[i] * 2) {
						z[i] = 2;
						ii -= pows[i] * 2;
					}

					if (ii >= pows[i]) {
						z[i] = 1;
						ii -= pows[i];
					}
					z[i] = 0;
				}

				int ans = 0;
				for (int i = 0; i < m; i++) {
					vector<int> val1(n * 2 - 1);
					for (int j = 0; j < n; j++) {
						val1[j] = (val[i][j] < z[j]);
					}
					for (int j = 0; j < n - 1; j++) {
						if (arr[i][j].op == 1) {
							val1[j + n] = val1[arr[i][j].a] & val1[arr[i][j].b];
						} else {
							val1[j + n] = val1[arr[i][j].a] | val1[arr[i][j].b];
						}
					}
					ans += val1.back();
				}

				if (ans == s) {
					for (int i = 0; i < n; i++) {
						cout << z[i] << " ";
						return 0;
					}
				}
			}
		}
	}

	if (s == 0) {
		for (int i = 0; i < n; i++) {
			cout << 0 << " ";
		}
		return 0;
	}

	if (s == m) {
		for (int i = 0; i < n; i++) {
			cout << m << " ";
		}
		return 0;
	}

	if (n == 2) {
		for (int z1 = 0; z1 < m; z1++) {
			int l = 0;
			int r = m;
			vector<vector<int> > now(m, vector<int>(n));
			for (int i = 0; i < m; i++) {
				now[i][0] = (val[i][0] < z1);
			}
			while ((r - l) > 1) {
				int z = (l + r) / 2;
				for (int i = 0; i < m; i++) {
					now[i][1] = (val[i][1] < z);
				}

				int ans = 0;

				for (int i = 0; i < m; i++) {
					if (arr[i][0].op == 1) {
						if (now[i][0] & now[i][1]) {
							ans++;
						}
					} else {
						if (now[i][0] | now[i][1]) {
							ans++;
						}
					}
				}

				if (ans >= s) {
					r = z;
				} else {
					l = z;
				}
			}

			int z = r;

			int ans = 0;

            for (int i = 0; i < m; i++) {
                if (arr[i][0].op == 1) {
                    if (now[i][0] & now[i][1]) {
                        ans++;
                    }
                } else {
                    if (now[i][0] | now[i][1]) {
                        ans++;
                    }
                }
            }

            if (ans == s) {
                cout << z1 << " " << z;
                return 0;
            }

		}
	}

	exit(1);
}
