#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <map>
#include <set>

#pragma GCC_OPTIMIZE("ofast")

using namespace std;

#define int long long
#define endl '\n'

signed main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin >> n;

	vector<int> arr(n, 0LL);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}

	vector<int> pref(n, 0LL);
	pref[0] = arr[0];
	for (int i = 1; i < n; i++) {
		pref[i] = pref[i - 1] + arr[i];
	}

	vector<int> suf(n, 0LL);
	suf[n - 1] = arr[n - 1];
	for (int i = n - 2; i >= 0; i--) {
		suf[i] = suf[i + 1] + arr[i];
	}

	int ans = -100000000LL;
	int ans_ind = 0;
	for (int i = 1; i < n - 1; i++) {
		if (pref[i] / suf[ans_ind + 1] > pref[ans_ind] / suf[i + 1]) {
			ans_ind = i;
		}
	}

	cout << ans_ind + 1 << endl;
}
