#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <map>
#include <set>

#pragma GCC_OPTIMIZE("ofast")

using namespace std;

#define int long long
#define endl '\n'

signed main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	int n, x;
	cin >> n >> x;

	vector<vector<int>> solve(n, vector<int>(n));
	int ans = 0;

	unordered_map<int, vector<pair<int, int> > > m;
	for (int a = 1; a <= n; a++) {
		for (int b = 1; a + b <= n + 1; b++) {
			if (a * b) {
				m[a * b].push_back(make_pair(a, b));
			}
			if (a == x || b == x) {
				continue;
			}

			for (auto p: m[a * b - n]) {
				if (p.first < a || p.second < b) {
					ans++;
				}
			}
		}
	}

	cout << ans;
}
