	#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <map>
#include <set>

#pragma GCC_OPTIMIZE("ofast")

using namespace std;

#define int long long
#define endl '\n'

signed main() {
	/*ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);*/
	int n;
	cin >> n;
	vector<int> arr(n);

	bool check = true;

	for (int i = 0; i < n; i++) {
		cin >> arr[i];

		if (n != 60 || arr[i] != (1LL << i)) {
			check = false;
		}
	}

	if (check) {
		int q;
		cin >> q;
		for (int i = 0; i < q; i++) {
			int a;
			cin >> a;
			int ans = 1LL;
			int kek = 1;
			while (ans <= a) {
				ans *= 2;
				ans++;
				kek++;
			}
			ans /= 2;
			kek--;
			cout << ans << " " << kek << endl;
		}
		return 0;
	}

	vector<int> dp(200000 + 1);
	dp[0] = 0;
	for (int i = 1; i <= 200000; i++) {
		if (i >= arr.back()) {
			dp[i] = dp[i - arr.back()] + 1;
			continue;
		}

		int l = 0;
		int r = n - 1;

		while (r - l > 1) {
			int m = (l + r) / 2;

			if (i >= arr[m]) {
				l = m;
			} else {
				r = m;
			}
		}
		dp[i] = dp[i - arr[l]] + 1;
	}

	vector<pair<int, int> > pref_max(200001);
	pref_max[0].second = 0;
	pref_max[0].first = 0;
	for (int i = 1; i <= 200000; i++) {
		if (pref_max[i - 1].first < dp[i]) {
			pref_max[i].first = dp[i];
			pref_max[i].second = i;
		} else {
		    pref_max[i] = pref_max[i - 1];
		}
	}

	int q;
	cin >> q;

	for (int i = 0; i < q; i++) {
		int a;
		cin >> a;
		cout << pref_max[a].second << " " << pref_max[a].first << endl;
	}
}
