	#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <map>
#include <set>

#pragma GCC_OPTIMIZE("ofast")

using namespace std;

#define int long long
#define endl '\n'

int n;
vector<int> arr;

int INF = 1000000000000000003LL;

int solve(int t, int b) {
	int now = 0LL;
	int now_ans = 0LL;
	for (int i = 0; i < n - 1; i++) {
		int kek = (arr[i + 1] - now - 1) / arr[i];
		if (now_ans + kek >= t) {
			return now + (t - now_ans) * arr[i];
		}

		if (kek > INF / arr[i]) {
			return b + 1;
		}
		now_ans += kek;
		now += kek * arr[i];
		if (now > INF) {
			return b + 1;
		}
	}

	return now + (t - now_ans) * arr.back();
}

signed main() {
	/*ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);*/
	cin >> n;
	arr.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}

	int q;
	cin >> q;

	for (int i = 0; i < q; i++) {
		int b;
		cin >> b;
		int l = 1LL;
		int r = b + 1;
		int ans = 0;
		while (r - l > 1) {
			int m = (l + r) / 2;

			if (solve(m, b) > b) {
				r = m;
			} else {
			    ans = solve(m, b);
				l = m;
			}
		}
		cout << ans << " " << l << endl;
	}

}
