#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <map>
#include <set>

#pragma GCC_OPTIMIZE("ofast")

using namespace std;

#define int long long
#define endl '\n'

int n;
vector<int> arr;

int INF = 1000000003LL;

int ans_ind;
vector<pair<int, int>> b;
vector<pair<int, int>> ans;

void solve() {
    int now = 0LL;
    int now_ans = 0LL;
    for (int i = 0; i < n - 1; i++) {
        int kek = (arr[i + 1] - now - 1) / arr[i];
        while (ans_ind != b.size() && kek > b[ans_ind].first / arr[i]) {
        	int kek1 = (b[ans_ind].first - now) / arr[i];
        	ans[b[ans_ind].second] = make_pair(now + kek1 * arr[i], now_ans + kek1);
        	ans_ind++;
        }

        while (ans_ind != b.size() && now + kek * arr[i] >= b[ans_ind].first) {
        	int kek1 = (b[ans_ind].first - now) / arr[i];
        	ans[b[ans_ind].second] = make_pair(now + kek1 * arr[i], now_ans + kek1);
        	ans_ind++;
        }

        now += kek * arr[i];
        now_ans += kek;
    }

    while (ans_ind != b.size()) {
    	int kek1 = (b[ans_ind].first - now) / arr.back();
    	ans[b[ans_ind].second] = make_pair(now + kek1 * arr.back(), now_ans + kek1);
    	ans_ind++;
    }
}

signed main() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(NULL);
    cout.tie(NULL);
    cin >> n;
    arr.resize(n);

    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }

    int q;
    cin >> q;
    b.resize(q);
    ans.resize(q);
    for (int i = 0; i < q; i++) {
        int b1;
        cin >> b1;
        b[i].first = b1;
        b[i].second = i;
    }

    sort(b.begin(), b.end());

    solve();

    for (int i = 0; i < q; i++) {
    	cout << ans[i].first << " " << ans[i].second << endl;
    }

}
