#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <map>

#define ff  first
#define ss  second
#define pb  push_back
#define sz  size()

using namespace std;

typedef long long ll;
typedef pair<int, int> pr;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    map<int, int> start;
    map<int, int> cur;
    for (int d = 1; d <= n; ++d) {
        long long sum = 0;
        ++start[v[d - 1]];
        cur = start;
        sum += cur.sz;
        for (int i = 1; i <= n - d; ++i) {
            int j = i + d;
            --cur[v[i - 1]];
            ++cur[v[j - 1]];
            if (!cur[v[i - 1]]) {
                cur.erase(v[i - 1]);
            }
            sum += cur.sz;
        }
        cout << sum << ' ';
    }

    return 0;
}