#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <map>

#define ff  first
#define ss  second
#define pb  push_back
#define sz  size()

using namespace std;

typedef long long ll;
typedef pair<int, int> pr;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    map<int, int> start;
    map<int, int> cur;
    int cnt = 0;
    int startCnt = 0;
    for (int d = 1; d <= n; ++d) {
        long long sum = 0;
        ++start[v[d - 1]];
        cur = start;
        cnt = startCnt;
        if (start[v[d - 1]] == 1) {
            ++cnt;
            ++startCnt;
        }
        sum += cnt;
        for (int i = 1; i <= n - d; ++i) {
            int j = i + d;
            if (v[i - 1] != v[j - 1]) {
                --cur[v[i - 1]];
                ++cur[v[j - 1]];
                if (!cur[v[i - 1]]) {
                    --cnt;
                }
                if (cur[v[j - 1]] == 1) {
                    ++cnt;
                }
            }

            sum += cnt;
        }
        cout << sum << ' ';
    }

    return 0;
}