#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <bitset>
#include <map>

#define ff  first
#define ss  second
#define pb  push_back
#define sz  size()
#define rsz  resize()

using namespace std;

typedef long long ll;
typedef pair<int, int> pr;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;

const int NN = 3020;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, foo;
    cin >> n >> foo;
    vector<set<int> > del(NN);
    for (int i = 1; i < NN; ++i) {
        for (int j = 1; j < sqrt(i) + 2; ++j) {
            if (!(i % j)) {
                del[i].insert(j);
            }
        }
    }
    vector<vector<int> > div(NN);
    for (int i = 0; i < NN; ++i) {
        for (auto it = del[i].begin(); it != del[i].end(); ++it)
            div[i].pb(*it);
    }
    set<pair<pr, pr> > res;
    for (int x = 1; x < n; ++x) {
        int y = n - x;
        for (int i = 0; i < div[x].sz; ++i) {
            int a = div[x][i];
            int b = x / a;
            for (int j = 0; j < div[y].sz; ++j) {
                int c = div[y][j];
                int d = y / c;

                if (a != b) {
                    if (c != d) {
                        if (a > c) {
                            if ((a != foo) && (b + d != foo)) {
                                res.insert({ {a, b + d}, {a - c, d} });
                            }
                        }
                        if (a > d) {
                            if ((a != foo) && (b + c != foo)) {
                                res.insert({ {a, b + c}, {a - d, c} });
                            }
                        }
                        if (b > c) {
                            if ((b != foo) && (a + d != foo)) {

                                res.insert({ {b, a + d}, {b - c, d} });
                            }

                        }
                        if (b > d) {
                            if ((b != foo) && (a + c != foo)) {
                                res.insert({ {b, a + c}, {b - d, c} });
                            }

                        }
                    } else {
                        if (b > c) {
                            if ((b != foo) && (a + c != foo)) {
                                res.insert({ {b, a + c}, {b - c, c} });
                            }

                        }
                        if (a > c) {
                            if ((a != foo) && (b + c != foo)) {
                                res.insert({ {a, b + c}, {a - c, c} });
                            }

                        }
                    }




                } else {
                    if (c != d) {
                        if (b > c) {
                            if ((b != foo) && (a + d != foo)) {
                                res.insert({ {b, a + d}, {b - c, d} });
                            }

                        }
                        if (b > d) {
                            if ((b != foo) && (a + c != foo)) {
                                res.insert({ {b, a + c}, {b - d, c} });
                            }

                        }
                    } else {
                        if (b > d) {
                            if ((b != foo) && (a + c != foo)) {
                                res.insert({ {b, a + c}, {b - c, c} });
                            }

                        }
                    }
                }
            }

        }
    }


    cout << res.sz;

    return 0;
}
