#include <iostream>
#include <cmath>
#include <algorithm>
#include <climits>
#include <vector>
#include <set>
#include <bitset>
#include <map>

#define ff  first
#define ss  second
#define pb  push_back
#define sz  size()
#define rsz  resize()

using namespace std;

typedef long long ll;
typedef pair<int, int> pr;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef long double ld;

const int NN = 3020;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vll a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    if (!q) {
        vll dp(n, 0);
        vi last_used(n);
        vi first_used(n);
        vi sm_used(n); // 2 
        vi sm1_used(n); // 1 
        vi used(n); //  
        dp[0] = a[0];
        sm_used[0] = 0;
        sm1_used[0] = 0;
        used[0] = 1;
        if (n > 1) {
            dp[1] = (ll)a[0] + a[1];
            last_used[1] = 1;
            first_used[1] = 0;
            sm_used[1] = 0;
            sm1_used[1] = 1;
            used[1] = 2;
        }
        if (n > 2) {
            dp[2] = dp[1] + a[2];
            last_used[2] = 2;
            first_used[2] = 0;
            sm_used[2] = 1;
            sm1_used[1] = 1;
            used[2] = 3;
        }
        last_used[0] = 0;
        first_used[0] = 0;
        for (int i = 3; i < n - 1; ++i) {
            if (used[i - 1] < 3) {
                dp[i] = dp[i - 1] + a[i];
                last_used[i] = i;
                first_used[i] = first_used[i - 1];
                sm_used[i] = sm_used[i - 1];
                sm1_used[i] = sm1_used[i - 1];
                used[i] = used[i - 1] + 1;
            } else {
                dp[i] = dp[i - 1];
                last_used[i] = last_used[i - 1];
                first_used[i] = first_used[i - 1];
                sm_used[i] = sm_used[i - 1];
                sm1_used[i] = sm1_used[i - 1];
                used[i] = 0;
            }
            if (dp[i - 2] + a[i] > dp[i]) {
                dp[i] = dp[i - 2] + a[i];
                last_used[i] = i;
                first_used[i] = first_used[i - 2];
                used[i] = 1;
                if (i - 1 == 2)
                    sm_used[i] = 0;
                else
                    sm_used[i] = sm_used[i - 2];
                if (i - 1 == 1)
                    sm1_used[i] = 0;
                else
                    sm1_used[i] = sm1_used[i - 2];
            }
            if (dp[i - 3] + a[i] + a[i - 1] > dp[i]) {
                dp[i] = dp[i - 3] + a[i] + a[i - 1];
                used[i] = 2;
                last_used[i] = i;
                first_used[i] = first_used[i - 3];
                if (i - 2 == 2)
                    sm_used[i] = 0;
                else
                    sm_used[i] = sm_used[i - 3];
                if (i - 2 == 1)
                    sm1_used[i] = 0;
                else
                    sm1_used[i] = sm1_used[i - 3];
                if (i - 1 == 2)
                    sm_used[i] = 1;
            }
            if (i > 3) {
                if (dp[i - 4] + a[i] + a[i - 1] + a[i - 2] > dp[i]) {
                    dp[i] = dp[i - 4] + a[i] + a[i - 1] + a[i - 2];
                    used[i] = 3;
                    last_used[i] = i;
                    first_used[i] = first_used[i - 4];
                    if (i - 3 == 2)
                        sm_used[i] = 0;
                    else
                        sm_used[i] = sm_used[i - 4];
                    if (i - 3 == 1)
                        sm1_used[i] = 0;
                    else
                        sm1_used[i] = sm1_used[i - 4];
                    if (i - 1 == 2) {
                        sm_used[i] = 1;
                    }
                    if (i - 2 == 2) {
                        sm_used[i] = 1;
                    }
                    if (i - 2 == 1) {
                        sm1_used[i] = 1;
                    }
                }
            } else {
                if ((ll)a[i] + a[i - 1] + a[i - 2] > dp[i]) {
                    dp[i] = (ll)a[i] + a[i - 1] + a[i - 2];
                    used[i] = 3;
                    last_used[i] = i;
                    first_used[i] = 1;
                    sm_used[i] = 1;
                    sm1_used[i] = 1;
                }
            }
        }
        if (n > 3) {
            if (n > 1) {
                ll var = dp[n - 2];
                last_used[n - 1] = last_used[n - 2];
                first_used[n - 1] = first_used[n - 2];
                if (n - 1 == 2)
                    sm_used[n - 1] = 1;
                else
                    sm_used[n - 1] = sm_used[n - 2];
                if (n - 1 == 1)
                    sm1_used[n - 1] = 1;
                else
                    sm1_used[n - 1] = sm1_used[n - 2];
                used[n - 1] = used[n - 2];
                if (dp[n - 1] < var)
                    dp[n - 1] = var;
                if (used[n - 2] == 0) {
                    if (!sm_used[n - 2])
                        var += a[n - 1];
                    else {
                        var += a[n - 1];
                        var -= a[2];
                        if (!sm1_used[n - 2])
                            var += a[1];
                        if (first_used[n - 2])
                            var += a[0];
                    }
                    last_used[n - 1] = n - 1;
                    first_used[n - 1] = first_used[n - 2];
                    if (dp[n - 1] < var)
                        dp[n - 1] = var;
                }
                if (used[n - 2] == 1) {
                    var = dp[n - 1] + a[n - 1];
                    if (sm1_used[n - 2]) {
                        var -= a[1];
                        if (first_used[n - 2])
                            var += a[0];
                    }
                    if (var > dp[n - 1])
                        dp[n - 1] = var;
                }
                if (used[n - 2] == 2) {
                    var = dp[n - 1] + a[n - 1];
                    if (!first_used[n - 2])
                        var -= min(a[n - 1], a[0]);
                    if (var > dp[n - 1])
                        dp[n - 1] = var;
                }
            }

            if (n > 2) {

                ll var = dp[n - 3];
                last_used[n - 1] = last_used[n - 3];
                first_used[n - 1] = first_used[n - 3];
                if (n - 1 == 2)
                    sm_used[n - 1] = 1;
                else
                    sm_used[n - 1] = sm_used[n - 2];
                used[n - 1] = 0;

                if (!sm_used[n - 3])
                    var += a[n - 1];
                else {
                    var += a[n - 1];
                    var -= a[2];
                    if (!sm1_used[n - 3])
                        var += a[1];
                    if (first_used[n - 3])
                        var += a[0];
                }
                last_used[n - 1] = n - 1;
                first_used[n - 1] = first_used[n - 2];
                if (dp[n - 1] < var)
                    dp[n - 1] = var;
            }
            if (n > 3) {
                ll var = dp[n - 4] + a[n - 1] + a[n - 2];
                if (sm1_used[n - 4]) {
                    var -= a[1];
                    if (first_used[n - 4])
                        var += a[0];
                }
                if (dp[n - 1] < var)
                    dp[n - 1] = var;
            }
            if (n > 4) {
                ll var = dp[n - 5] + a[n - 3] + a[n - 1] + a[n - 2];
                if (!first_used[n - 5])
                    var -= a[0];
                if (dp[n - 1] < var)
                    dp[n - 1] = var;
            }


        }
        cout << dp.back();
    }

    return 0;
}
