#include <bits/stdc++.h>

#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ff first
#define ss second
#define ld long double
#define int long long
// #define ll long long

using namespace std;
typedef vector <int> vi;
typedef pair<int,int> pii;
typedef vector <pii> vii;
typedef vector <vi> vvi;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int maxV = 5001;
int ind[maxV];
int localsize = 0;
const int maxN = 2e5 + 123;

/*vector <int> mst[4 * maxN];
void build_mst(int v, int lb, int rb, const vector <int>& vec) {
    int m = (lb + rb) / 2;
    if(lb + 1 < rb) {
        build_mst(2*v + 1, lb, m, vec);
        build_mst(2*v + 2, m, rb, vec);
        merge(mst[2*v + 1].begin(), mst[2*v + 1].end(), mst[2*v + 2].begin(), mst[2*v + 2].end(),  back_inserter(mst[v]));
        auto last = unique
    } else {
        mst[v].pb(vec[lb]);
    }
}*/

int ans[4 * maxN];
int tadd[4 * maxN];
// void bld(int v, int lb, int rb, int a)

void push(int v, int lb, int rb) {
    if(tadd[v] == 0) return;
    ans[v] += (rb - lb) * tadd[v];
    if(lb + 1 < rb) {
        tadd[2 * v + 1] += tadd[v];
        tadd[2 * v + 2] += tadd[v];
    }
    tadd[v] = 0;
}

void addx(int v, int lb, int rb, int L, int R, int x) {
    int m = (lb + rb) / 2;
    push(v, lb, rb);
    if(L >= rb || R <= lb) return;
    if(lb >= L && rb <= R) {
        tadd[v] += x;
        push(v, lb, rb);
        return;
    }
    if(lb + 1 < rb) {
        addx(2 * v + 1, lb, m, L, R, x);
        addx(2 * v + 2, m, rb, L, R, x);
        ans[v] = ans[2*v + 1] + ans[2 * v + 2];
    }
}

int get(int v, int lb, int rb, int L, int R) {
    int m = (lb + rb) / 2;
    push(v, lb, rb);
    if(L >= rb || R <= lb) return 0;
    if(lb >= L && rb <= R) {
        return ans[v];
    }
    if(lb + 1 < rb) {
        return get(2 * v + 1, lb, m, L, R) + get(2 * v + 2, m, rb, L, R);
    }
}

inline void add(int x) {
    if(ind[x] == 0) localsize++;
    ind[x]++;
}

inline void del(int x) {
    if(ind[x] == 1) localsize--;
    ind[x]--;
}

vvi positions;

inline int countrazl(int L, int R, int mx) {
    int ret = 0;
    for(int i = 0; i < mx; ++i) {
        auto it = lower_bound(all(positions[i]), L);
        if(it == positions[i].end() || (*it) > R ) continue;
        ret++;
    }
    return ret;
}

void printtree(int n) {
    // cout << "tree : ";
    for(int i = 0; i < n; ++i) cout << get(0, 0, n, i, i + 1) << " "; cout << "\n";
}

vector <int> hector;

void solve() {
    int n;
    cin >> n;
    vi v(n);
    for(int i = 0; i < n; ++i) cin >> v[i];
    vi v2 = v;
    sort(all(v2));
    vi v3;
    v3.pb(v2[0]);
    for(int i = 1; i < n; ++i) {
        if(v2[i] == v2[i-1]) continue;
        v3.pb(v2[i]);
    }
    int mx = 0;
    for(int i = 0; i < n; ++i) {
        v[i] = lower_bound(all(v3), v[i]) - v3.begin();
        mx = max(mx, v[i]);
    }
    mx++;

    if(n > 5000) {
        positions.resize(mx);
        for(int i = 0; i < n; ++i) {
            positions[v[i]].pb(i);
        }
        for(int i = 0; i < n; ++i) {
            hector.clear();
            for(int cnt = 1; cnt <= mx; ++cnt) {
                int L = -1, R = n - i - 1;
                if(countrazl(i, n-1, mx) < cnt) continue;
                while(L + 1 < R) {
                    int M = (L + R) >> 1;
                    if(countrazl(i, i + M, mx) >= cnt) {
                        R = M;
                    } else {
                        L = M;
                    }
                }
                hector.pb(R);
            }
            for(int j = 1; j < hector.size(); ++j) {
                addx(0, 0, n, hector[j-1], hector[j], j);
            }
            addx(0, 0, n, hector.back(), n-i, (int)hector.size());
        }
        printtree(n);
        return;
    }

    for(int len = 1; len <= n; ++len) {
        memset(ind, 0, sizeof ind);
        localsize = 0;
        int s = 0;
        for(int i = 0; i < len; ++i) {
            add(v[i]);
        }
        s += localsize;
        for(int i = len; i < n; ++i) {
            add(v[i]);
            del(v[i - len]);
            s += localsize;
        }
        cout << s << " ";
    }
}

// #define lolipop

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#endif
    fastio();
    solve();
    return 0;
}
