#include <bits/stdc++.h>

#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ff first
#define ss second
#define ld long double
#define int long long

using namespace std;
typedef vector <int> vi;
typedef pair<int,int> pii;
typedef vector <pii> vii;
typedef vector <vi> vvi;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

bool nxt(vector <int>&v, int max_val) {
    v.back()++;
    int ind = v.size() - 1;
    while(v[ind] == max_val) {
        if(ind == 0) return false;
        v[ind] = 0;
        v[ind - 1]++;
        ind--;
    }
    return true;
}

int n, m, s;
vector < vector <int> > a;
vector < vector <int> > b;
vector < vector <int> > op;
vector < vector <int> > matrix;
vvi usd;

bool dfs(int y, int x, const vector <int>& z) {
    if(usd[y][x] != -1) return usd[y][x];
    if(x < n) {
        usd[y][x] = matrix[y][x] < z[x];
        return usd[y][x];
    } else {
        if(op[y][x-n] == 1) {
            int v1 = dfs(y, a[y][x-n], z);
            if(v1 == 0) {
                usd[y][x] = 0;
                return usd[y][x];
            }
            int v2 = dfs(y, b[y][x-n], z);
            usd[y][x] = v2;
            return usd[y][x];
        } else {
            int v1 = dfs(y, a[y][x-n], z);
            if(v1 == 1) {
                usd[y][x] = 1;
                return usd[y][x];
            }
            int v2 = dfs(y, b[y][x-n], z);
            usd[y][x] = v2;
            return usd[y][x];
        }
    }
}

bool tr(const vector <int> &z) {
    usd.assign(m, vi(2*n - 1, -1));
    int counter = 0;
    for(int i = 0; i < m; ++i) {
        if(dfs(i, 2 * n - 2, z)) counter++;
    }
    return counter == s;
}

void solve() {
    cin >> n >> m >> s;
    a.assign(m, vi(n-1, 0));
    b.assign(m, vi(n-1, 0));
    op.assign(m, vi(n-1, 0));
    matrix.assign(m, vi(n, 0));
    for(int i = 0; i < m; ++i) {
        for(int j = 0; j < n-1; ++j) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];
            a[i][j]--;
            b[i][j]--;
        }
    }

    for(int i = 0; i < m; ++i) {
        for(int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }

    vector <int> z(n, 0);
    do {
        // for(auto i : z) cout << i << " "; cout << "\n";
        if(tr(z)) {
            for(auto i : z) cout << i << " ";
            return;
            cout << "\n";
        }
    } while( nxt(z, m+1) );

}

// #define lolipop

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#endif
    // fastio();
    solve();
    return 0;
}
