#include <bits/stdc++.h>

#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ff first
#define ss second
#define int long long

using namespace std;
typedef vector <int> vi;
typedef pair<int,int> pii;
typedef vector <pii> vii;
typedef vector <vi> vvi;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

struct Query {
    int x;
    int num;
    Query(){}
    Query(int x, int num) : x(x), num(num){}
    bool operator < (const Query& a) {
        return x < a.x;
    }
};

vector <Query> Q;
vector <int> ans;
vi v;
int n;

int tr(int x) {
    int ret = 0;
    for(auto i : v) {
        ret += x / i;
        x %= i;
    }
    return ret;
}

void solve() {
    cin >> n;
    v.resize(n);
    for(int i = 0; i < n; ++i) cin >> v[i];
    reverse(all(v));
    int q; cin >> q;
    ans.resize(q);
    for(int i = 0; i < q; ++i) {
        int a;
        cin >> a;
        Q.pb(Query(a, i));
    }
    sort(all(Q));
    //for(auto i : Q) cout << i.x << " "; cout << "\n";
    int now = 0;
    int best = 0;
    for(auto i : Q) {
        while(now <= i.x) {
            if(tr(now) > tr(best)) {
                best = now;
            }
            now++;
        }
        ans[i.num] = best;
    }
    for(auto i : ans) {
        cout << i << " " << tr(i) << "\n";
    }
}

// #define lolipop

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#endif // lolipop
    fastio();
    solve();
    return 0;
}
