#include <bits/stdc++.h>

#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ff first
#define ss second
#define int long long

using namespace std;
typedef vector <int> vi;
typedef pair<int,int> pii;
typedef vector <pii> vii;
typedef vector <vi> vvi;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

struct Query {
    int x;
    int num;
    Query(){}
    Query(int x, int num) : x(x), num(num){}
    bool operator < (const Query& a) {
        return x < a.x;
    }
};

vector <Query> Q;
vector <int> ans;
vector <int> fans;
vi v;
int n, q;

int tr(int x) {
    int ret = 0;
    int pos = upper_bound(all(v), x) - v.begin();
    for(int i = pos-1; i >= 0; --i) {
        ret += x / v[i];
        x %= v[i];
    }
    return ret;
}

pii max_bit(int a) {
    int ret = 0;
    int val = 0;
    for(int i = 0; i <= 60; ++i) {
        val += (1 << i);
        if(val <= a) {
            ret = i;
        } else {
            return {ret + 1, val - (1 << i)};
        }
    }
}

void solvenorm() {
    for(auto i : Q) {
        auto faf = max_bit(i.x);
        ans[i.num] = faf.ff;
        fans[i.num] = faf.ss;
    }
    for(int i = 0; i < q; ++i) {
        cout << ans[i] << " " << fans[i] << "\n";
    }
}

void solve() {
    cin >> n;
    v.resize(n);
    for(int i = 0; i < n; ++i) cin >> v[i];

    bool b = true;
    for(int i = 0; i < n; ++i) {
        if(v[i] != (1 << i)) b = false;
    }

    cin >> q;
    ans.resize(q);
    fans.resize(q);
    for(int i = 0; i < q; ++i) {
        int a;
        cin >> a;
        Q.pb(Query(a, i));
    }
    sort(all(Q));

    if(n == 60 && b) {
        solvenorm();
        return;
    }
    //for(auto i : Q) cout << i.x << " "; cout << "\n";
    int now = 0;
    int best = 0;
    int bbest = 0;
    for(auto i : Q) {
        while(now <= i.x) {
            int cbest = tr(now);
            if(cbest > bbest) {
                best = now;
                bbest = cbest;
            }
            now++;
        }
        ans[i.num] = best;
        fans[i.num] = bbest;
    }
    for(int i = 0; i < q; ++i) {
        cout << ans[i] << " " << fans[i] << "\n";
    }
}

//  #define lolipop

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#endif // lolipop
    fastio();
    solve();
    return 0;
}
