#include <bits/stdc++.h>

#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ff first
#define ss second
#define int long long

using namespace std;
typedef vector <int> vi;
typedef pair<int,int> pii;
typedef vector <pii> vii;
typedef vector <vi> vvi;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

bool good(int mask, int n) {
    if(n < 4) return true;
    vector <int> v;
    for(int i = 0; i < n; ++i) {
        v.pb( (mask & (1 << i)) != 0 );
    }
    for(int i = 0; i < n; ++i) v.pb(v[i]);
    for(int i = 0; i < n; ++i) {
        if(v[i] == 1 && v[i+1] == 1 && v[i+2] == 1 && v[i+3] == 1) {
            return false;
        }
    }
    // for(auto i : v) cout << i << " "; cout << "\n";
    return true;
}

int best(const vector <int>& v) {
    int bans = 0;
    int n = (int) v.size();
    for(int mask = 0; mask < (1 << n); ++mask) {
        if(good(mask, n)) {
            // cout << "mask = " << mask << "\n";
            int fans = 0;
            for(int i = 0; i < v.size(); ++i) {
                if( (mask & (1 << i)) >> i ) fans += v[i];
            }
            bans = max(bans, fans);
        }
    }
    return bans;
}

void solve() {
    int n;
    cin >> n;
    vi v(n);
    for(int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    cout << best(v) << "\n";
    int q;
    cin >> q;
    while(q--) {
        int a, b;
        cin >> a >> b;
        v[a-1] = b;
        cout << best(v) << "\n";
    }
}

// #define lolipop

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#endif // lolipop
    fastio();
    solve();
    return 0;
}
