#include<iostream>
#include<vector>
#include<map>
#include<cmath>
#include<algorithm>

using namespace std;

long long n, m, s;
vector<vector<int>> ms;
vector<vector<vector<int>>> h;

int ans(long long ser) {
	long long an = 0;
	for (int i = 0; i < m; i++) {
		vector<bool> g(2 * n - 1);
		long long k = ser - i * n;
		for (int j = 0; j < n; j++) {
			g[j] = (ms[i][j] < k);
		}
		for (int j = 0; j < n - 1; j++) {
			if (h[i][j][2] == 1) {
				g[n + j] = (g[h[i][j][0] - 1] & g[h[i][j][1] - 1]);
			}
			else {
				g[n + j] = (g[h[i][j][0] - 1] | g[h[i][j][1] - 1]);
			}
		}
		if (g[2 * n - 2]) {
			an++;
		}
	}
	return an;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin >> n >> m >> s;
	ms.resize(m, vector<int>(n, 0));
	h.resize(m, vector<vector<int>>(n - 1,vector<int>(3)));
	long long l = 0, r = n * m;
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n - 1; j++) {
			cin >> h[i][j][0]>> h[i][j][1] >> h[i][j][2];
		}
	}
	for (int i = 0; i < m; i++) {
		for (int j = 0; j < n ; j++) {
			cin >> ms[i][j];
		}
	}
	if (s == 0) {
		for (int i = 0; i < n; i++) {
			cout << "0 ";
		}
	}
	else {
		while (r - l > 1) {
			long long ser = (l + r) / 2;
			if (ans(ser) >= s) {
				r = ser;
			}
			else {
				l = ser;
			}
		}
		for (int i = 0; i < n; i++) {
			cout << max(min(r,m), (long long)0);
			r -= m;
		}
	}
} 

/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100

*/