#include "bits/stdc++.h"
#define ll long long
#define pb push_back
#define vi vector<ll>
#define vvi vector<vi>
#define pii pair<ll, ll>
#define ld long double
#define all(a) a.begin(), a.end()

const ll inf = 2e18;
const ld eps = 1e-7;

using namespace std;

void solve() {
    int n; cin >> n;
    vi speed(n), len(n);
    for (int i = 0; i < n; ++i) {
        cin >> speed[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> len[i];
    }
    int m; cin >> m;
    vector<ld> a(m);
    vi f(m);
    for (int i = 1; i < m; ++i) {
        cin >> a[i];
    }
    for (int i = 0; i < m; ++i) {
        cin >> f[i];
    }
    int q; cin >> q;
    for (int i = 0; i < q; ++i) {
        int s, t; cin >> s >> t;
        ld time = t - s;
        ld L = 0, R = inf;
        while (R - L > eps) {
            ld mid = (L + R) / 2;
            ld real = 0;
            for (int i = 0; i < n; ++i) {
                real += len[i] / (speed[i] + mid);
            }
            if (real + eps < time) R = mid;
            else L = mid;
        }
        int pos = lower_bound(all(a), L - eps) - a.begin();
        if (!pos) cout << "0\n";
        else cout << f[pos - 1] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}
