#include "bits/stdc++.h"
#define ll long long
#define pb push_back
#define vi vector<ll>
#define vvi vector<vi>
#define pii pair<ll, ll>
#define ld long double
#define all(a) a.begin(), a.end()

const ll inf = 2e18;
const ld eps = 1e-7;

using namespace std;

void solve() {
    int n; cin >> n;
    vi a(n), vals;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vals = a;
    sort(all(vals));
    vals.resize(unique(all(vals)) - vals.begin());
    for (int i = 0; i < n; ++i) {
        a[i] = lower_bound(all(vals), a[i]) - vals.begin();
    }
    vi last(n, -1);
    vi ans(n), dist(n);
    for (int i = 0; i < n; ++i) {
        ans[i] = (i + 1) * (n - i);
        if (last[a[i]] != -1) {
            if (i < n - 1) dist[i + 1] += 1;
            if (last[a[i]]) dist[n - last[a[i]]] += 1;
            dist[i - last[a[i]]] -= 1;
        }
        last[a[i]] = i;
    }
    int add = 0;
    int sum = 0;
    for (int i = 0; i < n; ++i) {
        sum += add;
        add += dist[i];
        sum += dist[i];
        ans[i] += sum;
    }
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    solve();
}
