#ifdef LOCAL
#define _GLIBCXX_DEBUG
#endif
#include "bits/stdc++.h"
#define ll long long
#define pb push_back
#define vi vector<ll>
#define vvi vector<vi>
#define pii pair<ll, ll>
#define ld long double
#define all(a) a.begin(), a.end()
#define mp make_pair

const ll inf = 2e18;
const ll iNF = 2e9;
const ld eps = 1e-7;
const ll MAXN = 4e5;

using namespace std;

ll dp[MAXN][4][4];

void solve(int n, vi &a) {
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j < 4; ++j) {
            for (int k = 0; k < 4; ++k) {
                dp[i][j][k] = -inf;
            }
        }
    }
    dp[0][0][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int k1 = 0; k1 < 4; ++k1) {
            for (int k2 = 0; k2 < 4; ++k2) {
                dp[i + 1][0][k2] = max(dp[i + 1][0][k2], dp[i][k1][k2]);
                if (k1 < 3) {
                    if (i == k1 && k1 == k2) dp[i + 1][k1 + 1][k2 + 1] = max(dp[i + 1][k1 + 1][k2 + 1], dp[i][k1][k2] + a[i]);
                    else if (i != k1) dp[i + 1][k1 + 1][k2] = max(dp[i + 1][k1 + 1][k2], dp[i][k1][k2] + a[i]);
                }
            }
        }
    }
    ll mx = -inf;
    for (int i = 0; i < 4; ++i) {
        for (int j = 0; j < 4; ++j) {
            if (i + j < 4) mx = max(mx, dp[n][i][j]);
        }
    }
    cout << mx << "\n";
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
#endif
    int n; cin >> n;
    vi a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    solve(n, a);
    int q; cin >> q;
    while (q--) {
        int p, v; cin >> p >> v; p--;
        a[p] = v;
        solve(n, a);
    }
}
