#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <cassert>
#include <cmath>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

#define int long long

using namespace std;

typedef long long ll;
typedef pair<int, int> pa;
typedef long double ld;

mt19937 rnd(228228);

struct go {
    int a, b, op;
};


int m, n, s;
vector<go> a;
vector<vector<int>> x;

int solve(vector<int> sr) {
    vector<vector<int>> pl(m, vector<int>(2));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < 2; ++j) {
            if (x[i][j] < sr[j])
                pl[i][j] = 1;
        }
    }
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        if (a[i].op == 1) {
            if (pl[i][0] & pl[i][1])
                ++ans;
        }
        else {
            if (pl[i][0] | pl[i][1])
                ++ans;
        }
    }
    return ans;
}

int solve1(vector<int> sr) {
    vector<vector<int>> pl(m, vector<int>(2));
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < 1; ++j) {
            if (x[i][j] < sr[j])
                ++ans;
        }
    }
    return ans;
}

signed main() {
    cin >> n >> m >> s;
    if (n == 1) {
        x.resize(m, vector<int>(n));
        for (vector<int>& i : x)
            for (int& j : i)
                cin >> j;
        for (int F = 0; F <= m; ++F) {
            int get = solve1({ F });
            if (get == s)
            {
                cout << F;
                return 0;
            }
        }
    }
    else {
        a.resize(m);
        for (int i = 0; i < m; ++i) {
            cin >> a[i].a >> a[i].b >> a[i].op;
        }
        x.resize(m, vector<int>(n));
        for (vector<int>& i : x)
            for (int& j : i)
                cin >> j;
        for (int F = 0; F <= m; ++F) {
            int l = 0, r = m + 1;
            while (l + 1 < r) {
                int md = (l + r) / 2;
                if (solve({ F, md }) <= s)
                    l = m;
                else
                    r = m;
            }
            if (solve({ F, l }) == s) {
                cout << F << " " << l;
                return 0;
            }
        }
    }
}