#include <iostream> 
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <cassert>
#include <map>
#define int long long

using namespace std;

typedef long double ld;
typedef pair<int, int> pa;

int n;
vector<int> a;
map<int, pa> mp;

pa solve(int b) {
    if (mp.count(b))
        return mp[b];
    if (!b)
        return { 0, 0 };
    int ps = upper_bound(a.begin(), a.end(), b) - a.begin();
    int nw = a[ps - 1];
    if (nw == 1)
        return { b, b };

    int ost = b % nw, pl = b / nw;

    pa f = solve(ost), s = solve(nw - 1);

    if (f.second + 1 >= s.second) {
        mp[b] = { f.first + pl * nw, f.second + pl };
    }
    else {
        mp[b] = { s.second + (pl - 1) * nw, s.second + pl - 1 };
    }
    return mp[b];
    
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    a.resize(n);
    for (int& i : a)
        cin >> i;
    int q;
    cin >> q;
    vector<pa> answer(q), ans(q);
    for (int i = 0; i < q; ++i) {
        cin >> answer[i].first;
        answer[i].second = i;
    }
    sort(answer.begin(), answer.end());
    for (pa i : answer) {
        ans[i.second] = solve(i.first);
    }
    for (pa& i : ans) {
        cout << i.first << " " << i.second << '\n';
    }
}