#include <bits/stdc++.h>

using namespace std;

vector<pair<int, int>> d;
vector<pair<int, int>> t;
int n;

void build(int v, int l, int r) {
    if (l + 1 == r) {
        t[v] = d[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m, r);
    t[v].second = t[2 * v].second + t[2 * v + 1].second;
    t[v].first = t[2 * v + 1].first + t[2 * v].first + (t[2 * v].second * (r - m));
    return;
}


void upd(int l, int r, int sgn) {
    if (l > r) return;
    d[l].first += sgn * 1;
    d[l].second += sgn;
    if (r + 1 < n) {
        d[r + 1].first -= sgn * (r - l + 2);
        d[r + 1].second -= sgn;
    }
    return;
}

int get(int v, int l, int r, int i) {
    if (l + 1 == r) {
        return t[v].first;
    }
    int m = (l + r) / 2;
    if (i < m) {
        return get(2 * v, l, m, i);
    }
    return get(2 * v + 1, m, r, i) + t[2 * v].first + (t[2 * v].second * (i + 1 - m));
}


int main()
{
    cin >> n;
    vector<int> a(n), pr(n);
    map<int, int> mp;
    d.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        pr[i] = mp[a[i]];
        mp[a[i]] = i + 1;
        upd(0, n - pr[i] - 1, 1);
        upd(i - pr[i] + 1, n - pr[i] - 1, -1);
        upd(n - i, n - pr[i] - 1, -1);
    }
    // for (auto elem : d) cout << elem.first << " " << elem.second << endl;
    t.resize(4 * n);
    build(1, 0, n);
    for (int i = 0; i < n; i++) {
        cout << get(1, 0, n, i) << " ";
    }
    cout << endl;
    return 0;
}
