#include <bits/stdc++.h>

using namespace std;

int n;
vector<long long> a;
vector<pair<long long, long long>> dp;
const int maxn = 2 * 1e5 + 10;
int anss1[maxn], anss2[maxn];
int cst[maxn];


int cost(int t) {
    int curr = n - 1, cnt = 0;
    while (curr >= 0 && t > 0) {
        int c = t / a[curr];
        t -= c * a[curr];
        cnt += c;
        curr--;
    }
    return cnt;
}



pair<long long, long long> get(long long t, int curr) {
    if (t == 0) return {0, 0};
    if (t < maxn) return {anss1[t], anss2[t]};
    if (a[curr] > t) while (a[curr] > t) curr--;
    if (a[curr] == t) {
        if (dp[curr].first != -1) return dp[curr];
        if (a[curr] < maxn) dp[curr] = {anss1[a[curr]], anss2[a[curr]]};
        else dp[curr] = get(a[curr] - 1, curr - 1);
        return dp[curr];
    }
    long long s1 = t / a[curr];
    if (dp[curr].first == -1) {
    if (a[curr] < maxn) dp[curr] = {anss1[a[curr]], anss2[a[curr]]};
    else dp[curr] = get(a[curr] - 1, curr - 1);
    }
    pair<long long, long long> x = dp[curr];
    pair<long long, long long> ans = {x.first + (a[curr] * (t - 1)), s1 - 1 + x.second};
    pair<long long, long long> ans1 = get(t % a[curr], curr - 1);
    ans.second += s1;
    ans.first += s1 * a[curr];
    if (ans1.second > ans.second) ans = ans1;
    return ans;
}

int32_t main()
{
    cin >> n; a.resize(n);
    bool check1 = true, check2 = true, check3 = true;
    bool check4 = true;
    if (n > 500) check1 = false;
    if (n != 60) check2 = false;
    vector<long long> pw(60);
    pw[0] = 1;
    for (int i = 1; i < 60; i++) pw[i] = pw[i - 1] * (long long)2;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (check2 && a[i] != pw[i]) check2 = false;
        if (a[i] > 500) check1 = false;
    }
    int q;
    cin >> q;
    if (q > 5) {
        check1 = false;
        check2 = false;
        check3 = false;
        check4 = false;
    }
    vector<long long> b(q);
    for (int i = 0; i < q; i++) {
        cin >> b[i];
        if (b[i] > 500) check1 = false;
        if (b[i] > 2 * 1e5) check3 = false;
    }
    if (check3) {
        const int maxn = 2 * 1e5 + 10;
        int ans1[maxn], ans2[maxn];
        int cst[maxn];
        cst[1] = 1;
        cst[0] = 0;
        ans1[1] = 1;
        ans2[1] = 1;
        for (int i = 2; i < maxn; i++) {
            int ind = upper_bound(a.begin(), a.end(), i) - a.begin() - 1;
            if (ind < 0) ind = 0;
            if (ind >= n) ind = n - 1;
            if (a[ind] <= i) cst[i] = cst[i - a[ind]] + 1;
            if (ans2[i - 1] > cst[i]) {
                ans1[i] = ans1[i - 1];
                ans2[i] = ans2[i - 1];
            }
            else {
                ans1[i] = i;
                ans2[i] = cst[i];
            }
        }
        for (int i = 0; i < q; i++) {
            if (b[i] > 2 * 1e5) b[i] = 2 * 1e5;
            cout << ans1[b[i]] << " " << ans2[b[i]] << endl;
        }
        return 0;
    }
    if (check2) {
        for (int i = 0; i < q; i++) {
            for (int j = n - 1; j >= 0; j--) {
                if (a[j] - 1 <= b[i]) {
                    cout << a[j] - 1 << " " << j << endl;
                    break;
                }
            }
        }
        return 0;
    }
    if (check4) {
        cst[1] = 1;
        cst[0] = 0;
        anss1[1] = 1;
        anss2[1] = 1;
        for (int i = 2; i < maxn; i++) {
            int ind = upper_bound(a.begin(), a.end(), i) - a.begin() - 1;
            if (ind < 0) ind = 0;
            if (ind >= n) ind = n - 1;
            if (a[ind] <= i) cst[i] = cst[i - a[ind]] + 1;
            if (anss2[i - 1] > cst[i]) {
                anss1[i] = anss1[i - 1];
                anss2[i] = anss2[i - 1];
            }
            else {
                anss1[i] = i;
                anss2[i] = cst[i];
            }
        }
        dp.resize(n, {-1, -1});
        dp[0] = {0, 0};
        for (int i = 0; i < 5000 && i < n; i++) {
            if (a[i] < maxn) dp[i] = {anss1[a[i]], anss2[a[i]]};
            else dp[i] = get(a[i] - 1, i - 1);
        }
        for (int i = 0; i < q; i++) {
            pair<long long, long long> ans = get(b[i], n - 1);
            cout << ans.first << " " << ans.second << endl;
        }
    }
}
