#include <iostream>
#include <math.h>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long
#define inf (int)1'000'000'007

int32_t main()
{
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	vector<int> b = a;
	sort(all(b));
	b.resize(unique(all(b)) - b.begin());
	map<int, int> back;

	for (int i = 0; i < b.size(); i++) back[b[i]] = i;
	for (int i = 0; i < n; i++) a[i] = back[a[i]];

	vector<int> last(n, -1);
	vector<int> prev(n, -1);

	for (int i = 0; i < n; i++)
	{
		prev[i] = (i - last[a[i]]);
		last[a[i]] = i;
	}

//	sort(all(prev));

	vector<int> ans(n, 0);
	ans[0] = n;
	vector<int> kolvo(n, 0);
	int curr = 1;
	kolvo[a[n - 1]] = 1;
	for (int i = 1; i < n; i++)
	{
		ans[i] = ans[i - 1] - curr;
		if (kolvo[a[n - i - 1]] == 0) curr++;
		kolvo[a[n - i - 1]]++;

		for (auto j : prev) if (j > i) ans[i]++;
	}
	for (auto i : ans) cout << i << " ";
	return 0;
}




