#include <iostream>
#include <math.h>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long
#define inf (int)1'000'000'007

vector<vector<pair<pair<int, int>, int>>> operations;
vector<vector<int>> table;
vector<int> ans;
int n, m, s;

int check()
{
	int ret = 0;
	for (int i = 0; i < m; i++)
	{
		vector<bool> curr(n + n, false);
		for (int j = 0; j < n; j++) curr[j + 1] = (table[i][j] < ans[j]);
		for (int j = n + 1; j < n + n; j++)
		{
			auto now = operations[i][j - n - 1];
			if (now.y == 1) curr[j] = (curr[now.x.x] & curr[now.x.y]);
			else curr[j] = (curr[now.x.x] | curr[now.x.y]);
		}
		if (curr[n + n - 1]) ret++;
	}

	return ret;
}

int32_t main()
{
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	cin >> n >> m >> s;
	if (s == 0)
	{
		cout << "0 0";
		return 0;
	}
	operations.resize(m, vector<pair<pair<int, int>, int>>(n));
	int kolvo = 0;
	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < n - 1; j++)
		{
			cin >> operations[i][j].x.x >> operations[i][j].x.y >> operations[i][j].y;
			if (operations[i][j].y == 2) kolvo++;
		}
	}
	if (n == 1)
	{
		cout << s;
		return 0;
	}

	table.resize(m, vector<int>(n));
	bool flag = true;
	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < n; j++)
		{
			cin >> table[i][j];
			if (table[i][j] != i) flag = false;
		}
	}

	if (n == 2)
	{
		if (kolvo >= s)
		{
			cout << 0 << " ";
			vector<int> useor;
			for (int i = 0; i < m; i++) if (operations[i][0].y == 2) useor.push_back(table[i][1]);
			sort(all(useor));
			cout << useor[s - 1] + 1;
			return 0;
		}
		s -= kolvo;
		cout << m << " ";
		vector<int> useand;
		for (int i = 0; i < m; i++) if (operations[i][0].y == 1) useand.push_back(table[i][1]);
		sort(all(useand));
		cout << useand[s - 1] + 1;
		return 0;
	}
	if (kolvo == 0)
	{
		for (int i = 0; i < n - 1; i++) cout << m << " ";
		cout << s;
		return 0;
	}
	if (flag)
	{
		for (int i = 0; i < n; i++) cout << s << " ";
		return 0;
	}

	
	if (n <= 100)
	{
		ans.resize(n);
		for (int i = 0; i < n; i++)
		{
			ans[i] = m;
			if (check() < s) continue;
			for (int j = 1; j < m; j++)
			{
				ans[i] = j;
				if (check() == s) break;
			}
			for (auto i : ans) cout << i << " ";
			return 0;
		}
		return 0;
	}
	return 0;
}




