#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long
#define inf 1'000'000'000'000'000'000ll


int32_t main()
{
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);

	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	if (n == 1)
	{
		int q;
		cin >> q;
		for (int i = 0; i < q; i++)
		{
			int tmp;
			cin >> tmp;
			cout << tmp << " " << tmp << '\n';
		}
		return 0;
	}
	
	vector<pair<int, int>> mxnumber(n);
	mxnumber[0] = { a[1] - 1, a[1] - 1 };
	for (int i = 1; i < n - 1; i++)
	{
		mxnumber[i] = mxnumber[i - 1];
		if (a[i] + mxnumber[i - 1].x < a[i + 1])
		{
			mxnumber[i].x = mxnumber[i - 1].x + a[i];
			mxnumber[i].y = mxnumber[i - 1].y + 1;
			int length = a[i + 1] - mxnumber[i].x - 1;
			int add = length / a[i];
			mxnumber[i].x += add * a[i];
			mxnumber[i].y += add;
		}
	}

	int q;
	cin >> q;
	for (int ttt = 0; ttt < q; ttt++)
	{
		int x;
		cin >> x;
		if (x < a[1])
		{
			cout << x << " " << x << '\n';
			continue;
		}
		int l = 0, r = n, m;
		while (r - l > 1)
		{
			m = (r + l) / 2;
			if (a[m] <= x) l = m;
			else r = m;
		}
		auto tmp = mxnumber[l - 1];

		if (a[l] + mxnumber[l - 1].x <= x)
		{
			tmp.x = mxnumber[l - 1].x + a[l];
			tmp.y = mxnumber[l - 1].y + 1;
			int length = x - mxnumber[l].x;
			int add = length / a[l];
			tmp.x += add * a[l];
			tmp.y += add;
		}
		/*
		if (a[i] + mxnumber[i - 1].x < a[i + 1])
		{
			mxnumber[i].x = mxnumber[i - 1].x + a[i];
			mxnumber[i].y = mxnumber[i - 1].y + 1;
			int length = a[i + 1] - mxnumber[i].y - 1;
			int add = length / a[i];
			mxnumber[i].x += add * a[i];
			mxnumber[i].y += add;
		}
		*/
		
		cout << tmp.x << " " << tmp.y << '\n';
	}

	return 0;
}