#include <iostream>
#include <math.h>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long
#define inf 200000


vector<int> a;
int n;

int solve()
{
	if (n < 4)
	{
		int s = 0;
		for (int i = 0; i < n; i++) s += a[i];
		return s;
	}
	int mx = 0;
	for (int i = 0; i < 4; i++)
	{
		vector<vector<int>> dp(n + 1, vector<int>(4, 0));

		int summ = 0;
		for (int j = 1; j <= i; j++)
		{
			summ += a[j - 1];
			dp[j][j] = summ;
		}
		for (int j = max(i + 1, 2ll); j <= n; j++)
		{
			dp[j][0] = dp[j - 1][0];
			for (int k = 1; k < 4; k++) dp[j][0] = max(dp[j][0], dp[j - 1][k]);
			for (int k = 1; k < 4; k++) dp[j][k] = dp[j - 1][k - 1] + a[j - 1];
		}

		for (int j = 0; j < 4 - i; j++) mx = max(mx, dp[n][j]);
		
	}
	return mx;
}

int32_t main()
{
	cin.tie(NULL);
	cout.tie(NULL);
	ios::sync_with_stdio(false);
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	cout << solve() << '\n';
	int q;
	cin >> q;
	for (int i = 0; i < q; i++)
	{
		int p, q;
		cin >> p >> q;
		a[p - 1] = q;
		cout << solve() << '\n';
	}
	return 0;
}