#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> res;

void gen(vector<int> &now, int max_n) {
    if (now.size() == max_n)
        res.push_back(now);
    else {
        for (int i = 0; i < 3; ++i) {
            now.push_back(i);
            gen(now, max_n);
            now.pop_back();
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, s;
    cin >> n >> m >> s;

    if (n == 1) {
        cout << s << '\n';
        return 0;
    }

    int c[m][n];
    vector<vector<int>> a(m), b(m), op(m);
    for (int i = 0; i < m; ++i) {
        a[i].resize(n - 1);
        b[i].resize(n - 1);
        op[i].resize(n - 1);
    }

    bool found_or = false;

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];
            --a[i][j], --b[i][j];
            if (op[i][j] == 2)
                found_or = true;
        }
    }

    if (!found_or) {
        cout << s << " ";
        for (int i = 0; i < n - 1; ++i)
            cout << m << " ";
        cout << '\n';
        return 0;
    }

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j)
            cin >> c[i][j];
    }

    if (n <= 10 && m <= 2) {
        vector<int> emt;
        gen(emt, n);

        int val[2 * n - 1];

        for (int k = 0; k < res.size(); ++k) {
            int sum = 0;
            for (int i = 0; i < m; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (c[i][j] < res[k][j])
                        val[j] = 1;
                    else
                        val[j] = 0;
                }
                for (int j = 0; j < n - 1; ++j) {
                    if (op[i][j] == 1)
                        val[n + j] = val[a[i][j]] & val[b[i][j]];
                    else
                        val[n + j] = val[a[i][j]] | val[b[i][j]];
                }
                sum += val[2 * n - 2];
            }
            if (sum == s) {
                for (int j : res[k])
                    cout << j << ' ';
                return 0;
            }
        }
    }

    int left = 0, right = m + 1, mid;

    while (right - left > 1) {
//    for (int mid = 0; mid <= m; ++mid) {
        mid = (left + right) / 2;
        int now = 0;
        for (int i = 0; i < m; ++i) {
            if (op[i][0] == 2 && c[i][0] < mid)
                ++now;
        }

        if (now > s) {
            right = mid;
            continue;
        }

        if (now == s) {
            cout << mid << " " << 0 << '\n';
            return 0;
        }

        vector<int> cur;
        for (int i = 0; i < m; ++i) {
            if ((op[i][0] == 2 && c[i][0] >= mid) || (op[i][0] == 1 && c[i][0] < mid))
                cur.push_back(c[i][1]);
        }

        sort(cur.begin(), cur.end());
        if (now + cur.size() < s)
            left = mid;
        else {
            cout << mid << " " << cur[s - now - 1] + 1 << '\n';
            return 0;
        }
    }

    mid = left;

    vector<int> cur;
    for (int i = 0; i < m; ++i) {
        if ((op[i][0] == 2 && c[i][0] >= mid) || (op[i][0] == 1 && c[i][0] < mid))
            cur.push_back(c[i][1]);
    }

    int now = 0;
    for (int i = 0; i < m; ++i) {
        if (op[i][0] == 2 && c[i][0] < mid)
            ++now;
    }

    if (now == s) {
        cout << mid << " " << 0 << "\n";
        return 0;
    }

    sort(cur.begin(), cur.end());
    if (now + cur.size() < s)
        assert(false);
    else {
        cout << mid << " " << cur[s - now - 1] + 1 << '\n';
        return 0;
    }

    return 0;
}

