#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> res;

void gen(vector<int> &now, int max_n) {
    if (now.size() == max_n)
        res.push_back(now);
    else {
        for (int i = 0; i < 3; ++i) {
            now.push_back(i);
            gen(now, max_n);
            now.pop_back();
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, s;
    cin >> n >> m >> s;

    if (n == 1) {
        cout << s << '\n';
        return 0;
    }

    int c[m][n];
    vector<vector<int>> a(m), b(m), op(m);
    for (int i = 0; i < m; ++i) {
        a[i].resize(n - 1);
        b[i].resize(n - 1);
        op[i].resize(n - 1);
    }

    bool found_or = false;
    bool found_i1 = false;

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];
            --a[i][j], --b[i][j];
            if (op[i][j] == 2)
                found_or = true;
        }
    }

    if (!found_or) {
        cout << s << " ";
        for (int i = 0; i < n - 1; ++i)
            cout << m << " ";
        cout << '\n';
        return 0;
    }

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> c[i][j];
            if (c[i][j] != i)
                found_i1 = true;
        }
    }

    if (!found_i1) {
        for (int i = 0; i < n; ++i)
            cout << s << " ";
        return 0;
    }

    //cout << "aa";

        int val[2 * n - 1];

        int left = -1, right = n * m, mid;
        while (true) {
            mid = (left + right) / 2;
            vector<int> res(n);
            int nnow = 0;
            for (int i = 0; i < n; ++i) {
                if (nnow + m < mid) {
                    nnow += m;
                    res[i] = m;
                }
                else {
                    res[i] = mid - nnow;
                    nnow = mid;
                }
            }
            int sum = 0;
            for (int i = 0; i < m; ++i) {
                for (int j = 0; j < n; ++j) {
                    if (c[i][j] < res[j])
                        val[j] = 1;
                    else
                        val[j] = 0;
                }
                for (int j = 0; j < n - 1; ++j) {
                    if (op[i][j] == 1)
                        val[n + j] = val[a[i][j]] & val[b[i][j]];
                    else
                        val[n + j] = val[a[i][j]] | val[b[i][j]];
                }
                sum += val[2 * n - 2];
            }
            if (sum == s) {
                for (int j : res)
                    cout << j << ' ';
                return 0;
            }
            if (sum > s) {
                right = mid;
            }
            else if (sum < s) {
                left = mid;
            }
            if (left + 1 == right) {
                left = right;
            }
        }

    return 0;
}
