#include <bits/stdc++.h>
using namespace std;

int n;
vector<int> a;
vector<vector<long long>> dp0, dp1, dp2, dp3;

void cnt_dp() {
    int n = (int)a.size();

    for (int i = 1; i < n; ++i) {

        dp0[i][0] = max({dp0[i - 1][0], dp0[i - 1][1], dp0[i - 1][2], dp0[i - 1][3]});
        dp0[i][1] = a[i] + dp0[i - 1][0];

        dp1[i][0] = max({dp1[i - 1][0], dp1[i - 1][1], dp1[i - 1][2], dp1[i - 1][3]});
        dp1[i][1] = a[(i + 1) % n] + dp1[i - 1][0];

        dp2[i][0] = max({dp2[i - 1][0], dp2[i - 1][1], dp2[i - 1][2], dp2[i - 1][3]});
        dp2[i][1] = a[(i + 2) % n] + dp2[i - 1][0];

        dp3[i][0] = max({dp3[i - 1][0], dp3[i - 1][1], dp3[i - 1][2], dp3[i - 1][3]});
        dp3[i][1] = a[(i + 3) % n] + dp3[i - 1][0];

        if (i >= 2) {
            dp0[i][2] = a[i] + a[i - 1] + dp0[i - 2][0];
            dp1[i][2] = a[(i + 1) % n] + a[i] + dp1[i - 2][0];
            dp2[i][2] = a[(i + 2) % n] + a[(i + 1) % n] + dp2[i - 2][0];
            dp3[i][2] = a[(i + 3) % n] + a[(i + 2) % n] + dp3[i - 2][0];
        }
        if (i >= 3) {
            dp0[i][3] = a[i] + a[i - 1] + a[i - 2] + dp0[i - 3][0];
            dp1[i][3] = a[(i + 1) % n] + a[i] + a[i - 1] + dp1[i - 3][0];
            dp2[i][3] = a[(i + 2) % n] + a[(i + 1) % n] + a[i] + dp2[i - 3][0];
            dp3[i][3] = a[(i + 3) % n] + a[(i + 2) % n] + a[(i + 1) % n] + dp3[i - 3][0];
        }
    }

}

long long find_mx() {
    long long mx = 0;
    for (int i = 0; i < 4; ++i) {
        mx = max({mx, dp0[n - 1][i], dp1[n - 1][i], dp2[n - 1][i], dp3[n - 1][i]});
    }
    return mx;
}

long long get() {
    vector<int> now(a.size() * 2);

    int n = (int)a.size();

    long long res = 0;

    for (int mask = 0; mask < (1 << n); ++mask) {
        for (int i = 0; i < n; ++i) {
            if (mask & (1 << i))
                now[i] = now[i + n] = 1;
            else
                now[i] = now[i + n] = 0;
        }
        bool found = false;
        for (int i = 3; i < n * 2; ++i) {
            if (now[i] & now[i - 1] & now[i - 2] & now[i - 3])
                found = true;
        }
        if (!found) {
            long long cur = 0;
            for (int i = 0; i < n; ++i) {
                if (now[i]) {
                    cur += a[i];
                }
            }
            res = max(res, cur);
        }
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int q;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    cin >> q;

    if (n <= 5) {
        cout << get() << '\n';

        while (q--) {
            int p, v;
            cin >> p >> v;
            a[p - 1] = v;
            cout << get() << '\n';
        }

        return 0;
    }

    dp0.resize(n + 1);
    dp1.resize(n + 1);
    dp2.resize(n + 1);
    dp3.resize(n + 1);

    for (int i = 0; i < dp0.size(); ++i) {
        dp0[i].resize(4);
        dp1[i].resize(4);
        dp2[i].resize(4);
        dp3[i].resize(4);
    }

    cnt_dp();

    cout << find_mx() << '\n';

    while (q--) {
        int p, v;
        cin >> p >> v;
        a[p - 1] = v;
        cnt_dp();
        cout << find_mx() << '\n';
    }


    return 0;
}
