#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#define sz(x) (int)x.size()
#define fi first
#define se second
#define vi vector<int>
#define all(x) x.begin(), x.end()
#define vvi vector<vector<int>>
#define ve vector
#define pii pair<int, int>
#pragma GCC optimize("Ofast", "unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse4,ssse3,popcnt")

using namespace std;
const int INF = 1e9;
const double E = 1e-7;

int main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int n, k;
	cin >> n;
	ve<double> le(n), sp(n);
	for (int i = 0; i < n; ++i) cin >> sp[i];
	for (int i = 0; i < n; ++i) cin >> le[i];
	int m;
	cin >> m;
	ve<pii> fin(m + 1, {0, 0});
	for (int i = 1; i < m; ++i) cin >> fin[i].fi;
	for (int i = 1; i <= m; ++i) cin >> fin[i].se;
	fin.back().fi = INF;
	int q;
	cin >> q;
	int t1, t2;
	double t;
	// for (auto p : fin) {
	// 	cout << "{" << p.fi << ", " << p.se << "}; ";
	// }
	// cout << endl;
	while (q--) {
		cin >> t1 >> t2;
		t = t2 - t1;
		int mx = 0;
		int l = -1, r = m, mm;
		while (r > (l + 1)) {
			mm = (l + r) / 2;
			double nt = 0;
			for (int i = 0; i < n; ++i) {
				nt += le[i] / (sp[i] + (double)fin[mm].fi);
			}
			// cout << l << ' ' << r << ' ' << mm << ' ' << nt << endl;
			if (nt > t) l = mm;
			else r = mm;
		}

		cout << fin[r].se << endl;
	}
	return 0;
}