#include <iostream>
#include <vector>
#include <string>
#include <math.h>
#define ll long long
#define pb emplace_back
#define sz(x) (int)x.size()
#define fi first
#define se second
#define vi vector<int>
#define all(x) x.begin(), x.end()
#define vvi vector<vector<int>>
#define ve vector
#define pii pair<int, int>
#pragma GCC optimize("Ofast", "unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse4,ssse3,popcnt")

using namespace std;
const int INF = 1e9;

ll best(const ve<ll> &ar) {
	ll ans = 0;
	int n = sz(ar);
	{
		ve<ve<ll>> dp(n, ve<ll>(4, -INF));
		dp[0][0] = 0;
		for (int i = 1; i < n; ++i) {
			dp[i][0] = max(max(dp[i - 1][0], dp[i - 1][1]), max(dp[i - 1][2], dp[i - 1][3]));
			dp[i][1] = dp[i - 1][0] + ar[i];
			dp[i][2] = dp[i - 1][1] + ar[i];
			dp[i][3] = dp[i - 1][2] + ar[i];
		}
		ans = max(ans, dp[n - 1][0]);
		ans = max(ans, dp[n - 1][1]);
		ans = max(ans, dp[n - 1][2]);
		ans = max(ans, dp[n - 1][3]);
	}
	{
		ve<ve<ll>> dp(n, ve<ll>(4, -INF));
		dp[1][0] = ar[0];
		for (int i = 2; i < n; ++i) {
			dp[i][0] = max(max(dp[i - 1][0], dp[i - 1][1]), max(dp[i - 1][2], dp[i - 1][3]));
			dp[i][1] = dp[i - 1][0] + ar[i];
			dp[i][2] = dp[i - 1][1] + ar[i];
			dp[i][3] = dp[i - 1][2] + ar[i];
		}
		ans = max(ans, dp[n - 1][0]);
		ans = max(ans, dp[n - 1][1]);
		ans = max(ans, dp[n - 1][2]);
	}
	{
		ve<ve<ll>> dp(n, ve<ll>(4, -INF));
		dp[2][0] = ar[0] + ar[1];
		for (int i = 3; i < n; ++i) {
			dp[i][0] = max(max(dp[i - 1][0], dp[i - 1][1]), max(dp[i - 1][2], dp[i - 1][3]));
			dp[i][1] = dp[i - 1][0] + ar[i];
			dp[i][2] = dp[i - 1][1] + ar[i];
			dp[i][3] = dp[i - 1][2] + ar[i];
		}
		ans = max(ans, dp[n - 1][0]);
		ans = max(ans, dp[n - 1][1]);
	}
	{
		ve<ve<ll>> dp(n, ve<ll>(4, -INF));
		dp[3][0] = ar[0] + ar[1] + ar[2];
		for (int i = 4; i < n; ++i) {
			dp[i][0] = max(max(dp[i - 1][0], dp[i - 1][1]), max(dp[i - 1][2], dp[i - 1][3]));
			dp[i][1] = dp[i - 1][0] + ar[i];
			dp[i][2] = dp[i - 1][1] + ar[i];
			dp[i][3] = dp[i - 1][2] + ar[i];
		}
		ans = max(ans, dp[n - 1][0]);
	}
	return ans;
}

int main() {
	cin.tie(nullptr);
	cout.tie(nullptr);
	ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	ve<ll> ar(n);
	for (int i = 0; i < n; ++i) cin >> ar[i];
	cout << best(ar) << '\n';
	int q, i;
	ll x;
	cin >> q;
	while (q--) {
		cin >> i >> x;
		i--;
		ar[i] = x;
		cout << best(ar) << '\n';
	}
	return 0;
}