#include <iostream>
#include <vector>
#include <unordered_set>
using namespace std;

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    vector <int> line(n);
    for (int& i : line)
        cin >> i;

    vector <int> ans(n);

    for (int i = 0; i < n; i++) {
        unordered_set <int> now;
        int s = 0;
        for (int j = 1; i + j <= n; j++) {
            if (now.find(line[i + j - 1]) == now.end())
                s++;
            now.insert(line[i + j - 1]);
            ans[j - 1] += s;
        }
    }

    for (int i : ans)
        cout << i << " ";
    cout << endl;
    return 0;
}
