#include <iostream>
#include <vector>
using namespace std;

signed main() {
    int n;
    cin >> n;
    vector <int> line(n);
    for (int& i : line)
        cin >> i;
    vector <int> ans(n);
    for (int i = 0; i < n; i++)
        ans[i] = (i + 1) * (n - i);

    vector <int> delta(n + 2);
    vector <int> after(n + 2);

    for (int j = n - 1; j > -1; j--) {
        for (int i = j - 1; i > -1; i--) {
            if (line[i] == line[j]) {
                int d = j - i + 1;
                delta[d]--;
                int going = min(n - j - 1, i);
                after[going + d]++;
                if (going > 0) {
                    after[n - going]++;
                }
                break;
            }
        }
    }

    int del = 0, d = 0;
    for (int i = 0; i < n; i++) {
        d += delta[i + 1];
        del += d;
        ans[i] += del;
        d += after[i + 1];
    }

    for (int i : ans)
        cout << i << " ";
    cout << endl;
    return 0;
}
