#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int N = 3010 * 3010;
vector <int> cnt[N];

signed main() {
    int n, x;
    cin >> n >> x;
    for (int c = 1; c < n; c++) {
        for (int d = 1; d < n; d++) {
            cnt[c * d + n].push_back(c);
        }
    }

    int ans = 0;
    for (int a = 2; a <= n; a++) {
        for (int b = 2; b <= n; b++) {
            if (a == x || b == x)
                continue;
            auto right = lower_bound(cnt[a * b].begin(), cnt[a * b].end(), a);
            auto left = upper_bound(cnt[a * b].begin(), cnt[a * b].end(), (a * b - n) / b);
            ans += max((int)(right - left), 0);
        }
    }
    cout << ans << endl;
    return 0;
}
