#include <iostream>
#include <vector>
using namespace std;

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    vector <int> line(n);
    for (int& i : line)
        cin >> i;

    vector <int> can(n - 1);
    for (int i = 0; i < n - 1; i++)
        can[i] = (line[i + 1] - 1) / line[i];

    vector <int> pref_can(n);
    pref_can[0] = 0;
    for (int i = 0; i < n - 1; i++) {
        pref_can[i + 1] = pref_can[i] + line[i] * can[i];
    }

    vector <int> pref_cnt(n);
    pref_cnt[0] = 0;
    for (int i = 0; i < n - 1; i++) {
        pref_cnt[i + 1] = pref_cnt[i] + can[i];
    }

    int q;
    cin >> q;
    while (q--) {
        int b;
        cin >> b;
        int l = 0, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (pref_can[m] > b)
                r = m;
            else
                l = m;
        }
        int ans = pref_can[l], money = pref_cnt[l];
        int more = (b - ans) / line[l];
        ans += more * line[l];
        money += more;
        cout << ans << " " << money << "\n";
    }
    return 0;
}
