#include <iostream>
#include <vector>
using namespace std;

const int N = 2e5 + 100;

signed main() {
    int n;
    cin >> n;
    vector <int> line(n);
    for (int& i : line)
        cin >> i;

    vector <int> need(N);
    for (int i = 1; i < N; i++) {
        int l = 0, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (line[m] > i)
                r = m;
            else
                l = m;
            need[i] = need[i - line[l]] + 1;
        }
    }

    vector <pair <int, int>> mx(N);
    int mxy = 0, ind = 0;
    for (int i = 1; i <= N; i++) {
        if (need[i] > mxy) {
            mxy = need[i], ind = i;
        }
        mx[i] = {mxy, ind};
    }

    int q;
    cin >> q;
    while (q--) {
        int b;
        cin >> b;
        cout << mx[b].second << " " << mx[b].first << endl;
    }
    return 0;
}
