#include <iostream>
#include <vector>
#define int long long
using namespace std;

const int N = 2e5 + 100;

signed main() {
    int n;
    cin >> n;
    vector <int> line(n);
    for (int& i : line)
        cin >> i;

    if (n == 60) {
        bool is_2 = true;
        for (int i = 0; i < n; i++)
            if (line[i] != ((long long) 1 << (i - 1)))
                is_2 = false;
        if (is_2) {
            int q;
            cin >> q;
            while (q--) {
                int a;
                cin >> a;
                int ans = 0;
                while (a) {
                    if (a % 2 == 1)
                        ans++;
                    a /= 2;
                }
                cout << ans << endl;
            }
            return 0;
        }
    }
    vector <int> need(N);
    need[0] = 0;
    for (int i = 1; i < N; i++) {
        int l = 0, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (line[m] > i)
                r = m;
            else
                l = m;
        }
        need[i] = need[i - line[l]] + 1;
    }

    vector <pair <int, int>> mx(N);
    int mxy = 0, ind = 0;
    for (int i = 1; i < N; i++) {
        if (need[i] > mxy) {
            mxy = need[i], ind = i;
        }
        mx[i] = {mxy, ind};
    }

    int q;
    cin >> q;
    while (q--) {
        int b;
        cin >> b;
        cout << mx[b].second << " " << mx[b].first << endl;
    }
    return 0;
}
