#include <iostream>
#include <vector>
#define int long long
using namespace std;

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    vector <int> line(n);
    for (int& i : line)
        cin >> i;

    vector <int> can(n - 1);
    for (int i = 0; i < n - 1; i++)
        can[i] = (line[i + 1] - 1) / line[i];

    vector <int> pref_can(n - 1);
    if (n > 1)
        pref_can[0] = line[0] * can[0];
    for (int i = 1; i < n - 1; i++) {
        pref_can[i] = pref_can[i - 1] + line[i] * can[i];
    }

    vector <int> pref_cnt(n - 1);
    if (n > 1)
        pref_cnt[0] = can[0];
    for (int i = 1; i < n - 1; i++) {
        pref_cnt[i] = pref_cnt[i - 1] + can[i];
    }

    int q;
    cin >> q;
    while (q--) {
        int b;
        cin >> b;
        int l = -1, r = n - 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (pref_can[m] >= b)
                r = m;
            else
                l = m;
        }

        int ans = 0, money = 0;
        if (r > 0)
            ans = pref_can[l], money = pref_cnt[l];

        for (int i = n - 1; i > l; i--) {
            int more = (b - ans) / line[r];
            ans += more * line[r];
            money += more;
        }
        cout << ans << " " << money << "\n";
    }
    return 0;
}
