#include <bits/stdc++.h>


using namespace std;


inline vector<int> input(int n){
    vector<int> rt(n);
    for (int i = 0; i < n; ++i){
        cin >> rt[i];
    }
    return rt;
}


long long int max_color(vector<int> picture){
    int color = 0, n = picture.size();
    vector<vector<int>> dp(n, vector<int>(4, 0));
    for (int i = 1; i < n; ++i){
        for (int j = 0; j < 4; ++j){
            dp[i][0] = max(dp[i - 1][j], dp[i][0]);
        }
        for (int j = 1; j < 4; ++j){
            dp[i][j] = dp[i - 1][j - 1] + picture[i];
        }
    } /*
    for (int elem : picture){
        cerr << elem << " ";
    }
    cerr << "\n";
    for (auto vec : dp){
        for (int elem : vec){
            cerr << elem << " ";
        }
        cerr << "\n";
    } //*/
    long long int result = 0;
    for (int i = 0; i < 4; ++i){
        if (result < dp.back()[i]){
            result = dp.back()[i];
        }
    }
    return result;
}


long long int circle_max_color(vector<int> picture){
    long long int result = 0, n = picture.size();
    for (int i = 0; i < 4; ++i){
        vector<int> temp(n);
        for (int j = 0; j < n; ++j){
            temp[j] = picture[(i + j)%n];
        }
        result = max(result, max_color(temp));
    }
    return result;
}

int main(){
    int n; cin >> n;
    vector<int> a = input(n);
    cout << circle_max_color(a);
/*
    for (int i = 0; i < 100; ++i){
        vector<int> a = input(n);
        cerr << max_color(a) << "\n";
    }  //*/
    //int q; cin >> q;
    //for (int i = 0; i < n; ++i){
    //    int elem; cin >> elem;
    //
    //}


}

