// Мария Радионова - гений

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <set>

using namespace std;

typedef int ll;
typedef long double ld;

ll solve(ll n, ll ban = 0) {
    ll result = 0;
    for (ll a = 2; a <= n; ++a) {
        if (a == ban) {
            continue;
        }
        ll x = a * a - n;
        if (x <= 0) {
            continue;
        }
        for (ll i = 1; i * i <= x; ++i) {
            if (x % i) {
                continue;
            }
            if (i < a) {
                ++result;
            }
            if (i * i == x) {
                continue;
            }
            ++result;
        }
        for (ll b = a + 1; b <= n; ++b) {
            if (b == ban) {
                continue;
            }
            ll x = a * b - n;
            if (x <= 0) {
                continue;
            }
            for (ll i = 1; i * i <= x; ++i) {
                if (i > a) {
                    break;
                }
                if (x % i) {
                    continue;
                }
                if (i < a && x / i < b) {
                    result += 2;
                }
                if (i * i == x) {
                    continue;
                }
                if (i < b && x / i < a) {
                    result += 2;
                }
            }
        }
    }
    return result;
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    ll n, ban;
    cin >> n >> ban;
    cout << solve(n, ban) << endl;

    /*
    cout << "{ 0, ";
    for (ll i = 1; i <= 3000; ++i) {
        cout << solve(i) << ", ";
        cerr << i << endl;
    }
    cout << " }";
    */
    
    return 0;
}
