// Мария Радионова - гений

#include <algorithm>
#include <iostream>
#include <vector>
#include <string>
#include <queue>
#include <set>

using namespace std;

typedef int ll;
typedef long double ld;

const ll INF = (ll)(8e18) + 666;
const ll N = 3000;

vector<ll> cnt[N * N];

ll solve(ll n, ll ban = 0) {
    ll result = 0;
    for (ll a = 1; a < n; ++a) {
        if (a == ban) {
            continue;
        }
        for (ll b = 2; b < n; ++b) {
            if (b == ban) {
                continue;
            }
            ll x = a * b - n;
            if (x <= 0) {
                continue;
            }
            result += lower_bound(cnt[x].begin(), cnt[x].end(), b) - cnt[x].begin();
        }
        for (ll b = 1; b < n; ++b) {
            if (b == ban) {
                continue;
            }
            cnt[a * b].emplace_back(b);
            ll ptr = (ll)cnt[a * b].size() - 1;
            while (ptr > 0 && cnt[a * b][ptr - 1] > cnt[a * b][ptr]) {
                swap(cnt[a * b][ptr - 1], cnt[a * b][ptr]);
                --ptr;
            }
        }
    }
    return result;
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    ll n, ban;
    cin >> n >> ban;
    cout << solve(n, ban) << endl;
    
    return 0;
}
