#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
using namespace std;

int m, n, s, z[500000], np[700000];
vector<vector<int>> a, b, op, x;

int check() {
    int cnt1 = 0;
    for (int i = 0; i < m; i++) {
        for (int p = 0; p < n; p++) {
            np[p] = x[i][p] < z[p];
        }
        for (int p = 0; p < n - 1; p++) {
            if (op[i][p] == 1) np[n + p] = np[a[i][p]] & np[b[i][p]];
            else np[n + p] = np[a[i][p]] | np[b[i][p]];
        }
        cnt1 += np[n + n - 2];
    }
    return cnt1;
}

void _set(int l, int r, int val) {
    for (int i = l; i <= r; i++) {
        z[i] = val;
    }
}

void solve(int lf, int rg, int minimum) {
    if (lf > rg) {
        return;
    }
    if (lf == rg) {
        int l0 = minimum - 1, r0 = m;
        while (l0 + 1 < r0) {
            int mid0 = (l0 + r0) / 2;
            z[lf] = mid0;
            if (check() >= s) {
                r0 = mid0;
            } else {
                l0 = mid0;
            }
        }
        z[lf] = r0;
        if (check() == s) {
            for (int i = 0; i < n; i++) {
                cout << z[i] << ' ';
            }
            exit(0);
        }
        return;
    }
    int mid = (lf + rg) / 2;
    int l0 = minimum - 1, r0 = m;
    while (l0 + 1 < r0) {
        int mid0 = (l0 + r0) / 2;
        int l1 = minimum - 1, r1 = m, z0 = mid0;
        _set(lf, mid, mid0);
        _set(mid + 1, rg, m);
        if (check() >= s) {
            r0 = mid0;
            while (l1 + 1 < r1) {
                int mid1 = (l1 + r1) / 2;
                _set(mid + 1, rg, mid1);
                if (check() >= s) {
                    r1 = mid1;
                } else {
                    l1 = mid1;
                }
            }
            _set(mid + 1, rg, r1);
            if (check() == s) {
                for (int i = 0; i < n; i++) {
                    cout << z[i] << ' ';
                }
                exit(0);
            }
        } else {
            l0 = mid0;
        }
    }
    int must_r = r0;
    int l1 = minimum - 1, r1 = m, z0 = r0;
    _set(lf, mid, r0);
    _set(mid + 1, rg, m);
    if (check() >= s) {
        while (l1 + 1 < r1) {
            int mid1 = (l1 + r1) / 2;
            _set(mid + 1, rg, mid1);
            if (check() >= s) {
                r1 = mid1;
            } else {
                l1 = mid1;
            }
        }
        _set(mid + 1, rg, r1);
        if (check() == s) {
            for (int i = 0; i < n; i++) {
                cout << z[i] << ' ';
            }
            exit(0);
        }
    }
    solve(lf, mid, must_r);
    solve(mid + 1, rg, r1);
}

void PUNKS_NOT_DEAD() {
    cin >> n >> m >> s;
    a.resize(m, vector<int>(n - 1));
    b.resize(m, vector<int>(n - 1));
    op.resize(m, vector<int>(n - 1));
    x.resize(m, vector<int>(n));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];
            a[i][j]--, b[i][j]--;
        }
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            cin >> x[i][j];
        }
    }
    if (s == 0) {
        for (int i = 0; i < n; i++) {
            cout << 0 << ' ';
        }
        exit(0);
    }
    solve(0, n - 1, 1);
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    PUNKS_NOT_DEAD();
}