#pragma optimaze ("Ofast, unroll-loops, no-stack-protector, fast-math")
#pragma target ("sse, sse2, sse3, ssse3, abm, avx, avx2, tune=native")
#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
using namespace std;

const int N = 40000;

int n, a[N], q;

long long dp[4][N];

long long calc() {
    long long best = 0;
    int sum = 0;
    for (int pref = 0; pref < 4; pref++) {
        for (int z = 0; z < 4; z++) {
            for (int zz = 0; zz < n; zz++) {
                dp[z][zz] = 0;
            }
        }
        if (pref) dp[pref][pref - 1] = sum;
        for (int i = pref; i < n; i++) {
            for (int cnt = 0; cnt < 4; cnt++) {
                long long kek = 0;
                if (i != 0) kek = dp[cnt][i - 1];
                if (cnt != 3 && i != pref) {
                    dp[cnt + 1][i] = max(dp[cnt + 1][i], kek + a[i]);
                }
                dp[0][i] = max(dp[0][i], kek);
            }
        }
        for (int p = 0; p < 4; p++) {
            if (p + pref < 4) {
                best = max(best, dp[p][n - 1]);
            }
        }
        sum += a[pref];
    }
    return best;
}

void PUNKS_NOT_DEAD() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cin >> q;
    cout << calc() << '\n';
    for (int i = 0; i < q; i++) {
        int p, u;
        cin >> p >> u, p--, a[p] = u;
        cout << calc() << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    PUNKS_NOT_DEAD();
}