#pragma optimize ("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma target ("sse,sse2,sse3,ssse3,avx,abx,mmx,avx2,tune=native")
#include <bits/stdc++.h>
#define all(x) x.begin(), x.end()
using namespace std;

const int N = 40000;

int n, a[N], q;

long long dp[N * 4][4][4], best, sum, cdp[N * 4][4][4];

void update(int v, int tl, int tr, int pos, int x) {
    if (tl == tr) {
        dp[v][1][1] = x;
        dp[v][0][0] = 0;
    } else {
        int tm = (tl + tr) / 2;
        if (tm >= pos) update(v << 1, tl, tm, pos, x);
        else update(v << 1 | 1, tm + 1, tr, pos, x);
        for (int l1 = 0; l1 < 4; l1++) {
            for (int r2 = 0; r2 < 4; r2++) {
                long long &now = dp[v][l1][r2];
                now = 0;
            }
        }
        for (int l1 = 0; l1 < 4; l1++) {
            for (int r2 = 0; r2 < 4; r2++) {
                for (int l2 = 0; l2 < 4; l2++) {
                    for (int r1 = 0; r1 < 4; r1++) {
                        if (l2 + r1 < 4) {
                            long long &L = dp[v << 1][l1][r1];
                            long long &R = dp[v << 1 | 1][l2][r2];
                            int curl = l1, curr = r2;
                            if (l1 == r1 && tm - tl + 1 == l1) {
                                curl += l2;
                            }
                            if (l2 == r2 && tr - tm == r2) {
                                curr += r1;
                            }
                            if (curl < 4 && curr < 4) {
                                long long &now = dp[v][curl][curr];
                                now = max(now, L + R);
                            }
                        }
                    }
                }
            }
        }
        if (v == 1) {
            for (int l = 0; l < 4; l++) {
                for (int r = 0; r < 4; r++) {
                    if (l + r < 4) {
                        best = max(best, dp[v][l][r]);
                    }
                }
            }
        }
    }
}

void PUNKS_NOT_DEAD() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        update(1, 0, n - 1, i, a[i]);
    }
    cin >> q;
    cout << best << '\n';
    for (int i = 0; i < q; i++) {
        int p, u;
        best = 0;
        cin >> p >> u, p--, a[p] = u;
        update(1, 0, n - 1, p, a[p]);
        cout << best << '\n';
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    PUNKS_NOT_DEAD();
}