#include <iostream>
#include <vector>

#define int long long

using namespace std;

bool check(int x, int time, int n, vector<int> & v, vector<int> & s){
    double sum = 0;
    for (int i = 0; i < n; i++){
        double q = s[i];
        double w = v[i];
        sum += (q / (w + x));
    }
    return sum <= time;
}

signed main()
{
    int n;
    cin >> n;
    vector<int> v(n);
    vector<int> s(n);
    for (int i = 0; i < n; i++){
        cin >> v[i];
    }
    for (int i = 0; i < n; i++){
        cin >> s[i];
    }
    int m;
    cin >> m;

    vector<int> a(m - 1);
    for (int i = 0; i < m - 1; i++){
        cin >> a[i];
    }
    vector<int> f(m);
    for (int i = 0; i < m; i++){
        cin >> f[i];
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++){
        int st, fn;
        cin >> st >> fn;
        int time = fn - st;
        if (check(0, time, n, v, s)){
            cout << 0 << "\n";
            continue;
        }
        int l = -1;
        int r = m - 1;
        while (r - l > 1){
            int mid = (r + l) / 2;
            if (check(a[mid], time, n, v, s)){
                r = mid;
            }else{
                l = mid;
            }
        }
        cout << f[r] << "\n";
    }

    return 0;
}
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100

1
1
100
1
100
10
1 10


1
1
100
10
1 2 3 4 5 6 7 8 9
1 2 3 4 5 6 7 8 9 10
100
1 100

*/
