#include <iostream>
#include <map>
#include <algorithm>
#include <vector>

using namespace std;

struct counter{
    vector<int> cnt;
    int c = 0;

    counter(){
        cnt.resize(10000);
    }

    void add(int v){
        cnt[v]++;
        c += (cnt[v] == 1);
    }

    void red(int v){
        cnt[v]--;
        c -= (cnt[v] == 0);
    }

    int get(){
        return c;
    }

};

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    vector<pair<int, int> > sp;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        sp.push_back({a[i], i});
    }
    sort(sp.begin(), sp.end());
    a[sp[0].second] = 0;
    int now = 0;
    for (int i = 1; i < n; i++){
        if (sp[i].first != sp[i - 1].first){
            now++;
        }
        a[sp[i].second] = now;
    }
    for (int len = 1; len <= n; len++){
        counter c;
        int cur = 0;
        for (int i = 0; i < len; i++){
            c.add(a[i]);
        }
        cur += c.get();
        for (int i = len; i < n; i++){
            c.add(a[i]);
            c.red(a[i - len]);
            cur += c.get();
        }
        cout << cur << ' ';
    }
    cout << "\n";
    return 0;
}
