#include <iostream>
#include <vector>

using namespace std;

int build(int n, int m, vector<vector<int> > &f, vector<vector<vector<int> > > & ask, vector<int> &z){
    vector<vector<int> > val(m, vector<int>(2 * n - 1));
    int cnt = 0;
    for (int i = 0; i < m; i++){
        for (int j = 0; j < n; j++){
            val[i][j] = f[i][j] < z[j];
        }
        for (int j = n; j < 2 * n - 1; j++){
            if (ask[i][j - n][2] == 1){
                val[i][j] = val[i][ask[i][j - n][0]] && val[i][ask[i][j - n][1]];
            }else{
                val[i][j] = val[i][ask[i][j - n][0]] || val[i][ask[i][j - n][1]];
            }
        }
        cnt += val[i][2 * n - 2];
    }
    return cnt;
}

int main()
{
    int n, m, s;
    cin >> n >> m >> s;
    vector<vector<vector<int> > > ask(m, vector<vector<int> >(n - 1, vector<int>(3)));
    for (int i = 0; i < m; i++){
        for (int j = 0; j < n - 1; j++){
            cin >> ask[i][j][0] >> ask[i][j][1] >> ask[i][j][2];
            ask[i][j][0]--;
            ask[i][j][1]--;
        }
    }
    vector<vector<int> > f(m, vector<int>(n));
    for (int i = 0; i < m; i++){
        for (int j = 0; j < n; j++){
            cin >> f[i][j];
        }
    }

    if (n == 1){
        vector<int> z(1);
        for (; z[0] < m; z[0]++){
            if (build(n, m, f, ask, z) == s){
                cout << z[0] << endl;
                return 0;
            }
        }
    }else if (n == 2){
        vector<int> z(2);
        for (; z[0] < m; z[0]++){
            for (z[1] = 0; z[1] < m; z[1]++){
                int cnt = 0;
                for (int i = 0; i < m; i++){
                    if (ask[i][0][2] == 1){
                        cnt += (f[i][0] < z[0]) && (f[i][1] < z[1]);
                    }else{
                        cnt += (f[i][0] < z[0]) || (f[i][1] < z[1]);
                    }
                }
                if (cnt == s){
                    cout << z[0] << ' ' << z[1] << endl;
                    return 0;
                }
            }
        }
    }else if(m <= 2){
        vector<int> mask(n);
        while (mask != vector<int>(n, m)){
            mask[0]++;
            int now = 0;
            while (mask[now] == m + 1){
                mask[now] = 0;
                now++;
                mask[now]++;
            }
            if (build(n, m, f, ask, mask) == s){
                for (int i = 0; i < n; i++){
                    cout << mask[i] << ' ';
                }
                cout << endl;
                return 0;
            }
        }
    }else{
        cout << s << ' ';
        for (int i = 0; i < m - 1; i++){
            cout << m << ' ';
        }
        cout << endl;
        return 0;
    }

    return 0;
}
