#include <iostream>
#include <vector>

#define int long long

using namespace std;

signed main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    bool is_2 = true;
    for (int i = 0; i < n; i++){
        cin >> a[i];
        if (a[i] != (1 << (i))){
            is_2 = false;
        }
    }
    int q;
    cin >> q;
    vector<int> b(q);
    for (int i = 0; i < q; i++){
        cin >> b[i];
    }
    if (is_2 && n == 60){
        int sum = 0;
        for (int i = 0; i < q; i++){
            sum = 0;
            bool out = false;
            for (int j = 0; j < n; j++){
                if (sum + a[j] > b[i]){
                    cout << sum << ' ' << j << "\n";
                    out = true;
                    break;
                }
                sum += a[j];
            }
            if (!out){
                int d = b[i] - sum;
                int cnt = n;
                if (a[n - 1] == 0){
                    cout << "PE";
                    return 0;
                }
                cnt += (d / a[n - 1]);
                sum += (d / a[n - 1]) * a[n - 1];
                cout << sum << ' ' << cnt << "\n";
            }
        }

        return 0;
    }
    const int INF = 1e9;
    vector<int> dp(200001, INF);
    dp[0] = 0;
    for (int i = 1; i < dp.size(); i++){
        int l = 0;
        int r = n;
        while (r - l > 1){
            int m = (r + l) / 2;
            if (a[m] <= i){
                l = m;
            }else{
                r = m;
            }
        }
        dp[i] = (dp[i % a[l]]) + (i / a[l]);
    }
    /*for (auto i : dp){
        cout << i << ' ';
    }
    cout << endl;*/
    vector<int> mx(dp.size(), 0);
    for (int i = 1; i < dp.size(); i++){
        mx[i] = mx[i - 1];
        if (dp[i] > dp[mx[i]]){
            mx[i] = i;
        }
    }
    /*for (auto i : mx){
        cout << i << ' ';
    }
    cout << endl;*/
    for (int i = 0; i < q; i++){
        cout << mx[b[i]] << ' ' << dp[mx[b[i]]] << "\n";
    }
    return 0;
}
/*
4
1 5 10 50
3
2
8
50


10
1 2 4 8 16 32 64 128 256 512
1
1000000000000000000

*/
