#include <iostream>
#include <vector>

#define int long long

using namespace std;

pair<int, int> solve(int x, vector<int> & a){
    int n = a.size();
    int sum = 0;
    int cnt = 0;
    for (int i = 0; i < n - 1; i++){
        int nx = min(x, a[i + 1] - 1);
        int d = nx - sum;
        sum += (d / a[i]) * a[i];
        cnt += (d / a[i]);
    }
    if (sum + a[n - 1] <= x){
        int d = (x - sum);
        sum += (d / a[n - 1]) * a[n - 1];
        cnt += (d / a[n - 1]);
    }
    return {sum, cnt};
}

signed main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }

    int q;
    cin >> q;
    vector<int> b(q);
    for (int i = 0; i < q; i++){
        cin >> b[i];
        auto ans = solve(b[i], a);
        cout << ans.first << ' ' << ans.second << "\n";
    }
    cout << endl;
    return 0;
}
