#include <iostream>
#include <vector>

#define int long long

using namespace std;


pair<int, int> solve(int x, vector<int> & a){
    int n = a.size();
    int sum = 0;
    int cnt = 0;
    for (int i = 0; i < n - 1; i++){
        int nx = min(x, a[i + 1] - 1);
        int d = nx - sum;
        sum += (d / a[i]) * a[i];
        cnt += (d / a[i]);
    }
    if (sum + a[n - 1] <= x){
        int d = (x - sum);
        sum += (d / a[n - 1]) * a[n - 1];
        cnt += (d / a[n - 1]);
    }
    return {sum, cnt};
}

signed main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }



    int q;
    cin >> q;
    vector<int> b(q);
    for (int i = 0; i < q; i++){
        cin >> b[i];

    }
    if (n == 1){
        for (int i = 0; i < q; i++){
            auto ans = solve(b[i], a);
            cout << ans.first << ' ' << ans.second << "\n";
        }
    }else{
        vector<int> sm(n - 1);
        vector<int> c(n - 1);
        c[0] = sm[0] = a[1] - 1;
        for (int i = 1; i < n - 1; i++){
            int d = a[i + 1] - 1 - sm[i - 1];
            c[i] = c[i - 1] + (d / a[i]);
            sm[i] = sm[i - 1] + ((d / a[i]) * a[i]);
        }
        for (int i = 0; i < q; i++){
            if (b[i] > sm[n - 2]){
                int now = sm[n - 2];
                int cnt = c[n - 2];
                int nx = b[i];
                int d = nx - now;
                now += (d / a[n - 1]) * a[n - 1];
                cnt += (d / a[n - 1]);
                cout << now << ' ' << cnt << "\n";
            }else{
                if (b[i] < a[1]){
                    cout << b[i] << ' ' << b[i] << "\n";
                }else{
                    int l = 0;
                    int r = n - 1;
                    while (r - l > 1){
                        int m = (r + l) / 2;
                        if (sm[m] <= b[i]){
                            l = m;
                        }else{
                            r = m;
                        }
                    }
                    int nx = min(a[l + 1] - 1, b[i]);
                    int d = nx - sm[l];
                    int sum = sm[l] + (d / a[l]) * a[l];
                    int cnt = c[l] + (d / a[l]);
                    cout << sum << ' ' << cnt << "\n";
                }
            }
        }
    }
    return 0;
}
