#include <iostream>
#include <vector>
#include <tuple>
#include <cmath>
using namespace std;
typedef long long I;

I eval(vector<tuple<I, I, I>>& prog, vector<bool>& vals) {
    vector<bool> res(2 * vals.size() - 1);
    for (I i = 0; i < vals.size(); ++i) {
        res[i] = vals[i];
    }
    for (I i = vals.size(); i < res.size(); ++i) {
        if (get<2>(prog[i - vals.size()]) == 1) {
            res[i] = res[get<0>(prog[i - vals.size()]) - 1] && res[get<1>(prog[i - vals.size()]) - 1];
        } else {
            res[i] = res[get<0>(prog[i - vals.size()]) - 1] || res[get<1>(prog[i - vals.size()]) - 1];
        }
    }
    return res[res.size() - 1];
}

int main() {
    I n, m, s, a, b, op, ands = 0, ors = 0;
    bool rowed = true, r1, r2;
    cin >> n >> m >> s;
    vector<vector<tuple<I, I, I>>> progs(m, vector<tuple<I, I, I>>(n - 1));
    vector<vector<I>> table(m, vector<I>(n));
    vector<bool> vals(n);

    for (I i = 0; i < m; ++i) {
        for (I j = 0; j < n - 1; ++j) {
            cin >> a >> b >> op;
            if (op == 1) {
                ++ands;
            } else {
                ++ors;
            }
            progs[i][j] = {a, b, op};
        }
    }
    for (I i = 0; i < m; ++i) {
        for (I j = 0; j < n; ++j) {
            cin >> table[i][j];
            rowed = rowed && (table[i][j] == i);
        }
    }

    if (ands == m * (n - 1)) {
        cout << s;
        if (n > 1) {
            cout << " ";
        }
        for (I i = 1; i < n; ++i) {
            cout << m;
            if (i < n - 1) {
                cout << " ";
            }
        }
        cout << endl;
    } else if (rowed || m == 1) {
        for (I i = 0; i < n; ++i) {
            cout << s;
            if (i < n - 1) {
                cout << " ";
            }
        }
    } else if (m == 2) {
        for (I num = 0; num < pow(3, n); num++) {
            I curr = num;
            for (I i = 0; i < n; ++i) {
                vals[i] = (table[0][i] < (curr % 3));
                curr = curr / 3;
                //cout << vals[i] << " ";
            }
            // cout << "A";
            r1 = eval(progs[0], vals);
            //cout << "B";
            curr=  num;
            for (I i = 0; i < n; ++i) {
                vals[i] = table[1][i] < (curr % 3);
                curr = curr / 3;
                // cout << vals[i] << " ";
            }
            //cout << "C";
            r2 = eval(progs[1], vals);
            //cout << "D";
            curr = num;
            if ((I)r1 + (I)r2 == s) {
                // << "F";
                for (I i = 0; i < n; ++i) {
                    cout << (curr % 3);
                    curr = curr / 3;
                    if (i < n - 1) {
                        cout << " ";
                    }
                }
                cout << endl;
                return 0;
            }
        }
    } else {

    }

    return 0;
}