#include <iostream>
#include <vector>
#include <tuple>
#include <cmath>
using namespace std;
typedef long long I;

I eval(vector<tuple<I, I, I>>& prog, vector<bool>& vals) {
    vector<bool> res(2 * vals.size() - 1);
    for (I i = 0; i < vals.size(); ++i) {
        res[i] = vals[i];
    }
    for (I i = vals.size(); i < res.size(); ++i) {
        if (get<2>(prog[i - vals.size()]) == 1) {
            res[i] = res[get<0>(prog[i - vals.size()]) - 1] && res[get<1>(prog[i - vals.size()]) - 1];
        } else {
            res[i] = res[get<0>(prog[i - vals.size()]) - 1] || res[get<1>(prog[i - vals.size()]) - 1];
        }
    }
    return res[res.size() - 1];
}

I ev(I i, bool p1, bool p2) {
    if (i == 1) {
        return p1 && p2;
    } else {
        return p1 || p2;
    }
}

int main() {
    I n, m, s, a, b, op, ands = 0, ors = 0;
    bool rowed = true, r1, r2;
    cin >> n >> m >> s;
    vector<vector<tuple<I, I, I>>> progs(m, vector<tuple<I, I, I>>(n - 1));
    vector<vector<I>> table(m, vector<I>(n));
    vector<bool> vals(n);

    for (I i = 0; i < m; ++i) {
        for (I j = 0; j < n - 1; ++j) {
            cin >> a >> b >> op;
            if (op == 1) {
                ++ands;
            } else {
                ++ors;
            }
            progs[i][j] = {a, b, op};
        }
    }
    for (I i = 0; i < m; ++i) {
        for (I j = 0; j < n; ++j) {
            cin >> table[i][j];
            rowed = rowed && (table[i][j] == i);
        }
    }

    if (ands == m * (n - 1)) {
        cout << s;
        if (n > 1) {
            cout << " ";
        }
        for (I i = 1; i < n; ++i) {
            cout << m;
            if (i < n - 1) {
                cout << " ";
            }
        }
        cout << endl;
    } else if (rowed || m == 1 || s == 0) {
        for (I i = 0; i < n; ++i) {
            cout << s;
            if (i < n - 1) {
                cout << " ";
            }
        }
    } else if (m == 2) {
        for (I num = 0; num < pow(3, n); num++) {
            I curr = num;
            for (I i = 0; i < n; ++i) {
                vals[i] = (table[0][i] < (curr % 3));
                curr = curr / 3;
                //cout << vals[i] << " ";
            }
            // cout << "A";
            r1 = eval(progs[0], vals);
            //cout << "B";
            curr=  num;
            for (I i = 0; i < n; ++i) {
                vals[i] = table[1][i] < (curr % 3);
                curr = curr / 3;
                // cout << vals[i] << " ";
            }
            //cout << "C";
            r2 = eval(progs[1], vals);
            //cout << "D";
            curr = num;
            if ((I)r1 + (I)r2 == s) {
                // << "F";
                for (I i = 0; i < n; ++i) {
                    cout << (curr % 3);
                    curr = curr / 3;
                    if (i < n - 1) {
                        cout << " ";
                    }
                }
                cout << endl;
                return 0;
            }
        }
    } else if (n == 2) {
        vector<I> perm1(m);
        vector<I> perm2(m);
        vector<bool> vals1(m, false);
        vector<bool> vals2(m, false);
        for (I i = 0; i < m; ++i) {
            //cout << i << table[i][0] << table[i][1] << endl;
            perm1[table[i][0]] = i;
            perm2[table[i][1]] = i;
        }

        I z1 = 0, z2 = 0;
        I res = 0;

        for (I i2 = 1; i2 <= m; ++i2) {
            z2 = i2;
            vals2[perm2[i2 - 1]] = true;
            if (get<2>(progs[perm2[i2 - 1]][0]) == 2) {
                ++res;
            }
            if (res == s) {
                cout << 0 << " " << i2 << endl;
                return 0;
            }
            if (res > s) {
                break;
            }
        }

        while (res != s) {
            ++z1;
            //cout << "B" << z1 << " " << z2 << perm1[z1-1] << endl;
            vals1[perm1[z1 - 1]] = true;
            auto oper = get<2>(progs[perm1[z1 - 1]][0]);
            if (ev(oper, true, vals2[perm1[z1 - 1]]) != ev(oper, false, vals2[perm1[z1 - 1]])) {
                ++res;
            }

            while (res > s) {
                //cout << z1 << " " << z2 << endl;
                vals2[perm2[z2 - 1]] = false;
                oper = get<2>(progs[perm2[z2 - 1]][0]);
                if (ev(oper, true, vals1[perm2[z2 - 1]]) != ev(oper, false, vals1[perm2[z2 - 1]])) {
                    --res;
                }
                --z2;
            }
            //cout << "E" <<  z1 << " " << z2 << endl;
        }
        cout << z1 << " " << z2 << endl;
    }

    return 0;
}