#include<bits/stdc++.h>
#define int long long
#define pb push_back
#define ld long double
const int inf = 1e16;

using namespace std;

int n;
vector<int> a;
vector<int> dp;

void relax(int &a, int b) {
	a = max(a, b);
}

void full(){
	for (int i = 4; i < n; i++) {
		dp[i] = 0;
		relax(dp[i], dp[i - 1]);
		relax(dp[i], dp[i - 2] + a[i - 1]);
		relax(dp[i], dp[i - 3] + a[i - 1] + a[i - 2]);
		relax(dp[i], dp[i - 4] + a[i - 1] + a[i - 2] + a[i - 3]);
	}
}

int ansver() {
	int ans = 0;

	dp[0] = 0;
	dp[1] = -inf;
	dp[2] = -inf;
	dp[3] = a[1] + a[2];
	full();
	relax(ans, dp[n - 1]);
	relax(ans, dp[n - 2] + a[n - 1]);
	relax(ans, dp[n - 3] + a[n - 1] + a[n - 2]);
	relax(ans, dp[n - 4] + a[n - 1] + a[n - 2] + a[n - 3]);

	dp[0] = -inf;
	dp[1] = a[0];
	dp[2] = -inf;
	dp[3] = a[0] + a[2];
	full();
	relax(ans, dp[n - 1]);
	relax(ans, dp[n - 2] + a[n - 1]);
	relax(ans, dp[n - 3] + a[n - 1] + a[n - 2]);

	dp[0] = -inf;
	dp[1] = -inf;
	dp[2] = a[0] + a[1];
	dp[3] = a[0] + a[1];
	full();
	relax(ans, dp[n - 1]);
	relax(ans, dp[n - 2] + a[n - 1]);

	dp[0] = 0;
	dp[1] = 0;
	dp[2] = -inf;
	dp[3] = a[2];
	full();
	relax(ans, dp[n - 1]);
	relax(ans, dp[n - 2] + a[n - 1]);
	relax(ans, dp[n - 3] + a[n - 1] + a[n - 2]);
	relax(ans, dp[n - 4] + a[n - 1] + a[n - 2] + a[n - 3]);

	dp[0] = 0;
	dp[1] = -inf;
	dp[2] = a[1];
	dp[3] = a[1];
	full();
	relax(ans, dp[n - 1]);
	relax(ans, dp[n - 2] + a[n - 1]);
	relax(ans, dp[n - 3] + a[n - 1] + a[n - 2]);
	relax(ans, dp[n - 4] + a[n - 1] + a[n - 2] + a[n - 3]);

	dp[0] = -inf;
	dp[1] = a[0];
	dp[2] = a[0];
	dp[3] = a[0];
	full();
	relax(ans, dp[n - 1]);
	relax(ans, dp[n - 2] + a[n - 1]);
	relax(ans, dp[n - 3] + a[n - 1] + a[n - 2]);

	dp[0] = -inf;
	dp[1] = -inf;
	dp[2] = -inf;
	dp[3] = a[0] + a[1] + a[2];
	full();
	relax(ans, dp[n - 1]);

	return ans;
}

signed main() {
	cin >> n;
	a.resize(n);
	dp.resize(n);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	cout << ansver() << '\n';
	int q;
	cin >> q;
	int p, u;
	for (int i = 0; i < q; i++) {
		cin >> p >> u;
		a[p - 1] = u;
		cout << ansver() << '\n';
	}
}

/*
g++ a_test.cpp -std=c++11 -O2 -Wall -Wextra -oa_test
&& time ./a_test
*/