#include <iostream>
#include <vector>
#include <deque>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <cmath>
using namespace std;
using ll = long long;

#define db(x, name) // cerr << "#dbg-" << name << ": " << x << '\n';
ll binp(ll e, const vector<ll>& a) {
    ll l = 0, r = a.size() - 1;
    for (int i = 0; i < 100; i++) {
        ll mid = r - (r - l) / 2;
        if (a[mid] < e) {
            l = mid;
        }
        else r = mid;
    }
    return l;
}

int main() {
    ll n;
    cin >> n;

    vector<ll> maxv(n);
    for (ll i = 0; i < n; i++) {
        cin >> maxv[i];
    }

    vector<ll> l(n);
    ll lsum = 0;
    for (ll i = 0; i < n; i++) {
        cin >> l[i];
        lsum += l[i];
    }
    
    ll m;
    cin >> m;
    
    vector<ll> a(m);
    a[0] = 0;
    for (ll i = 1; i < m; i++) {
        cin >> a[i];
    }
    
    vector<ll> f(m);
    for (ll i = 0; i < m; i++) {
        cin >> f[i];
    }
    
    ll q;
    cin >> q;
    
    for (ll i = 0; i < q; i++) {
        double s, t;
        cin >> s >> t;
        vector<double> v(n, lsum / (t - s));
        ll w = 0;
        for (int j = 0; j < n; j++) {
            if (v[j] > maxv[j]) {
                double e = v[j] - maxv[j];
                e = round(e);
                w = max(f[binp(e, a)], w);
            }
        }
        cout << w << '\n';
    }
    
}