#include <iostream>
#include <vector>
#include <deque>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <cmath>
using namespace std;
using ll = long long;

int main() {
    int max_ai = 0;

    cout.tie(0);
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;
    vector<int> tasks(n);
    for (int i = 0; i < n; i++) {
        cin >> tasks[i];
//        solve_mode |= (tasks[i] > 5001)
        max_ai = max(max_ai, tasks[i]);
    }
    bool solve_mode = max_ai > 5000;
    vector<int> profile(n);
    if (solve_mode){
        for (int i = 1; i <= n; i++) {
            int v = 0;
            for (int start = 0; start <= n - i; start++) {
                set<int> va;
                for (int j = start; j < start + i; j++) {
                    va.insert(tasks[j]);
                }
                v += va.size();
            }
            profile[i - 1] = v;
        }
    }
    else {
        for (int i = 1; i <= n; i++) {
            int v = 0;
            vector<int> usage_times(max_ai + 1, 0);
            for (int m = 0; m < i; m++) {
                usage_times[tasks[m]]++;
            }
            for (int m = 1; m <= max_ai; m++) {
                if (usage_times[m]) v++;
            }
            int lv = v;
            for (int start = 1; start <= n - i; start++) {
                    int tlv = 0;
                    usage_times[tasks[start - 1]]--;
                    usage_times[tasks[start + i - 1]]++;
                    v += lv - 1;
                    tlv += lv - 1;
                    if (usage_times[tasks[start - 1]]) {v++; tlv++;}
                    else if (usage_times[tasks[start + i - 1]] == 1) {v++; tlv++;}
                    lv = tlv;
            }
            profile[i - 1] = v;
        }
    }
    for (auto now : profile) cout << now << ' ';
}