#include <iostream>
#include <vector>
#include <deque>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <cmath>
using namespace std;
using ll = long long;

const bool AND = false;
const bool OR = true;

struct NMLP_op {
    int a, b;
    bool op;
};

vector<vector<NMLP_op>> nmlps;
vector<vector<int>> table;
vector<int> z;
int n, m, s;

void gen(int i) { // почему бы и нет?
    if (i == n) {
        vector<bool>vals(m, false);
        for (int j = 0; j < m; j++) {
            vector<bool> val(2*n - 1);
            for (int o = 0; o < n; o++) {
                val[o] = table[j][o] < z[o];
            }
            for (int p = 0; p < n - 1; p++) {
                if (nmlps[j][p].op == AND) {
                    val[n + p] = val[nmlps[j][p].a - 1] && val[nmlps[j][p].b - 1];
                }
                else if (nmlps[j][p].op == OR) {
                    val[n + p] = val[nmlps[j][p].a - 1] || val[nmlps[j][p].b - 1];
                }
            }
            vals[j] = val[2 * n - 2];
        }
        int zeros = 0, ones = 0;
        for (auto now: vals) {
            if (now) ones++; else zeros++;
        }
        if (ones == s && zeros == m - s) {
            for (auto now: z) {
                cout << now << ' ';
            }
            exit(0);
        }
    }
    else {
        for (int j = 0; j < m; j++) {
            z[i] = j;
            gen(i + 1);
        }
    }
}

int main() {
    cin >> n >> m >> s;
    nmlps.assign(m, vector<NMLP_op>(n - 1));
    table.assign(m, vector<int>(n));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            int a, b, op;
            cin >> a >> b >> op;
            bool bop = bool(op - 1);
            nmlps[i][j] = {a, b, bop};
        }
    }

    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            cin >> table[i][j];
        }
    }

    z.assign(n, 0);
    gen(0);
}