#include <iostream>
#include <vector>
#include <deque>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <cmath>
using namespace std;
using ull = unsigned long long;
using ll = long long;

string check(ull m, ull mbw) {
    string bitm;
    for (ll i = mbw; i >= 0; i--) {
//        cerr << ":: :: :: :: Parsing bit #" << i;
        bitm += ((m & (1ull << i)) >= 1 ? "1" : "0");
//        cerr << " ==> " << bitm[bitm.length() - 1] << " ==> " << bitm << '\n';
    }

    int ir = 0;

    for (char x : bitm) {
        if (x == '1') ir++;
        if (ir > 3) {/*cerr << "4 bits together. Nope(\n";*/ return "0";}
        if (x == '0') ir = 0;
    }
    if (bitm[0] == '1' && bitm[bitm.length() - 1] == '1') {/*cerr << "1st and last are together...\n"; */return "0";}
    return bitm;
}

int solve(vector<ull> &a, ull n) {
    ull ma = 0;
    for (ull m = 1; m < (1ull << n); m++) {
//        cerr << ":::: m == " << m << '\n';
        string cm = check(m, n - 1);
        if (cm != "0"){
            ull ans = 0;
            for (ull i = 0; i < min(ull(cm.length()), n); i++) {
                if (cm[i] == '1') {
                    ans += a[i];
                }
            }
            ma = max(ans, ma);
        }
    }
    return ma;
}

int main() {
    int n;
    cin >> n;
    vector<ull> a(n);

    for (int i = 0; i < n; i++) {cin >> a[i];}

    int q;
    cin >> q;

    cout << solve(a, n) << '\n';

    while (q --> 0) {
        int p, v;
        cin >> p >> v;
        a[p - 1] = v;
        cout << solve(a, n) << '\n';
    }

    return 0;
}