#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

int main()
{
	int n = 0;
	cin >> n;

	vector <int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	ll left = 0, right = 0;
	for (const int& x : a)
		right += x;

	int max_pos = 1;
	ll max_val = 0;

	for (int i = 1; i < n; ++i)
	{
		left += a[i - 1];
		right -= a[i - 1];
		ll prod = left * right;

		if (prod > max_val)
		{
			max_pos = i;
			max_val = prod;
		}
	}

	cout << max_pos;

	return 0;
}