#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;
using ll = long long;
constexpr ll inf = 1e18;

int main()
{
	int n = 0;
	cin >> n;

	vector <ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	vector <ll> ps = { 0 };
	for (int i = 0; i < n; ++i)
		ps.push_back(ps.back() + a[i]);

	int max_pos = 0;
	ll max_val = inf;

	for (int i = 1; i < n; ++i)
	{
		ll diff = abs(2 * ps[i] - ps.back());

		if (diff < max_val)
		{
			max_pos = i;
			max_val = diff;
		}
	}

	cout << max_pos;

	return 0;
}