#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	vector <ll> sample = { 1 };
	for (int i = 1; i < 60; ++i)
		sample.push_back(sample.back() * 2);
	reverse(sample.begin(), sample.end());

	vector <ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	reverse(a.begin(), a.end());

	int q = 0;
	cin >> q;

	if (a == sample)
	{
		for (int i = 0; i < q; ++i)
		{
			ll b = 0;
			cin >> b;

			ll log_b = floorl(log2(b + 1));
			cout << (ll(1) << log_b) - 1 << ' ' << log_b << '\n';
		}
	}
	else
	{		
		while (q--)
		{
			ll max_b = 0;
			cin >> max_b;

			ll max_op = 0, ans_b = 0;
			for (ll b = 1; b <= max_b; ++b)
			{
				ll b_buf = b;
				int cnt = 0, ind = 0;
				while (b_buf)
				{
					cnt += b_buf / a[ind];
					b_buf %= a[ind++];
				}

				if (cnt > max_op)
				{
					max_op = cnt;
					ans_b = b;
				}
			}

			cout << ans_b << ' ' << max_op << '\n';
		}
	}

	return 0;
}