#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF = 2e18 + 109;

vector<int> v;
int n;

bool check1() {
    for (int i = 0; i < n; i++) {
        if (v[i] != (1ll << i)) {
            return false;
        }
    }
    return true;
}


int steps(int b) {
    int st = 0, bord = n;
    while (b > 0) {
        int l = 0, r = bord, m;
        while (l + 1 < r) {
            m = (l + r) / 2;
            if (b >= v[m]) {
                l = m;
            } else {
                r = m;
            }
        }
        st += b / v[l];
        b %= v[l];
        bord = l;
    }
    return st;
}


signed main() {
    cin >> n;

    v.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    int q;
    cin >> q;

    if (n == 60 && check1()) {
        while (q--) {
            int b;
            cin >> b;

            int pow;
            for (pow = 60; (1ll << pow) - 1 > b; pow--) {}
            cout << (1ll << pow) - 1 << " " << pow << "\n";
        }
        return 0;
    }

    v.push_back(0);
    while (q--) {
        int b;
        cin >> b;
        v[n] = b;

        //cout << "OK1\n";
        int st = 0, sum = 0, ind;
        for (ind = 0; ind < n; ind++) {
            while (sum + v[ind] <= min(b, v[ind + 1] - 1)) {
                sum += v[ind];
                st++;
            }
        }
        if (ind == n) {
            ind--;
        }
        //cout << "ok2 " << sum << " " << ind << " " << v[ind] << " " << v[ind + 1] << "\n";
        while (sum + v[ind] < min(b, v[ind + 1])) {
            sum += v[ind];
            st++;
        }

        //cout << "OK3 " << sum << " " << st << "\n";
    }

    return 0;
}

