#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

//#include <string>
//#include <set>
//#include <unordered_set>
//#include <map>
//#include <unordered_map>
//#include <bitset>

///#pragma GCC optimize("Ofast")
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;

void fast_IO() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

const int INF = 1e18;
const int DEBUG = 0;

int n;
vector<int> v;
vector<int> l;
int m;
vector<int> a;
vector<int> f;
int q;
vector<int> s;
vector<int> t;

void init() {
    ///ifstream cin("test.in"); ofstream cout("test.out");
    ///fast_IO();
    cin >> n;
    v.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    l.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    cin >> m;
    a.resize(m);
    a[0] = 0;
    for (int i = 1; i < m; ++i) {
        cin >> a[i];
    }
    f.resize(m);
    for (int i = 0; i < m; ++i) {
        cin >> f[i];
    }
    cin >> q;
    s.resize(q);
    t.resize(q);
    for (int i = 0; i < q; ++i) {
        cin >> s[i] >> t[i];
        t[i] = t[i] - s[i];
    }
    ///cin.close(); cout.close();
}

bool can(int id, int tm) {
    double time = 0;
    for (int i = 0; i < n; ++i) {
        time += (double)l[i] / (double)(v[i] + a[id]);
    }
    return time > tm;
}

signed main()
{
    ///ifstream cin("test.in"); ofstream cout("test.out");
    ///fast_IO();
    init();
    for (int i = 0; i < q; ++i) {
        int L, R;
        L = 0;
        R = m;
        while (R - L > 1) {
            int M = (L + R) / 2;
            if (can(M, t[i])) {
                L = M;
            }
            else {
                R = M;
            }
        }
        if (!can(L, t[i])) {
            cout << 0 << endl;
        }
        else {
            cout << f[L] << endl;
        }
    }
    return 0;
    ///cin.close(); cout.close();
}
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100

*/
