#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

//#include <string>
//#include <set>
//#include <unordered_set>
//#include <map>
//#include <unordered_map>
//#include <bitset>

///#pragma GCC optimize("Ofast")
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;

void fast_IO() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

const int INF = 1e18;
const int DEBUG = 0;

int n, m, s;
vector<vector<int>> a;
vector<vector<int>> b;
vector<vector<int>> op;
vector<vector<int>> x;

vector<int> z;

vector<int> val;

void init() {
    ///ifstream cin("test.in"); ofstream cout("test.out");
    ///fast_IO();
    cin >> n >> m >> s;
    a.resize(m);
    b.resize(m);
    op.resize(m);
    for (int i = 0; i < m; ++i) {
        a[i].resize(n - 1);
        b[i].resize(n - 1);
        op[i].resize(n - 1);
        for (int j = 0; j < n - 1; ++j) {
            cin >> a[i][j];
            cin >> b[i][j];
            cin >> op[i][j];
        }
    }
    x.resize(m);
    for (int i = 0; i < m; ++i) {
        x[i].resize(n);
        for (int j = 0; j < n; ++j) {
            cin >> x[i][j];
        }
    }
    z.resize(n);
    val.resize(2 * n);
    ///cin.close(); cout.close();
}

int dfs(int i, int j) {
    j--;
    if (j < n) {
        val[j] = (x[i][j] < z[j]);
        return (x[i][j] < z[j]);
    }
    int id = j - n;
    if (op[i][id] == 1) {
        return dfs(i, a[i][id]) && dfs(i, b[i][id]);
    }
    if (op[i][id] == 2) {
        return dfs(i, a[i][id]) || dfs(i, b[i][id]);
    }
}

bool check() {
    int cnt = 0;
    for (int i = 0; i < m; ++i) {
        cnt += dfs(i, 2 * n - 1);
    }
    return cnt == s;
}

bool gen(int j = 0) {
    if (j == n) {
        return check();
    }
    for (int id = 0; id <= m; ++id) {
        z[j] = id;
        if (gen(j + 1)) {
            return 1;
        }
    }
    return 0;
}

signed main()
{
    ///ifstream cin("test.in"); ofstream cout("test.out");
    ///fast_IO();
    init();

    int trash = gen();


    for (int j = 0; j < n; ++j) {
        cout << z[j] << " ";
    }
    return 0;
    ///cin.close(); cout.close();
}
/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1

*/

