#include <bits/stdc++.h>

using namespace std;

#define endl '\n'

ostream &operator<<(ostream &out, const pair<int, int> &p) {
    out << p.first << " " << p.second;
}

int bitcnt(long long a) {
    int ans = 0;
    while (a) {
        if (a & 1) {
            ans++;
        }
        a >>= 1;
    }
    return ans;
}

signed main() {
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    #endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    long long a[n];
    bool flag = true;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (bitcnt(a[i]) != 1) {
            flag = false;
        }
    }
    long long counter[n + 1], number[n + 1];
    counter[0] = number[0] = 0;
    if (n == 1) {
        int q;
        cin >> q;
        while (q--) {
            long long b;
            cin >> b;
            cout << b << " " << b << endl;
        }
        return 0;
    }
    if (!flag) {
        int MAXN = 200000;
        int ans[MAXN + 1];
        ans[0] = 0;
        int now = 0;
        for (int i = 1; i <= MAXN; i++) {
            if (now < n - 1 && i >= a[now + 1]) {
                now++;
            }
            ans[i] = ans[i - a[now]] + 1;
        }
        pair<int, int> max_ans[MAXN + 1];
        max_ans[0] = {0, 0};
        for (int i = 1; i <= MAXN; i++) {
            max_ans[i] = max(max_ans[i - 1], {ans[i], i});
        }
        int q;
        cin >> q;
        while (q--) {
            int b;
            cin >> b;
            cout << max_ans[b].second << " " << max_ans[b].first << endl;
        }
        return 0;
    }
    counter[1] = number[1] = a[1] - 1;
    for (int i = 2; i < n; i++) {
        number[i] = ((a[i] - number[i - 1]) / a[i - 1]) * a[i - 1] + number[i - 1];
        counter[i] = counter[i - 1] + (a[i] - number[i - 1]) / a[i - 1];
        if (a[i - 1] == a[i]) {
            number[i] = counter[i] = 1;
        }
    }
    int q;
    cin >> q;
    while (q--) {
        long long b;
        cin >> b;
        auto it = upper_bound(a, a + n, b) - a - 1;
        long long k = number[it], c = counter[it];
        long long d = (b - k) / a[it];
        c += d;
        k += d * a[it];
        cout << k << " " << c << endl;
    }
}
