#include <bits/stdc++.h>

using namespace std;

#define DEBUGd

void mult(deque<long long> &d, long long t) {
    for (int i = 0; i < d.size(); ++i)
        d[i] *= t;
    long long left = 0ll;
    for (int i = d.size() - 1; i >= 0; --i) {
        long long tmp = d[i];
        d[i] = (tmp + left) % 10ll;
        left = (tmp + left) / 10ll;
    }
    while (left > 0) {
        d.push_front(left % 10ll);
        left /= 10ll;
    }
}

bool cmp(long long a, long long b, long long c, long long d) {
    string s = to_string(a), t = to_string(c);
    deque<long long> A(s.size());
    for (int i = 0; i < s.size(); ++i)
        A[i] = s[i] - '0';
    deque<long long> B(t.size());
    for (int i = 0; i < t.size(); ++i)
        B[i] = t[i] - '0';
    mult(A, b);
    mult(B, d);
    if (A.size() != B.size())
        return A.size() > B.size();
    for (int i = 0; i < A.size(); ++i)
        if (A[i] != B[i])
            return A[i] > B[i];
    return false;
}

void solve() {
    int n;
    cin >> n;
    vector<long long> v(n);
    for (int i = 0; i < n; ++i)
        cin >> v[i];
    for (int i = 1; i < n; ++i)
        v[i] += v[i - 1];
    int opt = 0;
    for (int i = 1; i < n - 1; ++i) {
        if (cmp(v[i], v.back() - v[i], v[opt], v.back() - v[opt]))
            opt = i;
    }
    cout << opt + 1 << endl;
}

int main() {
    #ifdef DEBUG
        freopen("Atest.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
