#include <bits/stdc++.h>

using namespace std;

#define DEBUGd

vector<int> simple;

const int MAXN = 1e7;

int p[MAXN];

void work(int a, int b, int c, int &ans, vector<pair<int, int>> &dels, int pos = 0, int col = 1) {
    if (pos == dels.size()) {
        if (col < a && c / col < b)
            ++ans;
        return;
    }
    for (int i = 0; i <= dels[pos].second; ++i) {
        work(a, b, c, ans, dels, pos + 1, col);
        col *= dels[pos].first;
        if (col >= a)
            return;
    }
}

void solve() {
    p[1] = 1;
    for (int i = 2; i < MAXN; ++i) {
        p[i] = -1;
    }
    for (int i = 2; i < MAXN; ++i) {
        if (p[i] == -1) {
            p[i] = i;
            simple.push_back(i);
        }
        for (int j = 0; j < simple.size() && simple[j] <= i && simple[j] * i < MAXN; ++j)
            p[i * simple[j]] = simple[j];
    }
    int n, x;
    cin >> n >> x;
    int ans  = 0;
    for (int a = 1; a <= n; ++a) {
        if (a == x)
            continue;
        for (int b = 1; b <= n; ++b) {
            if (b == x)
                continue;
            int c = a * b - n;
            if (c <= 0)
                continue;
            vector<pair<int, int>> dels;
            while (c != 1) {
                if (dels.size() == 0 || dels.back().first != p[c])
                    dels.push_back({p[c], 0});
                ++dels.back().second;
                c /= p[c];
            }
            c = a * b - n;
            work(a, b, c, ans, dels);
        }
    }
    cout << ans << endl;
}

int main() {
    #ifdef DEBUG
        freopen("Btest.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}
