#include <bits/stdc++.h>

using namespace std;

#define DEBUGu

bool good(int a, int b) {
    a = a * 8 + b;
    if ((a & 60) == 60)
        return false;
    if ((a & 30) == 30)
        return false;
    if ((a & 15) == 15)
        return false;
    return true;
}

bool valid(int i, int a, int b) {
    if (i == 2)
        return a == b;
    if (i == 3)
        return (a & 3) == (b>>1);
    if (i == 4)
        return (a & 1) == (b>>2);
    return true;
}

void solver(vector<long long> &v) {
    int n = v.size();
    vector<vector<vector<long long>>> dp(n, vector<vector<long long>>(8, vector<long long>(8)));
    for (int i = 0; i < 8; ++i) {
        if (i & 4)
            dp[2][i][i] += v[0];
        if (i & 2)
            dp[2][i][i] += v[1];
        if (i & 1)
            dp[2][i][i] += v[2];
    }
    for (int i = 2; i < n - 1; ++i) {
        for (int fmask = 0; fmask < 8; ++fmask) {
            for (int mask = 0; mask < 8; ++mask) {
                if (!valid(i, fmask, mask))
                    continue;
                dp[i + 1][fmask][(mask & 3) * 2] = max(dp[i + 1][fmask][(mask & 3) * 2], dp[i][fmask][mask]);
                if (mask != 7)
                    dp[i + 1][fmask][((mask & 3) * 2 + 1)] = max(dp[i + 1][fmask][((mask & 3) * 2 + 1)],
                    dp[i][fmask][mask] + v[i + 1]);
            }
        }
    }
    /*for (int i = 0; i < n; ++i) {
        cout << i + 1 << endl;
        for (int lmask = 0; lmask < 8; ++lmask) {
            cout << lmask << ":\n";
            for (int mask = 0; mask < 8; ++mask)
                cout << mask << " " << dp[i][lmask][mask] << "; ";
            cout << endl;
        }
        cout << endl << endl;
    }*/
    long long ans = 0;
    for (int fmask = 0; fmask < 8; ++fmask) {
        for (int mask = 0; mask < 8; ++mask)
            if (good(mask, fmask)) {
                //if (dp[n-1][fmask][mask] > ans)
                    //cout << dp[n - 1][fmask][mask] << " " << fmask << " " << mask << endl;
                ans = max(ans, dp[n - 1][fmask][mask]);
            }
    }
    cout << ans << '\n';
}

void solve() {
    int n;
    cin >> n;
    if (n < 3000) {
        vector<long long> v(n);
        for (int i = 0; i < n; ++i)
            cin >> v[i];
        solver(v);
        int q;
        cin >> q;
        for (int i = 0; i < q; ++i) {
            int a, b;
            cin >> a >> b;
            v[a - 1] = b;
            solver(v);
        }
    } else {

    }
}

int main() {
    #ifdef DEBUG
        freopen("Dtest.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}

