#include <iostream>
#include <vector>

using namespace std;

const int MAXN = 2 * 1e5;
int t[4 * MAXN];
int n;
vector<int> vec;

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = vec[tl];
    } else {
        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm);
        build(v * 2 + 1, tm + 1, tr);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }
}

int sum(int v, int tl, int tr, int l, int r) {
    if (l > r) {
        return 0;
    }
    if (tl == l && tr == r) {
        return t[v];
    }
    int tm = (tr + tl) / 2;
    return sum(v * 2, tl, tm, l, min(r, tm)) + sum(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
}

int main() {
    cin >> n;
    int sum = 0;
    for (int i = 0; i < n; i++) {
        int temp;
        cin >> temp;
        vec.push_back(temp);
        sum += temp;
    }
    //build(1, 0, n - 1);
    int max_ = -1e9;
    int ans = -1;
    int sumLeft = 0;
    int sumRight = sum;
    for (int i = 0; i < n - 1; i++) {
        sumLeft += vec[i];
        sumRight -= vec[i];
        //cout << sum1 << ' ' << sum2 << endl;
        if (sumLeft * sumRight > max_) {
            max_ = sumLeft * sumRight;
            ans = i;
        }
    }
    cout << ans + 1;
}
