#include <iostream>
#include <vector>
#include <set>
#define int long long

using namespace std;

const int MAXN = 2 * 1e5;

int f(int k) {
    int x = k + 1;
    int ans = 0;
    while (x > 0) {
        x /= 2;
        ans++;
    }
    return ans - 1;
}

int32_t main() {
    int n;
    cin >> n;
    set<int> steps;
    if (n == 60) {
        steps.insert(1);
        int last = 1;
        for (int i = 1; i <= n; i++) {
            steps.insert(last * 2);
            last *= 2;
        }
    }
    bool flag = true;
    vector<int> vec(n);
    for (int i = 0; i < n; i++) {
        cin >> vec[i];
        if (steps.find(vec[i]) == steps.end()) {
            flag = false;
        }
    }
    int q;
    cin >> q;
    int pred[MAXN + 1];
    for (int i = 1; i <= MAXN; i++) {
        int sum = 0;
        int h = i;
        for (int k = n - 1; k >= 0 && h != 0; k--) {
            sum += (h / vec[k]);
            h %= vec[k];
        }
        pred[i] = sum;
    }
    int preff[MAXN + 1];
    preff[1] = 1;
    int max_ = 1;
    for (int i = 2; i <= MAXN; i++) {
        if (pred[i] > pred[max_]) {
            preff[i] = i;
            max_ = i;
        } else {
            preff[i] = max_;
        }
    }
    if (flag) {
        cout << 1;
        for (int i = 0; i < q; i++) {
            int x;
            cin >> x;
            int max_ = -1;
            for (auto k: steps) {
                if (k - 1 < x) {
                    max_ = k - 1;
                }
            }
            cout << max_ << ' ' << f(max_) << endl;
        }
    } else {
        for (int i = 0; i < q; i++) {
            int x;
            cin >> x;
            cout << preff[x] << ' ' << pred[preff[x]] << endl;
        }
    }
}
