#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n;
    cin >> n;
    long double sum = 0;
    vector <long double> v(n);
    for (int i = 0; i < n; i++)
        cin >> v[i];
    vector <long double> l(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i];
        sum += l[i] / v[i];
    }
    int m;
    cin >> m;
    vector <long double> a(m - 1);
    for (int i = 0; i < m - 1; i++)
        cin >> a[i];
    vector <int> f(m);
    for (int i = 0; i < m; i++)
        cin >> f[i];
    int q;
    cin >> q;
    for (int it = 0; it < q; it++) {
        long double s, t;
        cin >> s >> t;
        int ans = 0;
        if (t - s >= sum) {
            cout << ans << '\n';
        }
        else {
            int left = -1, right = m - 1;
            while (right - left > 1) {
                int tm = (left + right) / 2;
                long double now = 0;
                for (int j = 0; j < n; j++)
                    now += (l[j] / (v[j] + a[tm]));
                if (now <= t - s) right = tm;
                else left = tm;
            }
            cout << f[right] << '\n';
        }
    }
}

