#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector <int> v(n);
    vector <int> a(n);
    map <int, int> m;
    int now = 0;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        a[i] = v[i];
    }
    sort(a.begin(), a.end());
    m[a[0]] = now++;
    for (int i = 1; i < n; i++)
        if (a[i] != a[i - 1])
            m[a[i]] = now++;
    for (int i = 0; i < n; i++)
        v[i] = m[v[i]];
    vector <int> xl(n, -1);
    vector <int> fl(n, -1);
    for (int i = 0; i < n; i++) {
        fl[i] = xl[v[i]];
        xl[v[i]] = i;
    }
    vector <pair <int, int> > x;
    for (int i = 0; i < n; i++) {
        for (int j = i - fl[i]; j > 0; j--) {
            x.push_back({j, 0});
            x.push_back({j + n - i - 1, 1});
        }
    }
    sort(x.begin(), x.end());
    int ans = 0;
    int it = 0;
    for (int i = 1; i <= n; i++) {
        while(it < int(x.size()) && x[it].first == i && x[it].second == 0) {
            ans++;
            it++;
        }
        cout << ans << " ";
        while(it < int(x.size()) && x[it].first == i && x[it].second == 1) {
            ans--;
            it++;
        }
    }
}


