#define _USE_MATH_DEFINES
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <random>
#include <set>
#include <map>
#include <bitset>
#include <functional>
#include <numeric>
#include <iomanip>
#include <cassert>
#include <cmath>
#include <deque>
#include <unordered_map>
#include <unordered_set>
using namespace std;
#define kekek ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

const long double eps = 1e-7;
vector<int> v, l;

long double gett(int vv) {
	long double ans = 0;
	for (int i = 0; i < v.size(); i++) {
		ans += (long double)l[i] / (v[i] + vv);
	}
	return ans;
}

signed main() {
	kekek;
	int n;
	cin >> n;
	v.resize(n);
	l.resize(n);
	for (auto& i : v) {
		cin >> i;
	}
	for (auto& i : l) {
		cin >> i;
	}
	int m;
	cin >> m;
	vector<int> a(m, 0), f(m);
	for (int i = 1; i < m; i++) {
		cin >> a[i];
	}
	for (auto& i : f) {
		cin >> i;
	}

	auto tmin = gett(0), tmax = gett(a[m - 1]);
	int q;
	cin >> q;
	while (q--) {
		int s, t;
		cin >> s >> t;
		t -= s;

		if (t - tmin >= -eps) {
			cout << "0\n";
		}
		else if (t - tmax < -eps) {
			cout << f.back() << '\n';
		}
		else {
			int l = 0, r = m;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (gett(a[mid]) <= t) {
					r = mid;
				} else {
					l = mid;
				}
			}
			cout << f[l] << '\n';
		}
		
	}

	return 0;
}