#define _USE_MATH_DEFINES
#pragma GCC optimize("O3")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

struct node {
    int a, b, op;
};

int n, m, s;
vector<vector<node>> kek;
vector<vector<int>> tb;
vector<vector<int>> val;
vector<int> z;

int get_cnt_from_z(vector<int>& z) {
    int cnt = 0;
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            val[i][j] = (tb[i][j] < z[j]);
        }
        for (int j = n; j < 2 * n - 1; j++) {
            if (kek[i][j - n].op == 1) {
                val[i][j] = (val[i][kek[i][j - n].a] & val[i][kek[i][j - n].b]);
            } else {
                val[i][j] = (val[i][kek[i][j - n].a] | val[i][kek[i][j - n].b]);
            }
        }
        if (val[i][2 * n - 2]) cnt++;
    }
    return cnt;
}

void fun(int pos) {
    if (pos == n) { 
        if (get_cnt_from_z(z) == s) {
            for (auto i : z) {
                cout << i << " ";
            }
            exit(0);
        }

        return;
    }

    for (int i = 0; i <= m; i++) {
        z[pos] = i;
        fun(pos + 1);
    }
}

int getbest1() {
    int l1 = 0, r1 = m + 1;
    while (r1 - l1 > 1) {
        int m1 = (l1 + r1) / 2;
        z[1] = m1;

        if (get_cnt_from_z(z) > s) {
            r1 = m1;
        } else {
            l1 = m1;
        }
    }
    return l1;
}

signed main() {
    kekek;
    cin >> n >> m >> s;
    kek.resize(m, vector<node>(n - 1));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            cin >> kek[i][j].a >> kek[i][j].b >> kek[i][j].op;
            kek[i][j].a--, kek[i][j].b--;
        }
    }
    tb.resize(m, vector<int>(n));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            cin >> tb[i][j];
        }
    }
    val.resize(m, vector<int>(2 * n + 1));
    z.resize(n);
    if (m <= 3) {
        fun(0);
    } else if (n == 2) {

        int l0 = 0, r0 = m + 1;
        while (r0 - l0 > 1) {
            int m0 = (l0 + r0) / 2;

            z[0] = m0;
            z[1] = getbest1();
            if (get_cnt_from_z(z) > s) {
                r0 = m0;
            } else {
                l0 = m0;
            }
        }
        z[0] = l0;
        cout << l0 << " " << getbest1() << '\n';

    } else {
        for (int i = 0; i < n; i++) {
            cout << s << '\n';
        }
    }

    return 0;
}