#define _USE_MATH_DEFINES
#pragma GCC optimize("O3")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <numeric>
#include <algorithm>
#include <random>
#include <cassert>
#include <ctime>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define int long long

int n;
vector<int> a;

int do_iter(int c) {
    auto kek = upper_bound(a.begin(), a.end(), c);
    return *(--kek);
}

const int maxb = 2e5 + 5;
int dp[maxb];
set<int> pw2;

signed main() {
    kekek;
    int curpw2 = 1;
    for (int i = 0; i < 60; i++) {
        pw2.insert(curpw2);
        curpw2 <<= 1;
    }

    cin >> n;
    a.resize(n);
    bool f = true;
    for (auto& i : a) {
        cin >> i;
        if (pw2.find(i) == pw2.end()) f = false;
    }
    
    if (!(f && n == 60)) {
        for (int i = 1; i < maxb; i++) {
            dp[i] = dp[i - do_iter(i)] + 1;
        }

        int q;
        cin >> q;
        while (q--) {
            int b;
            cin >> b;
            assert(b < maxb);
            int pos = 0;
            for (int i = 1; i <= b; i++) {
                if (dp[pos] < dp[i]) {
                    pos = i;
                }
            }
            cout << pos << " " << dp[pos] << '\n';
        }
    } else {
        int q;
        cin >> q;
        while (q--) {
            int b;
            cin >> b;
            auto kek = pw2.upper_bound(b + 1);
            kek--;
            cout << *kek - 1 << " " << log2(*kek) << '\n';
        }
    }

    return 0;
}