#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <assert.h>
#include <iomanip>

using namespace std;

const int maxN = 100000;

long long int v[maxN];
long long int l[maxN];
long long int c[maxN];
long long int f[maxN];
int ind[maxN];
long long int ans[maxN];
pair<long long int, int> t[maxN];
int n, m, q;

long double get(int i) {
	if (ind[i] == 0) return 1.0 * l[i] / v[i];
	if (ind[i] == m) return 0.0;
	return 1.0 * l[i] / (1.0 * v[i] + c[ind[i] - 1]);
}

int main() {
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%lld", &v[i]);
		ind[i] = 0;
	}
	for (int i = 0; i < n; i++)
		scanf("%lld", &l[i]);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n - 1; j++) {
			if (l[j] * v[j + 1] > l[j + 1] * v[j]) {
				swap(l[j], l[j + 1]);
				swap(v[j], v[j + 1]);
			}
		}
	}
	scanf("%d", &m);
	for (int i = 0; i < m - 1; i++)
		scanf("%lld", &c[i]);
	for (int i = 0; i < m; i++)
		scanf("%lld", &f[i]);
	scanf("%d", &q);
	long long int a, b;
	for (int i = 0; i < q; i++) {
		scanf("%lld %lld", &a, &b);
		t[i].first = b - a;
		t[i].second = i;
	}
	sort(t, t + q, [](pair<long long int, int> a, pair<long long int, int> b) {
		return a > b;
		});
	long double nowTime = 0;
	for (int i = 0; i < n; i++) nowTime += 1.0 * l[i] / v[i];
	int pos = 0;
	long long int cost = 0;
	if (n == 1 || m == 1) {
		while (pos < q) {
			while (pos < q && 1.0 * t[pos].first >= nowTime) {
				ans[t[pos].second] = cost;
				pos++;
			}
			if (pos == q) break;
			if (m == 1) {
				if (pos == q) break;
				nowTime = 1000000000;
				cost = f[0];
			}
			else if (n == 1) {
				while (nowTime > t[pos].first) {
					nowTime -= get(0);
					if (ind[0] < m) {
						if (ind[0] != 0) cost -= f[ind[0] - 1];
						ind[0]++;
						cost += f[ind[0] - 1];
					}
					nowTime += get(0);
				}
			}
			ans[t[pos].second] = cost;
			pos++;
		}
		for (int i = 0; i < q; i++)
			printf("%lld ", ans[i]);
		return 0;
	}
	long double dp[2000][11];
	long double INF = 1e18;
	for (int i = 0; i < 2000; i++)
		for (int j = 0; j < 11; j++)
			dp[i][j] = INF + 1;
	dp[0][0] = nowTime;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 2000; j++) {
			if (dp[j][i] >= INF - 1) continue;
			for (int q = 0; q <= m; q++) {
				ind[i] = 0;
				long double delta = -get(i);
				ind[i] = q;
				delta += get(i);
				int nc = 0;
				if (q > 0) nc = f[q - 1];
				if (j + nc < 2000)
					dp[j + nc][i + 1] = min(dp[j + nc][i + 1], dp[j][i] + delta);
			}
		}
	}
	for (int i = 0; i < 2000; i++)
		if (dp[i][n] < INF - 1)
			cout << i << " " << dp[i][n] << endl;
	int p = 0;
	for (int i = 0; i < q; i++) {
		while (dp[p][n] > t[i].first) p++;
		ans[t[i].second] = p;
	}
	for (int i = 0; i < q; i++)
		printf("%lld ", ans[i]);
	return 0;
}