#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

const int maxN = 200000;

long long int arr[maxN];
long long int pref[maxN];
long long int ind[maxN];
pair<long long int, int> mas[maxN];
pair<long long int, long long int> ans[maxN];
int n, q;

pair<long long int, long long int> get(long long int r) {
	long long int L = 0, R = n;
	while (R - L > 1) {
		long long int M = (R + L) / 2;
		if (arr[M] <= r) L = M;
		else R = M;
	}
	if (L == 0) return { r, r };
	long long int res, p;
	long long int beg = r / arr[L] * arr[L];
	long long int add = beg / arr[L];
	long long int res1 = -1, p1 = -1;
	if (add > 0) {
		res1 = pref[L] + (add - 1);
		p1 = ind[L] + (add - 1) * arr[L];
	}
	long long int res2 = -1, p2 = -1;
	if ((r + 1) % arr[L] == 0) {
		res1++;
		p1 += arr[L];
	}
	else {
		auto t = get(r - beg);
		res2 = t.first + add;
		p2 = t.second + arr[L] * add;
	}
	if (res1 > res2) {
		res = res1;
		p = p1;
	}
	else {
		res = res2;
		p = p2;
	}
	return { res, p };
}

int main() {
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%lld", &arr[i]);
	}
	scanf("%d", &q);
	for (int i = 0; i < q; i++) {
		scanf("%lld", &mas[i].first);
		mas[i].second = i;
	}
	sort(mas, mas + q);
	int pos = 0;
	long long int mx = 0;
	long long int ps = 0;
	for (int i = 0; i < q; i++) {
		while (pos < n && arr[pos] <= mas[i].first) {
			auto t = get(arr[pos] - 1);
			pref[pos] = t.first;
			ind[pos] = t.second;
			pos++;
		}
		auto t = get(mas[i].first);
		if (pref[pos] > t.first) {
			ans[mas[i].second].first = ind[pos];
			ans[mas[i].second].second = pref[pos];
		}
		else {
			ans[mas[i].second].first = t.second;
			ans[mas[i].second].second = t.first;
		}
	}
	for (int i = 0; i < q; i++)
		printf("%lld %lld\n", ans[i].first, ans[i].second);
	return 0;
}