#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;

const int maxN = 40000;

long long int arr1[maxN];
long long int arr2[maxN];
long long int arr3[maxN];
long long int arr4[maxN];
long long int dp[maxN + 1][5];
int n, q;

void prep() {
	for (int i = 0; i <= n; i++) {
		for (int j = 0; j < 5; j++)
			dp[i][j] = -1;
	}
	dp[0][0] = 0;
}

long long int calc() {
	long long int res = 0;
	prep();
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 4; j++) {
			dp[i + 1][j + 1] = max(dp[i][j] + arr1[i], dp[i + 1][j + 1]);
			dp[i + 1][0] = max(dp[i][j], dp[i + 1][0]);
		}
	}
	for (int i = 0; i < 4; i++)
		if (dp[n - 1][i] > res) res = dp[n - 1][i];
	prep();
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 4; j++) {
			dp[i + 1][j + 1] = max(dp[i][j] + arr2[i], dp[i + 1][j + 1]);
			dp[i + 1][0] = max(dp[i][j], dp[i + 1][0]);
		}
	}
	for (int i = 0; i < 4; i++)
		if (dp[n - 1][i] > res) res = dp[n - 1][i];
	prep();
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 4; j++) {
			dp[i + 1][j + 1] = max(dp[i][j] + arr3[i], dp[i + 1][j + 1]);
			dp[i + 1][0] = max(dp[i][j], dp[i + 1][0]);
		}
	}
	for (int i = 0; i < 4; i++)
		if (dp[n - 1][i] > res) res = dp[n - 1][i];
	prep();
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 4; j++) {
			dp[i + 1][j + 1] = max(dp[i][j] + arr4[i], dp[i + 1][j + 1]);
			dp[i + 1][0] = max(dp[i][j], dp[i + 1][0]);
		}
	}
	for (int i = 0; i < 4; i++)
		if (dp[n - 1][i] > res) res = dp[n - 1][i];
	return res;
}

int main() {
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%lld", &arr1[i]);
		arr2[(i - 1 + n) % n] = arr1[i];
		arr3[(i - 2 + n) % n] = arr1[i];
		arr4[(i - 3 + n) % n] = arr1[i];
	}
	printf("%lld\n", calc());
	scanf("%d", &q);
	int pos, val;
	for (int i = 0; i < q; i++) {
		scanf("%d %d", &pos, &val);
		pos--;
		arr1[pos] = val;
		arr2[(pos - 1 + n) % n] = val;
		arr3[(pos - 2 + n) % n] = val;
		arr4[(pos - 3 + n) % n] = val;
		printf("%lld\n", calc());
	}
	return 0;
}