#include <bits/stdc++.h>
using namespace std;

typedef int64_t ll;
const ll INF = 1e18;

int n;
vector<ll> a;
int q;
vector<ll> b;

vector<ll> max_k;
vector<ll> min_s;

ll find_min(ll z) {
	int pos = lower_bound(max_k.begin(), max_k.end(), z) - max_k.begin();
	if ( pos == n - 1 ) {
		return min_s[n-2] + (z - max_k[n-2]) * a[n-1];
	} else if ( pos == 0 ) {
		return z * a[0];
	} else {
		return min_s[pos-1] + (z - max_k[pos-1]) * a[pos];
	}
}

bool check(ll z, ll b) {
	return find_min(z) <= b;
}

pair<ll, ll> find_ans(ll b) {
	ll lft = 0;
	ll rgt = 1e15;

	while ( rgt - lft > 1 ) {
		ll mid = (lft + rgt) / 2;
		if ( check(mid, b) ) {
			lft = mid;
		} else {
			rgt = mid;
		}
	}

	return {find_min(lft), lft};
}

int main() {
	cin >> n;
	a = vector<ll>(n);
	for ( int i = 0; i < n; ++i ) cin >> a[i];
	cin >> q;
	b = vector<ll>(q);
	for ( int i = 0; i < q; ++i ) cin >> b[i];

	max_k = vector<ll>(n, 0);
	min_s = vector<ll>(n, 0);

	max_k[0] = (a[1] - 1) / a[0];
	min_s[0] = max_k[0] * a[0];

	for ( int i = 1; i < n - 1; ++i ) {
		max_k[i] = max_k[i-1] + (ll)((ll)(a[i+1] - min_s[i-1] - 1) / a[i]);
		min_s[i] = min_s[i-1] + (max_k[i] - max_k[i-1]) * a[i];
	}

	max_k[n-1] = INF;
	min_s[n-1] = 0;

	for ( int i = 0; i < q; ++i ) {
		pair<ll, ll> res = find_ans(b[i]);
		cout << res.first << " " << res.second << endl;
	}
	return 0;
}