#include <bits/stdc++.h>
#pragma GCC optimize ("Ofast")

using namespace std;

const int N = 3e3 + 179;
const int K = 1e5 + N + 12;

vector<int> era[K];

void eratosphene() {
    for (long long i = 2; i < K; i++) {
        if (era[i].size() != 0) continue;
        era[i].push_back(i);
        for (long long j = i * i; j < K; j += i) {
            era[j].push_back(i);
        }
    }
}
int ans;
/*
void full(int i) {
    int n = i;
    for (auto el: era[i]) {
        n /= el;
    }
    int k = 2;
    while (k *k <= n) {
        while (n % k == 0) {
            n /= k;
            era[i].push_back(k);
        }
        k++;
    }
    sort(era[i].begin(), era[i].end());
}*/

vector<int> transform(int n) {
    int i = 1;
    vector<int> ans;
    while (i * i <= n) {
        if (n % i == 0) {
            ans.push_back(i);
            //if (n / i != i) ans.push_back(n / i);
        }
        i++;
    }
    return ans;
}


int main() {
    int n, x;
    cin >> n >> x;
    for (int s1 = n + 1; s1 < K; s1++) {
        int s2 = s1 - n;
        auto ms1 = transform(s1);
        auto ms2 = transform(s2);

        for (auto el1: ms1) {
            if (el1 == x || s1 / el1 == x) continue;
            for (auto el2: ms2) {
                //if (s1 == n + 1) {
                //    cout << el1 << " " << s1 / el1 << " || " << el2 << " " << s2 / el2 <<endl;
                //}
                if (el1 == s1 / el1) {
                    if (el2 == s2 / el2) {
                        ans++;
                    } else {
                        if (el2 < el1 && s2 / el2 < el1) ans += 2;
                    }
                } else {
                    if (el2 == s2 / el2) {
                        if (el2 < el1 && el2 < s1 / el1) ans += 2;
                    } else {
                        if (el2 < el1 && s2 / el2 < s1 / el1) ans += 2;
                        if (el2 < s1 / el1 && s2 / el2 < el1) ans += 2;
                    }

                }
            }
        }
    }

    cout << ans << endl;
    return 0;
}