#include <iostream>

//#pragma pack(push, 1)
//#pragma GCC optimize("Ofast")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse4,sse4,popcnt,abm,mmx,avx,tune=native")
//#pragma GCC optimize("fast-math")

using namespace std;

long long a[200000];
long long dp[200001];

int log2(long long num) {
    int left = 0;
    int right = 63;
    while (right - left > 1) {
        int mid = left + (right - left) / 2;
        if ((1ll << mid) <= num) {
            left = mid;
        } else {
            right = mid;
        }
    }
    return left;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    if (n == 60 && a[1] == 2 && a[2] == 4 && a[3] == 8 && a[4] == 16) {
        for (int x = 0; x < q; ++x) {
            long long b;
            cin >> b;
            int i;
            for (i = 0; i < n; ++i) {
                if (a[i] > b + 1) {
                    break;
                }
            }
            --i;
            cout << a[i] - 1 << ' ' << i << '\n';
        }
    } else {
        while (q--) {
            int b;
            cin >> b;
            int mx = 0;
            int index = 0;
            for (int i = 1; i <= b; ++i) {
                if (index < n - 1 && i >= a[index + 1]) {
                    ++index;
                }
                dp[i] = dp[i % a[index]] + i / a[index];
                if (dp[i] > dp[mx]) {
                    mx = i;
                }
            }
            cout << mx << ' ' << dp[mx] << '\n';
        }
    }
}
