#include <iostream>
#include <bitset>
#include <cstdlib>
#include <ctime>
#include <algorithm>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <queue>
#include <set>
#include <iomanip>
#include <complex>

#define fast ios_base::sync_with_stdio(0), cin.tie(), cout.tie()
#define endl '\n'
#define ll long long
#define int ll

using namespace std;

signed main() {
    fast;
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector<int> v(n),L(n);
    for(int i = 0; i < n;i++){
        cin >> v[i];
    }
    for(int i = 0; i < n;i++){
        cin >> L[i];
    }
    int m;
    cin >> m;
    vector<int> a(m);
    for(int i = 1; i < m;i++){
        cin >> a[i];
    }
    vector<int> f(m);
    for(int i = 0; i < m;i++){
        cin >> f[i];
    }
    int q;
    cin >> q;
    auto check = [&](int pos, int len)
    {
        double t = 0;
        for(int i = 0; i < n;i++){
            double speed = v[i] + a[pos];
            t += (double)L[i]/speed;
        }
        return t <= len;
    };
    auto solve = [&](int len)
    {
        int l = 0, r = m;
        int mid;
        while(r - l > 0){
            mid = (l+r)/2;
            if(check(mid,len)){
                r = mid;
            }
            else{
                l = mid+1;
            }
        }
        return l;
    };
    while(q--){
        int s,t;
        cin >> s >> t;
        int res = solve(t-s);
        if(res == m){
            if(!check(res,t-s)){
                res++;
            }
        }
        if(res == 0){
            cout << 0 << endl;
        }
        else{
            cout << f[res-1] << endl;
        };
    }
    return 0;
}
