#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const double eps = 1e-5;
int n, m, sum = 0;
vector<int> v, d, a, f;

bool ok(int e, int t) {
    double tt = 0.0;
    for (int i = 0; i < n; i++) {
        tt += d[i] * 1.0 / ((v[i] + e) * 1.0);
    }
    if (tt - t <= eps) {
        return true;
    }
    return false;
}

void solve() {
    int l, r;
    cin >> l >> r;
    int dif = r - l;
    int lt = -1, rt = sum + 1, mid;
    while (rt - lt > 1) {
        mid = (lt + rt) / 2;
        if (ok(mid, dif)) {
            rt = mid;
        } else {
            lt = mid;
        }
    }
    if (rt == 0) {
        cout << "0\n";
        return;
    }
    auto it = lower_bound(all(a), rt) - a.begin();
    if (it == m - 1) {
        cout << f.back() << "\n";
        return;
    }
    cout << f[it] << "\n";
    //cout << rt << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    // cout << fixed << setprecision(10) << 400.0 / 20.0 + 500.0 / 30.0 + 600.0 / 40.0 << "\n";
    // cout << fixed << setprecision(10) << 400.0 / 18.0 + 500.0 / 28.0 + 600.0 / 38.0 << "\n";

    cin >> n;
    v.resize(n);
    d.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> d[i];
        sum += d[i];
    }
    cin >> m;
    a.resize(m - 1);
    f.resize(m);
    for (int i = 0; i < m - 1; i++) {
        cin >> a[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> f[i];
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        solve();
    }

    return 0;
}
