#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define int long long
#define sz(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define x first
#define y second

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int maxn = 200 * 1000 + 3;

int add[maxn], pr[maxn];
int n;
vector<int> s, a;
map<int, vector<int>> mp;

vector<int> t(4 * maxn);

int d = 0;
int st, ed;

void upd_segm(int v, int l, int r) {
    if (l >= ed || st >= r) return;
    if (st <= l && r <= ed) {
        t[v] += d;
        return;
    }
    if (v == -1) exit(0);
    //cout << v << " " << l << " " << r << "\n";
    int vl = 2 * v;
    int vr = vl + 1;
    int m = (l + r) / 2;
    upd_segm(vl, l, m);
    upd_segm(vr, m, r);
}

void push_all(int v, int l, int r) {
    if (l + 1 == r) {
        add[l] = t[v];
        return;
    }
    int vl = 2 * v;
    int vr = vl + 1;
    int m = (l + r) / 2;
    t[vl] += t[v];
    t[vr] += t[v];
    push_all(vl, l, m);
    push_all(vr, m, r);
}

void solve() {
    for (auto &block : mp) {
        int cnt = 0;
        for (int i = 0; i < sz(block.y); i++) {
            if (i == 0) {
                cnt = block.y[i];
            } else {
                cnt = block.y[i] - block.y[i - 1];
            }
            if (cnt == 1) continue;
            int v = block.y[i];
            //cout << v << ": \n";
            //cout << "cnt = " << cnt << "\n";

            //cout << 2 << " " << 2 + cnt - 2 + 1 << "\n";
            //cout << cnt + n - v - 0 + 1 << " " << cnt + n - v - (cnt - 2) + 1 << "\n";
            /*
            pr[2]++;
            pr[2 + cnt - 2 + 1]--;
            pr[cnt + n - v - 0 + 1]--;
            pr[cnt + n - v - (cnt - 2) + 1]++;
            */
            //cout << "\n";
            //cout << 2 << " " << 2 + cnt - 2 + 1 << "\n\n";
            d = 1;
            st = 2 + 0;
            ed = 2 + cnt - 2 + 1;
            upd_segm(1, 0, maxn - 1);
            d = -1;
            st = cnt + n - v - (cnt - 2) + 1;
            ed = cnt + n - v - 0 + 1  + 1;
            upd_segm(1, 0, maxn - 1);

            /*
            for (int j = 0; j < cnt - 1; j++) {
                //cout << 2 + j << " " << cnt + n - v - j + 1 << "\n";
                add[2 + j]++;
                add[cnt + n - v - j + 1]--;
            }

            for (int j = v; j <= n; j++) {
                cout << "add = " << 2 + j - v << " " << cnt + j - v << "\n";
                //add[2 + j - v]++;
                //add[cnt + j - v + 1]--;
            }
            */
        }
    }
}
/*
5
1 3 2 1 2
*/

signed main() {
    ios::sync_with_stdio(false);

    cin >> n;
    a.resize(n);
    s.resize(n);
    // int p = 1;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        mp[a[i]].push_back(i + 1);
        s[i] = n - i;
        /*
        if (a[i] > 5000) {
            p = 0;
        }
        */
    }
    solve();
    int cnt = 0;
    int val = 0;
    int ad = 0;
    push_all(1, 0, maxn);
    for (int i = 1; i <= n; i++) {
        cnt += add[i];
        s[i - 1] += cnt;
    }
    for (int i = 0; i < n; i++) {
        cout << s[i] << " ";
    }
    cout << "\n";


    return 0;
}

