#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast,no-stack-protector")

int n, m;
vector<long long> l, s, gr, st;

long double check(int it){
    long double ans = 0;
    for(int i = 0; i<n; i++)
        ans += ((long double)l[i])/(s[i]+gr[it]);
    return ans;
}

int get(int t){
    //cout << t << "FEDFDSF" << endl;
    int l = -1, r = m;
    //cout << m << endl;
    while(r-l>1){
        int m = (l+r)/2;
        //cout << l << ':' << r << ' ' << t << endl;
        if(check(m)<=t)
            r = m;
        else
            l = m;
    }
    return r;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    l.resize(n);
    s.resize(n);
    for(int i = 0; i<n; i++)
        cin >> s[i];
    for(int i = 0; i<n; i++)
        cin >> l[i];
    cin >> m;
    st.resize(m+1);
    st[0] = 0;
    gr.resize(m+1);
    gr[0] = 0;
    for(int i = 1; i<m; i++)
        cin >> gr[i];
    gr[m] = 1000000000000000000;
    for(int i = 0; i<m; i++)
        cin >> st[i+1];
    int q;
    cin >> q;
    //for(int i = 0; i<m; i++)
        //cout << i << ") " << check(i) << endl;
    for(int i = 0; i<q; i++){
        int s, t;
        cin >> s >> t;
        int ans = get(t-s);
        cout << st[ans] << '\n';
    }

    return 0;
}
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100
*/
