#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast,no-stack-protector")

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    set<int> qr;
    for(int i = 0; i<n; i++){
        cin >> a[i];
        qr.insert(a[i]);
    }
    map<int, int> m;
    int it1 = 0;
    for(auto it = qr.begin(); it!=qr.end(); it++)
        m[*it] = it1++;
    for(int i = 0; i<n; i++)
        a[i] = m[a[i]];
    vector<vector<int> > jij(n);
    for(int i = 0; i<n; i++)
        jij[a[i]].push_back(i);
    vector<long long> ans(n);
    for(int i = 0; i<n; i++)
        ans[i] = ((long long)(i+1))*(n-i);
    for(int i = 0; i<n; i++){
        for(int j = 1; j<jij[i].size(); j++){
            //cout << j << '/' << jij[i].size() << endl;
            for(int y = jij[i][j]-jij[i][j-1]; y<n; y++){
                int lst = min(jij[i][j-1], n-y-1);
                int frt = max(0, jij[i][j]-y);
                //cout << y << ") " << jij[i][j-1] << ':' << jij[i][j] << ' ' << frt << ':' << lst << endl;
                ans[y] -= lst-frt+1;
            }
        }
    }
    for(int i = 0; i<n; i++)
        cout << ans[i] << ' ';
    /*vector<long long> ans(n);
    for(int i = 0; i<n; i++){
        vector<bool> qr(n);
        int jij = 0;
        for(int j = i; j<n; j++){
            if(!qr[a[j]]){
                jij++;
                qr[a[j]] = true;
            }
            ans[j-i] += jij;
        }
    }
    for(int i = 0; i<n; i++)
        cout << ans[i] << ' ';*/

    return 0;
}
/*
5
1 3 2 1 2

3
10 10 10
*/
