#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast,no-stack-protector")

struct Seq{

    int a, b, it;

    Seq(){
        a = 0;
        b = 0;
        it = 0;
    }

};

bool operator!=(Seq &a, Seq &b){
    return (a.a!=b.a)||(a.b!=b.b)||(a.it!=b.it);
}

istream& operator>>(istream &i, Seq &a){
    i >> a.a >> a.b >> a.it;
    a.a--;
    a.b--;
    return i;
}

int n, m, s;
vector<vector<int> > a;
vector<vector<Seq> > b;
vector<int> ans;

/*int solve(int it){
    //cout << it << endl;
    if(it==0){
        int jij = 0;
        for(int i = 0; i<m; i++){
            vector<int> val(2*n-1);
            for(int j = 0; j<n; j++)
                val[j] = (a[i][j]<ans[j]);
            for(int j = 0; j<n-1; j++){
                if(b[i][j].it==1)
                    val[n+j] = (val[b[i][j].a]&val[b[i][j].b]);
                else
                    val[n+j] = (val[b[i][j].a]|val[b[i][j].b]);
            }
            jij += val[2*n-2];
        }
        if(jij==s){
            for(int i = 0; i<n; i++)
                cout << ans[i] << ' ';
            exit(0);
        }
        return jij;
    }
    if(it==1){
        int l = -1, r = m;
        while(r-l>1){
            int m = (l+r)/2;
            ans.push_back(m);
            if(solve(0)>s)
                r = m;
            else
                l = m;
            ans.pop_back();
        }
        return 0;
    }
    for(int i = 0; i<=m; i++){
        ans.push_back(i);
        solve(it-1);
        ans.pop_back();
    }
    return 0;
}*/

pair<int, int> solve(int it){
    /*cout << it << ") ";
    for(int i = 0; i<ans.size(); i++)
        cout << ans[i] << ' ';
    cout << endl;*/
    if(it==0){
        int jij = 0;
        for(int i = 0; i<m; i++){
            vector<int> val(2*n-1);
            for(int j = 0; j<n; j++)
                val[j] = (a[i][j]<ans[j]);
            for(int j = 0; j<n-1; j++){
                if(b[i][j].it==1)
                    val[n+j] = (val[b[i][j].a]&val[b[i][j].b]);
                else
                    val[n+j] = (val[b[i][j].a]|val[b[i][j].b]);
            }
            jij += val[2*n-2];
            /*if(jij>s)
                return make_pair(jij, jij);
            if(jij+(m-1-i)<s)
                return make_pair(jij, jij);*/
        }
        if(jij==s){
            for(int i = 0; i<n; i++)
                cout << ans[i] << ' ';
            exit(0);
        }
        return {jij, jij};
    }
    ans.push_back(0);
    pair<int, int> kek = solve(it-1);
    int mn = kek.first;
    ans.pop_back();
    if(kek.first>s)
        return kek;
    ans.push_back(m);
    kek = solve(it-1);
    int mx = kek.second;
    ans.pop_back();
    if(kek.second<s)
        return kek;
    int l = -1, r = m;
    while(r-l>1){
        int m = (l+r)/2;
        ans.push_back(m);
        if(solve(it-1).first>s)
            r = m;
        else
            l = m;
        ans.pop_back();
    }
    return {mn, mx};
}

vector<bool> u;
vector<int> kekesh, pr;

void calc(int v){
    u[v] = true;
    if(v>=n){
        if(b[0][v-n].it==2){
            if(!u[b[0][v-n].a])
                calc(b[0][v-n].a);
            if(!u[b[0][v-n].b])
                calc(b[0][v-n].b);
        }
    }
    else if(v!=0)
        kekesh.push_back(v);
    //cout << v << ':' << endl;
    if(pr[v]!=-1&&!u[pr[v]])
        calc(pr[v]);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> s;
    a.resize(m, vector<int>(n));
    b.resize(m, vector<Seq>(n-1));
    bool keker5 = true, keker7 = true;
    vector<Seq> pjij(n-1);
    for(int i = 0; i<m; i++){
        for(int j = 0; j<n-1; j++){
            cin >> b[i][j];
            if(b[i][j].it==2)
                keker5 = false;
            if(pjij[j].it==0)
                pjij[j] = b[i][j];
            if(pjij[j]!=b[i][j])
                keker7 = false;
        }
    }
    bool keker4 = true;
    for(int i = 0; i<m; i++){
        for(int j = 0; j<n; j++){
            cin >> a[i][j];
            if(a[i][j]!=i)
                keker4 = false;
        }
    }
    if(keker4){
        for(int i = 0; i<n; i++)
            cout << s << ' ';
        return 0;
    }
    if(keker5){
        vector<int> ans(n);
        for(int i = 0; i<s; i++)
            for(int j = 0; j<n; j++)
                ans[j] = max(ans[j], a[i][j]+1);
        vector<int> bjij;
        for(int i = 0; i<m; i++){
            bool kek = true;
            for(int j = 0; j<n; j++){
                if(a[i][j]>=ans[j]){
                    //cout << a[i][j] << ':' << ans[j] << endl;
                    kek = false;
                    break;
                }
            }
            if(kek)
                bjij.push_back(a[i][0]);
        }
        if(bjij.size()!=s){
            sort(bjij.begin(), bjij.end());
            bjij.push_back(m);
            ans[0] = bjij[s];
        }
        for(int i = 0; i<n; i++)
            cout << ans[i] << ' ';
        return 0;
    }
    if(keker7){
        u.resize(2*n-1, false);
        pr.resize(2*n-1);
        pr[2*n-2] = -1;
        for(int i = 0; i<n-1; i++){
            pr[pjij[i].a] = i+n;
            pr[pjij[i].b] = i+n;
        }
        vector<int> ans(n);
        for(int i = 0; i<s; i++)
            for(int j = 0; j<n; j++)
                ans[j] = max(ans[j], a[i][j]+1);
        vector<int> bjij;
        for(int i = 0; i<m; i++){
            vector<int> val(2*n-1);
            for(int j = 0; j<n; j++)
                val[j] = (a[i][j]<ans[j]);
            for(int j = 0; j<n-1; j++){
                if(b[i][j].it==1)
                    val[n+j] = (val[b[i][j].a]&val[b[i][j].b]);
                else
                    val[n+j] = (val[b[i][j].a]|val[b[i][j].b]);
            }
            if(val[2*n-2])
                bjij.push_back(a[i][0]);
        }
        calc(0);
        for(int i = 0; i<kekesh.size(); i++)
            ans[kekesh[i]] = 0;
        if(bjij.size()!=s){
            sort(bjij.begin(), bjij.end());
            bjij.push_back(m);
            ans[0] = bjij[s];
        }
        for(int i = 0; i<n; i++)
            cout << ans[i] << ' ';
        return 0;
    }
    solve(n);
    cout << "WTF?!";

    return 0;
}
/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1

2 2 1
1 2 1
1 2 2
0 0
1 1

3 3 2
1 2 1
3 4 1
1 2 1
3 4 1
1 2 1
3 4 1
0 2 1
1 1 2
2 0 0


3 3 2
1 2 2
3 4 2
1 2 2
3 4 2
1 2 2
3 4 2
0 2 1
1 1 2
2 0 0
*/
