#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <vector>
#include <random>
#include <bitset>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast,no-stack-protector")

long long n;

long long mx(vector<long long> &a){
    long long ans = 0;
    for(long long i = 0; i<a.size(); i++)
        ans = max(ans, a[i]);
    return ans;
}

long long calc(vector<long long> &a){
    vector<vector<long long> > d(n, vector<long long>(64, 0));
    for(long long i = 0; i<64; i++){
        if((i&7)!=(i>>3))
            continue;
        d[2][i] = ((i>>0)&1)*a[0]+((i>>1)&1)*a[1]+((i>>2)&1)*a[2];
        //cout << i << ':' << d[2][i] << endl;
    }
    for(long long i = 3; i<n; i++){
        for(long long j = 0; j<64; j++){
            for(long long y1 = 0; y1<8; y1++){
                long long y = y1+((j>>3)<<3);
                if(((y>>1)&1)!=(j&1)||((y>>2)&1)!=((j>>1)&1))
                    continue;
                if((j&7)==7&&(y&7)==7)
                    continue;
                //cout << i << ':' << j << ' ' << y << endl;
                if(i+1<n){
                    d[i][j] = max(d[i][j], d[i-1][y]+((j>>2)&1)*a[i]);
                    continue;
                }
                vector<bool> jij = {(j&1), ((j>>1)&1), ((j>>2)&1), ((j>>3)&1), ((j>>4)&1), ((j>>5)&1)};
                bool kek = false;
                for(long long h = 0; h<3; h++){
                    if(jij[h]&&jij[h+1]&&jij[h+2]&&jij[h+3]){
                        kek = true;
                        break;
                    }
                }
                if(kek)
                    continue;
                d[i][j] = max(d[i][j], d[i-1][y]+((j>>2)&1)*a[i]);
                //if(i-3<3&&(y>>3)!=((y&7)>>()))
                /*vector<bool> jij = {(y&1), ((y>>1)&1), ((y>>2)&1), (j&1), ((j>>1)&1), ((j>>2)&1)};
                bool kek = false;
                for(long long h = 0; h<3; h++){
                    if(jij[h]&&jij[h+1]&&jij[h+2]&&jij[h+3]){
                        kek = true;
                        break;
                    }
                }
                if(kek)
                    continue;
                if(i+1<n){
                    d[i][j] = max(d[i][j], d[i-3][y]+(jij[3]*a[i-2])+(jij[4]*a[i-1])+(jij[5]*a[i]));
                    continue;
                }
                jij = {(j&1), ((j>>1)&1), ((j>>2)&1), ((j>>3)&1), ((j>>4)&1), ((j>>5)&1)};
                kek = false;
                for(long long h = 0; h<3; h++){
                    if(jij[h]&&jij[h+1]&&jij[h+2]&&jij[h+3]){
                        kek = true;
                        break;
                    }
                }
                if(kek)
                    continue;
                d[i][j] = max(d[i][j], d[i-3][y]+(jij[3]*a[i-2])+(jij[4]*a[i-1])+(jij[5]*a[i]));*/
            }
        }
        /*for(long long j = 0; j<8; j++){
            if(i+3<n){
                if((j&1)==0)
                    for(long long y = j; y<64; y += 8)
                        d[j][y] = mx(d[j-3])+((j>>1)&1)*a[i-1]+((j>>2)&1)*a[i];
                else{
                    if(((j>>1)&1)==0)
                        for(long long y = j; y<64; j += 8)
                            d[j][y] =
                }
            }
            else{

            }
        }*/
    }
    long long ans = mx(d[n-1]);
    return ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    vector<long long> a(n);
    for(long long i = 0; i<n; i++)
        cin >> a[i];
    cout << calc(a) << '\n';
    long long q;
    cin >> q;
    for(long long i = 0; i<q; i++){
        long long it, v;
        cin >> it >> v;
        it--;
        a[it] = v;
        cout << calc(a) << '\n';
    }
    /*long long mx = 0;
    for(long long i = 0; i<(1<<n); i++){
        bitset<10> it = i;
        bool kek = false;
        for(long long j = 0; j<n; j++){
            bool keker = true;
            for(long long y = 0; y<4; y++){
                if(!it[(j+y)%n]){
                    keker = false;
                    break;
                }
            }
            if(keker){
                kek = true;
                break;
            }
        }
        if(kek)
            continue;
        long long ans = 0;
        for(long long j = 0; j<n; j++)
            ans += it[j]*a[j];
        mx = max(mx, ans);
    }
    cout << mx << '\n';
    long long q;
    cin >> q;
    for(long long i = 0; i<q; i++){
        long long it, v;
        cin >> it >> v;
        it--;
        a[it] = v;
        long long mx = 0;
        for(long long i = 0; i<(1<<n); i++){
            bitset<10> it = i;
            bool kek = false;
            for(long long j = 0; j<n; j++){
                bool keker = true;
                for(long long y = 0; y<4; y++){
                    if(!it[(j+y)%n]){
                        keker = false;
                        break;
                    }
                }
                if(keker){
                    kek = true;
                    break;
                }
            }
            if(kek)
                continue;
            long long ans = 0;
            for(long long j = 0; j<n; j++)
                ans += it[j]*a[j];
            mx = max(mx, ans);
        }
        cout << mx << '\n';
    }*/

    return 0;
}
/*
6
1 2 3 4 5 6
2
6 0
2 5
*/
