#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <string.h>
#include <vector>
#include <random>
#include <bitset>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast,no-stack-protector")

long long n;
long long d[40000][64];
vector<bool> jij;

void calc1(int i, int v){
    memset(d[i], 0x00, sizeof(d[i][0])*64);
    for(long long j = 0; j<64; j++){
        for(long long y1 = 0; y1<2; y1++){
            long long y = y1+((j&3)<<1)+((j>>3)<<3);
            if((j&7)==7&&(y&7)==7)
                continue;
            if(i+1<n){
                d[i][j] = max(d[i][j], d[i-1][y]+((j>>2)&1)*v);
                continue;
            }
            jij = {(j&1), ((j>>1)&1), ((j>>2)&1), ((j>>3)&1), ((j>>4)&1), ((j>>5)&1)};
            bool kek = false;
            for(long long h = 0; h<3; h++){
                if(jij[h]&&jij[h+1]&&jij[h+2]&&jij[h+3]){
                    kek = true;
                    break;
                }
            }
            if(kek)
                continue;
            d[i][j] = max(d[i][j], d[i-1][y]+((j>>2)&1)*v);
        }
    }
}

long long calc(vector<long long> &a){
    for(long long i = 0; i<64; i++){
        if((i&7)!=(i>>3))
            continue;
        d[2][i] = ((i>>0)&1)*a[0]+((i>>1)&1)*a[1]+((i>>2)&1)*a[2];
    }
    for(long long i = 3; i<n; i++)
        calc1(i, a[i]);
    long long ans = 0;
    for(int i = 0; i<64; i++)
        ans = max(ans, d[n-1][i]);
    return ans;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    vector<long long> a(n);
    for(long long i = 0; i<n; i++)
        cin >> a[i];
    cout << calc(a) << '\n';
    long long q;
    cin >> q;
    for(long long i = 0; i<q; i++){
        long long it, v;
        cin >> it >> v;
        it--;
        a[it] = v;
        if(it<3){
            for(long long i = 0; i<64; i++){
                if((i&7)!=(i>>3))
                    continue;
                d[2][i] = ((i>>0)&1)*a[0]+((i>>1)&1)*a[1]+((i>>2)&1)*a[2];
            }
        }
        for(int j = max(3ll, it); j<n; j++)
            calc1(j, a[j]);
        long long ans = 0;
        for(int i = 0; i<64; i++)
            ans = max(ans, d[n-1][i]);
        cout << ans << '\n';
        //cout << calc(a) << '\n';
    }

    return 0;
}
/*
6
1 2 3 4 5 6
2
6 0
2 5
*/
