#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iostream>
#include <string.h>
#include <vector>
#include <random>
#include <cmath>
#include <ctime>
#include <queue>
#include <map>
#include <set>
using namespace std;

#pragma target("sse,sse2,sse3,ssse3,sse4,avx,avx2,tune=native")
#pragma optimize("unroll-loops")
#pragma optimize("Ofast,no-stack-protector")

const int N = 40000;
int n;
int a[N], b[N];
long long d[N][2], ans[N+1];

void inic(){
    d[0][0] = 0;
    d[0][1] = a[0];
    d[1][0] = a[0];
    d[1][1] = a[0]+a[1];
    d[2][0] = a[0]+a[1];
    d[2][1] = (long long)a[0]+a[1]+a[2];
}

void calc(int i){
    d[i][0] = max(d[i-1][0], d[i-1][1]);
    d[i][1] = a[i]+max(d[i-1][0], max(d[i-2][0]+a[i-1], d[i-3][0]+a[i-1]+a[i-2]));
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    for(int i = 0; i<n; i++)
        cin >> a[i];
    memcpy(b, a, n*sizeof(n));
    inic();
    for(int i = 3; i<n; i++)
        calc(i);
    int q;
    cin >> q;
    memset(ans, 0x7f, (q+1)*sizeof(ans[0]));
    ans[0] = min(ans[0], max(d[n-1][0], d[n-1][1]));
    vector<pair<int, int> > Q(q);
    for(int i = 0; i<q; i++){
        int it, v;
        cin >> it >> v;
        it--;
        Q[i] = {it, v};
        a[it] = v;
        if(it<3)
            inic();
        for(int i = max(3, it); i<n; i++)
            calc(i);
        ans[i+1] = min(ans[i+1], max(d[n-1][0], d[n-1][1]));
    }
    for(int i = 0; i<3; i++){
        for(int j = 1; j<n; j++)
            swap(b[j-1], b[j]);
        memcpy(a, b, n*sizeof(a[0]));
        inic();
        for(int i = 3; i<n; i++)
            calc(i);
        ans[0] = min(ans[0], max(d[n-1][0], d[n-1][1]));
        for(int i = 0; i<q; i++){
            Q[i].first--;
            if(Q[i].first==-1)
                Q[i].first = n-1;
            int it = Q[i].first, v = Q[i].second;
            a[it] = v;
            if(it<3)
                inic();
            for(int i = max(3, it); i<n; i++)
                calc(i);
            ans[i+1] = min(ans[i+1], max(d[n-1][0], d[n-1][1]));
        }
    }
    for(int i = 0; i<=q; i++)
        cout << ans[i] << '\n';

    return 0;
}
/*
6
1 2 3 4 5 6
2
6 0
2 5

4
1000000000 1000000000 1000000000 0
4
4 1
4 2
4 3
4 1000000001
*/
