#include <bits/stdc++.h>
using namespace std;
#define endl '\n'
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define len(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define int long long
void solve();
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    return 0;
}

struct bit_op{
    int a, b, t;
};

bool calc(vector<bool> a, vector<bit_op> op){
    vector<bool> res(len(a) + len(op));
    forn (i, len(a)) {
        res[i] = a[i];
    }
    forn (i, len(op)){
        if (op[i].t == 0)
            res[i + len(a)] = res[op[i].a]&res[op[i].b];
        else
            res[i + len(a)] = res[op[i].a]|res[op[i].b];
    }
    return res.back();
}


int n, m, s;
vector<vector<bit_op>> ops;
vector<vector<int>> f;
vector<vector<int>> wh;

void solve() {
    int n, m, s; cin >> n >> m >> s;
    ops.resize(m);
    forn (i, m){
        ops[i].resize(n - 1);
        forn (j, n - 1){
            cin >> ops[i][j].a >> ops[i][j].b >> ops[i][j].t;
            ops[i][j].a--;
            ops[i][j].b--;
            ops[i][j].t--;
        }
    }
    vector<vector<bool>> cur(m, vector<bool>(n));
    f.resize(m, vector<int>(n));
    wh.resize(n, vector<int>(m + 1));
    forn (i, m){
        forn (j, n){
            cin >> f[i][j];
            wh[j][f[i][j]] = i;
        }
    }
    vector<int> border(n);
    if (s == 0){
        for (auto i : border){
            cout << i << ' ';
        }
        cout << endl;
        return;
    }
    int cnt1 = 0;
    forn (i, n){
        forn (j, m){
            border[i] = j + 1;
            int ind = wh[i][border[i]];
            int oldans = calc(cur[ind], ops[ind]);
            cur[ind][i] = 1;
            int nans = calc(cur[ind], ops[ind]);
            cnt1 += nans - oldans;
            if (cnt1 == s){
                int p = 0;
                forn (i, m){
                    p += calc(cur[i], ops[i]);
                }
                if (p != s){
                    exit(1);
                }
                for (auto i : border){
                    cout << i << ' ';
                }
                cout << endl;
                return;
            }

        }

    }
}