#include <bits/stdc++.h>
using namespace std;
#define endl '\n'
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define len(a) (int) (a).size()
#define all(a) (a).begin(), (a).end()
#define int long long
void solve();
signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    solve();
    return 0;
}

struct bit_op{
    int a, b, t;
};

bool calc(vector<bool> a, vector<bit_op> op){
    vector<bool> res(len(a) + len(op));
    forn (i, len(a)) {
        res[i] = a[i];
    }
    forn (i, len(op)){
        if (op[i].t == 0)
            res[i + len(a)] = res[op[i].a]&res[op[i].b];
        else
            res[i + len(a)] = res[op[i].a]|res[op[i].b];
    }
    return res.back();
}


int n, m, s;
vector<vector<bit_op>> ops;
vector<vector<int>> f;


int get(vector<int> border){
    vector<vector<bool>> cur(m, vector<bool>(n));
    int cnt1 = 0;
    forn (ii, m){
        forn (jj, n){
            cur[ii][jj] = f[ii][jj] < border[jj];
        }
    }
    forn (ii, m){
        cnt1 += calc(cur[ii], ops[ii]);
    }
    if (cnt1 == s){
        for (auto i : border){
            cout << i << ' ';
        }
        cout << endl;
        exit(0);
    }
    return cnt1;
}
vector<int> gen(int s){
    vector<int> a(n);
    forn (i, n){
        if (s >= m){
            a[i] = m;
            s -= m;
        }
        else {
            a[i] = s;
            break;
        }
    }
    return a;
}


void solve() {
    cin >> n >> m >> s;
    ops.resize(m);
    forn (i, m){
        ops[i].resize(n - 1);
        forn (j, n - 1){
            cin >> ops[i][j].a >> ops[i][j].b >> ops[i][j].t;
            ops[i][j].a--;
            ops[i][j].b--;
            ops[i][j].t--;
        }
    }
    f.resize(m, vector<int>(n));
    forn (i, m){
        forn (j, n){
            cin >> f[i][j];
        }
    }
    forn (i, n * m){
        get(gen(i));
    }



}