#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;
typedef long double ldouble;

#ifdef LOCAL
#define TEST "C2"

#else

#endif

int main() {
#ifdef TEST
    cerr << "Test " << TEST << "\n";
#endif
#ifdef  LOCAL
    cerr << "LOCAL\n";
#ifdef TEST
    char in_file[100] = "in_";
    strcat(in_file, TEST);
    cerr << "Input file : " << in_file << "\n";
    if (!freopen(in_file, "r", stdin)) cerr << "No input found\n";
    if (!freopen("out", "w", stdout)) cerr << "Output failed\n";
#endif
#endif
    ll n;
    cin >> n;
    lvec s(n);
    lvec v(n), v2(n), rank(n);
    for (auto &el : v) cin >> el;
    v2 = v;
    sort(v2.begin(), v2.end());
    v2.erase(unique(v2.begin(), v2.end()), v2.end());
    for (ll i = 0; i < n; i++) {
        ll x = v[i];
        rank[i] = lower_bound(v2.begin(), v2.end(), x) - v2.begin();
    }
    for (ll d = 0; d < n; d++) {
        s[d] = (n - d) * v2.size();
    }
    lvec next(n, n), prev(n, -1), fr(n, -1);
    for (ll i = 0; i < n; i++) {
        ll x = rank[i];
        if (fr[x] == -1) fr[x] = i;
        if (prev[x] != -1) next[prev[x]] = i;
        prev[x] = i;
    }
    lvec add(n + 1);
    for (ll x = 0; x < v2.size(); x++) {
        ll first = -1;
        while (first != n) {
            ll second;
            if (first == -1) second = fr[x];
            else second = next[first];
            ll len = second - first - 1;
            //for(ll d = len - 1; d >= 0; d --) s[d] -= len - d;
            if(len != 0) add[len - 1]++;
            first = second;
        }
    }
    ll cur = 0, delta = 0;
    for (ll i = n ; i > -1; i--) {
        delta += add[i];
        cur += delta;
        s[i] -= cur;
    }
    for (auto el : s) cout << el << " ";
    return 0;
}