#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;
typedef long double ldouble;

#ifdef LOCAL
#define TEST ""

#else

#endif

lpair solve(ll a, ll b, ll res) {
    if(b == 0) return { res / a, 0};
    auto r = solve(b, a % b, res);
    return {r.second, r.first - a / b * r.second};
}

int main() {
    cerr << solve(7, 12, 4).first << " " << solve(7, 12, 4).second;
#ifdef TEST
    cerr << "Test " << TEST << "\n";
#endif
#ifdef  LOCAL
    cerr << "LOCAL\n";
#ifdef TEST
    char in_file[100] = "in_";
    strcat(in_file, TEST);
    cerr << "Input file : " << in_file << "\n";
    if (!freopen(in_file, "r", stdin)) cerr << "No input found\n";
    if (!freopen("out", "w", stdout)) cerr << "Output failed\n";
#endif
#endif
    ll n, exc, ans = 0;
    cin >> n >> exc;
    for (ll dc = 1; dc <= n; dc++) {
        for (ll dd = 1; dd * dc <= n; dd++) {
            ll eq = n - dc * dd;
            ll GCD = __gcd(dc, dd);
            if (eq % GCD) continue;
            eq /= GCD;
            ll x = dd / GCD, y = dc / GCD;
            auto r = solve(x, y, eq);
            ll mint = - (r.first / y), maxt = (r.second / x);
            if(r.first % y == 0) mint++;
            if(r.first < 0) mint = abs(r.first) / y + 1;
            if(r.second % x == 0) maxt--;
            if(r.second < 0) maxt = -abs(r.second) / x - 1;
            ans += max(0LL, maxt - mint + 1);
        }
    }
    cout << ans;
    return 0;
}