#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<ll> lvec;
typedef pair<ll, ll> lpair;
typedef long double ldouble;

#ifdef LOCAL
#define TEST "D"

#else

#endif

void calc(ll i, lvec& dp, lvec& a, ll mini) {
    dp[i] = dp[i - 1];
    if(i > mini + 1) dp[i] = max(dp[i], a[i - 2] + dp[i - 2]);
    if(i > mini + 2) dp[i] = max(dp[i], a[i - 2] + a[i - 3] + dp[i - 3]);
    if(i > mini + 3) dp[i] = max(dp[i], a[i - 2] + a[i - 3] + a[i - 4] + dp[i - 4]);
}

int main() {
#ifdef TEST
    cerr << "Test " << TEST << "\n";
#endif
#ifdef  LOCAL
    cerr << "LOCAL\n";
#ifdef TEST
    char in_file[100] = "in_";
    strcat(in_file, TEST);
    cerr << "Input file : " << in_file << "\n";
    if (!freopen(in_file, "r", stdin)) cerr << "No input found\n";
    if (!freopen("out", "w", stdout)) cerr << "Output failed\n";
#endif
#endif
    ll n;
    cin >> n;
    lvec dp1(n + 10), a(n), dp2(n + 10), dp3(n + 10), dp4(n + 10);
    for(auto &el : a) cin >> el;
    for(ll i = 0; i < 5; i ++) a.push_back(a[i]);
    for(ll i = 3; i < n + 2; i ++) calc(i, dp1, a, 1);
    for(ll i = 4; i < n + 3; i ++) calc(i, dp2, a, 2);
    for(ll i = 5; i < n + 4; i ++) calc(i, dp3, a, 3);
    for(ll i = 6; i < n + 5; i ++) calc(i, dp4, a, 4);
    //cout << dp1[n + 1] << " " << dp2[n + 2] << " " << dp3[n + 3] << " " << dp4[n + 4] << "\n";
    cout << max({dp1[n + 1], dp2[n + 2], dp3[n + 3], dp4[n + 4] }) << "\n";
    ll q;
    cin >> q;
    while(q--) {
        ll p, v;
        cin >> p >> v;
        a[--p] = v;
        if(p < 5) a[p + n] = v;
        for(ll i = 3; i < n + 2; i ++) calc(i, dp1, a, 1);
        for(ll i = 4; i < n + 3; i ++) calc(i, dp2, a, 2);
        for(ll i = 5; i < n + 4; i ++) calc(i, dp3, a, 3);
        for(ll i = 6; i < n + 5; i ++) calc(i, dp4, a, 4);
        //cout << dp1[n + 1] << " " << dp2[n + 2] << " " << dp3[n + 3] << " " << dp4[n + 4] << "\n";
        cout << max({dp1[n + 1], dp2[n + 2], dp3[n + 3], dp4[n + 4] }) << "\n";
    }
    return 0;
}