#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;
vector <long long> v;
vector <long long> l;
vector <long long> a;

long double check(long long m) {
    if (m == a.size()) return 0;
    long double ans = 0;
    for (long long i = 0; i < v.size(); i++) {
        ans += l[i] / (double)(v[i] + a[m]);
    }
    return ans;
}

int main() {
    long long n;
    cin >> n;
    v.resize(n);
    l.resize(n);
    for (long long i = 0; i < n; i++) {
        cin >> v[i];
    }
    for (long long j = 0; j < n; j++) {
        cin >> l[j];
    }
    long long m;
    cin >> m;
    a.resize(m, 0);
    for (long long i = 1; i < m; i++) {
        cin >> a[i];
    }
    vector <long long> f(m + 1, 0);
    for (long long i = 1; i <= m; i++) {
        cin >> f[i];
    }
    long long q;
    cin >> q;
    for (long long i = 0; i < q; i++) {
        long long s, t;
        cin >> s >> t;
        long long L = 0, r = m + 1;
        while (L + 1 < r) {
            long long m = (L + r) / 2;
            if (check(m) < (t - s) + 1e-8)
                r = m;
            else 
                L = m;
            continue;
        }
        if (check(L) <= (t - s) + 1e-8)cout << f[L] << endl;
        else cout << f[L + 1] << endl;
    }
}
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100
*/