#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <unordered_map>
#include <cmath>
#include <ctime>

using namespace std;

int main() {
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    vector <int> a(n); 
    vector <pair<int, int> > b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        b[i] = { a[i], i };
    }
    sort(b.begin(), b.end());
    for (int i = 0; i < n; i++) {
        if (i == 0 || b[i].first != b[i - 1].first) a[b[i].second] = i;
        else a[b[i].second] = a[b[i - 1].second];
    }
    if (n >= 502) {
        for (int i = 0; i < n; i++) {
            int ans = 0;
            vector <int> d(5001, 0); int u = 0;
            for (int k = 0; k <= i; k++) {
                if (d[a[k]] == 0) {
                    u++;
                }
                d[a[k]] ++;
            }
            ans += u;
            for (int j = 1; j < n - i; j++) {
                if (d[a[j - 1]] == 1) u--;
                d[a[j - 1]] --;
                if (d[a[j + i]] == 0) {
                    u++;
                }
                d[a[j + i]] ++;
                ans += u;
            }
            cout << ans << ' ';
        }
    }
    else {
        for (int i = 0; i < n; i++) {
            int ans = 0;
            unordered_map <int, int> d; int u = 0;
            for (int k = 0; k <= i; k++) {
                if (d[a[k]] == 0) {
                    u++;
                }
                d[a[k]] ++;
            }
            ans += u;
            for (int j = 1; j < n - i; j++) {
                if (d[a[j - 1]] == 1) u--;
                d[a[j - 1]] --;
                if (d[a[j + i]] == 0) {
                    u++;
                }
                d[a[j + i]] ++;
                ans += u;
            }
            cout << ans << ' ';
        }
    }
}