#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <ctime>
using namespace std;

int n, m, s;
vector <vector <pair <int, pair <int, int > > > > c;
vector <vector <int> > a;

bool bol(vector <int> z) {
    int ans = 0;
    for (int i = 0; i < m; i++) {
        vector <bool> k(n);
        for (int j = 0; j < n; j++) {
            k[j] = (bool)(a[i][j] < z[j]);
        }
        for (int j = 0; j < n - 1; j++) {
            if (c[i][j].first == 1)
                k.push_back(k[c[i][j].second.first - 1] && k[c[i][j].second.second - 1]);
            else 
                k.push_back(k[c[i][j].second.first - 1] || k[c[i][j].second.second - 1]);
            continue;
        }
        if (k[2 * n - 2]) ans++;
    }
    return ans - s;
}

void f(vector <int> z) {
    if (z.size() == n) {
        if (bol(z) == 0) {
            for (int i : z) cout << i << ' ';
            exit(0);
        }
        return;
    }
    for (int i = 0; i <= m; i++) {
        z.push_back(i);
        f(z);
        z.pop_back();
    }
}

int main() {
    cin >> n >> m >> s;
    c.resize(m);
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            int op, a, b;
            cin >> a >> b >> op;
            c[i].push_back({ op, {a, b} });
        }
    }
    vector <int> z(n, s);
    a.resize(m);
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            int num;
            cin >> num;
            a[i].push_back(num);
        }
    }
    if (bol(z) == 0) {
        for (int i = 0; i < n; i++) {
            cout << s << ' ';
        }
    }
    else {
        srand(time(NULL));
        if (m <= 2 || n == 1)f({});
        else if (n <= 2) {
            int time = clock();
            while ((clock() - time) / (long double)(CLOCKS_PER_SEC) > 0.88) {
                int h = abs(bol(z));
                auto s = z;
                z[rand() % n] += (rand() % 5) - 2;
                int h2 = abs(bol(z));
                if (h2 > h && (rand() / RAND_MAX) <= 1 / pow(2.79, h2 - h / ((clock() - time) / (long double)(CLOCKS_PER_SEC)))) {
                    z = s;
                }
            }
            for (int i = 0; i < n; i++) {
                cout << z[i] << ' '; 
            }
        }
    }
}
/*
3 2 2
2 3 2
3 4 1
1 2 1
3 4 2
1 0 0
0 1 1
*/