#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <algorithm>

#define ll long long
#define sz(v) (int)v.size()
#define forn(i, n) for (int i = 0; i < n; ++i)
#define forln(i, l, n) for (int i = l; i < n; ++i)
#define cinv(v) for (auto& x: v) cin >> x
#define fr first
#define se second
#define all(v) v.begin(), v.end()
#define pb push_back
#define pii pair<int, int>
#define pll pair<ld, ld>
#define ld long double

using namespace std;

const ll inf = (ll)2e9;

random_device rd;
mt19937 rnd(rd());

int kek (vector<pll>& goo, vector<ld>& moo, ld k, ld t) {
    ld ans = 0;
    for (auto& x: goo) {
        ld v = x.se + moo[k];
        ans += x.fr / v;
    }
    return ans <= t;
}

int BinSearch (vector<pll>& goo, vector<ld>& moo, vector<ld>& soo, ld t) {
    int l = -1, r = sz (moo);
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (kek (goo, moo, m, t)) r = m;
        else l = m;
    }
    return soo[r];
}

int main () {
    ios_base::sync_with_stdio (false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<pll> goo (n);
    ld f = 0;
    forn (i, n) {
        cin >> goo[i].se;
    }
    forn (i, n) {
        cin >> goo[i].fr;
    }
    for (auto& x: goo) f += x.fr / x.se;
    int m;
    cin >> m;
    vector<ld> moo (m - 1);
    cinv(moo);
    vector<ld> soo (m);
    cinv (soo);
    int q;
    cin >> q;
    while (q--) {
        ld s, t;
        cin >> s >> t;
        if (t - s >= f) {
            cout << 0 << '\n';
            continue;
        }
        int ans = BinSearch(goo,  moo, soo, t - s);
        cout << ans << '\n';
    }



}
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100

 */