#include <bits/stdc++.h>

using namespace std;

const int maxn = 2e5, big = 1e18;

int t[4 * maxn + 5], sum[4 * maxn + 5], ans[maxn];

void build(int v, int l, int r) {
    sum[v] = 0;
    if (l == r - 1) {
        t[v] = ans[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m, r);
    t[v] = max(t[2 * v], t[2 * v + 1]);
}

void upd(int v, int l, int r, int tl, int tr, int c) {
    if (l >= tr || tl >= r) return;
    if (l <= tl && tr <= r) {
        sum[v] += c;
        return;
    }
    int tm = (tl + tr) / 2;
    upd(2 * v, l, r, tl, tm, c);
    upd(2 * v + 1, l, r, tm, tr, c);
    t[v] = max(t[2 * v + 1] + sum[2 * v + 1], t[2 * v] + sum[2 * v]);
}

int get(int v, int l, int r, int tl, int tr) {
    if (l >= tr || tl >= r) return -big;
    if (l <= tl && tr <= r) return t[v] + sum[v];
    int tm = (tl + tr) / 2;
    return max(get(2 * v, l, r, tl, tm), get(2 * v + 1, l, r, tm, tr)) + sum[v];
}

void solve() {
    int n;
    cin >> n;
    int a[n];
    for (int i = 0; i < n; ++i) cin >> a[i];
    vector <pair <int, int> > zn(n);
    for (int i = 0; i < n; ++i) zn[i].first = a[i];
    for (int i = 0; i < n; ++i) zn[i].second = i;
    sort(zn.begin(), zn.end());
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        if (i && zn[i - 1].first != zn[i].first) ++cnt;
        a[zn[i].second] = cnt;
    }
    for (int i = 0; i < n; ++i) ans[i] = 0;
    build(1, 0, n);
    vector <queue <int> > kek(cnt + 1);
    for (int i = 0; i < n; ++i) {
        kek[a[i]].push(i);
    }
    for (int i = 0; i <= cnt; ++i) kek[i].push(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= cnt; ++j) {
            //cout << i << ' ' << kek[j].front() << '\n';
            upd(1, kek[j].front() - i, n - i, 0, n, 1);
        }
        kek[a[i]].pop();
    }
    for (int i = 0; i < n; ++i) cout << get(1, i, i + 1, 0, n) << ' ';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
