#include <bits/stdc++.h>

#define ll long long
#define ld long double

using namespace std;

const ld delta = 1e-9;

int n, m, q;
vector<int> u, s, a, f;

void go(int t) {
    ld h = 0;
    for (int i = 0; i < n; i++) h += ((ld) s[i] / (u[i]));
    if (abs(t - h) < delta || t > h) {
        cout << "0\n";
        return;
    }
    int l = 0, r = m - 2, mid;
    while (l <= r) {
        mid = (l + r) / 2;
        h = 0;
        for (int i = 0; i < n; i++)
            h += ((ld) s[i] / (u[i] + a[mid]));
        if (h <= t || abs(t - h) < delta) {
            r = mid - 1;
        } else {
            l = mid + 1;
        }
    }
    cout << f[l] << "\n";
    return;
}

signed main() {
    freopen("B.txt", "rt", stdin);
    ios::sync_with_stdio(NULL);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    u.resize(n); s.resize(n);
    for (auto &e : u) cin >> e;
    for (auto &e : s) cin >> e;
    cin >> m;
    a.resize(m - 1); f.resize(m);
    for (auto &e : a) cin >> e;
    for (auto &e : f) cin >> e;
    cin >> q;
    int s, t;
    while (q--) {
        cin >> s >> t;
        go(t - s);
    }
    return 0;
}
