#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <utility>
#include <iomanip>
using namespace std;
#define int long long
int ans1 = -1, ans2 = -1;

int n;

inline void relax(int p1, int p2) {
	int x = (p1 + p2) / 2;
	int y = p2 - x;
	if (p1 + p2 % 2 == 0 && x >= 1 && y >= 1) {
		ans1 = x;
		ans2 = y;
	}
}

void solve() {
	
	cin >> n;
	for (int i = 1; i * i <= n; ++i) {
		if (n % i == 0) {
			relax(i, n / i);
			relax(n / i, i);
		}
	}
	if (ans1 == -1) {
		cout << "No";
	}
	else {
		cout << "Yes\n" << ans1 << " " << ans2 << "\n";
	}
}

int32_t main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // DEBUG'
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
}