#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <utility>
#include <iomanip>
#include <unordered_set>
using namespace std;
#define int long long
#define ld long double

vector <int> a, pref;

inline int get(int l, int r) {
	return pref[r + 1] - pref[l];
}

void solve() {
	int n;
	cin >> n;
	a.resize(n);
	pref.resize(n + 1);
	for (auto& i : a) cin >> i;
	for (int i = 1; i <= n; ++i) pref[i] = pref[i - 1] + a[i - 1];
	int ans = 0;
	int pos = 0;
	for (int i = 0; i + 1 < n; ++i) {
		int to = get(0, i) * get(i + 1, n - 1);
		if (to > ans) {
			ans = to;
			pos = i;
		}
	}
	cout << pos + 1;
}

int32_t main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // DEBUG'
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
}