#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <utility>
#include <iomanip>
#include <unordered_set>
using namespace std;
//#define int long long
#define ld long double

int cnt(int a, int b, int cd) {
	int add = 0;
	for (int c = 1; c * c <= cd; ++c) {
		if (cd % c == 0) {
			int d = cd / c;
			if (a > c&& b > d) ++add;
			if (c != d && a > d&& b > c) ++add;
		}
	}
	return add;
}

int solve(int n, int x) {
	int ans = 0;
	for (int ab = n + 1; ab <= n * n; ++ab) {
		int cd = ab - n;
		for (int a = 2; a * a <= ab; ++a) {
			if (ab % a == 0) {
				int b = ab / a;
				if (a != x && b != x) {
					ans += cnt(a, b, cd);
					if (a != b) ans += cnt(b, a, cd);
				}
			}
		}
	}
	return ans;
}

void solve() {
	int n, k;
	cin >> n >> k;
	cout << solve(n, k);
}

int32_t main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // DEBUG'
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
}