#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <utility>
#include <iomanip>
#include <unordered_set>
using namespace std;
#define int long long
#define ld long double

const int MAXC = 1000000;

int check_second_subtask(vector <int>& a) {
	int n = a.size();
	if (n != 60) return 0;
	for (int i = 0; i < n; ++i) {
		if (a[i] != (1ll << i)) return 0;
	}
	return 1;
}

void solve() {
	int n;
	cin >> n;
	vector <int> a(n);
	for (auto& i : a) cin >> i;
	if (check_second_subtask(a)) {
		cerr << "2s\n";
		int q;
		cin >> q;
		while (q--) {
			int b;
			cin >> b;
			int ans = 0, now = 0;
			while (now <= b) {
				now = 2 * now + 1;
				++ans;
			}
			cout << now / 2 << " " << ans - 1 << "\n";
		}
		return;
	}
	vector <int> d(MAXC);
	d[0] = 0;
	int p = 0;
	for (int i = 1; i < MAXC; ++i) {
		while (p + 1 < n && a[p + 1] <= i) ++p;
		d[i] = d[i - a[p]] + 1;
	}
	vector <int> ans(MAXC);
	for (int i = 1; i < MAXC; ++i) {
		if (d[ans[i - 1]] > d[i]) ans[i] = ans[i - 1];
		else ans[i] = i;
	}
	int q;
	cin >> q;
	for (int qqq = 0; qqq < q; ++qqq) {
		int b;
		cin >> b;
		cout << ans[b] << " " << d[ans[b]] << "\n";
	}
}

int32_t main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // DEBUG'
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
}