#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <utility>
#include <iomanip>
#include <unordered_set>
using namespace std;
#define int long long
#define ld long double

const int INF = 1e18;

void solve() {
	int n;
	cin >> n;
	vector <int> a(n);
	for (auto& i : a) cin >> i;
	int q;
	cin >> q;
	while (q--) {
		int b;
		cin >> b;
		int now = 0, ans = 0;
		for (int i = 0; i < n; ++i) {
			int to = min(b, (i == n - 1 ? INF : a[i + 1] - 1));
			int op = (to - now) / a[i];
			now += op * a[i];
			ans += op;
		}
		cout << now << " " << ans << "\n";
	}
}

int32_t main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // DEBUG'
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int test = 1;
	//cin >> test;
	while (test--) {
		solve();
		cout << "\n";
	}
}