#include <iostream>

#define int long long

using namespace std;

pair<int, int> answer(int n) {
    int i = 1;
    while (i * i < n) {
        //cout << i << " " << n / i << endl;
        if (n % i == 0) {
            if (i % 2 == (n / i) % 2) return make_pair(i, n / i);
        }
        i++;
    }
    return make_pair(-1, -1);
}

signed main() {
    int n; cin >> n;
    if (n == 0) {
        cout << "YES" << endl;
        cout << 1 << " " << 1 << endl;
        return 0;
    }
    pair<int, int> ans = answer(n);
    if (ans.first == -1 && ans.second == -1) {
        cout << "NO" << endl;
        return 0;
    }
    cout << "YES" << endl;
    int x = ans.first;
    int y = ans.second;
    //cout << x << " " << y << endl;
    cout << (x + y) / 2 << " " << (y - x) / 2 << endl;
}