#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9;

int main() {
    int n; cin >> n;
    vector<int> limit(n);
    vector<int> length(n);
    for (int i = 0; i < n; i++) {
        cin >> limit[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> length[i];
    }
    int m; cin >> m;
    vector<int> segments(m + 2);
    segments[0] = -1;
    segments[1] = 0;
    for (int i = 2; i < m + 1; i++) {
        cin >> segments[i];
    }
    segments[m + 1] = INF;
    vector<int> sanction(m + 1);
    sanction[0] = 0;
    for (int i = 1; i < m + 1; i++) {
        cin >> sanction[i];
    }
    int q; cin >> q;
    for (int i = 0; i < q; i++) {
        int l, r; cin >> l >> r;
        int T = r - l;
        double left = 0;
        double right = 1e9;
        for (int k = 0; k < 100; k++) {
            double middle = (left + right) / 2;
            double t = 0;
            for (int j = 0; j < n; j++) {
                t += length[j] / (limit[j] + middle);
            }
            if (t <= T) {
                right = middle;
            } else {
                left = middle;
            }
        }
        //cout << left << " " << right << endl;
        /* int l1 = 0;
        int r1 = m + 1;
        while (r1 - l1 > 1) {
            int m1 = (l1 + r1) / 2;
            if (segments[m1] <= left) l1 = m1;
            else r1 = m1;
        } */
        int ans = 1e9;
        /* for (int i = 0; i < m - 1; i++) {
            //cout << left << " " << segments[i] << " " << segments[i + 1] << endl;
            if (segments[i] < left && left <= segments[i + 1]) {
                cout << sanction[i] << endl;
                break;
            }
        }
        //cout << left << " " << segments[m - 1] << endl;
        if (left > segments[m - 1]) cout << sanction[m - 1] << endl;
        if (left == 0) cout << 0 << endl; */
        int tl = 0;
        int tr = m + 2;
        while (tr - tl > 1) {
            int tm = (tl + tr) / 2;
            if (segments[tm] >= left) tr = tm;
            else tl = tm;
        }
        cout << sanction[tl] << endl;
    }
}