#include <iostream>
#include <vector>
#include <set>

using namespace std;

vector<vector<bool>> tree;
vector<int> array;

void build(int v, int tl, int tr) {
    if (tl + 1 == tr) {
        tree[v][array[tl]] = true;
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v + 1, tl, tm);
    build(2 * v + 2, tm, tr);
    for (int i = 1; i < 5001; i++) {
        tree[v][i] = (tree[2 * v + 1][i] || tree[2 * v + 2][i]);
    }
}

bool get(int v, int tl, int tr, int ql, int qr, int x) {
    if (ql >= tr || qr <= tl) {
        //cout << "Fuck " << v << " " << tl << " " << tr << " " << x << endl;
        return false;
    }
    if (tl + 1 == tr) {
        //cout << v << " " << tree[v][x] << endl;
        return tree[v][x];
    }
    int tm = (tl + tr) / 2;
    return get(2 * v + 1, tl, tm, ql, qr, x) || get(2 * v + 2, tm, tr, ql, qr, x);
}

int main() {
    int n; cin >> n;
    array.resize(n);
    int status = 0;
    for (int i = 0; i < n; i++) {
        cin >> array[i];
        if (array[i] > 5001) {
            status = 1;
        }
    }
    //status = 1;
    if (status == 0) {
        tree = vector<vector<bool>>(4 * n + 5, vector<bool>(5005, false));
        build(0, 0, n);
        /* for (int i = 0; i < tree.size(); i++) {
            //cout << i << ": " << tree[i][3] << endl;
        } */
        vector<vector<int>> dp(n + 1, vector<int>(n + 1, 0));
        vector<int> ans(n + 1, 0);
        dp[0][1] = 1;
        for (int i = 0; i < n + 1; i++) {
            for (int j = i + 1; j < n + 1; j++) {
                if (i + 1 == j) dp[i][j] = 1;
                else {
                    //cout << array[j - 1] << " " << i << " " << j - 1 << " " << get(0, 0, n, i, j - 1, array[j - 1]) << endl;
                    dp[i][j] = dp[i][j - 1] + 1 - get(0, 0, n, i, j - 1, array[j - 1]);
                }
                ans[j - i] += dp[i][j];
            }
        }
        for (int i = 1; i <= n; i++) {
            cout << ans[i] << " ";
        }
    }
    if (status == 1) {
        for (int i = 1; i <= n; i++) {
            long long ans = 0;
            for (int j = 0; j <= n - i; j++) {
                set<int> t;
                for (int k = j; k < i + j; k++) {
                    t.insert(array[k]);
                }
                ans += t.size();
            }
            cout << ans << " ";
        }
    }
}