#include <iostream>
#include <vector>
#include <cmath>
#define int long long

using namespace std;

bool can(int a, int b, int n, int x) {
    if (a == x || b == x) return false;
    int val = a * b - n;
    for (int i = 1; i <= sqrt(val); i++) {
        if (val % i == 0 && i < min(a, b) && (val / i) < max(a, b)) {
            //cout << a << " " << b << " " << i << " " << val / i << endl;
            return true;
        }
    }
    return false;
}

signed main() {
    int n, x; cin >> n >> x;
    int answer = 0;
    for (int a = 1; a <= n; a++) {
        for (int b = 1; b <= n; b++) {
            if (can(a, b, n, x)) {
                //cout << a << " " << b << endl;
                answer++;
            }
            //cout << 1 << endl;
        }
    }
    cout << answer << endl;
}