#include <iostream>
#include <vector>

using namespace std;

vector<int> debils;
vector<int> prefix;

vector<vector<int>> go(8, vector<int>());
vector<vector<int>> banned(8, vector<int>());

int n;

long long sum = 0;

void gen(int i) {
    if (i == n - 1) {
        for (int j = 0; j < n; j++) {
            //cout << prefix[j] << " ";
        }
        //cout << endl;
        if (n >= 4) {
            if (prefix[0] == 1 && prefix[1] == 1 && prefix[2] && prefix[n - 1] == 1) return;
            if (prefix[0] == 1 && prefix[1] && prefix[n - 2] == 1 && prefix[n - 1] == 1) return;
            if (prefix[0] && prefix[n - 1] && prefix[n - 2] && prefix[n - 3]) return;
            if (prefix[n - 4] && prefix[n - 3] == 1 && prefix[n - 2] == 1 && prefix[n - 1] == 1) return;
        }
        //cout  << "SURVIVED!" << endl;
        long long k_sum = 0;
        for (int j = 0; j < n; j++) {
            if (prefix[j] == 1) {
                k_sum += debils[j];
            }
        }
        //cout << k_sum << endl;
        sum = max(sum, k_sum);
        return;
    }
    prefix[i + 1] = 0;
    gen(i + 1);
    if (i + 1 < 3) {
        prefix[i + 1] = 1;
        gen(i + 1);
    }
    else {
        if (!(prefix[i - 2] && prefix[i - 1] == 1 && prefix[i] == 1)) {
            prefix[i + 1] = 1;
            gen(i + 1);
        }
    }
}

long long get_sum(int xmask, int ymask) {
    vector<int> daun;
    daun.push_back(xmask / 4);
    daun.push_back((xmask % 4) / 2);
    daun.push_back((xmask % 2));
    daun.push_back(ymask / 4);
    daun.push_back((ymask % 4) / 2);
    daun.push_back((ymask % 2));
    long long answer = 0;
    for (int i = 0; i < 6; i++) {
        answer += daun[i] * debils[i];
    }
    return answer;
}
void cout_answer() {
    gen(-1);
    cout << sum << endl;
    sum = 0;
}

void init1() {
    go[0].push_back(0);
    go[0].push_back(1);
    go[0].push_back(4);
    go[0].push_back(5);
    go[1].push_back(2);
    go[1].push_back(3);
    go[1].push_back(6);
    go[1].push_back(7);
    go[2].push_back(0);
    go[2].push_back(1);
    go[2].push_back(4);
    go[2].push_back(5);
    go[3].push_back(2);
    go[3].push_back(3);
    go[3].push_back(6);
    go[3].push_back(7);
    go[4].push_back(0);
    go[4].push_back(1);
    go[4].push_back(4);
    go[4].push_back(5);
    go[5].push_back(2);
    go[5].push_back(3);
    go[5].push_back(6);
    go[5].push_back(7);
    go[6].push_back(0);
    go[6].push_back(1);
    go[6].push_back(4);
    go[6].push_back(5);
    go[7].push_back(2);
    go[7].push_back(3);
    go[7].push_back(6);
    go[7].push_back(7);
    banned[1].push_back(7);
    banned[7].push_back(5);
    banned[7].push_back(6);
    banned[7].push_back(4);
    banned[3].push_back(6);
    banned[3].push_back(7);
    banned[7].push_back(7);
    banned[5].push_back(7);
}

bool isBanned(int x, int y) {
    for (int k = 0; k < banned[x].size(); k++) {
        if (banned[x][k] == y) return true;
    }
    return false;
}

int main() {
    cin >> n;
    debils.resize(n);
    for (int i = 0; i < n; i++) cin >> debils[i];
    if (n <= 5) {
        prefix.resize(n);
        cout_answer();
        int q;
        cin >> q;
        for (int i = 0; i < q; i++) {
            int index, value;
            cin >> index >> value;
            index--;
            debils[index] = value;
            cout_answer();
        }
    } else {
        vector<vector<vector<long long>>> dp(n + 3, vector<vector<long long>>(8, vector<long long>(8, 0)));
        init1();
        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < 8; j++) {
                dp[6][i][j] = get_sum(i, j);
            }
        }
        dp[6][5][7] = 0;
        dp[6][3][7] = 0;
        dp[6][3][6] = 0;
        dp[6][1][7] = 0;
        dp[6][7][4] = 0;
        dp[6][7][5] = 0;
        dp[6][7][6] = 0;
        dp[6][7][7] = 0;
        for (int i = 7; i <= n; i++) {
            for (int zmask = 0; zmask < 8; zmask++) {
                for (int xmask = 0; xmask < 8; xmask++) {
                    for (int ymask = 0; ymask < go[xmask].size(); ymask++) {
                        if (!(isBanned(xmask, ymask))) {
                            dp[i][zmask][ymask] = max(dp[i][zmask][ymask], dp[i - 1][zmask][xmask] + (ymask % 2) * debils[i - 1]);
                        }
                    }
                }
            }
        }
        long long answer = 0;
        for (int xmask = 0; xmask < 8; xmask++) {
            for (int ymask = 0; ymask < 8; ymask++) {
                if (!(isBanned(xmask, ymask))) {
                    if (!(isBanned(ymask, xmask))) {
                        answer = max(answer, dp[n][xmask][ymask]);
                        //cout << xmask << " " << ymask << endl;
                    }
                }
            }
        }
        cout << answer << endl;
        int q; cin >> q;
        for (int qu = 0; qu < q; qu++) {
            int index, value; cin >> index >> value;
            debils[index - 1] = value;
            for (int i = 0; i < 8; i++) {
                for (int j = 0; j < 8; j++) {
                    dp[6][i][j] = get_sum(i, j);
                }
            }
            dp[6][5][7] = 0;
            dp[6][3][7] = 0;
            dp[6][3][6] = 0;
            dp[6][1][7] = 0;
            dp[6][7][4] = 0;
            dp[6][7][5] = 0;
            dp[6][7][6] = 0;
            dp[6][7][7] = 0;
            for (int i = 7; i <= n; i++) {
                for (int zmask = 0; zmask < 8; zmask++) {
                    for (int xmask = 0; xmask < 8; xmask++) {
                        for (int ymask = 0; ymask < go[xmask].size(); ymask++) {
                            if (!(isBanned(xmask, ymask))) {
                                dp[i][zmask][ymask] = max(dp[i][zmask][ymask], dp[i - 1][zmask][xmask] + (ymask % 2) * debils[i - 1]);
                            }
                        }
                    }
                }
            }
            long long answer = 0;
            for (int xmask = 0; xmask < 8; xmask++) {
                for (int ymask = 0; ymask < 8; ymask++) {
                    if (!(isBanned(xmask, ymask))) {
                        if (!(isBanned(ymask, xmask))) {
                            answer = max(answer, dp[n][xmask][ymask]);
                            //cout << xmask << " " << ymask << endl;
                        }
                    }
                }
            }
            cout << answer << endl;
        }
    }
}