#include <iostream>
#include <fstream>
#include <vector>
#include <array>
#include <algorithm>

using namespace std;

int apply(vector<int>& a, vector<array<int, 3> >& ops) {
    int n = (int)a.size();
    vector<int> cur(2 * n - 1);
    for (int i = 0; i < 2 * n - 1; i++) {
        if (i < n) cur[i] = a[i];
        else if (ops[i - n][2] == 1) cur[i] = cur[ops[i - n][0]] & cur[ops[i - n][1]];
        else if (ops[i - n][2] == 2) cur[i] = cur[ops[i - n][0]] | cur[ops[i - n][1]];
    }
    return cur.back();
}

int main()
{
    //ifstream cin("input.txt");
    int n, m, s;
    cin >> n >> m >> s;
    vector<vector<array<int, 3> > > a(m, vector<array<int, 3> >(n - 1));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            int ax, bx, op;
            cin >> ax >> bx >> op;
            a[i][j] = { ax - 1, bx - 1, op };
        }
    }
    vector<vector<int> > mat(m, vector<int>(n));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) cin >> mat[i][j];
    }
    vector<int> ans(n, -1);
    for (int pos = 0; pos < n; pos++) {
        vector<array<int, 4> > val(m);
        for (int i = 0; i < m; i++) {
            for (int z = 0; z < 4; z++) {
                vector<int> cur(n);
                for (int j = 0; j < n; j++) {
                    if (j < pos) cur[j] = mat[i][j] < ans[j];
                    else if (j > pos) cur[j] = z % 2;
                    else cur[j] = z / 2;
                }
                val[i][z] = apply(cur, a[i]);
            }
        }
        int def = 0;
        for (int i = 0; i < m; i++) {
            if (val[i][0] == 1) def++;
        }
        if (def == s) {
            ans[pos] = 0;
            continue;
        }
        vector<int> ord(m);
        for (int i = 0; i < m; i++) {
            ord[mat[i][pos]] = i;
        }
        for (int ind = 0; ind < m; ind++) {
            int i = ord[ind];
            if (val[i][0] == 0 && val[i][3] == 1) {
                def++;
            }
            if (def == s) {
                ans[pos] = ind + 1;
                break;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] << ' ';
    }
    cout << endl;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
