#include <iostream>
#include <vector>
#include <algorithm>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,abm,mmx,popcnt,tune=native")

using namespace std;
using ll = long long;

const int maxn = 3001;

vector<short int> divs[maxn * maxn];

int main()
{
    int n, x;
    cin >> n >> x;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (i + j > n + 1) continue;
            divs[i * j].push_back(i);
        }
    }
    long long ans = 0;
    for (int s1 = n; s1 < maxn * maxn; s1++) {
        int s = s1 - n;
        int l = 0, r = 0;
        for (int a : divs[s1]) {
            int b = s1 / a;
            if (a == x || b == x) continue;
            while (l < (int)divs[s].size() && divs[s][l] * b <= s) l++;
            while (r < (int)divs[s].size() && divs[s][r] < a) r++;
            ans += r - l;
        }
    }
    cout << ans << endl;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
