#include <iostream>
#include <vector>
#include <algorithm>
#pragma GCC optimize("Ofast")

using namespace std;
using ll = long long;

const ll INF = 2e18;

//struct stree {
//    vector<int> t;
//    void init(vector<int>& a) {
//        int n = (int)a.size();
//        int _n = 1;
//        while (_n < n) _n *= 2;
//        n = _n;
//        t.resize(2 * n), a.resize(n);
//        for (int i = 2 * n - 1; i >= 0; i--) {
//            if (i >= n) t[i] = a[i - n];
//            else t[i] = max(t[2 * i], t[2 * i + 1]);
//        }
//    }
//    int next_greater(int pos, int val) {
//        int v = pos + (int)t.size() / 2;
//
//    }
//};

int main()
{
    int n;
    cin >> n;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<pair<ll, int> > b(n);
    b[n - 1] = { INF, n - 1 };
    for (int i = 0; i < n - 1; i++) b[i] = { a[i + 1] - a[i], i };
    sort(b.begin(), b.end());
    vector<int> suf(n + 1);
    suf[n] = n;
    for (int i = n - 1; i >= 0; i--) {
        suf[i] = min(b[i].second, suf[i + 1]);
    }
    int q;
    cin >> q;
    for (int z = 0; z < q; z++) {
        ll x;
        cin >> x;
        ll sum = 0;
        ll cnt = 0;
        while (true) {
            int ind = upper_bound(b.begin(), b.end(), make_pair(sum, n)) - b.begin();
            int pos = suf[ind];
            /*int pos = 0;
            for (int i = 0; i < n; i++) {
                if (b[i] > sum) {
                    pos = i;
                    break;
                }
            }*/
            ll c = pos < n - 1 ? (a[pos + 1] - sum - 1) / a[pos] : INF;
            ll c1 = min(c, (x - sum) / a[pos]);
            cnt += c1, sum += a[pos] * c1;
            if (c1 < c) break;
        }
        //for (int i = 0; i < n; i++) {
        //    //ll nxt = (i < n - 1 ? a[i + 1] : 1e18);
        //    ll c = i < n - 1 ? (a[i + 1] - sum - 1) / a[i] : 2e18;
        //    ll c1 = min(c, (x - sum) / a[i]);
        //    cnt += c1;
        //    sum += a[i] * c1;
        //    if (c1 < c) break;
        //}
        cout << sum << ' ' << cnt << endl;
    }
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
