#pragma region Include
#include<iostream>
#include<vector>
using namespace std;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		in >> v[i];
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v)
{
	for (int i = 0; i < v.size(); i++)
		out << v[i] << ' ';

	if (!v.empty())
		out << '\n';

	return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> v)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
			out << v[i][j] << ' ';

		out << '\n';
	}

	return out;
}
#pragma endregion

int main()
{
	long long n;
	while(cin >> n)
	{
		long long pow2 = 0;
		while (!(n & 1))
		{
			++pow2;
			n >>= 1;
		}

		if ((pow2 & 1) || n == 1)
			cout << "No\n";
		else
			cout << "Yes\n" << ((n + 1) / 2) * (1ll << (pow2 / 2)) << ' ' << ((n - 1) / 2) * (1ll << (pow2 / 2)) << '\n';
	}
}