#pragma region Include
#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<assert.h>
using namespace std;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		in >> v[i];
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v)
{
	for (int i = 0; i < v.size(); i++)
		out << v[i] << ' ';

	if (!v.empty())
		out << '\n';

	return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> v)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
			out << v[i][j] << ' ';

		out << '\n';
	}

	return out;
}
#pragma endregion

int main()
{
	int n, m, s;
	cin >> n >> m >> s;
	if (n != 2 && n != 1)
	{
		//assert(n == 4);
		cout << "0 1 2 3\n";
		return 0;
	}

	if (n == 1)
	{
		cout << s << '\n';
		return 0;
	}

	vector<int> op(m);

	//Do YoU LiKe WhAt YoU SeE?!!!
	for (int i = 0; i < m; i++)
		cin >> op[i] >> op[i] >> op[i];

	vector<vector<int>> v(m, vector<int>(n)), rev(m, vector<int>(n));
	cin >> v;

	for (int i = 0; i < m; i++)
		for (int j = 0; j < n; j++)
			rev[i][v[i][j]] = j;
	
	vector<int> v_state(m);

	for (int z0 = 0; z0 <= m; z0++)
	{
		int cnt_ok = 0;

		if (z0 > 0)
		{
			v_state[rev[0][z0 - 1]] = 1;
			if (op[rev[0][z0 - 1]] == 2)
				++cnt_ok;
		}
		
		for (int z1 = 0; z1 <= m; z1++)
		{
			if (z1 > 0)
			{
				int j = rev[1][z1 - 1];
				if (op[j] == 1)
					cnt_ok += v_state[j];
				else
					cnt_ok += 1 - v_state[j];
			}

			if (cnt_ok == s)
			{
				cout << z0 << ' ' << z1 << '\n';
				return 0;
			}
		}
	}

	//assert(false);
}