#pragma region Include
#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<assert.h>
using namespace std;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& v)
{
	for (int i = 0; i < v.size(); i++)
		in >> v[i];
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> v)
{
	for (int i = 0; i < v.size(); i++)
		out << v[i] << ' ';

	if (!v.empty())
		out << '\n';

	return out;
}

template<typename T>
ostream& operator << (ostream& out, vector<vector<T>> v)
{
	for (int i = 0; i < v.size(); i++)
	{
		for (int j = 0; j < v[i].size(); j++)
			out << v[i][j] << ' ';

		out << '\n';
	}

	return out;
}
#pragma endregion

int main()
{
	int n, x;
	cin >> n >> x;
	long long ans = 0;

	vector<vector<int>> dv(n + 1);

	for (int i = 1; i <= n; i++)
		for (int j = i; j <= n; j += i)
			dv[j].push_back(i);

	for (int i = 1; i <= n; i++)
	{
		for (int j = 1; i * j <= n; j++)
		{
			int k = n - i * j;

			for (int h : dv[k])
			{
				int d = k / h;
				if (d <= j)
					break;
				if (d != x && i + h != x)
					++ans;
			}
		}
	}

	cout << ans;
}