#include <bits/stdc++.h>

#define int long long
#define endl '\n'
#define vc vector
#define pb push_back
#define all(v) v.begin(), v.end()
#define rep(n, i) for (int i = 0; i < n; ++i)
#define fs first
#define sc second
#define endd endl; return 0;
#ifdef LOCAL
#define cerr cout
#else
#define cerr if (0) cout
#endif
#define sz(v) (int) v.size()

using namespace std;

const long long INF = 1e18;
const int N = 1e5 + 5;
const int A = 1e6 + 5;

int bit(int mask, int i) {
    return (mask >> i) & 1;
}

int stress(int n, const vc<int> &a) {
    int ans = 0;
    rep((1 << n), mask) {
        int f = 0;
        for (int i = 3; i < n + 5; ++i) {
            if (bit(mask, i % n) && bit(mask, (i - 1) % n) &&
                bit(mask, (i - 2) % n) && bit(mask, (i - 3) % n)) {
                f = 1;
                break;
            }
        }
        if (f) {
            continue;
        }
        int cnt = 0;
        rep(n, i) {
            if (bit(mask, i)) {
                cnt += a[i];
            }
        }
        ans = max(ans, cnt);
    }
    return ans;
}

int fi(const vc<int> &a) {
    int n = sz(a);
    if (n < 3) {
        return 0;
    }
    vc<vc<int>> dp(n, vc<int>(8));
    rep(8, j) {
        dp[2][j] = a[0] * ((j >> 2) & 1) + a[1] * ((j >> 1) & 1) + a[2] * (j & 1);
    }
    for (int i = 3; i < n; ++i) {
        rep(8, j) {
            dp[i][j] = max(dp[i][j], dp[i - 1][j >> 1] + (a[i]) * (j & 1));
            if (j != 7) {
                dp[i][j] = max(dp[i][j], dp[i - 1][(j >> 1) + 4] + (a[i]) * (j & 1));
            }
        }
    }
    rep(n, i) {
        rep(8, j) {
            cerr << dp[i][j] << ' ';
        }
        cerr << endl;
    }
    int ans = 0;
    rep(8, i) {
        ans = max(ans, dp[n - 1][i]);
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
#ifdef LOCAL
    freopen("text.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vc<int> a(n);
    rep(n, i) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    if (q == 0) {
        auto b = a;
        b.pop_back();
        int ans = fi(b);
        b = a;
        b.erase(b.begin());
        ans = max(ans, fi(b));
        b.clear();
        for (int i = 2; i < n - 3; ++i) {
            b.pb(a[i]);
        }
        ans = max(ans, fi(b) + a[0] + a[n - 1] + a[n - 2]);
        b.clear();
        for (int i = 3; i < n - 2; ++i) {
            b.pb(a[i]);
        }
        ans = max(ans, fi(b) + a[0] + a[1] + a[n - 1]);
        b.clear();
        for (int i = 2; i < n - 2; ++i) {
            b.pb(a[i]);
        }
        ans = max(ans, fi(b) + a[0] + a[n - 1]);
        cout << ans << endl;
        cerr << stress(n, a) << endl;
        return 0;
    }
    cout << stress(n, a) << endl;
    rep(q, lol) {
        int ind, v;
        cin >> ind >> v;
        --ind;
        a[ind] = v;
        cout << stress(n, a) << endl;
    }
    return 0;
}