#include<iomanip>
#include<iostream>
#include<vector>
#include<set>
#include<map>
using namespace std;
multiset<int> sp;
/*int make(vector<int> &a, int p) {
    sp.clear();
    int ans = 0;
    int col = 0;
    for(int i = 0; i <= p - 1; ++i) {
        if(sp.find(a[i]) == sp.end()) {
            ++col;
        }
        sp.insert(a[i]);
    }
    ans += col;
    for(int i = p; i < a.size(); ++i) {
        sp.erase(sp.find(a[i - p]));
        if(sp.find(a[i - p]) == sp.end()) {
            --col;
        }
        if(sp.find(a[i]) == sp.end()) {
            ++col;
        }
        sp.insert(a[i]);
        ans += col;
    }
    return ans;
}*/
int make(vector<int> &pred, int p) {
    int ans = 0;
    int col = 0;
    vector<int> is(pred.size(), 0);
    for(int i = 0; i <= p - 1; ++i) {
        if(pred[i] != -1 && pred[i] >= i - p + 1) {
            is[pred[i]] = 1;
        }
        else {
            ++col;
        }
    }
    ans += col;
    for(int i = p; i < pred.size(); ++i) {
        if(is[i - p] == 0) {
            --col;
        }
        if(pred[i] != -1 && pred[i] >= i - p + 1) {
            is[pred[i]] = 1;
        }
        else {
        ++col;
        }
        ans += col;
    }
    return ans;
}
int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> pred(n);
    map<int,int> sp;
    for(int i = 0; i < n; ++i) {
        if(sp.find(a[i]) != sp.end()) {
            pred[i] = sp[a[i]];
        }
        else {
            pred[i] = -1;
        }
        sp[a[i]] = i;
    }
    if(n >= 5001) {
        vector<int> ans(n);
        for(int u = 0; u <= 50; ++u) {
            vector<int> sp;
            for(int i = 0; i < n; ++i) {
                if(a[i] == u) {
                    sp.push_back(i);
                }
            }
            vector<int> lens(n);
            if(sp.size() == 0) {
                lens.push_back(n);
            }
            if(sp.size() == 1) {
                lens.push_back(sp[0] - 1);
                lens.push_back(n - sp[0]);
            }
            if(sp.size() > 1) {
                lens.push_back(sp[0] - 1);
                for(int i = 1; i < sp.size() - 1; ++i) {
                    lens.push_back(sp[i + 1] - sp[i] - 1);
                }
                lens.push_back(n - 1 - sp[sp.size() - 1]);
            }
            int col = 0;
            stable_sort(lens.begin(), lens.end());
            int it = 0;
            for(int i = 1; i <= n; ++i) {
                while(it < lens.size() && lens[it] <= i) {
                    ++it;
                    ++col;
                }
                ans[i - 1] -= col;
            }
        }
        for(int i = 0; i < n; ++i) {
            ans[i] += 50*(n - i);
        }
        for(int i = 0; i < n; ++i) {
            cout << ans[i] << "\n";
        }
        return 0;
    }
    for(int i = 0; i < n; ++i) {
        cout << make(pred, i + 1) << " ";
    }
    return 0;
}
