#include<iomanip>
#include<iostream>
#include<vector>
using namespace std;
#define int long long
const int maxn = 2e5 + 2;
int c1 = 1;
bool is(vector<int> &a) {
    if(a.size() != 60) {
        return 0;
    }
    for(int i = 0; i < a.size(); ++i) {
        if(a[i] != (c1 << i)) {
            return 0;
        }
    }
    return 1;
}
signed main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if(is(a)) {
        int q;
        cin >> q;
        for(int i = 0; i < q; ++i) {
            int b;
            cin >> b;
            int l = 0, r = 61;
            while(r - l > c1) {
                int ser = (r + l)/2;
                if(b >= (c1 << l) - c1) {
                    l = ser;
                }
                else {
                    r = ser;
                }
            }
            cout << l << " " << (c1 << l) - c1 << "\n";
        }
        return 0;
    }
    vector<int> dp(maxn);
    dp[0] = 0;
    int it = 0;
    for(int i = 1; i < maxn; ++i) {
        while(it < n - 1 && a[it + 1] <= i) {
            ++it;
        }
        dp[i] = 1 + dp[i - a[it]];
    }
    vector<pair<int,int>> an(maxn);
    an[0] = {0, 0};
    for(int i = 1; i < maxn; ++i) {
        if(dp[i] > an[i - 1].first) {
            an[i].first = dp[i];
            an[i].second = i;
        }
        else {
            an[i] = an[i - 1];
        }
    }
    int q;
    cin >> q;
    for(int i = 0; i < q; ++i) {
        int b;
        cin >> b;
        cout << an[b].second << " " << an[b].first << "\n";
    }
    return 0;
}
