#include<iostream>
#include<iomanip>
#include<vector>
using namespace std;
#define int long long
const int maxn = 40000;
vector<int> dp(maxn);
int f(vector<int> &a) {
    int n = a.size();
    for(int i = 0; i < n; ++i) {
        dp[i] = 0;
    }
    for(int i = n - 1; i >= 1; --i) {
        int sum = 0;
        for(int k = 0; k <= 2  && i + k < n; ++k) {
            sum += a[i + k];
            if(i + k + 2 >= n) {
                dp[i] = max(dp[i], sum);
            }
            else {
                dp[i] = max(dp[i], sum + dp[i + k + 2]);
            }
        }
    }
    int ans = 0;
    for(int i = 0; i < n; ++i) {
        ans = max(ans, dp[i]);
    }
    return ans;
}
signed main() {
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> z1(n);
    vector<int> z2(n);
    vector<int> z3(n);
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    for(int i = 0; i < n; ++i) {
        z1[i] = a[(i + 1)%n];
        z2[i] = a[(i + 2)%n];
        z3[i] = a[(i + 3)%n];
    }
    if(n <= 3) {
        int sum = 0;
        for(int i = 0; i < n; ++i) {
            sum += a[i];
        }
        cout << sum << "\n";
        int q;
        cin >> q;
        for(int i = 0; i < q; ++i) {
            int pos, p;
            cin >> pos, p;
            --pos;
            sum -= a[pos];
            sum += p;
            a[pos] = p;
            cout << sum << "\n";
        }
        return 1;
    }
    cout << max(max(f(a), f(z1)), max(f(z2), f(z3))) << "\n";
    int q;
    cin >> q;
    for(int i = 0; i < q; ++i) {
        int pos, p;
        cin >> pos >> p;
        --pos;
        a[pos] = p;
        z1[(pos - 1 + n)%n] = p;
        z2[(pos - 2 + n)%n] = p;
        z3[(pos - 3 + n)%n] = p;
        cout << max(max(f(a), f(z1)), max(f(z2), f(z3))) << "\n";
    }
    return 0;
}
