#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<ld> num(n);
    for (int i = 0; i < n; i++)
        cin >> num[i];

    ld x = num[0];
    ld y = 0;
    for (int i = 1; i < n; i++)
        y += num[i];

    ld best = x * y;
    int ans = 0;
    for (int i = 1; i < n; i++)
    {
        x += num[i];
        y -= num[i];
        if (x * y > best)
        {
            best = x * y;
            ans = i;
        }
    }

    cout << ans + 1 << endl;

    return 0;
}