#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, x;
    cin >> n >> x;

    vector<vector<int>> counted(3000 + 1500 * 1500 + 1);

    int ans = 0;
    for (int c = 1; c <= 1500; c++)
    {
        for (int d = 1; d <= c; d++)
        {
            if ((c + 1) * (d + 1) - c * d > n)
                continue;

            int q = n + c * d;
            if (counted[q].empty())
            {
                vector<int> bw;
                for (int f = 1; f * f <= q; f++)
                {
                    if (q % f == 0)
                    {
                        counted[q].push_back(f);
                        if (f * f != q)
                            bw.push_back(q / f);
                    }
                }

                for (auto it = bw.rbegin(); it != bw.rend(); it++)
                    counted[q].push_back(*it);
            }

            for (auto it = lower_bound(counted[q].begin(), counted[q].end(), c + 1);
                it != counted[q].end(); it++)
            {
                int a = *it;

                if (a * a > q)
                    break;
                if (q / a <= d)
                    break;

                if (q % a == 0 && a != x && q / a != x)
                {
                    ans++;
                    if (c != d)
                        ans++;
                }
            }

            for (auto it = lower_bound(counted[q].begin(), counted[q].end(), d + 1);
                 it != counted[q].end(); it++)
            {
                int b = *it;

                if (b * b >= q)
                    break;
                if (q / b <= c)
                    break;

                if (q % b == 0 && b != x && q / b != x)
                {
                    ans++;
                    if (c != d)
                        ans++;
                }
            }
        }
    }

    cout << ans << endl;

    return 0;
}