#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, x;
    cin >> n >> x;

    vector<vector<int>> counted(3000 + 1500 * 1500 + 1);

    ll ans = 0;
    for (int c = 1; c <= 1500; c++)
    {
        for (int d = 1; d <= c; d++)
        {
            if ((c + 1) * (d + 1) - c * d > n)
                continue;

            int q = n + c * d;
            if (counted[q].empty())
            {
                vector<int> bw;
                for (int f = 1; f * f <= q; f++)
                {
                    if (q % f == 0)
                    {
                        counted[q].push_back(f);
                        if (f * f != q)
                            bw.push_back(q / f);
                    }
                }

                for (auto it = bw.rbegin(); it != bw.rend(); it++)
                    counted[q].push_back(*it);
            }

            int l = lower_bound(counted[q].begin(), counted[q].end(), c + 1) - counted[q].begin();
            int r;
            if (q % d == 0)
                r = lower_bound(counted[q].begin(), counted[q].end(), q / d) - counted[q].begin();
            else
                r = upper_bound(counted[q].begin(), counted[q].end(), q / d) - counted[q].begin();

            ll add = r - l;
            if (add <= 0)
                continue;

            if (x != 0 && q % x == 0)
            {
                if (counted[q][l] <= x && x <= counted[q][r - 1])
                    add--;
                if (x * x != q && counted[q][l] <= q / x && q / x <= counted[q][r - 1])
                    add--;
            }

            if (c != d)
                ans += add * 2ll;
            else
                ans += add;
        }
    }

    cout << ans << endl;

    return 0;
}