#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<ll> num(n);
    for (int i = 0; i < n; i++)
        cin >> num[i];

    vector<ll> start(n, 0);
    vector<ll> stans(n, 0);
    for (int i = 1; i < n; i++)
    {
        start[i] = start[i - 1] + ((num[i] - start[i - 1] - 1) / num[i - 1]) * num[i - 1];
        stans[i] = stans[i - 1] + (num[i] - start[i - 1] - 1) / num[i - 1];
    }

    int q;
    cin >> q;

    for (int i = 0; i < q; i++)
    {
        ll x;
        cin >> x;

        int a = upper_bound(num.begin(), num.end(), x) - num.begin() - 1;
        ll v = start[a] + ((x - start[a]) / num[a]) * num[a];
        ll vans = stans[a] + (x - start[a]) / num[a];
        cout << v << " " << vans << endl;
    }

    return 0;
}