#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#define l first
#define r second

using namespace std;

const int maxn = 2e6;

int n, m, s;
pair<int, int> g[maxn];
vector<vector<int> > v;
int tp[maxn], cz[maxn];
int cn;

bool dfs(int x) {
    if (x % cn < n)
        return (v[x / cn][x % cn] < cz[x % cn]);
    if (tp[x] == 1)
        return dfs(g[x].l) && dfs(g[x].r);
    else
        return dfs(g[x].l) || dfs(g[x].r);
}

bool calc(int i) {
    return dfs(cn * (i + 1) - 1);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cin >> n >> m >> s;
    cn = 2 * n - 1;
    v.resize(m, vector<int>(n, 0));
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            int u, v, t; cin >> u >> v >> t;
            --u; --v; g[cn * i + j + n] = {u + cn * i, v + cn * i};
            tp[cn * i + j + n] = t;
        }
    }
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
            cin >> v[i][j];
    int _l = -1, _r = m;
    while (_r - _l > 1) {
        int md = (_l + _r) / 2;
        for (int i = 0; i < n; i++)
            cz[i] = md;
        int cnt = 0;
        for (int i = 0; i < m; i++)
            cnt += calc(i);
        if (cnt < s) _l = md;
        else _r = md;
    }
    int pa = _l;
    _l = -1; _r = n;
    while (_r - _l > 1) {
        int md = (_l + _r) / 2;
        for (int i = 0; i < n; i++)
            cz[i] = pa + (i < md);
        int cnt = 0;
        for (int i = 0; i < m; i++)
            cnt += calc(i);
        if (cnt < s) _l = md;
        else _r = md;
    }
    for (int i = 0; i < n; i++)
        cz[i] = pa + (i < _r);
    for (int i = 0; i < n; i++)
        cout << cz[i] << ' ';
    return 0;
}
/*
4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1
*/
