#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,avx,avx2,abm,mmx")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;};
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;};

int n;
vector<int> v;
vector<int> l;
int m;
vector<int> a;
vector<int> f;
void read() {
	cin >> n;
	v.resize(n);
	for (auto &i : v)
		cin >> i;
	l.resize(n);
	for (auto &i : l)
		cin >> i;
	cin >> m;
	a.resize(m - 1);
	for (auto &i : a)
		cin >> i;
	a.push_back(1e9 + 10);
	f.resize(m);
	for (auto &i : f)
		cin >> i;
}

bool check(ld add, int t) {
	ld T = 0;
	for (int i = 0; i < n; i++) {
		T += (ld)l[i] / (v[i] + add);
	}
	return T <= t || abs(T - t) < 1e-9;
}

int solve(int t) {
	if (check(0, t)) return 0;
	ld l = 0, r = 1e9 + 10;
	while (abs(l - r) > 1e-9) {
		ld mid = (l + r) / 2;
		if (check(mid, t)) {
			r = mid;
		}
		else {
			l = mid;
		}
	} 
	int pos = lower_bound(all(a), r) - a.begin();
	return f[pos];
}

vector<int> ans;

void run() {
	int q;
	cin >> q;
	while (q--) {
		int s, f;
		cin >> s >> f;
		ans.push_back(solve(f - s));
	}
}

void write() {
	for (auto i : ans)
		cout << i << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}

