#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,avx,avx2,abm,mmx")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;};
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;};

int n, x;

void read() {
	cin >> n >> x;
}

int get(int a, int b) {
	int have = a * b - n;
	if (have > a * b) return 0;
	if (have <= 0) return 0;
	int ans = 0;
	for (int i = 1; i * i <= have; i++) {
		if (have % i) continue;
		if (a > i && b > have / i)
			ans++;
		if (i * i == have) continue;
		if (b > i && a > have / i)
			ans++;
	}
	return ans;
}

int ans = 0;

void run() {
	for (int a = 2; a <= n; a++) {
		for (int b = 2; b <= n; b++) {
			if (a == x || b == x) continue;
			ans += get(a, b);
		//	cout << ans << endl;
		}
	}
}

void write() {
	cout << ans << endl;
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}

