#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,avx,avx2,abm,mmx")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;};
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;};

#define int ll

const int MAXN = 4e4 + 10;
int dp[MAXN][5];
int a[MAXN];
int n;

void read() {
	cin >> n;
	for (int i = 1; i <= n; i++)
		cin >> a[i];
}

const int INF = -1e18;

void clear() {
	for (int i = 0; i <= n + 10; i++)
		for (int j = 0; j <= 4; j++)
				dp[i][j] = INF;
}

int get_val(int pos) {
	if (pos <= n) return a[pos];
	return a[pos - n];
}

int calc(int pos) {
	clear();
	dp[pos][0] = 0;
	for (int i = pos + 1; i <= n + pos - 1; i++) {
		int x = 0;
		for (int j = 0; j <= 3; j++)
			chkmax(x, dp[i - 1][j]);
		dp[i][0] = x;
		for (int j = 1; j <= 3; j++)
			if (dp[i - 1][j - 1] != INF)
				dp[i][j] = dp[i - 1][j - 1] + get_val(i);
	}
	int ans = 0;
	for (int j = 0; j <= 3; j++)
		chkmax(ans, dp[n + pos - 1][j]);
	return ans;
}

int calc() {
	if (n <= 3) {
		int ans = 0;
		for (int i = 1; i <= n; i++)
			ans += a[i];
		return ans;
	}
	int ans = 0;
	for (int i = 1; i <= 4; i++){
		chkmax(ans, calc(i));
		//cout << calc(i) << " ";
	}
	//cout << endl;
	return ans;
}

void upd() {
	int p, x;
	cin >> p >> x;
	a[p] = x;
}

vector<int> ans;

void run() {
	ans.push_back(calc());
	//return;
	int q;
	cin >> q;
	while (q--) {
		upd();
		ans.push_back(calc());
	}
}

void write() {
	for (auto i : ans)
		cout << i << "\n";
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}

