#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    /*
     vector<int> left(n, -1);

     for (int i = 0; i < n; i++) {
        if (mapi[a[i]] != 0) {
            left[i] = mapi[a[i]] - 1;
        }
        mapi[a[i]] = i + 1;
     }
     mapi.clear();
     vector<int> right(n, n);
     for (int i = n - 1; i >= 0; i--) {
        if (mapi[a[i]] != 0) {
            right[i] = mapi[a[i]] - 1;
        }
        mapi[a[i]] = i + 1;
     }
     */

     map<int, int> mapi;
     vector<ll> ans(n + 1);

    for (int i = 1; i <= n; i++) {
        int res = 0;
        for (int j = 0; j < i; j++) {
            if (mapi[a[j]] == 0) {
                res++;
            }
            mapi[a[j]]++;
        }
        ans[i] += res;

        for (int j = i, k = 0; j < n; j++, k++) {
            if (mapi[a[k]] == 1) {
                res--;
            }
            mapi[a[k]]--;
            if (mapi[a[j]] == 0) {
                res++;
            }

            mapi[a[j]]++;
            ans[i] += res;
        }
        for (int j = n - i; j < n; j++) {
            mapi[a[j]]--;
        }

    }
    for (int i = 1; i <= n; i++) {
        cout << ans[i] << " ";
    }

    return 0;
}

/*
5
1 3 2 1 2

10
1 2 3 4 5 6 7 8 9 10

*/

