#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>
#include <functional>
#include <map>
using namespace std;

const int INF = 1000000001;

int main() {
	int n;
	cin >> n;
	vector <long long int> arr(n);
	vector <pair<long long int, long long int>> dp_arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}

	function <pair<long long int, long long int>(long long int)> f = [&](long long int num) {
		int l = 0, r = n;
		while (l + 1 < r) {
			int mid = (l + r) / 2;
			if (num < arr[mid]) {
				r = mid;
			} else {
				l = mid;
			}
		}
		if (num == 0) {
			return make_pair(0LL, 0LL);
		}
		if (l == 0) {
			return make_pair(num, num);
		}
		long long int dp = arr[l];
		pair<long long int, long long int> ans1 = f(num % dp);
		ans1.first += num / dp;
		ans1.second += (long long int(num) / dp) * dp;
		pair<long long int, long long int> ans2 = dp_arr[l];
		ans2.first += (num / dp) - 1;
		ans2.second += ((long long int)((num / dp) - 1)) * dp;
		if (ans2.first > ans1.first) {
			swap(ans1, ans2);
		}
		return ans1;
	};

	for (int i = 0; i < n; i++) {
		dp_arr[i] = f(arr[i] - 1);
	}

	int q;
	cin >> q;
	long long int b;
	for (int i = 0; i < q; i++) {
		cin >> b;
		pair<long long int, long long int> ans = f(b);
		cout << ans.second << " " << ans.first << "\n";
	}

//	system("pause");
	return 0;
}