#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>
#include <functional>
#include <map>
using namespace std;

const int INF = 1000000001;

int main() {
	int n;
	cin >> n;
	vector <long long int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}

	function <long long int()> f = [&]() {
		long long int ans = -1;
		for (long long int mask = 0; mask < (1LL << n); mask++) {
			long long int dp_ans = 0;
			bool dpdp = false;
			for (int i = 0; i < n; i++) {
				int dp = 0;
				for (int j = 0; j < 4; j++) {
					int l = (i + j) % n;
					if (((mask % (1LL << (l + 1))) / (1LL << l))) {
						dp++;
					}
				}
				if (dp == 4) {
					dpdp = true;
					break;
				}
			}
			if (dpdp) {
				continue;
			}
			for (int i = 0; i < n; i++) {
				if ((mask % (1LL << (i + 1))) / (1LL << i)) {
					dp_ans += arr[i];
				}
			}
			if (dp_ans > ans) {
				ans = dp_ans;
			}
		}
		return ans;
	};

	cout << f() << "\n";

	int q;
	cin >> q;
	int p;
	long long int v;
	for (int i = 0; i < q; i++) {
		cin >> p >> v;
		p--;
		arr[p] = v;
		cout << f() << "\n";
	}
//	system("pause");
	return 0;
}