#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>
#include <functional>
#include <map>
using namespace std;

const int INF = 1000000001;

int main() {
	int n;
	cin >> n;
	vector <long long int> arr(n);
	vector <vector <vector <long long int>>> dp_arr(n, vector <vector <long long int>>(8, vector <long long int>(8)));
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}

	function <void()> f = [&]() {
		for (int i = 0; i < n; i++) {
			for (int mask1 = 0; mask1 < 8; mask1++) {
				for (int mask2 = 0; mask2 < 8; mask2++) {
					dp_arr[i][mask1][mask2] = -1;
				}
			}
		}
		for (int mask = 0 ; mask < 8 ; mask++){
			dp_arr[2][mask][mask] = 0;
			for (int i = 0; i < 3; i++) {
				if ((mask % (1 << (i + 1))) / (1 << i)) {
					dp_arr[2][mask][mask] += arr[i];
				}
			}
		}
		for (int i = 3; i < n; i++) {
			for (int mask1 = 0; mask1 < 8; mask1++) {
				for (int mask2 = 0; mask2 < 8; mask2++) {
					if (dp_arr[i - 1][(mask1 % 4) * 2][mask2] != -1) {
						if (mask1 / 4) {
							dp_arr[i][mask1][mask2] = max(dp_arr[i - 1][(mask1 % 4) * 2][mask2], dp_arr[i - 1][(mask1 % 4) * 2 + 1][mask2]) + arr[i];
						}
						else {
							dp_arr[i][mask1][mask2] = max(dp_arr[i - 1][(mask1 % 4) * 2][mask2], dp_arr[i - 1][(mask1 % 4) * 2 + 1][mask2]);
						}
					}
					else {
						dp_arr[i][mask1][mask2] = -1;
					}
				}
			}
		}
		for (int mask1 = 0; mask1 < 8; mask1++) {
			for (int mask2 = 0; mask2 < 8; mask2++) {
				int mask = mask1 + mask2 * 8;
				for (int i = 0; i < 3; i++) {
					if ((mask % (1 << (i + 4))) / (1 << i) == 15) {
						dp_arr[n - 1][mask1][mask2] = -1;
					}
				}
			}
		}
		long long int ans = -1;
		for (int mask1 = 0; mask1 < 8; mask1++) {
			for (int mask2 = 0; mask2 < 8; mask2++) {
				if (ans < dp_arr[n - 1][mask1][mask2]) {
					ans = dp_arr[n - 1][mask1][mask2];
				}
			}
		}
		cout << ans << "\n";
	};

	f();

	int q;
	cin >> q;
	int p;
	long long int v;
	for (int i = 0; i < q; i++) {
		cin >> p >> v;
		p--;
		arr[p] = v;
		f();
	}
//	system("pause");
	return 0;
}