#include <iostream>
#include <iomanip>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <stack>
#include <functional>
#include <map>
using namespace std;

const long long int INF = 100000000000000001;

int main() {
	int n;
	cin >> n;
	vector <long long int> arr(n);
	vector <vector <long long int>> dp_arr(n, vector <long long int>(8));
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}

	function <void()> f = [&]() {
		for (int i = 0; i < n; i++) {
			for (int mask = 0; mask < 8; mask++) {
				dp_arr[i][mask] = (-1LL) * INF;
			}
		}
		for (int mask = 0 ; mask < 8 ; mask++){
			dp_arr[0][mask] = 0;
			for (int i = 0; i < 3; i++) {
				if ((mask % (1 << (i + 1))) / (1 << i)) {
					dp_arr[0][mask] += arr[i];
				}
			}
		}
		for (int i = 1; i < n; i++) {
			for (int mask = 0; mask < 8; mask++) {
				if (mask == 7) {
					dp_arr[i][mask] = dp_arr[i - 1][6] + arr[i + 2];
				}
				else {
					if (mask / 4) {
						dp_arr[i][mask] = max(dp_arr[i - 1][(mask % 4) * 2], dp_arr[i - 1][(mask % 4) * 2 + 1]) + arr[i + 2];
					}
					else {
						dp_arr[i][mask] = max(dp_arr[i - 1][(mask % 4) * 2], dp_arr[i - 1][(mask % 4) * 2 + 1]);
					}
				}
			}
		}
		long long int ans = (-1LL) * INF;
		for (int mask = 0; mask < 8; mask++) {
			if (ans < dp_arr[n - 1][mask]) {
				ans = dp_arr[n - 1][mask];
			}
		}
		cout << ans / 3 << "\n";
	};

	f();

	int q;
	cin >> q;
	int p;
	long long int v;
	for (int i = 0; i < q; i++) {
		cin >> p >> v;
		p--;
		arr[p] = v;
		f();
	}
//	system("pause");
	return 0;
}