#define _USE_MATH_DEFINES

#pragma GCC optimize("Ofast,no-stack-protector")

#include <bits/stdc++.h>

// #define int long long 
#define endl "\n"
#define double long double 
#define pii pair<int, int>
#define vec vector
#define pb push_back
#define $(x) (int)((x).size())
#define dbg(x) cout << #x << " = " << (x) << endl;
#define x first
#define y second

using namespace std;

void solve(); signed main() {
	// freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(6);
	solve();
	return 0;
}

const int MAXN = 10e6 + 10;

void solve() {
	int n, x;
	cin >> n >> x;

	vec<vec<int>> divs(MAXN);
	for (int a = 1; a <= 1000; ++a) {
		for (int b = 1; b <= 1000; ++b) {
			divs[a * b].pb(a);
			divs[a * b].pb(b);
		}
	}
	for (int i = 1; i < MAXN; ++i) {
		sort(divs[i].begin(), divs[i].end());
		divs[i].resize(unique(divs[i].begin(), divs[i].end()) - divs[i].begin());
	}

	int ans = 0;
	for (int a = 2; a <= 1000; ++a) {
		for (int b = 2; b <= 1000; ++b) {
			if (a != x && b != x) {
				int t = a * b - n;
				if (t <= 0) continue;

				int id1 = lower_bound(divs[t].begin(), divs[t].end(), a) - divs[t].begin();
				int id2 = lower_bound(divs[t].begin(), divs[t].end(), b) - divs[t].begin();
				id2--;
				id1--;
				if (id1 == -1 || id2 == -1) continue; 
				int cur = t / divs[t][id1];
				int curid = lower_bound(divs[t].begin(), divs[t].end(), cur) - divs[t].begin();
				if (curid > id2) {
					continue;
				}
				int l = -1, r = id1;
				while (r - l > 1) {
					int mid = (r + l) / 2;
					int cur = t / divs[t][mid];
					int curid = lower_bound(divs[t].begin(), divs[t].end(), cur) - divs[t].begin();
					if (curid <= id2) {
						r = mid;
					}
					else {
						l = mid;
					}
				}
				ans += (id1 - r + 1);
			}
		}
	}

	cout << ans << endl;	
}