#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

#define int long long 
#define endl "\n"
#define double long double 
#define pii pair<int, int>
#define vec vector
#define pb push_back
#define $(x) (int)((x).size())
#define dbg(x) cout << #x << " = " << (x) << endl;

using namespace std;

void solve(); signed main() {
	// freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(6);
	solve();
	return 0;
}

const int MAXN = 2e5 + 10, INF = 1e18;

void solve() {
	int n;
	cin >> n;
	vec<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	if (n == 60 && a[1] == 2) {
		int q;
		cin >> q;
		for (int i = 0; i < q; ++i) {
			int b;
			cin >> b;
			int t = (int)log2(b) + 1;
			if (b == ((1ll << t) - 1)) {
				cout << b << " " << t << endl;
			}
			else {
				cout << (1ll << (t - 1)) - 1 << " " << t - 1 << endl;
			}
		}
		return;
	}

	int q;
	cin >> q;
	for (int _ = 0; _ < q; ++_) {
		int b; 
		cin >> b;
		vec<int> dp(MAXN);
		dp[0] = 0;
		for (int i = 1; i < MAXN; ++i) {
			int it = upper_bound(a.begin(), a.end(), i) - a.begin();
			it--;
			it = a[it];
			int k = i / it;
			dp[i] = dp[i - k * it] + k;
		}

		int mx = -INF, id = -1;
		for (int i = 0; i <= b; ++i) {
			if (mx <= dp[i]) {
				mx = dp[i];
				id = i;
			}
		}

		cout << id << " " << mx << endl;
	}
}