#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

#define int long long 
#define endl "\n"
#define double long double 
#define pii pair<int, int>
#define vec vector
#define pb push_back
#define $(x) (int)((x).size())
#define dbg(x) cout << #x << " = " << (x) << endl;
#define x first
#define y second

using namespace std;

void solve(); signed main() {
	// freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(6);
	solve();
	return 0;
}

void solve() {
	int n;
	cin >> n;
	vec<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}		

	if (n == 1) {
		int q;
		cin >> q;
		for (int i = 0; i < q; ++i) {
			int b;
			cin >> b;
			cout << b << endl;
		}
		return;
	}
	a.pb(1e18 + 1);

	vec<pii> dp(n);
	dp[0] = {a[1] - 1, a[1] - 1};
	for (int i = 1; i < n; ++i) {
		auto p = dp[i - 1];
		int num = p.x, cnt = p.y;
		int k = (a[i + 1] - num) / a[i];
		dp[i] = {num + k * a[i], cnt + k};
	}

	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int b;
		cin >> b;
		int id = upper_bound(a.begin(), a.end(), b) - a.begin();
		id--;
		if (id == 0) {
			cout << b << " " << b << endl;
		}
		else {
			if (dp[id].x <= b) {
				cout << dp[id].x << " " << dp[id].y << endl;
			}
			else {
				cout << dp[id - 1].x << " " << dp[id - 1].y << endl;
			}
		}
	}
}