#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

#define int long long 
#define endl "\n"
#define double long double 
#define pii pair<int, int>
#define vec vector
#define pb push_back
#define $(x) (int)((x).size())
#define dbg(x) cout << #x << " = " << (x) << endl;
#define x first
#define y second

using namespace std;

void solve(); signed main() {
	// freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(6);
	solve();
	return 0;
}

const int MAXN = 1000 + 10, INF = 1e18;

void solve() {
	int n;
	cin >> n;
	assert(n != 1);
	vec<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}		

	if (n == 1) {
		int q;
		cin >> q;
		for (int i = 0; i < q; ++i) {
			int b;
			cin >> b;
			cout << b << endl;
		}
		return;
	}
	a.pb(1e18 + 1);

	vec<pii> dp1(n);
	dp1[0] = {a[1] - 1, a[1] - 1};
	for (int i = 1; i < n; ++i) {
		auto p = dp1[i - 1];
		int num = p.x, cnt = p.y;
		int k = (a[i + 1] - num) / a[i];
		dp1[i] = {num + k * a[i], cnt + k};
	}

	vec<vec<int>> dp(n, vec<int>(MAXN, INF));
	for (int i = 1; i < MAXN; ++i) {
		dp[0][i] = i;
	}
	for (int i = 0; i < n; ++i) {
		dp[i][0] = 0;
	}
	for (int i = 0; i < n - 1; ++i) {
		for (int j = 0; j < MAXN; ++j) {
			int num = dp[i][j], cnt = j;
			if (num < a[i + 1]) { 
				for (int k = 1; k < MAXN; ++k) {
					if (num + k * a[i + 1] >= a[i + 2]) break;
					if (j + k < MAXN) {
						dp[i + 1][j + k] = min(dp[i + 1][j + k], dp[i][j] + k * a[i + 1]);
					}
				}
			}
		}
	}

	// dbg(dp[3][1])

	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int b;
		cin >> b;
		int id = upper_bound(a.begin(), a.end(), b) - a.begin();
		id--;
		if (id == 0) {
			cout << b << " " << b << endl;
		}
		else {
			int cnt = -INF, num = -INF;
			for (int j = 1; j < MAXN; ++j) {
				if (dp[id][j] <= b && j >= cnt) {
					cnt = j;
					num = dp[id][j];
				}
			}
			if (dp1[id - 1].y >= cnt) {
				cnt = dp1[id - 1].y;
				num = dp1[id - 1].x;
			}

			cout << num << " " << cnt << endl;
		}
	}
}