#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

#define int long long 
#define endl "\n"
#define double long double 
#define pii pair<int, int>
#define vec vector
#define pb push_back
#define $(x) (int)((x).size())
#define dbg(x) cout << #x << " = " << (x) << endl;
#define x first
#define y second

using namespace std;

void solve(); signed main() {
	// freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(6);
	solve();
	return 0;
}

const int MAXN = 1000 + 10, INF = 1e18;

void solve() {
	int n;
	cin >> n;
	vec<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}		

	if (n == 1) {
		int q;
		cin >> q;
		for (int i = 0; i < q; ++i) {
			int b;
			cin >> b;
			cout << b << " " << b << endl;
		}
		return;
	}
	a.pb(1e18);

	vec<pii> dp1(n);
	dp1[0] = {a[1] - 1, a[1] - 1};
	for (int i = 1; i < n; ++i) {
		auto p = dp1[i - 1];
		int num = p.x, cnt = p.y;
		int k = (a[i + 1] - num) / a[i];
		dp1[i] = {num + k * a[i], cnt + k};
	}

	vec<vec<int>> dp(n, vec<int>(MAXN, INF));
	for (int i = 1; i < MAXN; ++i) {
		dp[0][i] = i;
	}
	for (int i = 0; i < n; ++i) {
		dp[i][0] = 0;
	}
	for (int i = 1; i < n; ++i) {
		for (int cnt1 = 0; cnt1 < MAXN; ++cnt1) {
			for (int cnt2 = cnt1 + 1; cnt2 < MAXN; ++cnt2) {
				int num = dp[i - 1][cnt1];
				int k = (a[i + 1] - num) / a[i];
				if (cnt1 + k == cnt2) {
					dp[i][cnt2] = min(dp[i][cnt2], dp[i - 1][cnt2] + k * a[i]);
				}
			}
		}
	}

	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int b;
		cin >> b;
		int id = upper_bound(a.begin(), a.end(), b) - a.begin();
		id--;
		if (id == 0) {
			cout << b << " " << b << endl;
		}
		else {
			int cnt = -INF, num = -INF;
			for (int j = 1; j < MAXN; ++j) {
				if (dp[id][j] <= b && j >= cnt) {
					cnt = j;
					num = dp[id][j];
				}
			}	
			
			if (dp1[id].x <= b && dp1[id].y >= cnt) {
				cnt = dp1[id].y;
				num = dp1[id].x;
			}

			cout << num << " " << cnt << endl;
		}
	}
}