#define _USE_MATH_DEFINES

#include <bits/stdc++.h>

#define int long long 
#define endl "\n"
#define double long double 
#define pii pair<int, int>
#define vec vector
#define pb push_back
#define $(x) (int)((x).size())
#define dbg(x) cout << #x << " = " << (x) << endl;

using namespace std;

void solve(); signed main() {
	freopen("input.txt", "r", stdin);
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cout.setf(ios::fixed); cout.precision(6);
	solve();
	return 0;
}

const int MAXN = 2e5 + 10, INF = 1e18;
int n;
vec<int> a;

void query() {
	vec<vec<int>> dp(n * 2, vec<int>(4, -INF));
	vec<int> b;
	for (int i = 0; i < n; ++i) {
		b.pb(a[i]);
	}
	for (int i = 0; i < n; ++i) {
		b.pb(a[i]);
	}

	int ans = -INF;
	dp[n][0] = 0;
	for (int i = n + 1; i < $(b); ++i) {
		dp[i][0] = max({dp[i - 1][0], dp[i - 1][1], dp[i - 1][2], dp[i - 1][3]});
		dp[i][1] = max({dp[i - 2][0], dp[i - 2][1], dp[i - 2][2], dp[i - 2][3]}) + b[i];
		dp[i][1] = max(dp[i][1], dp[i - 1][0] + b[i]);
		dp[i][2] = max({dp[i - 3][0], dp[i - 3][1], dp[i - 3][2], dp[i - 3][3]}) + b[i] + b[i - 1];
		dp[i][2] = max(dp[i][2], dp[i - 1][1] + b[i]);
		dp[i][3] = max({dp[i - 4][0], dp[i - 4][1], dp[i - 4][2], dp[i - 4][3]}) + b[i] + b[i - 1] + b[i - 2];
		dp[i][3] = max(dp[i][3], dp[i - 1][2] + b[i]);
	}
	ans = max({ans, dp[2 * n - 1][0], dp[2 * n - 1][1], dp[2 * n - 1][2], dp[2 * n - 1][3]});
	for (int i = 0; i < $(b); ++i) {
		for (int k = 0; k <= 3; ++k) {
			dp[i][k] = -INF;
		}
	}
	dp[n][1] = b[n];
	for (int i = n + 1; i < $(b); ++i) {
		dp[i][0] = max({dp[i - 1][0], dp[i - 1][1], dp[i - 1][2], dp[i - 1][3]});
		dp[i][1] = max({dp[i - 2][0], dp[i - 2][1], dp[i - 2][2], dp[i - 2][3]}) + b[i];
		dp[i][1] = max(dp[i][1], dp[i - 1][0] + b[i]);
		dp[i][2] = max({dp[i - 3][0], dp[i - 3][1], dp[i - 3][2], dp[i - 3][3]}) + b[i] + b[i - 1];
		dp[i][2] = max(dp[i][2], dp[i - 1][1] + b[i]);
		dp[i][3] = max({dp[i - 4][0], dp[i - 4][1], dp[i - 4][2], dp[i - 4][3]}) + b[i] + b[i - 1] + b[i - 2];
		dp[i][3] = max(dp[i][3], dp[i - 1][2] + b[i]);
	}
	ans = max({ans, dp[2 * n - 1][0], dp[2 * n - 1][1], dp[2 * n - 1][2]});
	for (int i = 0; i < $(b); ++i) {
		for (int k = 0; k <= 3; ++k) {
			dp[i][k] = -INF;
		}
	}

	dp[n][2] = b[n] + b[n - 1];
	for (int i = n + 1; i < $(b); ++i) {
		dp[i][0] = max({dp[i - 1][0], dp[i - 1][1], dp[i - 1][2], dp[i - 1][3]});
		dp[i][1] = max({dp[i - 2][0], dp[i - 2][1], dp[i - 2][2], dp[i - 2][3]}) + b[i];
		dp[i][1] = max(dp[i][1], dp[i - 1][0] + b[i]);
		dp[i][2] = max({dp[i - 3][0], dp[i - 3][1], dp[i - 3][2], dp[i - 3][3]}) + b[i] + b[i - 1];
		dp[i][2] = max(dp[i][2], dp[i - 1][1] + b[i]);
		dp[i][3] = max({dp[i - 4][0], dp[i - 4][1], dp[i - 4][2], dp[i - 4][3]}) + b[i] + b[i - 1] + b[i - 2];
		dp[i][3] = max(dp[i][3], dp[i - 1][2] + b[i]);
	}
	ans = max({ans, dp[2 * n - 2][0], dp[2 * n - 2][1]});
	for (int i = 0; i < $(b); ++i) {
		for (int k = 0; k <= 3; ++k) {
			dp[i][k] = -INF;
		}
	}
	dp[n][3] = b[n] + b[n - 1] + b[n - 2];
	for (int i = n + 1; i < $(b); ++i) {
		dp[i][0] = max({dp[i - 1][0], dp[i - 1][1], dp[i - 1][2], dp[i - 1][3]});
		dp[i][1] = max({dp[i - 2][0], dp[i - 2][1], dp[i - 2][2], dp[i - 2][3]}) + b[i];
		dp[i][1] = max(dp[i][1], dp[i - 1][0] + b[i]);
		dp[i][2] = max({dp[i - 3][0], dp[i - 3][1], dp[i - 3][2], dp[i - 3][3]}) + b[i] + b[i - 1];
		dp[i][2] = max(dp[i][2], dp[i - 1][1] + b[i]);
		dp[i][3] = max({dp[i - 4][0], dp[i - 4][1], dp[i - 4][2], dp[i - 4][3]}) + b[i] + b[i - 1] + b[i - 2];
		dp[i][3] = max(dp[i][3], dp[i - 1][2] + b[i]);
	}
	ans = max({ans, dp[2 * n - 3][0]});

	// dbg(dp[2 * n - 3][0])

	for (int i = 0; i < $(b); ++i) {
		for (int k = 0; k <= 3; ++k) {
			dp[i][k] = -INF;
		}
	}
	cout << ans << endl;
}

void solve() {
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}

	int q;
	cin >> q;
	query();
	for (int _ = 0; _ < q; ++_) {
		int p, v;
		cin >> p >> v;
		p--;
		a[p] = v;
		query();
	}
}