#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <map>

using namespace std;

long long a[200005];
long long d[200005];
long long c[200005];

int main() {
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	sort(a, a + n);
	d[0] = 0;
	c[0] = 0;
	for (int i = 1; i < n; ++i) {
		long long x = max((long long)0, (a[i] - d[i - 1] - 1) / a[i - 1]);
		d[i] = d[i - 1] + x * a[i - 1];
		c[i] = c[i - 1] + x;
	}
	int q;
	cin >> q;
	for (int j = 0; j < q; ++j) {
		long long b = 0;
		cin >> b;
		int i = upper_bound(d, d + n, b) - d - 1;
		long long nxt;
		if (i == n - 1)
			nxt = b;
		else
			nxt = min(b, a[i + 1] - 1);
		long long x = max((long long)0, (nxt - d[i]) / a[i]);
		cout << d[i] + x * a[i] << ' ' << c[i] + x << '\n';
	}
	return 0;
}
