#include <iostream>
#include <algorithm>
#include <map>
#include <vector>

using namespace std;

void Compress(vector<int> &a)
{
    map<int, int> mMap;
    int iCurNew = 1;
    for (int i = 0; i < a.size(); i++)
    {
        if (mMap[a[i]] >= 1)
        {
            a[i] = mMap[a[i]] - 1;
        }
        else
        {
            mMap[a[i]] = iCurNew;
            a[i] = iCurNew - 1;
            iCurNew++;
        }
    }
}

void Print(const vector<int> &a)
{
    for (int i = 0; i < a.size(); i++)
    {
        cout << a[i] << " ";
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
        //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    Compress(a);
    vector<int> c(n);
    for (int k = 1; k <= n; k++)
    {
        long long s = 0;
        int cnt = 0;
        for (int i = 0; i < n; i++)
        {
            c[i] = 0;
        }
        for (int i = 0; i < k - 1; i++)
        {
            if (c[a[i]] == 0)
            {
                cnt++;
            }
            c[a[i]]++;
        }
        for (int i = k - 1; i < n; i++)
        {
            if (c[a[i]] == 0)
            {
                cnt++;
            }
            c[a[i]]++;
            s += cnt;
            c[a[i - k + 1]]--;
            if (c[a[i - k + 1]] == 0)
            {
                cnt--;
            }
        }
        cout << s << " ";
    }
}
