import java.io.PrintWriter;
import java.util.Scanner;

public class Main {
    PrintWriter out;
    Scanner sc;

    public static void main(String [] arg) {
        new Main().run();
    }

    public void run() {
        sc = new Scanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();

    }

    public void solve() {
        long n = nextLong();
        if (n % 2 == 0 && n % 4 != 0) {
            out.println("No");
            return;
        }
        if (n == 4 || n == 1) {
            out.println("No");
            return;
        }
        if (n == 0) {
            out.println("Yes");
            out.println("1 1");
            return;
        }
        if (n % 2 == 0) {
            long k = n / 4;
            out.println("Yes");
            out.println((k + 1) + " " + (k - 1));
            return;
        }
        out.println("Yes");
        out.println((1 + n) / 2 + " " + (n - 1) / 2);
    }

    public int nextInt() {
        return sc.nextInt();
    }

    public long nextLong() {
        return  sc.nextLong();
    }

    public String nextToken() {
        return sc.next();
    }
}
