import java.io.PrintWriter;
import java.util.Scanner;
//3
//10 20 30
//400 500 600
//6
//1 5 10 12 16
//100 300 600 800 1000 1500
//3
//10 100
//20 70
//45 100
public class Main {
    PrintWriter out;
    Scanner sc;

    public static void main(String [] arg) {
        new Main().run();
    }

    public void run() {
        sc = new Scanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();

    }

    public void solve() {
        int n = nextInt();
        int [] arrV = new int[n];
        int [] arrL = new int[n];
        for (int i = 0; i < n; i++) {
            arrV[i] = nextInt();
        }
        for (int i = 0; i < n; i++) {
            arrL[i] = nextInt();
        }
        int m = nextInt();
        int [] arrStr = new int[m];
        int [] arrMon = new int[m + 1];
        arrStr[0] = 0;
        for (int i = 1; i < m; i++) {
            arrStr[i] = nextInt();
        }
        arrMon[0] = 0;
        for (int i = 1; i < m + 1; i++) {
            arrMon[i] = nextInt();
        }
        int q = nextInt();
        int [] time = new int[q];
        for (int i = 0; i < q; i++) {
            int a = nextInt();
            int b = nextInt();
            time[i] = b - a;
        }

        double [] ans = new double[m + 1];
        double [] temp = new double[n];
        double [] canRide = new double[n];
        for (int i = 0; i < n; i++) {
            temp[i] = (double) arrL[i] / arrV[i];
        }

        for (int i = 0; i < n; i++) {
            canRide[i] = (double) arrL[i] / arrV[i];
        }

        for (int i = 0; i < m; i++) {
            double t = 0;
            for (int j = 0; j < n; j++) {
                temp[j] = canRide[j] * arrV[j] / (arrV[j] + arrStr[i]);
                t += temp[j];
            }
            ans[i] = t;
        }
        ans[ans.length - 1] = 0;

//        for (int i = 0; i < m + 1; i++) {
//            System.out.print(ans[i] + " ");
//        }


        for (int i = 0; i < q; i++) {
            int x = time[i];
            if (x >= ans[0]) {
                out.println(0);
                continue;
            }
            int l = 0;
            int r = ans.length;
            while (l != r - 1) {
                int s = (l + r) / 2;
                if (ans[s] > x) {
                    l = s;
                } else {
                    r = s;
                }
            }
            out.println(arrMon[r]);
        }
    }

    public int nextInt() {
        return sc.nextInt();
    }

    public long nextLong() {
        return  sc.nextLong();
    }

    public String nextToken() {
        return sc.next();
    }
}
