import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

public class Main {
    PrintWriter out;
    Scanner sc;

    public static void main(String [] arg) {
        new Main().run();
    }

    public void run() {
        sc = new Scanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();

    }

    public void solve() {
        int n = nextInt();
        long [] arr = new long[n];
        for (int i = 0; i < n; i++) {
            arr[i] = nextLong();
        }
        int q = nextInt();
        for (int i = 0; i < q; i++) {
            long b = nextLong();
            long count = 0;
            long sum = 0;
            long addS = 0;
            long addC = 0;
            if (b >= arr[n - 1] * 2) {
                b -= arr[n - 1] * (b / arr[n - 1] - 1);
                addC = (b / arr[n - 1] - 1);
                addS = arr[n - 1] * (b / arr[n - 1] - 1);

            }
            int j = 0;
            while (sum < b && j < n - 1) {
                if ((arr[j + 1] - 1 - sum) / arr[j] * arr[j] + sum >= b) {
                    count += (b - sum) / arr[j];
                    sum += (b - sum) / arr[j] * arr[j];
                    break;
                }
                count += (arr[j + 1] - 1 - sum) / arr[j];
                sum += (arr[j + 1] - 1 - sum) / arr[j] * arr[j];
                j++;
            }
            out.println(sum + " " + count);
        }
    }

    public int nextInt() {
        return sc.nextInt();
    }

    public long nextLong() {
        return  sc.nextLong();
    }

    public String nextToken() {
        return sc.next();
    }
}


