import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Random;
import java.util.Scanner;

public class Main {
    PrintWriter out;
    Scanner sc;

    public static void main(String [] arg) {
        new Main().run();
    }

    public void run() {
        sc = new Scanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();

    }

    public int f(int a) {
        if (a == n) {
            used[n] = used[0];
            used[n + 1] = used[1];
            used[n + 2] = used[2];
            for (int i = 0; i < n; i++) {
                if (used[i] && used[i + 1] && used[i + 2] && used[i + 3]) {
                    return 0;
                }
            }
            int count = 0;
            for (int i = 0; i < n; i++) {
                if (used[i]) {
                    count += arr[i];
                }
            }
            return count;
        }
        int x = f(a + 1);
        used[a] = true;
        int y = f(a + 1);
        used[a] = false;
        return Math.max(x, y);
    }

    int n;
    int [] arr;
    boolean [] used;
    public void solve() {
        n = nextInt();
        arr = new int[n];
        used = new boolean[n + 3];

        for (int i = 0; i < n; i++) {
            arr[i] = nextInt();
        }

        Random rnd = new Random(228);
        if (n > 20) {
            int ans = 0;
            for (int _ = 0; _ < 1000; _++) {
                for (int i = 0; i < n; i++) {
                    if (i > 3) {
                        if (used[i - 1] && used[i - 2] && used[i - 3]) {
                            used[i] = false;
                        } else {
                            used[i] = rnd.nextBoolean();
                        }
                    } else {
                        used[i] = rnd.nextBoolean();
                    }
                }
                used[n] = used[0];
                used[n + 1] = used[1];
                used[n + 2] = used[2];
                for (int i = 0; i < n; i++) {
                    if (used[i] && used[i + 1] && used[i + 2] && used[i + 3]) {
                        Arrays.fill(used, false);
                        continue;
                    }
                }
                int count = 0;
                for (int i = 0; i < n; i++) {
                    if (used[i]) {
                        count += arr[i];
                    }
                }
                ans = Math.max(ans, count);
                Arrays.fill(used, false);
            }
            out.println(ans);
            return;
        }
        out.println(f(0));
        int q = nextInt();
        for (int i = 0; i < q; i++) {
            int a = nextInt();
            int b = nextInt();
            arr[a - 1] = b;
            out.println(f(0));
        }


    }

    public int nextInt() {
        return sc.nextInt();
    }

    public long nextLong() {
        return  sc.nextLong();
    }

    public String nextToken() {
        return sc.next();
    }
}



