#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long double UNO = 1.0;
const long double EPS = 1e-6;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector <int> v(n), len(n);
	for (auto& u : v)
		cin >> u;
	for (auto& u : len)
		cin >> u;
	int m;
	cin >> m;
	vector <int> a(m - 1), f(m);
	for (int i = 0; i < m - 1; i++) {
		cin >> a[i];
	}
	if (a.empty())
		a.emplace_back(0);
	for (int i = 0; i < m; i++) {
		cin >> f[i];
	}
	long double good_t = 0, bad_t = 0;
	for (int i = 0; i < n; i++) {
		good_t += UNO * len[i] / v[i];
		bad_t += UNO * len[i] / (v[i] + a.back());
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int s, t;
		cin >> s >> t;
		int way = t - s;
		if (way + EPS > good_t) {
			cout << 0 << '\n';
			continue;
		}
		if (way - EPS < bad_t) {
			cout << f.back() << '\n';
			continue;
		}
		int L = -1, R = m - 1;
		while (L + 1 < R) {
			int M = (L + R) / 2;
			long double cur_t = 0;
			for (int i = 0; i < n; i++) {
				cur_t += UNO * len[i] / (v[i] + a[M]);
			}
			if (cur_t > way - EPS)
				L = M;
			else
				R = M;
		}
		cout << f[R] << '\n';
	}
}

/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500

*/