#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <ctime>

using namespace std;

//#define __int128 int64_t

const __int128 UNO = 1;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector <int> a(n);
	for (auto& u : a)
		cin >> u;
	vector <long long> pref_sum(n);
	pref_sum[0] = a[0];
	vector <long long> suf_sum(n);
	suf_sum.back() = a.back();
	for (int i = 1; i < n; i++) {
		pref_sum[i] = a[i] + pref_sum[i - 1];
		suf_sum[n - i - 1] = a[n - i - 1] + suf_sum[n - i];
	}
	__int128 ans = 0, pos = 0;
	for (int i = 0; i < n - 1; i++) {
		if (ans < UNO * pref_sum[i] * suf_sum[i + 1]) {
			pos = i;
			ans = UNO * pref_sum[i] * suf_sum[i + 1];
		}
	}
	cout << pos + 1;
}