#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, x;
	cin >> n >> x;
	vector <vector <int>> divisors(n * n + 1);
	vector <char> need(n * n + 1, 0);
	for (int a = 1; a <= n; a++) {
		for (int b = a; b <= n; b++) {
			if (a * b > n)
				need[a * b - n] = 1;
		}
	}
	for (int i = 1; i <= n; i++) {
		for (int j = i; j <= n * n; j += i) {
			if (need[j])
				divisors[j].emplace_back(i);
		}
	}
	int ans = 0;
	for (int a = 1; a <= n; a++) {
		if (a == x)
			continue;
		for (int b = n / a; b <= n; b++) {
			if (b == x)
				continue;
			int val = a * b - n;
			if (val < 0)
				continue;
			for (auto u : divisors[val]) {
				if (a > u && b > val / u)
					ans++;
			}
		}
	}
	cout << ans;
}