#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <cmath>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector <long long> a(n);
    for (auto& u : a)
        cin >> u;
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        long long b;
        long long ans = 0, pos = 0;
        cin >> b;
        for (int j = 1; j <= b; j++) {
            int tmp = j;
            long long cur_ans = 0;
            while (tmp > 0) {
                int ind = upper_bound(a.begin(), a.end(), tmp) - a.begin() - 1;
                cur_ans += tmp / a[ind];
                tmp %= a[ind];
            }
            if (ans < cur_ans) {
                pos = j;
                ans = cur_ans;
            }
        }
        cout << pos << ' ' << ans << '\n';
    }
}

/*
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <cmath>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector <int> a(n), all;
    for (auto& u : a) {
        cin >> u;
        all.emplace_back(u);
    }
    sort(all.begin(), all.end());
    all.resize(unique(all.begin(), all.end()) - all.begin());
    for (auto& u : a)
        u = lower_bound(all.begin(), all.end(), u) - all.begin();
    vector <long long> ans(n);
    vector <int> cnt(all.size(), 0);
    int cur_cnt = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i; j < n; j++) {
            if (!cnt[a[j]]) {
                cnt[a[j]] = 1;
                cur_cnt++;
            }
            ans[j - i] += cur_cnt;
        }
        cnt.resize(0);
        cnt.resize(all.size(), 0);
        cur_cnt = 0;
    }
    for (auto& u : ans)
        cout << u << ' ';
}
*/