#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;

using namespace std;

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int64 n;
	cin >> n;
	for (int64 i = 1; i * i <= n; i++) {
		if (n % i != 0) {
			continue;
		}
		int64 x = i;
		int64 y = n / i;
		if (y < x) {
			swap(x, y);
		}
		int64 del = y - x;
		if (del % 2 != 0) {
			continue;
		}
		cout << "YES\n";
		cout << x + del / 2 << ' ' << del / 2 << '\n';
		return 0;
	}
	cout << "NO\n";
}