#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;

using namespace std;

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int64 n;
	cin >> n;
	int64 cnt = 0;
	int64 m = n;
	while (m % 2 == 0) {
		m /= 2;
		cnt++;
	}
	if (cnt > 1) {
		int64 del = n / 2 - 2;
		if (del % 2 == 0) {
			int64 y = del / 2;
			int64 x = 2 + y;
			if (min(x, y) > 0) {
				cout << "YES\n";
				cout << x << ' ' << y;
				return 0;
			}
		}
	}
	for (int64 i = 1; i * i <= n; i += 2) {
		if (n % i == 0 && ((n / i) & 1)) {
			int64 a = i, b = n / i;
			int64 delta = b - a;
			int64 y = delta / 2;
			int64 x = y + a;
			if (y > 0) {
				cout << "YES\n";
				cout << x << ' ' << y << '\n';
				return 0;
			}
		}
	}
	cout << "NO\n";
}