#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;

using namespace std;

void Compress(vector <int64>& a) {
	vector <int64> b = a;
	sort(b.begin(), b.end());
	for (auto& i : a) {
		i = (int)(lower_bound(b.begin(), b.end(), i) - b.begin());
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector <int64> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	Compress(a);
	vector <int64> res(n, 0);
	for (int d = 1; d <= n; d++) {
		vector <int> cntleft(n, 0);
		vector <int> cntright(n, 0);
		for (int i = 0; i < d - 1; i++) {
			cntright[a[i]]++;
		}
		for (int R = d - 1; R < n; R++) {
			int L = R - d + 1;
			cntright[a[R]]++;
			for (int j = 0; j < n; j++) {
				if (cntright[j] - cntleft[j] > 0) {
					res[d - 1]++;
				}
			}
			cntleft[a[L]]++;
		}
	}
	for (auto i : res) {
		cout << i << ' ';
	}
	cout << '\n';
}
/*
5
1 3 2 1 2

3
10 10 10
*/
