#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;

using namespace std;

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int q;
	cin >> q;
	vector <int64> E(q);
	for (int i = 0; i < q; i++) {
		cin >> E[i];
	}
	if (*max_element(E.begin(), E.end()) * n <= 7'000'000 && *max_element(E.begin(), E.end()) <= 4'000'00) {
		int m = *max_element(E.begin(), E.end());
		vector <int64> dp(m + 1, 0);
		dp[1] = 1;
		for (int i = 2; i <= m; i++) {
			int j = (int)(upper_bound(a.begin(), a.end(), i) - a.begin());
			j--;
			dp[i] = 1 + dp[i - a[j]];
		}
		for (auto i : E) {
			int64 res = *max_element(dp.begin(), dp.begin() + i + 1);
			int pos = 0;
			while (dp[pos] != res) {
				pos++;
			}
			cout << pos << ' ' << res << '\n';
		}
		return 0;
	}
}
/*
4
1 5 10 50
3
2
8
50
*/