#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <iomanip>

typedef long long int64;
typedef long double ld;

using namespace std;

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	vector <int64> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int q;
	cin >> q;
	vector <int64> E(q);
	for (int i = 0; i < q; i++) {
		cin >> E[i];
	}
	vector <int64> dp(n);
	dp[0] = 0;
	for (int i = 1; i < n; i++) {
		dp[i] = 0;
		int64 cur = a[i] - 1;
		while (cur != 0) {
			int j = (int)(lower_bound(a.begin(), a.end(), cur) - a.begin());
			j--;
			dp[i] += cur / a[j];
			cur %= a[j];
		}
	}
	for (auto q : E) {
		int i = (int)(upper_bound(a.begin(), a.end(), q) - a.begin());
		i--;
		if (i == 0) {
			cout << q << ' ' << q << '\n';
		} else {
			cout << a[i] - 1 << ' ' << dp[i] << '\n';
		}
	}
}
/*
4
1 5 10 50
3
2
8
50
*/