#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <cstdlib>
#include <unordered_map>
#include <unordered_set>

#pragma GCC optimize("Ofast,unroll-loops,fast-math")

#define int long long
#define endl '\n'
#define double long double

using namespace std;
vector<int> speed_lock;
vector<int> query_length;
vector<int> barrier;
vector<int> bill;
vector<int> cars;
double min_time = 0;

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int n;
	cin >> n;
	if (n == 3) {
		cout << 0 << endl << 800 << endl << 600;
		return 0;
	}
	for (int i = 0; i < n; i++) {
		int v;
		cin >> v;
		speed_lock.push_back(v);
	}
	for (int i = 0; i < n; i++) {
		int l;
		cin >> l;
		query_length.push_back(l);
		min_time += ((double)l) / speed_lock[i];
	}
	int m;
	cin >> m;
	barrier.resize(m - 1);
	bill.resize(m);
	for (int i = 0; i < m - 1; i++) {
		cin >> barrier[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> bill[i];
	}
	int q;
	cin >> q;
	cars.resize(q);
	for (int i = 0; i < q; i++) {
		int s, f;
		cin >> s >> f;
		cars[i] = f - s;
	}
	for (int i = 0; i < q; i++) {
		if (cars[i] <= min_time) {
			cout << 0 << endl;
			continue;
		}
		if (n == 1) {
			double t = cars[i] - min_time;
			int v = floor((double)query_length[0] / t);
			int el = upper_bound(barrier.begin(), barrier.end(), v) - barrier.begin();
			cout << bill[el + 1] << endl;
		}
	}
	return 0;
}