#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define int long long
#define double long double
#define endl '\n'

#pragma GCC optimize("Ofast,fast-math,unroll-loops")

vector<int> arr;
int b[200005];

int calc_dels(int n, int a, int b) {
	int ans = 0;
	for (int i = 1; i * i <= n; i++) {
		int ln = n / i;
		if (n % i == 0) {
			if (i < a && ln < b)
				ans++;
			if (i < b && ln < a && ln != i)
				ans++;
		}
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int n, x;
	cin >> n >> x;
	int ans = 0;
	for (int a = 2; a < 700; a++) {
		if (a == x)
			continue;
		for (int b = a; b < 700; b++) {
			if (b == x)
				continue;
			if (a * b <= n)
				continue;
			if (a != b)
				ans += calc_dels(a * b - n, a, b) * 2;//  + calc_dels(a * b - n, b, a);
			else
				ans += calc_dels(a * b - n, a, b);
		}
	}
	cout << ans;
	return 0;
}