#include <iostream>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <map>
//#define long long long long

using namespace std;
using namespace __gnu_pbds;

long long tn;
vector<long long> t;


long long sum(long long r)
{
    long long result = 0;
    for (; r > -1; r = (r & (r + 1)) - 1) result += t[r];
    return result;
}


void inc(long long idx, long long d)
{
    for (long long i = idx; i < tn; i = (i | (i + 1))) t[i] += d;
}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    long long n;
    cin >> n;
    tn = n;
    t.resize(tn);
    vector<long long> a(n);
    for (long long i(0); i < n; ++i) cin >> a[i];
    if (n == 1LL)
    {
        cout << 1 << endl;
        return 0;
    }
    map<long long, long long> c;
    for (long long i(0); i < n; ++i)
    {
        if (c[a[i]] == 0) c[a[i]] = i + 1;
        a[i] = c[a[i]];
    }
    vector<long long> is_was(n, -1);
    vector<long long> closest_next(n, n);
    for (long long i(0); i < n; ++i)
    {
        if (is_was[a[i]] != -1) closest_next[is_was[a[i]]] = i;
        is_was[a[i]] = i;
    }
    for (long long i(0); i < n; ++i) inc(closest_next[i] - i - 1, 1);
    vector<long long> v(n);
    long long all_sum = sum(n - 1);
    v[0] = all_sum;
    for (long long i(1); i < n; ++i) v[i] = all_sum - sum(i - 1);
    vector<long long> k(n);
    k[0] = 1;
    is_was.assign(n, -1);
    is_was[a[0]] = 0;
    for (long long i(1); i < n; ++i)
    {
        if (is_was[a[i]]!= -1) k[i] = k[i - 1];
        else k[i] = k[i - 1] + 1;
        is_was[a[i]] = i;
    }
    vector<long long> result(n);
    result[0] = n;
    for (long long i(1); i < n; ++i) result[i] = result[i - 1] - k[i - 1] + v[i];
    for (long long i: result) cout << i << ' ';
    cout << endl;
    return 0;
}
