#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;


struct bmlp
{
    int a, b, p;
};


bool operator < (bmlp x, bmlp y)
{
    int f, t;
    if (x.p == 2) f = min(x.a, x.b);
    else f = max(x.a, x.b);
    if (y.p == 2) t = min(y.a, y.b);
    else t = max(y.a, y.b);
    return f < t;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, s;
    cin >> n >> m >> s;
    if (n == 1)
    {
        vector<int> a(m);
        for (int i(0); i < m; ++i) cin >> a[i];
        sort(a.begin(), a.end());
        cout << a[s - 1] << endl;
        return 0;
    }
    vector<bmlp> a(m);
    for (int i(0); i < m; ++i) cin >> a[i].a >> a[i].b >> a[i].p;
    for (int i(0); i < m; ++i) cin >> a[i].a >> a[i].b;
    sort(a.begin(), a.end());
    int minf = 0;
    int mint = 0;
    int c = 0;
    for (bmlp i: a)
    {
        if (i.p == 1)
        {
            minf = max(minf, i.a);
            mint = max(mint, i.b);
        }
        else
        {
            if (i.a < i.b) minf = max(minf, i.a);
            else mint = max(mint, i.b);
        }
        c++;
        if (c == s) break;
    }
    cout << minf << ' ' << mint << endl;
    return 0;
}
