#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long

using namespace std;
using namespace __gnu_pbds;

gp_hash_table<int, int> dp;
gp_hash_table<int, int> sum;
set<int> s;


pair<int, int> dp_rec(int n)
{
    if (dp[n] != 0) return {dp[n], sum[n]};
    int k = *(s.lower_bound(-n));
    k *= -1;
    if (n % k == 0)
    {
        if (n == 1) return {1, 1};
        pair<int, int> v = {dp[k], sum[k]};
        if (v.first > n / k)
        {
            dp[n] = v.first;
            sum[n] = v.second;
        }
        else
        {
            dp[n] = n / k;
            sum[n] = n;
        }
        return {dp[n], sum[n]};
    }
    pair<int, int> v = dp_rec(n % k);
    if (n / k - 1 + dp[k] > n / k + v.first)
    {
        dp[n] = n / k - 1 + dp[k];
        sum[n] = (n / k - 1) * k + sum[k];
    }
    else
    {
        dp[n] = n / k + v.first;
        sum[n] = n / k * k + v.second;
    }
    return {dp[n], sum[n]};
}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    sum[1] = 1;
    int c;
    for (int i(0); i < n; ++i)
    {
        cin >> c;
        s.insert(-c);
    }
    for (int i: s) dp_rec(-i);
    int q;
    cin >> q;
    for (int i(0); i < q; ++i)
    {
        int b;
        cin >> b;
        pair<int, int> v = dp_rec(b);
        cout << v.second << ' ' << v.first << endl;
    }
    return 0;
}
