#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#define int long long

using namespace std;
using namespace __gnu_pbds;

gp_hash_table<int, int> dp;
gp_hash_table<int, int> sum;
set<int> s;


pair<int, int> dp_rec(int n)
{
    //if (dp[n] != 0) return {dp[n], sum[n]};
    int k = *(s.lower_bound(-n));
    k *= -1;
    if (n == k && dp[n] != 0) return {dp[n], sum[n]};
    int f, t;
    if (n % k == 0)
    {
        if (n == 1) return {1, 1};
        if (n == k)
        {
            f = dp_rec(n - 1).first;
            t = dp_rec(n - 1).second;
            dp[n] = f;
            sum[n] = t;
            return {f, t};
        }
        pair<int, int> v = {n / k - 1 + dp[k], n - k + sum[k]};
        if (v.first > n / k)
        {
            f = v.first;
            t = v.second;
        }
        else
        {
            f = n / k;
            t = n;
        }
        return {f, t};
    }
    pair<int, int> v = dp_rec(n % k);
    if (n / k - 1 + dp[k] > n / k + v.first)
    {
        f = n / k - 1 + dp[k];
        t = (n / k - 1) * k + sum[k];
    }
    else
    {
        f = n / k + v.first;
        t = n / k * k + v.second;
    }
    return {f, t};
}


int32_t main()
{
    //ifstream inp("input.txt");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    dp[1] = 1;
    sum[1] = 1;
    int c;
    set<int> tc;
    for (int i(0); i < n; ++i)
    {
        cin >> c;
        s.insert(-c);
        tc.insert(c);
    }
    for (int i: tc) dp_rec(i);
    int q;
    cin >> q;
    for (int i(0); i < q; ++i)
    {
        int b;
        cin >> b;
        pair<int, int> v = dp_rec(b);
        cout << v.second << ' ' << v.first << endl;
    }
    return 0;
}
