#include <iostream>
#include <vector>
#define int long long

using namespace std;


int count_dp(vector<int> & color, int n)
{
    vector<int> dp(n);
    for (int i(1); i < n; ++i)
    {
        dp[i] = dp[i - 1];
        if (i == 1) dp[i] = color[i];
        if (i == 2) dp[i] = color[i - 1] + color[i];
        if (i == 3) dp[i] = color[i - 2] + color[i - 1] + color[i];
        if (i > 1) dp[i] = max(dp[i], dp[i - 2] + color[i]);
        if (i > 2) dp[i] = max(dp[i], dp[i - 3] + color[i - 1] + color[i]);
        if (i > 3) dp[i] = max(dp[i], dp[i - 4] + color[i - 2] + color[i - 1] + color[i]);
    }
    return dp[n - 1];
}


int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> color(n);
    for (int i(0); i < n; ++i) cin >> color[i];
    vector<int> cf, cs, ct, cc;
    cf = color;
    for (int i(1); i < n; ++i) cs.push_back(color[i]);
    cs.push_back(color[0]);
    for (int i(2); i < n; ++i) ct.push_back(color[i]);
    ct.push_back(color[0]);
    ct.push_back(color[1]);
    for (int i(3); i < n; ++i) cc.push_back(color[i]);
    cc.push_back(color[0]);
    cc.push_back(color[1]);
    cc.push_back(color[2]);
    int result = 0;
    result = max(count_dp(cf, n), max(count_dp(cs, n), max(count_dp(ct, n), count_dp(cc, n))));
    cout << result << endl;
    int q;
    cin >> q;
    for (int i(0); i < q; ++i)
    {
        int f, t;
        cin >> f >> t;
        f--;
        color[f] = t;
        cf.clear();
        cs.clear();
        ct.clear();
        cc.clear();
        cf = color;
        for (int i(1); i < n; ++i) cs.push_back(color[i]);
        cs.push_back(color[0]);
        for (int i(2); i < n; ++i) ct.push_back(color[i]);
        ct.push_back(color[0]);
        ct.push_back(color[1]);
        for (int i(3); i < n; ++i) cc.push_back(color[i]);
        cc.push_back(color[0]);
        cc.push_back(color[1]);
        cc.push_back(color[2]);
        result = max(count_dp(cf, n), max(count_dp(cs, n), max(count_dp(ct, n), count_dp(cc, n))));
        cout << result << endl;
    }
    return 0;
}
