#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
typedef long long ll;
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n, m, q, s, t;
    cin >> n;
    vector<int> limit(n);
    vector<int> road(n);
    for (int i = 0; i < n; i++)
        cin >> limit [i];
    for (int i = 0; i < n; i++)
        cin >> road[i];
    cin >> m;
    vector<int> bill_limit(m - 1);
    vector<int> bill(m);
    for (int i = 0; i < m - 1; i++)
        cin >> bill_limit[i];
    for (int i = 0; i < m; i++)
        cin >> bill[i];
    cin >> q;
    double min_time = 0;
    for (int i = 0; i < n; i++)
        min_time += road[i] / limit[i];
    for (int k = 0; k < q; k++)
    {
        cin >> s >> t;
        if (t - s >= min_time)
            cout << 0 << '\n';
        else
        {
            ll l, r;
            if (bill_limit.size() - 1ll >= 0ll)
            {
                l = 0;
                r = bill_limit[bill_limit.size() - 1] + 1ll;
            }
            else
            {
                cout << bill[0] << '\n';
                continue;
            }
            while (l < r - 1)
            {
                ll mid = (l + r) / 2;
                double res = 0;
                for (int i = 0; i < n; i++)
                    res += road[i] / (limit[i] + mid);
                if (res >= t - s || res == 0)
                    l = mid;
                else
                    r = mid;
            }
            ll diff = r;
            l = -1, r = m;
            while (l < r - 1)
            {
                ll mid = (l + r) / 2;
                if (bill_limit[mid] > diff)
                    r = mid;
                else
                    l = mid;
            }
            if (bill_limit[l] == diff)
            {
                cout << bill[l] << '\n';
            }
            else
            {
                cout << bill[l + 1] << '\n';
            }
        }
    }
    return 0;
}
