#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <map>
typedef long long ll;
using namespace std;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin >> n;
	vector<int> arr(n);
	vector<int> ans(n);
	vector<pair<pair<int, int>, int>> types(n + 1, { {1, 0}, 0 });
	for (int i = 0; i < n; i++)
	{
		cin >> arr[i];
		for (int j = 1; j < types.size(); j++)
		{
			if (i < j)
			{
				if (arr[i] == 1)
				{
					if (types[j].second == 0)
						types[j].first.second++;
					types[j].second++;
				}
				else
				{
					if (types[j].first.first % arr[i] != 0)
						types[j].first.second++;
					types[j].first.first *= arr[i];
				}
			}
			else
			{
				ans[j - 1] += types[j].first.second;
				if (arr[i - j] == 1)
				{
					types[j].second--;
					if (types[j].second == 0)
						types[j].first.second--;
				}
				else
				{
					types[j].first.first /= arr[i - j];
					if (types[j].first.first % arr[i - j] != 0)
						types[j].first.second--;
				}
				if (arr[i] == 1)
				{
					if (types[j].second == 0)
						types[j].first.second++;
					types[j].second++;
				}
				else
				{
					if (types[j].first.first % arr[i] != 0)
						types[j].first.second++;
					types[j].first.first *= arr[i];
				}
			}
		}
	}

	/*
	ans[0] = n;
	for (int len = 2; len <= n; len++)
	{
		map<int, int> types;
		res = 0;
		for (int i = 0; i < len; i++)
		{
			if (!types[arr[i]])
				res++;
			types[arr[i]]++;
		}
		ans[len - 1] += res;
		for (int i = 1; i <= n - len; i++)
		{
				types[arr[i - 1]]--;
				if (!types[arr[i - 1]])
					res--;
				if (!types[arr[i + len - 1]])
					res++;
				types[arr[i + len - 1]]++;
			//cout << i << "->" << i + len - 1 << ": " << types[1] << " " << types[2] << " " << types[3] << endl;
			ans[len - 1] += res;
		}
	}
	*/
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i] + types[i + 1].first.second << " ";
	return 0;
}