#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
typedef long long ll;
using namespace std;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n;
	cin >> n;
	vector<int> arr(n);
	int mx = 0;
	for (int i = 0; i < n; i++)
	{
		cin >> arr[i];
		mx = max(mx, arr[i]);
	}
	vector<int> ans(n);
	if (mx <= 1000000)
	{
		vector<pair<vector<int>, int>> types(n + 1, { vector<int>(mx + 1, 0), 0 });
		for (int i = 0; i < n; i++)
		{;
			for (int j = 1; j < types.size(); j++)
			{
				if (i < j)
				{
					if (!types[j].first[arr[i]])
						types[j].second++;
					types[j].first[arr[i]]++;
				}
				else
				{
					ans[j - 1] += types[j].second;
					types[j].first[arr[i - j]]--;
					if (!types[j].first[arr[i - j]])
						types[j].second--;
					if (!types[j].first[arr[i]])
						types[j].second++;
					types[j].first[arr[i]]++;
				}
			}
		}
		for (int i = 0; i < ans.size(); i++)
			cout << ans[i] + types[i + 1].second << " ";
	}
	else
	{
		vector<pair<unordered_map<int, int>, int>> types(n + 1, { unordered_map<int, int>(), 0 });
		for (int i = 0; i < n; i++)
		{
			for (int j = 1; j < types.size(); j++)
			{
				if (i < j)
				{
					if (!types[j].first[arr[i]])
						types[j].second++;
					types[j].first[arr[i]]++;
				}
				else
				{
					ans[j - 1] += types[j].second;
					types[j].first[arr[i - j]]--;
					if (!types[j].first[arr[i - j]])
						types[j].second--;
					if (!types[j].first[arr[i]])
						types[j].second++;
					types[j].first[arr[i]]++;
				}
			}
		}
		for (int i = 0; i < ans.size(); i++)
			cout << ans[i] + types[i + 1].second << " ";
	}
	return 0;
}