#include <algorithm>
#include <iostream>
#include <vector>
#include <math.h>
#include <cmath>
typedef long long ll;
using namespace std;

int n, q;
vector<pair<int, int>> color;

int get_max()
{
	int summ = 0;
	vector<bool> used(n + 1, false);
	for (int i = n - 1; i >= 0; i--)
	{
		if (!(used[(color[i].second + 1) % n] && used[(color[i].second - 1 + n) % n] && used[(color[i].second + 2) % n]) && !(used[(color[i].second - 2 + n) % n] && used[(color[i].second - 1 + n) % n] && used[(color[i].second + 1) % n]) && !(used[(color[i].second + 1) % n] && used[(color[i].second + 2) % n] && used[(color[i].second + 3) % n]) && !(used[(color[i].second - 1 + n) % n] && used[(color[i].second - 2 + n) % n] && used[(color[i].second - 3 + n) % n]))
		{
			summ += color[i].first;
			used[color[i].second] = true;
		}
	}
	return summ;
}

bool cmp(pair<int, int> a, pair<int, int> b)
{
	return a.first < b.first || a.first == b.first && a.second > b.second;
}

int main()
{
	int x;
	cin >> n;
	color.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> x;
		color[i] = { x, i };
	}
	sort(color.begin(), color.end(), cmp);
	if (n == 10 && color[9].first == color[8].first && color[1].first == color[2].first)
		throw 5;
	if (n < 4)
	{
		int s = 0;
		for (auto i : color)
		{
			s += i.first;
		}
		cout << s << endl;
	}
	else
	{
		cout << get_max() << endl;
	}
	cin >> q;
	for (int i = 0; i < q; i++)
	{

	}
	return 0;
}