#include <iostream>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <cmath>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

#define ll long long 
#define all(x) x.begin(), x.end()
#define for(i, x) for (int i=0; i<x; i++)
#define pairll pair <long long, long long>
#define pairint pair <int, int>



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector <int> v(n), l(n);
	double lmax = 0;
	double tmax = 0;
	for (i, n) {
		cin >> v[i];
	}
	for (i, n) {
		cin >> l[i];
		lmax += l[i];
		tmax += (double)l[i] / (double)v[i];
	}
	int m;
	cin >> m;
	vector <double> a(m);

	vector <int>  f(m);
	for (i, m - 1) {
		cin >> a[i];
	}
	for (i, m) {
		cin >> f[i];
	}
	int q;
	cin >> q;
	vector <int> s(q), t(q);
	vector <double> w(q);
	for (i, q) {
		cin >> s[i] >> t[i];
		t[i] -= s[i];
		w[i] = lmax / (double)t[0];
	}
	a.push_back(1e9);
	if (n == 1) {
		int ans = -1, cur;
		for (i, q) {
			for (j, n) {
				int ind;
				ind = lower_bound(all(a), max((double)w[i] - (double)v[j], 0.0)) - a.begin();
				cur = f[ind - 1];
				ans = max(ans, cur);
			}
			cout << ans << '\n';
		}
	}
	return 0;
}

/*3
10 20 30
400 500 600
6
1 5 10 12 16
10 300 600 800 1000 1500
3
10 100
20 70
45 100
*/