#include <iostream>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <cmath>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

#define ll long long 
#define all(x) x.begin(), x.end()
//#define for(i, x) for (int i=0; i<x; i++)
#define pairll pair <long long, long long>
#define pairint pair <int, int>



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector <int> dp(n + 1);
	for (int d = 0; d < n + 1; d++) {
		dp[d] = 0;
		for (int i = 0; i <= n - d; i++) {
			set <int> s;
			for (int j = 0; j < d; j++) {
				s.insert(a[i + j]);
			}
			dp[d] += s.size();
		}
		if (d) {
			cout << dp[d] << " ";
		}
	}
	return 0;
}

