#include <iostream>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <cmath>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

#define ll long long 
#define all(x) x.begin(), x.end()
//#define for(i, x) for (int i=0; i<x; i++)
#define pairll pair <long long, long long>
#define pairint pair <int, int>


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector <int> a(n);
	map<int, int> m;
	set<int> s;
	vector <int> pred(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		s.insert(a[i]);
		pred[i] = s.size();
	}
	int ind = 0;
	for (auto k : s) {
		m[k] = ind;
		ind++;
	}
	for (int i = 0; i < n; i++) {
		a[i] = m[a[i]];
	}
	vector <vector <int>> dp(n + 1, vector <int> (2));
	vector <int> used(s.size() + 1, 0);
	for (int i = 1; i <= n; i++) {
		dp[i][0] = pred[i - 1];
	}
	vector <int> ans(n, 0);
	for (int d = 2; d <= n; d++) {
		vector <int> used(s.size() + 1, 0);
		for (int j = 0; j < d; j++) {
			used[a[j]]++;
		}
		ans[d - 1] = dp[d][0];
		for (int i = 1; i <= n - d; i++) {
			used[a[i - 1]]--;
			if (a[i - 1] == a[i - 1 + d]) {
				dp[d][1] = dp[d][0];
			}
			else {
				if (!used[a[i - 1 + d]] && used[a[i-1]]) {
					dp[d][1] = dp[d][0] + 1;
				}
				if (!used[a[i - 1 + d]] && !used[a[i - 1]]) {
					dp[d][1] = dp[d][0];
				}
				if (used[a[i - 1 + d]] && !used[a[i - 1]]) {
					dp[d][1] = dp[d][0] - 1;
				}
				if (used[a[i - 1 + d]] && used[a[i - 1]]) {
					dp[d][1] = dp[d][0];
				}
			}
			used[a[i - 1 + d]]++;
			ans[d - 1] += dp[d][1];
			dp[d][0] = dp[d][1];			
		}
	}
	ans[0] = n;
	for (int p : ans) {
		cout << p << " ";
	}
	return 0;
}

