#include <iostream>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <cstdlib>
#include <vector>
#include <cmath>

using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define forr(i, x) for (int i=0; i<x; i++)
#define pairll pair <long long, long long>
#define pairint pair <int, int>
#define fir first
#define sec second


string pr = " ";
char en = '\n';

int n;

bool okmask(int mask) {
	for (int i = 0; i < n; i++) {
		if ((mask & (1 << i)) && (mask & (1 << ((i+1)%n))) && (mask & (1 << (i + 2) % n)) && (mask & (1 << (i + 3) % n)) ){
			return false;
		}
	}
	return true;
}


bool okmaskk(int mask) {
	for (int i = 0; i < n; i++) {
		if ((mask & (1 << i))) cout << 1;
		else cout << 0;
	}
	return true;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	vector <ll> a(n+n);
	forr (i, n) {
		cin >> a[i];
		a[i + n] = a[i];
	}
	int ans = -1;
	for (int mask = 0; mask < (1 << n); mask++) {
		int p = 0;
		if (okmask(mask)) {
			for (int i = 0; i < n; i++) {
				if ((mask & (1 << i))) {
					p += a[i];
				}
			}
			/*if (p > ans) {
				cout << p << " ";
				okmaskk(mask);
				cout << en;
			}*/
			ans = max(ans, p);
		}
	}
	cout << ans << en;
	int q;
	cin >> q;
	forr(i, q) {
		int e, t;
		cin >> e >> t;
		a[e - 1] = t; 
		int ans = -1;
		for (int mask = 0; mask < (1 << n); mask++) {
			int p = 0;
			if (okmask(mask)) {
				for (int i = 0; i < n; i++) {
					if ((mask & (1 << i))) {
						p += a[i];
					}
				}
				ans = max(ans, p);
			}
		}
		cout  << ans<< en;
	}
	return 0;
}
