#include <bits/stdc++.h>

using namespace std;
#define all(x) x.begin(), x.end()
typedef long long int ll;
/*
#pragma optimize("Ofast")
#pragma target("avx2,fma")
#pragma optemizer("unroll-loops")
*/
const ll nax = 2e5 + 1, N = 4e5;
ll n, a[nax], ans[nax], k[nax], dp[nax];
vector<ll> t[N];
void build() {
    for (ll i = n - 1; i > 0; --i) {
        //cout << t[i << 1].size();
        t[i].resize(t[i << 1].size() + t[i << 1 | 1].size());
        merge(all(t[i << 1]), all(t[i << 1 | 1]), t[i].begin());
    }
}

ll query(ll l, ll r, ll x) {
    ll res = 0;
    for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
        if (l & 1) {
            res += lower_bound(all(t[l]), x) - t[l].begin();
            ++l;
        }
        if (r & 1) {
            --r;
            res += lower_bound(all(t[r]), x) - t[r].begin();
        }
    }
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    cin >> n;
    set<ll> s;
    map<ll, ll> b;
    vector<ll> c;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        if (b.count(a[i]))
            t[i + n].push_back(i - b[a[i]]);
        else
            t[i + n].push_back(i + 1);
        b[a[i]] = i;
    }

    build();
    for (ll i = n - 1; i >= 0; --i) {
        s.insert(a[i]);
        k[n - i] = s.size();
    }
    for (ll i = 1; i <= n; ++i) {
        dp[i] = dp[i - 1] - k[i - 1] + n - i + 1 - query(i - 1, n, i);
    }
    for (ll i = 1; i <= n; ++i) cout << dp[i] << " ";
    return 0;
}
