#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define all(x) x.size(), x.begin()
#define sz(x) int(x.size())
//#define int long long
#ifndef MY
    #define endl '\n'
#endif // MY

ostream& operator << (ostream& out, const vector < int > lst) {
    for (auto x : lst) {
        out << x << ' ';
    }
    out << endl;
    return out;
}

const int N = 1e5 + 5;
const int K = 15;
int v[K], p[K];
int lst[N], debt[N];
int n, k;

bool check(int m, int t) {
    double res = 0;
    for (int i = 0; i < k; i++) {
        int a = v[i] + lst[m];
        res += p[i] * 1.0 / a;
    }
    return res <= t;
}

void solve() {
    int s, f;
    cin >> s >> f;
    int l = -1, r = n;
    while (l + 1 != r) {
        int m = (l + r) / 2;
        if (check(m, f - s)) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << debt[r] << endl;
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> k;
    for (int i = 0; i < k; i++) {
        cin >> v[i];
    }
    for (int i = 0; i < k; i++) {
        cin >> p[i];
    }
    cin >> n;
    for (int i = 1; i < n; i++) {
        cin >> lst[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> debt[i];
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        solve();
    }
    return 0;
}
