#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int MAXN = 1e5, INF = 1e18;
int dp[MAXN][4][4];
int arr[MAXN];

inline int get(int m1, int m2) {
    int res = 0;
    for (int i = 0; i < 3; ++i) {
        if (m2 & (1 << i)) {
            res++;
        } else {
            break;
        }
    }
    for (int i = 2; i >= 0; --i) {
        if (m1 & (1 << i)) {
            res++;
        } else {
            break;
        }
    }
    return res;
}

inline int build(int n) {
    for (int i = 0; i < n; ++i) {
        for (int m1 = 0; m1 < 4; ++m1) {
            for (int m2 = 0; m2 < 4; ++m2) {
                dp[i][m1][m2] = -INF;
            }
        }
    }
    for (int i = 0; i < 8; ++i) {
        int s = 0;
        for (int j = 0; j < 3; ++j) {
            if (i & (1 << j)) {
                s += arr[j];
            }
        }
        dp[2][get(i, 0)][get(0, i)] = max(s, dp[2][get(i, 0)][get(0, i)]);
    }
    for (int i = 2; i < n - 1; ++i) {
        for (int m1 = 0; m1 < 4; ++m1) {
            for (int m2 = 0; m2 < 4; ++m2) {
                if (dp[i][m1][m2] == -INF) {
                    continue;
                }
                dp[i + 1][0][m2] = max(dp[i + 1][0][m2], dp[i][m1][m2]);
                if (i == n - 2) {
                    if (m1 + m2 < 3) {
                        dp[i + 1][m1 + 1][m2] = max(dp[i + 1][m1 + 1][m2], dp[i][m1][m2] + arr[i + 1]);
                    }
                } else {
                    if (m1 != 3) {
                        dp[i + 1][m1 + 1][m2] = max(dp[i + 1][m1 + 1][m2], dp[i][m1][m2] + arr[i + 1]);
                    }
                }
            }
        }
    }
    int ans = -INF;
    for (int m1 = 0; m1 < 4; ++m1) {
        for (int m2 = 0; m2 < 4; ++m2) {
            if (dp[n - 1][m1][m2] > ans) {
                ans = dp[n - 1][m1][m2];
            }
        }
    }
    return ans;
}

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> arr[i];
    }
    cout << build(n) << '\n';
    int q;
    cin >> q;
    while (q--) {
        int p, v;
        cin >> p >> v;
        p--;
        arr[p] = v;
        cout << build(n) << '\n';
    }
    return 0;
}
