#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")

#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int long long

int calc2(vector<int> &arr) {
	int n = arr.size();
	vector<vector<int>> dp(n, vector<int> (4, LLONG_MIN));
	dp[0][0] = 0;
	for (int i = 0; i < n - 1; i++) {
		for (int j = 0; j < 4; j++) {
			if (j != 3) {
				dp[i + 1][j + 1] = max(dp[i + 1][j + 1], dp[i][j] + arr[i + 1]);
			}
			dp[i + 1][0] = max(dp[i + 1][0], dp[i][j]);
		}
	}
	return *max_element(dp.back().begin(), dp.back().end());
}

int calc(vector<int> &arr) {
	int n = arr.size();
	int max_ans = LLONG_MIN;
	for (int st = 0; st < 4; st++) {
		vector<int> arr2(n);
		for (int i = 0; i < n; i++) {
			arr2[(i + n - st) % n] = arr[i];
		}
		max_ans = max(max_ans, calc2(arr2));
	}
	return max_ans;
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	cout << calc(arr) << endl;
	int q;
	cin >> q;
	while (q--) {
		int i, v;
		cin >> i >> v;
		arr[i - 1] = v;
		cout << calc(arr) << endl;
	}
}
