#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<cassert>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<bitset>
#include<cmath>
#include<random>
#include<algorithm>
#include<numeric>
#include<queue>
#include<tuple>
//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")
//#pragma GCC optimize("unroll-loops")

using namespace std;

typedef long long ll;
typedef long double ldob;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution <int> rand_int(1, 1000);

//#define int ll
#define double ldob
#define loop(i, n) for(int i = 0; i < n; ++i)
#define loop1(i, n) for(int i = 1; i <= n; ++i)
#define all(x) x.begin(), x.end()
#define pb push_back
#define pi pair <int, int>
#define ti tuple <int, int, int>
#define F first
#define S second

const int N = 40007;

ll dp[N][8][8];
int n, a[N];
bool masks[8][8];

void precalc_masks() {
	for (int i = 0; i < 8; ++i)
		for (int j = 0; j < 8; ++j) {
			int mask = (i << 3) + j;
			bool ok = 1;
			loop(c, 3)
				if ((mask & (1 << c)) && (mask & (1 << c + 1)) && (mask & (1 << c + 2)) && (mask & (1 << c + 3)))
					ok = 0;
			masks[i][j] = ok;
		}
}

ll calc_dp() {
	loop(mask, 8)
		dp[3][mask][mask] = (mask & 1 ? a[3] : 0) + (mask & 2 ? a[2] : 0) + (mask & 4 ? a[1] : 0);
	for (int len = 4; len <= n; ++len) {
		loop(stmask, 8) {
			loop(mask, 8)
				dp[len][stmask][mask] = 0;
			loop(mask, 7) {
				dp[len][stmask][(mask << 1) & 7] = max(dp[len][stmask][(mask << 1) & 7], dp[len - 1][stmask][mask]);
				dp[len][stmask][((mask << 1) & 7) + 1] = max(dp[len][stmask][((mask << 1) & 7) + 1], dp[len - 1][stmask][mask] + a[len]);
			}
			dp[len][stmask][6] = max(dp[len][stmask][6], dp[len - 1][stmask][7]);
		}
	}
	ll ans = 0;
	loop(i, 8)
		loop(j, 8)
		    if (masks[i][j])
			    ans = max(ans, dp[n][j][i]);
	return ans;
}

void solve() {
	cin >> n;
	loop1(i, n)
		cin >> a[i];
	cout << calc_dp();
	int q;
	cin >> q;
	loop(i, q) {
		int pos, val;
		cin >> pos >> val;
		a[pos] = val;
		cout << calc_dp();
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	precalc_masks();
	solve();
	return 0;
}