#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <algorithm>
#include "math.h"
#include "assert.h"
#include <cstdlib>
#include <climits>
using namespace std;

#define ll long long
#define ld long double
#define ull unsigned ll
#define sz(x) (ll)(x).size()
#define all(x) (x).begin(), (x).end()
#define vec vector
#define x first
#define y second
#define pb push_back
#define eb emplace_back

#pragma GCC optimize("unroll-loops")

template<class T>
inline ostream &operator<<(ostream &out, const vec<T> &v)
{
    if(v.empty())
        return out;
    out << *v.begin();
    for(auto it = ++v.begin(); it != v.end(); ++it)
        out << ' ' << *it;
    return out;
}

template<class T>
inline istream &operator>>(istream &in, vec<T> &v)
{
    for(auto it = v.begin(); it != v.end(); ++it)
        in >> *it;
    return in;
}

template<class T1, class T2>
inline ostream &operator<<(ostream &out, const pair<T1, T2> &p)
{
    return out << p.x << ' ' << p.y;
}

template<class T1, class T2>
inline istream &operator>>(istream &in, pair<T1, T2> &p)
{
    return in >> p.x >> p.y;
}

//===================================================================================
//===================================================================================

ll solve(const vector<ll> &v)
{
    vector<ll> pref(sz(v) + 1);
    for(ll i = 0; i < sz(v); ++i)
        pref[i + 1] = pref[i] + v[i];
    ll mx_ans = LLONG_MIN;
    ll best_idx = -1;
    for(ll i = 0; i < sz(v) - 1; ++i)
    {
        ll cur_ans = pref[i + 1] * (pref[sz(v)] - pref[i + 1]);
        if(cur_ans > mx_ans)
        {
            mx_ans = cur_ans;
            best_idx = i + 1;
        }
    }
    return best_idx;
}

int main()
{
    ll n;
    cin >> n;
    vector<ll> v(n);
    cin >> v;
    cout << solve(v) << endl;
}