#ifdef _MSC_VER
	#define _CRT_SECURE_NO_WARNINGS
	#include <__msvc_all_public_headers.hpp>
#else
	#include <bits/stdc++.h>
	#define _MSC_VER 2000
#endif

#define uint			unsigned int
#define int				long long
#define double			long double
#define all(q)			q.begin(), q.end()
#define fora(q)			for(auto &p : q)
#define foru(q)			for (int x = 0; x < q; x++)

using namespace std;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie();
	cout.tie();

	int n = 0;
	cin >> n;

	deque <int> v(n);
	deque <int> lu(n);
	fora(v)
		cin >> p;
	fora(lu)
		cin >> p;

	int m = 0;
	cin >> m;

	deque <int> a(m - 1);
	deque <int> f(m);
	fora(a)
		cin >> p;
	fora(f)
		cin >> p;

	a.push_back(pow(10, 10));

	double mint = 0;
	for (int i = 0; i < n; i++)
		mint += (double)lu[i] / (double)v[i];

	int q = 0;
	cin >> q;
	foru(q)
	{
		int s = 0, t = 0;
		cin >> s >> t;

		double d = t - s;
		if (d >= mint)
			cout << 0 << "\n";
		else
		{
			double l = 0, r = pow(10, 9);
			while (r - l > pow(10, -5))
			{
				double m = (l + r) / 2;

				double curt = 0;
				for (int i = 0; i < n; i++)
					curt += (double)lu[i] / (double)(v[i] + m);

				if (curt > d)
					l = m;
				else
					r = m;
			}

			cout << f[lower_bound(all(a), l) - a.begin()] << endl;
		}
	}

	if (_MSC_VER < 1920)
		system("Pause");
	return 0;
}

/*3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100*/