#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#define _MSC_VER 2000
#endif

#define uint			unsigned int
#define int				long long
#define double			long double
#define all(q)			q.begin(), q.end()
#define fora(q)			for(auto &p : q)
#define foru(q)			for (int x = 0; x < q; x++)

using namespace std;

struct prog { int a, b, op; };

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie();
	cout.tie();
	
	int n = 0, m = 0, s = 0;
	cin >> n >> m >> s;

	deque <deque <prog>> pr(m, deque <prog>(n - 1));
	for (auto& p : pr)
		for (auto& q : p)
			cin >> q.a >> q.b >> q.op;

	deque <deque <int>> mt(m, deque <int>(n));
	for (auto& p : mt)
		for (auto& q : p)
			cin >> q;

	for (int z1 = 0; z1 <= m; z1++)
	{
		for (int z2 = 0; z2 <= m; z2++)
		{
			deque <int> z = { z1, z2 };
			int cs = 0;

			for (int i = 0; i < m; i++)
			{
				deque <int> val(2 * n - 1);

				for (int j = 0; j < n; j++)
					val[j] = (mt[i][j] < z[j]) ? 1 : 0;

				for (int j = n; j < 2 * n - 1; j++)
				{
					if (pr[i][j - n].op == 1)
						val[j] = (pr[i][j - n].a && pr[i][j - n].b);
					else
						val[j] = (pr[i][j - n].a || pr[i][j - n].b);
				}

				if (val[2 * n - 2])
					cs++;
			}

			if (cs == s)
				cout << z1 << " " << z2 << endl, exit(0);
		}
	}

	if (_MSC_VER < 1920)
		system("Pause");
	return 0;
}