#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#define _MSC_VER 2000
#endif

#define uint			unsigned int
#define int				long long
#define double			long double
#define all(q)			q.begin(), q.end()
#define fora(q)			for(auto &p : q)
#define foru(q)			for (int x = 0; x < q; x++)

using namespace std;

struct prog { int a, b, op; };

bool check(int s, deque <deque <int>> mt, deque <deque <prog>> pr, deque <int> z)
{
	int m = mt.size(), n = mt[0].size();
	
	int count = 0;
	for (int i = 0; i < m; i++)
	{
		vector <int> val(2 * n - 1);

		for (int j = 0; j < n; j++)
			val[j] = (mt[i][j] < z[j]) ? 1 : 0;

		for (int j = n; j < 2 * n - 1; j++)
		{
			if (pr[i][j - n].op == 1)
				val[j] = (val[pr[i][j - n].a - 1] && val[pr[i][j - n].b - 1]);
			else
				val[j] = (val[pr[i][j - n].a - 1] || val[pr[i][j - n].b - 1]);
		}

		if (val[2 * n - 2])
			count++;
	}

	if (count == s)
		return true;

	return false;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie();
	cout.tie();
	
	int n = 0, m = 0, s = 0;
	cin >> n >> m >> s;

	deque <deque <prog>> pr(m, deque <prog>(n - 1));
	for (auto& p : pr)
		for (auto& q : p)
			cin >> q.a >> q.b >> q.op;

	deque <deque <int>> mt(m, deque <int>(n));
	for (auto& p : mt)
		for (auto& q : p)
			cin >> q;

	if (n == 1)
	{
		for (int i = 0; i <= m; i++)
		{
			int cou = 0;
			for (int j = 0; j < m; j++)
			{
				vector <int> val(2 * n - 1);
				val[0] = (mt[j][0] < i) ? 1 : 0;

				if (val[0])
					cou++;
			}

			if (cou == s)
				cout << i << endl, exit(0);
		}
	}
	else if (n == 2)
	{
		for (int i = 0; i <= m; i++)
		{
			for (int j = 0; j <= m; j++)
			{
				deque <int> z = { i, j };
				if (check(s, mt, pr, z))
					cout << i << " " << j << endl, exit(0);
			}
		}
	}

	if (_MSC_VER < 1920)
		system("Pause");
	return 0;
}