#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#define _MSC_VER 2000
#endif

#define uint			unsigned int
#define int				long long
#define double			long double
#define all(q)			q.begin(), q.end()
#define fora(q)			for(auto &p : q)
#define foru(q)			for (int x = 0; x < q; x++)

using namespace std;

struct prog { int a, b, op; };

bool check(int s, deque <deque <int>> mt, deque <deque <prog>> pr, deque <int> z)
{
	int m = mt.size(), n = mt[0].size();
	
	int count = 0;
	for (int i = 0; i < m; i++)
	{
		vector <int> val(2 * n - 1);

		for (int j = 0; j < n; j++)
			val[j] = (mt[i][j] < z[j]) ? 1 : 0;

		for (int j = n; j < 2 * n - 1; j++)
		{
			if (pr[i][j - n].op == 1)
				val[j] = (val[pr[i][j - n].a - 1] && val[pr[i][j - n].b - 1]);
			else
				val[j] = (val[pr[i][j - n].a - 1] || val[pr[i][j - n].b - 1]);
		}

		if (val[2 * n - 2])
			count++;
	}

	if (count == s)
		return true;

	return false;
}

void rec(int n, int m, int s, deque <deque <int>> mt, deque <deque <prog>> pr, deque <int> z = {}, int cou = 0)
{
	if (cou == n)
	{
		if (check(s, mt, pr, z))
			cout << "Found" << endl, exit(0);
	}

	for (int i = 0; i <= m; i++)
	{
		z.push_back(i);
		rec(n, m, s, mt, pr, z, cou + 1);
		z.pop_back();
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie();
	cout.tie();
	
	int n = 0, m = 0, s = 0;
	cin >> n >> m >> s;

	deque <deque <prog>> pr(m, deque <prog>(n - 1));
	for (auto& p : pr)
		for (auto& q : p)
			cin >> q.a >> q.b >> q.op;

	deque <deque <int>> mt(m, deque <int>(n));
	for (auto& p : mt)
		for (auto& q : p)
			cin >> q;

	rec(n, m, s, mt, pr);

	if (_MSC_VER < 1920)
		system("Pause");
	return 0;
}