#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <__msvc_all_public_headers.hpp>
#else
#include <bits/stdc++.h>
#define _MSC_VER 2000
#endif

#define uint			unsigned int
#define int				long long
#define double			long double
#define all(q)			q.begin(), q.end()
#define fora(q)			for(auto &p : q)
#define foru(q)			for (int x = 0; x < q; x++)

using namespace std;

struct prog { int a, b, op; };

deque <deque <int>> mt;
deque <deque <prog>> pr;
int n, m, s;

bool check(deque <int> z)
{	
	int count = 0;
	for (int i = 0; i < m; i++)
	{
		vector <int> val(2 * n - 1);

		for (int j = 0; j < n; j++)
			val[j] = (mt[i][j] < z[j]) ? 1 : 0;

		for (int j = n; j < 2 * n - 1; j++)
		{
			if (pr[i][j - n].op == 1)
				val[j] = (val[pr[i][j - n].a - 1] && val[pr[i][j - n].b - 1]);
			else
				val[j] = (val[pr[i][j - n].a - 1] || val[pr[i][j - n].b - 1]);
		}

		if (val[2 * n - 2])
			count++;
	}

	if (count == s)
		return true;

	return false;
}

void rec(deque <int> z = {})
{
	if (z.size() == n)
	{
		if (check(z))
		{
			for (auto& p : z)
				cout << p << " ";
			exit(0);
		}
		return;
	}

	for (int i = 0; i <= m; i++)
	{
		z.push_back(i);
		rec(z);
		z.pop_back();
	}
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie();
	cout.tie();

	cin >> n >> m >> s;

	pr.assign(m, deque<prog>(n - 1));
	for (auto& p : pr)
		for (auto& q : p)
			cin >> q.a >> q.b >> q.op;

	mt.assign(m, deque <int>(n));
	for (auto& p : mt)
		for (auto& q : p)
			cin >> q;

	if (n == 1)
	{
		cout << s - 1 << endl;
	}
	if (n == 2)
	{
		deque <int> ind(m + 1);
		for (int j = 0; j < m; j++)
			ind[mt[j][1]] = j;

		for (int z1 = 0; z1 <= m; z1++)
		{
			vector <vector <int>> val(m, vector <int> (2 * n - 1));
			deque <int> z = { z1, 0 };
			int chk = 0;

			for (int i = 0; i < m; i++)
			{
				for (int j = 0; j < n; j++)
					val[i][j] = (mt[i][j] < z[j]) ? 1 : 0;

				for (int j = n; j < 2 * n - 1; j++)
				{
					if (pr[i][j - n].op == 1)
						val[i][j] = (val[i][pr[i][j - n].a - 1] && val[i][pr[i][j - n].b - 1]);
					else
						val[i][j] = (val[i][pr[i][j - n].a - 1] || val[i][pr[i][j - n].b - 1]);
				}

				if (val[i][2 * n - 2])
					chk++;
			}			

			for (int z2 = 0; z2 <= m; z2++)
			{
				z[1] = z2;
				int id = ind[z2];

				val[id][1] = (mt[id][1] < z2) ? 1 : 0;
				
				int buf = 0;
				if (pr[id][0].op == 1)
					buf = (val[id][pr[id][0].a - 1] && val[id][pr[id][0].b - 1]);
				else
					buf = (val[id][pr[id][0].a - 1] || val[id][pr[id][0].b - 1]);

				if (buf == 1 && val[id][2] == 0)
					chk++;
				else if (buf == 0 && val[id][2] == 1)
					chk--;

				val[id][2] = buf;

				if (chk == s)
					cout << z1 << " " << z2, exit(0);
			}
		}
	}
	else
		rec();

	if (_MSC_VER < 1920)
		system("Pause");
	return 0;
}

/*4 3 2
1 2 1
3 4 1
5 6 2
1 2 2
3 5 1
4 6 2
1 4 1
2 3 1
5 6 2
0 1 2 2
2 2 1 0
1 0 0 1*/