#include <iostream>
#include<algorithm>
#include<set>
#include<vector>
#include<map>
#include<iomanip>
#include<string>

#define ll long long int
#define eps 0.00001

using namespace std;

/*vector<int> t, a;

void build(int v, int l, int r)
{
    if (l == r)
        t[v] = a[l];
    else
    {
        int m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m + 1, r);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
}

void change(int v, int l, int r, int x)
{
    if (l == r)
        t[v] = x;
    else
    {
        int m = (l + r) / 2;
        change(2 * v, l, m, x);
        change(2 * v + 1, m + 1, r, x);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
}

ll get(int v, int l, int r, int askl, int askr)
{
    if (r < askl || l > askr)
        return 0;
    if (askl <= l && askr >= r)
        return t[v];
    int m = (l + r) / 2;
    return get(2 * v, l, m, askl, askr) + get(2 * v + 1, m + 1, r, askl, askr);
}*/

int main()
{
    int n, m, q;
    cin >> n;
    vector<int> limit = vector<int>(n), length = vector<int>(n);
    for (int& i : limit) cin >> i;
    for (int& i : length) cin >> i;
    cin >> m;
    vector<int> a = vector<int>(m - 1), fees = vector<int>(m);
    for (int& i : a) cin >> i;
    for (int& i : fees) cin >> i;
    cin >> q;
    vector<int> tstart = vector<int>(q), tend = vector<int>(q);
    for (int i = 0; i < q; i++)
        cin >> tstart[i] >> tend[i];


    vector<int> ttot = vector<int>(q);
    for (int i = 0; i < q; i++) ttot[i] = tend[i] - tstart[i];
    vector<double> tmax = vector<double>(n);
    for (int i = 0; i < n; i++)
        tmax[i] = (double)length[i] / limit[i];
    vector<double> mintimes = vector<double>(m);
    for (int i = 0; i < m - 1; i++)
    {
        for (int j = 0; j < n; j++)
        {
            mintimes[i] += (double)length[j] / (a[i] + limit[j]);
        }
    }
    

    for (int i = 0; i < q; i++)
    {
        if (ttot[i] > mintimes[0] + eps)
        {
            cout << 0 << endl;
            continue;
        }
        int l = 0, r = m, res = -1;
        while (l < r)
        {
            int med = (l + r) / 2;
            if (abs(mintimes[med] - ttot[i]) < eps)
            {
                res = med;
                break;
            }
            if (ttot[i] < mintimes[med])
                l = med + 1;
            else
                r = med;
        }
        if (res == -1)
            if (mintimes[l] > ttot[i])
                cout << fees[l + 1] << endl;
            else cout << fees[l] << endl;
    }

    /*int n;
    cin >> n;
    vector<int> a = vector<int>(n);
    set<int> s;
    for (int& i : a) cin >> i;
    for (int d = 1; d <= n; d++)
    {
        int sum = 0;
        for (int l = 0; l < n - d + 1; l++)
        {
            s.clear();
            for (int i = l; i < l + d; i++)
                s.emplace(a[i]);
            sum += s.size();
        }
        cout << sum << " ";
    }*/
}
