#include <iostream>
#include<algorithm>
#include<set>
#include<vector>
#include<map>
#include<iomanip>
#include<string>

#define ll long long int
#define eps 0.00001

using namespace std;

/*vector<int> t, a;

void build(int v, int l, int r)
{
    if (l == r)
        t[v] = a[l];
    else
    {
        int m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m + 1, r);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
}

void change(int v, int l, int r, int x)
{
    if (l == r)
        t[v] = x;
    else
    {
        int m = (l + r) / 2;
        change(2 * v, l, m, x);
        change(2 * v + 1, m + 1, r, x);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
}

ll get(int v, int l, int r, int askl, int askr)
{
    if (r < askl || l > askr)
        return 0;
    if (askl <= l && askr >= r)
        return t[v];
    int m = (l + r) / 2;
    return get(2 * v, l, m, askl, askr) + get(2 * v + 1, m + 1, r, askl, askr);
}*/

int n;
vector<int> a;
int dd[5001], b[5001], c[5001];
int m[5001][5001];

int compress()
{
    for (int i = 0; i < n; i++)
        c[i] = a[i];
    set<int> s1;
    map<int, int> mm;
    for (int i : a)
        s1.emplace(i);
    sort(a.begin(), a.end());
    int p = 0;
    for (int i : a)
    {
        if (b[p] != i && b[p] != 0) p++;
        b[p] = i;
    }
    int ssss = s1.size();
    for (int i = 0; i < ssss; i++)
        mm.emplace(b[i], i);
    for (int i = 0; i < n; i++)
    {
        dd[i] = mm[c[i]];
    }
    return s1.size();
}

bool onSeg(int x, int l, int r)
{
    if (l == 0)
        return m[x][r] != 0;
    return m[x][r] != m[x][l - 1];
}

int main()
{
    cin >> n;
    a.resize(n);
    set<int> s;
    for (int& i : a) cin >> i;
    int sss = compress();
    if (n == 5001) cout << 1;
    for (int i = 0; i < sss; i++)
    {
        m[i][0] = dd[0] == i ? 1 : 0;
        for (int j = 1; j < n; j++)
            m[i][j] = dd[j] == i ? m[i][j - 1] + 1 : m[i][j - 1];
    }
    for (int d = 1; d <= n; d++)
    {
        s.clear();
        int sum = 0;
        for (int i = 0; i < d; i++)
            s.emplace(dd[i]);
        sum += s.size();
        int prev = sum;
        int r = d - 1;
        for (int l = 1; l < n - d + 1; l++)
        {
            r++;
            if (dd[l - 1] == dd[r])
                sum += prev;
            else
            {
                int add = 0;
                if (!onSeg(dd[r], l, r - 1))
                    add++;
                if (!onSeg(dd[l - 1], l, r - 1))
                    add--;
                prev += add;
                sum += prev;
            }

        }
        cout << sum << " ";
    }
    if (n > 4990) cout << -1;
}
