#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int main()
{
    ll n, m, s; cin >> n >> m >> s;
    vector<vector<int>> x(m, vector<int>(n));
    vector<vector<vector<int>>> cmp(m, vector<vector<int>>(n - 1, vector<int>(3)));
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n - 1; j++)
            cin >> cmp[i][j][0] >> cmp[i][j][1] >> cmp[i][j][2];
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
            cin >> x[i][j];
    if (n == 1)
    {
        cout << s << "\n";
    }
    else if (n == 2 && m < 1000)
    {
        // 0 - and    1 - or
        vector<int> res(m);
        vector<vector<int>> r_f(m + 1, vector<int>(m));
        vector<vector<int>> r_s(m + 1, vector<int>(m));
        for (int i = 0; i < m; i++)
            res[i] = cmp[i][0][2] - 1;
        for (int i = 0; i <= m; i++)
        {
            for (int j = 0; j < m; j++)
            {
                if (x[j][0] < i)
                    r_f[i][j] = 1;
                else
                    r_f[i][j] = 0;
                if (x[j][1] < i)
                    r_s[i][j] = 1;
                else
                    r_s[i][j] = 0;
            }
        }
        for (int i = 0; i <= m; i++)
        {
            int l = 0, r = m + 1;
            bool was_s = false;
            while (l + 1 < r)
            {
                int md = (l + r) / 2, cnt = 0;
                for (int j = 0; j < m; j++)
                {
                    if (res[j] == 0 && r_f[i][j] == 1 && r_s[md][j] == 1)
                        cnt++;
                    if (res[j] == 1 && (r_f[i][j] == 1 || r_s[md][j] == 1))
                        cnt++;
                }
                if (cnt <= s)
                    l = md;
                else
                    r = md;
                if (cnt == s)
                    was_s = true;
            }
            if (was_s)
            {
                cout << i << " " << l << "\n";
                return 0;
            }
        }
    }
    else if (m <= 2)
    {
        vector<vector<int>> a_b(2, vector<int>(n - 1));
        int pow = 1;
        for (int i = 0; i < n; i++)
            pow *= (m + 1);
        for (int mask = 0; mask < pow; mask++)
        {
            vector<int> z(n);
            int smask = mask;
            for (int i = 0; i < n; i++)
            {
                z[i] = smask % (m + 1);
                smask /= (m + 1);
            }
            for (int in_m = 0; in_m < m; in_m++)
                for (int i = 0; i < n - 1; i++)
                {
                    int a = cmp[0][i][0] - 1;
                    int b = cmp[0][i][1] - 1;
                    int op = cmp[0][i][2];
                    int res_a = 0, res_b = 0;
                    if (a < n && x[in_m][a] < z[a])
                        res_a = 1;
                    else if (a < n)
                        res_a = 0;
                    else
                        res_a = a_b[in_m][a];
                    if (b < n && x[in_m][b] < z[b])
                        res_b = 1;
                    else if (b < n)
                        res_b = 0;
                    else
                        res_b = a_b[in_m][b];
                    if (op == 1)
                        a_b[in_m][i] = (res_a & res_b);
                    else
                        a_b[in_m][i] = (res_a | res_b);
                }
            int cnt = 0;
            for (int in_m = 0; in_m < m; in_m++)
                cnt += a_b[in_m][n - 2];
            if (cnt == s)
            {
                for (int i = 0; i < n; i++)
                {
                    cout << z[i] << " ";
                }
                return 0;
            }
        }
    }
    return 0;
}
