#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 1e6;


vector<vector<int>> tree(4 * MAXN, vector<int>(16, -1));
vector<int> a;


void build(int l, int r, int v)
{
    if (l + 1 == r)
    {
        tree[v][0] = 0;
        tree[v][5] = a[l];
    }
    else
    {
        int m = (l + r) / 2;
        build(l, m, 2 * v + 1);
        build(m, r, 2 * v + 2);
        for (int pr = 0; pr < 4; pr++)
            for (int suf = 0; suf < 4; suf++)
                if (pr + suf < r - l || (pr == suf && pr == r - l))
                {
                    if (pr <= m - l)
                    {
                        if (suf <= r - m)
                        {
                            for (int i = 0; i < 4; i++)
                                for (int j = 0; i + j < 4; j++)
                                    if (tree[2 * v + 1][pr * 4 + i] != -1 && tree[2 * v + 2][j * 4 + suf] != -1)
                                        tree[v][pr * 4 + suf] = max(tree[v][pr * 4 + suf], tree[2 * v + 1][pr * 4 + i] + tree[2 * v + 2][j * 4 + suf]);
                        }
                        else
                        {
                            if (tree[2 * v + 2][min((int)15, (r - m) * 4 + r - m)] != -1)
                            {
                                int corr_suf = suf - (r - m);
                                if (corr_suf < 4)
                                    if (tree[2 * v + 1][pr * 4 + corr_suf] != -1)
                                        tree[v][pr * 4 + suf] = max(tree[v][pr * 4 + suf], tree[2 * v + 1][pr * 4 + corr_suf] + tree[2 * v + 2][min((int)15, (r - m) * 4 + r - m)]);
                            }
                        }
                    }
                    else
                    {
                        if (suf <= m - l)
                        {
                            if (tree[2 * v + 1][min((int)15, (m - l) * 4 + m - l)] != -1)
                            {
                                int corr_suf = pr - (m - l);
                                if(corr_suf < 4)
                                    if (tree[2 * v + 2][corr_suf * 4 + suf] != -1)
                                        tree[v][pr * 4 + suf] = max(tree[v][pr * 4 + suf], tree[2 * v + 1][min((int)15, (m - l) * 4 + m - l)] + tree[2 * v + 2][corr_suf * 4 + suf]);
                            }
                        }
                        else
                        {
                            tree[v][pr * 4 + suf] = tree[2 * v + 1][min((int)15, (m - l) * 4 + m - l)] + tree[2 * v + 2][min((int)15, (r - m) * 4 + r - m)];
                        }
                    }
                }
    }
}


void change(int l, int r, int ind, int x, int v)
{
    if (l + 1 == r && l == ind)
    {
        tree[v][5] = x;
    }
    else if (ind < l || r <= ind)
        return;
    else
    {
        int m = (l + r) / 2;
        change(l, m, ind, x, 2 * v + 1);
        change(m, r, ind, x, 2 * v + 2);
        for (int pr = 0; pr < 4; pr++)
            for (int suf = 0; suf < 4; suf++)
                if (pr + suf < r - l || (pr == suf && pr == r - l))
                {
                    if (pr <= m - l)
                    {
                        if (suf <= r - m)
                        {
                            for (int i = 0; i < 4; i++)
                                for (int j = 0; i + j < 4; j++)
                                    if (tree[2 * v + 1][pr * 4 + i] != -1 && tree[2 * v + 2][j * 4 + suf] != -1)
                                        tree[v][pr * 4 + suf] = max(tree[v][pr * 4 + suf], tree[2 * v + 1][pr * 4 + i] + tree[2 * v + 2][j * 4 + suf]);
                        }
                        else
                        {
                            if (tree[2 * v + 2][min((int)15, (r - m) * 4 + r - m)] != -1)
                            {
                                int corr_suf = suf - (r - m);
                                if (corr_suf < 4)
                                    if (tree[2 * v + 1][pr * 4 + corr_suf] != -1)
                                        tree[v][pr * 4 + suf] = max(tree[v][pr * 4 + suf], tree[2 * v + 1][pr * 4 + corr_suf] + tree[2 * v + 2][min((int)15, (r - m) * 4 + r - m)]);
                            }
                        }
                    }
                    else
                    {
                        if (suf <= m - l)
                        {
                            if (tree[2 * v + 1][min((int)15, (m - l) * 4 + m - l)] != -1)
                            {
                                int corr_suf = pr - (m - l);
                                if(corr_suf < 4)
                                    if (tree[2 * v + 2][corr_suf * 4 + suf] != -1)
                                        tree[v][pr * 4 + suf] = max(tree[v][pr * 4 + suf], tree[2 * v + 1][min((int)15, (m - l) * 4 + m - l)] + tree[2 * v + 2][corr_suf * 4 + suf]);
                            }
                        }
                        else
                        {
                            tree[v][pr * 4 + suf] = tree[2 * v + 1][min((int)15, (m - l) * 4 + m - l)] + tree[2 * v + 2][min((int)15, (r - m) * 4 + r - m)];
                        }
                    }
                }
    }
}


int get_ans()
{
    int ans = 0;
    for (int i = 0; i < 4; i++)
        for (int j = 0; i + j <= 3; j++)
            if (tree[0][i * 4 + j] != -1)
                ans = max(ans, tree[0][i * 4 + j]);
    return ans;
}


int32_t main()
{
    int n, q; cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    build(0, n, 0);
    cout << get_ans() << "\n";
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        int p, v; cin >> p >> v;
        change(0, n, p - 1, v, 0);
        cout << get_ans();
    }
    return 0;
}
