#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <ostream>
#include <istream>
#include <string>
#include <random>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>

using namespace std;

#define int long long
#define pb push_back
#define all(a) (a).begin(), (a).end()

ostream& operator << (ostream& a, const vector<int> &b) {
    for (auto k : b) cout << k << " ";
    cout << "\n";
    return a;
}

#define LOCAL

#ifdef LOCAL
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
    #define dbg(x)
#endif

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    if (n <= (1 << 30)) {
        int x;
        for (int y = 1; y * y + n <= 4611686018427387903; y++) {
            x = sqrt(n + y * y);
            if (x * x == n + y * y && x != 0) {
                cout << "Yes\n" << x << " " << y << "\n";
                return 0;
            }
        }
        cout << "No\n";
        return 0;
    } else {
        int s = sqrt(n) + 1, y;
        for (int x = s; x < (1<<31); x++) {
            y = sqrt(x * x - n);
            if (y * y + n == x * x && y != 0) {
                cout << "Yes\n" << x << " " << y << "\n";
                return 0;
            }
        }
        cout << "No\n";
        return 0;
    }
}
/*

*/
