#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <ostream>
#include <istream>
#include <string>
#include <random>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <time.h>

using namespace std;

#pragma GCC optimize("Ofast")

#define int long long
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define ld long double

ostream& operator << (ostream& a, const vector<int> &b) {
    for (auto k : b) cout << k << " ";
    cout << "\n";
    return a;
}

#define LOCAL

#ifdef LOCAL
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
    #define dbg(x)
#endif

struct road {
    int v, l;
    road(){}
};

vector<road> r;
int m, n;
inline bool comp(const road &a, const road& b) {
    if (a.l == b.l) return a.v > b.v;
    return a.l > b.l;
}
vector<int> a;
vector<int> f;

const int INF = 1e18;

int ans = INF;
ld mn;
int t;

void check(const vector<int> &mod){
    ld curt = 0;
    int curans = 0;
    for (int i = 0; i < n; i++) {
        curans += f[mod[i]];
        if (mod[i] != m - 1) {
            curt += (ld)r[i].l/((ld)r[i].v + (ld)a[mod[i]]);
        }
    }
    int curtt = ceil(curt);
    if (curtt <= t) {
        ans = min(ans, curans);
    }
}

void tryhard(vector<int> cur, int lft) {
    if (!lft) {
        check(cur);
        return;
    }
    if (!cur.size()){
        for (int i = 0; i < m; i++) {
            tryhard({i}, lft - 1);
        }
    } else {
        for (int i = 0; i <= cur.back(); i++) {
            cur.push_back(i);
            tryhard(cur, lft - 1);
            cur.pop_back();
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    vector<int> l(n), v(n);
    for (int i = 0; i < n; i++) cin >> v[i];
    for (int i = 0; i < n; i++) cin >> l[i];
    cin >> m;
    a.resize(m - 1);
    f.resize(m);
    for (int i = 1; i < m; i++) cin >> a[i - 1];
    for (int i = 0; i < m; i++) cin >> f[i];
    int q;
    cin >> q;
    mn = 0;
    for (int i = 0; i < n; i++) {
        mn += (ld)l[i]/(ld)v[i];
    }
    int qqq, www;
    if (m == 1 || n == 1) {
        while (q--) {
            cin >> qqq >> www;
            t = www - qqq;
            if ((ld)t >= mn) {
                cout << "0\n";
                continue;
            }
            ld s = (ld)l[0]/(ld)t;
            int help = ceil(s) - v[0];
            int ind = lower_bound(all(a), help) - a.begin();
            cout << f[ind] << "\n";
        }
    } else {
        r.resize(n);
        for (int i = 0; i < n; i++) {
            r[i].l = l[i];
            r[i].v = v[i];
        }
        sort(all(r), comp);
        while(q--){
            ans = INF;
            tryhard({}, n);
            cout << ans << "\n";
        }
    }
}
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
*/
