#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <ostream>
#include <istream>
#include <string>
#include <random>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>

using namespace std;

#define int long long
#define pb push_back
#define all(a) (a).begin(), (a).end()

ostream& operator << (ostream& a, const vector<int> &b) {
    for (auto k : b) cout << k << " ";
    cout << "\n";
    return a;
}

#define LOCAL

#ifdef LOCAL
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
    #define dbg(x)
#endif

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<int> ans(n, 0);
    int cur;
    for (int i = 0; i < n; i++) {
        unordered_map<int, int> cnt;
        cur = 0;
        for (int j = i; j >= 0; j--) {
            if (!cnt.count(a[j])) {
                cur++;
                cnt.insert(a[j]);
            }
            ans[i - j] += cur;
        }
    }
    for (auto k : ans) cout << k << " ";
}
/*
help
*/
