#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <ostream>
#include <istream>
#include <string>
#include <random>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <time.h>

using namespace std;

//#pragma GCC optimize("Ofast")

#define int long long
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define ld long double
#define pii pair<int, int>

ostream& operator << (ostream& a, const vector<int> &b) {
    for (auto k : b) cout << k << " ";
    cout << "\n";
    return a;
}

#define LOCAL

#ifdef LOCAL
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
    #define dbg(x)
#endif

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    int ans = 0;
    for (int i = 0; i < (1LL << n); i++) {
        int pref = 0, suf = 0, cur = 0;
        int kek = n - 1;
        while (kek >= 0 && ((i >> kek) & 1)) {
            pref++;
            kek--;
        }
        if (pref >= 4) continue;
        kek = 0;
        while (kek <= n - 1 && ((i >> kek) & 1)) {
            suf++;
            kek++;
        }
        if (suf >= 4 || pref + suf >= 4) continue;
        for (int j = n - 1; j >= 0; j--) {
            if ((i >> j) & 1) {
                cur += a[j];
            }
        }
        ans = max(ans, cur);
    }
    cout << ans;
}
/*
*/
