#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <ostream>
#include <istream>
#include <string>
#include <random>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <iomanip>
#include <time.h>

using namespace std;

//#pragma GCC optimize("Ofast")

#define int long long
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define ld long double
#define pii pair<int, int>

ostream& operator << (ostream& a, const vector<int> &b) {
    for (auto k : b) cout << k << " ";
    cout << "\n";
    return a;
}

#define LOCAL

#ifdef LOCAL
    #define dbg(x) cout << #x << " : " << (x) << "\n";
#else
    #define dbg(x)
#endif

const int INF = 1e9;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int dp[n][4][4];
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 4; j++) {
            for (int k = 0; k < 4; k++) dp[i][j][k] = 0;
        }
    }
    dp[0][1][1] = a[0];
    dp[0][0][0] = 0;
    dp[1][1][0] = a[0];
    dp[1][0][1] = a[1];
    dp[1][2][2] = a[0] + a[1];
    dp[1][0][0] = 0;
    dp[2][3][3] = a[0] + a[1] + a[2];
    dp[2][2][0] = a[0] + a[1];
    dp[2][1][1] = a[0] + a[2];
    dp[2][0][2] = a[1] + a[2];
    dp[2][1][0] = a[0];
    dp[2][0][0] = a[1];
    dp[2][0][1] = a[2];
//    for (int i = 0; i < 3; i++) {
//        for (int j = 0; j < 4; j++) {
//            for (int k = 0; k < 4; k++) {
//                cout << i << " " << j << " " << k << " : " << dp[i][j][k] << "\n";
//            }
//        }
//    }
    for (int i = 3; i < n; i++) {
        for (int k = 0; k < 4; k++) {
            dp[i][k][0] = max(dp[i - 1][k][1], max(dp[i - 1][k][2], max(dp[i - 1][k][3], dp[i - 1][k][0])));
            dp[i][k][1] = dp[i-1][k][0] + a[i];
            dp[i][k][2] = dp[i-1][k][1] + a[i];
            dp[i][k][3] = dp[i-1][k][2] + a[i];
        }
    }
    int ans = 0;
    for (int j = 0; j < 4; j++) {
        for (int k = 0; k < 4; k++) {
            if (j + k < 4) {
                ans = max(ans, dp[n - 1][j][k]);
//                if (ans == dp[n - 1][j][k]) {
//                    cout << j << " " << k << "\n";
//                }
            }
        }
    }
//    dbg(dp[n - 1][2][1]);
    cout << ans;
}
/*
5
6 7 0 2 3
-> 16
*/
