#include <iostream>
#include <cmath>
#include <vector>
#include <set>
using namespace std;

int n, m, q;
int64_t need_time = 0;
vector<int64_t> v;
vector<int64_t> l;
long double exceeded_v = 0;
vector<int64_t> a;
vector<int64_t> f;

int binsearch(int l, int r) {
	int mid = 0;
	while (r - l > 1) {
		mid = (l + r) / 2;
		if (mid < m - 1 && exceeded_v - a[mid + 1] > 1e-9)
			l = mid;
		else if (exceeded_v - a[mid] < 1e-9)
			r = mid;
		else
			return mid;
	}
	return l;
}

int main() {
	cin >> n;
	int sum = 0;
	v.resize(n);
	l.resize(n);
	for (int i = 0; i < n; ++i)
		cin >> v[i];
	for (int i = 0; i < n; ++i) {
		cin >> l[i];
		need_time += l[i] * 1.0l / v[i];
		sum += l[i];
	}
	cin >> m;
	a.push_back(0);
	a.resize(m);
	f.resize(m);
	for (int i = 0; i < m - 1; ++i)
		cin >> a[i + 1];
	for (int i = 0; i < m; ++i)
		cin >> f[i];
	int s, t;
	cin >> q;
	int index;
	for (int i = 0; i < q; ++i) {
		cin >> s >> t;
		index = -1;
		if (n == 1) {
			exceeded_v = sum / (t - s) - v[0];
			if (m > 1)
				index = binsearch(-1, m);
			else if (exceeded_v > 0)
				index = 0;
			if (index != -1)
				cout << f[index];
			else
				cout << 0;
		}
		else if (need_time - t + s > -1e-9)
			cout << f[0];
		else 
			cout << 0;
		cout << '\n';
	}
	return 0;
}