#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC target("sse,sse2,ssse3,sse4,avx,avx2,popcnt")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define len(a) (int)a.size()
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif

using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using ld = long double;

const int MAX     = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const ll MOD      = (ll)(1e9)  + 7;
const ll INF_LL   = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T> inline void init(vector<T> & v, size_t size, T value = 0) { v.assign(size, value); }

template<typename T> inline bool chkmin(T & a, const T & b) { if (a > b) { a = b; return true; } return false; }

template<typename T> inline bool chkmax(T & a, const T & b) { if (a < b) { a = b; return true; } return false; }

void solve();
void boot_up() {
#ifdef LOCAL
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}


int n, x;

signed main() {
    boot_up();

    while (cin >> n >> x) {
        solve();
    }
}

void solve() {
    NEW_TEST;

    int ans = 0;

    for (int c = 1; c <= n; ++c) {
        for (int d = 1; d <= n; ++d) {
            int need = n + c * d;

            for (int div = 1; div * div <= need; ++div) {
                if (need % div == 0) {
                    int scd = need / div;
                    
                    if (div != x && scd != x) {
                        if (div > c && scd > d) {
                            ++ans;
                        }

                        if (div > d && scd > c && div != scd) {
                            ++ans;
                        }
                    }
                }
            }
        }
    }

    cout << ans << '\n';
}
