import sys


def get_val(b, noms):
    ans = 0
    while b != 0:
        l, r = 0, n
        while r - l > 1:
            mid = (l + r) // 2
            if noms[mid] > b:
                r = mid
            else:
                l = mid
        ans += b // noms[l]
        b %= noms[l]
    return ans


def get_max(b, noms, prefs):
    l, r = 0, n
    while r - l > 1:
        mid = (l + r) // 2
        if noms[mid] > b:
            r = mid
        else:
            l = mid
    return prefs[l]


n = int(sys.stdin.readline())
noms = list(map(int, sys.stdin.readline().split()))
prefs = [(0, 0)]
for i in range(1, n):
    val = get_val(noms[i] - 1, noms)
    if val > prefs[i - 1][1]:
        prefs.append((noms[i] - 1, val))
    else:
        prefs.append(prefs[i - 1])
q = int(sys.stdin.readline())
for i in range(q):
    b = int(sys.stdin.readline())
    ans = (0, 0)
    ans = max(ans, get_max(b, noms, prefs))
    val = get_val(b, noms)
    if ans[1] < val:
        ans = (b, val)
    print(*ans)