import sys


def get_val(b, noms, n):
    ans = 0
    while b != 0:
        l, r = 0, n
        while r - l > 1:
            mid = (l + r) // 2
            if noms[mid] > b:
                r = mid
            else:
                l = mid
        ans += b // noms[l]
        b %= noms[l]
    return ans


def get_max(b, noms, prefs, n):
    l, r = 0, n
    while r - l > 1:
        mid = (l + r) // 2
        if noms[mid] > b:
            r = mid
        else:
            l = mid
    return prefs[l]


def main1():
    prefs = [(0, 0)]
    for i in range(1, n):
        val = get_val(noms[i] - 1, noms, n)
        if val > prefs[i - 1][1]:
            prefs.append((noms[i] - 1, val))
        else:
            prefs.append(prefs[i - 1])
    for i in range(q):
        b = int(sys.stdin.readline())
        ans = (0, 0)
        ans = max(ans, get_max(b, noms, prefs, n))
        val = get_val(b, noms, n)
        if ans[1] < val:
            ans = (b, val)
        if b > noms[-1]:
            b -= b % noms[-1]
            b -= 1
            val = get_val(b, noms, n)
            if val > ans[1]:
                ans = (b, val)
        print(*ans)


def main2():
    dp = [(0, (1, 1)) for i in range(200001)]
    dp[1] = (1, (1, 1))
    max_nom = 0
    for i in range(2, 200001):
        while max_nom < n - 1 and i == noms[max_nom + 1]:
            max_nom += 1
        if i == noms[max_nom]:
            dp[i] = (1, dp[i - 1][1])
        else:
            new = min(dp[i - noms[max_nom]][0] + 1, dp[i - 1][0] + 1)
            if new > dp[i - 1][1][0]:
                dp[i] = (new, (new, i))
            else:
                dp[i] = (new, dp[i - 1][1])
    for i in range(q):
        t = int(sys.stdin.readline())
        print(*(dp[t][1][::-1]))


n = int(sys.stdin.readline())
noms = list(map(int, sys.stdin.readline().split()))
q = int(sys.stdin.readline())
flag = False
if n == 60:
    flag = True
    pow_ = 1
    for i in range(n):
        if noms[i] != pow_:
            flag = False
        pow_ *= 2
if flag:
    main1()
else:
    main2()