import sys


def get_val(b, noms, n):
    ans = 0
    while b != 0:
        l, r = 0, n
        while r - l > 1:
            mid = (l + r) // 2
            if noms[mid] > b:
                r = mid
            else:
                l = mid
        ans += b // noms[l]
        b %= noms[l]
    return ans


def get_max(b, noms, prefs, n):
    l, r = 0, n
    while r - l > 1:
        mid = (l + r) // 2
        if noms[mid] > b:
            r = mid
        else:
            l = mid
    return prefs[l]


def main():
    n = int(sys.stdin.readline())
    noms = list(map(int, sys.stdin.readline().split()))
    prefs = [(0, 0)]
    for i in range(1, n):
        val = get_val(noms[i] - 1, noms, n)
        if val > prefs[i - 1][1]:
            prefs.append((noms[i] - 1, val))
        else:
            prefs.append(prefs[i - 1])
    q = int(sys.stdin.readline())
    for i in range(q):
        b = int(sys.stdin.readline())
        ans = (0, 0)
        ans = max(ans, get_max(b, noms, prefs, n))
        val = get_val(b, noms, n)
        if ans[1] < val:
            ans = (b, val)
        for i in range(n):
            b1 = b
            b1 -= b1 % noms[i]
            b1 -= 1
            val = get_val(b1, noms, n)
            if val > ans[1]:
                ans = (b1, val)
        print(*ans)


main()