#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
vector<double> A;
vector<double> V;
vector<int> F;
vector<int> L;
long long min1 = 10000000000000;
vector<int> used;
double v;
int n, m;
void perebor(double c, long long cost) {
    int fl = 0;
    for (int i = 0; i < n; ++i) {
        if (used[i] == 0) {
            fl = 1;
            for (int j = 0; j < m; ++j) {
                used[i] = 1;
                perebor(c + 1 / (V[i] + A[j]), cost + F[j]);
            }
        }
    }
    if (fl == 0) {
        if (1 / c >= v && cost < min1) {
            min1 = cost;
        }
    }

}
int bin_p(double num) {
    int l = 0;
    int r = m;
    while (r - l > 1) {
        int center = (r + l) / 2;
        if (A[center] >= num) {
            r = center;
        } else {
            l = center;
        }
    }
    return l;
}
int bin_p2(double num) {
    int l = 0;
    int r = m;
    while (r - l > 1) {
        int center = (r + l) / 2;
        if (V[center] > num) {
            r = center;
        } else {
            l = center;
        }
    }
    return l;
}
int main() {
    int q;
    double leng;
    leng = 0;
    cin >> n;
    V.resize(n);
    for (int i = 0; i < n ; ++i) {
        cin >> V[i];
    }
    vector<double> L(n);
    for (int i = 0; i < n; ++i) {
        cin >> L[i];
        leng += L[i];
    }
    cin >> m;
    A.resize(m);
    A[0] = 0;
    for (int i = 1; i < m; ++i) {
        cin >> A[i];
    }
    vector<int> F(m);
    for (int i = 0; i < m; ++i) {
        cin >> F[i];
    }
    cin >> q;
    double s, f;
    for (int i = 0; i < q; ++i) {
        cin >> s >> f;
        if (n == 1) {
            v = leng / (f - s);
            double e = v - V[0];
            if (e > 0) {
                cout << F[bin_p(e)] << "\n";
            } else {
                cout << 0 << "\n";
            }
        } else {
            double c = 0;
            int fl = 0;
            v = leng / (f - s);
            for (int i = 0; i < n; ++i) {
                c += L[i] / V[i];
            }
            if (leng / c >= v) {
                cout << 0 << "\n";
            } else {
                perebor(0, 0);
                cout << min1 << "\n";
            }
        }

    }

}
