#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
using namespace std;
int main() {
    long long n, q, b;
    cin >> n;
    vector<long long> a(n);
    int Fl = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (a[i] != pow(2, i)) {
            Fl = 1;
        }
    }
    cin >> q;
    if (Fl == 0 && n == 60) {
        for (int i = 0; i < q; ++i) {
            cin >> b;
            int l = 0;
            int r = n;
            while (r - l > 1) {
                int center = (r + l) / 2;
                if (a[center] - 1 > b) {
                    r = center;
                } else {
                    l = center;
                }
            }
            if (a[l] == 1) {
                cout << "1 1\n";
            } else {
                cout << a[l] - 1 << " " << l << "\n";
            }
        }
        return 0;
    }
    vector<long long> dp(2 * 100001, 0);
    dp[0] = 0;
    for (int i = 1; i < 2 * 100001; ++i) {
        int l = 0;
        int r = n;
        int fl = 0;
        while (r - l > 1) {
            int center = (r + l) / 2;
            if (a[center] == i) {
                dp[i] = 1;
                fl = 1;
                break;
            }
            if (a[center] > i) {
                r = center;
            } else {
                l = center;
            }
        }
        if (fl == 0) {
            dp[i] = dp[i - a[l]] + 1;
        }
    }
    for (int i = 0; i < q; ++i) {
        cin >> b;
        long long max1 = 1;
        long long num = 1;
        for (int i = 1; i < b + 1; ++i) {
            if (dp[i] > max1) {
                num = i;
                max1 = dp[i];
            }
        }
        cout << num << " " << max1 << "\n";
    }
}
