#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,mmx,abm,tune=native")
//#define int long long

using namespace std;

const int MAXN = 52;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector <int> num(n);
    for (int i = 0; i < n; i++)
        cin >> num[i];
    if (n <= 5002) {
        unordered_map <int, int> pos;
        vector <int> kek;
        for (auto el : num)
            kek.push_back(el);
        sort(kek.begin(), kek.end());
        for (int i = 0; i < n; i++)
            pos[kek[i]] = i;
        vector <int> position(n);
        for (int i = 0; i < n; i++)
            position[i] = pos[num[i]];
        vector <long long> ans(n);
        for (int i = 0; i < n; i++) {
            vector <int> bad(5007);
            int res = 0;
            for (int j = i; j < n; j++) {
                int x = position[j];
                if (!bad[x]) {
                    bad[x] = 1;
                    res++;
                }
                ans[j - i] += res;
            }
        }
        for (auto el : ans)
            cout << el << " ";
        cout << "\n";
        return 0;
    }
    assert(false);
    for (auto el : num) {
        if (el > 50)
            assert(false);
    }
    vector <int> all(MAXN);
    for (auto el : num)
        all[el] = 1;
    vector <vector <int> > smth(MAXN);
    for (int i = 0; i < n; i++)
        smth[num[i]].push_back(i);
    for (int i = 0; i < MAXN; i++)
        smth[i].push_back(1e9 + 18);
    vector <long long> pref(n + 4);
    vector <int> nxt(MAXN);
    for (int i = 0; i < n; i++) {
        vector <int> possible = all;
        possible[num[i]] = 0;
        int j = i;
        int delta = 0;
        for (int j = 0; j < MAXN; j++) {
            if (!possible[j])
                continue;
            while (smth[j][nxt[j]] < i)
                nxt[j]++;
        }
        int step = 0;
        while (j < n) {
            step++;
            int best = 1e9 + 7, elem = -1;
            for (int el = 0; el < MAXN; el++) {
                if (!possible[el])
                    continue;
                if (smth[el][nxt[el]] < best) {
                    best = smth[el][nxt[el]];
                    elem = el;
                }
            }
            int len1 = j - i, len2 = best - i - 1;
            delta++;
            if (best < n) {
                int l = len1, r = len2;
                pref[l] += delta;
                pref[r + 1] -= delta;
                possible[elem] = 0;
                j = best;
            }
            else {
                int len3 = n - 1 - i;
                int l = len1, r = len3;
                pref[l] += delta;
                pref[r + 1] -= delta;
                break;
            }
        }
    }
    long long sum = 0;
    for (int i = 0; i < n; i++) {
        sum += pref[i];
        cout << sum << " ";
    }
    cout << "\n";
    return 0;
}
