#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <utility>
#include <algorithm>

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

#define int long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define fx(x, a) for (auto &x : a)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()
#define lb lower_bound
#define ub upper_bound

using namespace std;


typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef vector<ch> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef long long ll;
typedef unsigned long long ull;


const int MX = 200010;
const int INF = 1e9 + 50;
const int MOD = 1000000007;

int v[MX];
int l[MX];
int a[MX];
int f[MX];
signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    fi(0, n)
        cin >> v[i];
    fi(0, n)
        cin >> l[i];
    int m;
    cin >> m;
    fi(1, m )
        cin >> a[i];
    a[0] = 0;
    a[m] = INF;
    fi(1, m + 1)
        cin >> f[i];
    int q;
    cin >> q;
    fi(0, q) {
        int t1, t2;
        cin >> t1 >> t2;
        int delta = t2 - t1;
        if (n == 1) {
            int left = -1;
            int right = m;
            while (right - left > 1) {
                int mid = (right + left) >> 1;
                int vv = v[0] + a[mid];
                if (vv * delta >= l[0])
                    right = mid;
                else
                    left = mid;
            }
            cout << f[right] << '\n';
        }
    }
}