#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <map>
#include <utility>
#include <algorithm>

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#pragma GCC target("popcnt")

#define int  long long
#define fi(a, b) for (int i = a; i < b; ++i)
#define fj(a, b) for (int j = a; j < b; ++j)
#define fk(a, b) for (int k = a; k < b; ++k)
#define fi1(a, b) for (int i = a - 1; i >= b; --i)
#define fj1(a, b) for (int j = a - 1; j >= b; --j)
#define fk1(a, b) for (int k = a - 1; k >= b; --k)
#define rep(i, a, b) for (int i = a; i < b; ++i)
#define rep1(i, a, b) for (int i = a - 1; i >= b; --i)
#define fx(x, a) for (auto &x : a)
#define all(x) x.begin(), x.end()
#define siz(x) (int)x.size()
#define lb lower_bound
#define ub upper_bound

using namespace std;


typedef vector<int> vi;
typedef vector<vi> vvi;
typedef string str;
typedef char ch;
typedef vector<ch> vch;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef long long ll;
typedef unsigned long long ull;


const int MX = 200010;
const int INF = 1e9 + 50;
const int MOD = 1000000007;


int arr[MX];

signed main() {
#ifdef LOCAL
    freopen("C:\\work\\untitled\\input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);


    int n;
    cin >> n;
    bool pws = true;
    fi(0, n) {
        cin >> arr[i];
        if (__builtin_popcount(arr[i]) != 1)
            pws = false;
    }
    int q;
    cin >> q;
    if (pws) {
        fi(0, q) {
            int b;
            cin >> b;
            int h = 0;
            while ((1 << h) - 1 <= b)
                ++h;
            cout << (1 << (h - 1)) - 1<< ' ' <<h - 1 << '\n';
        }
    } else {
        vector<pii> pmax(MX);
        pmax[0] = {-1, -1};
        fi(1, MX) {
            pmax[i] = {0, i};
            int cur = i;
            while (cur) {
                auto it = ub(arr, arr + n, cur);
                --it;
                int cup = *it;
                pmax[i].first += cur / cup;
                cur %= cup;
            }
            pmax[i] = max(pmax[i], pmax[i - 1]);
        }
        fi(0, q) {
            int b;
            cin >> b;
            cout << pmax[b].second << ' ' << pmax[b].first << '\n';
        }
    }

}