#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <numeric>
#include <assert.h>
#include <chrono>
#include <ctime>
#include <random>
using namespace std;

#define all(x) (x).begin(), (x).end()

#define int long long

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int n;
    cin >> n;
    if (n == 0) {
        cout << "YES" << '\n';
        cout << 1 << " " << 1;
        return 0;
    }
    for (int i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            int a = i, b = n / i;
            if (a < b) swap(a, b);
            int x = (a + b) / 2;
            int y = a - x;
            if (x >= 1 && y >= 1 && x * x - y * y == n) {
                cout << "YES" << '\n';
                cout << x << " " << y << endl;
                return 0;
            }
        }
    }
    cout << "NO";
}
