#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <numeric>
#include <assert.h>
#include <chrono>
#include <ctime>
#include <random>
using namespace std;

#define all(x) (x).begin(), (x).end()
#define int long long

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<int> u(n);
    for (int i = 0; i < n; ++i) {
        cin >> u[i];
    }
    vector<int> l(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i];
    }
    int m;
    cin >> m;
    vector<double> lw(m, 0);
    for (int i = 1; i < m; ++i) {
        cin >> lw[i];
    }
    vector<double> f(m + 1);
    for (int i = 1; i <= m; ++i) {
        cin >> f[i];
    }
    int q;
    cin >> q;
    if (m == 1) assert(false);
    while (q--) {
        int s, t;
        cin >> s >> t;
        double tim = t - s;
        int left = -1, right = m;
        while (left + 1 != right) {
            int mid = (left + right) / 2;
            double time = 0;
            for (int i = 0; i < n && time <= tim; ++i) {
                time += l[i] / (lw[mid] + u[i]);
            }
            if (time <= tim) {
                right = mid;
            } else {
                left = mid;
            }
        }
        cout << f[right] << '\n';
    }
}
