#include <iostream>
#include <vector>

#define ll long long
#define dl double long
#define eps 1e-5

using namespace std;

int main() {
    ll n;
    cin >> n;
    vector <ll> v(n), l(n);
    for (ll i = 0; i < n; i++)
        cin >> v[i];
    for (ll i = 0; i < n; i++)
        cin >> l[i];
    ll m;
    cin >> m;
    vector <ll> a(m), f(m);
    a[0] = 0;
    for (ll i = 1; i < m; i++)
        cin >> a[i];
    for (ll i = 0; i < m; i++)
        cin >> f[i];
    int q;
    vector <int> ans;
    cin >> q;
    while (q--) {
        ll in, out;
        cin >> in >> out;
        ll left = 0, right = m, cnt = 0;
        bool tf = false;
        while (left != right || cnt == 0) {
            ll middle = (left + right) / 2;
            dl hm = 0;
            for (ll i = 0; i < n; i++)
                hm += ((dl)l[i] / ( (dl) v[i] + (dl) a[middle]));
            tf = (hm < (dl)out - in + eps);
            if (left == right)
                break;
            if (!tf)
                left = middle + 1;
            else
                right = middle;
            if (left == right)
                cnt++;
        }
        if (tf) {
            if (left == 0)
                cout << "0" << endl;
            else
                cout << f[left - 1] << endl;
        }
        if (!tf) {
            cout << f[left - 1] << endl;
        }
    }
    return 0;
}

/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100
*/