#include <iostream>
#include <unordered_map>
#include <vector>
#include <map>
#include <algorithm>

#define ll long long

using namespace std;

void update(vector <ll>& t, ll v, ll tl, ll tr, ll l, ll r, ll val) {
    if (l > r)
        return;
    if (l == tl && r == tr) {
        t[v] += val;
        return;
    }
    ll tm = (tl + tr) / 2;
    t[v * 2] += t[v];
    t[v * 2 + 1] += t[v];
    t[v] = 0;
    update(t, v * 2, tl, tm, l, min(tm, r), val);
    update(t, v * 2 + 1, tm + 1, tr, max(tm + 1, l), r, val);
}

void create(vector <ll>& t, vector <ll> &a, ll v, ll tl, ll tr) {
    if (tl == tr) {
        a[tl] = t[v];
        return;
    }
    ll tm = (tl + tr) / 2;
    t[v * 2] += t[v];
    t[v * 2 + 1] += t[v];
    t[v] = 0;
    create(t, a, v * 2, tl, tm);
    create(t, a, v * 2 + 1, tm + 1, tr);
}

int main() {
    ll n;
    cin >> n;
    vector <ll> a(n), b(n), ans(n + 1), hm(n + 2);
    vector <ll> strpre(n + 2), revpre(n + 2);
    vector <ll> tans(4 * n + 4), tstrpre(4 * n + 8), trevpre(4 * n + 8);
    unordered_map <ll, vector <ll>> m;
    for (ll i = 0; i < n; i++)
        cin >> a[i];
    for (ll i = 0; i < n; i++) {
        m[a[i]].push_back(i);
    }
    for (auto arr : m) {
        for (ll i = 1; i < arr.second.size(); i++)
            b[arr.second[i]] = arr.second[i - 1];
        b[arr.second[0]] = -1;
    }
    for (ll i = 0; i < n; i++) {
        ll r = i;
        ll l = b[i];
        update(tans, 1, 0, n, 1, n - l - 1, r - l);
        if (r != l + 1) {
            update(tstrpre, 1, 0, n + 1, n - r + 1, n - l - 1, -1);
            update(trevpre, 1, 0, n + 1, 1, r - l - 1, -1);
            ll x = r - l - 1;
            hm[n - l] += x;
        }
    }
    create(tans, ans, 1, 0, n);
    create(tstrpre, strpre, 1, 0, n + 1);
    create(trevpre, revpre, 1, 0, n + 1);
    for (ll i = 1; i <= n; i++)
        strpre[i] += hm[i];
    vector <ll> c(n + 2);
    vector <ll> d(n + 2);
    for (ll i = 1; i <= n; i++)
        c[i] = c[i - 1] + strpre[i];
    for (ll i = n; i >= 1; i--)
        d[i] = d[i + 1] + revpre[i];
    for (ll i = 1; i <= n; i++)
        cout << ans[i] + c[i] + d[i] << " ";
    return 0;
}