#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<map>
typedef long long unsigned ll;
using namespace std;

vector<pair<int, int>>tree;
void add(int x, int L, int R, int LL, int RR, int w) {
	if(LL>=RR)return;
	if (L == LL && R == RR) {
		tree[x].second += w;
		return;
	}
	int m = (L + R) / 2;
	tree[2 * x + 1].second += tree[x].second;
	tree[2 * x + 2].second += tree[x].second;
	tree[x].first += tree[x].second;
	tree[x].second = 0;
	add(2 * x + 1, L, m, LL, min(m, RR), w);
	add(2 * x + 2, m, R, max(m, LL), RR, w);
}
int get1(int x, int L, int R, int pos) {
	if (L >= R)return 0;
	if (L == R - 1) {		
		return tree[x].first+tree[x].second;
	}
	int m = (L + R) / 2;
	tree[2 * x + 1].second += tree[x].second;
	tree[2 * x + 2].second += tree[x].second;
	tree[x].first += tree[x].second;
	tree[x].second = 0;
	if (pos < m) {
		return get1(2 * x + 1, L, m, pos);
	}
	else {
		return get1(2 * x + 2, m, R, pos);
	}
}
void solve() {
	int n; cin >> n;
	vector<pair<int, int>>mas(n);
	tree.resize(4 * n);
	for (int i = 0; i < n; i++) {
		cin >> mas[i].first;
		mas[i].second = i;
	}
	sort(mas.begin(), mas.end());
	vector<pair<int, int>>otr;
	for (int i = 0; i < n - 1; i++) {
		if (mas[i].first == mas[i + 1].first) {
			otr.push_back({ mas[i].second, mas[i + 1].second });
		}
	}
	for (int i = 0; i < otr.size(); i++) {
		int len = n - (otr[i].second - otr[i].first + 1)+1;
		int del = min(len/2, n - otr[i].second);
		add(0, 0, n, otr[i].second - otr[i].first, min(n, otr[i].second - otr[i].first+del), 1);
		add(0, 0, n, max(0, n - del+2), n, -1);
	}
	vector<int>ans(n);
	for (int i = 0; i < n; i++) {
		ans[i] = (i + 1) * (n - i);
	}
	int sum = 0;
	for (int i = 0; i < n; i++) {
		sum += get1(0, 0, n, i);
		ans[i] -= sum;
		cout << ans[i] << ' ';
	}
	
}

int main() {
	ios_base::sync_with_stdio(false);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	solve();
}