#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<cmath>
#include<algorithm>
#include<vector>
#include<map>
#include<unordered_map>
typedef long long unsigned ll;
using namespace std;
int n; 
vector<ll>a;
unordered_map<ll, pair<ll, ll>>mem;
pair<ll, ll> rec(ll b) {
	if (mem.find(b) != mem.end()) {
		return mem[b];
	}
	if (b < a[1]) {
		return { b, b };
	}
	int ind = lower_bound(a.begin(), a.end(), b) - a.begin();
	if (ind<a.size() && a[ind] == b) {
		return mem[b] = rec(b - 1);
	}
	ind--;
	ll k = b / a[ind];	
	auto p1 = rec(a[ind] - 1);
	auto p2 = rec(b - a[ind] * k);
	if (p1.second + k - 1 > p2.second + k) {
		return mem[b] = { p1.first + a[ind] * (k - 1), p1.second + k - 1 };
	}
	else {
		return mem[b] = { p2.first + a[ind]*k, p2.second + k };
	}	
}

void solve() {
	cin >> n;

	a.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	int q; cin >> q;
	for (int q1 = 0; q1 < q; q1++) {
		ll b; cin >> b;
		if (n == 1) {
			cout << b << ' ' << b << '\n';
		}
		else {
			auto p = rec(b);
			cout << p.first << ' ' << p.second << '\n';
		}
	}

}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	solve();
}