#pragma GCC optimize("O3")
#include <iostream>
#include <algorithm>
#include <vector>
#include <array>

long long n;

long long gcd(long long a, long long b)
{
    while (a != 0)
    {
        b %= a;
        if (a > b)
        {
            std::swap(a, b);
        }
    }
    return b;
}

int main()
{
    std::ios_base::sync_with_stdio(false);
    std::cout.precision(10);
    std::cin >> n;
    if ((n % 2) && (n != 1))
    {
        std::cout << "Yes\n" << (n / 2 + 1) << ' ' << (n / 2);
        return 0;
    }
    else
    {
        if ((n > 5) && ((n % 4) == 0))
        {
            
            std::cout << "Yes\n" << ((n / 2 + 1)/2 + 1) << ' ' << ((n / 2 - 1) / 2);
            return 0;
        }
    }
    if (n == 0)
    {
        std::cout << "Yes\n" << 1 << ' ' << 1;
        return 0;
    }
    for (long long i = 1; (i * i) < n; i++)
    {
        if ((n % i) == 0)
        {
            long long d1 = i;
            long long d2 = n / i;
            if (((d1 - d2) % 2) == 0)
            {
                long long d = (d2 - d1) / 2;
                std::cout << "Yes\n" << (d2-d)  << ' ' << (d);
                return 0;
            }
        }
    }

    std::cout << "No";
    return 0;
}