#include <cstring>
#include <string>
#include <iostream>
#include <vector>
#include <assert.h>
#include <algorithm>

using namespace std;

struct Func {
    int a, b, op;
};

bool compa(const Func& x, const Func& y) {
    return x.a < y.a;
}
bool compb(const Func& x, const Func& y) {
    return x.b < y.b;
}

int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);
    int n, m, s;
    cin >> n >> m >> s;
    vector<vector<Func>> f(m, vector<Func>(n - 1));
    bool suc = true;
    for (int i = 0; i < m; ++i)
        for (int j = 0; j < n - 1; ++j)
        {
            cin >> f[i][j].a >> f[i][j].b >> f[i][j].op;
            suc = suc && f[i][j].op == 1;
        }
    vector<vector<int>> t(m, vector<int>(n));
    for (int i = 0; i < m; ++i)
        for (int j = 0; j < n; ++j)
            cin >> t[i][j];
    if (suc)
    {
        for (int i = 0; i < n - 1; ++i)
        {
            cout << m << ' ';
        }
        cout << s << '\n';
        return 0;
    }
    if (n > 10 || n == 1) {
        for (int i = 0; i < n; ++i)
        {
            cout << s << ' ';
        }
        return 0;
    }
    vector<vector<bool>> tr(m, vector<bool>(2 * n - 1));
    if (n > 2)
    {
        vector<int> tern(n + 1);
        tern[0] = 1;
        for (int i = 1; i <= n; ++i)
            tern[i] = tern[i - 1] * 3;
        for (int mask = 0; mask < tern[n]; ++mask)
        {
            for (int i = 0; i < m; ++i)
                for (int j = 0; j < n; ++j)
                    tr[i][j] = (mask / tern[j]) % 3 > t[i][j];
            for (int i = 0; i < m; ++i)
                for (int j = 0; j < n - 1; ++j)
                {
                    if (f[i][j].op == 1)
                        tr[i][j + n] = tr[i][f[i][j].a - 1] && tr[i][f[i][j].b - 1];
                    else
                        tr[i][j + n] = tr[i][f[i][j].a - 1] || tr[i][f[i][j].b - 1];
                }
            int ans = 0;
            for (int i = 0; i < m; ++i)
                ans += tr[i][2 * n - 2];
            if (ans == s)
            {
                for (int i = 0; i < n; ++i)
                {
                    cout << mask % 3 << ' ';
                    mask /= 3;
                }
                cout << '\n';
                return 0;
            }
        }
        return 0;
    }
    if (n == 2)
    {
        vector<Func> ands;
        vector<Func> ors;
        for (int i = 0; i < m; ++i)
        {
            if (f[i][0].op == 1)
            {
                ands.push_back({ t[i][0], t[i][1], 1 });
            }
            else
            {
                ors.push_back({ t[i][0], t[i][1], 2 });
            }
        }
        sort(ors.begin(), ors.end(), compa);
        sort(ands.begin(), ands.end(), compa);
        int ans = ors.size();
        ans = min(ans, s);
        int x = ors[ans - 1].a + 1;
        int y = 0;
        ans = s - ans;
        if (ans != 0)
            x = m;
        for (int i = 0; i < ans; ++i)
        {
            y = max(ands[i].b + 1, y);
        }
        int check = 0;
        for (int i = 0; i < m; ++i)
        {
            if (f[i][0].op == 1)
            {
                check += (t[i][0] < x) && (t[i][1] < y);
            }
            else
            {
                check += (t[i][0] < x) || (t[i][1] < y);
            }
        }
        assert(check == s);
        cout << x << ' ' << y << '\n';
        return 0;
    }
    return 0;
}