#include <cstring>
#include <string>
#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>

#define int long long
#define x first
#define y second

using namespace std;

/*
Node tr[1000000];
int SZ = 0;

struct Node
{
    int l, r, lbond, rbond, pushed = 0, s = 0;

    void push(int x)
    {
        pushed += x;
    }

    void push()
    {
        if (rbond - lbond == 1)
            return;
        tr[l].push(pushed);
        tr[r].push(pushed);
    }

    int get()
    {
        return s + pushed * (rbond - lbond);
    }

    void update()
    {
        if (rbond - lbond == 1)
            return;
        s = tr[l].get() + tr[r].get();
    }



    int get(int x, int y)
    {
        if (rbond <= x || y <= lbond)
            return 0;
        if (x <= lbond && rbond <= y)
            return this->get();
        push();
        update();
        return tr[l].get(x, y) + tr[r].get(x, y);
    }

    void update(int x, int y, int z)
    {
        if (rbond <= x || y <= lbond)
            return;
        if (x <= lbond && rbond <= y)
            return push(z);
        push();
        tr[++SZ] = tr[l];
        l = SZ - 1;
        tr[++SZ] = tr[r];
        r = SZ - 1;
        tr[l].update(x, y, z);
        tr[r].update(x, y, z);
        update();
    }
};*/



int32_t main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(0);
    //while (true)
    //{
        int n;
        int tmp;
        int ans;
        cin >> n;
        //n = rand() % 7 + 4;
        vector<int> a(n);
        for (int i = 0; i < n; ++i)
        {
            cin >> a[i];
            //a[i] = rand() % (int)1e9;
        }
        vector<vector<int>> dp(n, vector<int>(4, -(int)1e18));
        dp[0][1] = a[0];
        dp[1][2] = a[0] + a[1];
        dp[1][0] = a[1];
        dp[2][3] = a[0] + a[1] + a[2];
        dp[2][1] = a[0] + a[2];
        dp[2][0] = a[1] + a[2];
        dp[3][0] = a[1] + a[2] + a[3];
        dp[3][1] = a[0] + a[2] + a[3];
        dp[3][2] = a[0] + a[1] + a[3];
        for (int i = 1; i < 4; ++i)
        {
            for (int it = 0; it < 4; ++it)
                dp[i][it] = max(dp[i][it], dp[i - 1][it]);
        }
        for (int i = 4; i < n; ++i)
        {
            tmp = 0;
            for (int it = 0; it < 4; ++it)
                dp[i][it] = max(dp[i][it], dp[i - 1][it]);
            for (int j = 0; j < 3; ++j)
            {
                tmp += a[i - j];
                if (i != n - 1)
                    for (int it = 0; it < 4; ++it)
                        dp[i][it] = max(dp[i][it], dp[i - j - 2][it] + tmp);
                else
                    for (int it = 0; it < 3 - j; ++it)
                        dp[i][it] = max(dp[i][it], dp[i - j - 2][it] + tmp);

            }
        }
        ans = 0;
            for (int j = 0; j < 4; ++j)
                ans = max(ans, dp[n - 1][j]);
        cout << ans << '\n';
        /*
        int sans = 0;
        int bmask = 0;
        for (int mask = 0; mask < (1 << n); ++mask)
        {
            int seq = 0, mseq = 0;
            for (int i = 0; i < 2 * n; ++i)
            {
                if ((1 << (i % n)) & mask)
                    ++seq;
                else
                    seq = 0;
                mseq = max(seq, mseq);
            }
            int tmp = 0;
            for (int i = 0; i < n; ++i)
                if ((1 << i) & mask)
                    tmp += a[i];
            if (tmp > sans&& mseq < 4)
            {
                bmask = mask;
                sans = tmp;
            }
        }
        cout << sans << '\n';
        */
        /*
        if (sans != ans)
        {
            cout << "WA\n" << n << '\n';
            for (int i = 0; i < n; ++i)
            {
                cout << a[i] << ' ';
            }
            cout << '\n';
            break;
        }
        cout << "OK\n";
        */
        ///*
        int q;
        //q = 0;
        cin >> q;
        for (int k = 0; k < q; ++k)
        {
            int p, v;
            cin >> p >> v;
            a[p - 1] = v;
            dp.assign(n, vector<int>(4, -(int)1e18));
            dp[0][1] = a[0];
            dp[1][2] = a[0] + a[1];
            dp[1][0] = a[1];
            dp[2][3] = a[0] + a[1] + a[2];
            dp[2][1] = a[0] + a[2];
            dp[2][0] = a[1] + a[2];
            dp[3][0] = a[1] + a[2] + a[3];
            dp[3][1] = a[0] + a[2] + a[3];
            dp[3][2] = a[0] + a[1] + a[3];
            for (int i = 1; i < 4; ++i)
            {
                for (int it = 0; it < 4; ++it)
                    dp[i][it] = max(dp[i][it], dp[i - 1][it]);
            }
            for (int i = 4; i < n; ++i)
            {
                tmp = 0;
                for (int it = 0; it < 4; ++it)
                    dp[i][it] = max(dp[i][it], dp[i - 1][it]);
                for (int j = 0; j < 3; ++j)
                {
                    tmp += a[i - j];
                    if (i != n - 1)
                        for (int it = 0; it < 4; ++it)
                            dp[i][it] = max(dp[i][it], dp[i - j - 2][it] + tmp);
                    else
                        for (int it = 0; it < 3 - j; ++it)
                            dp[i][it] = max(dp[i][it], dp[i - j - 2][it] + tmp);

                }
            }
            ans = 0;
            for (int j = 0; j < 4; ++j)
                ans = max(ans, dp[n - 1][j]);
            cout << ans << '\n';
            /*
            int sans = 0;
            int bmask = 0;
            for (int mask = 0; mask < (1 << n); ++mask)
            {
                int seq = 0, mseq = 0;
                for (int i = 0; i < 2 * n; ++i)
                {
                    if ((1 << (i % n)) & mask)
                        ++seq;
                    else
                        seq = 0;
                    mseq = max(seq, mseq);
                }
                int tmp = 0;
                for (int i = 0; i < n; ++i)
                    if ((1 << i) & mask)
                        tmp += a[i];
                if (tmp > sans&& mseq < 4)
                {
                    bmask = mask;
                    sans = tmp;
                }
            }
            cout << sans << '\n';
            */        
        }
        //*/
    //}
}