#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;
vector<int> v;
vector<int> tree;
void build(int p, int l, int r)
{
    if (r - l == 1)
    {
        tree[p] = v[l];
    }
    int m = (l + r) / 2;
    build(2 * p + 1, l, m);
    build(2 * p + 1, m, r);
    tree[p] = tree[2 * p + 1] + tree[2 * p + 2];
}
int get(int p, int l, int r, int ql, int qr)
{
    if (l >= qr || r <= ql)
    {
        return 1e9;
    }
    if (l >= qr && r <= qr)
    {
        return tree[p];
    }
    int m = (l + r) / 2;
    return get(2 * p + 1, l, m, ql, qr) + get(2 * p + 2, m, r, ql, qr);
}
void upd(int p, int l, int r, int id, int val)
{
    if (r - l == 1)
    {
        tree[p] += val;
        return;
    }
    int m = (l + r) / 2;
    if (m >= id)
    {
        return upd(2 * p + 1, l, m, id, val);
    }
    return upd(2 * p + 2, m, r, id, val);
}
int main() {
    int n;
    cin >> n;
    v.resize(n);
    vector<pair<int, int>> w(n);
    int id = 1;
    map<int, int> mp;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        if (mp[v[i]] == 0)
        {
            mp[v[i]] = id;
            id++;
        }
    }
    for (int i = 0; i < n; i++)
    {
        v[i] = mp[v[i]];
    }
    vector<int> same(n);
    same[0] = 1;
    for (int i = 1; i < n; i++)
    {
        if (v[i] == v[i - 1])
        {
            same[i] = same[i - 1] + 1;
        }
        else
        {
            same[i] = 1;
        }
    }
    vector<int> ans(n + 1);
    for (int i = 0; i < n; i++)
    {
        vector<int> cnt(mp.size() + 1);
        int now = 0;
        for (int j = i; j >= 0;)
        {
            if (cnt[v[j]] == 0)
            {
                now++;
                cnt[v[j]] = 1;
            }
            ans[i - j] += now;
            ans[i - j + same[j]] -= now;
            j -= same[j];
        }
    }
    int now =0;
    for (int i = 0; i < n; i++)
    {
        now += ans[i];
        cout << now << ' ';
    }
}
