#include <iostream>
#include <algorithm>

using namespace std;

bool cmp(pair <int, int> a, pair <int, int> b) {
	return a.first * (b.second * b.second) > b.first * (a.second * a.second);
}

int main()
{
	int n;
	cin >> n;
	pair <int, int>* peaces = new pair <int, int>[n];
	for (int i = 0; i < n; i++) {
		cin >> peaces[i].second;
	}
	double first_time = 0;
	for (int i = 0; i < n; i++) {
		cin >> peaces[i].first;
		first_time += (double)peaces[i].first / peaces[i].second;
	}
	sort(peaces, peaces + n, cmp);
	int m;
	cin >> m;
	if (m != 1) {
		int* a = new int[m - 1];
		for (int i = 0; i < m - 1; i++) {
			cin >> a[i];
		}
		int* f = new int[m];
		for (int i = 0; i < m; i++) {
			cin >> f[i];
		}
		int q;
		cin >> q;
		for (int i = 0; i < q; i++) {
			int s, t;
			cin >> s >> t;
			int need = t - s;
			int left = -1;
			int right = f[m - 1] * n;
			while (right - left > 1) {
				int mid = (right + left) / 2;
				int now = mid;
				double time = 0;
				for (int i = 0; i < n; i++) {
					int j = upper_bound(f, f + m, now) - f;
					if (j == m || f[j] > now) {
						j--;
					}
					if (j != -1 && j != m - 1) {
						time += (double)peaces[i].first / (peaces[i].second + a[j]);
						now -= f[j];
					}
					else if (j == -1) {
						time += (double)peaces[i].first / (peaces[i].second);
					}
					else {
						now -= f[j];
					}
				}
				if (time <= need) {
					right = mid - now;
				}
				else {
					left = mid;
				}
			}
			cout << right << endl;
		}
	}
	if (m == 1) {
		int f;
		cin >> f;
		int q;
		cin >> q;
		int* times = new int[n];
		for (int i = 0; i < n; i++) {
			times[i] = (double)peaces[i].first / peaces[i].second;
		}
		sort(times, times + n);
		for (int i = 0; i < q; i++) {
			int s, t;
			cin >> s >> t;
			int need = t - s;
			int j = 0;
			int time = 0;
			while (time <= need && j < n) {
				time += times[j];
				j++;
			}
			if (time <= need) {
				cout << 0 << endl;
			}
			else {
				cout << f * (n - j + 1) << endl;
			}
		}
	}

}
