#include <bits/stdc++.h>

#define int long long

using namespace std;

struct treap{
    vector <int> a;
    vector <int> add;
    treap(int n){
        a.resize(4 * n);
        add.resize(4 * n);
    }
    void push(int v, int vl, int vr){
         if (vl == vr - 1){
             a[v] += add[v];
             add[v] = 0;
             return;
         }
        add[2 * v + 1] += add[v];
        add[2 * v + 2] += add[v];
        add[v] = 0;
    }
    int get(int v, int vl, int vr, int pos){
        push(v, vl, vr);
        if (pos < vl || vr <= pos)
            return 0;
        if (vl == pos && vr == vl + 1)
            return a[v];
        int m = (vl + vr) / 2;
        return get(2 * v + 1, vl, m, pos) + get(2 * v + 2, m, vr, pos);
    }
    void inc(int v, int vl, int vr, int l, int r, int x){
        if (vr <= l || r <= vl)
            return;
        if (l <= vl && vr <= r){
            add[v] += x;
            return;
        }
        int m = (vl + vr) / 2;
        inc(2 * v + 1, vl, m, l, r, x);
        inc(2 * v + 2, m, vr, l, r, x);
    }
};

signed main() {
    int n;
    cin >> n;
    vector <int> a;
    treap k = treap(n);
    treap b = treap(n);
    for (int i = 0; i < n; ++i) {
        int x;
         cin >> x;
         a.push_back(x);
    }
    map <int, int> mapa;
    int nxt[n];
    for (int l = n - 1; l >= 0; --l) {
        nxt[l] = mapa[a[l]];
        mapa[a[l]] = l;
    }

    for (int m = 0; m < n; ++m) {
        int l = m;
        int r = nxt[m];
        if (r == 0)
            continue;
        int a = l;
        int b1 = n - 1 - r;
        int c = r - l;
        k.inc(0, 0, n, c, c + min(a, b1) + 1, 1);
        b.inc(0, 0, n, c, c + min(a, b1) + 1, c - 1);
        b.inc(0, 0, n, c + min(a, b1) + 1, c + max(a, b1) + 1, -min(a, b1) - 1);
        k.inc(0, 0, n, c + max(a, b1) + 1, n, -1);
        b.inc(0, 0, n, c + max(a, b1) + 1, n,  - n);
        //cout << k.get(0, 0, n, 2) << " " << b.get(0, 0, n, 2) << endl;
    }

    for (int j = 0; j < n; ++j) {
        int res = (n - j) * (j + 1);
        res -=  j * k.get(0, 0, n, j);
        res +=  b.get(0, 0, n, j);
       // cout << k.get(0, 0, n, j) << " " << b.get(0, 0, n, j) << endl;
        cout << res << " " ;
    }
}
