#include <bits/stdc++.h>

#define int long long
#define pb push_back
#define ppb pop_back
#define pf push_front
#define ppf pop_front
#define ins insert
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ff first
#define ss second
#define pii pair<int, int>
#define ld long double

using namespace std;

mt19937 rnd(time(nullptr));

const int INF = 1e18, N = 2e5 + 10;
int rmq[4 * N];
pii mod1[4 * N], mod2[4 * N];
int mod3[4 * N], ans[N];

void push(int t, int l, int r) {
    if (l + 1 == r) {
        rmq[t] += mod1[t].ff + mod2[t].ff + mod3[t];
    } else {
        int m = (l + r) / 2;
        int s1, s2, dt;

        mod3[t * 2 + 1] += mod3[t];
        mod3[t * 2 + 2] += mod3[t];

        dt = mod1[t].ss;
        s1 = mod1[t].ff;
        s2 = s1 + (m - l) * dt;
        mod1[t * 2 + 1].ff += s1;
        mod1[t * 2 + 1].ss += dt;
        mod1[t * 2 + 2].ff += s2;
        mod1[t * 2 + 2].ss += dt;


        dt = mod2[t].ss;
        s1 = mod2[t].ff;
        s2 = s1 + (m - l) * dt;
        mod2[t * 2 + 1].ff += s1;
        mod2[t * 2 + 1].ss += dt;
        mod2[t * 2 + 2].ff += s2;
        mod2[t * 2 + 2].ss += dt;

    }
    mod1[t].ff = 0;
    mod1[t].ss = 0;
    mod2[t].ff = 0;
    mod2[t].ss = 0;
    mod3[t] = 0;
}

void upd(int t, int l, int r, int x, int y, int i, int s, int dt) {
    push(t, l, r);
    if (y <= l || r <= x) {
        return;
    }
    if (x <= l && r <= y) {
        s += (l - x) * dt;
        if (dt == 1) {
            mod1[t].ff += s;
            mod1[t].ss += dt;
        } else if (dt == -1) {
            mod2[t].ff += s;
            mod2[t].ss += dt;
        } else {
            mod3[t] += s;
        }
        push(t, l, r);
        return;
    }
    int m = (l + r) / 2;
    upd(t * 2 + 1, l, m, x, y, i, s, dt);
    upd(t * 2 + 2, m, r, x, y, i, s, dt);
}

void build(int t, int l, int r) {
    push(t, l, r);
    if (l + 1 != r) {
        int m = (l + r) / 2;
        build(t * 2 + 1, l, m);
        build(t * 2 + 2, m, r);
    } else {
        ans[l] = rmq[t];
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> a(n);
    set<int> st;
    map<int, int> mp;
    int id = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        st.insert(a[i]);
    }
    for (int elem : st) {
        mp[elem] = id;
        id++;
    }
    for (int i = 0; i < n; i++) {
        a[i] = mp[a[i]];
    }
    vector<int> last(n + 10, -1);
    vector<int> rt(n + 10, n - 1);
    for (int i = 0; i < n; i++) {
        if (last[a[i]] == -1) {
            last[a[i]] = i;
        } else {
            int j = last[a[i]];
            rt[j] = i - 1;
            last[a[i]] = i;
        }
    }
    for (int i = 0; i < n; i++) {
            //cout << i << "\n";
        int r = rt[i] + 1, max_vl = min(r - i, i + 1);
        int end1 = max_vl, end2 = r - max_vl + 1;
        if (2 * max_vl > r) {
            end1 = r / 2;
            end2 = r / 2 + 1;
        }
        int v2 = (r - end2 + 1);
        /*int cur = 1;
        for (int j = 1; j <= end1; j++) {
            ans[j] += cur;
            cur++;
        }
        cur = 1;
        for (int j = r; j >= end2; j--) {
            ans[j] += cur;
            cur++;        int r = rt[i] + 1, max_vl = min(r - i, i + 1);
        int end1 = max_vl, end2 = r - max_vl + 1;
        if (2 * max_vl > r) {
            end1 = r / 2;
            end2 = r / 2 + 1;
        }
        }
        cur = max_vl;
        for (int j = end1 + 1; j < end2; j++) {
            ans[j] += cur;
        }*/
       // cout << r << ' ' << end1 << ' ' << end2 << ' ' << v2 << "\n";
        upd(0, 0, N, 1, end1 + 1, 1, 1, 1);
        upd(0, 0, N, end2, r + 1, end2, v2, -1);
        if (end1 + 1 <= end2 - 1) {
            upd(0, 0, N, end1 + 1, end2, end1 + 1, max_vl, 0);
        }
        //build(0, 0, n + 1);
        /*for (int i = 1; i <= n; i++) {
            cout << ans[i] << ' ';
        }
        cout << "\n";
        cout << "=====\n";*/
    }
    build(0, 0, N);
    for (int i = 1; i <= n; i++) {
        cout << ans[i] << ' ';
    }
    return 0;
}
