#pragma GCC optimize("unroll-loops,inline,fast-math,no-stack-protector")
#pragma GCC optimize("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,abm,mmx,avx,avx2,popcnt,tune=native")
#pragma comment(linker, "/STACK:36777216")
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <ctime>
#include <random>
#include <chrono>
#include <queue>
#include <deque>
#include <stack>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <cstdio>
#include <iostream>
using namespace std;
#define fastio() ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define sp system("pause");
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define rev(x) reverse(all(x));
#define vin(v) for(auto &i:v)cin>>i;
#define vout(v,c) for(auto i:v)cout<<i<<c;
#define pbc push_back
#define sqr(x) (x)*(x)
#define pob pop_back()
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
int MAXN = 2e5 + 1;
const ld EPS = 1e-9;
const int inf = 1e9;
const ll INF = 1e18;
const ld PI = acos(-1.0);
const int MOD7 = 1000000007;
const int MOD9 = 1000000009;
const int fftmod = 998244353;
int MOD;
mt19937 rnd(time(0));
vector<ll> hashpows{ 37,41,43,179,229,29 };
#define int ll
vector<int> ans;
//2:15 -   200      
vector<int> t1(4 * MAXN);
struct query
{
	int type, l, r, x;
};
vector<int> add1(4 * MAXN);
void push1(int v, int l, int r)
{
	if (l != r - 1)
	{
		add1[2 * v + 1] += add1[v];
		add1[2 * v + 2] += add1[v];
	}
	t1[v] += (r - l) * add1[v];
	add1[v] = 0;
}
void upd1(int v, int l, int r, int ql, int qr, int x)
{
	push1(v, l, r);
	if (l >= qr || ql >= r) return;
	if (l >= ql && r <= qr)
	{
		add1[v] += x;
		push1(v, l, r);
		return;
	}
	upd1(2 * v + 1, l, (l + r) / 2, ql, qr, x);
	upd1(2 * v + 2, (l + r) / 2, r, ql, qr, x);
	t1[v] = t1[2 * v + 1] + t1[2 * v + 2];
}
int get1(int v, int l, int r, int ql, int qr)
{
	push1(v, l, r);
	if (l >= qr || ql >= r) return 0;
	if (l >= ql && r <= qr)
	{
		return t1[v];
	}
	int g1 = get1(2 * v + 1, l, (l + r) / 2, ql, qr);
	int g2 = get1(2 * v + 2, (l + r) / 2, r, ql, qr);
	return g1 + g2;
}
vector<int> t2(4 * MAXN);
vector<pair<int, int>> add2(4 * MAXN);
void push2(int v, int l, int r)
{
	if (!add2[v].second) return;
	if (l != r - 1)
	{
		int mm = (l + r) / 2;
		add2[2 * v + 1].first += add2[v].first;
		add2[2 * v + 1].second += add2[v].second;
		add2[2 * v + 2].second += add2[v].second;
		add2[2 * v + 2].first += add2[v].second * (mm - l) + add2[v].first;
		//add2[2 * v + 2] += add2[v] + mm - l;
	}
	t2[v] += add2[v].first * (r - l);
	int lasd = r - l;
	t2[v] += add2[v].second * lasd * (lasd - 1) / 2;
	add2[v].first = 0;
	add2[v].second = 0;
}
void upd2(int v, int l, int r, int ql, int qr, int x)
{
	push2(v, l, r);
	if (l >= qr || ql >= r) return;
	if (l >= ql && r <= qr)
	{
		add2[v].first += x * (l - ql + 1);
		add2[v].second += x;
		push2(v, l, r);
		return;
	}
	int mm = (l + r) / 2;
	upd2(2 * v + 1, l, (l + r) / 2, ql, qr, x);
	upd2(2 * v + 2, (l + r) / 2, r, ql, qr, x);
	t2[v] = t2[2 * v + 1] + t2[2 * v + 2];
}
int get2(int v, int l, int r, int ql, int qr)
{
	push2(v, l, r);
	if (l >= qr || ql >= r) return 0;
	if (l >= ql && r <= qr)
	{
		return t2[v];
	}
	int g1 = get2(2 * v + 1, l, (l + r) / 2, ql, qr);
	int g2 = get2(2 * v + 2, (l + r) / 2, r, ql, qr);
	return g1 + g2;
}
signed main()
{
	fastio();
	int n;
	cin >> n;

	MAXN = 2e5 + 1;
	vector<int> a(n);
	vin(a);
	/*int q;
	cin >> q;
	while (q--)
	{
		int t;
		cin >> t;
		if (t == 1)
		{
			int l, r, x;
			cin >> l >> r;
			l--;
			upd2(0, 0, MAXN, l, r, 1);
		}
		else
		{
			int x;
			cin >> x;
			cout << get2(0, 0, MAXN, x - 1, x) << endl;
		}
	}
	sp;*/
	ans.resize(n + 1);
	for (int i = 1; i <= n; ++i)
	{
		ans[i] = i * (n - i + 1);
	}
	map<int, int> was;
	vector<int> nxt(n + 1);
	for (int i = n - 1; i >= 0; --i)
	{
		if (was.count(a[i]))
			nxt[i] = was[a[i]];
		was[a[i]] = i;
	}
	/*for (int i = 0; i < n; ++i)
	{
		cout << nxt[i] << ' ';
	}
	cout << endl;*/
	for (int i = 0; i < n; ++i)
	{
		int xx = nxt[i];
		if (xx == 0) continue;
		int dd = xx - i + 1;
		int lol = min(i + 1, n - xx);
		//		for (int j = 1; j <= lol; ++j)
		//		{
			//		ans[dd + j - 1] -= j;
			//	}
		upd2(0, 0, MAXN, dd, dd + lol, 1);
		for (int xx = n; xx > n - lol + 1; --xx)
		{
			ans[xx] -= n - xx + 1;
		}
		upd1(0, 0, MAXN, dd + lol, n - lol + 2, -lol);
		//for (int j = dd + lol; j <= n - lol + 1; ++j) ans[j] -= lol;
	}
	for (int i = 1; i <= n; ++i)
	{
		ans[i] += get1(0, 0, MAXN, i, i + 1);
		ans[i] -= get2(0, 0, MAXN, i, i + 1);
		cout << ans[i] << ' ';
	}
	//sp;
}