#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) fro (int i = n - 1; i >= 0; --i)
#define allar(a, n) a, a + n
#define allv(a) a.begin(), a.end()
#define mp make_pair
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

#include <algorithm>
#include <string.h>
#include <iostream>
#include <math.h>
#include <string>
#include <random>
#include <chrono>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const db EPS = 1e-7;

const int N = (int)10;
const int M = (int)1e5;

int n, v[N], l[N], m, a[M], f[M], q;

bool check(db e, db all_time) {
	db cur_time = 0;
	rep(n, i) {
		db max_v = v[i] + e;
		cur_time += l[i] / max_v;
	}
	if (cur_time - all_time > EPS) {
		return false;
	}
	return true;
}

int solve(int s, int t) {
	db T = t - s;
	db max_e = 0;
	rep(n, i) {
		db cur_v = n * l[i] / T;
		max_e = max(max_e, cur_v - v[i]);
	}
	db l = 0, r = max_e;
	rep(100, it) {
		db m = (l + r) / 2;
		if (check(m, T)) {
			r = m;
		} else {
			l = m;
		}
	}
	if (abs(l) < EPS) {
		return 0;
	}
	int ind = lower_bound(allar(a, m - 1), l) - a;
	return f[ind];
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	scanf("%d", &n);
	rep(n, i) {
		scanf("%d", &v[i]);
	}
	rep(n, i) {
		scanf("%d", &l[i]);
	}
	scanf("%d", &m);
	rep(m - 1, i) {
		scanf("%d", &a[i]);
	}
	rep(m, i) {
		scanf("%d", &f[i]);
	}
	scanf("%d", &q);
	rep(q, i) {
		int s, t;
		scanf("%d%d", &s, &t);
		printf("%d\n", solve(s, t));
	}
	return 0;
}