#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allar(a, n) a, a + n
#define allv(a) a.begin(), a.end()
#define mp make_pair
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

#include <algorithm>
#include <string.h>
#include <iostream>
#include <math.h>
#include <string>
#include <random>
#include <chrono>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const db EPS = 1e-7;

const int N = (int)3e5;

struct prog {
	int a, b, op;
};

int n, m, s;
vector <int> z;
vector <vector <int>> a;
vector <vector <bool>> val;
vector <vector <prog>> blmp;

bool recalc(int ind) {
	rep(n, i) {
		val[ind][i] = (a[ind][i] < z[i]);
	}
	rep(n - 1, i) {
		if (blmp[ind][i].op == 1) {
			val[ind][n + i] = (val[ind][blmp[ind][i].a] & val[ind][blmp[ind][i].b]);
		} else {
			val[ind][n + i] = (val[ind][blmp[ind][i].a] | val[ind][blmp[ind][i].b]);
		}
	}
	return val[ind][2 * n - 2];
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	scanf("%d%d%d", &n, &m, &s);
	blmp.resize(m);
	z.resize(n, 0);
	rep(m, i) {
		blmp[i].resize(n - 1);
		rep(n - 1, j) {
			scanf("%d%d%d", &blmp[i][j].a, &blmp[i][j].b, &blmp[i][j].op);
			--blmp[i][j].a, --blmp[i][j].b;
		}
	}
	a.resize(m);
	rep(m, i) {
		a[i].resize(n);
		rep(n, j) {
			scanf("%d", &a[i][j]);
		}
	}
	val.resize(m, vector <bool>(2 * n - 1, false));
	rep(n, i) {
		if (s == 0) {
			break;
		}
		rep(m, j) {
			if (s == 0) {
				break;
			}
			int ind = -1;
			rep(m, k) {
				if (a[k][i] == j) {
					ind = k;
					break;
				}
			}
			++z[i];
			if (!val[ind][2 * n - 2] && recalc(ind)) {
				--s;
			}
		}
	}
	rep(n, i) {
		printf("%d ", z[i]);
	}
	return 0;
}