#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allar(a, n) a, a + n
#define allv(a) a.begin(), a.end()
#define mp make_pair
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

#include <algorithm>
#include <string.h>
#include <iostream>
#include <math.h>
#include <string>
#include <random>
#include <chrono>
#include <vector>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const db EPS = 1e-7;

const int N = (int)3e5;

struct prog {
	int a, b, op;
};

int n, m, s;
vector <int> z;
vector <vector <int>> a, p, first_and, type_child;
vector <vector <pair <bool, bool>>> used_and;
vector <bool> is_good;
vector <vector <prog>> blmp;
vector <vector <vector <int>>> G;

void dfs(int v, int ind, int last = -1, int type = 0) {
	first_and[ind][v] = last;
	type_child[ind][v] = type;
	bool f = false;
	if (v >= n) {
		if (blmp[ind][v - n].op == 1) {
			f = true;
		}
	}
	rep(G[ind][v].size(), i) {
		int u = G[ind][v][i];
		if (!f) {
			dfs(u, ind, last, type);
		} else {
			dfs(u, ind, v, i + 1);
		}
	}
}

void make_tree_blmp() {
	p.resize(m);
	G.resize(m);
	first_and.resize(m);
	used_and.resize(m);
	type_child.resize(m);
	rep(m, i) {
		type_child[i].resize(2 * n - 1, 0);
		used_and[i].resize(2 * n - 1, mp(false, false));
		G[i].resize(2 * n - 1);
		p[i].resize(2 * n - 1, -1);
		first_and[i].resize(2 * n - 1, -2);
		rep(n - 1, j) {
			p[i][blmp[i][j].a] = n + j;
			p[i][blmp[i][j].b] = n + j;
			G[i][n + j].push_back(blmp[i][j].a);
			G[i][n + j].push_back(blmp[i][j].b);
		}
		dfs(2 * n - 2, i);
	}
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	scanf("%d%d%d", &n, &m, &s);
	blmp.resize(m);
	is_good.resize(m, false);
	z.resize(n, 0);
	rep(m, i) {
		blmp[i].resize(n - 1);
		rep(n - 1, j) {
			scanf("%d%d%d", &blmp[i][j].a, &blmp[i][j].b, &blmp[i][j].op);
			--blmp[i][j].a, --blmp[i][j].b;
		}
	}
	make_tree_blmp();
	a.resize(m);
	rep(m, i) {
		a[i].resize(n);
		rep(n, j) {
			scanf("%d", &a[i][j]);
		}
	}
	rep(n, i) {
		if (s == 0) {
			break;
		}
		rep(m, j) {
			if (s == 0) {
				break;
			}
			int ind = -1;
			rep(m, k) {
				if (a[k][i] == j) {
					ind = k;
					break;
				}
			}
			++z[i];
			if (!is_good[ind]) {
				int cur_v = i;
				if (first_and[ind][cur_v] == -2) {
					continue;
				}
				while (first_and[ind][cur_v] != -1) {
					int cur_type = type_child[ind][cur_v];
					int and_ind = first_and[ind][cur_v];
					bool changed_ = false;
					if (cur_type == 1) {
						if (!used_and[ind][and_ind].first) {
							used_and[ind][and_ind].first = true;
							changed_ = true;
						}
					} else {
						if (!used_and[ind][and_ind].second) {
							used_and[ind][and_ind].second = true;
							changed_ = true;
						}
					}
					if (changed_ && used_and[ind][and_ind].first && used_and[ind][and_ind].second) {
						cur_v = and_ind;
					} else {
						break;
					}
				}
				if (first_and[ind][cur_v] == -1) {
					is_good[ind] = true;
					--s;
				}
			}
		}
	}
	rep(n, i) {
		printf("%d ", z[i]);
	}
	return 0;
}