#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allar(a, n) a, a + n
#define allv(a) a.begin(), a.end()
#define mp make_pair
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

#include <algorithm>
#include <string.h>
#include <iostream>
#include <math.h>
#include <string>
#include <random>
#include <chrono>
#include <vector>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const db EPS = 1e-7;

const int N = (int)9e6;

int n, x;
ll ans;

int gcd(int a, int b) {
	while (b) {
		int r = a % b;
		a = b;
		b = r;
	}
	return a;
}

pii find_solut(int a, int b) {
	if (a * b == 0) {
		return mp(a, b);
	}
	int k = abs(a) / abs(b);
	if (a * b < 0) {
		k = -k;
	}
	int r = a - k * b;
	pii cur_res = find_solut(b, r);
	pii res = mp(cur_res.second, cur_res.first - k * cur_res.second);
	return res;
}

void solve(int a, int c, int n) {
	int nod = gcd(a, c);
	if (n % nod) {
		return;
	}
	n /= nod;
	a /= nod;
	c /= nod;
	pii sol = find_solut(a, -c);
	sol.first *= n;
	sol.second *= n;
	if (sol.second <= 0) {
		int cnt = abs(sol.second) / a + 1;
		sol.second += cnt * a;
		sol.first += cnt * c;
	} else if (sol.second > a) {
		int cnt = sol.second / a;
		sol.second -= a * cnt;
		sol.first -= c * cnt;
		if (sol.second == 0) {
			sol.second += a;
			sol.first += c;
		}
	}
	int max_d = (n + a - c - 1) / (a - c) - 1;
	if (max_d >= sol.second) {
		ans += (max_d - sol.second) / a + 1;
	}
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	scanf("%d%d", &n, &x);
	for (int a = 2; a <= n + 1; ++a) {
		for (int c = 1; c < a; ++c) {
			solve(a, c, n);
		}
	}
	printf("%lld", ans);
	return 0;
}