#define _CRT_SECURE_NO_WARNINGS
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allar(a, n) a, a + n
#define allv(a) a.begin(), a.end()
#define mp make_pair
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

#include <algorithm>
#include <string.h>
#include <iostream>
#include <math.h>
#include <string>
#include <random>
#include <chrono>
#include <vector>
#include <map>
#include <set>
#include <queue>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const db EPS = 1e-7;

const int N = (int)4e3;

int n, a[N], q;

ll solve() {
	ll ans = 0;
	rep(1 << n, mask) {
		rep(n, i) {
			int ind1 = i;
			int ind2 = (ind1 + 1) % n;
			int ind3 = (ind2 + 1) % n;
			if ((mask >> ind1 & 1) && (mask >> ind2 & 1) && (mask >> ind3 & 1)) {
				continue;
			}
		}
		ll cur_ans = 0;
		rep(n, i) {
			if (mask >> i & 1) {
				cur_ans += a[i];
			}
		}
		ans = max(ans, cur_ans);
	}
	return ans;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	scanf("%d", &n);
	rep(n, i) {
		scanf("%d", &a[i]);
	}
	scanf("%d", &q);
	printf("%lld\n", solve());
	rep(q, i) {
		int p, v;
		scanf("%d%d", &p, &v);
		--p;
		a[p] = v;
		printf("%lld\n", solve());
	}
	return 0;
}