#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <utility>
#include <unordered_map>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

using namespace std;

#define ll long long
#define pb push_back

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<ll> ans(n);
	for (int i = 1; i <= n; i++) {
		unordered_set<ll> s;
		unordered_map<ll, int> m;
		for (int j = 0; j < i; j++) {
			s.insert(a[j]);
			if (m.find(a[j]) == m.end()) {
				m[a[j]] = 1;
			}
			else {
				m[a[j]]++;
			}
		}
		ans[i - 1] += s.size();
		for (int j = i; j < n; j++) {
			if (m[a[j - i]] == 1) {
				s.erase(a[j - i]);
				m[a[j - i]]--;
			}
			else {
				m[a[j - i]]--;
			}
			if (m[a[j]] == 0 || m.find(a[j]) == m.end()) {
				s.insert(a[j]);
				m[a[j]] = 1;
			}
			else {
				m[a[j]]++;
			}
			ans[i - 1] += s.size();
		}
	}
	for (ll i : ans) {
		cout << i << " ";
	}
	return 0;
}