#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <utility>
#include <unordered_map>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

using namespace std;

#define ll long long
#define pb push_back

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<ll> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<ll> dp(n + 2);
	vector<ll> dpcur(n + 2);
	dp[0] = 1;
	dpcur[0] = 1;
	if (n > 1) {
		dp[1] = a[1] - 1;
		dpcur[1] = a[1] - 1;
	}
	for (int i = 2; i < n; i++) {
		dp[i] = dp[i - 1] + (a[i] - dp[i - 1]) / a[i - 1] * a[i - 1];
		dpcur[i] = dpcur[i - 1] + (a[i] - dp[i - 1]) / a[i - 1];
		if (dp[i] == a[i]) {
			dp[i] -= a[i - 1];
			dpcur[i]--;
		}
	}
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		ll b;
		cin >> b;
		int l = -1, r = n, m;
		while (r - l != 1) {
			m = (l + r) / 2;
			if (b > a[m]) {
				l = m;
			}
			else {
				r = m;
			}
		}
		if (r == 0) {
			cout << "1 1" << "\n";
		}
		else if (r != n) {
			if (b >= dp[r]) {
				cout << dp[r] << " " << dpcur[r] << "\n";
			}
			else {
				ll rb = b % a[r - 1];
				ll rr = dp[r] % a[r - 1];
				if (rb >= rr) {
					b -= rb - rr;
				}
				else {
					b -= a[r - 1] + rb - rr;
				}
				cout << b << " " << dpcur[r] - (dp[r] - b) / a[r - 1] << "\n";
			}
		}
		else {
			ll rr = dp[n - 1] % a[n - 1];
			ll rb = b % a[n - 1];
			if (rb >= rr) {
				b -= rb - rr;
			}
			else {
				b += rr - rb;
				b -= a[n - 1];
			}
			cout << b << " " << dpcur[n - 1] + (b - dp[n - 1]) / a[n - 1] << "\n";
		}
	}
	return 0;
}