#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
using namespace std;
typedef int ll;
ll const INF = 1000000007, N = 10000;
int min(int a, int b) {
    if (a < b) {
        return a;
    }
    return b;
}
int max(int a, int b) {
    if (a > b) {
        return a;
    }
    return b;
}

vector<ll> prim(ll n)
{
    vector<ll> arr;
    arr.push_back(1);
    ll i = 2;
    while (i * i < n + 100) {
        if (n % i == 0) {
            arr.push_back(i);
        }
        i++;

    }
    return arr;
}

int main()
{
    int n;
    cin >> n;
    vector<ll> arr = prim(n);
    int len = arr.size();
    bool ans = false;
    ll a, b;
    for (int i = 0; i < len; i++) {
        ll x = arr[i], y = n / x;
        if (!ans && (x + y) % 2 == 0) {
            ans = true;
            a = (x + y) / 2;
            b = abs(x - a);
        }
    }
    if (ans) {
        cout << "Yes" << '\n' << a << " " << b;
    }
    else {
        cout << "No";
    }
}
