#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
using namespace std;
typedef long long ll;
ll const INF = 100000, N = 10000;

void perm(int len, ll cur, vector<vector<ll>> arr, vector<ll>& ans) {
    if (len == 0) {
        ans.push_back(cur);
    }
    else {
        int i = arr.size() - len;
        vector<ll> p = arr[i];
        for (int j = 0; j < p.size(); j++) {
            perm(len - 1, cur * pow(p[1], j), arr, ans);
        }
    }
}

vector<ll> prim(ll n)
{
    vector<vector<ll>> arr;
    ll i = 2;
    vector<ll> p, q;
    p.push_back(0);
    q.push_back(0);
    while (n > 1) {
        if (n % i == 0) {
            p.push_back(i);
            n /= i;
        }
        else {
            arr.push_back(p);
            p = q;
            i++;
        }
    }
    if (p.size() > 1) {
        arr.push_back(p);
    }
    int len = arr.size();
    vector<ll> ans;
    perm(len, 1, arr, ans);
    return ans;
}

int main()
{
    ll n;
    cin >> n;
    vector<ll> arr = prim(n);
    sort(arr.begin(), arr.end());
    int len = arr.size();
    bool ans = false;
    ll x, y;
    for (int i = 0; i < len; i++) {
        if (!ans) {
            ll a = arr[i], b = n / a;
            if (abs(a + b) % 2 == 0) {
                x = abs(a + b) / 2;
                y = abs(x - a);
                if (x > 0 && y > 0) {
                    ans = true;
                }


            }
        }
    }
    if (ans) {
        cout << "Yes" << endl << x << " " << y;

    }
    else {
        cout << "No";
    }

}