#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
using namespace std;
typedef int ll;
ll const INF = 10000000000000000, N = 10000;

double check(double mid, vector<int> v, vector<int> s) {
    int n = v.size();
    double ans = 0;
    for (int i = 0; i < n; i++) {
        ans += ((double)s[i] / (mid + v[i]));
    }
    return ans;
}

int main()
{
    int n;
    cin >> n;
    vector<int> v, s;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        v.push_back(x);
    }
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        s.push_back(x);
    }
    int m;
    cin >> m;
    vector<ll> arr, cost;
    for (int i = 0; i < m - 1; i++) {
        int x;
        cin >> x;
        arr.push_back(x);
    }
    arr.push_back(INF);
    for (int i = 0; i < m; i++) {
        int x;
        cin >> x;
        cost.push_back(x);
    }
    int t;
    cin >> t;
    while (t--) {
        int a, b, len;
        cin >> a >> b;
        len = abs(a - b);
        if (check(0, v, s) <= len) {
            cout << 0 << endl;
        }
        else {
            double l = 0, r = INF;
            while (l + 0.0001 < r)
            {
                double mid = (l + r) / 2;
                if (check(mid, v, s) <= len) {
                    r = mid;
                }
                else {
                    l = mid;
                }
            }
            double k = l + 0.0001;
            int l_ = -1, r_ = m;
            while (l_ + 1 < r_) {
                int mid = (l_ + r_) / 2;
                if (k > arr[mid]) {
                    l_ = mid;
                }
                else {
                    r_ = mid;
                }
            }
            cout << cost[r_] << endl;
        }
    }
}

// 3 10 20 30 400 500 600 6 1 5 10 12 16 100 300 600 800 1000 1500 3 10 100 20 70 45 100
