#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cstdio>
using namespace std;
typedef long long ll;
ll const INF = 1000000000, N = 10000;
vector<ll> a;

ll check(ll x)
{
    ll ans = 0;
    while (x > 0) {
        int l = -1, r = a.size();
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (a[mid] > x) {
                r = mid;
            }
            else {
                l = mid;
            }
        }
        ll k = a[l];
        ll num = x / k;
        ans += num;
        x -= k * num;
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll n, x, ans = 0;
    cin >> n;

    for (int i = 0; i < n; i++) {
        ll x;
        cin >> x;
        a.push_back(x);
    }
    vector<int> p;
    p.push_back(1);
    for (int i = 1; i < n; i++) {
        if (a[i] - 1 == a[i - 1]) {
            p.push_back(p[p.size() - 1]);
        }
        else {
            p.push_back(a[i] - 1);
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        ll x;
        cin >> x;
        int l = -1, r = n;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (a[mid] > x) {
                r = mid;
            }
            else {
                l = mid;
            }
        }
        ll y = check(x), z = check(p[l]);
        if (y > z) {
            cout << x << " " << y << '\n';
        }
        else {
            cout << p[l] << " " << z << '\n';
        }
        
    }
}
