#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#define ll long long
#define pb push_back
#define pii pair<int, int>
#define ft first
#define sd second

using namespace std;

void update(vector<int> &tree, int n, int i) {
    while (i < n) {
        tree[i] += 1;
        i = i | (i + 1);
    }
}

int sum(vector<int> &tree, int n, int r) {
    if (r <= -1) return 0;
    int ans = 0;
    while (r >= 0) {
        ans += tree[r];
        r = (r & (r + 1)) - 1;
    }
    return ans;
}

int main() {
    int n, m, s;
    cin >> n >> m >> s;
    if (n == 1) {
        //vector<int> v(m);
        //vector<int> pos(n);
        for (int i = 0; i < m; ++i) {
            int a;
            cin >> a;
        }
        cout << s;
        return 0;
    }
    if (n == 2) {
        vector<int> op(m);

        for (int i = 0; i < m; ++i) {
            int a, b, c;
            cin >> a >> b >> c;
            op[i] = c;
        }
        vector<int> pos(m);
        vector<int> op1(m);
        vector<int> idx(m);
        vector<pii> v3;
        vector<pii> u;
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin >> a >> b;
            if (op[i] == 1) {
                op1[a] = 1;
            } else {
                op1[a] = 2;
            }
            v3.pb({b, i});
            u.pb({a, b});
            //v4.pb({a, i});
        }
        sort(v3.begin(), v3.end());
        vector<int> pos_b(m);
        int cnt1 = 0, cnt2 = 0;
        for (int i = 0; i < m; ++i) {
            if (op[v3[i].sd] == 1) {
                pos_b[i] = cnt1;
                ++cnt1;
            } else {
                pos_b[i] = cnt2;
                ++cnt2;
            }
        }
        //vector<int> pos(m);
        for (int i = 0; i < m; ++i) {
            pos[u[i].ft] = pos_b[u[i].sd];
        }
        /*cout << "\n";
        for (int i = 0; i < m; ++i) {
            cout << pos[i] << " " << op1[i] << "\n";
        }
        cout << "\n\n";*/
        vector<pii> v;
        cnt1 = 0;
        cnt2 = 0;
        v.pb({0, 0});

        for (int i = 0; i < m; ++i) {
            if (op[v3[i].sd] == 1) ++cnt1;
            else ++cnt2;
            v.pb({cnt1, cnt2});
        }
        /*for (int i = 0; i <= m; ++i) {
            cout << v[i].ft << " " << v[i].sd << "\n";
        }
        cout << "\n\n";*/
        vector<int> v1(m), v2(m);
        for (int i = 0; i <= m; ++i) {
            if (i != 0) {
                if (op1[i - 1] == 1) {
                    update(v1, cnt1, pos[i - 1]);
                } else {
                    update(v2, cnt2, pos[i - 1]);
                }
            }
            int l = -1, r = m;
            while (l + 1 < r) {
                int mid = (l + r) / 2;
                if (sum(v1, cnt1, v[mid].ft - 1) + (sum(v2, cnt2, cnt2 - 1) - sum(v2, cnt2, v[mid].sd - 1) +  v[mid].sd) >= s) {
                    r = mid;
                } else {
                    l = mid;
                }

            }
            if (sum(v1, cnt1, v[r].ft - 1) + (sum(v2, cnt2, cnt2 - 1) - sum(v2, cnt2, v[r].sd - 1) +  v[r].sd) == s) {
                cout << i << " " << r;
                return 0;
            }

        }
    }
    return 0;
}

