#include<iostream>
#include<random>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_map>
#include<unordered_set>
#include<random>
#include<string>
#include<time.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define sz(c) (int)(c).size()
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

const int MAXN = 1e5;
const int INF = 1e9;

/*

int a[MAXN], tree[4 * MAXN], add[4 * MAXN];

void build(int ind, int l, int r) {
	add[ind] = 0;
	if (l - r == 1) {
		tree[ind] = a[l];
		return;
	}
	int m = (l + r) / 2;
	build(ind * 2 + 1, l, m);
	build(ind * 2 + 2, m, r);
	tree[ind] = max(tree[ind * 2 + 1], tree[ind * 2 + 1]);
}

void push(int ind, int l, int r) {
	tree[ind] += add[ind];
	if (l - r != 1) {
		add[ind * 2 + 1] += add[ind];
		add[ind * 2 + 2] += add[ind];
	}
	add[ind] = 0;
}

int query_max(int ind, int l, int r, int q_l, int q_r) {
	push(ind, l, r);
	if (q_l >= r || q_r <= l) {
		return -INF;
	}
	if (q_l <= l && r <= q_r) {
		return tree[ind];
	}
	int m = (l + r) / 2;
	return max(query_max(ind * 2 + 1, l, m, q_l, q_r), query_max(ind * 2 + 2, m, r, q_l, q_r));
}

int segm_plus(int ind, int l, int r, int q_l, int q_r, int delta) {
	push(ind, l, r);
	if (q_l >= r || q_r <= l) {
		return;
	}
	if (q_l <= l && r <= q_r) {
		add[ind] += delta;
		push(ind, l, r);
		return;
	}
	int m = (l + r) / 2;
	segm_plus(ind * 2 + 1, l, m, q_l, q_r, delta);
	segm_plus(ind * 2 + 2, m, r, q_l, q_r, delta);
	tree[ind] = max(tree[ind * 2 + 1], tree[ind * 2 + 1]);
}

*/

/* 

vector<vector<int>> g;
vector<int> used;
vector<int> pr;

*/

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int n; cin >> n;

	vector<ld> vel(n);
	for (int i = 0; i < n; ++i) {
		cin >> vel[i];
	}
	
	vector<ld> len(n);
	for (int i = 0; i < n; ++i) {
		cin >> len[i];
	}

	int m; cin >> m;
	vector<ld> a(m);
	a[0] = 0;
	for (int i = 1; i < m; ++i) {
		cin >> a[i];
	}

	vector<ll> fed(m);
	for (int i = 0; i < m; ++i) {
		cin >> fed[i];
	}

	vector<int> ans;
	int q; cin >> q;
	for (int t = 0; t < q; ++t) {
		ld x, y;
		cin >> x >> y;
		ld segm = y - x;
		int l = 0, r = m + 1;
		ld exx = 0;
		for (int i = 0; i < n; ++i) {
			exx += (len[i] / (vel[i]));
		}
		if ((exx - segm) < (1e-6)) {
			ans.pb(0);
			continue;
		}
		while (r - l != 1) {
			int mid = (l + r) / 2;
			ld e = a[mid];
			ld ex = 0;
			for (int i = 0; i < n; ++i) {
				ex += (len[i] / (vel[i] + e));
			}
			if (abs(ex - segm) < 1e-6) {
				l = mid - 1;
				r = mid;
				break;
			}
			if (ex > segm) {
				l = mid;
			}
			else {
				r = mid;
			}
		}
		ans.pb(fed[l]);
	}

	for (auto el : ans) {
		cout << el << endl;
	}
	//system("pause");
	return 0;
}