#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#define cerr if (false) cerr
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

template <typename It>
void output(It b, It e, ostream &out) {
    while (b != e) {
        out << (*b) << ' ';
        ++b;
    }
}

constexpr ll INF = 1e18;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input();
    vector<int> v(n), l(n);
    for (int &i : v) {
        i = input();
    }
    for (int &i : l) {
        i = input();
    }
    auto calc = [&](int dv) {
        ld res = 0;
        for (int i = 0; i < n; ++i) {
            res += ld(l[i]) / (ld(v[i]) + dv);
        }
        return res;
    };

    int m = input();
    vector<int> a(m - 1), f(m);
    for (int &i : a) {
        i = input();
    }
    for (int &i : f) {
        i = input();
    }
    int q = input();
    while (q--) {
        int s = input();
        int t = input() - s;
        int le = -1, ri = INF;
//        int iter = 100;
        while (ri - le > 1) {
            int mid = (ri + le) / 2;
            if (calc(mid) < t) {
                ri = mid;
            } else {
                le = mid;
            }
        }
        debug(ri);
        debug(calc(ri));
        debug(t);
        int ind = lower_bound(all(a), ri) - a.begin();
        if (ri == 0) {
            cout << 0 << endl;
        } else {
            cout << f[ind] << endl;
        }
    }
}
