#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#define cerr if (false) cerr
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

template <typename It>
void output(It b, It e, ostream &out) {
    while (b != e) {
        out << (*b) << ' ';
        ++b;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input();
    int m = input();
    int s = input();

    vector<vector<tuple<int, int, int>>> arr(m);
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n - 1; ++j) {
            int a = input();
            int b = input();
            int op = input();
            arr[i].emplace_back(a, b, op);
        }
    }
    vector<vector<int>> x(m, vector<int>(n));
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            x[i][j] = input();
        }
    }

    vector<int> zs(n);

    if (n == 1) {
        cout << s << endl;
        return 0;
    }

    vector<vector<int>> to_ith(n, vector<int>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            to_ith[i][x[i][j]] = j;
        }
    }

    auto oper = [&](bool a, bool b, int t) {
        if (t == 1) {
            return a & b;
        } else {
            return a | b;
        }
    };

    if (n == 2) {
        for (int z1 = 0; z1 <= m; ++z1) {
            vector<vector<bool>> mat(m, vector<bool>(2 * n - 1));
            vector<bool> fir, sec;
            for (int i = 0; i < m; ++i) {
                mat[i][0] = x[i][0] < z1;
            }
            int cnt = 0;
            auto relax = [&](int ind) {
                for (int i = 0; i < n - 1; ++i) {
                    auto[a, b, op] = arr[ind][i];
                    cnt -= mat[ind][n + i];
                    mat[ind][n + i] = oper(mat[ind][a], mat[ind][b], op);
                    cnt += mat[ind][n + i];
                }
            };
            for (int z2 = 0; z2 <= m; ++z2) {
                if (cnt == s) {
                    cout << z1 << ' ' << z2 << endl;
                    return 0;
                }
                if (z2 < m) {
                    int ind = to_ith[1][z2];
                    mat[ind][1] = true;
                    relax(ind);
                }
            }
        }
    }
}
