#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,popcnt,tune=native")

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

//#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#define cerr if (false) cerr
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

template <typename It>
void output(It b, It e, ostream &out) {
    while (b != e) {
        out << (*b) << ' ';
        ++b;
    }
}

constexpr int N = 1e7;
vector<int> vals[N];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input();
    int x = input();

    ll ans = 0;

    for (int c = 1; c <= n; ++c) {
        for (int d = 1; c + d - 1 <= n; ++d) {
            vals[c * d].emplace_back(c);
        }
    }
    for (auto &vec : vals) {
        sort(all(vec));
    }

    for (int a = 1; a <= n; ++a) {
        for (int b = 1; a + b - 1 <= n; ++b) {
            if (a == x || b == x || a * b < n) {
                continue;
            }
            int cd = a * b - n;
            ans += lower_bound(all(vals[cd]), a) - upper_bound(all(vals[cd]), cd / b);
        }
    }
    cout << ans << endl;
}
