#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#define cerr if (false) cerr
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

template <typename It>
void output(It b, It e, ostream &out) {
    while (b != e) {
        out << (*b) << ' ';
        ++b;
    }
}

constexpr int N = 2e5 + 47;
pii answer[N];
vector<ll> cur_arr;
vector<pii> evs;
int n, q;

int calc(int x) {
    int res = 0;
    while (x) {
        int a = *prev(upper_bound(all(cur_arr), x));
        res += x / a;
        x %= a;
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    n = input();
    for (int i = 0; i < n; ++i) {
        int a = input();
        evs.emplace_back(a, -1);
    }

    q = input();
    for (int i = 0; i < q; ++i) {
        int bi = input();
        evs.emplace_back(bi, i);
    }
    sort(all(evs));

    for (auto[x, i] : evs) {
        if (i == -1) {
            if (sz(cur_arr) && x < 2 * cur_arr.back()) {
                cur_arr.pop_back();
            }
            cur_arr.emplace_back(x);
        } else {
            int ind = -1, ans = 0;
            for (int bb = 1; bb <= x; ++bb) {
                int cur = calc(bb);
                if (ans < cur) {
                    ans = cur;
                    ind = bb;
                }
            }
            answer[i] = {ind, ans};
        }
    }

    for (int i = 0; i < q; ++i) {
        cout << answer[i].first << ' ' << answer[i].second << endl;
    }
}
