#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#define cerr if (false) cerr
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

template <typename It>
void output(It b, It e, ostream &out) {
    while (b != e) {
        out << (*b) << ' ';
        ++b;
    }
    out << endl;
}

constexpr int N = 2e5 + 47;
pii answer[N];
vector<tuple<int, int, int>> evs;
vector<int> arr;
int n, q;

int calc(int x) {
    int res = 0;
    while (x) {
        int a = *prev(upper_bound(all(arr), x));
        res += x / a;
        x %= a;
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    n = input();
    arr.resize(n);
    for (int i = 0; i < n; ++i) {
        int a = input();
        arr[i] = a;
        evs.emplace_back(a, -1, i);
    }
    arr.emplace_back(2e18);

    q = input();
    for (int i = 0; i < q; ++i) {
        int bi = input();
        evs.emplace_back(bi, 0, i);
    }
    sort(all(evs));

    int best = 0;
    int pr_x = 0;
    for (auto[x, t, i] : evs) {
        if (t == -1) {
            if (i) {
                int n = (x - best - 1) / pr_x;
                int res1 = calc(best);
                int res2 = calc(best + n * pr_x);
                if (res1 < res2) {
                    best += n * pr_x;
                }
            }
            pr_x = x;
        } else {
            debug(best);
            int l = 0, r = ll(2e18) / pr_x;
            while (r - l > 1) {
                int m = (r + l) / 2;
                debug(best + pr_x * m);
                if (best + pr_x * m <= x) {
                    l = m;
                } else {
                    r = m;
                }
            }
            int res = best + l * pr_x;
            debug(l);
            answer[i] = {res, calc(res)};
        }
    }

    for (int i = 0; i < q; ++i) {
        cout << answer[i].first << ' ' << answer[i].second << endl;
    }
}
