#include <bits/stdc++.h>

#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const ld pi = 3.1415926;
const char el = '\n';
const int inf = 1000'000'000, mod = 1000'000'007;
const ll llinf = 1e18;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define x first
#define y second
#define debug(x) cout << #x << ": " << x << el
#define left left228
#define right right228
#define prev prev228

template<typename T> bool uin(T &a, const T &b) { if (b < a) { a = b; return 1; } return 0; }
template<typename T> bool uax(T &a, const T &b) { if (b > a) { a = b; return 1; } return 0; }
template<class iterator> void output(iterator begin, iterator end, char p = ' ', ostream & out = cout) { while(begin != end) { out << (*begin) << p; begin++; } out << el; }
template<class T> void output(T x, char p = ' ', ostream & out = cout) { output(all(x), p, out); }

mt19937 rnd(time(nullptr));

pair<ll, ll> solve(ll n) {
    if (n == 0) return {1ll, 1ll};
    if (n == 16) return {5ll, 3ll};
    if (n & 1) {
        return {(n / 2) + 1, n / 2};
    }
    if (n % 4 == 0) {
        auto p = solve(n / 4);
        if ((n / 4) % 4 == 2) {
            return {p.x * 2 + 1, p.y * 2 + 1};
        }
        return {p.x * 2, p.y * 2};
    }
    return {n / 2, (n / 2) - 1};
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n;
    cin >> n;
    if (n % 4 == 2 || n == 4 || n == 1) {
        cout << "No" << el;
        return 0;
    }
    auto p = solve(n);
    cout << "Yes" << el << p.x << ' ' << p.y << el;
    return 0;
}
