#include <bits/stdc++.h>

#ifdef ONLINE_JUDGE
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("vpt")
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const char el = '\n';
const int inf = 1e9, mod = 1000'000'007;
const ll llinf = 1e18;
const ld pi = 3.1415926;

#define x first
#define y second
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define debug(x) cout << #x << ' ' << x << el

template<typename T> void uin(T &a, T b) { if (b < a) a = b; }
template<typename T> void uax(T &a, T b) { if (b > a) a = b; }

mt19937 rnd(time(NULL));

#define int ll

int n, m;
vector<int> t[4][4];
vector<ll> a;
void particle_solve() {
    int q;
    cin >> q;
    vector<int> tmp[4];
    forn(i, 4) tmp[i].resize(n);
    forn(qq, q + 1) {
        ll ans = 0;
        forn(i, 4) {
            ll sum = 0;
            forn(j, i) sum += a[j];
            forn(j, 4) tmp[j][i] = sum;
            for (int j = i + 1; j < n; ++j) {
                tmp[0][j] = tmp[3][j - 1];
                firn(k, 4) {
                    tmp[k][j] = max(tmp[3][j - 1], a[j] + tmp[k - 1][j - 1]);
                }
            }
            uax(ans, tmp[3 - i][n - 1]);
        }
        cout << ans << el;
        if (qq < q) {
            int p, v;
            cin >> p >> v;
            a[p - 1] = v;
        }
    }
}
vector<pair<int, int>> blocks;
vector<ll> tmp[4];
void solve(int k) {
    int l = blocks[k].x, r = blocks[k].y;
    forn(i, 4) {
        ll sum = 0;
        forn(j, i) sum += a[l + j];
        tmp[0][i] = tmp[1][i] = tmp[2][i] = tmp[3][i] = sum;
        for (int j = i + 1; j <= r - l; j++) {
            tmp[0][j] = tmp[3][j - 1];
            firn(k, 4) {
                tmp[k][j] = max(tmp[3][j - 1], a[j + l] + tmp[k - 1][j - 1]);
            }
        }
        forn(j, 4) t[i][j][k] = tmp[j][r - l];
    }
}
ll find_ans() {
    ll ans = 0;
    forn(i, 4) {
        forn(j, 4) tmp[j][0] = t[i][j][0];
        firn(j, m) {
            forn(k, 4) forn(l, 4) {
                uax(tmp[k][j], tmp[3 - l][j - 1] + t[l][k][j]);
            }
        }
        uax(ans, tmp[3 - i][m - 1]);
    }
    return ans;
}
int T = 282;
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cin >> n;
    a.resize(n);
    forn(i, n) cin >> a[i];
    if (n <= 1000) {
        particle_solve();
        return 0;
    }
    for (int i = 0; i < n; i += T) {
        if (i + T + T > n) {
            blocks.emplace_back(i, n - 1);
            break;
        }
        blocks.emplace_back(i, i + T - 1);
    }
    m = (int)blocks.size();
    forn(i, 4) {
        forn(j, 4) t[i][j].resize(m);
        tmp[i].resize(n);
    }
    forn(i, m) solve(i);
    int q;
    cin >> q;
    forn(qq, q + 1) {
        cout << find_ans() << el;
        if (qq < q) {
            int p, v;
            cin >> p >> v;
            p--;
            a[p] = v;
            auto j = upper_bound(all(blocks), pair<int, int>{p, inf}) - blocks.begin() - 1;
            if (p < blocks[j].x || p > blocks[j].y) {
                return 1;
            }
            solve(j);
        }
    }
    return 0;
}