#include<bits/stdc++.h>

#define pb push_back
#define X first
#define Y second
#define endl '\n'

using namespace std;
typedef long long ll;

int dp[5010][5010];
int ans[5010];

vector<int> a;
vector<vector<int>> tree;

void build(int v, int tl, int tr) {
    if (tl == tr - 1) {
        tree[v][a[tl]] = 1;
    } else {
        int tm = (tl + tr) / 2;
        build(2 * v + 1, tl, tm);
        build(2 * v + 2, tm, tr);
        for(int i = 0; i < 5005; ++i) {
            tree[v][i] = max({tree[v][i], tree[2 * v + 1][i], tree[2 * v + 2][i]});
        }
    }
}

bool get(int v, int tl, int tr, int lef, int rig, int x) {
    if (lef >= rig) {
        return 0;
    }
    if (tl == lef && tr == rig) {
        return (tree[v][x]);
    }
    int tm = (tl + tr) / 2;
    int a = get(2 * v + 1, tl, tm, lef, min(tm, rig), x);
    int b = get(2 * v + 2, tm, tr, max(tm, lef), rig, x);
    return (a | b);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    a.resize(n);
    int mx = 0;
    for(int i = 0; i < n; ++i) {
        cin >> a[i];
        mx = max(mx, a[i]);
    }
    for(int i = 0; i < n; ++i) {
        dp[i][1] = 1;
    }
    if (mx <= 5000 && n > 500) {
        tree.resize(4 * n + 10);
        for(int i = 0; i < 4 * n + 5; ++i) {
            tree[i].resize(5010, 0);
        }
        build(0, 0, n);
        return 0;
        for(int d = 2; d <= n; ++d) {
            for(int lef = 0; lef + d - 1 < n; ++lef) {
                bool flag = !get(0, 0, n, lef + 1, lef + d, a[lef]);
                dp[lef][d] = dp[lef + 1][d - 1] + flag;
                ans[d] += dp[lef][d];
            }
        }
    } else {
        for(int d = 2; d <= n; ++d) {
            for(int lef = 0; lef + d - 1 < n; ++lef) {
                int flag = 1;
                for(int i = lef + 1; i <= lef + d - 1; ++i) {
                    if (a[i] == a[lef]) {
                        flag = 0;
                    }
                }
                dp[lef][d] = dp[lef + 1][d - 1] + flag;
                ans[d] += dp[lef][d];
            }
        }
    }
    cout << n << ' ';
    for(int d = 2; d <= n; ++d) {
        cout << ans[d] << ' ';
    }
}
