#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

using ll = long long;
using pii = pair <int, int>;

const int oo = 1e9 + 4;
const int SZ = 2e5 + 4;
bool str = 0;

int n;
vector <int> a;

void read() {
    cin >> n;
    a.resize(n);
    for (auto &t : a) cin >> t;
}

void add(int l, int r, vector <ll> & ans) {
    int t = r - l + 1;
    for (int i = t; i <= n; i++) {
        int len = i - t + 1;
        if (i <= max(r + 1, n - l)) len = min({len, l + 1, n - r});
        else len = n - i + 1;
        ans[i - 1] -= len;
    }
}


vector <ll> solve() {
    vector <ll> ans;
    map <int, int> last;
    ans.resize(n);
    for (int i = 0; i < n; i++)
        ans[i] = 1ll * (n - i) * (i + 1);
    for (int i = 0; i < n; i++) {
        if (last.count(a[i])) {
            add(last[a[i]], i, ans);
        }
        last[a[i]] = i;
    }
    if (str) return ans;
    for (auto t : ans) cout << t << ' ';
}

vector <ll> solve0() {
    vector <ll> ans(n, 0);
    for (int len = 1; len <= n; len++) {
        for (int i = 0; i <= n - len; i++) {
            set <int> r;
            for (int j = 0; j < len; j++)
                r.insert(a[i + j]);
            ans[len - 1] += r.size();
        }
    }
    if (str) return ans;
    for (auto t : ans) cout << t << ' ';
}

mt19937 rnd(19937);

void gen() {
    n = rnd() % 10 + 2;
    a.resize(n);
    for (int i = 0; i < n; i++)
        a[i] = rnd() % 1000;
}

void stress() {
    while (1) {
        gen();
        auto A = solve0();
        auto B = solve();
        if (A != B) {
            cout << "aAaAA" << endl;
            cout << n << endl;
            for (auto t : a) cout << t << ' '; cout << endl;
            cout << "OK: ";
            for (auto t : A) cout << t << ' '; cout << endl;
            cout << "NE: ";
            for (auto t : B) cout << t << ' '; cout << endl;
            break;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    if (str)
        stress();
    else {
        read();
        solve();
    }
}
