#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

using ll = long long;
using pii = pair <int, int>;

const int oo = 1e9 + 4;
const int SZ = 2e5 + 4;

int n, q;
vector <ll> a;
bool ai2 = 1;
ll sum;

void read() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] != (1 << i)) ai2 = 0;
        sum += a[i];
    }
    if (n != 60) ai2 = 0;
    cin >> q;
    if (q > 5) ai2 = 0;
}

map <ll, ll> mem;

ll go (ll n) {
    if (mem.count(n)) return mem[n];
    if (!n) return 0;
    int k = upper_bound(a.begin(), a.end(), n) - a.begin() - 1;
    ll l = a[k];
    return mem[n] = n / l + go(n % l);
}

void solve() {
    mem.clear();
    while (q--) {
        ll b;
        cin >> b;
        ll mx = 0, i = 0;
        for (ll j = 0; j <= b; j++)
            if (go(j) > mx) {
                mx = go(j);
                i = j;
            }
        cout << i << ' ' << mx << endl;
    }
}

void solve2() {
    while (q--) {
        ll b;
        cin >> b;

        ll c = 0, ans = 0;
        for (int i = 0; i < 60; i++) {
            if (c + (1ll << i) <= b) c += (1ll << i), ans++;
        }

        cout << c << ' ' << ans << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    if (n <= 500 && q <= 5 && a.back() <= 500 && !ai2)
        solve();
    else if (ai2)
        solve2();
    else
        solve();
}
