#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

using ll = long long;
using pii = pair <int, int>;

const int oo = 1e9 + 4;
const int SZ = 2e5 + 4;

int n, q;
vector <ll> a;
bool ai2 = 1;
ll sum;

void read() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (a[i] != (1ll << i)) ai2 = 0;
    }
    if (n != 60) ai2 = 0;
    cin >> q;
    if (q > 5) ai2 = 0;
}

map <ll, ll> mem;

ll go(ll n) {
    if (!n) return 0;
    int k = upper_bound(a.begin(), a.end(), n) - a.begin() - 1;
    ll l = a[k];
    return n / l + go(n % l);
}

void solveHA(ll b) {
    ll mx = 1, i = 1;
    int k = upper_bound(a.begin(), a.end(), b) - a.begin() - 1;
    for (ll j = 0; j <= n; j++) {
        ll res = go(a[k] - 1);
        if (res > mx) {
            mx = res;
            i = j;
        }
    }
    cout << i << ' ' << mx << endl;
}

void solve() {
    mem.clear();
    while (q--) {
        ll b;
        cin >> b;
        if (b <= 2e5) {
            ll mx = 0, i = 0;
            for (ll j = 0; j <= b; j++)
                if (go(j) > mx) {
                    mx = go(j);
                    i = j;
                }
            cout << i << ' ' << mx << endl;
       }  else {
            solveHA(b);
        }
    }
}


void solve2() {
    for (int i = 0; i < q; i++) {
        ll b;
        cin >> b;
            ll c = 0, ans = 0;
            for (int i = 0; i < 60; i++) {
                if (c + a[i] <= b) c += a[i], ans++;
            }
            cout << c << ' ' << ans << endl;

    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    if (n <= 500 && q <= 5 && a.back() <= 500)
        solve();
    else if (ai2)
        solve2();
    else
        solve();
}
