#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

using ll = long long;
using pii = pair <int, int>;

const int oo = 1e9 + 4;
const int SZ = 2e5 + 4;

int n, q;
vector <int> a;

void read() {
    cin >> n;
    a.resize(n);
    for (auto &t : a) cin >> t;
    cin >> q;
}

ll go() {
    ll mx = 0;
    for (int m = 0; m < (1 << n); m++) {
        int k = 0;
        ll sum = 0;
        bool ok = 1;
        for (int i = 0; i < n + 4; i++) {
            if (i >= n) {
                if (m & (1 << (i- n))) {
                    k++;
                    if (k == 4) ok = 0;
                } else k = 0;
            } else {
                if (m & (1 << i)) {
                    sum += a[i];
                    k++;
                    if (k == 4) ok = 0;
                } else k = 0;
            }
        }
        if (ok) mx = max(mx, sum);
    }
    return mx;
}

void solve() {
    cout << go() << endl;
    while (q--) {
        int p, v;
        cin >> p >> v;
        a[p - 1] = v;
        cout << go() << endl;
    }
}

bool can[8][8];

ll get(int beg) {
    vector <ll> dp[8];
    for (int i = 0; i < 8; i++) {
        dp[i].resize(n, 0);
    }
    for (int i = 0; i < 3; i++)
        if (((1 << i) & beg)) dp[2][beg] += a[i];

    for (int i = 3; i < n; i++) {
        for (int j = 0; j < 8; j++) {
            int l = j * 2 % 8;
            dp[i][j] = dp[i - 1][l];
            l += 1;
            if (!(l == 7 && (j & 4) != 1)) dp[i][j] = max(dp[i][j], dp[i - 1][l]);
            if ((j & 4)) dp[i][j] += a[i];
        }
    }

    ll ret = 0;

    for (int i = 0; i < 8; i++)
        if (can[i][beg]) ret = max(ret, dp[n - 1][i]);
    return ret;
}

void solve0() {
    for (int i = 0; i < 8; i++)
        for (int j = 0; j < 8; j++) {

            int c = (i << 3) + j;
            int k = 0;
            bool ok = 1;
            for (int p = 0; p < 10; p++) {
                if (c & (1 << (p % 6))) {
                    k++;
                    if (k > 3) ok = 0;
                } else k  =0;
            }
            can[i][j] = ok;
        }
    ll ans = 0;
    for (int i = 0; i < 8; i++)
        ans = max(ans, get(i));
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    if (!q && n > 10)
        solve0();
    else
        solve();
}
