#include <bits/stdc++.h>
using namespace std;

#define F first
#define S second

using ll = long long;
using pii = pair <int, int>;

const int oo = 1e9 + 4;
const int SZ = 2e5 + 4;

int n, q;
vector <ll> a;

void read() {
    cin >> n;
    a.resize(n);
    for (auto &t : a) cin >> t;
    cin >> q;
}

ll go() {
    ll mx = 0;
    for (int m = 0; m < (1 << n); m++) {
        int k = 0;
        ll sum = 0;
        bool ok = 1;
        for (int i = 0; i < n + 4; i++) {
            if (i >= n) {
                if (m & (1 << (i- n))) {
                    k++;
                    if (k == 4) ok = 0;
                } else k = 0;
            } else {
                if (m & (1 << i)) {
                    sum += a[i];
                    k++;
                    if (k == 4) ok = 0;
                } else k = 0;
            }
        }
        if (ok) mx = max(mx, sum);
    }
    return mx;
}

void solve() {
    cout << go() << endl;
    while (q--) {
        int p, v;
        cin >> p >> v;
        a[p - 1] = v;
        cout << go() << endl;
    }
}

bool can[8][8];

ll get(int beg) {
    vector <ll> dp[4];
    for (int i = 0; i < 4; i++) {
        dp[i].resize(n, 0);
    }
    for (int i = 0; i < beg; i++)
        dp[0][beg] += a[i];

    for (int i = beg + 1; i < n; i++) {
        dp[0][i] = max({dp[1][i - 1], dp[2][i - 1], dp[3][i - 1]});
        dp[1][i] = dp[0][i - 1] + a[i];
        dp[2][i] = dp[1][i - 1] + a[i];
        dp[3][i] = dp[2][i - 1] + a[i];
    }
    ll ret = 0;
    for (int i = 0; i <= 3 - beg; i++)
        ret = max(ret, dp[i][n - 1]);
    return ret;
}

void solve0() {
    for (int i = 0; i < 8; i++)
        for (int j = 0; j < 8; j++) {
            int c = (i << 3) + j;
            int k = 0;
            bool ok = 1;

            for (int p = 0; p < 12; p++) {
                if (c & (1 << (p % 6))) {
                    k++;
                    if (k > 3) ok = 0;
                } else k = 0;
            }
            can[i][j] = ok;
        }
    ll ans = 0;
    for (int i = 0; i < 4; i++)
        ans = max(ans, get(i));
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    if (!q && n > 10)
        solve0();
    else
        solve();
}
