#include <iostream>
#include <vector>
#define int long long
using namespace std;

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; i++)
        cin >> v[i];
    vector<int> l(n);
    for (int i = 0; i < n; i++)
        cin >> l[i];

    int m;
    cin >> m;
    vector<int> a(m);
    a[0] = 0;
    for (int i = 1; i < m; i++)
    {
        cin >> a[i];
    }
    vector<int> f(m);
    for (int i = 0; i < m; i++)
        cin >> f[i];

    int q;
    cin >> q;
    while (q--)
    {
        int ts, tf;
        cin >> ts >> tf;
        int t = tf - ts;

        int lv = -1;
        int rv = LONG_MAX;
        while (rv - lv > 1)
        {
            int mv = (lv + rv) >> 1;

            double min_t = 0;
            for (int i = 0; i < n; i++)
                min_t += (double)(l[i]) / (double)(v[i] + mv);
            //cout << lv << ' ' << rv << ' ' << mv << ' ' << min_t << ' ' << t << endl;

            if (min_t > t)
                lv = mv;
            else
                rv = mv;
        }

        if (rv == 0)
        {
            cout << "0\n";
            continue;
        }
        int lf = 0;
        int rf = m;
        //cout << rv << endl ;
        while (rf - lf > 1)
        {
            int mf = (lf + rf) >> 1;
            //cout << lf << ' ' << rf << ' ' << mf << ' ' << a[mf] << endl;
            if (rv > a[mf])
                lf = mf;
            else
                rf = mf;
        }
        cout << f[lf] << '\n';
    }

    return 0;
}
