/// YUR3K ///
#include <iostream>
#include <vector>
#pragma GCC optimize ("O3")
#define int long long
using namespace std;


inline void fastio()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

vector<int> a;


inline bool find_four(int mask, int n)
{
    int cnt = 0;
    int backup = mask;
    for (int i = 0; i < n; i++)
    {
        if (mask & 1) cnt++;
        else cnt = 0;
        if (cnt == 4)
            return true;
        mask = mask >> 1;
    }
    mask = backup;
    for (int i = 0; i < n; i++)
    {
        if (mask & 1) cnt++;
        else cnt = 0;
        if (cnt == 4)
            return true;
        mask = mask >> 1;
    }

    return false;
}


inline int find_max(int n)
{
    int maxc = 0;
    vector<int> dp(1 << n);
    dp[0] = 0;
    for (int mask = 1; mask < (1 << n); mask++)
    {
        if (find_four(mask, n))
            continue;

        for (int last = 0; last < n; last++)
        {
            if (!(mask & (1<<last)))
                continue;

            int submask = mask ^ (1<<last);
            dp[mask] = max(dp[mask], dp[submask] + a[last]);
        }
        maxc = max(maxc, dp[mask]);
        //cout << mask << ' ' << dp[mask] << endl;
    }

    return maxc;
}


signed main()
{
    fastio();

    int n;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];

    cout << find_max(n) << '\n';

    int q;
    cin >> q;
    while (q--)
    {
        int p, v;
        cin >> p >> v;
        a[p-1] = v;
        cout << find_max(n) << '\n';
    }

    return 0;
}
