#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>

#define ll long long

using namespace std;

ll inf = 1e9;
ll in = -1e9;

bool f(ll a) {
    return (long double)sqrt(a) == (ll)sqrt(a);
}

int main()
{
    iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    ll n;
    cin >> n;
    if (n == 2) {
        cout << "No";
        return 0;
    }
    for (ll i = 1; i < 2147483649; ++i) {
        if (f(i * i + n)) {
            cout << "Yes" << endl << (ll)sqrt(i * i + n) << " " << i << endl;
             return 0;
        }
        if (i * i > n&& f(i * i - n)) {
            cout << "Yes" << endl << i << " " << sqrt(i * i - n) << endl;
            return 0;
        }
    }
    cout << "No" << endl;
}