#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>

#define ll long long
#define ld long double

using namespace std;


int main()
{
    int n;
    cin >> n;
    vector<ld> ras(n), mx_v(n);
    for (int i = 0; i < n; ++i) {
        cin >> mx_v[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> ras[i];
    }
    int m;
    cin >> m;
    m++;
    vector<ld> pr(m), cost(m);
    pr[0] = cost[0] = 0;
    for (int i = 1; i < m - 1; ++i) {
        cin >> pr[i];
    }
    pr[m - 1] = pr[m - 2] + 1;
    for (int i = 1; i < m; ++i) {
        cin >> cost[i];
    }
    for (int i = 0; i < pr.size(); ++i) {
        ld x = 0;
        for (int j = 0; j < n; ++j) {
            x += ras[j] / (mx_v[j] + pr[i]);
        }
        pr[i] = x;
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        ld st, fi;
        cin >> st >> fi;
        ld time = fi - st;
        ll l = 0, r = m;
        while (r - l > 1) {
            ll mid = (l + r) / 2;
            if (time >= pr[mid]) {
                r = mid;
            }
            else {
                l = mid;
            }
        }
        if (l == 0 && pr[0] <= time) {
            r = l;
        }
        if (r == m) { --r; }
        cout << cost[r] << endl;
    }
}