#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iomanip>

#define ll long long
#define ld long double

using namespace std;

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<ll> s(n, 0);
    vector<vector<int>> d(n);
    vector<bool> use(n, 0);
    d[0].resize(n, 1);
    s[0] = n;
    for (int i = 1; i < n; ++i) {
        d[i].resize(n - i,0);
        for (int j = 0; j < n - i; ++j) {
            if (i == 1) {
                d[i][j] = 2;
                if (a[j] == a[j + i]) {
                    d[i][j]--;
                    use[j + i] = 1;
                }
                s[i] += d[i][j];
                continue;
            }
            if (use[j + 1]) {
                d[i][j] = d[i - 1][j];
                s[i] += d[i][j];
                continue;
            }
            d[i][j] = d[i - 1][j] + d[i - 1][j + 1] - d[i - 2][j + 1];
            if (a[j] == a[j + i]) {
                d[i][j]--;
                use[j + i] = 1;
            }
            s[i] += d[i][j];
        }
    }
    /*for (int i = 0; i < n; ++i) {
        for (int j = 0; j < d[i].size(); ++j) {
            cout << d[i][j] << " ";
        }
        cout << endl;
    }*/
    for (int i = 0; i < n; ++i) {
        cout << s[i] << " ";
    }
}