#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>

using namespace std;

#define ll long long
#define ld long double

int main()
{
    iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    
    int n1 = 61;
    vector<ll> a1(n1 + 1);
    a1[0] = 0;

    ll k = 1;
    for (int i = 0; i < 60; ++i) {
        a1[i + 1] = k;
        k *= 2;
    }
    

    int n;
    cin >> n;
    vector<ll> a(n + 1);
    a[0] = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i + 1];
    }
    n++;

    if ((n == n1 && a1 == a)) {
        int q;
        cin >> q;
        for (int i = 0; i < q; ++i) {
            int b;
            cin >> b;
            int l = 1, r = n1 + 1;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (a[m] > b) {
                    r = m;
                }
                else {
                    l = m;
                }
            }
            if (b == a[l + 1] - 1) {
                cout << b << " " << l << endl;
            }
            else {
                cout << a[l] - 1 << " " << l - 1 << endl;
            }
        }
        return 0;
    }
    int q;
    cin >> q;
    vector<pair<ll,ll>> b(q);
    ll mx = 0;
    for (int i = 0; i < q; ++i) {
        cin >> b[i].first;
        b[i].second = i;
        if (b[i].first > mx) { mx = b[i].first; }
    }
    sort(b.begin(), b.end());
    vector<pair<ll, ll>> ans(b.size());
    pair<ll, ll> mx_in = { 1,1 };
    int j = 0;
    if (b[0].first == 1) {
        j++;
        ans[b[0].second] = mx_in;
    }
    for (int i = 2; i <= mx; ++i) {
        ll sch = 0, z = i;
        for (int k = 0; z > 0 && k < 2000; ++k) {
            //if (k == 1000) { cout << i; return 0; }
            int l = 1, r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (a[m] > z) {
                    r = m;
                }
                else {
                    l = m;
                }
            }
            sch += z / a[l];
            z %= a[l];
        }
        if (sch > mx_in.second) {
            mx_in = { i, sch };
        }
        if (i == b[j].first) {
            ans[b[j].second] = mx_in;
            j++;
        }
    }
    /*for (int i = 0; i < dp.size(); ++i) {
        cout << dp[i].first << " " << dp[i].second << endl;
    }*/
    cout << endl;
    for (int i = 0; i < ans.size(); ++i) {
        cout << ans[i].first << " " << ans[i].second << endl;
    }
}