//
// Created by Vasiliy Silvestrov on 18.01.2020.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

vector<int> delt(int x)
{
    //cout << x << " - x" << endl;
    vector<int> ans;
    vector<int> ans1;
    for (int i = 1; i * i <= x; ++i) {
        if (x % i == 0) {
            ans.push_back(i);
            if (i * i != x) {
                ans1.push_back(x / i);
            }
        }
    }
    reverse(ans1.begin(), ans1.end());
    for (int i = 0; i < ans1.size(); ++i) {
        ans.push_back(ans1[i]);
    }
    return ans;
}

int solve1(int n, int x)
{
    vector<vector<int>> del(n * n + 1);
    for (int i = 0; i < n * n + 1; ++i) {
        del[i] = delt(i);
    }
    ll cnt = 0;
    for (int a = 2; a < n; ++a) {
        for (int b = 2; b < n; ++b) {
            if (a != x && b != x)
            {
                int cd = a * b - n;
                if (cd >= 1) {
                    for (int c : del[cd]) {
                        if (c < a && cd / c < b)
                        {
                            ++cnt;
                        }
                    }
                }
            }
        }
    }
    return cnt;
}

int solve2(int n, int x)
{
    vector<vector<int>> del(n * n + 1);
    for (int i = 0; i < n * n + 1; ++i) {
        del[i] = delt(i);
    }
    ll cnt = 0;
    for (int a = 2; a < n; ++a) {
        for (int b = 2; b < n; ++b) {
            if (a != x && b != x)
            {
                int cd = a * b - n;
                if (cd >= 1) {
                    int it1 = lower_bound(del[cd].begin(), del[cd].end(), a) - del[cd].begin(); // первый элемент, который нам не подходит
                    int it2 = lower_bound(del[cd].begin(), del[cd].end(), (cd + b - 2) / (b - 1)) - del[cd].begin();
                    cnt += max(it1 - it2, 0);
                }
            }
        }
    }
    return cnt;
}

int main()
{
    for (int n = 2500; n < 3000; ++n) {
        if (solve1(n, 0) != solve2(n, 0))
        {
            cout << n << endl;
        }
    }
}