//
// Created by Vasiliy Silvestrov on 18.01.2020.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;
using ld = long double;

vector<int> delt(int x)
{
    //cout << x << " - x" << endl;
    vector<int> ans;
    vector<int> ans1;
    for (int i = 1; i * i <= x; ++i) {
        if (x % i == 0) {
            ans.push_back(i);
            if (i * i == x) {
                ans1.push_back(x / i);
            }
        }
    }
    reverse(ans1.begin(), ans1.end());
    for (int i = 0; i < ans1.size(); ++i) {
        ans.push_back(ans1[i]);
    }
    return ans;
}

int solve2(int n, int x)
{
    vector<vector<int>> del((n - 1) * (n - 1) - n + 1);
    for (int i = 0; i < (n - 1) * (n - 1) - n + 1; ++i) {
        del[i] = delt(i);
    }
    ll cnt = 0;
    for (int a = 2; a < n; ++a) {
        for (int b = (n + a - 1) / a; b < n; ++b) {
            if (a != x && b != x)
            {
                int cd = a * b - n;
                if (cd >= 1) {
                    int it1 = lower_bound(del[cd].begin(), del[cd].end(), a) - del[cd].begin(); // первый элемент, который нам не подходит
                    int it2 = lower_bound(del[cd].begin(), del[cd].end(), b) - del[cd].begin() - 1;
                    int c = cd / del[cd][it2];
                    int it3 = lower_bound(del[cd].begin(), del[cd].end(), c) - del[cd].begin();
                    cnt += max(it1 - it3, 0);
                }
            }
        }
    }
    return cnt;
}

int main()
{
    int n, x;
    cin >> n >> x;
    cout << solve2(n, x) << endl;
}