//
// Created by olymp on 18.01.2020.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

bool kuk(vector<int> v)
{
    int n = v.size();
    for (int i = 0; i < n;++i)
    {
        if (v[i % n] == 1 && v[(i + 1) % n] == 1 && v[(i + 2) % n] == 1 && v[(i + 3) % n] == 1)
        {
            return false;
        }
    }
    return true;
}

ll check(vector<int> v, int mask)
{
    vector<int> bit(v.size());
    for (int i = 0; i < v.size(); ++i) {
        bit[i] = ((mask >> i) & 1);
    }
    if (kuk(bit))
    {
        ll ans = 0;
        for (int i = 0; i < v.size(); ++i) {
            ans += v[i] * bit[i];
        }
        return ans;
    }
    return 0;
}

ll answer(vector<int> v)
{
    int n = v.size();
    ll mx = 0;
    for (int i = 0; i < (1 << n); ++i)
    {
        mx = max(mx, check(v, i));
    }
    return mx;
}

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    for (int i = 0; i < q + 1; ++i) {
        if (i != 0)
        {
            int p, v;
            cin >> p >> v;
            --p;
            a[p] = v;
        }
        cout << answer(a) << endl;
    }

}