#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <tuple>
#include <set>

#define int long long
#define float long double

using namespace std;

bool check(vector <int> &v)
{
    for (int i = 1; i < v.size(); ++i)
    {
        if (v[i - 1] * 2 != v[i])
        {
            return false;
        }
    }
    return true;
}

signed main()
{
    int n;
    cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    int q;
    cin >> q;
    vector <int> b(q), ans1(q), ans2(q);
    for (int i = 0; i < q; ++i)
        cin >> b[i];
    if (check(a) && n == 60)
    {
        for (int i = 0; i < n; ++i)
            --a[i];
        for (int i = 0; i < q; ++i)
        {
            ans2[i] = upper_bound(a.begin(), a.end(), b[i]) - a.begin() - 1;
            ans1[i] = a[ans2[i]];
        }
    }
    else
    {
        for (int i = 0; i < q; ++i)
        {
            for (int j = 1, p; j <= b[i]; ++j)
            {
                p = 0;
                for (int k = n - 1, w = j; k > -1; --k)
                {
                    p += w / a[k];
                    w %= a[k];
                }
                if (p > ans2[i])
                {
                    ans1[i] = j;
                    ans2[i] = p;
                }
            }
        }
    }
    for (int i = 0; i < q; ++i)
        cout << ans1[i] << " " << ans2[i] << endl;
    return 0;
}
