#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

inline int min(int a, int b) {return a < b ? a : b;}
inline int max(int a, int b) {return a > b ? a : b;}

int main()
{
    int n, m, s;
    cin >> n >> m >> s;
    int a[m][n], p[m][2*n], t[m][2*n], s1[m][2*n], s2[m][2*n], val[m][2*n];
    for (int i = 0; i < m; ++i)
    {
        fill(p[i], p[i] + 2 * n, -1);
        fill(s1[i], s1[i] + 2 * n, -1);
        fill(s2[i], s2[i] + 2 * n, -1);
        for (int j = 0; j < n - 1; ++j)
        {
            int a, b;
            cin >> a >> b >> t[i][n+j], --a, --b;
            if (b < a)
                swap(a, b);
            p[i][s2[i][p[i][s1[i][n+j]=a]=n+j]=b] = n + j;
        }
    }
    for (int i = 0; i < m; ++i)
        for (int j = 0; j < n; ++j)
            cin >> a[i][j];
    if (n <= 2)
    {
        vector<int> v1, v2;
        for (int i = 0; i < m; ++i)
            if (t[i][2] == 1)
                v1.push_back(min(a[i][s1[i][2]], a[i][s2[i][2]]));
            else
                v2.push_back(max(a[i][s1[i][2]], a[i][s2[i][2]]));
        sort(v1.begin(), v1.end());
        sort(v2.begin(), v2.end());
        /*cout << "v1: ";
        for (int x: v1)
            cout << x << ' ';
        cout << "\nv2: ";
        for (int x: v2)
            cout << x << ' ';
        cout << '\n';*/
        for (int i = 0; i <= m; ++i)
        {
            int l = i, r = m + 1, mid;
            while (r - l > 1)
            {
                mid = (l + r) / 2;
                int cnt = (lower_bound(v1.begin(), v1.end(), i) - v1.begin()) + (lower_bound(v2.begin(), v2.end(), mid) - v2.begin());
                if (cnt > s)
                    r = mid;
                else
                    l = mid;
            }
            //cout << "now " << i << ' ' << l << ' ';
            //cout << (lower_bound(v1.begin(), v1.end(), i) - v1.begin()) << ' ';
            //cout << (lower_bound(v2.begin(), v2.end(), l) - v2.begin()) << '\n';
            if ((lower_bound(v1.begin(), v1.end(), i) - v1.begin()) + (lower_bound(v2.begin(), v2.end(), l) - v2.begin()) == s)
            {
                //cout << "sum " << (lower_bound(v1.begin(), v1.end(), i) - v1.begin()) + (lower_bound(v2.begin(), v2.end(), l) - v2.begin()) << ", s " << s << '\n';
                cout << i << ' ' << l;
                return 0;
            }
        }
    }
    return 1;
}
