#include <iostream>
#define int long long
using namespace std;
const int inf = 1e18;

inline int max(int a, int b) {return a > b ? a : b;}
inline int max(int a, int b, int c, int d) {return max(max(a, b), max(c, d));}

int calc(int n, int* a)
{
    int dp[4][n][4];
    for (int i = 0; i < 4; ++i)
    {
        dp[i][i][0] = bool(i) * a[0] + bool(i > 1) * a[1] + bool(i > 2) * a[2];
        dp[i][i][1] = dp[i][i][2] = dp[i][i][3] = -inf;
        for (int j = i + 1; j < n; ++j)
            dp[i][j][0] = max(dp[i][j-1][0], dp[i][j-1][1], dp[i][j-1][2], dp[i][j-1][3]),
            dp[i][j][1] = a[j] + dp[i][j-1][0],
            dp[i][j][2] = a[j] + dp[i][j-1][1],
            dp[i][j][3] = a[j] + dp[i][j-1][2];
    }
    int ans = 0;
    for (int i = 0; i < 4; ++i)
        for (int j = 0; j < 4 - i; ++j)
            ans = max(ans, dp[i][n-1][j]);
    return ans;
}

signed main()
{
    int n;
    cin >> n;
    int a[n];
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    int q;
    cin >> q;
    int p[q], v[q];
    for (int i = 0; i < q; ++i)
        cin >> p[i] >> v[i];
    cout << calc(n, a) << '\n';
    for (int i = 0; i < q; ++i)
        a[--p[i]] = v[i], cout << calc(n, a) << '\n';
    return 0;
}
