def bin_search(l, r, x):
    while r - l > 1:
        m = (r + l) // 2
        if intervals[m] < x:
            l = m
        else:
            r = m
    return l


def count_limit(time):
    if time >= sum(roads_time):
        return 0
    return length_roads[0] / time - speed_limit[0]


n = int(input())
speed_limit = list(map(int, input().split()))
length_roads = list(map(int, input().split()))
roads_time = []
for i in range(n):
    roads_time.append(length_roads[i] / speed_limit[i])

m = int(input())
intervals = []
for _ in range(m - 1):
    intervals.append(int(input()))
cost = []
for _ in range(m):
    cost.append(int(input()))

for _ in range(int(input())):
    time_in, time_out = list(map(int, input().split()))
    time = time_out - time_in
    more_limit = count_limit(time)
    if more_limit == 0:
        print(0)
    else:
        x = bin_search(-1, m, more_limit)
        print(cost[x])