def bin_search(l, r, x):
    while r - l > 1:
        m = (r + l) // 2
        if intervals[m] <= x:
            l = m
        else:
            r = m
    return l + 1


def bin_search1(l, r, time):
    for _ in range(10):
        m = (r + l) // 2
        lol = 0
        for i in range(n):
            lol += length_roads[i] / (speed_limit[i] + m)
        if lol < time:
            r = m
        else:
            l = m
    return l


def count_limit(time):
    if time >= sum(roads_time):
        return 0
    return bin_search1(-1, 10 ** 6, time)


n = int(input())
speed_limit = list(map(int, input().split()))
length_roads = list(map(int, input().split()))
roads_time = []
for i in range(n):
    roads_time.append(length_roads[i] / speed_limit[i])

m = int(input())
intervals = list(map(int, input().split()))
cost = list(map(int, input().split()))

for _ in range(int(input())):
    time_in, time_out = list(map(int, input().split()))
    time = time_out - time_in
    more_limit = count_limit(time)
    if more_limit == 0:
        print(0)
    else:
        x = bin_search(-1, m - 1, more_limit)
        print(cost[x])



