import sys


n = int(sys.stdin.readline().strip())
speed_limit = list(map(int, sys.stdin.readline().strip().split()))
length_roads = list(map(int, sys.stdin.readline().strip().split()))
roads_time = []
for i in range(n):
    roads_time.append(length_roads[i] / speed_limit[i])

m = int(sys.stdin.readline().strip())
if n == 1 or m == 1:
    def bin_search(l, r, x):
        while r - l > 1:
            m = (r + l) // 2
            if intervals[m] <= x:
                l = m
            else:
                r = m
        return l + 1


    def count_limit(time):
        if time >= sum(roads_time):
            return 0
        return length_roads[0] / time - speed_limit[0]


    intervals = list(map(int, input().split()))
    cost = list(map(int, input().split()))

    for _ in range(int(input())):
        time_in, time_out = list(map(int, input().split()))
        time = time_out - time_in
        more_limit = count_limit(time)
        if more_limit == 0:
            print(0)
        else:
            x = bin_search(-1, m, more_limit)
            print(cost[x])
else:

    def bin_search(l, r, x):
        while r - l > 1:
            m = (r + l) // 2
            if intervals[m] <= x:
                l = m
            else:
                r = m
        return l + 1


    def bin_search1(l, r, time):
        for _ in range(30):
            m = (r + l) // 2
            lol = 0
            for i in range(n):
                lol += length_roads[i] / (speed_limit[i] + m)
            if lol < time:
                r = m
            else:
                l = m
        return l


    def count_limit(time):
        if time >= sum(roads_time):
            return 0
        return bin_search1(-1, 10 ** 6, time)


    intervals = list(map(int, sys.stdin.readline().strip().split()))
    cost = list(map(int, sys.stdin.readline().strip().split()))

    for _ in range(int(sys.stdin.readline().strip())):
        time_in, time_out = list(map(int, sys.stdin.readline().strip().split()))
        time = time_out - time_in
        more_limit = count_limit(time)
        if more_limit == 0:
            print(0)
        else:
            x = bin_search(-1, m - 1, more_limit)
            print(cost[x])
