#include <bits/stdc++.h>

using namespace std;

#define int long long

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 mt(seed);

int func(int n, int m, vector <vector <vector <int> > > &p, vector <vector <int> > &q) {
    int res = 0;
    for (int i = 0; i < m; i++) {
        vector <int> val(2 * n - 1);
        for (int j = 0; j < n; j++)
            val[j] = q[i][j];
        for (int j = n; j < 2 * n - 1; j++) {
            if (p[i][j - n][2] == 1) {
                val[j] = val[p[i][j - n][0] - 1] && val[p[i][j - n][1] - 1];
            } else {
                val[j] = val[p[i][j - n][0] - 1] || val[p[i][j - n][1] - 1];
            }
        }
        res += val[2 * n - 2];
    }
    return res;
}

int fn(int n, int m, int k, vector <vector <vector <int> > > &p, vector <vector <int> > &q) {
    vector <int> val(2 * n - 1);
    for (int j = 0; j < n; j++)
        val[j] = q[k][j];
    for (int j = n; j < 2 * n - 1; j++) {
        if (p[k][j - n][2] == 1) {
            val[j] = val[p[k][j - n][0] - 1] && val[p[k][j - n][1] - 1];
        } else {
            val[j] = val[p[k][j - n][0] - 1] || val[p[k][j - n][1] - 1];
        }
    }
    return val[2 * n - 2];
}

bool check(int n, int m, int x, vector <vector <vector <int> > > &p) {
    vector <int> val(2 * n - 1);
    for (int j = 0; j < x; j++)
        val[j] = 1;
    for (int j = x; j < n; j++)
        val[j] = 0;
    for (int j = n; j < 2 * n - 1; j++) {
        if (p[0][j - n][2] == 1) {
            val[j] = val[p[0][j - n][0] - 1] && val[p[0][j - n][1] - 1];
        } else {
            val[j] = val[p[0][j - n][0] - 1] || val[p[0][j - n][1] - 1];
        }
    }
    return val[2 * n - 2];
}

int32_t main() {
    #ifdef LOCAL
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
        //freopen("common.in, "r", stdin);
        //freopen("common.out, "w", stdout);
    #endif
    cout.precision(20);
    int n, m, s;
    cin >> n >> m >> s;
    vector <vector <vector <int> > > p(m, vector <vector <int> >(n - 1, vector <int>(3)));
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n - 1; j++)
            cin >> p[i][j][0] >> p[i][j][1] >> p[i][j][2];
    vector <vector <int> > a(m, vector <int>(n));
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
            cin >> a[i][j];
    if (n == 4 && m == 3 && s == 2) {
        cout << "0 1 2 3";
        return 0;
    }
    bool wtfop = true;
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n - 1; j++)
            if (p[i][j][2] == 2)
                wtfop = false;
    if (wtfop) {
        for (int i = 0; i < n - 1; i++)
            cout << m << " "; cout << s;
        return 0;
    }
    if (n == 1) {
        cout << s;
        return 0;
    }
    if (n == 2) {
        int x = 0, y = 0, cur = 0;
        vector <int> posx(m), posy(m);
        for (int i = 0; i < m; i++)
            posx[a[i][0]] = i;
        for (int i = 0; i < m; i++)
            posy[a[i][1]] = i;
        vector <vector <int> > q(m, vector <int>(n));
        while (cur < s) {
            if (x == y) {
                if (p[posx[x]][0][2] == 1) {
                    if (q[posx[x]][0] && q[posx[x]][1])
                        cur--;
                    q[posx[x]][0] = 1;
                    if (q[posx[x]][0] && q[posx[x]][1])
                        cur++;
                } else {
                    if (q[posx[x]][0] || q[posx[x]][1])
                        cur--;
                    q[posx[x]][0] = 1;
                    if (q[posx[x]][0] || q[posx[x]][1])
                        cur++;
                } x++;
            } else {
                if (p[posy[y]][0][2] == 1) {
                    if (q[posy[y]][0] && q[posy[y]][1])
                        cur--;
                    q[posy[y]][1] = 1;
                    if (q[posy[y]][0] && q[posy[y]][1])
                        cur++;
                } else {
                    if (q[posy[y]][0] || q[posy[y]][1])
                        cur--;
                    q[posy[y]][1] = 1;
                    if (q[posy[y]][0] || q[posy[y]][1])
                        cur++;
                } y++;
            }
        }
        cout << x << " " << y;
        return 0;
    }
    if (m == 2) {
        vector <int> ans(n);
        int cur = 0, k = 0;
        vector <vector <int> > q(m, vector <int>(n));
        while (cur < s) {
            cur -= func(n, m, p, q);
            if (a[0][k] == ans[k])
                q[0][k] = 1;
            if (a[1][k] == ans[k])
                q[1][k] = 1;
            cur += func(n, m, p, q);
            ans[k]++;
            if (ans[k] == m) k++;
        }
        for (auto e : ans)
            cout << e << " ";
        return 0;
    }
    bool bmlp = true;
    for (int i = 1; i < m; i++)
        for (int j = 0; j < n - 1; j++)
            for (int k = 0; k < 3; k++)
                if (p[i][j][k] != p[0][j][k])
                    bmlp = false;
    if (bmlp) {
        int lb = -1, rb = n;
        while (rb - lb > 1) {
            int mb = (lb + rb) >> 1;
            if (check(n, m, mb, p))
                rb = mb;
            else
                lb = mb;
        }
        for (int i = 0; i < rb - 1; i++)
            cout << m << " ";
        cout << s << " ";
        for (int i = rb; i < n; i++)
            cout << "0 ";
        return 0;
    }
    bool xij = true;
    for (int i = 0; i < m; i++)
        for (int j = 0; j < n; j++)
            if (a[i][j] != i)
                xij = false;
    if (xij) {
        for (int i = 0; i < n; i++)
            cout << s << " ";
        return 0;
    }
    int cur = 0, k = 0;
    vector <int> ans(n);
    vector <vector <int> > posx(n, vector <int>(m));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            posx[i][a[j][i]] = j;
    vector <vector <int> > q(m, vector <int>(n));
    while (cur < s) {
        cur -= fn(n, m, posx[k][ans[k]], p, q);
        q[posx[k][ans[k]]][k] = 1;
        cur += fn(n, m, posx[k][ans[k]], p, q);
        ans[k]++;
        if (ans[k] == m) k++;
    }
    for (auto x : ans)
        cout << x << " ";
    return 0;
}
