#include <bits/stdc++.h>

using namespace std;

#define int long long

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937 mt(seed);

const int MAXN = 2e5 + 9;

int32_t main() {
    #ifdef LOCAL
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
        //freopen("common.in, "r", stdin);
        //freopen("common.out, "w", stdout);
    #endif
    cout.precision(20);
    int n; cin >> n;
    vector <int> a(n);
    for (int i = 0; i < n; i++)
        cin >> a[i];
    bool powsof2 = true;
    for (int i = 0; i < n; i++)
        if (a[i - 1] * 2 != a[i])
            powsof2 = false;
    if (powsof2) {
        int q; cin >> q;
        for (int iq = 0; iq < q; iq++) {
            int b; cin >> b;
            int pw = 0, ans = 0, cur = 0;
            while (cur < n && pw + a[cur] <= b) {
                pw += a[cur];
                ans++; cur++;
            }
            if (cur == n) {
                while (pw != b) {
                    ans += (b - pw) / a[cur];
                    pw += ((b - pw) / a[cur]) * a[cur];
                    cur--;
                }
            }
            cout << pw << " " << ans << "\n";
        }
        return 0;
    }
    vector <int> dp(MAXN);
    int cmax = 0;
    for (int i = 1; i < MAXN; i++) {
        if (cmax + 1 < n && a[cmax + 1] <= i)
            cmax++;
        dp[i] = dp[i - a[cmax]] + 1;
    }
    int q; cin >> q;
    for (int iq = 0; iq < q; iq++) {
        int b; cin >> b;
        int ans = 0, ansi = 0;
        for (int i = 0; i <= b; i++) {
            if (dp[i] > ans) {
                ans = dp[i];
                ansi = i;
            }
        }
        cout << ansi << " " << ans << "\n";
    }
    return 0;
}
