#include<iostream>
#include<algorithm>
#include<vector>



using namespace std;


long double EPS = 0.0000001;
int main() {
    int N, M, Q;
    cin >> N;
    vector<int> L(N), V(N);
    for (int i = 0; i < N; ++i)
        cin >> L[i];
    for (int i = 0; i < N; ++i)
        cin >> V[i];
    vector<pair<double, int>>sor(N);
    for (int i = 0; i < N; ++i) {
        sor[i].first = L[i] / (L[i] / V[i] - EPS) - V[i];
        sor[i].second = i;
    }
    sort(sor.begin(), sor.end());
    int best = sor[N - 1].second;
    cin >> M;
    vector<int>A(M - 1), F(M);
    if (M == 1)
        getchar();
    else {
        for (int i = 0; i < M - 1; ++i)
            cin >> A[i];
    }
    for (int i = 0; i < M; ++i)
        cin >> F[i];
    cin >> Q;
    vector<pair<int, int>>car(Q);
    for (int i = 0; i < Q; ++i)
        cin >> car[i].first >> car[i].second;
    if (N == 1 and M == 1) {
        double t = L[0] / V[0];
        for (int i = 0; i < Q; ++i) {
            if (car[i].second - car[i].first < t)
                cout << F[0] << '\n';
            else
                cout << 0 << '\n';
        }
    } else if (N == 1) {
        for (int i = 0; i < Q; ++i) {
            double e = L[0] / (car[i].second - car[i].first) - V[0];
            if (e <= 0)
                cout << 0 << '\n';
            else {
                int l = -1;
                int r = M - 1;
                while ((r - l) > 1) {
                    int mid = (l + r) / 2;
                    if (e > A[mid])
                        l = mid;
                    else
                        r = mid;
                }
                cout << F[r] << '\n';
            }

        }
    }
}
   