#include<iostream>
#include<algorithm>
#include<vector>
#include<string>
using namespace std;
long double f(double x, int n, vector<int>& L, vector<int> &V) {
    double ans = 0;
    for (int i = 0; i < n; ++i) {
        ans += (double)(L[i] / (V[i] + x));
    }
    return ans;
}

long double EPS = 0.0000001;

int main() {
    int N, M, Q;
    cin >> N;
    vector<int> L(N), V(N);
    for (int i = 0; i < N; ++i) {
        cin >> V[i];
    }
    for (int i = 0; i < N; ++i) {
        cin >> L[i];
    }
    cin >> M;
    vector<int>A(M - 1), F(M);
    if (M == 1) {
        string s;
        getline(cin, s);
        char c;
        c = getchar();
    }
    else {
        for (int i = 0; i < M - 1; ++i) {
            cin >> A[i];
        }
    }
    for (int i = 0; i < M; ++i) {
        cin >> F[i];
    }
    cin >> Q;
    
    vector<pair<int, int>>car(Q);
    for (int i = 0; i < Q; ++i) {
        cin >> car[i].first >> car[i].second;
    }
    double t_pol = 0;

    for (int i = 0; i < N; ++i) {
        t_pol += (double)(L[i] / V[i]);
    }

    // cout << t_pol << '\n';
    for (int i = 0; i < Q; ++i) {
        if (car[i].second - car[i].first >= t_pol) {
            cout << 0 << '\n';
        }
        else {
            int dt = (car[i].second - car[i].first);
            double l = 0;
            double r = 1000000;
            while ((r - l) > 0.000001) {
                double mid = (l + r) / 2;
                if (f(mid, N, L, V) < dt)
                    r = mid;
                else {
                    l = mid;
                }
            }
            double e = (l + r) / 2;
            int l_ = -1;
            int r_ = M - 1;
            while ((r_ - l_) > 1) {
                int mid = (l_ + r_) / 2;
                if (e > A[mid])
                    l_ = mid;
                else
                    r_ = mid;
            }
            cout << F[r_] << '\n';
        }
    }
}
   