#include <bits/stdc++.h>


using namespace std;
typedef long long ll;
typedef vector<ll> vl;
typedef pair<ll, ll> pl;

#define divup(x, y) ((x + y - 1) / y)

ll gcd(ll a, ll b) {
    while(b != 0) {
        ll temp = b;
        b = a % b;
        a = temp;
    }

    return a;
}

ll lcm(ll a, ll b) {
    return (a / gcd(a, b)) * b;
}

#warning check 10**9 in addfrac!
pair<ll, ll> addfrac(pair<ll, ll> a, pair<ll, ll> b) {
    ll enumc = (a.first * b.second) + (b.first * a.second);
    ll denomc = a.second * b.second;
    ll gv = gcd(enumc, denomc);

    return make_pair(enumc / gv, denomc / gv);
}

int main() {
    ll n; cin >> n;

    vector<ll> v(n);
    for(ll i = 0; i < n; i++) cin >> v[i];

    vector<ll> l(n);
    for(ll i = 0; i < n; i++) cin >> l[i];

    ll m; cin >> m;

    vector<ll> a(m);
    a[0] = 0;
    for(ll i = 1; i < m; i++) cin >> a[i];


    vector<ll> f(m + 1);
    f[0] = 0;
    for(ll i = 1; i < m + 1; i++) cin >> f[i];

    pair<ll, ll> tnorm0 = make_pair(0, 1);
    for(ll i = 0; i < n; i++) tnorm0 = addfrac(tnorm0, make_pair(l[i], v[i]));

    pair<ll, ll> tnormmx = make_pair(0, 1);
    for(ll i = 0; i < n; i++) tnormmx = addfrac(tnormmx, make_pair(l[i], v[i] + a[m - 1]));

    ll q; cin >> q;
    for(ll testi = 0; testi < q; testi++) {
        ll si, ti; cin >> si >> ti;
        ll dt = ti - si;
        // test all-ok
        if(dt * tnorm0.second >= tnorm0.first) {
            cout << "0\n";
            continue;
        }

        if(dt * tnormmx.second < tnormmx.first) {
            cout << f[m] << '\n';
            continue;
        }

        // cout << "not-0: ";

        ll bsl = -1, bsr = m - 1;
        while(bsl + 1 < bsr) {
            ll cv = bsl + (bsr - bsl) / 2;

            pair<ll, ll> tnorm = make_pair(0, 1);
            for(ll i = 0; i < n; i++) tnorm = addfrac(tnorm, make_pair(l[i], v[i] + a[cv]));

            if(dt * tnorm.second >= tnorm.first) bsr = cv;
            else bsl = cv;
        }

        cout << f[bsr] << '\n';
    }

    return 0;
}
