#include <iostream>
#include <vector>
long long int max(long long int a, long long int b)
{
    return a > b ? a : b;
}
long long int min(long long int a, long long int b)
{
    return a < b ? a : b;
}
int lower(std::vector<long long int>& vec, int b)
{
    int l = 0, r = vec.size() - 1;
    while (l < r)
    {
        if (l == r - 1)
        {
            if (vec[r] > b)
                return l;
            return r;
        }
        int med = (l + r) / 2;
        if (vec[med] <= b)
            l = med;
        else
            r = med;
    }
}
std::pair<long long int, long long int> max(const std::pair<long long int, long long int> &a,const std::pair<long long int, long long int>& b)
{
    return a.first > b.first ? a : b;
}
std::pair<long long int, long long int> amount(long long int sum, std::vector<long long int> a, std::vector < std::pair<long long int, long long int>>& amounts_on_borders, int ab_ind = -1)
{
    if (sum == 0)
        return { 0, 0 };
    if (a.size() < 2 || sum < a[1])
        return { sum, sum };
    if (ab_ind == -1)
        ab_ind = lower(a, sum);

    if (ab_ind < amounts_on_borders.size() - 1 && sum == amounts_on_borders[ab_ind + 1].second)
        return amounts_on_borders[ab_ind + 1];
    
    long long int nb = sum / a[ab_ind];
    auto res = amount(sum - nb * a[ab_ind], a, amounts_on_borders);
    std::pair<long long int, long long int> th_am = { nb + res.first, nb * a[ab_ind] + res.second};
    if (nb > 1)
    {
        --nb;
        res = amount(sum - nb * a[ab_ind], a, amounts_on_borders);
        std::pair<long long int, long long int> els_am = { nb + res.first, nb * a[ab_ind] + res.second };
        return max(th_am, max(els_am, amounts_on_borders[ab_ind]));
    }
    return max(th_am, amounts_on_borders[ab_ind]);

}
int main()
{
    int n;
    std::cin >> n;
    std::vector<long long int> a(n);
    std::vector<std::pair<long long int, long long int>> amounts_on_borders(n);
    for (int i = 0; i < n; ++i)
    {
        std::cin >> a[i];
        if (i > 0)
        {
            amounts_on_borders[i] = amount(a[i] - 1, a, amounts_on_borders, i - 1);
        }
        else
            amounts_on_borders[i] = { 0,0 };
    }
    int q;
    std::cin >> q;
    for (int i = 0; i < q; ++i)
    {
        long long int b;
        std::cin >> b;
        auto res = amount(b, a, amounts_on_borders);
        std::cout << res.second << ' '<< res.first << std::endl;
    }
}