#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <string>
#include <algorithm>


using namespace std;

signed main()
{
    int n, x1;
    cin >> n >> x1;
    vector<vector<int>> v(3001);
    for (int i = 1; i <= 3000; i++)
    {
        for (int j = 1; j * j <= i; j++)
        {
            if (i % j == 0)
            {
                v[i].push_back(j);
            }
        }
        sort(v[i].begin(), v[i].end());
    }
    int ans = 0;
    map<pair<pair<int, int>, pair<int, int>>, int> mp;
    for (int i = 1; i <= n; i++)
    {
        int j = n - i;
        for (int q = 0; q < v[i].size(); q++)
        {
            for (int f = 0; f < v[j].size(); f++)
            {
                int x = v[i][q];
                int y = v[j][f];
                if (v[i][q] < v[j][f] && !mp[{ {x, i / x}, { y, j / y }}] && i / x + y / x != x1 && y != x1)
                {
                    ans++;
                    mp[{ {x, i / x}, { y, j / y }}] = 1;
                }
                if (v[i][q] < j / v[j][f] && !mp[{ {x, i / x}, { j / y, y }}] && i /x + y != x1 && j / y != x1)
                {
                    ans++;
                    mp[{ {x, i / x}, {j / y, y}}] = 1;
                }
                if (i / v[i][q] < j / v[j][f] && !mp[{ {i / x, x}, { j / y, y }}] && x + y != x1 && j / y != x1)
                {
                    ans++;
                    mp[{ {i / x, x}, { j / y, y }}] = 1;
                }
                if (i / v[i][q] < v[j][f] && !mp[{ {i / x, x}, { y, j / y }}] && x + j / y != x1 && y != x1)
                {
                    mp[{ {i / x, x}, { y, j / y }}] = 1;
                    ans++;
                }
            }
        }
        
    }
    cout << ans;
}