#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <string>
#include <algorithm>


using namespace std;

#define int long long

signed main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    vector<int> pr(n + 1);
    vector<int> cnt(n + 1);
    for (int i = 1; i < n; i++)
    {
        pr[i] = ((a[i] - pr[i - 1] - 1) / a[i - 1]) * a[i - 1] + pr[i - 1];
        cnt[i] = cnt[i - 1] + ((a[i] - pr[i - 1] - 1) / a[i - 1]);
    }
    int q;
    cin >> q;
    while (q--)
    {
        int b;
        cin >> b;
        int l = 0, r = n;
        while (l + 1 < r)
        {
            int m = (l + r) / 2;
            if (pr[m] <= b)
            {
                l = m;
            }
            else {
                r = m;
            }
        }
        int nb = b - pr[l];
        cout << pr[l] + nb / a[l] * a[l] << " ";
        cout << cnt[l] + nb / a[l] << endl;
    }
}