#include<iostream>
#include<vector>

using namespace std;
int n, m;
vector<long double> v;
vector<long double> l;
vector<long double> a;
vector<int> f;

long double inf = 1e9 + 1e6;
long double eps = 1e-5;
bool check(int mid, long double t) {
    long double time = 0;
    long double e = a[mid];
    for (int i = 0; i < n; i++) {
        if (v[i] + e == 0) {
            time += inf;
        } else {
            time += l[i] / (v[i] + e);
        }
    }
    if (time < t + eps) return true;
    return false;
}

int main() {
    cin >> n;
    v.resize(n);
    l.resize(n);
    for (auto& e:v) {
        cin >> e;
    }
    for (auto& e : l) {
        cin >> e;
    }
    cin >> m;
   
    a.resize(m + 1, 0);
    f.resize(m + 1, 0);
    for (int i = 1; i < m; i++) {
        cin >> a[i];
    }
    for (int i = 1; i <= m; i++) {
        cin >> f[i];
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        long double a, b;
        cin >> a >> b;
        long double t = b - a;
        int l = -1;
        int r = m;
        while (r - l > 1) {
            int mid = (r + l) / 2;
            if (check(mid, t)) {
                r = mid;
            }
            else {
                l = mid;
            }
        }
        cout << f[r] << endl;
    }
}