#include <string>
#include <algorithm>
#include <vector>
#include <iostream>
#include <time.h>
#include <fstream>
#include <set>


using namespace std;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n, m, s;
	cin >> n >> m >> s;
	if (s == 0)
	{
		for (int i = 0; i < n; ++i)
			cout << 0 << " ";
		return 0;
	}
	if (n == 1)
	{
		cout << s << endl;
		return 0;
	}
	vector<vector<int>> ar(m, vector<int>(n, 0));
	vector<vector<vector<int>>> instr(m, vector<vector<int>>(n, vector<int>()));
	vector<pair<int, int>> ar3(m, make_pair(0, 0));
	for (int i = 0; i < m; ++i)
	{
		for (int j = 0; j < n - 1; ++j)
		{
			int a, b, c;
			cin >> a >> b >> c;
			a--, b--;
			instr[i][j] = {a, b, c};
		}
	}
	for (int i = 0; i < m; ++i)
	{
		for (int j = 0; j < n; ++j)
		{
			cin >> ar[i][j];
		}
	}
	set<int> se;
	vector<int> arr;
	int maxelem = 0;
	for (int i = 0; i < m; ++i)
	{
		ar3[ar[i][0]] = {ar[i][1], instr[i][0][2]};
		if (instr[i][0][2] == 2)
		{
			arr.push_back(ar[i][1]);
			maxelem = max(maxelem, ar[i][1]);
		}
	}
	sort(arr.begin(), arr.end());
	if (arr.size() >= s)
	{
		cout << 0 << " " << arr[s - 1] + 1 << endl;
		return 0;
	}
	for (int i = 0; i <= m; ++i)
	{
		if (ar3[i].second == 1)
		{
			arr.push_back(ar3[i].first);
			maxelem = max(maxelem, ar3[i].first);
		}
		if (arr.size() == s)
		{
			cout << i + 1 << " " << maxelem + 1 << endl;
			return 0;
		}
	}
}