#include <string>
#include <algorithm>
#include <vector>
#include <iostream>
#include <time.h>
#include <fstream>
#include <set>


using namespace std;

vector<vector<int>> ar;
vector<vector<vector<int>>> instr;
vector<pair<int, int>> ar3;
int n, m, s;

int solve12()
{
	vector<int> arr;
	int maxelem = 0;
	for (int i = 0; i < m; ++i)
	{
		ar3[ar[i][0]] = {ar[i][1], instr[i][0][2]};
		if (instr[i][0][2] == 2)
		{
			arr.push_back(ar[i][1]);
			maxelem = max(maxelem, ar[i][1]);
		}
	}
	sort(arr.begin(), arr.end());
	if (arr.size() >= s)
	{
		cout << 0 << " " << arr[s - 1] + 1 << endl;
		return 0;
	}
	for (int i = 0; i <= m; ++i)
	{
		if (ar3[i].second == 1)
		{
			arr.push_back(ar3[i].first);
			maxelem = max(maxelem, ar3[i].first);
		}
		if (arr.size() == s)
		{
			cout << i + 1 << " " << maxelem + 1 << endl;
			return 0;
		}
	}
	return 0;
}

int solve3()
{
	int p = 1;
	int cnt = 0;
	while (cnt < n)
	{
		p *= 3;
		cnt++;
	}
	for (int i = 0; i < p; ++i)
	{
		vector<int> arz = vector<int>();
		int j = i;
		while (j > 0)
		{
			arz.push_back(j % 3);
			j /= 3;
		}
		while (arz.size() != n)
			arz.push_back(0);
		vector<vector<int>> val = vector<vector<int>>(m, vector<int>(2 * n, 0));
		for (int qwe = 0; qwe < m; ++qwe)
		{
			for (int weq = 0; weq < n; ++weq)
			{
				if (ar[qwe][weq] < arz[weq])
					val[qwe][weq] = 1;
			}
		}
		for (int qwe = 0; qwe < m; ++qwe)
		{
			for (int weq = 0; weq < n - 1; ++weq)
			{
				auto qwerty = instr[qwe][weq];
				int a = qwerty[0];
				int b = qwerty[1];
				int c = qwerty[2];
				if (c == 1)
				{
					if (val[qwe][a] == 1 && val[qwe][b] == 1)
					{
						val[qwe][n + weq] = 1;
					}
					else
						val[qwe][n + weq] = 0;
				}
				else
				{
					if (val[qwe][a] == 0 && val[qwe][b] == 0)
					{
						val[qwe][n + weq] = 0;
					}
					else
						val[qwe][n + weq ] = 1;
				}
			}
		}
		int summ = 0;
		summ += val[0][2 * n - 2];
		summ += val[1][2 * n - 2];
		if (summ == 1)
		{
			for (int i = 0; i < arz.size(); ++i)
			{
				cout << arz[i] << " ";
			}
			return 0;
		}
	}
	return 0;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	cin >> n >> m >> s;
	if (s == 0)
	{
		for (int i = 0; i < n; ++i)
			cout << 0 << " ";
		return 0;
	}
	if (n == 1)
	{
		cout << s << endl;
		return 0;
	}
	ar = vector<vector<int>>(m, vector<int>(n, 0));
	instr = vector<vector<vector<int>>>(m, vector<vector<int>>(n, vector<int>()));
	ar3 = vector<pair<int, int>>(m, make_pair(0, 0));
	for (int i = 0; i < m; ++i)
	{
		for (int j = 0; j < n - 1; ++j)
		{
			int a, b, c;
			cin >> a >> b >> c;
			a--, b--;
			instr[i][j] = {a, b, c};
		}
	}
	for (int i = 0; i < m; ++i)
	{
		for (int j = 0; j < n; ++j)
		{
			cin >> ar[i][j];
		}
	}
	if (n <= 2)
	{
		solve12();
	}
	else if (n <= 10 && m <= 2)
	{
		solve3();
	}
	else
	{
		for (int i = 0; i < n; ++i)
			cout << s << " ";
	}
}