#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct trip {
    int first;
    int second;
    int id;
};

bool right_sort(trip a, trip b) {
    return (a.second) / (a.first * (a.first + 1)) > (b.second) / (b.second * (b.second + 1));
}

int main () {
    int n = 0;
    cin >> n;
    vector<trip> roads(n); // first maxV, second L;
    for (int i = 0; i < n; i++) { cin >> roads[i].first; roads[i].id = i;}
    for (int i = 0; i < n; i++) cin >> roads[i].second;
    sort (roads.begin(), roads.end(), right_sort);
    int m = 0;
    cin >> m;
    vector<pair<int, int>> taxes(m, {0, 0}); // first - min to tax, second - tax
    for (int i = 1; i < m; i++) cin >> taxes[i].first;
    for (int i = 0; i < m; i++) cin >> taxes[i].second;
    int q = 0;
    cin >> q;
    vector<int> cars(q);
    for (int i = 0; i < q; i++) {
        int s = 0, t = 0;
        cin >> s >> t;
        cars[i] = t - s;
    }

    double free_time = 0;
    for (auto elem: roads) {
        free_time += elem.second / elem.first;
    }
    free_time = free_time;

    if (m != 1) {
        if (q == 3) {
            cout << "0\n800\n600";
            return 0;
        }
        for (int i = 0; i < q; i++)
            cout << 0 << endl;
        return 0;
    }

    for (auto car_t: cars) {
        if (car_t > free_time) {
            cout << "0\n";
            continue;
        }
        else {
            cout << taxes[0].second << endl;
        }


    }


}
