#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

double get_time(vector<pair<int, int>> roads, int add = 0);

int main () {
    int n = 0;
    cin >> n;
    vector<pair<int, int>> roads(n); // first maxV, second L;
    for (int i = 0; i < n; i++) cin >> roads[i].first;
    for (int i = 0; i < n; i++) cin >> roads[i].second;
    int m = 0;
    cin >> m;
    vector<pair<int, int>> taxes(m, {0, 0}); // first - min to tax, second - tax
    for (int i = 1; i < m; i++) cin >> taxes[i].first;
    for (int i = 0; i < m; i++) cin >> taxes[i].second;
    int q = 0;
    cin >> q;
    vector<int> cars(q);
    for (int i = 0; i < q; i++) {
        int s = 0, t = 0;
        cin >> s >> t;
        cars[i] = t - s;
    }

    for (auto car_t: cars) {
        if (car_t > get_time(roads)) {
            cout << "0\n";
            continue;
        }
        for (int index = 0; index < m; index++) {
            if (index + 1 < m) {
                if (get_time(roads, taxes[index + 1].first) < car_t) {
                    cout << taxes[index].second << endl;
                    break;
                }
            }
            else {
                cout << taxes[index].second << endl;
            }
        }

    }

}

double get_time(vector<pair<int, int>> roads, int add) {
    double answ = 0;
    for (auto elem: roads) {
        answ += elem.second / (elem.first + add);
    }
    return answ;
}
