#include <iostream>
#include <vector>

using namespace std;

int bin_search (vector<int>& a, int l, int r);
long long int take_sum(vector<int>& a, int from, int to);

int main () {
    int n = 0;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    cout << bin_search(a, 0, a.size());
    // the best choice - the leastest difference)
}

int bin_search (vector<int>& a, int l, int r) {
    if (r - l <= 1) {
        long long int znak1 = abs (take_sum(a, r, a.end() - a.begin()) - take_sum(a, 0, r));
        long long int znak2 = abs (take_sum(a, l, a.end() - a.begin()) - take_sum(a, 0, l));
        if (znak1 >= znak2) return l;
        else return r;
    }

    int c = (l + r) / 2;
    long long int znak = take_sum(a, c, a.end() - a.begin()) - take_sum(a, 0, c);
    if (znak == 0) return c;
    if (znak < 0) return bin_search(a, l, c);
    else return bin_search(a, c, r);
}

long long int take_sum(vector<int>& a, int from, int to) {
    long long int answ = 0;
    for (int i = from; i < to; i++) {
        answ += a[i];
    }
    return answ;
}
