#include <iostream>
#include <vector>
#include <queue>;

using namespace std;

// count of couputres;
long long int bankomat(vector<long long int>& a, int cash);
int bin_search (vector<long long int>& a, int cash, int l, int r);

int main () {
    int n = 0;
    cin >> n;
    vector<long long int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int q = 0;
    cin >> q;
    queue<pair<int, int>> answ;
    for (int i = 0; i < q; i++) {
        int b = 0;
        cin >> b;

        long long int Max = 0, best = 0;
        for (int i = 1; i <= b; i++) {
            long long int now = bankomat(a, i);
            if (now > Max) {
                Max = now;
                best = i;
            }
        }

        answ.push ({best, Max});
    }
    while (!answ.empty()) {
        cout << answ.front().first << " " << answ.front().second << endl;
        answ.pop();
    }
}

long long int bankomat(vector<long long int>& a, int cash) {
    if (cash == 0) return 0;
    else return 1 + bankomat(a, cash - a[bin_search(a, cash, 0, a.size())]);
}
int bin_search (vector<long long int>& a, int cash, int l, int r) {
    if (r - l <= 1) {
        if (a[r] <= cash) return r;
        else return l;
    }
    int c = (r + l) / 2;
    if (a[c] > cash) return bin_search(a, cash, l, c);
    else return bin_search(a, cash, c, r);
}

