#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


#define int long long


void dvs(int n, vector<int> &d1, vector<int> &d2) {
    for (int i = 1; i * i <= n; ++i) {
        if (n % i == 0) {
            d1.push_back(i);
            d2.push_back(n / i);
        }
    }
}


int get(int a, int b, int t) {
    vector<int> d1, d2;

    dvs(t, d1, d2);

    int res = 0;
    for (int i = 0; i < d1.size(); ++i) {
        if (d1[i] < a && d2[i] < b) {
            ++res;
        }

        if (d1[i] != d2[i] && d1[i] < b && d2[i] < a) {
            ++res;
        }
    }

    return res;
}


signed main() {
    fast_io();

    int n, x;
    cin >> n >> x;

    int answ = 0;

    for (int a = 1; a < n; ++a) {
        if (a == x) {
            continue;
        }

        answ += get(a, a, a * a - n);

        for (int b = 1; b < a; ++b) {
            if (b == x) {
                continue;
            }

            answ += 2 * get(a, b, a * b - n);
        }
    }

    cout << answ;

    return 0;
}
