#include <iostream>
#include <vector>
#include <algorithm>
#include <string>


using namespace std;


void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}


#define int long long


const int INF = (int)5e18;


vector<int> a;


signed main() {
    fast_io();

    int n;
    cin >> n;

    a.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    a.push_back(INF);

    vector<pair<int, int>> keys;
    keys.emplace_back(0, a[1] - 1);
    int curv = a[1] - 1;
    for (int i = 1; i < n; ++i) {
        while (curv + a[i] >= a[i + 1]) {
            ++i;
        }

        curv += a[i];
        int pk = (a[i + 1] - curv) / a[i];

        keys.emplace_back(curv, pk);

        curv += pk * a[i];
    }

    int m = keys.size();

    vector<int> prm(m + 1);
    for (int i = 0; i < m; ++i) {
        prm[i + 1] = prm[i] + keys[i].second + 1;
    }

    int q;
    cin >> q;

    int b;
    while (q--) {
        cin >> b;

        pair<int, int> pp = { b + 1, 0 };
        int ci = lower_bound(keys.begin(), keys.end(), pp) - keys.begin();
        --ci;

        int dd = (min(b, a[ci + 1] - 1) - keys[ci].first) / a[ci];

        int answ = dd * a[ci] + keys[ci].first;

        int res = prm[ci] + dd;

        cout << answ << ' ' << res << '\n';
    }

    return 0;
}
