#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 3e5 + 10, MAGIC = 500;
int n, m, s;
std::vector<std::vector<int>> a, val, pred, state;
struct seg_op
{
	int a, b, op;
};
std::vector<seg_op> v[N];
std::vector<std::pair<int,int>> check[N];
inline int updVal(int i, int j) {
	if (j >= m) {
		if (v[i][j - m].op == 1) {
			val[i][j] = (val[i][v[i][j - m].a] & val[i][v[i][j - m].b]);
		}
		else {
			val[i][j] = (val[i][v[i][j - m].a] | val[i][v[i][j - m].b]);
		}
	}
	return val[i][j];
}
inline int checker1(int x0) {
	int s = 0;
	FOR(i, n) {
		s += (val[i][0] = a[i][0] < x0);
	}
	return s;
}
int checker(int j1, int x) {
	int s = 0;
	FOR(i, n) {
		val[i][j1] = a[i][j1] < x;
		for (int j = m; j < 2 * m - 1; ++j) {
			updVal(i, j);
		}
		s += val[i][2 * m - 2];
	}
	return s;
}
void recountOneState(int i, int j) {
	if (j >= m) {
		int a = v[i][j - m].a, b = v[i][j - m].b;
		if (v[i][j - m].op == 1) {
			if (state[i][a] == 0 || state[i][b] == 0) {
				state[i][j] = 0;
				return;
			}

		}
		else {
			val[i][j] = (val[i][v[i][j - m].a] | val[i][v[i][j - m].b]);
		}
	}
}
void recountState(int j, int x) {

}
void doRec(int lvl, std::vector<int> &x) {
	if (lvl == m) {
		for (auto e : x) {
			std::cout << e << ' ';
		}
		return;
	}
	if (checker(lvl, 0) >= s) {
		x.pb(0);
		doRec(lvl + 1, x);
		return;
	}
	int l = -1, r = n;
	while (r - l > 1) {
		int tm = (l + r) / 2;
		std::vector<int> newX = x;
		if (checker(lvl, tm) >= s) {
			r = tm;
		}
		else {
			l = tm;
		}
	}
	x.pb(r);
	while (x.size() < m) {
		x.pb(n);
	}
	doRec(m, x);
}
int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	std::cin >> m >> n >> s;
	a.resize(n, std::vector<int>(m));
	val.resize(n, std::vector<int>(2 * m - 1, 1));
	pred.resize(n, std::vector<int>(2 * m - 1, -1));
	state.resize(n, std::vector<int>(2 * m - 1, 1));
	FOR(i, n) {
		FOR(j, m - 1) {
			int a1, b1, c1;
			std::cin >> a1 >> b1 >> c1;
			--a1; --b1;
			v[i].pb({a1, b1, c1});
			pred[i][a1] = j + m;
			pred[i][b1] = j + m;
		}
	}
	FOR(i, n) {
		FOR(j, m) {
			std::cin >> a[i][j];
			check[j].pb({a[i][j], i});
		}
	}
	FOR(j, m) {
		std::sort(check[j].begin(), check[j].end());
	}
	std::vector<int> x;
	doRec(0, x);
}