#include <iostream>
#include<vector>
#include<algorithm>
#include<iomanip>
#define ll long long
#define d long double
using namespace std;
ll n, m, k;
vector<ll> v, s;

bool check(ll prev, d time){
    d ans = 0;
    for(ll i = 0; i < n; ++i){
        ans += (d)((d)s[i] / (d)(v[i] + prev));
    }
    return (ans <= time);
}

int main() {
    cin >> n;
    v.resize(n);
    s.resize(n);
    for(ll i = 0; i < n; ++i){
        cin >> v[i];
    }
    for(ll i = 0; i < n; ++i){
        cin >> s[i];
    }
    cin >> m;
    vector<ll> num(m + 1), money(m);
    num[0] = 0;

    for(ll i = 1; i < m; ++i){
        cin >> num[i];
    }
    for(ll i = 0; i < m; ++i){
        cin >> money[i];
    }

    cin >> k;
    vector<ll> time(k);
    for(ll i = 0; i < k; ++i){
        ll st, en;
        cin >> st >> en;
        time[i] = en - st;
    }
    for(ll i = 0; i < k; ++i){
        ll l = -1, r = 1e9;
        while(l + 1 < r){
            ll m = (l + r) / 2;
            if (check(m, time[i])){
                r = m;
            } else {
                l = m;
            }
        }
        if (r == 0){
            cout << 0 << endl;
            continue;
        }
        ll val = r;
        l = -1, r = num.size();
        while(l + 1 < r){
            m = (l + r) / 2;
            if (num[m] < val){
                l = m;
            } else {
                r = m;
            }
        }
        cout << money[l] << endl;
    }
}
/*
3
10 20 30
400 500 600
6
1 5 10 12 16
100 300 600 800 1000 1500
3
10 100
20 70
45 100
 */