#include <iostream>
#include<string>
#include<vector>
#include<algorithm>
#include<cmath>
#include<math.h>
#include<queue>
#include<stack>
#include<set>
#include<unordered_map>
#define ll long long
using namespace std;
ll n;
vector<ll> arr;

ll get_dp(const vector<ll> arr, ll n){
    vector<vector<ll>> dp(n, vector<ll>(4, 0));
    dp[0][0] = 0;
    dp[0][1] = arr[0];
    dp[0][2] = arr[0];
    dp[0][3] = arr[0];
    for(ll i = 1; i < n; ++i){
        dp[i][0] = max({dp[i - 1][0], dp[i - 1][1], dp[i - 1][2], dp[i - 1][3]});
        dp[i][1] = dp[i - 1][0] + arr[i];
        dp[i][2] = (i == 1 ? 0 : dp[i - 2][0]) + arr[i] + arr[i - 1];
        dp[i][3] = (i < 3 ? 0: dp[i - 3][0]) + arr[i] + arr[i - 1] + (i == 1 ? 0: arr[i - 2]);
        //cout << dp[i][0] << " " << dp[i][1] << " " << dp[i][2] << " " << dp[i][3] << endl;
    }

    return max({dp[n - 1][0], dp[n - 1][1], dp[n - 1][2], dp[n - 1][3]});
}


ll get_ans(){
    vector<ll> arr0;
    vector<ll> arr1;
    vector<ll> arr12;
    for(ll i = 1; i < n; ++i){
        arr0.push_back(arr[i]);
    }
    for(ll i = 0; i < n - 1; ++i){
        arr1.push_back(arr[i]);
    }
    for(ll i = 0; i < n; ++i){
        if (i != 1 && i != n - 2){
            arr12.push_back(arr[i]);
        }
    }
    return max({get_dp(arr0, n - 1), get_dp(arr1, n - 1), get_dp(arr12, n - 2)});
}

int main() {
    ll q, player, val;
    cin >> n;
    arr.resize(n, 0);
    for(ll i = 0; i < n; ++i){
        cin >> arr[i];
    }
    cout << get_ans() << endl;
    cin >> q;
    for(ll i = 0; i < q; ++i){
        cin >> player >> val;
        player --;
        arr[player] = val;
        cout << get_ans() << endl;
    }
}