#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <numeric>
#include <random>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <tuple>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;

const ld eps = 1e-9;
const ll INF = 1e15;
const ld pi = atan2(0, -1);
const ll mod = 1e9 + 7;
const ll P = 179, Q = 239;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool equal(ld a, ld b) {
	return abs(a - b) < eps;
}

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}


bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll n, m, k;
vector <bool> used;
vector <ll> pref;

ll get(ll l, ll r) {
	if (!l) return pref[r];
	return pref[r] - pref[l - 1];
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	ll x;
	cin >> n >> x;
	ll cnt = 0;
	for (ll c = 1; c < n; ++c) {
		for (ll d = 1; d < n; ++d) {
			for (ll a = 1; a * a <= n + c * d; ++a) {
				if ((n + c * d) % a == 0) {
					ll f = a, s = (n + c * d) / a;
					if (f > c && f != x && (n + c * d) % f == 0) {
						ll b = (n + c * d) / f;
						if (b > d && b != x) {
							++cnt;
//							cout << a << ' ' << b << ' ' << c << ' ' << d << '\n';
						}
					}
					if (f != s) {
						if (s > c && s != x && (n + c * d) % s == 0) {
							ll b = (n + c * d) / s;
							if (b > d && b != x) {
								++cnt;
//								cout << a << ' ' << b << ' ' << c << ' ' << d << '\n';
							}
						}
					}
				}
			}
		}
	}
	cout << cnt;
	return 0;
}