#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC target("sse4")

#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <numeric>
#include <random>
#include <chrono>
#include <queue>
#include <unordered_map>
#include <tuple>
#include <ctime>

using namespace std;
using ll = long long;
using ld = long double;

const ld eps = 1e-9;
const ll INF = 1e15;
const ld pi = atan2(0, -1);
const ll mod = 1e9 + 7;
const ll P = 179, Q = 239;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

bool equal(ld a, ld b) {
	return abs(a - b) < eps;
}

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}


bool maxi(ld& a, ld b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ld& a, ld b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll n, m, k;
vector <bool> used;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cin >> n;
	vector <ll> a(n);
	bool leq500 = true;
	bool eq60 = true;
	bool pow2 = true;
	for (auto& x : a) {
		cin >> x;
		if (x > 500) leq500 = false;
		if (__builtin_popcount(x) > 1) pow2 = false;
	}
	ll q;
	cin >> q;
	if (leq500) {
		for (int i = 0; i < q; ++i) {
			ll b;
			cin >> b;
			ll ans = 0, value = 0;
			for (int cur = 1; cur <= b; ++cur) {
				ll cpy = cur;
				ll ptr = n - 1;
				ll curans = 0;
				while (cpy) {
					while (cpy >= a[ptr]) {
						cpy -= a[ptr];
						++curans;
					}
					--ptr;
				}
				if (curans > ans) {
					ans = curans;
					value = cur;
				}
			}
			cout << value << ' ' << ans << '\n';
		}
	}
	else if (eq60 && pow2) {
		vector <ll> pref(n);
		partial_sum(a.begin(), a.end(), pref.begin());
		for (int i = 0; i < q; ++i) {
			ll b;
			cin >> b;
			for (int i = n - 1; i >= 0; --i) {
				if (pref[i] <= b) {
					cout << pref[i] << ' ' << i + 1 << '\n';
					break;
				}
			}
		}
	}
	else {

	}
	return 0;
}