#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC optimize("no-stack-protector")

#include <iostream>
#include <vector>

using namespace std;

inline void maxi(long long& a, long long b) noexcept {
	if (b > a) {
		a = b;
	}
}

inline long long mmax(long long a, long long b) noexcept {
	if (a > b) return a;
	return b;
}

long long n;
long long a[40001];
long long dp[4][4][40001];

inline void recalc(int ind) noexcept {
	dp[0][0][1] = dp[0][1][1] = dp[0][2][1] = dp[0][3][1] = 0;
	for (int i = 1 + ind; i <= n; ++i) {
		dp[0][0][i] = mmax(mmax(dp[0][0][(i - 1)], dp[0][1][(i - 1)]), mmax(dp[0][2][(i - 1)], dp[0][3][(i - 1)]));
		dp[0][1][i] = dp[0][0][(i - 1)] + a[i - 1];
		dp[0][2][i] = dp[0][1][(i - 1)] + a[i - 1];
		dp[0][3][i] = dp[0][2][(i - 1)] + a[i - 1];
	}

	dp[1][0][1] = dp[1][1][1] = dp[1][2][1] = dp[1][3][1] = 0;
	for (int i = (2 + ind) % n; i <= n; ++i) {
		dp[1][0][i] = mmax(mmax(dp[1][0][(i - 1)], dp[1][1][(i - 1)]), mmax(dp[1][2][(i - 1)], dp[1][3][(i - 1)]));
		dp[1][1][i] = dp[1][0][(i - 1)] + a[i % n];
		dp[1][2][i] = dp[1][1][(i - 1)] + a[i % n];
		dp[1][3][i] = dp[1][2][(i - 1)] + a[i % n];
	}

	dp[2][0][1] = dp[2][1][1] = dp[2][2][1] = dp[2][3][1] = 0;
	for (int i = (3 + ind) % n; i <= n; ++i) {
		dp[2][0][i] = mmax(mmax(dp[2][0][(i - 1)], dp[2][1][(i - 1)]), mmax(dp[2][2][(i - 1)], dp[2][3][(i - 1)]));
		dp[2][1][i] = dp[2][0][(i - 1)] + a[(i + 1) % n];
		dp[2][2][i] = dp[2][1][(i - 1)] + a[(i + 1) % n];
		dp[2][3][i] = dp[2][2][(i - 1)] + a[(i + 1) % n];
	}

	dp[3][0][1] = dp[3][1][1] = dp[3][2][1] = dp[3][3][1] = 0;
	for (int i = (4 + ind) % n; i <= n; ++i) {
		dp[3][0][i] = mmax(mmax(dp[3][0][(i - 1)], dp[3][1][(i - 1)]), mmax(dp[3][2][(i - 1)], dp[3][3][(i - 1)]));
		dp[3][1][i] = dp[3][0][(i - 1)] + a[(i + 2) % n];
		dp[3][2][i] = dp[3][1][(i - 1)] + a[(i + 2) % n];
		dp[3][3][i] = dp[3][2][(i - 1)] + a[(i + 2) % n];
	}
}

int main() noexcept {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	recalc(1);
	long long ans = 0;
	for (int i = 0; i < 4; ++i) {
		for (int j = 0; j < 4; ++j) {
			maxi(ans, dp[i][j][n]);
		}
	}
	cout << ans << '\n';
	int q;
	cin >> q;
	for (int i = 0; i < q; ++i) {
		int p, v;
		cin >> p >> v;
		--p;
		a[p] = v;
		recalc(p);
		long long ans = 0;
		for (int i = 0; i < 4; ++i) {
			for (int j = 0; j < 4; ++j) {
				maxi(ans, dp[i][j][n]);
			}
		}
		cout << ans << '\n';
	}
	return 0;
}
/*
6
1 2 3 4 5 6
2
6 0
2 5
*/