#include <stdio.h>

int n, m, k;
long long a[40001];
long long dp[4][40001][4];

void recalc() {
	for (int ptr = 0; ptr < 4; ++ptr) {
		dp[ptr][1][0] = dp[ptr][1][1] = dp[ptr][1][2] = dp[ptr][1][3] = 0;
		for (int i = 2; i <= n; ++i) {
		    dp[ptr][i][0] = dp[ptr][i - 1][0];
			for (int j = 1; j < 4; ++j) {
                if (dp[ptr][i - 1][j] > dp[ptr][i][0])
                    dp[ptr][i][0] = dp[ptr][i - 1][j];
				dp[ptr][i][j] = dp[ptr][i - 1][j - 1] + a[((i - 1) + ptr) % n];
			}
		}
	}
}

int main() {
	scanf("%d", &n);
	for (int i = 0; i < n; ++i) {
		scanf("%d", &a[i]);
	}
	recalc();
	long long ans = 0;
	for (int i = 0; i < 4; ++i) {
		for (int j = 0; j < 4; ++j) {
			if (dp[i][n][j] > ans) {
                ans = dp[i][n][j];
			}
		}
	}
	printf("%d\n", ans);
	int q;
	scanf("%d", &q);
	int p, v;
	for (int i = 0; i < q; ++i) {
        scanf("%d %d", &p, &v);
		--p;
		a[p] = v;
		recalc();
		long long ans = 0;
		for (int k = 0; k < 4; ++k) {
			for (int j = 0; j < 4; ++j) {
                if (dp[k][n][j] > ans)
                    ans = dp[k][n][j];
			}
		}
		printf("%d%ll\n", ans);
	}
	return 0;
}
