#include <bits/stdc++.h>

using namespace std;

#define int long long
using ld = long double;


constexpr int INF = 1'000'000'000'000'000;
constexpr ld EPS = 1e-5;

struct ev {
    ld first;
    int second;
    int idx;
};

bool operator<(const ev &a, const ev &b){
    if (a.first == b.first) {
        if (b.second == a.second) {
            return a.idx > b.idx;
        }
        return a.second < b.second;
    }
    return a.first < b.first;
}

void run() {
    int n;
    cin >> n;
    ld d = 0;
    vector<pair<ld, ld>> c(n);
    for (int i = 0; i < n; i++) {
        cin >> c[i].second;
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i].first;
        d += c[i].first / c[i].second;
    }
    sort(c.rbegin(), c.rend());
    int m;
    cin >> m;
    vector<int> a(m + 2), f(m + 2);
    for (int i = 1; i < m; i++) {
        cin >> a[i];
    }
    for (int i = 1; i <= m; i++) {
        cin >> f[i];
    }
    vector<ld> pref(m);
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            pref[i] += (c[j].first) / (a[i] + c[j].second);
        }
    }
    pref.push_back(0);
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        ld s, t;
        cin >> s >> t;
        t -= s;
        if (t - d >= -EPS) {
            cout << "0\n";
            continue;
        }
        int L = 0;
        int R = pref.size() - 1;
        while (L + 1 < R) {
            int mid = L + R >> 1;
            if (t - pref[mid] >= -EPS) {
                R = mid;
            } else {
                L = mid;
            }
        }
        cout << f[R] << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    run();
    return 0;
}