#include <iostream>
#include <string>
#include <algorithm>
#include <math.h>
#include <vector>
#include <iomanip>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <random>

using namespace std;

#define _GLIBCXX_DEBUG

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef pair <int, int> pii;
typedef double db;

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n; cin >> n;
	vector <int> v(n); FR(i, n) cin >> v[i];
	vector <int> l(n); FR(i, n) cin >> l[i];

	int m; cin >> m;
	vector <int> a(m); FOR(i, 1, m) cin >> a[i];
	vector <int> f(m  + 1); FOR(i, 1, m + 1) cin >> f[i];

	vector <db> ans(m);
	FR(i, m) {
	
		FR(j, n) ans[i] += db(l[j]) / (db(v[j]) + db(a[i]));

	}
	
	reverse(all(f));
	reverse(all(ans)); ans.push_back(1e9);

	int q; cin >> q;
	FR(i, q) {
	
		int L, R; cin >> L >> R;
		db d = db(R - L);

		

		//cout << upper_bound(all(ans), d) - ans.begin() << ")\n";

		cout << f[upper_bound(all(ans), d) - ans.begin()] << '\n';

	}

	return 0;
}