#include <iostream>
#include <string>
#include <algorithm>
#include <math.h>
#include <vector>
#include <iomanip>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <random>
#include <bitset>

using namespace std;

#define _GLIBCXX_DEBUG

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) (a.begin(), a.end())

typedef long long ll;
typedef pair <int, int> pii;
typedef double db;


int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n; cin >> n;
	vector <int> a(n + 1); FOR(i, 1, n + 1) cin >> a[i];

	map <int, int> use;

	vector <int> ans(n + 1);

	FOR(i, 1, n + 1) {
	
		//FOR(j, 1, n - i + 2) ans[j]++;
		//FOR(j, 2, i + 1 - use[a[i]]) ans[j]++;

		FOR(L, use[a[i]] + 1, i + 1) FOR(R, i, n + 1) ans[R - L + 1]++;

		use[a[i]] = i;
	}

	FOR(i, 1, n + 1) cout << ans[i] << ' ';

	return 0;

}