#include <iostream>
#include <string>
#include <algorithm>
#include <math.h>
#include <vector>
#include <iomanip>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <random>
#include <bitset>

using namespace std;

#define _GLIBCXX_DEBUG

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) (a.begin(), a.end())

typedef long long ll;
typedef pair <int, int> pii;
typedef double db;


vector <ll> d;

void push(int i, int L, int R, int LL, int RR, ll dlt) {

	//cout << L << ' ' << R << '\n' << LL << ' ' << RR << '\n' << '\n';

	if (R <= LL || L >= RR) return;
	if (LL <= L && RR >= R) { d[i] += dlt; return; }

	//cout << (LL <= L && RR >= R) << '\n';

	int M = (L + R) / 2;

	push(i * 2, L, M, LL, RR, dlt);
	push(i * 2 + 1, M, R, LL, RR, dlt);

}

ll make(int i, int L, int R, int x) {

	//if (R <= x || L >= x) return 0;
	/*if (L == x) return (ans + d[i]);

	int M = (L + R) / 2;

	if (x < M) return make(i * 2, L, M, x, ans + d[i]);
	return make(i * 2 + 1, M, R, x, ans + d[i]);*/

	if (L == x && L + 1 == R) return (d[i]);

	int M = (L + R) / 2;

	if (x < M) return make(i * 2, L, M, x) + d[i];
	return make(i * 2 + 1, M, R, x) + d[i];

}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n; cin >> n;
	vector <int> a(n + 1); FOR(i, 1, n + 1) cin >> a[i];

	map <int, int> use;

	vector <ll> ans(n + 1);
	//vector <int> dp(n + 1);

	ll sz = 1;
	while (sz < n) sz *= 2;

	d.resize(sz * 2);

	FOR(i, 1, n + 1) {

		//FOR(L, use[a[i]] + 1, i + 1) dp[(i - L + 1) - 1]++, dp[n - L + 1]--;

		//FOR(L, use[a[i]] + 1, i + 1) push(1, 0, sz, i - L, i - L + 1, 1), push(1, 0, sz, n - L + 1, n - L + 2, -1);

		push(1, 0, sz, 0, i - use[a[i]], ll(1));
		push(1, 0, sz, n + 1 - i, n + 1 - use[a[i]], ll(-1));

		//push(1, 0, n + 2, 0, i - use[a[i]] + 2, 1);
		//push(1, 0, n + 2, n - i + 1, n - use[a[i]] + 1, -1);

		//dp; d[0];

		use[a[i]] = i;
	}

	//FOR(i, 1, n + 1) ans[i] = ans[i - 1] + dp[i - 1];

	//d[0], dp;

	FOR(i, 1, n + 1) ans[i] = ans[i - 1] + make(1, 0, sz, i - 1);

	FOR(i, 1, n + 1) cout << ans[i] << ' ';

	return 0;

}