#include <iostream>
#include <string>
#include <algorithm>
#include <math.h>
#include <vector>
#include <iomanip>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <random>
#include <bitset>

using namespace std;

#define _GLIBCXX_DEBUG

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) (a.begin(), a.end())

typedef long long ll;
typedef pair <int, int> pii;
typedef double db;

struct A {

	int a, b, p;

};

int n, m, s;

vector <vector <A>> bmlp;
vector <vector <int>> f;

int check(int z1, int z2) {

	int ans = 0;

	FR(i, m) {

		if (bmlp[i][0].p == 2) {

			if (f[i][0] < z1 || f[i][1] < z2) ans++;

		}
		else {

			if (f[i][0] < z1 && f[i][1] < z2) ans++;

		}

	}

	return ans;

}

int che(int z1) {

	int ans = 0;

	FR(i, m) if (f[i][0] < z1) ans++;

	return ans;

}

vector <int> z;
bool ANS = 0;

int Tw_check() {

	int ans = 0;

	vector <bool> val(2 * n);
	FR(i, m) {
	
		FR(j, 2 * n) val[j] = 0;

		FOR(j, 1, n + 1) val[j] = (f[i][j] < z[j - 1]);

		FR(j, n - 1) {
		
			if (bmlp[i][j].p == 2) val[n + j + 1] = val[bmlp[i][j].a] || val[bmlp[i][j].b];
			else val[n + j + 1] = val[bmlp[i][j].a] && val[bmlp[i][j].b];

		}

		if (val[2 * n - 1]) ans++;

	}

	return ans;
}

void rec(int step) {

	if (ANS) return;

	if (step == n) {
	
		if (Tw_check() == s) {
		
			FR(i, step) cout << z[i] << ' ';
			ANS = 1;

		}

		return;

	}
	else FR(i, 4) {

		z[step] = i;
		rec(step + 1);
	}

}

int main() {

	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	cin >> n >> m >> s;

	z.resize(n);

	bmlp.resize(m, vector <A> (n - 1));

	FR(i, m) FR(j, n - 1) cin >> bmlp[i][j].a >> bmlp[i][j].b >> bmlp[i][j].p;

	f.resize(m, vector <int> (n));
	FR(i, m) FR(j, n) cin >> f[i][j];

	if (n == 2) {
		bool ch = 0;

		FR(x, m + 1) {

			FR(y, m + 1) {

				if (check(x, y) == s) {

					cout << x << ' ' << y;
					ch = 1;
					break;

				}

			}

			if (ch) break;
		}
	} 
	else if (n == 1){

		FR(y, m + 1) {

			if (che(y) == s) {

				cout << y;
				break;

			}

		}

	} 
	else {
	
		rec(0);

	}

	return 0;
}