#include <iostream>
#include <string>
#include <algorithm>
#include <math.h>
#include <vector>
#include <iomanip>
#include <set>
#include <queue>
#include <stack>
#include <map>
#include <random>
#include <bitset>

using namespace std;

#define _GLIBCXX_DEBUG

#define FR(i, n) for (int i = 0; i < (n); i++)
#define FOR(i, L, R) for (int i = (L); i < (R); i++)
#define all(a) a.begin(), a.end()

typedef long long ll;
typedef pair <int, int> pii;
typedef long double db;

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n; cin >> n;
    vector <ll> a(n); FR(i, n) cin >> a[i];

    vector <ll> sm(n);
    vector <ll> k(n);

    FOR(i, 1, n) {
    
        k[i] = k[i - 1] + (a[i] - 1) / a[i - 1];
        sm[i] = sm[i - 1] + (k[i] - k[i - 1]) * a[i - 1];

    }
    
    sm.push_back(ll (1e18) + 1);

    int q; cin >> q;
    ll z;
    FR(i, q) {
    
        cin >> z;
        int ind = (lower_bound(all(sm), z) - sm.begin());
        if (sm[ind] > z) ind--;

        ll dlt = (z - sm[ind]) / a[ind];
        cout << sm[ind] + dlt * a[ind] << ' ' << k[ind] + dlt << '\n';

    }

    return 0;
}