#include <iostream>
#include <vector>
#include <string.h>
using namespace ::std;

int main() {
    int n, q, L, R, M, counter = 0;
    long long sum = 0, b;
    cin >> n;
    vector<long long> a(n);
    vector<long long> prefixes_1(n);
    vector<int> prefixes_2(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
    }
    prefixes_1[0] = 0;
    prefixes_2[0] = 0;
    for (int i = 0; i < (n - 1); i++){
        counter += (a[i + 1] - sum) / a[i] + min(1, (a[i + 1] - sum) % a[i]) - 1;
        sum += ((a[i + 1] - sum) / a[i] + min(1, (a[i + 1] - sum) % a[i]) - 1) * a[i];
        prefixes_1[i + 1] = sum;
        prefixes_2[i + 1] = counter;
    }
    cin >> q;
    vector<long long> ans_1(q);
    vector<int> ans_2(q);
    for (int i = 0; i < q; i++){
        cin >> b;
        L = 0;
        R = n - 1;
        while (L < R){
            M = (L + R + 1) / 2;
            if (prefixes_1[M] <= b){
                L = M;
            }
            else{
                R = M - 1;
            }
        }
        ans_1[i] = prefixes_1[L] + (b - prefixes_1[L]) / a[L] * a[L];
        ans_2[i] = prefixes_2[L] + (b - prefixes_1[L]) / a[L];
    }
    for (int j = 0; j < q; j++){
        cout << ans_1[j] << " " << ans_2[j] << endl;
    }
    return 0;
}