#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 2 * 1e5 + 42;
long long a[MAX_N];
long long s[MAX_N];
map < int, vector < int > > pos;
int cnt[MAX_N];
int is_end[MAX_N];
const int INF = 1e9;
vector < int > tree[MAX_N * 4];

void merge(vector < int >& aa, vector < int >& b, vector < int >& c) {
    int l = 0;
    int r = 0;
    while (l < aa.size() || r < b.size()) {
        if (l == aa.size()) {
            c.push_back(b[r]);
            r++;
            continue;
        }
        if (r == b.size()) {
            c.push_back(aa[l]);
            l++;
            continue;
        }
        if (aa[l] < b[r]) {
            c.push_back(aa[l]);
            l++;
            continue;
        }
        c.push_back(b[r]);
        r++;
        continue;
    }
}

void build_tree(int n) {
    for (int i = n; i < 2 * n; i++) {
        tree[i].push_back(cnt[i - n]);
    }
    for (int i = n - 1; i > 0; i--) {
        merge(tree[i * 2], tree[i * 2 + 1], tree[i]);
    }
}

int get(vector < int >& b, int x) {
    int l = -1;
    int r = b.size();
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (b[m] >= x) {
            r = m;
        } else {
            l = m;
        }
    }
    return b.size() - r;
}

int get_ans(int v, int vl, int vr, int l, int r, int x) {
    if (vl >= r || vr <= l) {
        return 0;
    }
    if (l <= vl && vr <= r) {
        //cout << v << " " << l << " " << r << endl;
        return get(tree[v], x);
    }
    int vm = (vl + vr) / 2;
    return get_ans(v * 2, vl, vm, l, r, x) +
            get_ans(v * 2 + 1, vm, vr, l, r, x);
}

int main() {
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        if (pos[a[i]].size() == 0) {
            cnt[i] = INF;
        } else {
            cnt[i] = i - pos[a[i]].back();
        }
        pos[a[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        is_end[pos[a[i]].back()] = 1;
    }
    int st = 1;
    while (st < n) {
        st *= 2;
    }
    int ans_pos = 1;
    s[1] = n;
    build_tree(st);
    //cout << get(tree[5], 2) << endl;
    for (int i = 2; i <= n; i++) {
        s[i] = s[i - 1] - ans_pos;
        s[i] += get_ans(1, 0, st, i - 1, n, i);
        if (is_end[n - i] == 1) {
            ans_pos++;
        }
    }
    for (int i = 1; i <= n; i++) {
        cout << s[i] << " ";
    }
    return 0;
}
