#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 10;
const int MAX_M = 1e5 + 42;
int op[MAX_M][MAX_N];
int a[MAX_M][MAX_N];
int b[MAX_M][MAX_N];
int x[MAX_M][MAX_N];
int val[MAX_M][MAX_N * 2];
int n, m, s;
vector < int > cnt[MAX_M];

void get(vector < int >& z, int i) {
    for (int j = 0; j < n; j++) {
        if (j >= z.size()) {
            val[i][j] = 0;
            continue;
        }
        if (x[i][j] < z[j]) {
            val[i][j] = 1;
        } else {
            val[i][j] = 0;
        }
    }
    for (int j = n; j < 2 * n - 1; j++) {
        if (op[i][j - n] == 1) {
            val[i][j] = (val[i][a[i][j - n]] & val[i][b[i][j - n]]);
        } else {
            val[i][j] = (val[i][a[i][j - n]] | val[i][b[i][j - n]]);
        }
    }
}

int get_all(vector < int >& z) {
    int ans = 0;
    for (int i = 0; i < m; i++) {
        get(z, i);
        ans += val[i][2 * n - 2];
    }
    return ans;
}

bool brute_force(vector < int >& z, int ans) {
    if (ans == s) {
        return 1;
    }
    if (z.size() == n) {
        return 0;
    }
    for (int i = 0; i <= m; i++) {
        z.push_back(i);
        for (int j = 0; j < m; j++) {
            if (x[j][z.size()] == i - 1) {
                ans -= val[j][2 * n - 2];
                get(z, j);
                ans += val[j][2 * n - 2];
            }
        }
        //ans = get_all(z);
        if (brute_force(z, ans)) {
            return 1;
        }
        z.pop_back();
        for (int j = 0; j < m; j++) {
            if (x[j][z.size()] == i - 1) {
                ans -= val[j][2 * n - 2];
                get(z, j);
                ans += val[j][2 * n - 2];
            }
        }
        //ans = get_all(z);
    }
    return 0;
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m >> s;
    if (n > 2) {
        assert(0);
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n - 1; j++) {
            cin >> a[i][j] >> b[i][j] >> op[i][j];
            a[i][j]--;
            b[i][j]--;
        }
    }
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            cin >> x[i][j];
            cnt[x[i][j]].push_back(i);
        }
    }
    if (n == 1) {
        cout << s;
        return 0;
    }
    vector < int > now;
    int ans = get_all(now);
    brute_force(now, ans);
    for (auto i : now) {
        cout << i << " ";
    }
    for (int i = now.size(); i < n; i++) {
        cout << 0 << " ";
    }
    //cout << 0 << " " << 0;
    return 0;
}
