#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 4 * 1e4 + 42;
long long a[MAX_N];
long long dp[MAX_N][42];
int n;

int get_rev(int x) {
    int ans = 0;
    ans = ((x >> 2) & 1) + ((x >> 1) & 1) * 2 + ((x >> 2) & 1) * 4;
    return ans;
}

long long get(int k, int mask) {
    long long ans = 0;
    for (int i = 0; i < 3; i++) {
        if (((mask >> i) & 1) == 1) {
            ans += a[3 - i - 1 + k];
        }
    }
    return ans;
}

bool check(int mask1, int mask2) {
    int sum = 0;
    int mask = mask1 * 8 + mask2;
    for (int i = 0; i < 2 * n; i++) {
        if (((mask >> i) & 1) == 0) {
            sum = 0;
            continue;
        }
        sum++;
        if (sum >= 4) {
            return 0;
        }
    }
    return 1;
}

long long get_ans() {
    long long ans = 0;
    for (int first = 0; first < 8; first++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < 8; j++) {
                dp[i][j] = 0;
            }
        }
        dp[0][first] = get(0, first);
        for (int i = 0; i < n - 3; i++) {
            for (int mask = 0; mask < 8; mask++) {
                //cout << i << " " << mask << " " << dp[i][mask] << endl;
                int new_mask = mask * 2;
                if (new_mask >= 8) {
                    new_mask -= 8;
                }
                dp[i + 1][new_mask] = max(dp[i + 1][new_mask], dp[i][mask]);
                if (mask == 7) {
                    continue;
                }
                new_mask = mask * 2 + 1;
                if (new_mask >= 8) {
                    new_mask -= 8;
                }
                dp[i + 1][new_mask] = max(dp[i + 1][new_mask], dp[i][mask] + a[i + 3]);
            }
        }
        for (int mask = 0; mask < 8; mask++) {
            if (check(mask, first)) {
                ans = max(ans, dp[n - 3][mask]);
            }
        }
    }
    return ans;
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cout << get_ans() << endl;
    int q;
    cin >> q;
    while (q--) {
        int p, v;
        cin >> p >> v;
        p--;
        a[p] = v;
        cout << get_ans() << endl;
    }
    return 0;
}
