#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define ll long long
#define int long long
const int inf = 1e9;
const int mod = 1e9 + 7;

int n;

void read() {
    cin >> n;
}

void solve() {
    for (int y = 1; y < (1ll << 62); ++y) {
        int x = sqrt(n + y * y);
        if (x * x - y * y == n) {
            cout << "Yes\n" << x << " " << y;
            return;
        }
    }
    cout << "No\n";
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}
