#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <cassert>

using namespace std;

#define ll long long
#define int long long
#define F first
#define S second
const int inf = 1e9;
const int mod = 1e9 + 7;
const int SZ = 2e5 + 4;
const double EPS = 1e-5;

int n;
int a[SZ];
int sum = 0;

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sum += a[i];
    }
}

void solve() {
    int mx = 0, ans = -1;
    int l = 0, r = sum;
    for (int i = 0; i < n; ++i) {
        l += a[i];
        r -= a[i];
        if (mx < l * r) {
            ans = i + 1;
            mx = l * r;
        }
    }
    cout << ans;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    read();
    solve();

    return 0;
}
