#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
using namespace std;
#define int long long

void fast_io() {
#ifdef DEBUG
	freopen("in.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

signed main() {
	fast_io();
	int n;
	cin >> n;
	vector<int> v(n);
	for (int &i : v) {
		cin >> i;
	}
	vector<int> l(n);
	for (int &i : l) {
		cin >> i;
	}
	double time = 0;
	for (int i = 0; i < n; i++) {
		time += (double) l[i] / v[i];
	}
	int m;
	cin >> m;
	vector<int> delta(m);
	for (int i = 1; i < m; i++) {
		cin >> delta[i];
	}
	vector<int> fine(m);
	for (int &i : fine) {
		cin >> i;
	}
	int q;
	cin >> q;
	while (q--) {
		int s, f;
		cin >> s >> f;
		int fs = f - s;
		int ans = 0;
		int L = -1, R = m;
		while (R - L > 1) {
			double now = 0;
			int M = (R + L) / 2;
			for (int j = 0; j < n; j++) {
				now += (double) l[j] / (v[j] + delta[M]);
			}
			if (fs < now) { // если я могу дать штраф 
				L = M;
			} else {
				R = M;
			}
		}

		if (L == -1) {
			cout << 0 << endl;
		} else {
			cout << fine[L] << endl;
		}
		/*for (int i = 0; i < m; i++) { 
			double now = 0;
			for (int j = 0; j < n; j++) {
				now += (double) l[j] / (v[j] + delta[i]);
			}
			//cout << fs << " " << now << endl;
			if (fs < now) {
				ans = fine[i];
			} else {
				break;
			}
		}
		cout << ans << endl;*/
	}
	return 0;
}