#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
using namespace std;

void fast_io() {
#ifdef DEBUG
	freopen("in.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}


int main() {
	fast_io();
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	for (int d = 1; d <= n; d++) {
		int ans = 0;
		map<int, int> m;
		set<int> s;
		for (int i = 0; i < d; i++) {
			s.insert(a[i]);
			m[a[i]]++;
		}
		ans += s.size();
		/*for (int i : s) {
			cout << i << " ";
		}
		cout << endl;*/
		for (int i = 1; i + d <= n; i++) {
			m[a[i - 1]]--;
			if (m[a[i - 1]] == 0) {
				s.erase(a[i - 1]);
			}
			m[a[i + d - 1]]++;
			s.insert(a[i + d - 1]);
			ans += s.size();
			/*for (int i : s) {
				cout << i << " ";
			}
			cout << endl;*/
		}

		cout << ans << " ";
	}
	cout << "\n";
	return 0;
}