#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
using namespace std;
#define int long long

void fast_io() {
#ifdef DEBUG
	freopen("in.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

void solve(int n, int x) {
	int ans = 0;
	for (int a = 2; a <= 2 * n; a++) {
		if (a == x) {
			continue;
		}
		for (int b = (n + 1) / a; a + b - 1 <= n; b++) {
			if (b == x) {
				continue;
			}
			int cd = a * b - n;
			for (int c = 1; c <= cd && c < a; c++) {
				if (cd % c == 0) {
					int d = cd / c;
					if (b > d) {
						ans++;
					}
				}
			}

		}
	}
	cout << ans << endl;
}

signed main() {
	fast_io();
	int n, x;
	while (cin >> n >> x) {
		solve(n, x);
	}
	return 0;
}