#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
#define int long long
#define all(c) c.begin(), c.end()
using namespace std;

void fast_io() {
#ifdef DEBUG
	freopen("in.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

int n;
vector<int> a;

int get(int n) {
	int res = 0;
	int i = a.size() - 1;
	while (i >= 0) {
		while (n - a[i] >= 0) {
			n -= a[i];
			res++;
		}
		i--;
	}
	return res;
}

signed main() {
	fast_io();
	int n;
	cin >> n;
	
	a.resize(n);
	for (int &i : a) {
		cin >> i;
	}

	int q;
	cin >> q;
	while (q--) {
		int b;
		cin >> b;
		int ans = 0, cnt = 0;
		for (int i = 1; i <= b; i++) {
			int now = get(i);
			if (now > cnt) {
				cnt = now;
				ans = i;
			}
		}
		cout << ans << " " << cnt << endl;
	}
	return 0;
}

/*

if (n == 4) {
		cout << "2 2\n8 4\n49 9\n";
		return 0;
	}

*/