#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
using namespace std;
#define int long long
#define all(v) v.begin(), v.end()
using pii = pair<int, int>;

void fast_io() {
#ifdef DEBUG
	freopen("in.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}


signed main() {
	fast_io();
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<pii> ans(n);
	vector<int> bord(n), cup(n);
	int now = 0, cnt = 0;
	for (int i = 0; i < n - 1; i++) {
		int k = (a[i + 1] - now) / a[i];
		if ((a[i + 1] - now) % a[i] == 0) {
			k--;
		}
		now += k * a[i];
		cnt += k;
		bord[i] = now;
		cup[i] = cnt;
	}
	/*for (int i : bord) {
		cout << i << " ";
	}
	cout << endl;
	for (int i : cup) {
		cout << i << " ";
	}
	cout << endl;*/
	int q;
	cin >> q;
	while (q--) {
		int x;
		cin >> x;
		int it = upper_bound(all(bord), x) - bord.begin() - 1;
		if (it == -1) {
			cout << x << " " << x << endl;
			continue;
		}
		if (it == n - 1) {
			it--;
		}
		//cout << x << " " << bord[it] << " " << a[it + 1] << " " << ((x - bord[it]) / a[it]) << endl;
		int now = bord[it] + a[it + 1] * ((x - bord[it]) / a[it + 1]);
		int cnt = cup[it] + (x - bord[it]) / a[it + 1];
		cout << now << " " << cnt << endl;
	}
	return 0;
}