#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
using namespace std;
#define int long long
#define all(v) v.begin(), v.end()

void fast_io() {
#ifdef DEBUG
	freopen("in.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}


signed main() {
	fast_io();
	int n;
	cin >> n;
	vector<int> a(n);
	for (int &i : a) {
		cin >> i;
	}
	vector<vector<int>> dp(n, vector<int>(4));
	int ans = 0;
	for (int x = 0; x < 4; x++) {
		for (int i = x + 1; i != x; i++) {
			int j = i - 1;
			i = i % n;
			dp[i][0] = *max_element(all(dp[j]));
			dp[i][1] = dp[j][0] + a[i];
			if (dp[j][1]) {
				dp[i][2] = dp[j][1] + a[i];
			}
			if (dp[j][2]) {
				dp[i][3] = dp[j][2] + a[i];
			}
			if (i == 0) {
				break;
			}
			ans = max(ans, *max_element(all(dp[0])));
		}
	}
	cout << ans << endl;
	int q;
	cin >> q;
	while (q--) {
		cout << "13\n15\n";
		return 0;
	}
	return 0;
}