#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <string>
using namespace std;
#define int long long
#define all(v) v.begin(), v.end()

void fast_io() {
#ifdef DEBUG
	freopen("in.in", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
}

int n;
vector<int> a;

int get() {
	int ans = 0;
	for (int x = 0; x < 4; x++) {
		vector<vector<int>> dp(n, vector<int>(4));
		for (int i = x + 1; ; i++) {
			int j = i - 1;
			i = i % n;
			dp[i][0] = *max_element(all(dp[j]));
			dp[i][1] = dp[j][0] + a[i];
			if (dp[j][1]) {
				dp[i][2] = dp[j][1] + a[i];
			}
			if (dp[j][2]) {
				dp[i][3] = dp[j][2] + a[i];
			}
			if (i == x) {
				break;
			}
		}
		ans = max(ans, *max_element(all(dp[(x - 1 + n) % n])));
	}
	return ans;
}

signed main() {
	fast_io();
	cin >> n;
	a.resize(n);
	for (int &i : a) {
		cin >> i;
	}
	cout << get() << endl;
	int q;
	cin >> q;
	while (q--) {
		int x, val;
		cin >> x >> val;
		a[x - 1] = val;
		cout << get() << endl;
	}
	return 0;
}