#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <queue>
#define int long long

using namespace std;

int mymax(vector<int> a, int x){
    int maxi = 0;
    for (int i = 0; i <= x; ++i) if (a[maxi] < a[i]) maxi = i;
    return maxi;
}

int f(vector<int> a, int x){
    int cou = 0;
    for (int i = a.size() - 1; i >= 0; --i){
        cou += x / a[i];
        x = x % a[i];
    }
    return cou;
}

signed main(){
    int n, q, i, j;
    cin >> n;
    vector<int> a(n);
    for (i = 0; i < n; ++i) cin >> a[i];
    vector<int> dp(1e6, 1e9);
    dp[0] = 0;
    dp[1] = 1;
    for (i = 2; i < dp.size(); ++i){
        dp[i] = f(a, i);
    }
    //for (i = 1; i < 1000; ++i) cout << "dp[" << i << "] = " << dp[i] << endl;
    cin >> q;
    vector<pair<int, int> > ans;
    for (i = 0; i < q; ++i){
        cin >> j;
        ans.push_back(make_pair(mymax(dp, j), dp[mymax(dp, j)]));
    }
    for (i = 0; i < ans.size(); ++i) cout << ans[i].first << " " << ans[i].second << endl;
}
