import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

import static java.lang.Math.*;

public class C {
    static class otr {
        long l, r, st, d;

        otr(int p, int q, int x, int y) {
            l = p;
            r = q;
            st = x;
            d = y;
        }
    }

    static int n;
    static ArrayList pod;
    static BufferedReader in;
    static StringTokenizer st;
    static int inT(){
        return Integer.parseInt(st.nextToken());
    }

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        st = new StringTokenizer(in.readLine());
        PrintWriter out = new PrintWriter(System.out);
        n = inT();
        st = new StringTokenizer(in.readLine());
        int a[] = new int[n];
        for (int i = 0; i < n; ++i) a[i] = inT();
        TreeMap<Integer, Integer> fn = new TreeMap<>();
        pod = new ArrayList();
        for (int i = 0; i < n; i++) {
            if (fn.containsKey(a[i])) {
                int l = fn.get(a[i]);
                int r = i;
                otr up = get_up(l, r);
                if (up.l <= up.r) pod.add(up);
                otr g = get_g(l, r);
                if (g.l <= g.r) pod.add(g);
                otr down = get_down(l, r);
                if (down.l <= down.r) pod.add(down);
                fn.remove(a[i]);
            }
            fn.put(a[i], i);
        }
        int cnt = pod.size();
        otr[] l = new otr[cnt];
        otr[] r = new otr[cnt];
        for (int i = 0; i < cnt; i++) {
            l[i] = (otr) pod.get(i);
            r[i] = (otr) pod.get(i);
        }
        Arrays.sort(l, new Comparator<otr>() {
            @Override
            public int compare(otr o1, otr o2) {
                if (o1.l > o2.l) return 1;
                if (o1.l < o2.l) return -1;
                return 0;
            }
        });

        Arrays.sort(r, new Comparator<otr>() {
            @Override
            public int compare(otr o1, otr o2) {
                if (o1.r > o2.r) return 1;
                if (o1.r < o2.r) return -1;
                return 0;
            }
        });

        long sm = 0;
        long tk = 0;
        long ans[] = new long[n + 1];
        int xL = 0;
        int yR = 0;
        for (int i = 0; i <= n; i++) {
            while (xL < cnt && l[xL].l == i) {
                sm += l[xL].st;
                tk += l[xL].d;
                xL++;
            }
            sm += tk;
            ans[i] = sm;
            while (yR < cnt && r[yR].r == i) {
                tk -= r[yR].d;
                sm -= fk(r[yR]);
                yR++;
            }
        }
        for (int i = 1; i <= n; i++) {
            ans[i] = ((long) (n - i + 1)) * i - ans[i];
            out.print(ans[i] + " ");
        }
        out.close();
    }

    private static long fk(otr tk) {
        long l = tk.l;
        long r = tk.r;
        long d = r - l + 1;
        long st = tk.st + tk.d;
        long fn = tk.st + d * tk.d;
        return fn;
    }

    private static otr get_down(int l, int r) {
        int f = max(n - 1 - l + 1, r - 0 + 1);
        int st = min(n - 1 - l + 1, r - 0 + 1);
        st++;
        int d = r - l + 1;
        int rz = st - d;
        return new otr(f + 1, n, rz, -1);
    }

    private static otr get_g(int l, int r) {
        int st = min(n - 1 - l + 1, r - 0 + 1);
        int f = max(n - 1 - l + 1, r - 0 + 1);
        st++;
        int d = r - l + 1;
        return new otr(st, f, st - d, 0);
    }

    private static otr get_up(int l, int r) {
        int st = r - l + 1;
        int d = 1;
        int f = min(n - 1 - l + 1, r - 0 + 1);
        return new otr(st, f, 0, d);
    }
}
