import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.StringTokenizer;

public class A {

    static BufferedReader in;
    static StringTokenizer st;

    public static void main(String[] args) throws IOException {
        in = new BufferedReader(new InputStreamReader(System.in));
        st = new StringTokenizer(in.readLine());
        int n = next();
        st = new StringTokenizer(in.readLine());
        long mas[] = new long[n];
        BigInteger sm = BigInteger.ZERO;
        for (int i = 0; i < n; i++) {
            mas[i] = next();
            sm = sm.add(BigInteger.valueOf(mas[i]));
        }
        BigInteger k = BigInteger.ZERO;
        BigInteger fn = BigInteger.ZERO;
        int uk = 0;
        for (int i = 0; i < n; i++) {
            k = k.add(BigInteger.valueOf(mas[i]));
            BigInteger fk = k.multiply(sm.subtract(k));
            if (fk.compareTo(fn)>0) {
                fn = fk;
                uk = i + 1;
            }
        }
        System.out.println(uk);
    }

    private static int next() {
        return Integer.parseInt(st.nextToken());
    }
}
