#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define double long double
#define left left228
#define right right228
#define index index228
#define list list228

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

const int N = 40 * 1000 + 228;
const int INF = 1e13 + 228;
const int K = 228;

int n, q;
int a[N];
int dp[N][4];
bool ok[N][4];
vector<int> b[N];

int block_index[N];
int inside_pos[N];
int value[N][4][4];

void build(int bi) {
	int sz = (int)b[bi].size();
	for (int fir = 0; fir < 4; ++fir) {
		for (int sec = 0; sec < 4; ++sec) {
			value[bi][fir][sec] = -INF;
		}
	}
	for (int fir = 0; fir < 4; ++fir) {
		for (int sec = 0; sec < 4; ++sec) {
			if (fir + sec > sz) continue;
			int cur = 0;
			for (int i = 0; i < fir; ++i) {
				cur += b[bi][i];
			}
			for (int i = sz - 1; i >= sz - 1 - sec + 1; --i) {
				cur += b[bi][i];
			}
			int posl = fir + 1;
			int posr = sz - 1 - sec - 1;
			if (posl <= posr) {
				for (int i = posl; i <= posr; ++i) {
					for (int j = 0; j < 4; ++j) {
						dp[i][j] = -INF;
					}
				}
				dp[posl][0] = 0;
				dp[posl][1] = b[bi][posl];
				for (int i = posl; i < posr; ++i) {
					for (int j = 0; j < 4; ++j) {
						uax(dp[i + 1][0], dp[i][j]);
						if (j + 1 <= 3) {
							uax(dp[i + 1][j + 1], dp[i][j] + b[bi][i + 1]);
						}
					}
				}
				int add = 0;
				for (int j = 0; j < 4; ++j) {
					uax(add, dp[posr][j]);
				}
				cur += add;
			}
			value[bi][fir][sec] = cur;
		}
	}
}

int mb = 0;

void solve() {
	int res = 0;
	for (int fir = 0; fir < 4; ++fir) {
		for (int i = 1; i <= mb; ++i) {
			for (int j = 0; j < 4; ++j) {
				dp[i][j] = ok[i][j] = 0;
			}
		}
		for (int i = 0; i < 4; ++i) {
			dp[1][i] = value[1][fir][i];
		}
		for (int i = 1; i < mb; ++i) {
			int ss = (int)b[i + 1].size();
			for (int j = 0; j < 4; ++j) {
				for (int x = 0; x < 4; ++x) {
					if (j + x > 3) continue;
					for (int y = 0; y < 4; ++y) {
						if (x + y == ss) {
							if (j + ss > 3) break; // fuc
							uax(dp[i + 1][ss], dp[i][j] + value[i + 1][ss][ss]);
						} else {
							uax(dp[i + 1][y], dp[i][j] + value[i + 1][x][y]);
						}
					}
				}
			}
		}
		for (int y = 0; y <= 3 - fir; ++y) {
			uax(res, dp[mb][y]);
		}
	}
	cout << res << '\n';
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> a[i];
		b[1 + (i - 1) / K].push_back(a[i]);
		block_index[i] = 1 + (i - 1) / K;
		inside_pos[i] = (int)b[block_index[i]].size() - 1;
		uax(mb, block_index[i]);
	}
	for (int i = 1; i <= mb; ++i) {
		build(i);
	}
	cin >> q;
	solve();
	while(q--) {
		int p, v;
		cin >> p >> v;
		b[block_index[p]][inside_pos[p]] = v;
		build(block_index[p]);
		solve();
	}
	return 0;
}




/*

6
1 2 3 4 5 6
2
6 0
2 5

8
1 2 3 1 3 2 1 4 
0


*/



