#include <bits/stdc++.h>

#define int long long
#define double long double
#define endl '\n'
using namespace std;

vector<int> f(int n) {
    vector<int> res;
    for (int i = 1; i * i <= n; i++) {
        if (n % i == 0) {
            res.push_back(i);
        }
    }
    int k = res.size();
    for (int i = k - 1; i >= 0; i--) {
        if (res[i] != n / res[i]) {
            res.push_back(n / res[i]);
        }
    }
    return res;
}

int bin(vector<int> &arr, int x) {
    int l = -1, r = arr.size();
    while (l + 1 < r) {
        int m = (r + l) / 2;
        if (arr[m] < x) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin.tie(nullptr);
    int n, x;
    cin >> n >> x;
    vector<vector<int>> kek(n * n + 100);
    const int INF = (int) 1e9;
    int res = 0;
    for (int a = 2; a < INF; a++) {
        if (a == x) {
            continue;
        }
        bool flag = false;
        for (int b = 2; a * b - (a - 1) * (b - 1) <= n; b++) {
            flag = true;
            if (b == x) {
                continue;
            }
            int k = a * b - n;
            if (k <= 0) {
                continue;
            }
            if (kek[k].empty()) {
                kek[k] = f(k);
            }
//            for (auto c : kek[k]) {
//                if (c < a && k / c < b) {
//                    res++;
//                }
//            }
            int i = bin(kek[k], a), j = bin(kek[k], b);
            if (i == -1 || j == -1) {
                continue;
            }
            int i1 = kek[k].size() - i - 1, j1 = kek[k].size() - j - 1;
            res += max(0LL, i - j1 + 1);
        }
        if (!flag) {
            break;
        }
    }
    cout << res << endl;
}