#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	vector<int> ans(n);
	if (n > 500)
	{
		for (int i = 0; i < n; ++i)
		{
			int cnt[5000] = {};
			int c = 0;
			for (int len = 1; i + len <= n; ++len)
			{
				if (cnt[a[i]] == 0)
					++c, cnt[a[i]] = 1;
				ans[len - 1] += c;
			}
		}
	}
	else
	{
		for (int i = 0; i < n; ++i)
		{
			set<int> s;
			for (int len = 1; i + len <= n; ++len)
			{
				s.insert(a[i]);
				ans[len - 1] += s.size();
			}
		}
	}
	

	for (auto x : ans)
		cout << x << " ";

	return 0;
}