#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<int> a;

int dissociade(int n) {
    int ans = 0;
    for (int i = a.size() - 1; i >= 0; --i) {
        ans += n / a[i];
        n %= a[i];
    }
    return ans;
}

int cut(int a, int m) {
    if ((a + 1) % m == 0) {
        return a;
    } else if (a % m == 0) {
        return a - 1;
    }
    return (a / m - 1) * m + m - 1;
}

pair<int, int> stupid(int b) {
    int maxx = 0;
    int ans = 0;
    for (int i = 0; i < b; ++i) {
        int c = dissociade(i + 1);
        if (maxx < c) {
            maxx = c;
            ans = i + 1;
        }
    }
    return {maxx, ans};
}

int checker(int answer, int maxx, int b) {
    int ans = stupid(b).first;
    if (answer != ans) {
        cout << "Incorrect answer:\n" << ans << " " << answer << " " << b << " " << maxx << " " << stupid(b).second << "\n";
    } else if (dissociade(maxx) != answer) {
        cout << "Incorrect dissociade:\n" << ans << " " << maxx << " " << dissociade(maxx) << "\n";
    }
}

signed main() {
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    a.resize(n);
    vector<int> bed(n);
    vector<int> good(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (i == 0) {
            bed[i] = 0;
            good[i] = 0;
        } else {
            bed[i] = cut(a[i] - 1, a[i - 1]) / a[i - 1] + bed[i - 1];
            good[i] = cut(a[i] - 1, a[i - 1]) / a[i - 1] * a[i - 1] + good[i - 1];
        }
    }
    //for (int i = 0; i < n; ++i) {
    //    cout << bed[i] << " " << good[i] << "\n";
    //}
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int b;
        cin >> b;
        if (b == 1) {
            //cout << 1 << " " << 1 << "\n";
            continue;
        }
        auto p = upper_bound(a.begin(), a.end(), b);
        p--;
        int c = p - a.begin();
        if (*p == b) {
            cout << good[c] << " " << bed[c] << "\n";
            //checker(bed[c], good[c], b);
        } else {
            int bed1 = cut(b, a[c]) / a[c] + bed[c];
            int good1 = cut(b, a[c]) / a[c] * a[c] + good[c];
            int bed2 = cut(b + a[c], a[c]) / a[c] + bed[c];
            int good2 = cut(b + a[c], a[c]) / a[c] * a[c] + good[c];
            if (bed1 < bed2 && good2 <= b) {
                cout << good2 << " " << bed2 << "\n";
                //checker(bed1, good1, b);
            } else {
                cout << good1 << " " << bed1 << "\n";
                //checker(bed2, good2, b);
            }
        }
    }
}
